/********************************************************************************
 *                                                                              *
 * This file is part of IfcOpenShell.                                           *
 *                                                                              *
 * IfcOpenShell is free software: you can redistribute it and/or modify         *
 * it under the terms of the Lesser GNU General Public License as published by  *
 * the Free Software Foundation, either version 3.0 of the License, or          *
 * (at your option) any later version.                                          *
 *                                                                              *
 * IfcOpenShell is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                 *
 * Lesser GNU General Public License for more details.                          *
 *                                                                              *
 * You should have received a copy of the Lesser GNU General Public License     *
 * along with this program. If not, see <http://www.gnu.org/licenses/>.         *
 *                                                                              *
 ********************************************************************************/

/********************************************************************************
 *                                                                              *
 * This file has been generated from IFC4.exp. Do not make modifications        *
 * but instead modify the python script that has been used to generate this.    *
 *                                                                              *
 ********************************************************************************/

#include "../ifcparse/Ifc4.h"
#include "../ifcparse/IfcSchema.h"
#include "../ifcparse/IfcException.h"
#include "../ifcparse/IfcFile.h"

#include <map>

const char* const Ifc4::Identifier = "IFC4";

using namespace IfcParse;

// External definitions
extern declaration* IFC4_types[1173];


const IfcParse::enumeration_type& Ifc4::IfcActionRequestTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[3]); }
const IfcParse::enumeration_type& Ifc4::IfcActionRequestTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[3]); }

Ifc4::IfcActionRequestTypeEnum::IfcActionRequestTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcActionRequestTypeEnum::IfcActionRequestTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcActionRequestTypeEnum::IfcActionRequestTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcActionRequestTypeEnum::ToString(Value v) {
    return Ifc4::IfcActionRequestTypeEnum::IfcActionRequestTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcActionRequestTypeEnum::Value Ifc4::IfcActionRequestTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcActionRequestTypeEnum::Value) Ifc4::IfcActionRequestTypeEnum::IfcActionRequestTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcActionRequestTypeEnum::operator Ifc4::IfcActionRequestTypeEnum::Value() const {
    return (Ifc4::IfcActionRequestTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcActionSourceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[4]); }
const IfcParse::enumeration_type& Ifc4::IfcActionSourceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[4]); }

Ifc4::IfcActionSourceTypeEnum::IfcActionSourceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcActionSourceTypeEnum::IfcActionSourceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcActionSourceTypeEnum::IfcActionSourceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcActionSourceTypeEnum::ToString(Value v) {
    return Ifc4::IfcActionSourceTypeEnum::IfcActionSourceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcActionSourceTypeEnum::Value Ifc4::IfcActionSourceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcActionSourceTypeEnum::Value) Ifc4::IfcActionSourceTypeEnum::IfcActionSourceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcActionSourceTypeEnum::operator Ifc4::IfcActionSourceTypeEnum::Value() const {
    return (Ifc4::IfcActionSourceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcActionTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[5]); }
const IfcParse::enumeration_type& Ifc4::IfcActionTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[5]); }

Ifc4::IfcActionTypeEnum::IfcActionTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcActionTypeEnum::IfcActionTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcActionTypeEnum::IfcActionTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcActionTypeEnum::ToString(Value v) {
    return Ifc4::IfcActionTypeEnum::IfcActionTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcActionTypeEnum::Value Ifc4::IfcActionTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcActionTypeEnum::Value) Ifc4::IfcActionTypeEnum::IfcActionTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcActionTypeEnum::operator Ifc4::IfcActionTypeEnum::Value() const {
    return (Ifc4::IfcActionTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcActuatorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[11]); }
const IfcParse::enumeration_type& Ifc4::IfcActuatorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[11]); }

Ifc4::IfcActuatorTypeEnum::IfcActuatorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcActuatorTypeEnum::IfcActuatorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcActuatorTypeEnum::IfcActuatorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcActuatorTypeEnum::ToString(Value v) {
    return Ifc4::IfcActuatorTypeEnum::IfcActuatorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcActuatorTypeEnum::Value Ifc4::IfcActuatorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcActuatorTypeEnum::Value) Ifc4::IfcActuatorTypeEnum::IfcActuatorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcActuatorTypeEnum::operator Ifc4::IfcActuatorTypeEnum::Value() const {
    return (Ifc4::IfcActuatorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAddressTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[13]); }
const IfcParse::enumeration_type& Ifc4::IfcAddressTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[13]); }

Ifc4::IfcAddressTypeEnum::IfcAddressTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAddressTypeEnum::IfcAddressTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAddressTypeEnum::IfcAddressTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAddressTypeEnum::ToString(Value v) {
    return Ifc4::IfcAddressTypeEnum::IfcAddressTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAddressTypeEnum::Value Ifc4::IfcAddressTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAddressTypeEnum::Value) Ifc4::IfcAddressTypeEnum::IfcAddressTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAddressTypeEnum::operator Ifc4::IfcAddressTypeEnum::Value() const {
    return (Ifc4::IfcAddressTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAirTerminalBoxTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[20]); }
const IfcParse::enumeration_type& Ifc4::IfcAirTerminalBoxTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[20]); }

Ifc4::IfcAirTerminalBoxTypeEnum::IfcAirTerminalBoxTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAirTerminalBoxTypeEnum::IfcAirTerminalBoxTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAirTerminalBoxTypeEnum::IfcAirTerminalBoxTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAirTerminalBoxTypeEnum::ToString(Value v) {
    return Ifc4::IfcAirTerminalBoxTypeEnum::IfcAirTerminalBoxTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAirTerminalBoxTypeEnum::Value Ifc4::IfcAirTerminalBoxTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAirTerminalBoxTypeEnum::Value) Ifc4::IfcAirTerminalBoxTypeEnum::IfcAirTerminalBoxTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAirTerminalBoxTypeEnum::operator Ifc4::IfcAirTerminalBoxTypeEnum::Value() const {
    return (Ifc4::IfcAirTerminalBoxTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAirTerminalTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[22]); }
const IfcParse::enumeration_type& Ifc4::IfcAirTerminalTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[22]); }

Ifc4::IfcAirTerminalTypeEnum::IfcAirTerminalTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAirTerminalTypeEnum::IfcAirTerminalTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAirTerminalTypeEnum::IfcAirTerminalTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAirTerminalTypeEnum::ToString(Value v) {
    return Ifc4::IfcAirTerminalTypeEnum::IfcAirTerminalTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAirTerminalTypeEnum::Value Ifc4::IfcAirTerminalTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAirTerminalTypeEnum::Value) Ifc4::IfcAirTerminalTypeEnum::IfcAirTerminalTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAirTerminalTypeEnum::operator Ifc4::IfcAirTerminalTypeEnum::Value() const {
    return (Ifc4::IfcAirTerminalTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAirToAirHeatRecoveryTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[25]); }
const IfcParse::enumeration_type& Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[25]); }

Ifc4::IfcAirToAirHeatRecoveryTypeEnum::IfcAirToAirHeatRecoveryTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAirToAirHeatRecoveryTypeEnum::IfcAirToAirHeatRecoveryTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAirToAirHeatRecoveryTypeEnum::IfcAirToAirHeatRecoveryTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAirToAirHeatRecoveryTypeEnum::ToString(Value v) {
    return Ifc4::IfcAirToAirHeatRecoveryTypeEnum::IfcAirToAirHeatRecoveryTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value Ifc4::IfcAirToAirHeatRecoveryTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value) Ifc4::IfcAirToAirHeatRecoveryTypeEnum::IfcAirToAirHeatRecoveryTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAirToAirHeatRecoveryTypeEnum::operator Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value() const {
    return (Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAlarmTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[28]); }
const IfcParse::enumeration_type& Ifc4::IfcAlarmTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[28]); }

Ifc4::IfcAlarmTypeEnum::IfcAlarmTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAlarmTypeEnum::IfcAlarmTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAlarmTypeEnum::IfcAlarmTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAlarmTypeEnum::ToString(Value v) {
    return Ifc4::IfcAlarmTypeEnum::IfcAlarmTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAlarmTypeEnum::Value Ifc4::IfcAlarmTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAlarmTypeEnum::Value) Ifc4::IfcAlarmTypeEnum::IfcAlarmTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAlarmTypeEnum::operator Ifc4::IfcAlarmTypeEnum::Value() const {
    return (Ifc4::IfcAlarmTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAnalysisModelTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[30]); }
const IfcParse::enumeration_type& Ifc4::IfcAnalysisModelTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[30]); }

Ifc4::IfcAnalysisModelTypeEnum::IfcAnalysisModelTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAnalysisModelTypeEnum::IfcAnalysisModelTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAnalysisModelTypeEnum::IfcAnalysisModelTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAnalysisModelTypeEnum::ToString(Value v) {
    return Ifc4::IfcAnalysisModelTypeEnum::IfcAnalysisModelTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAnalysisModelTypeEnum::Value Ifc4::IfcAnalysisModelTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAnalysisModelTypeEnum::Value) Ifc4::IfcAnalysisModelTypeEnum::IfcAnalysisModelTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAnalysisModelTypeEnum::operator Ifc4::IfcAnalysisModelTypeEnum::Value() const {
    return (Ifc4::IfcAnalysisModelTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAnalysisTheoryTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[31]); }
const IfcParse::enumeration_type& Ifc4::IfcAnalysisTheoryTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[31]); }

Ifc4::IfcAnalysisTheoryTypeEnum::IfcAnalysisTheoryTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAnalysisTheoryTypeEnum::IfcAnalysisTheoryTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAnalysisTheoryTypeEnum::IfcAnalysisTheoryTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAnalysisTheoryTypeEnum::ToString(Value v) {
    return Ifc4::IfcAnalysisTheoryTypeEnum::IfcAnalysisTheoryTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAnalysisTheoryTypeEnum::Value Ifc4::IfcAnalysisTheoryTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAnalysisTheoryTypeEnum::Value) Ifc4::IfcAnalysisTheoryTypeEnum::IfcAnalysisTheoryTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAnalysisTheoryTypeEnum::operator Ifc4::IfcAnalysisTheoryTypeEnum::Value() const {
    return (Ifc4::IfcAnalysisTheoryTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcArithmeticOperatorEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[46]); }
const IfcParse::enumeration_type& Ifc4::IfcArithmeticOperatorEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[46]); }

Ifc4::IfcArithmeticOperatorEnum::IfcArithmeticOperatorEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcArithmeticOperatorEnum::IfcArithmeticOperatorEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcArithmeticOperatorEnum::IfcArithmeticOperatorEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcArithmeticOperatorEnum::ToString(Value v) {
    return Ifc4::IfcArithmeticOperatorEnum::IfcArithmeticOperatorEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcArithmeticOperatorEnum::Value Ifc4::IfcArithmeticOperatorEnum::FromString(const std::string& s) {
    return (Ifc4::IfcArithmeticOperatorEnum::Value) Ifc4::IfcArithmeticOperatorEnum::IfcArithmeticOperatorEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcArithmeticOperatorEnum::operator Ifc4::IfcArithmeticOperatorEnum::Value() const {
    return (Ifc4::IfcArithmeticOperatorEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAssemblyPlaceEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[47]); }
const IfcParse::enumeration_type& Ifc4::IfcAssemblyPlaceEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[47]); }

Ifc4::IfcAssemblyPlaceEnum::IfcAssemblyPlaceEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAssemblyPlaceEnum::IfcAssemblyPlaceEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAssemblyPlaceEnum::IfcAssemblyPlaceEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAssemblyPlaceEnum::ToString(Value v) {
    return Ifc4::IfcAssemblyPlaceEnum::IfcAssemblyPlaceEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAssemblyPlaceEnum::Value Ifc4::IfcAssemblyPlaceEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAssemblyPlaceEnum::Value) Ifc4::IfcAssemblyPlaceEnum::IfcAssemblyPlaceEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAssemblyPlaceEnum::operator Ifc4::IfcAssemblyPlaceEnum::Value() const {
    return (Ifc4::IfcAssemblyPlaceEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcAudioVisualApplianceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[52]); }
const IfcParse::enumeration_type& Ifc4::IfcAudioVisualApplianceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[52]); }

Ifc4::IfcAudioVisualApplianceTypeEnum::IfcAudioVisualApplianceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcAudioVisualApplianceTypeEnum::IfcAudioVisualApplianceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcAudioVisualApplianceTypeEnum::IfcAudioVisualApplianceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcAudioVisualApplianceTypeEnum::ToString(Value v) {
    return Ifc4::IfcAudioVisualApplianceTypeEnum::IfcAudioVisualApplianceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcAudioVisualApplianceTypeEnum::Value Ifc4::IfcAudioVisualApplianceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcAudioVisualApplianceTypeEnum::Value) Ifc4::IfcAudioVisualApplianceTypeEnum::IfcAudioVisualApplianceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcAudioVisualApplianceTypeEnum::operator Ifc4::IfcAudioVisualApplianceTypeEnum::Value() const {
    return (Ifc4::IfcAudioVisualApplianceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBSplineCurveForm::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[86]); }
const IfcParse::enumeration_type& Ifc4::IfcBSplineCurveForm::Class() { return *((IfcParse::enumeration_type*)IFC4_types[86]); }

Ifc4::IfcBSplineCurveForm::IfcBSplineCurveForm(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBSplineCurveForm::IfcBSplineCurveForm(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBSplineCurveForm::IfcBSplineCurveForm(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBSplineCurveForm::ToString(Value v) {
    return Ifc4::IfcBSplineCurveForm::IfcBSplineCurveForm::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBSplineCurveForm::Value Ifc4::IfcBSplineCurveForm::FromString(const std::string& s) {
    return (Ifc4::IfcBSplineCurveForm::Value) Ifc4::IfcBSplineCurveForm::IfcBSplineCurveForm::Class().lookup_enum_offset(s);
}

Ifc4::IfcBSplineCurveForm::operator Ifc4::IfcBSplineCurveForm::Value() const {
    return (Ifc4::IfcBSplineCurveForm::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBSplineSurfaceForm::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[89]); }
const IfcParse::enumeration_type& Ifc4::IfcBSplineSurfaceForm::Class() { return *((IfcParse::enumeration_type*)IFC4_types[89]); }

Ifc4::IfcBSplineSurfaceForm::IfcBSplineSurfaceForm(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBSplineSurfaceForm::IfcBSplineSurfaceForm(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBSplineSurfaceForm::IfcBSplineSurfaceForm(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBSplineSurfaceForm::ToString(Value v) {
    return Ifc4::IfcBSplineSurfaceForm::IfcBSplineSurfaceForm::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBSplineSurfaceForm::Value Ifc4::IfcBSplineSurfaceForm::FromString(const std::string& s) {
    return (Ifc4::IfcBSplineSurfaceForm::Value) Ifc4::IfcBSplineSurfaceForm::IfcBSplineSurfaceForm::Class().lookup_enum_offset(s);
}

Ifc4::IfcBSplineSurfaceForm::operator Ifc4::IfcBSplineSurfaceForm::Value() const {
    return (Ifc4::IfcBSplineSurfaceForm::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBeamTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[60]); }
const IfcParse::enumeration_type& Ifc4::IfcBeamTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[60]); }

Ifc4::IfcBeamTypeEnum::IfcBeamTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBeamTypeEnum::IfcBeamTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBeamTypeEnum::IfcBeamTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBeamTypeEnum::ToString(Value v) {
    return Ifc4::IfcBeamTypeEnum::IfcBeamTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBeamTypeEnum::Value Ifc4::IfcBeamTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcBeamTypeEnum::Value) Ifc4::IfcBeamTypeEnum::IfcBeamTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcBeamTypeEnum::operator Ifc4::IfcBeamTypeEnum::Value() const {
    return (Ifc4::IfcBeamTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBenchmarkEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[61]); }
const IfcParse::enumeration_type& Ifc4::IfcBenchmarkEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[61]); }

Ifc4::IfcBenchmarkEnum::IfcBenchmarkEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBenchmarkEnum::IfcBenchmarkEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBenchmarkEnum::IfcBenchmarkEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBenchmarkEnum::ToString(Value v) {
    return Ifc4::IfcBenchmarkEnum::IfcBenchmarkEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBenchmarkEnum::Value Ifc4::IfcBenchmarkEnum::FromString(const std::string& s) {
    return (Ifc4::IfcBenchmarkEnum::Value) Ifc4::IfcBenchmarkEnum::IfcBenchmarkEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcBenchmarkEnum::operator Ifc4::IfcBenchmarkEnum::Value() const {
    return (Ifc4::IfcBenchmarkEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBoilerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[68]); }
const IfcParse::enumeration_type& Ifc4::IfcBoilerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[68]); }

Ifc4::IfcBoilerTypeEnum::IfcBoilerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBoilerTypeEnum::IfcBoilerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBoilerTypeEnum::IfcBoilerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBoilerTypeEnum::ToString(Value v) {
    return Ifc4::IfcBoilerTypeEnum::IfcBoilerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBoilerTypeEnum::Value Ifc4::IfcBoilerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcBoilerTypeEnum::Value) Ifc4::IfcBoilerTypeEnum::IfcBoilerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcBoilerTypeEnum::operator Ifc4::IfcBoilerTypeEnum::Value() const {
    return (Ifc4::IfcBoilerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBooleanOperator::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[72]); }
const IfcParse::enumeration_type& Ifc4::IfcBooleanOperator::Class() { return *((IfcParse::enumeration_type*)IFC4_types[72]); }

Ifc4::IfcBooleanOperator::IfcBooleanOperator(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBooleanOperator::IfcBooleanOperator(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBooleanOperator::IfcBooleanOperator(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBooleanOperator::ToString(Value v) {
    return Ifc4::IfcBooleanOperator::IfcBooleanOperator::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBooleanOperator::Value Ifc4::IfcBooleanOperator::FromString(const std::string& s) {
    return (Ifc4::IfcBooleanOperator::Value) Ifc4::IfcBooleanOperator::IfcBooleanOperator::Class().lookup_enum_offset(s);
}

Ifc4::IfcBooleanOperator::operator Ifc4::IfcBooleanOperator::Value() const {
    return (Ifc4::IfcBooleanOperator::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBuildingElementPartTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[95]); }
const IfcParse::enumeration_type& Ifc4::IfcBuildingElementPartTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[95]); }

Ifc4::IfcBuildingElementPartTypeEnum::IfcBuildingElementPartTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBuildingElementPartTypeEnum::IfcBuildingElementPartTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBuildingElementPartTypeEnum::IfcBuildingElementPartTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBuildingElementPartTypeEnum::ToString(Value v) {
    return Ifc4::IfcBuildingElementPartTypeEnum::IfcBuildingElementPartTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBuildingElementPartTypeEnum::Value Ifc4::IfcBuildingElementPartTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcBuildingElementPartTypeEnum::Value) Ifc4::IfcBuildingElementPartTypeEnum::IfcBuildingElementPartTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcBuildingElementPartTypeEnum::operator Ifc4::IfcBuildingElementPartTypeEnum::Value() const {
    return (Ifc4::IfcBuildingElementPartTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBuildingElementProxyTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[98]); }
const IfcParse::enumeration_type& Ifc4::IfcBuildingElementProxyTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[98]); }

Ifc4::IfcBuildingElementProxyTypeEnum::IfcBuildingElementProxyTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBuildingElementProxyTypeEnum::IfcBuildingElementProxyTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBuildingElementProxyTypeEnum::IfcBuildingElementProxyTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBuildingElementProxyTypeEnum::ToString(Value v) {
    return Ifc4::IfcBuildingElementProxyTypeEnum::IfcBuildingElementProxyTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBuildingElementProxyTypeEnum::Value Ifc4::IfcBuildingElementProxyTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcBuildingElementProxyTypeEnum::Value) Ifc4::IfcBuildingElementProxyTypeEnum::IfcBuildingElementProxyTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcBuildingElementProxyTypeEnum::operator Ifc4::IfcBuildingElementProxyTypeEnum::Value() const {
    return (Ifc4::IfcBuildingElementProxyTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBuildingSystemTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[102]); }
const IfcParse::enumeration_type& Ifc4::IfcBuildingSystemTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[102]); }

Ifc4::IfcBuildingSystemTypeEnum::IfcBuildingSystemTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBuildingSystemTypeEnum::IfcBuildingSystemTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBuildingSystemTypeEnum::IfcBuildingSystemTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBuildingSystemTypeEnum::ToString(Value v) {
    return Ifc4::IfcBuildingSystemTypeEnum::IfcBuildingSystemTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBuildingSystemTypeEnum::Value Ifc4::IfcBuildingSystemTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcBuildingSystemTypeEnum::Value) Ifc4::IfcBuildingSystemTypeEnum::IfcBuildingSystemTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcBuildingSystemTypeEnum::operator Ifc4::IfcBuildingSystemTypeEnum::Value() const {
    return (Ifc4::IfcBuildingSystemTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcBurnerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[105]); }
const IfcParse::enumeration_type& Ifc4::IfcBurnerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[105]); }

Ifc4::IfcBurnerTypeEnum::IfcBurnerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcBurnerTypeEnum::IfcBurnerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcBurnerTypeEnum::IfcBurnerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcBurnerTypeEnum::ToString(Value v) {
    return Ifc4::IfcBurnerTypeEnum::IfcBurnerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcBurnerTypeEnum::Value Ifc4::IfcBurnerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcBurnerTypeEnum::Value) Ifc4::IfcBurnerTypeEnum::IfcBurnerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcBurnerTypeEnum::operator Ifc4::IfcBurnerTypeEnum::Value() const {
    return (Ifc4::IfcBurnerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCableCarrierFittingTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[108]); }
const IfcParse::enumeration_type& Ifc4::IfcCableCarrierFittingTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[108]); }

Ifc4::IfcCableCarrierFittingTypeEnum::IfcCableCarrierFittingTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCableCarrierFittingTypeEnum::IfcCableCarrierFittingTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCableCarrierFittingTypeEnum::IfcCableCarrierFittingTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCableCarrierFittingTypeEnum::ToString(Value v) {
    return Ifc4::IfcCableCarrierFittingTypeEnum::IfcCableCarrierFittingTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCableCarrierFittingTypeEnum::Value Ifc4::IfcCableCarrierFittingTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCableCarrierFittingTypeEnum::Value) Ifc4::IfcCableCarrierFittingTypeEnum::IfcCableCarrierFittingTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCableCarrierFittingTypeEnum::operator Ifc4::IfcCableCarrierFittingTypeEnum::Value() const {
    return (Ifc4::IfcCableCarrierFittingTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCableCarrierSegmentTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[111]); }
const IfcParse::enumeration_type& Ifc4::IfcCableCarrierSegmentTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[111]); }

Ifc4::IfcCableCarrierSegmentTypeEnum::IfcCableCarrierSegmentTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCableCarrierSegmentTypeEnum::IfcCableCarrierSegmentTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCableCarrierSegmentTypeEnum::IfcCableCarrierSegmentTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCableCarrierSegmentTypeEnum::ToString(Value v) {
    return Ifc4::IfcCableCarrierSegmentTypeEnum::IfcCableCarrierSegmentTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCableCarrierSegmentTypeEnum::Value Ifc4::IfcCableCarrierSegmentTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCableCarrierSegmentTypeEnum::Value) Ifc4::IfcCableCarrierSegmentTypeEnum::IfcCableCarrierSegmentTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCableCarrierSegmentTypeEnum::operator Ifc4::IfcCableCarrierSegmentTypeEnum::Value() const {
    return (Ifc4::IfcCableCarrierSegmentTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCableFittingTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[114]); }
const IfcParse::enumeration_type& Ifc4::IfcCableFittingTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[114]); }

Ifc4::IfcCableFittingTypeEnum::IfcCableFittingTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCableFittingTypeEnum::IfcCableFittingTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCableFittingTypeEnum::IfcCableFittingTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCableFittingTypeEnum::ToString(Value v) {
    return Ifc4::IfcCableFittingTypeEnum::IfcCableFittingTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCableFittingTypeEnum::Value Ifc4::IfcCableFittingTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCableFittingTypeEnum::Value) Ifc4::IfcCableFittingTypeEnum::IfcCableFittingTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCableFittingTypeEnum::operator Ifc4::IfcCableFittingTypeEnum::Value() const {
    return (Ifc4::IfcCableFittingTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCableSegmentTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[117]); }
const IfcParse::enumeration_type& Ifc4::IfcCableSegmentTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[117]); }

Ifc4::IfcCableSegmentTypeEnum::IfcCableSegmentTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCableSegmentTypeEnum::IfcCableSegmentTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCableSegmentTypeEnum::IfcCableSegmentTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCableSegmentTypeEnum::ToString(Value v) {
    return Ifc4::IfcCableSegmentTypeEnum::IfcCableSegmentTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCableSegmentTypeEnum::Value Ifc4::IfcCableSegmentTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCableSegmentTypeEnum::Value) Ifc4::IfcCableSegmentTypeEnum::IfcCableSegmentTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCableSegmentTypeEnum::operator Ifc4::IfcCableSegmentTypeEnum::Value() const {
    return (Ifc4::IfcCableSegmentTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcChangeActionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[129]); }
const IfcParse::enumeration_type& Ifc4::IfcChangeActionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[129]); }

Ifc4::IfcChangeActionEnum::IfcChangeActionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcChangeActionEnum::IfcChangeActionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcChangeActionEnum::IfcChangeActionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcChangeActionEnum::ToString(Value v) {
    return Ifc4::IfcChangeActionEnum::IfcChangeActionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcChangeActionEnum::Value Ifc4::IfcChangeActionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcChangeActionEnum::Value) Ifc4::IfcChangeActionEnum::IfcChangeActionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcChangeActionEnum::operator Ifc4::IfcChangeActionEnum::Value() const {
    return (Ifc4::IfcChangeActionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcChillerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[132]); }
const IfcParse::enumeration_type& Ifc4::IfcChillerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[132]); }

Ifc4::IfcChillerTypeEnum::IfcChillerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcChillerTypeEnum::IfcChillerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcChillerTypeEnum::IfcChillerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcChillerTypeEnum::ToString(Value v) {
    return Ifc4::IfcChillerTypeEnum::IfcChillerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcChillerTypeEnum::Value Ifc4::IfcChillerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcChillerTypeEnum::Value) Ifc4::IfcChillerTypeEnum::IfcChillerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcChillerTypeEnum::operator Ifc4::IfcChillerTypeEnum::Value() const {
    return (Ifc4::IfcChillerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcChimneyTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[135]); }
const IfcParse::enumeration_type& Ifc4::IfcChimneyTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[135]); }

Ifc4::IfcChimneyTypeEnum::IfcChimneyTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcChimneyTypeEnum::IfcChimneyTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcChimneyTypeEnum::IfcChimneyTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcChimneyTypeEnum::ToString(Value v) {
    return Ifc4::IfcChimneyTypeEnum::IfcChimneyTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcChimneyTypeEnum::Value Ifc4::IfcChimneyTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcChimneyTypeEnum::Value) Ifc4::IfcChimneyTypeEnum::IfcChimneyTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcChimneyTypeEnum::operator Ifc4::IfcChimneyTypeEnum::Value() const {
    return (Ifc4::IfcChimneyTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCoilTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[148]); }
const IfcParse::enumeration_type& Ifc4::IfcCoilTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[148]); }

Ifc4::IfcCoilTypeEnum::IfcCoilTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCoilTypeEnum::IfcCoilTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCoilTypeEnum::IfcCoilTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCoilTypeEnum::ToString(Value v) {
    return Ifc4::IfcCoilTypeEnum::IfcCoilTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCoilTypeEnum::Value Ifc4::IfcCoilTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCoilTypeEnum::Value) Ifc4::IfcCoilTypeEnum::IfcCoilTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCoilTypeEnum::operator Ifc4::IfcCoilTypeEnum::Value() const {
    return (Ifc4::IfcCoilTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcColumnTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[157]); }
const IfcParse::enumeration_type& Ifc4::IfcColumnTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[157]); }

Ifc4::IfcColumnTypeEnum::IfcColumnTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcColumnTypeEnum::IfcColumnTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcColumnTypeEnum::IfcColumnTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcColumnTypeEnum::ToString(Value v) {
    return Ifc4::IfcColumnTypeEnum::IfcColumnTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcColumnTypeEnum::Value Ifc4::IfcColumnTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcColumnTypeEnum::Value) Ifc4::IfcColumnTypeEnum::IfcColumnTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcColumnTypeEnum::operator Ifc4::IfcColumnTypeEnum::Value() const {
    return (Ifc4::IfcColumnTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCommunicationsApplianceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[160]); }
const IfcParse::enumeration_type& Ifc4::IfcCommunicationsApplianceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[160]); }

Ifc4::IfcCommunicationsApplianceTypeEnum::IfcCommunicationsApplianceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCommunicationsApplianceTypeEnum::IfcCommunicationsApplianceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCommunicationsApplianceTypeEnum::IfcCommunicationsApplianceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCommunicationsApplianceTypeEnum::ToString(Value v) {
    return Ifc4::IfcCommunicationsApplianceTypeEnum::IfcCommunicationsApplianceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCommunicationsApplianceTypeEnum::Value Ifc4::IfcCommunicationsApplianceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCommunicationsApplianceTypeEnum::Value) Ifc4::IfcCommunicationsApplianceTypeEnum::IfcCommunicationsApplianceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCommunicationsApplianceTypeEnum::operator Ifc4::IfcCommunicationsApplianceTypeEnum::Value() const {
    return (Ifc4::IfcCommunicationsApplianceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcComplexPropertyTemplateTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[164]); }
const IfcParse::enumeration_type& Ifc4::IfcComplexPropertyTemplateTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[164]); }

Ifc4::IfcComplexPropertyTemplateTypeEnum::IfcComplexPropertyTemplateTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcComplexPropertyTemplateTypeEnum::IfcComplexPropertyTemplateTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcComplexPropertyTemplateTypeEnum::IfcComplexPropertyTemplateTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcComplexPropertyTemplateTypeEnum::ToString(Value v) {
    return Ifc4::IfcComplexPropertyTemplateTypeEnum::IfcComplexPropertyTemplateTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcComplexPropertyTemplateTypeEnum::Value Ifc4::IfcComplexPropertyTemplateTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcComplexPropertyTemplateTypeEnum::Value) Ifc4::IfcComplexPropertyTemplateTypeEnum::IfcComplexPropertyTemplateTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcComplexPropertyTemplateTypeEnum::operator Ifc4::IfcComplexPropertyTemplateTypeEnum::Value() const {
    return (Ifc4::IfcComplexPropertyTemplateTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCompressorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[172]); }
const IfcParse::enumeration_type& Ifc4::IfcCompressorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[172]); }

Ifc4::IfcCompressorTypeEnum::IfcCompressorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCompressorTypeEnum::IfcCompressorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCompressorTypeEnum::IfcCompressorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCompressorTypeEnum::ToString(Value v) {
    return Ifc4::IfcCompressorTypeEnum::IfcCompressorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCompressorTypeEnum::Value Ifc4::IfcCompressorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCompressorTypeEnum::Value) Ifc4::IfcCompressorTypeEnum::IfcCompressorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCompressorTypeEnum::operator Ifc4::IfcCompressorTypeEnum::Value() const {
    return (Ifc4::IfcCompressorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCondenserTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[175]); }
const IfcParse::enumeration_type& Ifc4::IfcCondenserTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[175]); }

Ifc4::IfcCondenserTypeEnum::IfcCondenserTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCondenserTypeEnum::IfcCondenserTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCondenserTypeEnum::IfcCondenserTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCondenserTypeEnum::ToString(Value v) {
    return Ifc4::IfcCondenserTypeEnum::IfcCondenserTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCondenserTypeEnum::Value Ifc4::IfcCondenserTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCondenserTypeEnum::Value) Ifc4::IfcCondenserTypeEnum::IfcCondenserTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCondenserTypeEnum::operator Ifc4::IfcCondenserTypeEnum::Value() const {
    return (Ifc4::IfcCondenserTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcConnectionTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[183]); }
const IfcParse::enumeration_type& Ifc4::IfcConnectionTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[183]); }

Ifc4::IfcConnectionTypeEnum::IfcConnectionTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcConnectionTypeEnum::IfcConnectionTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcConnectionTypeEnum::IfcConnectionTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcConnectionTypeEnum::ToString(Value v) {
    return Ifc4::IfcConnectionTypeEnum::IfcConnectionTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcConnectionTypeEnum::Value Ifc4::IfcConnectionTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcConnectionTypeEnum::Value) Ifc4::IfcConnectionTypeEnum::IfcConnectionTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcConnectionTypeEnum::operator Ifc4::IfcConnectionTypeEnum::Value() const {
    return (Ifc4::IfcConnectionTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcConstraintEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[186]); }
const IfcParse::enumeration_type& Ifc4::IfcConstraintEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[186]); }

Ifc4::IfcConstraintEnum::IfcConstraintEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcConstraintEnum::IfcConstraintEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcConstraintEnum::IfcConstraintEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcConstraintEnum::ToString(Value v) {
    return Ifc4::IfcConstraintEnum::IfcConstraintEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcConstraintEnum::Value Ifc4::IfcConstraintEnum::FromString(const std::string& s) {
    return (Ifc4::IfcConstraintEnum::Value) Ifc4::IfcConstraintEnum::IfcConstraintEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcConstraintEnum::operator Ifc4::IfcConstraintEnum::Value() const {
    return (Ifc4::IfcConstraintEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcConstructionEquipmentResourceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[189]); }
const IfcParse::enumeration_type& Ifc4::IfcConstructionEquipmentResourceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[189]); }

Ifc4::IfcConstructionEquipmentResourceTypeEnum::IfcConstructionEquipmentResourceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcConstructionEquipmentResourceTypeEnum::IfcConstructionEquipmentResourceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcConstructionEquipmentResourceTypeEnum::IfcConstructionEquipmentResourceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcConstructionEquipmentResourceTypeEnum::ToString(Value v) {
    return Ifc4::IfcConstructionEquipmentResourceTypeEnum::IfcConstructionEquipmentResourceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value Ifc4::IfcConstructionEquipmentResourceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value) Ifc4::IfcConstructionEquipmentResourceTypeEnum::IfcConstructionEquipmentResourceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcConstructionEquipmentResourceTypeEnum::operator Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value() const {
    return (Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcConstructionMaterialResourceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[192]); }
const IfcParse::enumeration_type& Ifc4::IfcConstructionMaterialResourceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[192]); }

Ifc4::IfcConstructionMaterialResourceTypeEnum::IfcConstructionMaterialResourceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcConstructionMaterialResourceTypeEnum::IfcConstructionMaterialResourceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcConstructionMaterialResourceTypeEnum::IfcConstructionMaterialResourceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcConstructionMaterialResourceTypeEnum::ToString(Value v) {
    return Ifc4::IfcConstructionMaterialResourceTypeEnum::IfcConstructionMaterialResourceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcConstructionMaterialResourceTypeEnum::Value Ifc4::IfcConstructionMaterialResourceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcConstructionMaterialResourceTypeEnum::Value) Ifc4::IfcConstructionMaterialResourceTypeEnum::IfcConstructionMaterialResourceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcConstructionMaterialResourceTypeEnum::operator Ifc4::IfcConstructionMaterialResourceTypeEnum::Value() const {
    return (Ifc4::IfcConstructionMaterialResourceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcConstructionProductResourceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[195]); }
const IfcParse::enumeration_type& Ifc4::IfcConstructionProductResourceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[195]); }

Ifc4::IfcConstructionProductResourceTypeEnum::IfcConstructionProductResourceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcConstructionProductResourceTypeEnum::IfcConstructionProductResourceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcConstructionProductResourceTypeEnum::IfcConstructionProductResourceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcConstructionProductResourceTypeEnum::ToString(Value v) {
    return Ifc4::IfcConstructionProductResourceTypeEnum::IfcConstructionProductResourceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcConstructionProductResourceTypeEnum::Value Ifc4::IfcConstructionProductResourceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcConstructionProductResourceTypeEnum::Value) Ifc4::IfcConstructionProductResourceTypeEnum::IfcConstructionProductResourceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcConstructionProductResourceTypeEnum::operator Ifc4::IfcConstructionProductResourceTypeEnum::Value() const {
    return (Ifc4::IfcConstructionProductResourceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcControllerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[204]); }
const IfcParse::enumeration_type& Ifc4::IfcControllerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[204]); }

Ifc4::IfcControllerTypeEnum::IfcControllerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcControllerTypeEnum::IfcControllerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcControllerTypeEnum::IfcControllerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcControllerTypeEnum::ToString(Value v) {
    return Ifc4::IfcControllerTypeEnum::IfcControllerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcControllerTypeEnum::Value Ifc4::IfcControllerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcControllerTypeEnum::Value) Ifc4::IfcControllerTypeEnum::IfcControllerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcControllerTypeEnum::operator Ifc4::IfcControllerTypeEnum::Value() const {
    return (Ifc4::IfcControllerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCooledBeamTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[209]); }
const IfcParse::enumeration_type& Ifc4::IfcCooledBeamTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[209]); }

Ifc4::IfcCooledBeamTypeEnum::IfcCooledBeamTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCooledBeamTypeEnum::IfcCooledBeamTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCooledBeamTypeEnum::IfcCooledBeamTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCooledBeamTypeEnum::ToString(Value v) {
    return Ifc4::IfcCooledBeamTypeEnum::IfcCooledBeamTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCooledBeamTypeEnum::Value Ifc4::IfcCooledBeamTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCooledBeamTypeEnum::Value) Ifc4::IfcCooledBeamTypeEnum::IfcCooledBeamTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCooledBeamTypeEnum::operator Ifc4::IfcCooledBeamTypeEnum::Value() const {
    return (Ifc4::IfcCooledBeamTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCoolingTowerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[212]); }
const IfcParse::enumeration_type& Ifc4::IfcCoolingTowerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[212]); }

Ifc4::IfcCoolingTowerTypeEnum::IfcCoolingTowerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCoolingTowerTypeEnum::IfcCoolingTowerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCoolingTowerTypeEnum::IfcCoolingTowerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCoolingTowerTypeEnum::ToString(Value v) {
    return Ifc4::IfcCoolingTowerTypeEnum::IfcCoolingTowerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCoolingTowerTypeEnum::Value Ifc4::IfcCoolingTowerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCoolingTowerTypeEnum::Value) Ifc4::IfcCoolingTowerTypeEnum::IfcCoolingTowerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCoolingTowerTypeEnum::operator Ifc4::IfcCoolingTowerTypeEnum::Value() const {
    return (Ifc4::IfcCoolingTowerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCostItemTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[217]); }
const IfcParse::enumeration_type& Ifc4::IfcCostItemTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[217]); }

Ifc4::IfcCostItemTypeEnum::IfcCostItemTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCostItemTypeEnum::IfcCostItemTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCostItemTypeEnum::IfcCostItemTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCostItemTypeEnum::ToString(Value v) {
    return Ifc4::IfcCostItemTypeEnum::IfcCostItemTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCostItemTypeEnum::Value Ifc4::IfcCostItemTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCostItemTypeEnum::Value) Ifc4::IfcCostItemTypeEnum::IfcCostItemTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCostItemTypeEnum::operator Ifc4::IfcCostItemTypeEnum::Value() const {
    return (Ifc4::IfcCostItemTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCostScheduleTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[219]); }
const IfcParse::enumeration_type& Ifc4::IfcCostScheduleTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[219]); }

Ifc4::IfcCostScheduleTypeEnum::IfcCostScheduleTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCostScheduleTypeEnum::IfcCostScheduleTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCostScheduleTypeEnum::IfcCostScheduleTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCostScheduleTypeEnum::ToString(Value v) {
    return Ifc4::IfcCostScheduleTypeEnum::IfcCostScheduleTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCostScheduleTypeEnum::Value Ifc4::IfcCostScheduleTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCostScheduleTypeEnum::Value) Ifc4::IfcCostScheduleTypeEnum::IfcCostScheduleTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCostScheduleTypeEnum::operator Ifc4::IfcCostScheduleTypeEnum::Value() const {
    return (Ifc4::IfcCostScheduleTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCoveringTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[224]); }
const IfcParse::enumeration_type& Ifc4::IfcCoveringTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[224]); }

Ifc4::IfcCoveringTypeEnum::IfcCoveringTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCoveringTypeEnum::IfcCoveringTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCoveringTypeEnum::IfcCoveringTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCoveringTypeEnum::ToString(Value v) {
    return Ifc4::IfcCoveringTypeEnum::IfcCoveringTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCoveringTypeEnum::Value Ifc4::IfcCoveringTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCoveringTypeEnum::Value) Ifc4::IfcCoveringTypeEnum::IfcCoveringTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCoveringTypeEnum::operator Ifc4::IfcCoveringTypeEnum::Value() const {
    return (Ifc4::IfcCoveringTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCrewResourceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[227]); }
const IfcParse::enumeration_type& Ifc4::IfcCrewResourceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[227]); }

Ifc4::IfcCrewResourceTypeEnum::IfcCrewResourceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCrewResourceTypeEnum::IfcCrewResourceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCrewResourceTypeEnum::IfcCrewResourceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCrewResourceTypeEnum::ToString(Value v) {
    return Ifc4::IfcCrewResourceTypeEnum::IfcCrewResourceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCrewResourceTypeEnum::Value Ifc4::IfcCrewResourceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCrewResourceTypeEnum::Value) Ifc4::IfcCrewResourceTypeEnum::IfcCrewResourceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCrewResourceTypeEnum::operator Ifc4::IfcCrewResourceTypeEnum::Value() const {
    return (Ifc4::IfcCrewResourceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCurtainWallTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[235]); }
const IfcParse::enumeration_type& Ifc4::IfcCurtainWallTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[235]); }

Ifc4::IfcCurtainWallTypeEnum::IfcCurtainWallTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCurtainWallTypeEnum::IfcCurtainWallTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCurtainWallTypeEnum::IfcCurtainWallTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCurtainWallTypeEnum::ToString(Value v) {
    return Ifc4::IfcCurtainWallTypeEnum::IfcCurtainWallTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCurtainWallTypeEnum::Value Ifc4::IfcCurtainWallTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCurtainWallTypeEnum::Value) Ifc4::IfcCurtainWallTypeEnum::IfcCurtainWallTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCurtainWallTypeEnum::operator Ifc4::IfcCurtainWallTypeEnum::Value() const {
    return (Ifc4::IfcCurtainWallTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcCurveInterpolationEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[241]); }
const IfcParse::enumeration_type& Ifc4::IfcCurveInterpolationEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[241]); }

Ifc4::IfcCurveInterpolationEnum::IfcCurveInterpolationEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcCurveInterpolationEnum::IfcCurveInterpolationEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcCurveInterpolationEnum::IfcCurveInterpolationEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcCurveInterpolationEnum::ToString(Value v) {
    return Ifc4::IfcCurveInterpolationEnum::IfcCurveInterpolationEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcCurveInterpolationEnum::Value Ifc4::IfcCurveInterpolationEnum::FromString(const std::string& s) {
    return (Ifc4::IfcCurveInterpolationEnum::Value) Ifc4::IfcCurveInterpolationEnum::IfcCurveInterpolationEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcCurveInterpolationEnum::operator Ifc4::IfcCurveInterpolationEnum::Value() const {
    return (Ifc4::IfcCurveInterpolationEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDamperTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[252]); }
const IfcParse::enumeration_type& Ifc4::IfcDamperTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[252]); }

Ifc4::IfcDamperTypeEnum::IfcDamperTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDamperTypeEnum::IfcDamperTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDamperTypeEnum::IfcDamperTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDamperTypeEnum::ToString(Value v) {
    return Ifc4::IfcDamperTypeEnum::IfcDamperTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDamperTypeEnum::Value Ifc4::IfcDamperTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDamperTypeEnum::Value) Ifc4::IfcDamperTypeEnum::IfcDamperTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDamperTypeEnum::operator Ifc4::IfcDamperTypeEnum::Value() const {
    return (Ifc4::IfcDamperTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDataOriginEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[253]); }
const IfcParse::enumeration_type& Ifc4::IfcDataOriginEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[253]); }

Ifc4::IfcDataOriginEnum::IfcDataOriginEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDataOriginEnum::IfcDataOriginEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDataOriginEnum::IfcDataOriginEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDataOriginEnum::ToString(Value v) {
    return Ifc4::IfcDataOriginEnum::IfcDataOriginEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDataOriginEnum::Value Ifc4::IfcDataOriginEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDataOriginEnum::Value) Ifc4::IfcDataOriginEnum::IfcDataOriginEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDataOriginEnum::operator Ifc4::IfcDataOriginEnum::Value() const {
    return (Ifc4::IfcDataOriginEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDerivedUnitEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[263]); }
const IfcParse::enumeration_type& Ifc4::IfcDerivedUnitEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[263]); }

Ifc4::IfcDerivedUnitEnum::IfcDerivedUnitEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDerivedUnitEnum::IfcDerivedUnitEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDerivedUnitEnum::IfcDerivedUnitEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDerivedUnitEnum::ToString(Value v) {
    return Ifc4::IfcDerivedUnitEnum::IfcDerivedUnitEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDerivedUnitEnum::Value Ifc4::IfcDerivedUnitEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDerivedUnitEnum::Value) Ifc4::IfcDerivedUnitEnum::IfcDerivedUnitEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDerivedUnitEnum::operator Ifc4::IfcDerivedUnitEnum::Value() const {
    return (Ifc4::IfcDerivedUnitEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDirectionSenseEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[268]); }
const IfcParse::enumeration_type& Ifc4::IfcDirectionSenseEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[268]); }

Ifc4::IfcDirectionSenseEnum::IfcDirectionSenseEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDirectionSenseEnum::IfcDirectionSenseEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDirectionSenseEnum::IfcDirectionSenseEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDirectionSenseEnum::ToString(Value v) {
    return Ifc4::IfcDirectionSenseEnum::IfcDirectionSenseEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDirectionSenseEnum::Value Ifc4::IfcDirectionSenseEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDirectionSenseEnum::Value) Ifc4::IfcDirectionSenseEnum::IfcDirectionSenseEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDirectionSenseEnum::operator Ifc4::IfcDirectionSenseEnum::Value() const {
    return (Ifc4::IfcDirectionSenseEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDiscreteAccessoryTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[271]); }
const IfcParse::enumeration_type& Ifc4::IfcDiscreteAccessoryTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[271]); }

Ifc4::IfcDiscreteAccessoryTypeEnum::IfcDiscreteAccessoryTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDiscreteAccessoryTypeEnum::IfcDiscreteAccessoryTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDiscreteAccessoryTypeEnum::IfcDiscreteAccessoryTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDiscreteAccessoryTypeEnum::ToString(Value v) {
    return Ifc4::IfcDiscreteAccessoryTypeEnum::IfcDiscreteAccessoryTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDiscreteAccessoryTypeEnum::Value Ifc4::IfcDiscreteAccessoryTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDiscreteAccessoryTypeEnum::Value) Ifc4::IfcDiscreteAccessoryTypeEnum::IfcDiscreteAccessoryTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDiscreteAccessoryTypeEnum::operator Ifc4::IfcDiscreteAccessoryTypeEnum::Value() const {
    return (Ifc4::IfcDiscreteAccessoryTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDistributionChamberElementTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[274]); }
const IfcParse::enumeration_type& Ifc4::IfcDistributionChamberElementTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[274]); }

Ifc4::IfcDistributionChamberElementTypeEnum::IfcDistributionChamberElementTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDistributionChamberElementTypeEnum::IfcDistributionChamberElementTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDistributionChamberElementTypeEnum::IfcDistributionChamberElementTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDistributionChamberElementTypeEnum::ToString(Value v) {
    return Ifc4::IfcDistributionChamberElementTypeEnum::IfcDistributionChamberElementTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDistributionChamberElementTypeEnum::Value Ifc4::IfcDistributionChamberElementTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDistributionChamberElementTypeEnum::Value) Ifc4::IfcDistributionChamberElementTypeEnum::IfcDistributionChamberElementTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDistributionChamberElementTypeEnum::operator Ifc4::IfcDistributionChamberElementTypeEnum::Value() const {
    return (Ifc4::IfcDistributionChamberElementTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDistributionPortTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[283]); }
const IfcParse::enumeration_type& Ifc4::IfcDistributionPortTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[283]); }

Ifc4::IfcDistributionPortTypeEnum::IfcDistributionPortTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDistributionPortTypeEnum::IfcDistributionPortTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDistributionPortTypeEnum::IfcDistributionPortTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDistributionPortTypeEnum::ToString(Value v) {
    return Ifc4::IfcDistributionPortTypeEnum::IfcDistributionPortTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDistributionPortTypeEnum::Value Ifc4::IfcDistributionPortTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDistributionPortTypeEnum::Value) Ifc4::IfcDistributionPortTypeEnum::IfcDistributionPortTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDistributionPortTypeEnum::operator Ifc4::IfcDistributionPortTypeEnum::Value() const {
    return (Ifc4::IfcDistributionPortTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDistributionSystemEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[285]); }
const IfcParse::enumeration_type& Ifc4::IfcDistributionSystemEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[285]); }

Ifc4::IfcDistributionSystemEnum::IfcDistributionSystemEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDistributionSystemEnum::IfcDistributionSystemEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDistributionSystemEnum::IfcDistributionSystemEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDistributionSystemEnum::ToString(Value v) {
    return Ifc4::IfcDistributionSystemEnum::IfcDistributionSystemEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDistributionSystemEnum::Value Ifc4::IfcDistributionSystemEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDistributionSystemEnum::Value) Ifc4::IfcDistributionSystemEnum::IfcDistributionSystemEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDistributionSystemEnum::operator Ifc4::IfcDistributionSystemEnum::Value() const {
    return (Ifc4::IfcDistributionSystemEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDocumentConfidentialityEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[286]); }
const IfcParse::enumeration_type& Ifc4::IfcDocumentConfidentialityEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[286]); }

Ifc4::IfcDocumentConfidentialityEnum::IfcDocumentConfidentialityEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDocumentConfidentialityEnum::IfcDocumentConfidentialityEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDocumentConfidentialityEnum::IfcDocumentConfidentialityEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDocumentConfidentialityEnum::ToString(Value v) {
    return Ifc4::IfcDocumentConfidentialityEnum::IfcDocumentConfidentialityEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDocumentConfidentialityEnum::Value Ifc4::IfcDocumentConfidentialityEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDocumentConfidentialityEnum::Value) Ifc4::IfcDocumentConfidentialityEnum::IfcDocumentConfidentialityEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDocumentConfidentialityEnum::operator Ifc4::IfcDocumentConfidentialityEnum::Value() const {
    return (Ifc4::IfcDocumentConfidentialityEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDocumentStatusEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[291]); }
const IfcParse::enumeration_type& Ifc4::IfcDocumentStatusEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[291]); }

Ifc4::IfcDocumentStatusEnum::IfcDocumentStatusEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDocumentStatusEnum::IfcDocumentStatusEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDocumentStatusEnum::IfcDocumentStatusEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDocumentStatusEnum::ToString(Value v) {
    return Ifc4::IfcDocumentStatusEnum::IfcDocumentStatusEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDocumentStatusEnum::Value Ifc4::IfcDocumentStatusEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDocumentStatusEnum::Value) Ifc4::IfcDocumentStatusEnum::IfcDocumentStatusEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDocumentStatusEnum::operator Ifc4::IfcDocumentStatusEnum::Value() const {
    return (Ifc4::IfcDocumentStatusEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDoorPanelOperationEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[294]); }
const IfcParse::enumeration_type& Ifc4::IfcDoorPanelOperationEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[294]); }

Ifc4::IfcDoorPanelOperationEnum::IfcDoorPanelOperationEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDoorPanelOperationEnum::IfcDoorPanelOperationEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDoorPanelOperationEnum::IfcDoorPanelOperationEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDoorPanelOperationEnum::ToString(Value v) {
    return Ifc4::IfcDoorPanelOperationEnum::IfcDoorPanelOperationEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDoorPanelOperationEnum::Value Ifc4::IfcDoorPanelOperationEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDoorPanelOperationEnum::Value) Ifc4::IfcDoorPanelOperationEnum::IfcDoorPanelOperationEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDoorPanelOperationEnum::operator Ifc4::IfcDoorPanelOperationEnum::Value() const {
    return (Ifc4::IfcDoorPanelOperationEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDoorPanelPositionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[295]); }
const IfcParse::enumeration_type& Ifc4::IfcDoorPanelPositionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[295]); }

Ifc4::IfcDoorPanelPositionEnum::IfcDoorPanelPositionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDoorPanelPositionEnum::IfcDoorPanelPositionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDoorPanelPositionEnum::IfcDoorPanelPositionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDoorPanelPositionEnum::ToString(Value v) {
    return Ifc4::IfcDoorPanelPositionEnum::IfcDoorPanelPositionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDoorPanelPositionEnum::Value Ifc4::IfcDoorPanelPositionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDoorPanelPositionEnum::Value) Ifc4::IfcDoorPanelPositionEnum::IfcDoorPanelPositionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDoorPanelPositionEnum::operator Ifc4::IfcDoorPanelPositionEnum::Value() const {
    return (Ifc4::IfcDoorPanelPositionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDoorStyleConstructionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[299]); }
const IfcParse::enumeration_type& Ifc4::IfcDoorStyleConstructionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[299]); }

Ifc4::IfcDoorStyleConstructionEnum::IfcDoorStyleConstructionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDoorStyleConstructionEnum::IfcDoorStyleConstructionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDoorStyleConstructionEnum::IfcDoorStyleConstructionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDoorStyleConstructionEnum::ToString(Value v) {
    return Ifc4::IfcDoorStyleConstructionEnum::IfcDoorStyleConstructionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDoorStyleConstructionEnum::Value Ifc4::IfcDoorStyleConstructionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDoorStyleConstructionEnum::Value) Ifc4::IfcDoorStyleConstructionEnum::IfcDoorStyleConstructionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDoorStyleConstructionEnum::operator Ifc4::IfcDoorStyleConstructionEnum::Value() const {
    return (Ifc4::IfcDoorStyleConstructionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDoorStyleOperationEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[300]); }
const IfcParse::enumeration_type& Ifc4::IfcDoorStyleOperationEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[300]); }

Ifc4::IfcDoorStyleOperationEnum::IfcDoorStyleOperationEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDoorStyleOperationEnum::IfcDoorStyleOperationEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDoorStyleOperationEnum::IfcDoorStyleOperationEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDoorStyleOperationEnum::ToString(Value v) {
    return Ifc4::IfcDoorStyleOperationEnum::IfcDoorStyleOperationEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDoorStyleOperationEnum::Value Ifc4::IfcDoorStyleOperationEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDoorStyleOperationEnum::Value) Ifc4::IfcDoorStyleOperationEnum::IfcDoorStyleOperationEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDoorStyleOperationEnum::operator Ifc4::IfcDoorStyleOperationEnum::Value() const {
    return (Ifc4::IfcDoorStyleOperationEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDoorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[302]); }
const IfcParse::enumeration_type& Ifc4::IfcDoorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[302]); }

Ifc4::IfcDoorTypeEnum::IfcDoorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDoorTypeEnum::IfcDoorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDoorTypeEnum::IfcDoorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDoorTypeEnum::ToString(Value v) {
    return Ifc4::IfcDoorTypeEnum::IfcDoorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDoorTypeEnum::Value Ifc4::IfcDoorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDoorTypeEnum::Value) Ifc4::IfcDoorTypeEnum::IfcDoorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDoorTypeEnum::operator Ifc4::IfcDoorTypeEnum::Value() const {
    return (Ifc4::IfcDoorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDoorTypeOperationEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[303]); }
const IfcParse::enumeration_type& Ifc4::IfcDoorTypeOperationEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[303]); }

Ifc4::IfcDoorTypeOperationEnum::IfcDoorTypeOperationEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDoorTypeOperationEnum::IfcDoorTypeOperationEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDoorTypeOperationEnum::IfcDoorTypeOperationEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDoorTypeOperationEnum::ToString(Value v) {
    return Ifc4::IfcDoorTypeOperationEnum::IfcDoorTypeOperationEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDoorTypeOperationEnum::Value Ifc4::IfcDoorTypeOperationEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDoorTypeOperationEnum::Value) Ifc4::IfcDoorTypeOperationEnum::IfcDoorTypeOperationEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDoorTypeOperationEnum::operator Ifc4::IfcDoorTypeOperationEnum::Value() const {
    return (Ifc4::IfcDoorTypeOperationEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDuctFittingTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[309]); }
const IfcParse::enumeration_type& Ifc4::IfcDuctFittingTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[309]); }

Ifc4::IfcDuctFittingTypeEnum::IfcDuctFittingTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDuctFittingTypeEnum::IfcDuctFittingTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDuctFittingTypeEnum::IfcDuctFittingTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDuctFittingTypeEnum::ToString(Value v) {
    return Ifc4::IfcDuctFittingTypeEnum::IfcDuctFittingTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDuctFittingTypeEnum::Value Ifc4::IfcDuctFittingTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDuctFittingTypeEnum::Value) Ifc4::IfcDuctFittingTypeEnum::IfcDuctFittingTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDuctFittingTypeEnum::operator Ifc4::IfcDuctFittingTypeEnum::Value() const {
    return (Ifc4::IfcDuctFittingTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDuctSegmentTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[312]); }
const IfcParse::enumeration_type& Ifc4::IfcDuctSegmentTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[312]); }

Ifc4::IfcDuctSegmentTypeEnum::IfcDuctSegmentTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDuctSegmentTypeEnum::IfcDuctSegmentTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDuctSegmentTypeEnum::IfcDuctSegmentTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDuctSegmentTypeEnum::ToString(Value v) {
    return Ifc4::IfcDuctSegmentTypeEnum::IfcDuctSegmentTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDuctSegmentTypeEnum::Value Ifc4::IfcDuctSegmentTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDuctSegmentTypeEnum::Value) Ifc4::IfcDuctSegmentTypeEnum::IfcDuctSegmentTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDuctSegmentTypeEnum::operator Ifc4::IfcDuctSegmentTypeEnum::Value() const {
    return (Ifc4::IfcDuctSegmentTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcDuctSilencerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[315]); }
const IfcParse::enumeration_type& Ifc4::IfcDuctSilencerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[315]); }

Ifc4::IfcDuctSilencerTypeEnum::IfcDuctSilencerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcDuctSilencerTypeEnum::IfcDuctSilencerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcDuctSilencerTypeEnum::IfcDuctSilencerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcDuctSilencerTypeEnum::ToString(Value v) {
    return Ifc4::IfcDuctSilencerTypeEnum::IfcDuctSilencerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcDuctSilencerTypeEnum::Value Ifc4::IfcDuctSilencerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcDuctSilencerTypeEnum::Value) Ifc4::IfcDuctSilencerTypeEnum::IfcDuctSilencerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcDuctSilencerTypeEnum::operator Ifc4::IfcDuctSilencerTypeEnum::Value() const {
    return (Ifc4::IfcDuctSilencerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcElectricApplianceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[323]); }
const IfcParse::enumeration_type& Ifc4::IfcElectricApplianceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[323]); }

Ifc4::IfcElectricApplianceTypeEnum::IfcElectricApplianceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcElectricApplianceTypeEnum::IfcElectricApplianceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcElectricApplianceTypeEnum::IfcElectricApplianceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcElectricApplianceTypeEnum::ToString(Value v) {
    return Ifc4::IfcElectricApplianceTypeEnum::IfcElectricApplianceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcElectricApplianceTypeEnum::Value Ifc4::IfcElectricApplianceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcElectricApplianceTypeEnum::Value) Ifc4::IfcElectricApplianceTypeEnum::IfcElectricApplianceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcElectricApplianceTypeEnum::operator Ifc4::IfcElectricApplianceTypeEnum::Value() const {
    return (Ifc4::IfcElectricApplianceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcElectricDistributionBoardTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[330]); }
const IfcParse::enumeration_type& Ifc4::IfcElectricDistributionBoardTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[330]); }

Ifc4::IfcElectricDistributionBoardTypeEnum::IfcElectricDistributionBoardTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcElectricDistributionBoardTypeEnum::IfcElectricDistributionBoardTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcElectricDistributionBoardTypeEnum::IfcElectricDistributionBoardTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcElectricDistributionBoardTypeEnum::ToString(Value v) {
    return Ifc4::IfcElectricDistributionBoardTypeEnum::IfcElectricDistributionBoardTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcElectricDistributionBoardTypeEnum::Value Ifc4::IfcElectricDistributionBoardTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcElectricDistributionBoardTypeEnum::Value) Ifc4::IfcElectricDistributionBoardTypeEnum::IfcElectricDistributionBoardTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcElectricDistributionBoardTypeEnum::operator Ifc4::IfcElectricDistributionBoardTypeEnum::Value() const {
    return (Ifc4::IfcElectricDistributionBoardTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcElectricFlowStorageDeviceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[333]); }
const IfcParse::enumeration_type& Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[333]); }

Ifc4::IfcElectricFlowStorageDeviceTypeEnum::IfcElectricFlowStorageDeviceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcElectricFlowStorageDeviceTypeEnum::IfcElectricFlowStorageDeviceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcElectricFlowStorageDeviceTypeEnum::IfcElectricFlowStorageDeviceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcElectricFlowStorageDeviceTypeEnum::ToString(Value v) {
    return Ifc4::IfcElectricFlowStorageDeviceTypeEnum::IfcElectricFlowStorageDeviceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value Ifc4::IfcElectricFlowStorageDeviceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value) Ifc4::IfcElectricFlowStorageDeviceTypeEnum::IfcElectricFlowStorageDeviceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcElectricFlowStorageDeviceTypeEnum::operator Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value() const {
    return (Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcElectricGeneratorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[336]); }
const IfcParse::enumeration_type& Ifc4::IfcElectricGeneratorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[336]); }

Ifc4::IfcElectricGeneratorTypeEnum::IfcElectricGeneratorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcElectricGeneratorTypeEnum::IfcElectricGeneratorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcElectricGeneratorTypeEnum::IfcElectricGeneratorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcElectricGeneratorTypeEnum::ToString(Value v) {
    return Ifc4::IfcElectricGeneratorTypeEnum::IfcElectricGeneratorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcElectricGeneratorTypeEnum::Value Ifc4::IfcElectricGeneratorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcElectricGeneratorTypeEnum::Value) Ifc4::IfcElectricGeneratorTypeEnum::IfcElectricGeneratorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcElectricGeneratorTypeEnum::operator Ifc4::IfcElectricGeneratorTypeEnum::Value() const {
    return (Ifc4::IfcElectricGeneratorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcElectricMotorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[339]); }
const IfcParse::enumeration_type& Ifc4::IfcElectricMotorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[339]); }

Ifc4::IfcElectricMotorTypeEnum::IfcElectricMotorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcElectricMotorTypeEnum::IfcElectricMotorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcElectricMotorTypeEnum::IfcElectricMotorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcElectricMotorTypeEnum::ToString(Value v) {
    return Ifc4::IfcElectricMotorTypeEnum::IfcElectricMotorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcElectricMotorTypeEnum::Value Ifc4::IfcElectricMotorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcElectricMotorTypeEnum::Value) Ifc4::IfcElectricMotorTypeEnum::IfcElectricMotorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcElectricMotorTypeEnum::operator Ifc4::IfcElectricMotorTypeEnum::Value() const {
    return (Ifc4::IfcElectricMotorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcElectricTimeControlTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[343]); }
const IfcParse::enumeration_type& Ifc4::IfcElectricTimeControlTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[343]); }

Ifc4::IfcElectricTimeControlTypeEnum::IfcElectricTimeControlTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcElectricTimeControlTypeEnum::IfcElectricTimeControlTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcElectricTimeControlTypeEnum::IfcElectricTimeControlTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcElectricTimeControlTypeEnum::ToString(Value v) {
    return Ifc4::IfcElectricTimeControlTypeEnum::IfcElectricTimeControlTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcElectricTimeControlTypeEnum::Value Ifc4::IfcElectricTimeControlTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcElectricTimeControlTypeEnum::Value) Ifc4::IfcElectricTimeControlTypeEnum::IfcElectricTimeControlTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcElectricTimeControlTypeEnum::operator Ifc4::IfcElectricTimeControlTypeEnum::Value() const {
    return (Ifc4::IfcElectricTimeControlTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcElementAssemblyTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[349]); }
const IfcParse::enumeration_type& Ifc4::IfcElementAssemblyTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[349]); }

Ifc4::IfcElementAssemblyTypeEnum::IfcElementAssemblyTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcElementAssemblyTypeEnum::IfcElementAssemblyTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcElementAssemblyTypeEnum::IfcElementAssemblyTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcElementAssemblyTypeEnum::ToString(Value v) {
    return Ifc4::IfcElementAssemblyTypeEnum::IfcElementAssemblyTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcElementAssemblyTypeEnum::Value Ifc4::IfcElementAssemblyTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcElementAssemblyTypeEnum::Value) Ifc4::IfcElementAssemblyTypeEnum::IfcElementAssemblyTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcElementAssemblyTypeEnum::operator Ifc4::IfcElementAssemblyTypeEnum::Value() const {
    return (Ifc4::IfcElementAssemblyTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcElementCompositionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[352]); }
const IfcParse::enumeration_type& Ifc4::IfcElementCompositionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[352]); }

Ifc4::IfcElementCompositionEnum::IfcElementCompositionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcElementCompositionEnum::IfcElementCompositionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcElementCompositionEnum::IfcElementCompositionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcElementCompositionEnum::ToString(Value v) {
    return Ifc4::IfcElementCompositionEnum::IfcElementCompositionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcElementCompositionEnum::Value Ifc4::IfcElementCompositionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcElementCompositionEnum::Value) Ifc4::IfcElementCompositionEnum::IfcElementCompositionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcElementCompositionEnum::operator Ifc4::IfcElementCompositionEnum::Value() const {
    return (Ifc4::IfcElementCompositionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcEngineTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[362]); }
const IfcParse::enumeration_type& Ifc4::IfcEngineTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[362]); }

Ifc4::IfcEngineTypeEnum::IfcEngineTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcEngineTypeEnum::IfcEngineTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcEngineTypeEnum::IfcEngineTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcEngineTypeEnum::ToString(Value v) {
    return Ifc4::IfcEngineTypeEnum::IfcEngineTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcEngineTypeEnum::Value Ifc4::IfcEngineTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcEngineTypeEnum::Value) Ifc4::IfcEngineTypeEnum::IfcEngineTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcEngineTypeEnum::operator Ifc4::IfcEngineTypeEnum::Value() const {
    return (Ifc4::IfcEngineTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcEvaporativeCoolerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[365]); }
const IfcParse::enumeration_type& Ifc4::IfcEvaporativeCoolerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[365]); }

Ifc4::IfcEvaporativeCoolerTypeEnum::IfcEvaporativeCoolerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcEvaporativeCoolerTypeEnum::IfcEvaporativeCoolerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcEvaporativeCoolerTypeEnum::IfcEvaporativeCoolerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcEvaporativeCoolerTypeEnum::ToString(Value v) {
    return Ifc4::IfcEvaporativeCoolerTypeEnum::IfcEvaporativeCoolerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcEvaporativeCoolerTypeEnum::Value Ifc4::IfcEvaporativeCoolerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcEvaporativeCoolerTypeEnum::Value) Ifc4::IfcEvaporativeCoolerTypeEnum::IfcEvaporativeCoolerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcEvaporativeCoolerTypeEnum::operator Ifc4::IfcEvaporativeCoolerTypeEnum::Value() const {
    return (Ifc4::IfcEvaporativeCoolerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcEvaporatorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[368]); }
const IfcParse::enumeration_type& Ifc4::IfcEvaporatorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[368]); }

Ifc4::IfcEvaporatorTypeEnum::IfcEvaporatorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcEvaporatorTypeEnum::IfcEvaporatorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcEvaporatorTypeEnum::IfcEvaporatorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcEvaporatorTypeEnum::ToString(Value v) {
    return Ifc4::IfcEvaporatorTypeEnum::IfcEvaporatorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcEvaporatorTypeEnum::Value Ifc4::IfcEvaporatorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcEvaporatorTypeEnum::Value) Ifc4::IfcEvaporatorTypeEnum::IfcEvaporatorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcEvaporatorTypeEnum::operator Ifc4::IfcEvaporatorTypeEnum::Value() const {
    return (Ifc4::IfcEvaporatorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcEventTriggerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[371]); }
const IfcParse::enumeration_type& Ifc4::IfcEventTriggerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[371]); }

Ifc4::IfcEventTriggerTypeEnum::IfcEventTriggerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcEventTriggerTypeEnum::IfcEventTriggerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcEventTriggerTypeEnum::IfcEventTriggerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcEventTriggerTypeEnum::ToString(Value v) {
    return Ifc4::IfcEventTriggerTypeEnum::IfcEventTriggerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcEventTriggerTypeEnum::Value Ifc4::IfcEventTriggerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcEventTriggerTypeEnum::Value) Ifc4::IfcEventTriggerTypeEnum::IfcEventTriggerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcEventTriggerTypeEnum::operator Ifc4::IfcEventTriggerTypeEnum::Value() const {
    return (Ifc4::IfcEventTriggerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcEventTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[373]); }
const IfcParse::enumeration_type& Ifc4::IfcEventTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[373]); }

Ifc4::IfcEventTypeEnum::IfcEventTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcEventTypeEnum::IfcEventTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcEventTypeEnum::IfcEventTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcEventTypeEnum::ToString(Value v) {
    return Ifc4::IfcEventTypeEnum::IfcEventTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcEventTypeEnum::Value Ifc4::IfcEventTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcEventTypeEnum::Value) Ifc4::IfcEventTypeEnum::IfcEventTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcEventTypeEnum::operator Ifc4::IfcEventTypeEnum::Value() const {
    return (Ifc4::IfcEventTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcExternalSpatialElementTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[382]); }
const IfcParse::enumeration_type& Ifc4::IfcExternalSpatialElementTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[382]); }

Ifc4::IfcExternalSpatialElementTypeEnum::IfcExternalSpatialElementTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcExternalSpatialElementTypeEnum::IfcExternalSpatialElementTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcExternalSpatialElementTypeEnum::IfcExternalSpatialElementTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcExternalSpatialElementTypeEnum::ToString(Value v) {
    return Ifc4::IfcExternalSpatialElementTypeEnum::IfcExternalSpatialElementTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcExternalSpatialElementTypeEnum::Value Ifc4::IfcExternalSpatialElementTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcExternalSpatialElementTypeEnum::Value) Ifc4::IfcExternalSpatialElementTypeEnum::IfcExternalSpatialElementTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcExternalSpatialElementTypeEnum::operator Ifc4::IfcExternalSpatialElementTypeEnum::Value() const {
    return (Ifc4::IfcExternalSpatialElementTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFanTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[396]); }
const IfcParse::enumeration_type& Ifc4::IfcFanTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[396]); }

Ifc4::IfcFanTypeEnum::IfcFanTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFanTypeEnum::IfcFanTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFanTypeEnum::IfcFanTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFanTypeEnum::ToString(Value v) {
    return Ifc4::IfcFanTypeEnum::IfcFanTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFanTypeEnum::Value Ifc4::IfcFanTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFanTypeEnum::Value) Ifc4::IfcFanTypeEnum::IfcFanTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFanTypeEnum::operator Ifc4::IfcFanTypeEnum::Value() const {
    return (Ifc4::IfcFanTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFastenerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[399]); }
const IfcParse::enumeration_type& Ifc4::IfcFastenerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[399]); }

Ifc4::IfcFastenerTypeEnum::IfcFastenerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFastenerTypeEnum::IfcFastenerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFastenerTypeEnum::IfcFastenerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFastenerTypeEnum::ToString(Value v) {
    return Ifc4::IfcFastenerTypeEnum::IfcFastenerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFastenerTypeEnum::Value Ifc4::IfcFastenerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFastenerTypeEnum::Value) Ifc4::IfcFastenerTypeEnum::IfcFastenerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFastenerTypeEnum::operator Ifc4::IfcFastenerTypeEnum::Value() const {
    return (Ifc4::IfcFastenerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFilterTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[409]); }
const IfcParse::enumeration_type& Ifc4::IfcFilterTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[409]); }

Ifc4::IfcFilterTypeEnum::IfcFilterTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFilterTypeEnum::IfcFilterTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFilterTypeEnum::IfcFilterTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFilterTypeEnum::ToString(Value v) {
    return Ifc4::IfcFilterTypeEnum::IfcFilterTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFilterTypeEnum::Value Ifc4::IfcFilterTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFilterTypeEnum::Value) Ifc4::IfcFilterTypeEnum::IfcFilterTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFilterTypeEnum::operator Ifc4::IfcFilterTypeEnum::Value() const {
    return (Ifc4::IfcFilterTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFireSuppressionTerminalTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[412]); }
const IfcParse::enumeration_type& Ifc4::IfcFireSuppressionTerminalTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[412]); }

Ifc4::IfcFireSuppressionTerminalTypeEnum::IfcFireSuppressionTerminalTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFireSuppressionTerminalTypeEnum::IfcFireSuppressionTerminalTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFireSuppressionTerminalTypeEnum::IfcFireSuppressionTerminalTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFireSuppressionTerminalTypeEnum::ToString(Value v) {
    return Ifc4::IfcFireSuppressionTerminalTypeEnum::IfcFireSuppressionTerminalTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFireSuppressionTerminalTypeEnum::Value Ifc4::IfcFireSuppressionTerminalTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFireSuppressionTerminalTypeEnum::Value) Ifc4::IfcFireSuppressionTerminalTypeEnum::IfcFireSuppressionTerminalTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFireSuppressionTerminalTypeEnum::operator Ifc4::IfcFireSuppressionTerminalTypeEnum::Value() const {
    return (Ifc4::IfcFireSuppressionTerminalTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFlowDirectionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[416]); }
const IfcParse::enumeration_type& Ifc4::IfcFlowDirectionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[416]); }

Ifc4::IfcFlowDirectionEnum::IfcFlowDirectionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFlowDirectionEnum::IfcFlowDirectionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFlowDirectionEnum::IfcFlowDirectionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFlowDirectionEnum::ToString(Value v) {
    return Ifc4::IfcFlowDirectionEnum::IfcFlowDirectionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFlowDirectionEnum::Value Ifc4::IfcFlowDirectionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFlowDirectionEnum::Value) Ifc4::IfcFlowDirectionEnum::IfcFlowDirectionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFlowDirectionEnum::operator Ifc4::IfcFlowDirectionEnum::Value() const {
    return (Ifc4::IfcFlowDirectionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFlowInstrumentTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[421]); }
const IfcParse::enumeration_type& Ifc4::IfcFlowInstrumentTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[421]); }

Ifc4::IfcFlowInstrumentTypeEnum::IfcFlowInstrumentTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFlowInstrumentTypeEnum::IfcFlowInstrumentTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFlowInstrumentTypeEnum::IfcFlowInstrumentTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFlowInstrumentTypeEnum::ToString(Value v) {
    return Ifc4::IfcFlowInstrumentTypeEnum::IfcFlowInstrumentTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFlowInstrumentTypeEnum::Value Ifc4::IfcFlowInstrumentTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFlowInstrumentTypeEnum::Value) Ifc4::IfcFlowInstrumentTypeEnum::IfcFlowInstrumentTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFlowInstrumentTypeEnum::operator Ifc4::IfcFlowInstrumentTypeEnum::Value() const {
    return (Ifc4::IfcFlowInstrumentTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFlowMeterTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[424]); }
const IfcParse::enumeration_type& Ifc4::IfcFlowMeterTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[424]); }

Ifc4::IfcFlowMeterTypeEnum::IfcFlowMeterTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFlowMeterTypeEnum::IfcFlowMeterTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFlowMeterTypeEnum::IfcFlowMeterTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFlowMeterTypeEnum::ToString(Value v) {
    return Ifc4::IfcFlowMeterTypeEnum::IfcFlowMeterTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFlowMeterTypeEnum::Value Ifc4::IfcFlowMeterTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFlowMeterTypeEnum::Value) Ifc4::IfcFlowMeterTypeEnum::IfcFlowMeterTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFlowMeterTypeEnum::operator Ifc4::IfcFlowMeterTypeEnum::Value() const {
    return (Ifc4::IfcFlowMeterTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFootingTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[440]); }
const IfcParse::enumeration_type& Ifc4::IfcFootingTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[440]); }

Ifc4::IfcFootingTypeEnum::IfcFootingTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFootingTypeEnum::IfcFootingTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFootingTypeEnum::IfcFootingTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFootingTypeEnum::ToString(Value v) {
    return Ifc4::IfcFootingTypeEnum::IfcFootingTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFootingTypeEnum::Value Ifc4::IfcFootingTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFootingTypeEnum::Value) Ifc4::IfcFootingTypeEnum::IfcFootingTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFootingTypeEnum::operator Ifc4::IfcFootingTypeEnum::Value() const {
    return (Ifc4::IfcFootingTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcFurnitureTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[447]); }
const IfcParse::enumeration_type& Ifc4::IfcFurnitureTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[447]); }

Ifc4::IfcFurnitureTypeEnum::IfcFurnitureTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcFurnitureTypeEnum::IfcFurnitureTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcFurnitureTypeEnum::IfcFurnitureTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcFurnitureTypeEnum::ToString(Value v) {
    return Ifc4::IfcFurnitureTypeEnum::IfcFurnitureTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcFurnitureTypeEnum::Value Ifc4::IfcFurnitureTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcFurnitureTypeEnum::Value) Ifc4::IfcFurnitureTypeEnum::IfcFurnitureTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcFurnitureTypeEnum::operator Ifc4::IfcFurnitureTypeEnum::Value() const {
    return (Ifc4::IfcFurnitureTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcGeographicElementTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[450]); }
const IfcParse::enumeration_type& Ifc4::IfcGeographicElementTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[450]); }

Ifc4::IfcGeographicElementTypeEnum::IfcGeographicElementTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcGeographicElementTypeEnum::IfcGeographicElementTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcGeographicElementTypeEnum::IfcGeographicElementTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcGeographicElementTypeEnum::ToString(Value v) {
    return Ifc4::IfcGeographicElementTypeEnum::IfcGeographicElementTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcGeographicElementTypeEnum::Value Ifc4::IfcGeographicElementTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcGeographicElementTypeEnum::Value) Ifc4::IfcGeographicElementTypeEnum::IfcGeographicElementTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcGeographicElementTypeEnum::operator Ifc4::IfcGeographicElementTypeEnum::Value() const {
    return (Ifc4::IfcGeographicElementTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcGeometricProjectionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[452]); }
const IfcParse::enumeration_type& Ifc4::IfcGeometricProjectionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[452]); }

Ifc4::IfcGeometricProjectionEnum::IfcGeometricProjectionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcGeometricProjectionEnum::IfcGeometricProjectionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcGeometricProjectionEnum::IfcGeometricProjectionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcGeometricProjectionEnum::ToString(Value v) {
    return Ifc4::IfcGeometricProjectionEnum::IfcGeometricProjectionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcGeometricProjectionEnum::Value Ifc4::IfcGeometricProjectionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcGeometricProjectionEnum::Value) Ifc4::IfcGeometricProjectionEnum::IfcGeometricProjectionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcGeometricProjectionEnum::operator Ifc4::IfcGeometricProjectionEnum::Value() const {
    return (Ifc4::IfcGeometricProjectionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcGlobalOrLocalEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[459]); }
const IfcParse::enumeration_type& Ifc4::IfcGlobalOrLocalEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[459]); }

Ifc4::IfcGlobalOrLocalEnum::IfcGlobalOrLocalEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcGlobalOrLocalEnum::IfcGlobalOrLocalEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcGlobalOrLocalEnum::IfcGlobalOrLocalEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcGlobalOrLocalEnum::ToString(Value v) {
    return Ifc4::IfcGlobalOrLocalEnum::IfcGlobalOrLocalEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcGlobalOrLocalEnum::Value Ifc4::IfcGlobalOrLocalEnum::FromString(const std::string& s) {
    return (Ifc4::IfcGlobalOrLocalEnum::Value) Ifc4::IfcGlobalOrLocalEnum::IfcGlobalOrLocalEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcGlobalOrLocalEnum::operator Ifc4::IfcGlobalOrLocalEnum::Value() const {
    return (Ifc4::IfcGlobalOrLocalEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcGridTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[464]); }
const IfcParse::enumeration_type& Ifc4::IfcGridTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[464]); }

Ifc4::IfcGridTypeEnum::IfcGridTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcGridTypeEnum::IfcGridTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcGridTypeEnum::IfcGridTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcGridTypeEnum::ToString(Value v) {
    return Ifc4::IfcGridTypeEnum::IfcGridTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcGridTypeEnum::Value Ifc4::IfcGridTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcGridTypeEnum::Value) Ifc4::IfcGridTypeEnum::IfcGridTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcGridTypeEnum::operator Ifc4::IfcGridTypeEnum::Value() const {
    return (Ifc4::IfcGridTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcHeatExchangerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[470]); }
const IfcParse::enumeration_type& Ifc4::IfcHeatExchangerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[470]); }

Ifc4::IfcHeatExchangerTypeEnum::IfcHeatExchangerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcHeatExchangerTypeEnum::IfcHeatExchangerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcHeatExchangerTypeEnum::IfcHeatExchangerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcHeatExchangerTypeEnum::ToString(Value v) {
    return Ifc4::IfcHeatExchangerTypeEnum::IfcHeatExchangerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcHeatExchangerTypeEnum::Value Ifc4::IfcHeatExchangerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcHeatExchangerTypeEnum::Value) Ifc4::IfcHeatExchangerTypeEnum::IfcHeatExchangerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcHeatExchangerTypeEnum::operator Ifc4::IfcHeatExchangerTypeEnum::Value() const {
    return (Ifc4::IfcHeatExchangerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcHumidifierTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[475]); }
const IfcParse::enumeration_type& Ifc4::IfcHumidifierTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[475]); }

Ifc4::IfcHumidifierTypeEnum::IfcHumidifierTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcHumidifierTypeEnum::IfcHumidifierTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcHumidifierTypeEnum::IfcHumidifierTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcHumidifierTypeEnum::ToString(Value v) {
    return Ifc4::IfcHumidifierTypeEnum::IfcHumidifierTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcHumidifierTypeEnum::Value Ifc4::IfcHumidifierTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcHumidifierTypeEnum::Value) Ifc4::IfcHumidifierTypeEnum::IfcHumidifierTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcHumidifierTypeEnum::operator Ifc4::IfcHumidifierTypeEnum::Value() const {
    return (Ifc4::IfcHumidifierTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcInterceptorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[490]); }
const IfcParse::enumeration_type& Ifc4::IfcInterceptorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[490]); }

Ifc4::IfcInterceptorTypeEnum::IfcInterceptorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcInterceptorTypeEnum::IfcInterceptorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcInterceptorTypeEnum::IfcInterceptorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcInterceptorTypeEnum::ToString(Value v) {
    return Ifc4::IfcInterceptorTypeEnum::IfcInterceptorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcInterceptorTypeEnum::Value Ifc4::IfcInterceptorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcInterceptorTypeEnum::Value) Ifc4::IfcInterceptorTypeEnum::IfcInterceptorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcInterceptorTypeEnum::operator Ifc4::IfcInterceptorTypeEnum::Value() const {
    return (Ifc4::IfcInterceptorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcInternalOrExternalEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[491]); }
const IfcParse::enumeration_type& Ifc4::IfcInternalOrExternalEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[491]); }

Ifc4::IfcInternalOrExternalEnum::IfcInternalOrExternalEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcInternalOrExternalEnum::IfcInternalOrExternalEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcInternalOrExternalEnum::IfcInternalOrExternalEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcInternalOrExternalEnum::ToString(Value v) {
    return Ifc4::IfcInternalOrExternalEnum::IfcInternalOrExternalEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcInternalOrExternalEnum::Value Ifc4::IfcInternalOrExternalEnum::FromString(const std::string& s) {
    return (Ifc4::IfcInternalOrExternalEnum::Value) Ifc4::IfcInternalOrExternalEnum::IfcInternalOrExternalEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcInternalOrExternalEnum::operator Ifc4::IfcInternalOrExternalEnum::Value() const {
    return (Ifc4::IfcInternalOrExternalEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcInventoryTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[494]); }
const IfcParse::enumeration_type& Ifc4::IfcInventoryTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[494]); }

Ifc4::IfcInventoryTypeEnum::IfcInventoryTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcInventoryTypeEnum::IfcInventoryTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcInventoryTypeEnum::IfcInventoryTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcInventoryTypeEnum::ToString(Value v) {
    return Ifc4::IfcInventoryTypeEnum::IfcInventoryTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcInventoryTypeEnum::Value Ifc4::IfcInventoryTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcInventoryTypeEnum::Value) Ifc4::IfcInventoryTypeEnum::IfcInventoryTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcInventoryTypeEnum::operator Ifc4::IfcInventoryTypeEnum::Value() const {
    return (Ifc4::IfcInventoryTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcJunctionBoxTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[502]); }
const IfcParse::enumeration_type& Ifc4::IfcJunctionBoxTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[502]); }

Ifc4::IfcJunctionBoxTypeEnum::IfcJunctionBoxTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcJunctionBoxTypeEnum::IfcJunctionBoxTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcJunctionBoxTypeEnum::IfcJunctionBoxTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcJunctionBoxTypeEnum::ToString(Value v) {
    return Ifc4::IfcJunctionBoxTypeEnum::IfcJunctionBoxTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcJunctionBoxTypeEnum::Value Ifc4::IfcJunctionBoxTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcJunctionBoxTypeEnum::Value) Ifc4::IfcJunctionBoxTypeEnum::IfcJunctionBoxTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcJunctionBoxTypeEnum::operator Ifc4::IfcJunctionBoxTypeEnum::Value() const {
    return (Ifc4::IfcJunctionBoxTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcKnotType::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[504]); }
const IfcParse::enumeration_type& Ifc4::IfcKnotType::Class() { return *((IfcParse::enumeration_type*)IFC4_types[504]); }

Ifc4::IfcKnotType::IfcKnotType(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcKnotType::IfcKnotType(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcKnotType::IfcKnotType(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcKnotType::ToString(Value v) {
    return Ifc4::IfcKnotType::IfcKnotType::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcKnotType::Value Ifc4::IfcKnotType::FromString(const std::string& s) {
    return (Ifc4::IfcKnotType::Value) Ifc4::IfcKnotType::IfcKnotType::Class().lookup_enum_offset(s);
}

Ifc4::IfcKnotType::operator Ifc4::IfcKnotType::Value() const {
    return (Ifc4::IfcKnotType::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcLaborResourceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[508]); }
const IfcParse::enumeration_type& Ifc4::IfcLaborResourceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[508]); }

Ifc4::IfcLaborResourceTypeEnum::IfcLaborResourceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcLaborResourceTypeEnum::IfcLaborResourceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcLaborResourceTypeEnum::IfcLaborResourceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcLaborResourceTypeEnum::ToString(Value v) {
    return Ifc4::IfcLaborResourceTypeEnum::IfcLaborResourceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcLaborResourceTypeEnum::Value Ifc4::IfcLaborResourceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcLaborResourceTypeEnum::Value) Ifc4::IfcLaborResourceTypeEnum::IfcLaborResourceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcLaborResourceTypeEnum::operator Ifc4::IfcLaborResourceTypeEnum::Value() const {
    return (Ifc4::IfcLaborResourceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcLampTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[512]); }
const IfcParse::enumeration_type& Ifc4::IfcLampTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[512]); }

Ifc4::IfcLampTypeEnum::IfcLampTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcLampTypeEnum::IfcLampTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcLampTypeEnum::IfcLampTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcLampTypeEnum::ToString(Value v) {
    return Ifc4::IfcLampTypeEnum::IfcLampTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcLampTypeEnum::Value Ifc4::IfcLampTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcLampTypeEnum::Value) Ifc4::IfcLampTypeEnum::IfcLampTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcLampTypeEnum::operator Ifc4::IfcLampTypeEnum::Value() const {
    return (Ifc4::IfcLampTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcLayerSetDirectionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[515]); }
const IfcParse::enumeration_type& Ifc4::IfcLayerSetDirectionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[515]); }

Ifc4::IfcLayerSetDirectionEnum::IfcLayerSetDirectionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcLayerSetDirectionEnum::IfcLayerSetDirectionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcLayerSetDirectionEnum::IfcLayerSetDirectionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcLayerSetDirectionEnum::ToString(Value v) {
    return Ifc4::IfcLayerSetDirectionEnum::IfcLayerSetDirectionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcLayerSetDirectionEnum::Value Ifc4::IfcLayerSetDirectionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcLayerSetDirectionEnum::Value) Ifc4::IfcLayerSetDirectionEnum::IfcLayerSetDirectionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcLayerSetDirectionEnum::operator Ifc4::IfcLayerSetDirectionEnum::Value() const {
    return (Ifc4::IfcLayerSetDirectionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcLightDistributionCurveEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[520]); }
const IfcParse::enumeration_type& Ifc4::IfcLightDistributionCurveEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[520]); }

Ifc4::IfcLightDistributionCurveEnum::IfcLightDistributionCurveEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcLightDistributionCurveEnum::IfcLightDistributionCurveEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcLightDistributionCurveEnum::IfcLightDistributionCurveEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcLightDistributionCurveEnum::ToString(Value v) {
    return Ifc4::IfcLightDistributionCurveEnum::IfcLightDistributionCurveEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcLightDistributionCurveEnum::Value Ifc4::IfcLightDistributionCurveEnum::FromString(const std::string& s) {
    return (Ifc4::IfcLightDistributionCurveEnum::Value) Ifc4::IfcLightDistributionCurveEnum::IfcLightDistributionCurveEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcLightDistributionCurveEnum::operator Ifc4::IfcLightDistributionCurveEnum::Value() const {
    return (Ifc4::IfcLightDistributionCurveEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcLightEmissionSourceEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[523]); }
const IfcParse::enumeration_type& Ifc4::IfcLightEmissionSourceEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[523]); }

Ifc4::IfcLightEmissionSourceEnum::IfcLightEmissionSourceEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcLightEmissionSourceEnum::IfcLightEmissionSourceEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcLightEmissionSourceEnum::IfcLightEmissionSourceEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcLightEmissionSourceEnum::ToString(Value v) {
    return Ifc4::IfcLightEmissionSourceEnum::IfcLightEmissionSourceEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcLightEmissionSourceEnum::Value Ifc4::IfcLightEmissionSourceEnum::FromString(const std::string& s) {
    return (Ifc4::IfcLightEmissionSourceEnum::Value) Ifc4::IfcLightEmissionSourceEnum::IfcLightEmissionSourceEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcLightEmissionSourceEnum::operator Ifc4::IfcLightEmissionSourceEnum::Value() const {
    return (Ifc4::IfcLightEmissionSourceEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcLightFixtureTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[526]); }
const IfcParse::enumeration_type& Ifc4::IfcLightFixtureTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[526]); }

Ifc4::IfcLightFixtureTypeEnum::IfcLightFixtureTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcLightFixtureTypeEnum::IfcLightFixtureTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcLightFixtureTypeEnum::IfcLightFixtureTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcLightFixtureTypeEnum::ToString(Value v) {
    return Ifc4::IfcLightFixtureTypeEnum::IfcLightFixtureTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcLightFixtureTypeEnum::Value Ifc4::IfcLightFixtureTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcLightFixtureTypeEnum::Value) Ifc4::IfcLightFixtureTypeEnum::IfcLightFixtureTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcLightFixtureTypeEnum::operator Ifc4::IfcLightFixtureTypeEnum::Value() const {
    return (Ifc4::IfcLightFixtureTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcLoadGroupTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[540]); }
const IfcParse::enumeration_type& Ifc4::IfcLoadGroupTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[540]); }

Ifc4::IfcLoadGroupTypeEnum::IfcLoadGroupTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcLoadGroupTypeEnum::IfcLoadGroupTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcLoadGroupTypeEnum::IfcLoadGroupTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcLoadGroupTypeEnum::ToString(Value v) {
    return Ifc4::IfcLoadGroupTypeEnum::IfcLoadGroupTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcLoadGroupTypeEnum::Value Ifc4::IfcLoadGroupTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcLoadGroupTypeEnum::Value) Ifc4::IfcLoadGroupTypeEnum::IfcLoadGroupTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcLoadGroupTypeEnum::operator Ifc4::IfcLoadGroupTypeEnum::Value() const {
    return (Ifc4::IfcLoadGroupTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcLogicalOperatorEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[543]); }
const IfcParse::enumeration_type& Ifc4::IfcLogicalOperatorEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[543]); }

Ifc4::IfcLogicalOperatorEnum::IfcLogicalOperatorEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcLogicalOperatorEnum::IfcLogicalOperatorEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcLogicalOperatorEnum::IfcLogicalOperatorEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcLogicalOperatorEnum::ToString(Value v) {
    return Ifc4::IfcLogicalOperatorEnum::IfcLogicalOperatorEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcLogicalOperatorEnum::Value Ifc4::IfcLogicalOperatorEnum::FromString(const std::string& s) {
    return (Ifc4::IfcLogicalOperatorEnum::Value) Ifc4::IfcLogicalOperatorEnum::IfcLogicalOperatorEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcLogicalOperatorEnum::operator Ifc4::IfcLogicalOperatorEnum::Value() const {
    return (Ifc4::IfcLogicalOperatorEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcMechanicalFastenerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[582]); }
const IfcParse::enumeration_type& Ifc4::IfcMechanicalFastenerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[582]); }

Ifc4::IfcMechanicalFastenerTypeEnum::IfcMechanicalFastenerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcMechanicalFastenerTypeEnum::IfcMechanicalFastenerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcMechanicalFastenerTypeEnum::IfcMechanicalFastenerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcMechanicalFastenerTypeEnum::ToString(Value v) {
    return Ifc4::IfcMechanicalFastenerTypeEnum::IfcMechanicalFastenerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcMechanicalFastenerTypeEnum::Value Ifc4::IfcMechanicalFastenerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcMechanicalFastenerTypeEnum::Value) Ifc4::IfcMechanicalFastenerTypeEnum::IfcMechanicalFastenerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcMechanicalFastenerTypeEnum::operator Ifc4::IfcMechanicalFastenerTypeEnum::Value() const {
    return (Ifc4::IfcMechanicalFastenerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcMedicalDeviceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[585]); }
const IfcParse::enumeration_type& Ifc4::IfcMedicalDeviceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[585]); }

Ifc4::IfcMedicalDeviceTypeEnum::IfcMedicalDeviceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcMedicalDeviceTypeEnum::IfcMedicalDeviceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcMedicalDeviceTypeEnum::IfcMedicalDeviceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcMedicalDeviceTypeEnum::ToString(Value v) {
    return Ifc4::IfcMedicalDeviceTypeEnum::IfcMedicalDeviceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcMedicalDeviceTypeEnum::Value Ifc4::IfcMedicalDeviceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcMedicalDeviceTypeEnum::Value) Ifc4::IfcMedicalDeviceTypeEnum::IfcMedicalDeviceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcMedicalDeviceTypeEnum::operator Ifc4::IfcMedicalDeviceTypeEnum::Value() const {
    return (Ifc4::IfcMedicalDeviceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcMemberTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[589]); }
const IfcParse::enumeration_type& Ifc4::IfcMemberTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[589]); }

Ifc4::IfcMemberTypeEnum::IfcMemberTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcMemberTypeEnum::IfcMemberTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcMemberTypeEnum::IfcMemberTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcMemberTypeEnum::ToString(Value v) {
    return Ifc4::IfcMemberTypeEnum::IfcMemberTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcMemberTypeEnum::Value Ifc4::IfcMemberTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcMemberTypeEnum::Value) Ifc4::IfcMemberTypeEnum::IfcMemberTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcMemberTypeEnum::operator Ifc4::IfcMemberTypeEnum::Value() const {
    return (Ifc4::IfcMemberTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcMotorConnectionTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[608]); }
const IfcParse::enumeration_type& Ifc4::IfcMotorConnectionTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[608]); }

Ifc4::IfcMotorConnectionTypeEnum::IfcMotorConnectionTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcMotorConnectionTypeEnum::IfcMotorConnectionTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcMotorConnectionTypeEnum::IfcMotorConnectionTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcMotorConnectionTypeEnum::ToString(Value v) {
    return Ifc4::IfcMotorConnectionTypeEnum::IfcMotorConnectionTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcMotorConnectionTypeEnum::Value Ifc4::IfcMotorConnectionTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcMotorConnectionTypeEnum::Value) Ifc4::IfcMotorConnectionTypeEnum::IfcMotorConnectionTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcMotorConnectionTypeEnum::operator Ifc4::IfcMotorConnectionTypeEnum::Value() const {
    return (Ifc4::IfcMotorConnectionTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcNullStyle::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[612]); }
const IfcParse::enumeration_type& Ifc4::IfcNullStyle::Class() { return *((IfcParse::enumeration_type*)IFC4_types[612]); }

Ifc4::IfcNullStyle::IfcNullStyle(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcNullStyle::IfcNullStyle(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcNullStyle::IfcNullStyle(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcNullStyle::ToString(Value v) {
    return Ifc4::IfcNullStyle::IfcNullStyle::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcNullStyle::Value Ifc4::IfcNullStyle::FromString(const std::string& s) {
    return (Ifc4::IfcNullStyle::Value) Ifc4::IfcNullStyle::IfcNullStyle::Class().lookup_enum_offset(s);
}

Ifc4::IfcNullStyle::operator Ifc4::IfcNullStyle::Value() const {
    return (Ifc4::IfcNullStyle::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcObjectTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[620]); }
const IfcParse::enumeration_type& Ifc4::IfcObjectTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[620]); }

Ifc4::IfcObjectTypeEnum::IfcObjectTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcObjectTypeEnum::IfcObjectTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcObjectTypeEnum::IfcObjectTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcObjectTypeEnum::ToString(Value v) {
    return Ifc4::IfcObjectTypeEnum::IfcObjectTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcObjectTypeEnum::Value Ifc4::IfcObjectTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcObjectTypeEnum::Value) Ifc4::IfcObjectTypeEnum::IfcObjectTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcObjectTypeEnum::operator Ifc4::IfcObjectTypeEnum::Value() const {
    return (Ifc4::IfcObjectTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcObjectiveEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[617]); }
const IfcParse::enumeration_type& Ifc4::IfcObjectiveEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[617]); }

Ifc4::IfcObjectiveEnum::IfcObjectiveEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcObjectiveEnum::IfcObjectiveEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcObjectiveEnum::IfcObjectiveEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcObjectiveEnum::ToString(Value v) {
    return Ifc4::IfcObjectiveEnum::IfcObjectiveEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcObjectiveEnum::Value Ifc4::IfcObjectiveEnum::FromString(const std::string& s) {
    return (Ifc4::IfcObjectiveEnum::Value) Ifc4::IfcObjectiveEnum::IfcObjectiveEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcObjectiveEnum::operator Ifc4::IfcObjectiveEnum::Value() const {
    return (Ifc4::IfcObjectiveEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcOccupantTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[622]); }
const IfcParse::enumeration_type& Ifc4::IfcOccupantTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[622]); }

Ifc4::IfcOccupantTypeEnum::IfcOccupantTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcOccupantTypeEnum::IfcOccupantTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcOccupantTypeEnum::IfcOccupantTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcOccupantTypeEnum::ToString(Value v) {
    return Ifc4::IfcOccupantTypeEnum::IfcOccupantTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcOccupantTypeEnum::Value Ifc4::IfcOccupantTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcOccupantTypeEnum::Value) Ifc4::IfcOccupantTypeEnum::IfcOccupantTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcOccupantTypeEnum::operator Ifc4::IfcOccupantTypeEnum::Value() const {
    return (Ifc4::IfcOccupantTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcOpeningElementTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[626]); }
const IfcParse::enumeration_type& Ifc4::IfcOpeningElementTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[626]); }

Ifc4::IfcOpeningElementTypeEnum::IfcOpeningElementTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcOpeningElementTypeEnum::IfcOpeningElementTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcOpeningElementTypeEnum::IfcOpeningElementTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcOpeningElementTypeEnum::ToString(Value v) {
    return Ifc4::IfcOpeningElementTypeEnum::IfcOpeningElementTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcOpeningElementTypeEnum::Value Ifc4::IfcOpeningElementTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcOpeningElementTypeEnum::Value) Ifc4::IfcOpeningElementTypeEnum::IfcOpeningElementTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcOpeningElementTypeEnum::operator Ifc4::IfcOpeningElementTypeEnum::Value() const {
    return (Ifc4::IfcOpeningElementTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcOutletTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[635]); }
const IfcParse::enumeration_type& Ifc4::IfcOutletTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[635]); }

Ifc4::IfcOutletTypeEnum::IfcOutletTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcOutletTypeEnum::IfcOutletTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcOutletTypeEnum::IfcOutletTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcOutletTypeEnum::ToString(Value v) {
    return Ifc4::IfcOutletTypeEnum::IfcOutletTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcOutletTypeEnum::Value Ifc4::IfcOutletTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcOutletTypeEnum::Value) Ifc4::IfcOutletTypeEnum::IfcOutletTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcOutletTypeEnum::operator Ifc4::IfcOutletTypeEnum::Value() const {
    return (Ifc4::IfcOutletTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPerformanceHistoryTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[642]); }
const IfcParse::enumeration_type& Ifc4::IfcPerformanceHistoryTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[642]); }

Ifc4::IfcPerformanceHistoryTypeEnum::IfcPerformanceHistoryTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPerformanceHistoryTypeEnum::IfcPerformanceHistoryTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPerformanceHistoryTypeEnum::IfcPerformanceHistoryTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPerformanceHistoryTypeEnum::ToString(Value v) {
    return Ifc4::IfcPerformanceHistoryTypeEnum::IfcPerformanceHistoryTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPerformanceHistoryTypeEnum::Value Ifc4::IfcPerformanceHistoryTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPerformanceHistoryTypeEnum::Value) Ifc4::IfcPerformanceHistoryTypeEnum::IfcPerformanceHistoryTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPerformanceHistoryTypeEnum::operator Ifc4::IfcPerformanceHistoryTypeEnum::Value() const {
    return (Ifc4::IfcPerformanceHistoryTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPermeableCoveringOperationEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[643]); }
const IfcParse::enumeration_type& Ifc4::IfcPermeableCoveringOperationEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[643]); }

Ifc4::IfcPermeableCoveringOperationEnum::IfcPermeableCoveringOperationEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPermeableCoveringOperationEnum::IfcPermeableCoveringOperationEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPermeableCoveringOperationEnum::IfcPermeableCoveringOperationEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPermeableCoveringOperationEnum::ToString(Value v) {
    return Ifc4::IfcPermeableCoveringOperationEnum::IfcPermeableCoveringOperationEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPermeableCoveringOperationEnum::Value Ifc4::IfcPermeableCoveringOperationEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPermeableCoveringOperationEnum::Value) Ifc4::IfcPermeableCoveringOperationEnum::IfcPermeableCoveringOperationEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPermeableCoveringOperationEnum::operator Ifc4::IfcPermeableCoveringOperationEnum::Value() const {
    return (Ifc4::IfcPermeableCoveringOperationEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPermitTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[646]); }
const IfcParse::enumeration_type& Ifc4::IfcPermitTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[646]); }

Ifc4::IfcPermitTypeEnum::IfcPermitTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPermitTypeEnum::IfcPermitTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPermitTypeEnum::IfcPermitTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPermitTypeEnum::ToString(Value v) {
    return Ifc4::IfcPermitTypeEnum::IfcPermitTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPermitTypeEnum::Value Ifc4::IfcPermitTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPermitTypeEnum::Value) Ifc4::IfcPermitTypeEnum::IfcPermitTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPermitTypeEnum::operator Ifc4::IfcPermitTypeEnum::Value() const {
    return (Ifc4::IfcPermitTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPhysicalOrVirtualEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[651]); }
const IfcParse::enumeration_type& Ifc4::IfcPhysicalOrVirtualEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[651]); }

Ifc4::IfcPhysicalOrVirtualEnum::IfcPhysicalOrVirtualEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPhysicalOrVirtualEnum::IfcPhysicalOrVirtualEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPhysicalOrVirtualEnum::IfcPhysicalOrVirtualEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPhysicalOrVirtualEnum::ToString(Value v) {
    return Ifc4::IfcPhysicalOrVirtualEnum::IfcPhysicalOrVirtualEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPhysicalOrVirtualEnum::Value Ifc4::IfcPhysicalOrVirtualEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPhysicalOrVirtualEnum::Value) Ifc4::IfcPhysicalOrVirtualEnum::IfcPhysicalOrVirtualEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPhysicalOrVirtualEnum::operator Ifc4::IfcPhysicalOrVirtualEnum::Value() const {
    return (Ifc4::IfcPhysicalOrVirtualEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPileConstructionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[655]); }
const IfcParse::enumeration_type& Ifc4::IfcPileConstructionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[655]); }

Ifc4::IfcPileConstructionEnum::IfcPileConstructionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPileConstructionEnum::IfcPileConstructionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPileConstructionEnum::IfcPileConstructionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPileConstructionEnum::ToString(Value v) {
    return Ifc4::IfcPileConstructionEnum::IfcPileConstructionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPileConstructionEnum::Value Ifc4::IfcPileConstructionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPileConstructionEnum::Value) Ifc4::IfcPileConstructionEnum::IfcPileConstructionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPileConstructionEnum::operator Ifc4::IfcPileConstructionEnum::Value() const {
    return (Ifc4::IfcPileConstructionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPileTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[657]); }
const IfcParse::enumeration_type& Ifc4::IfcPileTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[657]); }

Ifc4::IfcPileTypeEnum::IfcPileTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPileTypeEnum::IfcPileTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPileTypeEnum::IfcPileTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPileTypeEnum::ToString(Value v) {
    return Ifc4::IfcPileTypeEnum::IfcPileTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPileTypeEnum::Value Ifc4::IfcPileTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPileTypeEnum::Value) Ifc4::IfcPileTypeEnum::IfcPileTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPileTypeEnum::operator Ifc4::IfcPileTypeEnum::Value() const {
    return (Ifc4::IfcPileTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPipeFittingTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[660]); }
const IfcParse::enumeration_type& Ifc4::IfcPipeFittingTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[660]); }

Ifc4::IfcPipeFittingTypeEnum::IfcPipeFittingTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPipeFittingTypeEnum::IfcPipeFittingTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPipeFittingTypeEnum::IfcPipeFittingTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPipeFittingTypeEnum::ToString(Value v) {
    return Ifc4::IfcPipeFittingTypeEnum::IfcPipeFittingTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPipeFittingTypeEnum::Value Ifc4::IfcPipeFittingTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPipeFittingTypeEnum::Value) Ifc4::IfcPipeFittingTypeEnum::IfcPipeFittingTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPipeFittingTypeEnum::operator Ifc4::IfcPipeFittingTypeEnum::Value() const {
    return (Ifc4::IfcPipeFittingTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPipeSegmentTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[663]); }
const IfcParse::enumeration_type& Ifc4::IfcPipeSegmentTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[663]); }

Ifc4::IfcPipeSegmentTypeEnum::IfcPipeSegmentTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPipeSegmentTypeEnum::IfcPipeSegmentTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPipeSegmentTypeEnum::IfcPipeSegmentTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPipeSegmentTypeEnum::ToString(Value v) {
    return Ifc4::IfcPipeSegmentTypeEnum::IfcPipeSegmentTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPipeSegmentTypeEnum::Value Ifc4::IfcPipeSegmentTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPipeSegmentTypeEnum::Value) Ifc4::IfcPipeSegmentTypeEnum::IfcPipeSegmentTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPipeSegmentTypeEnum::operator Ifc4::IfcPipeSegmentTypeEnum::Value() const {
    return (Ifc4::IfcPipeSegmentTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPlateTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[674]); }
const IfcParse::enumeration_type& Ifc4::IfcPlateTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[674]); }

Ifc4::IfcPlateTypeEnum::IfcPlateTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPlateTypeEnum::IfcPlateTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPlateTypeEnum::IfcPlateTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPlateTypeEnum::ToString(Value v) {
    return Ifc4::IfcPlateTypeEnum::IfcPlateTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPlateTypeEnum::Value Ifc4::IfcPlateTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPlateTypeEnum::Value) Ifc4::IfcPlateTypeEnum::IfcPlateTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPlateTypeEnum::operator Ifc4::IfcPlateTypeEnum::Value() const {
    return (Ifc4::IfcPlateTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPreferredSurfaceCurveRepresentation::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[696]); }
const IfcParse::enumeration_type& Ifc4::IfcPreferredSurfaceCurveRepresentation::Class() { return *((IfcParse::enumeration_type*)IFC4_types[696]); }

Ifc4::IfcPreferredSurfaceCurveRepresentation::IfcPreferredSurfaceCurveRepresentation(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPreferredSurfaceCurveRepresentation::IfcPreferredSurfaceCurveRepresentation(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPreferredSurfaceCurveRepresentation::IfcPreferredSurfaceCurveRepresentation(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPreferredSurfaceCurveRepresentation::ToString(Value v) {
    return Ifc4::IfcPreferredSurfaceCurveRepresentation::IfcPreferredSurfaceCurveRepresentation::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPreferredSurfaceCurveRepresentation::Value Ifc4::IfcPreferredSurfaceCurveRepresentation::FromString(const std::string& s) {
    return (Ifc4::IfcPreferredSurfaceCurveRepresentation::Value) Ifc4::IfcPreferredSurfaceCurveRepresentation::IfcPreferredSurfaceCurveRepresentation::Class().lookup_enum_offset(s);
}

Ifc4::IfcPreferredSurfaceCurveRepresentation::operator Ifc4::IfcPreferredSurfaceCurveRepresentation::Value() const {
    return (Ifc4::IfcPreferredSurfaceCurveRepresentation::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcProcedureTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[707]); }
const IfcParse::enumeration_type& Ifc4::IfcProcedureTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[707]); }

Ifc4::IfcProcedureTypeEnum::IfcProcedureTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcProcedureTypeEnum::IfcProcedureTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcProcedureTypeEnum::IfcProcedureTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcProcedureTypeEnum::ToString(Value v) {
    return Ifc4::IfcProcedureTypeEnum::IfcProcedureTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcProcedureTypeEnum::Value Ifc4::IfcProcedureTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcProcedureTypeEnum::Value) Ifc4::IfcProcedureTypeEnum::IfcProcedureTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcProcedureTypeEnum::operator Ifc4::IfcProcedureTypeEnum::Value() const {
    return (Ifc4::IfcProcedureTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcProfileTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[717]); }
const IfcParse::enumeration_type& Ifc4::IfcProfileTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[717]); }

Ifc4::IfcProfileTypeEnum::IfcProfileTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcProfileTypeEnum::IfcProfileTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcProfileTypeEnum::IfcProfileTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcProfileTypeEnum::ToString(Value v) {
    return Ifc4::IfcProfileTypeEnum::IfcProfileTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcProfileTypeEnum::Value Ifc4::IfcProfileTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcProfileTypeEnum::Value) Ifc4::IfcProfileTypeEnum::IfcProfileTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcProfileTypeEnum::operator Ifc4::IfcProfileTypeEnum::Value() const {
    return (Ifc4::IfcProfileTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcProjectOrderTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[725]); }
const IfcParse::enumeration_type& Ifc4::IfcProjectOrderTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[725]); }

Ifc4::IfcProjectOrderTypeEnum::IfcProjectOrderTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcProjectOrderTypeEnum::IfcProjectOrderTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcProjectOrderTypeEnum::IfcProjectOrderTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcProjectOrderTypeEnum::ToString(Value v) {
    return Ifc4::IfcProjectOrderTypeEnum::IfcProjectOrderTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcProjectOrderTypeEnum::Value Ifc4::IfcProjectOrderTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcProjectOrderTypeEnum::Value) Ifc4::IfcProjectOrderTypeEnum::IfcProjectOrderTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcProjectOrderTypeEnum::operator Ifc4::IfcProjectOrderTypeEnum::Value() const {
    return (Ifc4::IfcProjectOrderTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcProjectedOrTrueLengthEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[720]); }
const IfcParse::enumeration_type& Ifc4::IfcProjectedOrTrueLengthEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[720]); }

Ifc4::IfcProjectedOrTrueLengthEnum::IfcProjectedOrTrueLengthEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcProjectedOrTrueLengthEnum::IfcProjectedOrTrueLengthEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcProjectedOrTrueLengthEnum::IfcProjectedOrTrueLengthEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcProjectedOrTrueLengthEnum::ToString(Value v) {
    return Ifc4::IfcProjectedOrTrueLengthEnum::IfcProjectedOrTrueLengthEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcProjectedOrTrueLengthEnum::Value Ifc4::IfcProjectedOrTrueLengthEnum::FromString(const std::string& s) {
    return (Ifc4::IfcProjectedOrTrueLengthEnum::Value) Ifc4::IfcProjectedOrTrueLengthEnum::IfcProjectedOrTrueLengthEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcProjectedOrTrueLengthEnum::operator Ifc4::IfcProjectedOrTrueLengthEnum::Value() const {
    return (Ifc4::IfcProjectedOrTrueLengthEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcProjectionElementTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[722]); }
const IfcParse::enumeration_type& Ifc4::IfcProjectionElementTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[722]); }

Ifc4::IfcProjectionElementTypeEnum::IfcProjectionElementTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcProjectionElementTypeEnum::IfcProjectionElementTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcProjectionElementTypeEnum::IfcProjectionElementTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcProjectionElementTypeEnum::ToString(Value v) {
    return Ifc4::IfcProjectionElementTypeEnum::IfcProjectionElementTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcProjectionElementTypeEnum::Value Ifc4::IfcProjectionElementTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcProjectionElementTypeEnum::Value) Ifc4::IfcProjectionElementTypeEnum::IfcProjectionElementTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcProjectionElementTypeEnum::operator Ifc4::IfcProjectionElementTypeEnum::Value() const {
    return (Ifc4::IfcProjectionElementTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPropertySetTemplateTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[740]); }
const IfcParse::enumeration_type& Ifc4::IfcPropertySetTemplateTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[740]); }

Ifc4::IfcPropertySetTemplateTypeEnum::IfcPropertySetTemplateTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPropertySetTemplateTypeEnum::IfcPropertySetTemplateTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPropertySetTemplateTypeEnum::IfcPropertySetTemplateTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPropertySetTemplateTypeEnum::ToString(Value v) {
    return Ifc4::IfcPropertySetTemplateTypeEnum::IfcPropertySetTemplateTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPropertySetTemplateTypeEnum::Value Ifc4::IfcPropertySetTemplateTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPropertySetTemplateTypeEnum::Value) Ifc4::IfcPropertySetTemplateTypeEnum::IfcPropertySetTemplateTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPropertySetTemplateTypeEnum::operator Ifc4::IfcPropertySetTemplateTypeEnum::Value() const {
    return (Ifc4::IfcPropertySetTemplateTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[748]); }
const IfcParse::enumeration_type& Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[748]); }

Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::IfcProtectiveDeviceTrippingUnitTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::IfcProtectiveDeviceTrippingUnitTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::IfcProtectiveDeviceTrippingUnitTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::ToString(Value v) {
    return Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::IfcProtectiveDeviceTrippingUnitTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value) Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::IfcProtectiveDeviceTrippingUnitTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::operator Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value() const {
    return (Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcProtectiveDeviceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[750]); }
const IfcParse::enumeration_type& Ifc4::IfcProtectiveDeviceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[750]); }

Ifc4::IfcProtectiveDeviceTypeEnum::IfcProtectiveDeviceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcProtectiveDeviceTypeEnum::IfcProtectiveDeviceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcProtectiveDeviceTypeEnum::IfcProtectiveDeviceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcProtectiveDeviceTypeEnum::ToString(Value v) {
    return Ifc4::IfcProtectiveDeviceTypeEnum::IfcProtectiveDeviceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcProtectiveDeviceTypeEnum::Value Ifc4::IfcProtectiveDeviceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcProtectiveDeviceTypeEnum::Value) Ifc4::IfcProtectiveDeviceTypeEnum::IfcProtectiveDeviceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcProtectiveDeviceTypeEnum::operator Ifc4::IfcProtectiveDeviceTypeEnum::Value() const {
    return (Ifc4::IfcProtectiveDeviceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcPumpTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[754]); }
const IfcParse::enumeration_type& Ifc4::IfcPumpTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[754]); }

Ifc4::IfcPumpTypeEnum::IfcPumpTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcPumpTypeEnum::IfcPumpTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcPumpTypeEnum::IfcPumpTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcPumpTypeEnum::ToString(Value v) {
    return Ifc4::IfcPumpTypeEnum::IfcPumpTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcPumpTypeEnum::Value Ifc4::IfcPumpTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcPumpTypeEnum::Value) Ifc4::IfcPumpTypeEnum::IfcPumpTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcPumpTypeEnum::operator Ifc4::IfcPumpTypeEnum::Value() const {
    return (Ifc4::IfcPumpTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcRailingTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[765]); }
const IfcParse::enumeration_type& Ifc4::IfcRailingTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[765]); }

Ifc4::IfcRailingTypeEnum::IfcRailingTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcRailingTypeEnum::IfcRailingTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcRailingTypeEnum::IfcRailingTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcRailingTypeEnum::ToString(Value v) {
    return Ifc4::IfcRailingTypeEnum::IfcRailingTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcRailingTypeEnum::Value Ifc4::IfcRailingTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcRailingTypeEnum::Value) Ifc4::IfcRailingTypeEnum::IfcRailingTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcRailingTypeEnum::operator Ifc4::IfcRailingTypeEnum::Value() const {
    return (Ifc4::IfcRailingTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcRampFlightTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[769]); }
const IfcParse::enumeration_type& Ifc4::IfcRampFlightTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[769]); }

Ifc4::IfcRampFlightTypeEnum::IfcRampFlightTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcRampFlightTypeEnum::IfcRampFlightTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcRampFlightTypeEnum::IfcRampFlightTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcRampFlightTypeEnum::ToString(Value v) {
    return Ifc4::IfcRampFlightTypeEnum::IfcRampFlightTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcRampFlightTypeEnum::Value Ifc4::IfcRampFlightTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcRampFlightTypeEnum::Value) Ifc4::IfcRampFlightTypeEnum::IfcRampFlightTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcRampFlightTypeEnum::operator Ifc4::IfcRampFlightTypeEnum::Value() const {
    return (Ifc4::IfcRampFlightTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcRampTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[771]); }
const IfcParse::enumeration_type& Ifc4::IfcRampTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[771]); }

Ifc4::IfcRampTypeEnum::IfcRampTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcRampTypeEnum::IfcRampTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcRampTypeEnum::IfcRampTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcRampTypeEnum::ToString(Value v) {
    return Ifc4::IfcRampTypeEnum::IfcRampTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcRampTypeEnum::Value Ifc4::IfcRampTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcRampTypeEnum::Value) Ifc4::IfcRampTypeEnum::IfcRampTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcRampTypeEnum::operator Ifc4::IfcRampTypeEnum::Value() const {
    return (Ifc4::IfcRampTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcRecurrenceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[781]); }
const IfcParse::enumeration_type& Ifc4::IfcRecurrenceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[781]); }

Ifc4::IfcRecurrenceTypeEnum::IfcRecurrenceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcRecurrenceTypeEnum::IfcRecurrenceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcRecurrenceTypeEnum::IfcRecurrenceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcRecurrenceTypeEnum::ToString(Value v) {
    return Ifc4::IfcRecurrenceTypeEnum::IfcRecurrenceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcRecurrenceTypeEnum::Value Ifc4::IfcRecurrenceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcRecurrenceTypeEnum::Value) Ifc4::IfcRecurrenceTypeEnum::IfcRecurrenceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcRecurrenceTypeEnum::operator Ifc4::IfcRecurrenceTypeEnum::Value() const {
    return (Ifc4::IfcRecurrenceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcReflectanceMethodEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[783]); }
const IfcParse::enumeration_type& Ifc4::IfcReflectanceMethodEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[783]); }

Ifc4::IfcReflectanceMethodEnum::IfcReflectanceMethodEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcReflectanceMethodEnum::IfcReflectanceMethodEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcReflectanceMethodEnum::IfcReflectanceMethodEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcReflectanceMethodEnum::ToString(Value v) {
    return Ifc4::IfcReflectanceMethodEnum::IfcReflectanceMethodEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcReflectanceMethodEnum::Value Ifc4::IfcReflectanceMethodEnum::FromString(const std::string& s) {
    return (Ifc4::IfcReflectanceMethodEnum::Value) Ifc4::IfcReflectanceMethodEnum::IfcReflectanceMethodEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcReflectanceMethodEnum::operator Ifc4::IfcReflectanceMethodEnum::Value() const {
    return (Ifc4::IfcReflectanceMethodEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcReinforcingBarRoleEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[788]); }
const IfcParse::enumeration_type& Ifc4::IfcReinforcingBarRoleEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[788]); }

Ifc4::IfcReinforcingBarRoleEnum::IfcReinforcingBarRoleEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcReinforcingBarRoleEnum::IfcReinforcingBarRoleEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcReinforcingBarRoleEnum::IfcReinforcingBarRoleEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcReinforcingBarRoleEnum::ToString(Value v) {
    return Ifc4::IfcReinforcingBarRoleEnum::IfcReinforcingBarRoleEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcReinforcingBarRoleEnum::Value Ifc4::IfcReinforcingBarRoleEnum::FromString(const std::string& s) {
    return (Ifc4::IfcReinforcingBarRoleEnum::Value) Ifc4::IfcReinforcingBarRoleEnum::IfcReinforcingBarRoleEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcReinforcingBarRoleEnum::operator Ifc4::IfcReinforcingBarRoleEnum::Value() const {
    return (Ifc4::IfcReinforcingBarRoleEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcReinforcingBarSurfaceEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[789]); }
const IfcParse::enumeration_type& Ifc4::IfcReinforcingBarSurfaceEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[789]); }

Ifc4::IfcReinforcingBarSurfaceEnum::IfcReinforcingBarSurfaceEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcReinforcingBarSurfaceEnum::IfcReinforcingBarSurfaceEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcReinforcingBarSurfaceEnum::IfcReinforcingBarSurfaceEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcReinforcingBarSurfaceEnum::ToString(Value v) {
    return Ifc4::IfcReinforcingBarSurfaceEnum::IfcReinforcingBarSurfaceEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcReinforcingBarSurfaceEnum::Value Ifc4::IfcReinforcingBarSurfaceEnum::FromString(const std::string& s) {
    return (Ifc4::IfcReinforcingBarSurfaceEnum::Value) Ifc4::IfcReinforcingBarSurfaceEnum::IfcReinforcingBarSurfaceEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcReinforcingBarSurfaceEnum::operator Ifc4::IfcReinforcingBarSurfaceEnum::Value() const {
    return (Ifc4::IfcReinforcingBarSurfaceEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcReinforcingBarTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[791]); }
const IfcParse::enumeration_type& Ifc4::IfcReinforcingBarTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[791]); }

Ifc4::IfcReinforcingBarTypeEnum::IfcReinforcingBarTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcReinforcingBarTypeEnum::IfcReinforcingBarTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcReinforcingBarTypeEnum::IfcReinforcingBarTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcReinforcingBarTypeEnum::ToString(Value v) {
    return Ifc4::IfcReinforcingBarTypeEnum::IfcReinforcingBarTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcReinforcingBarTypeEnum::Value Ifc4::IfcReinforcingBarTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcReinforcingBarTypeEnum::Value) Ifc4::IfcReinforcingBarTypeEnum::IfcReinforcingBarTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcReinforcingBarTypeEnum::operator Ifc4::IfcReinforcingBarTypeEnum::Value() const {
    return (Ifc4::IfcReinforcingBarTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcReinforcingMeshTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[796]); }
const IfcParse::enumeration_type& Ifc4::IfcReinforcingMeshTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[796]); }

Ifc4::IfcReinforcingMeshTypeEnum::IfcReinforcingMeshTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcReinforcingMeshTypeEnum::IfcReinforcingMeshTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcReinforcingMeshTypeEnum::IfcReinforcingMeshTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcReinforcingMeshTypeEnum::ToString(Value v) {
    return Ifc4::IfcReinforcingMeshTypeEnum::IfcReinforcingMeshTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcReinforcingMeshTypeEnum::Value Ifc4::IfcReinforcingMeshTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcReinforcingMeshTypeEnum::Value) Ifc4::IfcReinforcingMeshTypeEnum::IfcReinforcingMeshTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcReinforcingMeshTypeEnum::operator Ifc4::IfcReinforcingMeshTypeEnum::Value() const {
    return (Ifc4::IfcReinforcingMeshTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcRoleEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[861]); }
const IfcParse::enumeration_type& Ifc4::IfcRoleEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[861]); }

Ifc4::IfcRoleEnum::IfcRoleEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcRoleEnum::IfcRoleEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcRoleEnum::IfcRoleEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcRoleEnum::ToString(Value v) {
    return Ifc4::IfcRoleEnum::IfcRoleEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcRoleEnum::Value Ifc4::IfcRoleEnum::FromString(const std::string& s) {
    return (Ifc4::IfcRoleEnum::Value) Ifc4::IfcRoleEnum::IfcRoleEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcRoleEnum::operator Ifc4::IfcRoleEnum::Value() const {
    return (Ifc4::IfcRoleEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcRoofTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[864]); }
const IfcParse::enumeration_type& Ifc4::IfcRoofTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[864]); }

Ifc4::IfcRoofTypeEnum::IfcRoofTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcRoofTypeEnum::IfcRoofTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcRoofTypeEnum::IfcRoofTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcRoofTypeEnum::ToString(Value v) {
    return Ifc4::IfcRoofTypeEnum::IfcRoofTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcRoofTypeEnum::Value Ifc4::IfcRoofTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcRoofTypeEnum::Value) Ifc4::IfcRoofTypeEnum::IfcRoofTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcRoofTypeEnum::operator Ifc4::IfcRoofTypeEnum::Value() const {
    return (Ifc4::IfcRoofTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSIPrefix::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[900]); }
const IfcParse::enumeration_type& Ifc4::IfcSIPrefix::Class() { return *((IfcParse::enumeration_type*)IFC4_types[900]); }

Ifc4::IfcSIPrefix::IfcSIPrefix(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSIPrefix::IfcSIPrefix(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSIPrefix::IfcSIPrefix(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSIPrefix::ToString(Value v) {
    return Ifc4::IfcSIPrefix::IfcSIPrefix::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSIPrefix::Value Ifc4::IfcSIPrefix::FromString(const std::string& s) {
    return (Ifc4::IfcSIPrefix::Value) Ifc4::IfcSIPrefix::IfcSIPrefix::Class().lookup_enum_offset(s);
}

Ifc4::IfcSIPrefix::operator Ifc4::IfcSIPrefix::Value() const {
    return (Ifc4::IfcSIPrefix::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSIUnitName::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[903]); }
const IfcParse::enumeration_type& Ifc4::IfcSIUnitName::Class() { return *((IfcParse::enumeration_type*)IFC4_types[903]); }

Ifc4::IfcSIUnitName::IfcSIUnitName(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSIUnitName::IfcSIUnitName(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSIUnitName::IfcSIUnitName(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSIUnitName::ToString(Value v) {
    return Ifc4::IfcSIUnitName::IfcSIUnitName::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSIUnitName::Value Ifc4::IfcSIUnitName::FromString(const std::string& s) {
    return (Ifc4::IfcSIUnitName::Value) Ifc4::IfcSIUnitName::IfcSIUnitName::Class().lookup_enum_offset(s);
}

Ifc4::IfcSIUnitName::operator Ifc4::IfcSIUnitName::Value() const {
    return (Ifc4::IfcSIUnitName::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSanitaryTerminalTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[873]); }
const IfcParse::enumeration_type& Ifc4::IfcSanitaryTerminalTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[873]); }

Ifc4::IfcSanitaryTerminalTypeEnum::IfcSanitaryTerminalTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSanitaryTerminalTypeEnum::IfcSanitaryTerminalTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSanitaryTerminalTypeEnum::IfcSanitaryTerminalTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSanitaryTerminalTypeEnum::ToString(Value v) {
    return Ifc4::IfcSanitaryTerminalTypeEnum::IfcSanitaryTerminalTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSanitaryTerminalTypeEnum::Value Ifc4::IfcSanitaryTerminalTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSanitaryTerminalTypeEnum::Value) Ifc4::IfcSanitaryTerminalTypeEnum::IfcSanitaryTerminalTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSanitaryTerminalTypeEnum::operator Ifc4::IfcSanitaryTerminalTypeEnum::Value() const {
    return (Ifc4::IfcSanitaryTerminalTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSectionTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[881]); }
const IfcParse::enumeration_type& Ifc4::IfcSectionTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[881]); }

Ifc4::IfcSectionTypeEnum::IfcSectionTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSectionTypeEnum::IfcSectionTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSectionTypeEnum::IfcSectionTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSectionTypeEnum::ToString(Value v) {
    return Ifc4::IfcSectionTypeEnum::IfcSectionTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSectionTypeEnum::Value Ifc4::IfcSectionTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSectionTypeEnum::Value) Ifc4::IfcSectionTypeEnum::IfcSectionTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSectionTypeEnum::operator Ifc4::IfcSectionTypeEnum::Value() const {
    return (Ifc4::IfcSectionTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSensorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[885]); }
const IfcParse::enumeration_type& Ifc4::IfcSensorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[885]); }

Ifc4::IfcSensorTypeEnum::IfcSensorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSensorTypeEnum::IfcSensorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSensorTypeEnum::IfcSensorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSensorTypeEnum::ToString(Value v) {
    return Ifc4::IfcSensorTypeEnum::IfcSensorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSensorTypeEnum::Value Ifc4::IfcSensorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSensorTypeEnum::Value) Ifc4::IfcSensorTypeEnum::IfcSensorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSensorTypeEnum::operator Ifc4::IfcSensorTypeEnum::Value() const {
    return (Ifc4::IfcSensorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSequenceEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[886]); }
const IfcParse::enumeration_type& Ifc4::IfcSequenceEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[886]); }

Ifc4::IfcSequenceEnum::IfcSequenceEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSequenceEnum::IfcSequenceEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSequenceEnum::IfcSequenceEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSequenceEnum::ToString(Value v) {
    return Ifc4::IfcSequenceEnum::IfcSequenceEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSequenceEnum::Value Ifc4::IfcSequenceEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSequenceEnum::Value) Ifc4::IfcSequenceEnum::IfcSequenceEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSequenceEnum::operator Ifc4::IfcSequenceEnum::Value() const {
    return (Ifc4::IfcSequenceEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcShadingDeviceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[889]); }
const IfcParse::enumeration_type& Ifc4::IfcShadingDeviceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[889]); }

Ifc4::IfcShadingDeviceTypeEnum::IfcShadingDeviceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcShadingDeviceTypeEnum::IfcShadingDeviceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcShadingDeviceTypeEnum::IfcShadingDeviceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcShadingDeviceTypeEnum::ToString(Value v) {
    return Ifc4::IfcShadingDeviceTypeEnum::IfcShadingDeviceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcShadingDeviceTypeEnum::Value Ifc4::IfcShadingDeviceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcShadingDeviceTypeEnum::Value) Ifc4::IfcShadingDeviceTypeEnum::IfcShadingDeviceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcShadingDeviceTypeEnum::operator Ifc4::IfcShadingDeviceTypeEnum::Value() const {
    return (Ifc4::IfcShadingDeviceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSimplePropertyTemplateTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[898]); }
const IfcParse::enumeration_type& Ifc4::IfcSimplePropertyTemplateTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[898]); }

Ifc4::IfcSimplePropertyTemplateTypeEnum::IfcSimplePropertyTemplateTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSimplePropertyTemplateTypeEnum::IfcSimplePropertyTemplateTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSimplePropertyTemplateTypeEnum::IfcSimplePropertyTemplateTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSimplePropertyTemplateTypeEnum::ToString(Value v) {
    return Ifc4::IfcSimplePropertyTemplateTypeEnum::IfcSimplePropertyTemplateTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSimplePropertyTemplateTypeEnum::Value Ifc4::IfcSimplePropertyTemplateTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSimplePropertyTemplateTypeEnum::Value) Ifc4::IfcSimplePropertyTemplateTypeEnum::IfcSimplePropertyTemplateTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSimplePropertyTemplateTypeEnum::operator Ifc4::IfcSimplePropertyTemplateTypeEnum::Value() const {
    return (Ifc4::IfcSimplePropertyTemplateTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSlabTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[909]); }
const IfcParse::enumeration_type& Ifc4::IfcSlabTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[909]); }

Ifc4::IfcSlabTypeEnum::IfcSlabTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSlabTypeEnum::IfcSlabTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSlabTypeEnum::IfcSlabTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSlabTypeEnum::ToString(Value v) {
    return Ifc4::IfcSlabTypeEnum::IfcSlabTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSlabTypeEnum::Value Ifc4::IfcSlabTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSlabTypeEnum::Value) Ifc4::IfcSlabTypeEnum::IfcSlabTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSlabTypeEnum::operator Ifc4::IfcSlabTypeEnum::Value() const {
    return (Ifc4::IfcSlabTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSolarDeviceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[913]); }
const IfcParse::enumeration_type& Ifc4::IfcSolarDeviceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[913]); }

Ifc4::IfcSolarDeviceTypeEnum::IfcSolarDeviceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSolarDeviceTypeEnum::IfcSolarDeviceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSolarDeviceTypeEnum::IfcSolarDeviceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSolarDeviceTypeEnum::ToString(Value v) {
    return Ifc4::IfcSolarDeviceTypeEnum::IfcSolarDeviceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSolarDeviceTypeEnum::Value Ifc4::IfcSolarDeviceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSolarDeviceTypeEnum::Value) Ifc4::IfcSolarDeviceTypeEnum::IfcSolarDeviceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSolarDeviceTypeEnum::operator Ifc4::IfcSolarDeviceTypeEnum::Value() const {
    return (Ifc4::IfcSolarDeviceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSpaceHeaterTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[925]); }
const IfcParse::enumeration_type& Ifc4::IfcSpaceHeaterTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[925]); }

Ifc4::IfcSpaceHeaterTypeEnum::IfcSpaceHeaterTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSpaceHeaterTypeEnum::IfcSpaceHeaterTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSpaceHeaterTypeEnum::IfcSpaceHeaterTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSpaceHeaterTypeEnum::ToString(Value v) {
    return Ifc4::IfcSpaceHeaterTypeEnum::IfcSpaceHeaterTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSpaceHeaterTypeEnum::Value Ifc4::IfcSpaceHeaterTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSpaceHeaterTypeEnum::Value) Ifc4::IfcSpaceHeaterTypeEnum::IfcSpaceHeaterTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSpaceHeaterTypeEnum::operator Ifc4::IfcSpaceHeaterTypeEnum::Value() const {
    return (Ifc4::IfcSpaceHeaterTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSpaceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[927]); }
const IfcParse::enumeration_type& Ifc4::IfcSpaceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[927]); }

Ifc4::IfcSpaceTypeEnum::IfcSpaceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSpaceTypeEnum::IfcSpaceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSpaceTypeEnum::IfcSpaceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSpaceTypeEnum::ToString(Value v) {
    return Ifc4::IfcSpaceTypeEnum::IfcSpaceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSpaceTypeEnum::Value Ifc4::IfcSpaceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSpaceTypeEnum::Value) Ifc4::IfcSpaceTypeEnum::IfcSpaceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSpaceTypeEnum::operator Ifc4::IfcSpaceTypeEnum::Value() const {
    return (Ifc4::IfcSpaceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSpatialZoneTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[934]); }
const IfcParse::enumeration_type& Ifc4::IfcSpatialZoneTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[934]); }

Ifc4::IfcSpatialZoneTypeEnum::IfcSpatialZoneTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSpatialZoneTypeEnum::IfcSpatialZoneTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSpatialZoneTypeEnum::IfcSpatialZoneTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSpatialZoneTypeEnum::ToString(Value v) {
    return Ifc4::IfcSpatialZoneTypeEnum::IfcSpatialZoneTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSpatialZoneTypeEnum::Value Ifc4::IfcSpatialZoneTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSpatialZoneTypeEnum::Value) Ifc4::IfcSpatialZoneTypeEnum::IfcSpatialZoneTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSpatialZoneTypeEnum::operator Ifc4::IfcSpatialZoneTypeEnum::Value() const {
    return (Ifc4::IfcSpatialZoneTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcStackTerminalTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[943]); }
const IfcParse::enumeration_type& Ifc4::IfcStackTerminalTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[943]); }

Ifc4::IfcStackTerminalTypeEnum::IfcStackTerminalTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcStackTerminalTypeEnum::IfcStackTerminalTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcStackTerminalTypeEnum::IfcStackTerminalTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcStackTerminalTypeEnum::ToString(Value v) {
    return Ifc4::IfcStackTerminalTypeEnum::IfcStackTerminalTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcStackTerminalTypeEnum::Value Ifc4::IfcStackTerminalTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcStackTerminalTypeEnum::Value) Ifc4::IfcStackTerminalTypeEnum::IfcStackTerminalTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcStackTerminalTypeEnum::operator Ifc4::IfcStackTerminalTypeEnum::Value() const {
    return (Ifc4::IfcStackTerminalTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcStairFlightTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[947]); }
const IfcParse::enumeration_type& Ifc4::IfcStairFlightTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[947]); }

Ifc4::IfcStairFlightTypeEnum::IfcStairFlightTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcStairFlightTypeEnum::IfcStairFlightTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcStairFlightTypeEnum::IfcStairFlightTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcStairFlightTypeEnum::ToString(Value v) {
    return Ifc4::IfcStairFlightTypeEnum::IfcStairFlightTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcStairFlightTypeEnum::Value Ifc4::IfcStairFlightTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcStairFlightTypeEnum::Value) Ifc4::IfcStairFlightTypeEnum::IfcStairFlightTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcStairFlightTypeEnum::operator Ifc4::IfcStairFlightTypeEnum::Value() const {
    return (Ifc4::IfcStairFlightTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcStairTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[949]); }
const IfcParse::enumeration_type& Ifc4::IfcStairTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[949]); }

Ifc4::IfcStairTypeEnum::IfcStairTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcStairTypeEnum::IfcStairTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcStairTypeEnum::IfcStairTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcStairTypeEnum::ToString(Value v) {
    return Ifc4::IfcStairTypeEnum::IfcStairTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcStairTypeEnum::Value Ifc4::IfcStairTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcStairTypeEnum::Value) Ifc4::IfcStairTypeEnum::IfcStairTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcStairTypeEnum::operator Ifc4::IfcStairTypeEnum::Value() const {
    return (Ifc4::IfcStairTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcStateEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[950]); }
const IfcParse::enumeration_type& Ifc4::IfcStateEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[950]); }

Ifc4::IfcStateEnum::IfcStateEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcStateEnum::IfcStateEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcStateEnum::IfcStateEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcStateEnum::ToString(Value v) {
    return Ifc4::IfcStateEnum::IfcStateEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcStateEnum::Value Ifc4::IfcStateEnum::FromString(const std::string& s) {
    return (Ifc4::IfcStateEnum::Value) Ifc4::IfcStateEnum::IfcStateEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcStateEnum::operator Ifc4::IfcStateEnum::Value() const {
    return (Ifc4::IfcStateEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcStructuralCurveActivityTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[958]); }
const IfcParse::enumeration_type& Ifc4::IfcStructuralCurveActivityTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[958]); }

Ifc4::IfcStructuralCurveActivityTypeEnum::IfcStructuralCurveActivityTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcStructuralCurveActivityTypeEnum::IfcStructuralCurveActivityTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcStructuralCurveActivityTypeEnum::IfcStructuralCurveActivityTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcStructuralCurveActivityTypeEnum::ToString(Value v) {
    return Ifc4::IfcStructuralCurveActivityTypeEnum::IfcStructuralCurveActivityTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcStructuralCurveActivityTypeEnum::Value Ifc4::IfcStructuralCurveActivityTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcStructuralCurveActivityTypeEnum::Value) Ifc4::IfcStructuralCurveActivityTypeEnum::IfcStructuralCurveActivityTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcStructuralCurveActivityTypeEnum::operator Ifc4::IfcStructuralCurveActivityTypeEnum::Value() const {
    return (Ifc4::IfcStructuralCurveActivityTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcStructuralCurveMemberTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[961]); }
const IfcParse::enumeration_type& Ifc4::IfcStructuralCurveMemberTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[961]); }

Ifc4::IfcStructuralCurveMemberTypeEnum::IfcStructuralCurveMemberTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcStructuralCurveMemberTypeEnum::IfcStructuralCurveMemberTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcStructuralCurveMemberTypeEnum::IfcStructuralCurveMemberTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcStructuralCurveMemberTypeEnum::ToString(Value v) {
    return Ifc4::IfcStructuralCurveMemberTypeEnum::IfcStructuralCurveMemberTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcStructuralCurveMemberTypeEnum::Value Ifc4::IfcStructuralCurveMemberTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcStructuralCurveMemberTypeEnum::Value) Ifc4::IfcStructuralCurveMemberTypeEnum::IfcStructuralCurveMemberTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcStructuralCurveMemberTypeEnum::operator Ifc4::IfcStructuralCurveMemberTypeEnum::Value() const {
    return (Ifc4::IfcStructuralCurveMemberTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcStructuralSurfaceActivityTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[987]); }
const IfcParse::enumeration_type& Ifc4::IfcStructuralSurfaceActivityTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[987]); }

Ifc4::IfcStructuralSurfaceActivityTypeEnum::IfcStructuralSurfaceActivityTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcStructuralSurfaceActivityTypeEnum::IfcStructuralSurfaceActivityTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcStructuralSurfaceActivityTypeEnum::IfcStructuralSurfaceActivityTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcStructuralSurfaceActivityTypeEnum::ToString(Value v) {
    return Ifc4::IfcStructuralSurfaceActivityTypeEnum::IfcStructuralSurfaceActivityTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value Ifc4::IfcStructuralSurfaceActivityTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value) Ifc4::IfcStructuralSurfaceActivityTypeEnum::IfcStructuralSurfaceActivityTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcStructuralSurfaceActivityTypeEnum::operator Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value() const {
    return (Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcStructuralSurfaceMemberTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[990]); }
const IfcParse::enumeration_type& Ifc4::IfcStructuralSurfaceMemberTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[990]); }

Ifc4::IfcStructuralSurfaceMemberTypeEnum::IfcStructuralSurfaceMemberTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcStructuralSurfaceMemberTypeEnum::IfcStructuralSurfaceMemberTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcStructuralSurfaceMemberTypeEnum::IfcStructuralSurfaceMemberTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcStructuralSurfaceMemberTypeEnum::ToString(Value v) {
    return Ifc4::IfcStructuralSurfaceMemberTypeEnum::IfcStructuralSurfaceMemberTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcStructuralSurfaceMemberTypeEnum::Value Ifc4::IfcStructuralSurfaceMemberTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcStructuralSurfaceMemberTypeEnum::Value) Ifc4::IfcStructuralSurfaceMemberTypeEnum::IfcStructuralSurfaceMemberTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcStructuralSurfaceMemberTypeEnum::operator Ifc4::IfcStructuralSurfaceMemberTypeEnum::Value() const {
    return (Ifc4::IfcStructuralSurfaceMemberTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSubContractResourceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[999]); }
const IfcParse::enumeration_type& Ifc4::IfcSubContractResourceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[999]); }

Ifc4::IfcSubContractResourceTypeEnum::IfcSubContractResourceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSubContractResourceTypeEnum::IfcSubContractResourceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSubContractResourceTypeEnum::IfcSubContractResourceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSubContractResourceTypeEnum::ToString(Value v) {
    return Ifc4::IfcSubContractResourceTypeEnum::IfcSubContractResourceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSubContractResourceTypeEnum::Value Ifc4::IfcSubContractResourceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSubContractResourceTypeEnum::Value) Ifc4::IfcSubContractResourceTypeEnum::IfcSubContractResourceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSubContractResourceTypeEnum::operator Ifc4::IfcSubContractResourceTypeEnum::Value() const {
    return (Ifc4::IfcSubContractResourceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSurfaceFeatureTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1005]); }
const IfcParse::enumeration_type& Ifc4::IfcSurfaceFeatureTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1005]); }

Ifc4::IfcSurfaceFeatureTypeEnum::IfcSurfaceFeatureTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSurfaceFeatureTypeEnum::IfcSurfaceFeatureTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSurfaceFeatureTypeEnum::IfcSurfaceFeatureTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSurfaceFeatureTypeEnum::ToString(Value v) {
    return Ifc4::IfcSurfaceFeatureTypeEnum::IfcSurfaceFeatureTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSurfaceFeatureTypeEnum::Value Ifc4::IfcSurfaceFeatureTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSurfaceFeatureTypeEnum::Value) Ifc4::IfcSurfaceFeatureTypeEnum::IfcSurfaceFeatureTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSurfaceFeatureTypeEnum::operator Ifc4::IfcSurfaceFeatureTypeEnum::Value() const {
    return (Ifc4::IfcSurfaceFeatureTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSurfaceSide::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1010]); }
const IfcParse::enumeration_type& Ifc4::IfcSurfaceSide::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1010]); }

Ifc4::IfcSurfaceSide::IfcSurfaceSide(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSurfaceSide::IfcSurfaceSide(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSurfaceSide::IfcSurfaceSide(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSurfaceSide::ToString(Value v) {
    return Ifc4::IfcSurfaceSide::IfcSurfaceSide::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSurfaceSide::Value Ifc4::IfcSurfaceSide::FromString(const std::string& s) {
    return (Ifc4::IfcSurfaceSide::Value) Ifc4::IfcSurfaceSide::IfcSurfaceSide::Class().lookup_enum_offset(s);
}

Ifc4::IfcSurfaceSide::operator Ifc4::IfcSurfaceSide::Value() const {
    return (Ifc4::IfcSurfaceSide::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSwitchingDeviceTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1025]); }
const IfcParse::enumeration_type& Ifc4::IfcSwitchingDeviceTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1025]); }

Ifc4::IfcSwitchingDeviceTypeEnum::IfcSwitchingDeviceTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSwitchingDeviceTypeEnum::IfcSwitchingDeviceTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSwitchingDeviceTypeEnum::IfcSwitchingDeviceTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSwitchingDeviceTypeEnum::ToString(Value v) {
    return Ifc4::IfcSwitchingDeviceTypeEnum::IfcSwitchingDeviceTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSwitchingDeviceTypeEnum::Value Ifc4::IfcSwitchingDeviceTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSwitchingDeviceTypeEnum::Value) Ifc4::IfcSwitchingDeviceTypeEnum::IfcSwitchingDeviceTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSwitchingDeviceTypeEnum::operator Ifc4::IfcSwitchingDeviceTypeEnum::Value() const {
    return (Ifc4::IfcSwitchingDeviceTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcSystemFurnitureElementTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1029]); }
const IfcParse::enumeration_type& Ifc4::IfcSystemFurnitureElementTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1029]); }

Ifc4::IfcSystemFurnitureElementTypeEnum::IfcSystemFurnitureElementTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcSystemFurnitureElementTypeEnum::IfcSystemFurnitureElementTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcSystemFurnitureElementTypeEnum::IfcSystemFurnitureElementTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcSystemFurnitureElementTypeEnum::ToString(Value v) {
    return Ifc4::IfcSystemFurnitureElementTypeEnum::IfcSystemFurnitureElementTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcSystemFurnitureElementTypeEnum::Value Ifc4::IfcSystemFurnitureElementTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcSystemFurnitureElementTypeEnum::Value) Ifc4::IfcSystemFurnitureElementTypeEnum::IfcSystemFurnitureElementTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcSystemFurnitureElementTypeEnum::operator Ifc4::IfcSystemFurnitureElementTypeEnum::Value() const {
    return (Ifc4::IfcSystemFurnitureElementTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTankTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1035]); }
const IfcParse::enumeration_type& Ifc4::IfcTankTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1035]); }

Ifc4::IfcTankTypeEnum::IfcTankTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTankTypeEnum::IfcTankTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTankTypeEnum::IfcTankTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTankTypeEnum::ToString(Value v) {
    return Ifc4::IfcTankTypeEnum::IfcTankTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTankTypeEnum::Value Ifc4::IfcTankTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTankTypeEnum::Value) Ifc4::IfcTankTypeEnum::IfcTankTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTankTypeEnum::operator Ifc4::IfcTankTypeEnum::Value() const {
    return (Ifc4::IfcTankTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTaskDurationEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1037]); }
const IfcParse::enumeration_type& Ifc4::IfcTaskDurationEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1037]); }

Ifc4::IfcTaskDurationEnum::IfcTaskDurationEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTaskDurationEnum::IfcTaskDurationEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTaskDurationEnum::IfcTaskDurationEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTaskDurationEnum::ToString(Value v) {
    return Ifc4::IfcTaskDurationEnum::IfcTaskDurationEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTaskDurationEnum::Value Ifc4::IfcTaskDurationEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTaskDurationEnum::Value) Ifc4::IfcTaskDurationEnum::IfcTaskDurationEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTaskDurationEnum::operator Ifc4::IfcTaskDurationEnum::Value() const {
    return (Ifc4::IfcTaskDurationEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTaskTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1041]); }
const IfcParse::enumeration_type& Ifc4::IfcTaskTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1041]); }

Ifc4::IfcTaskTypeEnum::IfcTaskTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTaskTypeEnum::IfcTaskTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTaskTypeEnum::IfcTaskTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTaskTypeEnum::ToString(Value v) {
    return Ifc4::IfcTaskTypeEnum::IfcTaskTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTaskTypeEnum::Value Ifc4::IfcTaskTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTaskTypeEnum::Value) Ifc4::IfcTaskTypeEnum::IfcTaskTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTaskTypeEnum::operator Ifc4::IfcTaskTypeEnum::Value() const {
    return (Ifc4::IfcTaskTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTendonAnchorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1048]); }
const IfcParse::enumeration_type& Ifc4::IfcTendonAnchorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1048]); }

Ifc4::IfcTendonAnchorTypeEnum::IfcTendonAnchorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTendonAnchorTypeEnum::IfcTendonAnchorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTendonAnchorTypeEnum::IfcTendonAnchorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTendonAnchorTypeEnum::ToString(Value v) {
    return Ifc4::IfcTendonAnchorTypeEnum::IfcTendonAnchorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTendonAnchorTypeEnum::Value Ifc4::IfcTendonAnchorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTendonAnchorTypeEnum::Value) Ifc4::IfcTendonAnchorTypeEnum::IfcTendonAnchorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTendonAnchorTypeEnum::operator Ifc4::IfcTendonAnchorTypeEnum::Value() const {
    return (Ifc4::IfcTendonAnchorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTendonTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1050]); }
const IfcParse::enumeration_type& Ifc4::IfcTendonTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1050]); }

Ifc4::IfcTendonTypeEnum::IfcTendonTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTendonTypeEnum::IfcTendonTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTendonTypeEnum::IfcTendonTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTendonTypeEnum::ToString(Value v) {
    return Ifc4::IfcTendonTypeEnum::IfcTendonTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTendonTypeEnum::Value Ifc4::IfcTendonTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTendonTypeEnum::Value) Ifc4::IfcTendonTypeEnum::IfcTendonTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTendonTypeEnum::operator Ifc4::IfcTendonTypeEnum::Value() const {
    return (Ifc4::IfcTendonTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTextPath::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1060]); }
const IfcParse::enumeration_type& Ifc4::IfcTextPath::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1060]); }

Ifc4::IfcTextPath::IfcTextPath(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTextPath::IfcTextPath(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTextPath::IfcTextPath(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTextPath::ToString(Value v) {
    return Ifc4::IfcTextPath::IfcTextPath::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTextPath::Value Ifc4::IfcTextPath::FromString(const std::string& s) {
    return (Ifc4::IfcTextPath::Value) Ifc4::IfcTextPath::IfcTextPath::Class().lookup_enum_offset(s);
}

Ifc4::IfcTextPath::operator Ifc4::IfcTextPath::Value() const {
    return (Ifc4::IfcTextPath::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTimeSeriesDataTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1082]); }
const IfcParse::enumeration_type& Ifc4::IfcTimeSeriesDataTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1082]); }

Ifc4::IfcTimeSeriesDataTypeEnum::IfcTimeSeriesDataTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTimeSeriesDataTypeEnum::IfcTimeSeriesDataTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTimeSeriesDataTypeEnum::IfcTimeSeriesDataTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTimeSeriesDataTypeEnum::ToString(Value v) {
    return Ifc4::IfcTimeSeriesDataTypeEnum::IfcTimeSeriesDataTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTimeSeriesDataTypeEnum::Value Ifc4::IfcTimeSeriesDataTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTimeSeriesDataTypeEnum::Value) Ifc4::IfcTimeSeriesDataTypeEnum::IfcTimeSeriesDataTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTimeSeriesDataTypeEnum::operator Ifc4::IfcTimeSeriesDataTypeEnum::Value() const {
    return (Ifc4::IfcTimeSeriesDataTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTransformerTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1091]); }
const IfcParse::enumeration_type& Ifc4::IfcTransformerTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1091]); }

Ifc4::IfcTransformerTypeEnum::IfcTransformerTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTransformerTypeEnum::IfcTransformerTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTransformerTypeEnum::IfcTransformerTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTransformerTypeEnum::ToString(Value v) {
    return Ifc4::IfcTransformerTypeEnum::IfcTransformerTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTransformerTypeEnum::Value Ifc4::IfcTransformerTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTransformerTypeEnum::Value) Ifc4::IfcTransformerTypeEnum::IfcTransformerTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTransformerTypeEnum::operator Ifc4::IfcTransformerTypeEnum::Value() const {
    return (Ifc4::IfcTransformerTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTransitionCode::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1092]); }
const IfcParse::enumeration_type& Ifc4::IfcTransitionCode::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1092]); }

Ifc4::IfcTransitionCode::IfcTransitionCode(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTransitionCode::IfcTransitionCode(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTransitionCode::IfcTransitionCode(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTransitionCode::ToString(Value v) {
    return Ifc4::IfcTransitionCode::IfcTransitionCode::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTransitionCode::Value Ifc4::IfcTransitionCode::FromString(const std::string& s) {
    return (Ifc4::IfcTransitionCode::Value) Ifc4::IfcTransitionCode::IfcTransitionCode::Class().lookup_enum_offset(s);
}

Ifc4::IfcTransitionCode::operator Ifc4::IfcTransitionCode::Value() const {
    return (Ifc4::IfcTransitionCode::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTransportElementTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1096]); }
const IfcParse::enumeration_type& Ifc4::IfcTransportElementTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1096]); }

Ifc4::IfcTransportElementTypeEnum::IfcTransportElementTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTransportElementTypeEnum::IfcTransportElementTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTransportElementTypeEnum::IfcTransportElementTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTransportElementTypeEnum::ToString(Value v) {
    return Ifc4::IfcTransportElementTypeEnum::IfcTransportElementTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTransportElementTypeEnum::Value Ifc4::IfcTransportElementTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTransportElementTypeEnum::Value) Ifc4::IfcTransportElementTypeEnum::IfcTransportElementTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTransportElementTypeEnum::operator Ifc4::IfcTransportElementTypeEnum::Value() const {
    return (Ifc4::IfcTransportElementTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTrimmingPreference::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1100]); }
const IfcParse::enumeration_type& Ifc4::IfcTrimmingPreference::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1100]); }

Ifc4::IfcTrimmingPreference::IfcTrimmingPreference(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTrimmingPreference::IfcTrimmingPreference(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTrimmingPreference::IfcTrimmingPreference(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTrimmingPreference::ToString(Value v) {
    return Ifc4::IfcTrimmingPreference::IfcTrimmingPreference::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTrimmingPreference::Value Ifc4::IfcTrimmingPreference::FromString(const std::string& s) {
    return (Ifc4::IfcTrimmingPreference::Value) Ifc4::IfcTrimmingPreference::IfcTrimmingPreference::Class().lookup_enum_offset(s);
}

Ifc4::IfcTrimmingPreference::operator Ifc4::IfcTrimmingPreference::Value() const {
    return (Ifc4::IfcTrimmingPreference::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcTubeBundleTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1105]); }
const IfcParse::enumeration_type& Ifc4::IfcTubeBundleTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1105]); }

Ifc4::IfcTubeBundleTypeEnum::IfcTubeBundleTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcTubeBundleTypeEnum::IfcTubeBundleTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcTubeBundleTypeEnum::IfcTubeBundleTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcTubeBundleTypeEnum::ToString(Value v) {
    return Ifc4::IfcTubeBundleTypeEnum::IfcTubeBundleTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcTubeBundleTypeEnum::Value Ifc4::IfcTubeBundleTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcTubeBundleTypeEnum::Value) Ifc4::IfcTubeBundleTypeEnum::IfcTubeBundleTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcTubeBundleTypeEnum::operator Ifc4::IfcTubeBundleTypeEnum::Value() const {
    return (Ifc4::IfcTubeBundleTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcUnitEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1118]); }
const IfcParse::enumeration_type& Ifc4::IfcUnitEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1118]); }

Ifc4::IfcUnitEnum::IfcUnitEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcUnitEnum::IfcUnitEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcUnitEnum::IfcUnitEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcUnitEnum::ToString(Value v) {
    return Ifc4::IfcUnitEnum::IfcUnitEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcUnitEnum::Value Ifc4::IfcUnitEnum::FromString(const std::string& s) {
    return (Ifc4::IfcUnitEnum::Value) Ifc4::IfcUnitEnum::IfcUnitEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcUnitEnum::operator Ifc4::IfcUnitEnum::Value() const {
    return (Ifc4::IfcUnitEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcUnitaryControlElementTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1113]); }
const IfcParse::enumeration_type& Ifc4::IfcUnitaryControlElementTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1113]); }

Ifc4::IfcUnitaryControlElementTypeEnum::IfcUnitaryControlElementTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcUnitaryControlElementTypeEnum::IfcUnitaryControlElementTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcUnitaryControlElementTypeEnum::IfcUnitaryControlElementTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcUnitaryControlElementTypeEnum::ToString(Value v) {
    return Ifc4::IfcUnitaryControlElementTypeEnum::IfcUnitaryControlElementTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcUnitaryControlElementTypeEnum::Value Ifc4::IfcUnitaryControlElementTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcUnitaryControlElementTypeEnum::Value) Ifc4::IfcUnitaryControlElementTypeEnum::IfcUnitaryControlElementTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcUnitaryControlElementTypeEnum::operator Ifc4::IfcUnitaryControlElementTypeEnum::Value() const {
    return (Ifc4::IfcUnitaryControlElementTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcUnitaryEquipmentTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1116]); }
const IfcParse::enumeration_type& Ifc4::IfcUnitaryEquipmentTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1116]); }

Ifc4::IfcUnitaryEquipmentTypeEnum::IfcUnitaryEquipmentTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcUnitaryEquipmentTypeEnum::IfcUnitaryEquipmentTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcUnitaryEquipmentTypeEnum::IfcUnitaryEquipmentTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcUnitaryEquipmentTypeEnum::ToString(Value v) {
    return Ifc4::IfcUnitaryEquipmentTypeEnum::IfcUnitaryEquipmentTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcUnitaryEquipmentTypeEnum::Value Ifc4::IfcUnitaryEquipmentTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcUnitaryEquipmentTypeEnum::Value) Ifc4::IfcUnitaryEquipmentTypeEnum::IfcUnitaryEquipmentTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcUnitaryEquipmentTypeEnum::operator Ifc4::IfcUnitaryEquipmentTypeEnum::Value() const {
    return (Ifc4::IfcUnitaryEquipmentTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcValveTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1124]); }
const IfcParse::enumeration_type& Ifc4::IfcValveTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1124]); }

Ifc4::IfcValveTypeEnum::IfcValveTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcValveTypeEnum::IfcValveTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcValveTypeEnum::IfcValveTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcValveTypeEnum::ToString(Value v) {
    return Ifc4::IfcValveTypeEnum::IfcValveTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcValveTypeEnum::Value Ifc4::IfcValveTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcValveTypeEnum::Value) Ifc4::IfcValveTypeEnum::IfcValveTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcValveTypeEnum::operator Ifc4::IfcValveTypeEnum::Value() const {
    return (Ifc4::IfcValveTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcVibrationIsolatorTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1133]); }
const IfcParse::enumeration_type& Ifc4::IfcVibrationIsolatorTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1133]); }

Ifc4::IfcVibrationIsolatorTypeEnum::IfcVibrationIsolatorTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcVibrationIsolatorTypeEnum::IfcVibrationIsolatorTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcVibrationIsolatorTypeEnum::IfcVibrationIsolatorTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcVibrationIsolatorTypeEnum::ToString(Value v) {
    return Ifc4::IfcVibrationIsolatorTypeEnum::IfcVibrationIsolatorTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcVibrationIsolatorTypeEnum::Value Ifc4::IfcVibrationIsolatorTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcVibrationIsolatorTypeEnum::Value) Ifc4::IfcVibrationIsolatorTypeEnum::IfcVibrationIsolatorTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcVibrationIsolatorTypeEnum::operator Ifc4::IfcVibrationIsolatorTypeEnum::Value() const {
    return (Ifc4::IfcVibrationIsolatorTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcVoidingFeatureTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1137]); }
const IfcParse::enumeration_type& Ifc4::IfcVoidingFeatureTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1137]); }

Ifc4::IfcVoidingFeatureTypeEnum::IfcVoidingFeatureTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcVoidingFeatureTypeEnum::IfcVoidingFeatureTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcVoidingFeatureTypeEnum::IfcVoidingFeatureTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcVoidingFeatureTypeEnum::ToString(Value v) {
    return Ifc4::IfcVoidingFeatureTypeEnum::IfcVoidingFeatureTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcVoidingFeatureTypeEnum::Value Ifc4::IfcVoidingFeatureTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcVoidingFeatureTypeEnum::Value) Ifc4::IfcVoidingFeatureTypeEnum::IfcVoidingFeatureTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcVoidingFeatureTypeEnum::operator Ifc4::IfcVoidingFeatureTypeEnum::Value() const {
    return (Ifc4::IfcVoidingFeatureTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWallTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1144]); }
const IfcParse::enumeration_type& Ifc4::IfcWallTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1144]); }

Ifc4::IfcWallTypeEnum::IfcWallTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWallTypeEnum::IfcWallTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWallTypeEnum::IfcWallTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWallTypeEnum::ToString(Value v) {
    return Ifc4::IfcWallTypeEnum::IfcWallTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWallTypeEnum::Value Ifc4::IfcWallTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWallTypeEnum::Value) Ifc4::IfcWallTypeEnum::IfcWallTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWallTypeEnum::operator Ifc4::IfcWallTypeEnum::Value() const {
    return (Ifc4::IfcWallTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWasteTerminalTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1150]); }
const IfcParse::enumeration_type& Ifc4::IfcWasteTerminalTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1150]); }

Ifc4::IfcWasteTerminalTypeEnum::IfcWasteTerminalTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWasteTerminalTypeEnum::IfcWasteTerminalTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWasteTerminalTypeEnum::IfcWasteTerminalTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWasteTerminalTypeEnum::ToString(Value v) {
    return Ifc4::IfcWasteTerminalTypeEnum::IfcWasteTerminalTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWasteTerminalTypeEnum::Value Ifc4::IfcWasteTerminalTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWasteTerminalTypeEnum::Value) Ifc4::IfcWasteTerminalTypeEnum::IfcWasteTerminalTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWasteTerminalTypeEnum::operator Ifc4::IfcWasteTerminalTypeEnum::Value() const {
    return (Ifc4::IfcWasteTerminalTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWindowPanelOperationEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1153]); }
const IfcParse::enumeration_type& Ifc4::IfcWindowPanelOperationEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1153]); }

Ifc4::IfcWindowPanelOperationEnum::IfcWindowPanelOperationEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWindowPanelOperationEnum::IfcWindowPanelOperationEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWindowPanelOperationEnum::IfcWindowPanelOperationEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWindowPanelOperationEnum::ToString(Value v) {
    return Ifc4::IfcWindowPanelOperationEnum::IfcWindowPanelOperationEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWindowPanelOperationEnum::Value Ifc4::IfcWindowPanelOperationEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWindowPanelOperationEnum::Value) Ifc4::IfcWindowPanelOperationEnum::IfcWindowPanelOperationEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWindowPanelOperationEnum::operator Ifc4::IfcWindowPanelOperationEnum::Value() const {
    return (Ifc4::IfcWindowPanelOperationEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWindowPanelPositionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1154]); }
const IfcParse::enumeration_type& Ifc4::IfcWindowPanelPositionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1154]); }

Ifc4::IfcWindowPanelPositionEnum::IfcWindowPanelPositionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWindowPanelPositionEnum::IfcWindowPanelPositionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWindowPanelPositionEnum::IfcWindowPanelPositionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWindowPanelPositionEnum::ToString(Value v) {
    return Ifc4::IfcWindowPanelPositionEnum::IfcWindowPanelPositionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWindowPanelPositionEnum::Value Ifc4::IfcWindowPanelPositionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWindowPanelPositionEnum::Value) Ifc4::IfcWindowPanelPositionEnum::IfcWindowPanelPositionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWindowPanelPositionEnum::operator Ifc4::IfcWindowPanelPositionEnum::Value() const {
    return (Ifc4::IfcWindowPanelPositionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWindowStyleConstructionEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1158]); }
const IfcParse::enumeration_type& Ifc4::IfcWindowStyleConstructionEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1158]); }

Ifc4::IfcWindowStyleConstructionEnum::IfcWindowStyleConstructionEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWindowStyleConstructionEnum::IfcWindowStyleConstructionEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWindowStyleConstructionEnum::IfcWindowStyleConstructionEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWindowStyleConstructionEnum::ToString(Value v) {
    return Ifc4::IfcWindowStyleConstructionEnum::IfcWindowStyleConstructionEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWindowStyleConstructionEnum::Value Ifc4::IfcWindowStyleConstructionEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWindowStyleConstructionEnum::Value) Ifc4::IfcWindowStyleConstructionEnum::IfcWindowStyleConstructionEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWindowStyleConstructionEnum::operator Ifc4::IfcWindowStyleConstructionEnum::Value() const {
    return (Ifc4::IfcWindowStyleConstructionEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWindowStyleOperationEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1159]); }
const IfcParse::enumeration_type& Ifc4::IfcWindowStyleOperationEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1159]); }

Ifc4::IfcWindowStyleOperationEnum::IfcWindowStyleOperationEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWindowStyleOperationEnum::IfcWindowStyleOperationEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWindowStyleOperationEnum::IfcWindowStyleOperationEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWindowStyleOperationEnum::ToString(Value v) {
    return Ifc4::IfcWindowStyleOperationEnum::IfcWindowStyleOperationEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWindowStyleOperationEnum::Value Ifc4::IfcWindowStyleOperationEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWindowStyleOperationEnum::Value) Ifc4::IfcWindowStyleOperationEnum::IfcWindowStyleOperationEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWindowStyleOperationEnum::operator Ifc4::IfcWindowStyleOperationEnum::Value() const {
    return (Ifc4::IfcWindowStyleOperationEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWindowTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1161]); }
const IfcParse::enumeration_type& Ifc4::IfcWindowTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1161]); }

Ifc4::IfcWindowTypeEnum::IfcWindowTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWindowTypeEnum::IfcWindowTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWindowTypeEnum::IfcWindowTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWindowTypeEnum::ToString(Value v) {
    return Ifc4::IfcWindowTypeEnum::IfcWindowTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWindowTypeEnum::Value Ifc4::IfcWindowTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWindowTypeEnum::Value) Ifc4::IfcWindowTypeEnum::IfcWindowTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWindowTypeEnum::operator Ifc4::IfcWindowTypeEnum::Value() const {
    return (Ifc4::IfcWindowTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWindowTypePartitioningEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1162]); }
const IfcParse::enumeration_type& Ifc4::IfcWindowTypePartitioningEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1162]); }

Ifc4::IfcWindowTypePartitioningEnum::IfcWindowTypePartitioningEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWindowTypePartitioningEnum::IfcWindowTypePartitioningEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWindowTypePartitioningEnum::IfcWindowTypePartitioningEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWindowTypePartitioningEnum::ToString(Value v) {
    return Ifc4::IfcWindowTypePartitioningEnum::IfcWindowTypePartitioningEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWindowTypePartitioningEnum::Value Ifc4::IfcWindowTypePartitioningEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWindowTypePartitioningEnum::Value) Ifc4::IfcWindowTypePartitioningEnum::IfcWindowTypePartitioningEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWindowTypePartitioningEnum::operator Ifc4::IfcWindowTypePartitioningEnum::Value() const {
    return (Ifc4::IfcWindowTypePartitioningEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWorkCalendarTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1164]); }
const IfcParse::enumeration_type& Ifc4::IfcWorkCalendarTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1164]); }

Ifc4::IfcWorkCalendarTypeEnum::IfcWorkCalendarTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWorkCalendarTypeEnum::IfcWorkCalendarTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWorkCalendarTypeEnum::IfcWorkCalendarTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWorkCalendarTypeEnum::ToString(Value v) {
    return Ifc4::IfcWorkCalendarTypeEnum::IfcWorkCalendarTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWorkCalendarTypeEnum::Value Ifc4::IfcWorkCalendarTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWorkCalendarTypeEnum::Value) Ifc4::IfcWorkCalendarTypeEnum::IfcWorkCalendarTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWorkCalendarTypeEnum::operator Ifc4::IfcWorkCalendarTypeEnum::Value() const {
    return (Ifc4::IfcWorkCalendarTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWorkPlanTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1167]); }
const IfcParse::enumeration_type& Ifc4::IfcWorkPlanTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1167]); }

Ifc4::IfcWorkPlanTypeEnum::IfcWorkPlanTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWorkPlanTypeEnum::IfcWorkPlanTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWorkPlanTypeEnum::IfcWorkPlanTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWorkPlanTypeEnum::ToString(Value v) {
    return Ifc4::IfcWorkPlanTypeEnum::IfcWorkPlanTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWorkPlanTypeEnum::Value Ifc4::IfcWorkPlanTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWorkPlanTypeEnum::Value) Ifc4::IfcWorkPlanTypeEnum::IfcWorkPlanTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWorkPlanTypeEnum::operator Ifc4::IfcWorkPlanTypeEnum::Value() const {
    return (Ifc4::IfcWorkPlanTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::enumeration_type& Ifc4::IfcWorkScheduleTypeEnum::declaration() const { return *((IfcParse::enumeration_type*)IFC4_types[1169]); }
const IfcParse::enumeration_type& Ifc4::IfcWorkScheduleTypeEnum::Class() { return *((IfcParse::enumeration_type*)IFC4_types[1169]); }

Ifc4::IfcWorkScheduleTypeEnum::IfcWorkScheduleTypeEnum(IfcEntityInstanceData&& e)
    : IfcBaseType(std::move(e))
{}

Ifc4::IfcWorkScheduleTypeEnum::IfcWorkScheduleTypeEnum(Value v) {
    set_attribute_value(0, EnumerationReference(&declaration(), static_cast<size_t>(v)));
}

Ifc4::IfcWorkScheduleTypeEnum::IfcWorkScheduleTypeEnum(const std::string& v) {
    set_attribute_value(0, EnumerationReference(&declaration(), declaration().lookup_enum_offset(v)));
}

const char* Ifc4::IfcWorkScheduleTypeEnum::ToString(Value v) {
    return Ifc4::IfcWorkScheduleTypeEnum::IfcWorkScheduleTypeEnum::Class().lookup_enum_value((size_t)v);
}

Ifc4::IfcWorkScheduleTypeEnum::Value Ifc4::IfcWorkScheduleTypeEnum::FromString(const std::string& s) {
    return (Ifc4::IfcWorkScheduleTypeEnum::Value) Ifc4::IfcWorkScheduleTypeEnum::IfcWorkScheduleTypeEnum::Class().lookup_enum_offset(s);
}

Ifc4::IfcWorkScheduleTypeEnum::operator Ifc4::IfcWorkScheduleTypeEnum::Value() const {
    return (Ifc4::IfcWorkScheduleTypeEnum::Value) data_.storage_.get<EnumerationReference>(0).index();
}

const IfcParse::select_type& Ifc4::IfcActorSelect::Class() { return *((IfcParse::select_type*)IFC4_types[8]); }

const IfcParse::select_type& Ifc4::IfcAppliedValueSelect::Class() { return *((IfcParse::select_type*)IFC4_types[37]); }

const IfcParse::select_type& Ifc4::IfcAxis2Placement::Class() { return *((IfcParse::select_type*)IFC4_types[54]); }

const IfcParse::select_type& Ifc4::IfcBendingParameterSelect::Class() { return *((IfcParse::select_type*)IFC4_types[62]); }

const IfcParse::select_type& Ifc4::IfcBooleanOperand::Class() { return *((IfcParse::select_type*)IFC4_types[71]); }

const IfcParse::select_type& Ifc4::IfcClassificationReferenceSelect::Class() { return *((IfcParse::select_type*)IFC4_types[143]); }

const IfcParse::select_type& Ifc4::IfcClassificationSelect::Class() { return *((IfcParse::select_type*)IFC4_types[144]); }

const IfcParse::select_type& Ifc4::IfcColour::Class() { return *((IfcParse::select_type*)IFC4_types[149]); }

const IfcParse::select_type& Ifc4::IfcColourOrFactor::Class() { return *((IfcParse::select_type*)IFC4_types[150]); }

const IfcParse::select_type& Ifc4::IfcCoordinateReferenceSystemSelect::Class() { return *((IfcParse::select_type*)IFC4_types[215]); }

const IfcParse::select_type& Ifc4::IfcCsgSelect::Class() { return *((IfcParse::select_type*)IFC4_types[229]); }

const IfcParse::select_type& Ifc4::IfcCurveFontOrScaledCurveFontSelect::Class() { return *((IfcParse::select_type*)IFC4_types[240]); }

const IfcParse::select_type& Ifc4::IfcCurveOnSurface::Class() { return *((IfcParse::select_type*)IFC4_types[242]); }

const IfcParse::select_type& Ifc4::IfcCurveOrEdgeCurve::Class() { return *((IfcParse::select_type*)IFC4_types[243]); }

const IfcParse::select_type& Ifc4::IfcCurveStyleFontSelect::Class() { return *((IfcParse::select_type*)IFC4_types[248]); }

const IfcParse::select_type& Ifc4::IfcDefinitionSelect::Class() { return *((IfcParse::select_type*)IFC4_types[258]); }

const IfcParse::select_type& Ifc4::IfcDerivedMeasureValue::Class() { return *((IfcParse::select_type*)IFC4_types[259]); }

const IfcParse::select_type& Ifc4::IfcDocumentSelect::Class() { return *((IfcParse::select_type*)IFC4_types[290]); }

const IfcParse::select_type& Ifc4::IfcFillStyleSelect::Class() { return *((IfcParse::select_type*)IFC4_types[406]); }

const IfcParse::select_type& Ifc4::IfcGeometricSetSelect::Class() { return *((IfcParse::select_type*)IFC4_types[457]); }

const IfcParse::select_type& Ifc4::IfcGridPlacementDirectionSelect::Class() { return *((IfcParse::select_type*)IFC4_types[463]); }

const IfcParse::select_type& Ifc4::IfcHatchLineDistanceSelect::Class() { return *((IfcParse::select_type*)IFC4_types[467]); }

const IfcParse::select_type& Ifc4::IfcLayeredItem::Class() { return *((IfcParse::select_type*)IFC4_types[514]); }

const IfcParse::select_type& Ifc4::IfcLibrarySelect::Class() { return *((IfcParse::select_type*)IFC4_types[519]); }

const IfcParse::select_type& Ifc4::IfcLightDistributionDataSourceSelect::Class() { return *((IfcParse::select_type*)IFC4_types[522]); }

const IfcParse::select_type& Ifc4::IfcMaterialSelect::Class() { return *((IfcParse::select_type*)IFC4_types[576]); }

const IfcParse::select_type& Ifc4::IfcMeasureValue::Class() { return *((IfcParse::select_type*)IFC4_types[578]); }

const IfcParse::select_type& Ifc4::IfcMetricValueSelect::Class() { return *((IfcParse::select_type*)IFC4_types[591]); }

const IfcParse::select_type& Ifc4::IfcModulusOfRotationalSubgradeReactionSelect::Class() { return *((IfcParse::select_type*)IFC4_types[596]); }

const IfcParse::select_type& Ifc4::IfcModulusOfSubgradeReactionSelect::Class() { return *((IfcParse::select_type*)IFC4_types[598]); }

const IfcParse::select_type& Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect::Class() { return *((IfcParse::select_type*)IFC4_types[599]); }

const IfcParse::select_type& Ifc4::IfcObjectReferenceSelect::Class() { return *((IfcParse::select_type*)IFC4_types[619]); }

const IfcParse::select_type& Ifc4::IfcPointOrVertexPoint::Class() { return *((IfcParse::select_type*)IFC4_types[678]); }

const IfcParse::select_type& Ifc4::IfcPresentationStyleSelect::Class() { return *((IfcParse::select_type*)IFC4_types[703]); }

const IfcParse::select_type& Ifc4::IfcProcessSelect::Class() { return *((IfcParse::select_type*)IFC4_types[709]); }

const IfcParse::select_type& Ifc4::IfcProductRepresentationSelect::Class() { return *((IfcParse::select_type*)IFC4_types[713]); }

const IfcParse::select_type& Ifc4::IfcProductSelect::Class() { return *((IfcParse::select_type*)IFC4_types[714]); }

const IfcParse::select_type& Ifc4::IfcPropertySetDefinitionSelect::Class() { return *((IfcParse::select_type*)IFC4_types[737]); }

const IfcParse::select_type& Ifc4::IfcResourceObjectSelect::Class() { return *((IfcParse::select_type*)IFC4_types[854]); }

const IfcParse::select_type& Ifc4::IfcResourceSelect::Class() { return *((IfcParse::select_type*)IFC4_types[855]); }

const IfcParse::select_type& Ifc4::IfcRotationalStiffnessSelect::Class() { return *((IfcParse::select_type*)IFC4_types[869]); }

const IfcParse::select_type& Ifc4::IfcSegmentIndexSelect::Class() { return *((IfcParse::select_type*)IFC4_types[882]); }

const IfcParse::select_type& Ifc4::IfcShell::Class() { return *((IfcParse::select_type*)IFC4_types[894]); }

const IfcParse::select_type& Ifc4::IfcSimpleValue::Class() { return *((IfcParse::select_type*)IFC4_types[899]); }

const IfcParse::select_type& Ifc4::IfcSizeSelect::Class() { return *((IfcParse::select_type*)IFC4_types[904]); }

const IfcParse::select_type& Ifc4::IfcSolidOrShell::Class() { return *((IfcParse::select_type*)IFC4_types[916]); }

const IfcParse::select_type& Ifc4::IfcSpaceBoundarySelect::Class() { return *((IfcParse::select_type*)IFC4_types[922]); }

const IfcParse::select_type& Ifc4::IfcSpecularHighlightSelect::Class() { return *((IfcParse::select_type*)IFC4_types[937]); }

const IfcParse::select_type& Ifc4::IfcStructuralActivityAssignmentSelect::Class() { return *((IfcParse::select_type*)IFC4_types[953]); }

const IfcParse::select_type& Ifc4::IfcStyleAssignmentSelect::Class() { return *((IfcParse::select_type*)IFC4_types[993]); }

const IfcParse::select_type& Ifc4::IfcSurfaceOrFaceSurface::Class() { return *((IfcParse::select_type*)IFC4_types[1008]); }

const IfcParse::select_type& Ifc4::IfcSurfaceStyleElementSelect::Class() { return *((IfcParse::select_type*)IFC4_types[1012]); }

const IfcParse::select_type& Ifc4::IfcTextFontSelect::Class() { return *((IfcParse::select_type*)IFC4_types[1057]); }

const IfcParse::select_type& Ifc4::IfcTimeOrRatioSelect::Class() { return *((IfcParse::select_type*)IFC4_types[1079]); }

const IfcParse::select_type& Ifc4::IfcTranslationalStiffnessSelect::Class() { return *((IfcParse::select_type*)IFC4_types[1093]); }

const IfcParse::select_type& Ifc4::IfcTrimmingSelect::Class() { return *((IfcParse::select_type*)IFC4_types[1101]); }

const IfcParse::select_type& Ifc4::IfcUnit::Class() { return *((IfcParse::select_type*)IFC4_types[1110]); }

const IfcParse::select_type& Ifc4::IfcValue::Class() { return *((IfcParse::select_type*)IFC4_types[1121]); }

const IfcParse::select_type& Ifc4::IfcVectorOrDirection::Class() { return *((IfcParse::select_type*)IFC4_types[1127]); }

const IfcParse::select_type& Ifc4::IfcWarpingStiffnessSelect::Class() { return *((IfcParse::select_type*)IFC4_types[1147]); }


// Function implementations for IfcAbsorbedDoseMeasure
const IfcParse::type_declaration& Ifc4::IfcAbsorbedDoseMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[0]); }
const IfcParse::type_declaration& Ifc4::IfcAbsorbedDoseMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[0]); }
Ifc4::IfcAbsorbedDoseMeasure::IfcAbsorbedDoseMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcAbsorbedDoseMeasure::IfcAbsorbedDoseMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcAbsorbedDoseMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcAccelerationMeasure
const IfcParse::type_declaration& Ifc4::IfcAccelerationMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1]); }
const IfcParse::type_declaration& Ifc4::IfcAccelerationMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1]); }
Ifc4::IfcAccelerationMeasure::IfcAccelerationMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcAccelerationMeasure::IfcAccelerationMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcAccelerationMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcAmountOfSubstanceMeasure
const IfcParse::type_declaration& Ifc4::IfcAmountOfSubstanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[29]); }
const IfcParse::type_declaration& Ifc4::IfcAmountOfSubstanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[29]); }
Ifc4::IfcAmountOfSubstanceMeasure::IfcAmountOfSubstanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcAmountOfSubstanceMeasure::IfcAmountOfSubstanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcAmountOfSubstanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcAngularVelocityMeasure
const IfcParse::type_declaration& Ifc4::IfcAngularVelocityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[32]); }
const IfcParse::type_declaration& Ifc4::IfcAngularVelocityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[32]); }
Ifc4::IfcAngularVelocityMeasure::IfcAngularVelocityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcAngularVelocityMeasure::IfcAngularVelocityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcAngularVelocityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcArcIndex
const IfcParse::type_declaration& Ifc4::IfcArcIndex::Class() { return *((IfcParse::type_declaration*)IFC4_types[43]); }
const IfcParse::type_declaration& Ifc4::IfcArcIndex::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[43]); }
Ifc4::IfcArcIndex::IfcArcIndex(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcArcIndex::IfcArcIndex(std::vector< int > /*[3:3]*/ v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcArcIndex::operator std::vector< int > /*[3:3]*/() const { return data_.get_attribute_value(0); }

// Function implementations for IfcAreaDensityMeasure
const IfcParse::type_declaration& Ifc4::IfcAreaDensityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[44]); }
const IfcParse::type_declaration& Ifc4::IfcAreaDensityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[44]); }
Ifc4::IfcAreaDensityMeasure::IfcAreaDensityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcAreaDensityMeasure::IfcAreaDensityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcAreaDensityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcAreaMeasure
const IfcParse::type_declaration& Ifc4::IfcAreaMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[45]); }
const IfcParse::type_declaration& Ifc4::IfcAreaMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[45]); }
Ifc4::IfcAreaMeasure::IfcAreaMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcAreaMeasure::IfcAreaMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcAreaMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcBinary
const IfcParse::type_declaration& Ifc4::IfcBinary::Class() { return *((IfcParse::type_declaration*)IFC4_types[63]); }
const IfcParse::type_declaration& Ifc4::IfcBinary::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[63]); }
Ifc4::IfcBinary::IfcBinary(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcBinary::IfcBinary(boost::dynamic_bitset<> v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcBinary::operator boost::dynamic_bitset<>() const { return data_.get_attribute_value(0); }

// Function implementations for IfcBoolean
const IfcParse::type_declaration& Ifc4::IfcBoolean::Class() { return *((IfcParse::type_declaration*)IFC4_types[69]); }
const IfcParse::type_declaration& Ifc4::IfcBoolean::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[69]); }
Ifc4::IfcBoolean::IfcBoolean(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcBoolean::IfcBoolean(bool v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcBoolean::operator bool() const { return data_.get_attribute_value(0); }

// Function implementations for IfcBoxAlignment
const IfcParse::type_declaration& Ifc4::IfcBoxAlignment::Class() { return *((IfcParse::type_declaration*)IFC4_types[83]); }
const IfcParse::type_declaration& Ifc4::IfcBoxAlignment::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[83]); }
Ifc4::IfcBoxAlignment::IfcBoxAlignment(IfcEntityInstanceData&& e) : IfcLabel(std::move(e)) {  }
Ifc4::IfcBoxAlignment::IfcBoxAlignment(std::string v) : IfcLabel(v) {  }
Ifc4::IfcBoxAlignment::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcCardinalPointReference
const IfcParse::type_declaration& Ifc4::IfcCardinalPointReference::Class() { return *((IfcParse::type_declaration*)IFC4_types[118]); }
const IfcParse::type_declaration& Ifc4::IfcCardinalPointReference::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[118]); }
Ifc4::IfcCardinalPointReference::IfcCardinalPointReference(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcCardinalPointReference::IfcCardinalPointReference(int v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcCardinalPointReference::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcComplexNumber
const IfcParse::type_declaration& Ifc4::IfcComplexNumber::Class() { return *((IfcParse::type_declaration*)IFC4_types[161]); }
const IfcParse::type_declaration& Ifc4::IfcComplexNumber::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[161]); }
Ifc4::IfcComplexNumber::IfcComplexNumber(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcComplexNumber::IfcComplexNumber(std::vector< double > /*[1:2]*/ v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcComplexNumber::operator std::vector< double > /*[1:2]*/() const { return data_.get_attribute_value(0); }

// Function implementations for IfcCompoundPlaneAngleMeasure
const IfcParse::type_declaration& Ifc4::IfcCompoundPlaneAngleMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[169]); }
const IfcParse::type_declaration& Ifc4::IfcCompoundPlaneAngleMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[169]); }
Ifc4::IfcCompoundPlaneAngleMeasure::IfcCompoundPlaneAngleMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcCompoundPlaneAngleMeasure::IfcCompoundPlaneAngleMeasure(std::vector< int > /*[3:4]*/ v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcCompoundPlaneAngleMeasure::operator std::vector< int > /*[3:4]*/() const { return data_.get_attribute_value(0); }

// Function implementations for IfcContextDependentMeasure
const IfcParse::type_declaration& Ifc4::IfcContextDependentMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[199]); }
const IfcParse::type_declaration& Ifc4::IfcContextDependentMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[199]); }
Ifc4::IfcContextDependentMeasure::IfcContextDependentMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcContextDependentMeasure::IfcContextDependentMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcContextDependentMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcCountMeasure
const IfcParse::type_declaration& Ifc4::IfcCountMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[221]); }
const IfcParse::type_declaration& Ifc4::IfcCountMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[221]); }
Ifc4::IfcCountMeasure::IfcCountMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcCountMeasure::IfcCountMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcCountMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcCurvatureMeasure
const IfcParse::type_declaration& Ifc4::IfcCurvatureMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[236]); }
const IfcParse::type_declaration& Ifc4::IfcCurvatureMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[236]); }
Ifc4::IfcCurvatureMeasure::IfcCurvatureMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcCurvatureMeasure::IfcCurvatureMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcCurvatureMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDate
const IfcParse::type_declaration& Ifc4::IfcDate::Class() { return *((IfcParse::type_declaration*)IFC4_types[254]); }
const IfcParse::type_declaration& Ifc4::IfcDate::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[254]); }
Ifc4::IfcDate::IfcDate(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDate::IfcDate(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDate::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDateTime
const IfcParse::type_declaration& Ifc4::IfcDateTime::Class() { return *((IfcParse::type_declaration*)IFC4_types[255]); }
const IfcParse::type_declaration& Ifc4::IfcDateTime::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[255]); }
Ifc4::IfcDateTime::IfcDateTime(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDateTime::IfcDateTime(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDateTime::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDayInMonthNumber
const IfcParse::type_declaration& Ifc4::IfcDayInMonthNumber::Class() { return *((IfcParse::type_declaration*)IFC4_types[256]); }
const IfcParse::type_declaration& Ifc4::IfcDayInMonthNumber::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[256]); }
Ifc4::IfcDayInMonthNumber::IfcDayInMonthNumber(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDayInMonthNumber::IfcDayInMonthNumber(int v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDayInMonthNumber::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDayInWeekNumber
const IfcParse::type_declaration& Ifc4::IfcDayInWeekNumber::Class() { return *((IfcParse::type_declaration*)IFC4_types[257]); }
const IfcParse::type_declaration& Ifc4::IfcDayInWeekNumber::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[257]); }
Ifc4::IfcDayInWeekNumber::IfcDayInWeekNumber(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDayInWeekNumber::IfcDayInWeekNumber(int v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDayInWeekNumber::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDescriptiveMeasure
const IfcParse::type_declaration& Ifc4::IfcDescriptiveMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[264]); }
const IfcParse::type_declaration& Ifc4::IfcDescriptiveMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[264]); }
Ifc4::IfcDescriptiveMeasure::IfcDescriptiveMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDescriptiveMeasure::IfcDescriptiveMeasure(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDescriptiveMeasure::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDimensionCount
const IfcParse::type_declaration& Ifc4::IfcDimensionCount::Class() { return *((IfcParse::type_declaration*)IFC4_types[266]); }
const IfcParse::type_declaration& Ifc4::IfcDimensionCount::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[266]); }
Ifc4::IfcDimensionCount::IfcDimensionCount(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDimensionCount::IfcDimensionCount(int v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDimensionCount::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDoseEquivalentMeasure
const IfcParse::type_declaration& Ifc4::IfcDoseEquivalentMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[304]); }
const IfcParse::type_declaration& Ifc4::IfcDoseEquivalentMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[304]); }
Ifc4::IfcDoseEquivalentMeasure::IfcDoseEquivalentMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDoseEquivalentMeasure::IfcDoseEquivalentMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDoseEquivalentMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDuration
const IfcParse::type_declaration& Ifc4::IfcDuration::Class() { return *((IfcParse::type_declaration*)IFC4_types[316]); }
const IfcParse::type_declaration& Ifc4::IfcDuration::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[316]); }
Ifc4::IfcDuration::IfcDuration(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDuration::IfcDuration(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDuration::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcDynamicViscosityMeasure
const IfcParse::type_declaration& Ifc4::IfcDynamicViscosityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[317]); }
const IfcParse::type_declaration& Ifc4::IfcDynamicViscosityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[317]); }
Ifc4::IfcDynamicViscosityMeasure::IfcDynamicViscosityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcDynamicViscosityMeasure::IfcDynamicViscosityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcDynamicViscosityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcElectricCapacitanceMeasure
const IfcParse::type_declaration& Ifc4::IfcElectricCapacitanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[324]); }
const IfcParse::type_declaration& Ifc4::IfcElectricCapacitanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[324]); }
Ifc4::IfcElectricCapacitanceMeasure::IfcElectricCapacitanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcElectricCapacitanceMeasure::IfcElectricCapacitanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcElectricCapacitanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcElectricChargeMeasure
const IfcParse::type_declaration& Ifc4::IfcElectricChargeMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[325]); }
const IfcParse::type_declaration& Ifc4::IfcElectricChargeMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[325]); }
Ifc4::IfcElectricChargeMeasure::IfcElectricChargeMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcElectricChargeMeasure::IfcElectricChargeMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcElectricChargeMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcElectricConductanceMeasure
const IfcParse::type_declaration& Ifc4::IfcElectricConductanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[326]); }
const IfcParse::type_declaration& Ifc4::IfcElectricConductanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[326]); }
Ifc4::IfcElectricConductanceMeasure::IfcElectricConductanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcElectricConductanceMeasure::IfcElectricConductanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcElectricConductanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcElectricCurrentMeasure
const IfcParse::type_declaration& Ifc4::IfcElectricCurrentMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[327]); }
const IfcParse::type_declaration& Ifc4::IfcElectricCurrentMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[327]); }
Ifc4::IfcElectricCurrentMeasure::IfcElectricCurrentMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcElectricCurrentMeasure::IfcElectricCurrentMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcElectricCurrentMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcElectricResistanceMeasure
const IfcParse::type_declaration& Ifc4::IfcElectricResistanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[340]); }
const IfcParse::type_declaration& Ifc4::IfcElectricResistanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[340]); }
Ifc4::IfcElectricResistanceMeasure::IfcElectricResistanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcElectricResistanceMeasure::IfcElectricResistanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcElectricResistanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcElectricVoltageMeasure
const IfcParse::type_declaration& Ifc4::IfcElectricVoltageMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[344]); }
const IfcParse::type_declaration& Ifc4::IfcElectricVoltageMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[344]); }
Ifc4::IfcElectricVoltageMeasure::IfcElectricVoltageMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcElectricVoltageMeasure::IfcElectricVoltageMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcElectricVoltageMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcEnergyMeasure
const IfcParse::type_declaration& Ifc4::IfcEnergyMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[359]); }
const IfcParse::type_declaration& Ifc4::IfcEnergyMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[359]); }
Ifc4::IfcEnergyMeasure::IfcEnergyMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcEnergyMeasure::IfcEnergyMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcEnergyMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcFontStyle
const IfcParse::type_declaration& Ifc4::IfcFontStyle::Class() { return *((IfcParse::type_declaration*)IFC4_types[435]); }
const IfcParse::type_declaration& Ifc4::IfcFontStyle::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[435]); }
Ifc4::IfcFontStyle::IfcFontStyle(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcFontStyle::IfcFontStyle(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcFontStyle::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcFontVariant
const IfcParse::type_declaration& Ifc4::IfcFontVariant::Class() { return *((IfcParse::type_declaration*)IFC4_types[436]); }
const IfcParse::type_declaration& Ifc4::IfcFontVariant::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[436]); }
Ifc4::IfcFontVariant::IfcFontVariant(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcFontVariant::IfcFontVariant(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcFontVariant::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcFontWeight
const IfcParse::type_declaration& Ifc4::IfcFontWeight::Class() { return *((IfcParse::type_declaration*)IFC4_types[437]); }
const IfcParse::type_declaration& Ifc4::IfcFontWeight::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[437]); }
Ifc4::IfcFontWeight::IfcFontWeight(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcFontWeight::IfcFontWeight(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcFontWeight::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcForceMeasure
const IfcParse::type_declaration& Ifc4::IfcForceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[441]); }
const IfcParse::type_declaration& Ifc4::IfcForceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[441]); }
Ifc4::IfcForceMeasure::IfcForceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcForceMeasure::IfcForceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcForceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcFrequencyMeasure
const IfcParse::type_declaration& Ifc4::IfcFrequencyMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[442]); }
const IfcParse::type_declaration& Ifc4::IfcFrequencyMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[442]); }
Ifc4::IfcFrequencyMeasure::IfcFrequencyMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcFrequencyMeasure::IfcFrequencyMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcFrequencyMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcGloballyUniqueId
const IfcParse::type_declaration& Ifc4::IfcGloballyUniqueId::Class() { return *((IfcParse::type_declaration*)IFC4_types[458]); }
const IfcParse::type_declaration& Ifc4::IfcGloballyUniqueId::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[458]); }
Ifc4::IfcGloballyUniqueId::IfcGloballyUniqueId(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcGloballyUniqueId::IfcGloballyUniqueId(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcGloballyUniqueId::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcHeatFluxDensityMeasure
const IfcParse::type_declaration& Ifc4::IfcHeatFluxDensityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[471]); }
const IfcParse::type_declaration& Ifc4::IfcHeatFluxDensityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[471]); }
Ifc4::IfcHeatFluxDensityMeasure::IfcHeatFluxDensityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcHeatFluxDensityMeasure::IfcHeatFluxDensityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcHeatFluxDensityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcHeatingValueMeasure
const IfcParse::type_declaration& Ifc4::IfcHeatingValueMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[472]); }
const IfcParse::type_declaration& Ifc4::IfcHeatingValueMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[472]); }
Ifc4::IfcHeatingValueMeasure::IfcHeatingValueMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcHeatingValueMeasure::IfcHeatingValueMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcHeatingValueMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcIdentifier
const IfcParse::type_declaration& Ifc4::IfcIdentifier::Class() { return *((IfcParse::type_declaration*)IFC4_types[476]); }
const IfcParse::type_declaration& Ifc4::IfcIdentifier::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[476]); }
Ifc4::IfcIdentifier::IfcIdentifier(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcIdentifier::IfcIdentifier(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcIdentifier::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcIlluminanceMeasure
const IfcParse::type_declaration& Ifc4::IfcIlluminanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[477]); }
const IfcParse::type_declaration& Ifc4::IfcIlluminanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[477]); }
Ifc4::IfcIlluminanceMeasure::IfcIlluminanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcIlluminanceMeasure::IfcIlluminanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcIlluminanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcInductanceMeasure
const IfcParse::type_declaration& Ifc4::IfcInductanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[485]); }
const IfcParse::type_declaration& Ifc4::IfcInductanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[485]); }
Ifc4::IfcInductanceMeasure::IfcInductanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcInductanceMeasure::IfcInductanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcInductanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcInteger
const IfcParse::type_declaration& Ifc4::IfcInteger::Class() { return *((IfcParse::type_declaration*)IFC4_types[486]); }
const IfcParse::type_declaration& Ifc4::IfcInteger::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[486]); }
Ifc4::IfcInteger::IfcInteger(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcInteger::IfcInteger(int v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcInteger::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcIntegerCountRateMeasure
const IfcParse::type_declaration& Ifc4::IfcIntegerCountRateMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[487]); }
const IfcParse::type_declaration& Ifc4::IfcIntegerCountRateMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[487]); }
Ifc4::IfcIntegerCountRateMeasure::IfcIntegerCountRateMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcIntegerCountRateMeasure::IfcIntegerCountRateMeasure(int v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcIntegerCountRateMeasure::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcIonConcentrationMeasure
const IfcParse::type_declaration& Ifc4::IfcIonConcentrationMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[495]); }
const IfcParse::type_declaration& Ifc4::IfcIonConcentrationMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[495]); }
Ifc4::IfcIonConcentrationMeasure::IfcIonConcentrationMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcIonConcentrationMeasure::IfcIonConcentrationMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcIonConcentrationMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcIsothermalMoistureCapacityMeasure
const IfcParse::type_declaration& Ifc4::IfcIsothermalMoistureCapacityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[499]); }
const IfcParse::type_declaration& Ifc4::IfcIsothermalMoistureCapacityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[499]); }
Ifc4::IfcIsothermalMoistureCapacityMeasure::IfcIsothermalMoistureCapacityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcIsothermalMoistureCapacityMeasure::IfcIsothermalMoistureCapacityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcIsothermalMoistureCapacityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcKinematicViscosityMeasure
const IfcParse::type_declaration& Ifc4::IfcKinematicViscosityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[503]); }
const IfcParse::type_declaration& Ifc4::IfcKinematicViscosityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[503]); }
Ifc4::IfcKinematicViscosityMeasure::IfcKinematicViscosityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcKinematicViscosityMeasure::IfcKinematicViscosityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcKinematicViscosityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLabel
const IfcParse::type_declaration& Ifc4::IfcLabel::Class() { return *((IfcParse::type_declaration*)IFC4_types[505]); }
const IfcParse::type_declaration& Ifc4::IfcLabel::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[505]); }
Ifc4::IfcLabel::IfcLabel(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLabel::IfcLabel(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLabel::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLanguageId
const IfcParse::type_declaration& Ifc4::IfcLanguageId::Class() { return *((IfcParse::type_declaration*)IFC4_types[513]); }
const IfcParse::type_declaration& Ifc4::IfcLanguageId::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[513]); }
Ifc4::IfcLanguageId::IfcLanguageId(IfcEntityInstanceData&& e) : IfcIdentifier(std::move(e)) {  }
Ifc4::IfcLanguageId::IfcLanguageId(std::string v) : IfcIdentifier(v) {  }
Ifc4::IfcLanguageId::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLengthMeasure
const IfcParse::type_declaration& Ifc4::IfcLengthMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[516]); }
const IfcParse::type_declaration& Ifc4::IfcLengthMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[516]); }
Ifc4::IfcLengthMeasure::IfcLengthMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLengthMeasure::IfcLengthMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLengthMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLineIndex
const IfcParse::type_declaration& Ifc4::IfcLineIndex::Class() { return *((IfcParse::type_declaration*)IFC4_types[539]); }
const IfcParse::type_declaration& Ifc4::IfcLineIndex::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[539]); }
Ifc4::IfcLineIndex::IfcLineIndex(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLineIndex::IfcLineIndex(std::vector< int > /*[2:?]*/ v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLineIndex::operator std::vector< int > /*[2:?]*/() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLinearForceMeasure
const IfcParse::type_declaration& Ifc4::IfcLinearForceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[535]); }
const IfcParse::type_declaration& Ifc4::IfcLinearForceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[535]); }
Ifc4::IfcLinearForceMeasure::IfcLinearForceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLinearForceMeasure::IfcLinearForceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLinearForceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLinearMomentMeasure
const IfcParse::type_declaration& Ifc4::IfcLinearMomentMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[536]); }
const IfcParse::type_declaration& Ifc4::IfcLinearMomentMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[536]); }
Ifc4::IfcLinearMomentMeasure::IfcLinearMomentMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLinearMomentMeasure::IfcLinearMomentMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLinearMomentMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLinearStiffnessMeasure
const IfcParse::type_declaration& Ifc4::IfcLinearStiffnessMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[537]); }
const IfcParse::type_declaration& Ifc4::IfcLinearStiffnessMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[537]); }
Ifc4::IfcLinearStiffnessMeasure::IfcLinearStiffnessMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLinearStiffnessMeasure::IfcLinearStiffnessMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLinearStiffnessMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLinearVelocityMeasure
const IfcParse::type_declaration& Ifc4::IfcLinearVelocityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[538]); }
const IfcParse::type_declaration& Ifc4::IfcLinearVelocityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[538]); }
Ifc4::IfcLinearVelocityMeasure::IfcLinearVelocityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLinearVelocityMeasure::IfcLinearVelocityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLinearVelocityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLogical
const IfcParse::type_declaration& Ifc4::IfcLogical::Class() { return *((IfcParse::type_declaration*)IFC4_types[542]); }
const IfcParse::type_declaration& Ifc4::IfcLogical::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[542]); }
Ifc4::IfcLogical::IfcLogical(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLogical::IfcLogical(boost::logic::tribool v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLogical::operator boost::logic::tribool() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLuminousFluxMeasure
const IfcParse::type_declaration& Ifc4::IfcLuminousFluxMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[546]); }
const IfcParse::type_declaration& Ifc4::IfcLuminousFluxMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[546]); }
Ifc4::IfcLuminousFluxMeasure::IfcLuminousFluxMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLuminousFluxMeasure::IfcLuminousFluxMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLuminousFluxMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLuminousIntensityDistributionMeasure
const IfcParse::type_declaration& Ifc4::IfcLuminousIntensityDistributionMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[547]); }
const IfcParse::type_declaration& Ifc4::IfcLuminousIntensityDistributionMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[547]); }
Ifc4::IfcLuminousIntensityDistributionMeasure::IfcLuminousIntensityDistributionMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLuminousIntensityDistributionMeasure::IfcLuminousIntensityDistributionMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLuminousIntensityDistributionMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcLuminousIntensityMeasure
const IfcParse::type_declaration& Ifc4::IfcLuminousIntensityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[548]); }
const IfcParse::type_declaration& Ifc4::IfcLuminousIntensityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[548]); }
Ifc4::IfcLuminousIntensityMeasure::IfcLuminousIntensityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcLuminousIntensityMeasure::IfcLuminousIntensityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcLuminousIntensityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMagneticFluxDensityMeasure
const IfcParse::type_declaration& Ifc4::IfcMagneticFluxDensityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[549]); }
const IfcParse::type_declaration& Ifc4::IfcMagneticFluxDensityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[549]); }
Ifc4::IfcMagneticFluxDensityMeasure::IfcMagneticFluxDensityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMagneticFluxDensityMeasure::IfcMagneticFluxDensityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMagneticFluxDensityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMagneticFluxMeasure
const IfcParse::type_declaration& Ifc4::IfcMagneticFluxMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[550]); }
const IfcParse::type_declaration& Ifc4::IfcMagneticFluxMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[550]); }
Ifc4::IfcMagneticFluxMeasure::IfcMagneticFluxMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMagneticFluxMeasure::IfcMagneticFluxMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMagneticFluxMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMassDensityMeasure
const IfcParse::type_declaration& Ifc4::IfcMassDensityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[554]); }
const IfcParse::type_declaration& Ifc4::IfcMassDensityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[554]); }
Ifc4::IfcMassDensityMeasure::IfcMassDensityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMassDensityMeasure::IfcMassDensityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMassDensityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMassFlowRateMeasure
const IfcParse::type_declaration& Ifc4::IfcMassFlowRateMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[555]); }
const IfcParse::type_declaration& Ifc4::IfcMassFlowRateMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[555]); }
Ifc4::IfcMassFlowRateMeasure::IfcMassFlowRateMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMassFlowRateMeasure::IfcMassFlowRateMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMassFlowRateMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMassMeasure
const IfcParse::type_declaration& Ifc4::IfcMassMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[556]); }
const IfcParse::type_declaration& Ifc4::IfcMassMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[556]); }
Ifc4::IfcMassMeasure::IfcMassMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMassMeasure::IfcMassMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMassMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMassPerLengthMeasure
const IfcParse::type_declaration& Ifc4::IfcMassPerLengthMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[557]); }
const IfcParse::type_declaration& Ifc4::IfcMassPerLengthMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[557]); }
Ifc4::IfcMassPerLengthMeasure::IfcMassPerLengthMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMassPerLengthMeasure::IfcMassPerLengthMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMassPerLengthMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcModulusOfElasticityMeasure
const IfcParse::type_declaration& Ifc4::IfcModulusOfElasticityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[593]); }
const IfcParse::type_declaration& Ifc4::IfcModulusOfElasticityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[593]); }
Ifc4::IfcModulusOfElasticityMeasure::IfcModulusOfElasticityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcModulusOfElasticityMeasure::IfcModulusOfElasticityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcModulusOfElasticityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcModulusOfLinearSubgradeReactionMeasure
const IfcParse::type_declaration& Ifc4::IfcModulusOfLinearSubgradeReactionMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[594]); }
const IfcParse::type_declaration& Ifc4::IfcModulusOfLinearSubgradeReactionMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[594]); }
Ifc4::IfcModulusOfLinearSubgradeReactionMeasure::IfcModulusOfLinearSubgradeReactionMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcModulusOfLinearSubgradeReactionMeasure::IfcModulusOfLinearSubgradeReactionMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcModulusOfLinearSubgradeReactionMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcModulusOfRotationalSubgradeReactionMeasure
const IfcParse::type_declaration& Ifc4::IfcModulusOfRotationalSubgradeReactionMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[595]); }
const IfcParse::type_declaration& Ifc4::IfcModulusOfRotationalSubgradeReactionMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[595]); }
Ifc4::IfcModulusOfRotationalSubgradeReactionMeasure::IfcModulusOfRotationalSubgradeReactionMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcModulusOfRotationalSubgradeReactionMeasure::IfcModulusOfRotationalSubgradeReactionMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcModulusOfRotationalSubgradeReactionMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcModulusOfSubgradeReactionMeasure
const IfcParse::type_declaration& Ifc4::IfcModulusOfSubgradeReactionMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[597]); }
const IfcParse::type_declaration& Ifc4::IfcModulusOfSubgradeReactionMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[597]); }
Ifc4::IfcModulusOfSubgradeReactionMeasure::IfcModulusOfSubgradeReactionMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcModulusOfSubgradeReactionMeasure::IfcModulusOfSubgradeReactionMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcModulusOfSubgradeReactionMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMoistureDiffusivityMeasure
const IfcParse::type_declaration& Ifc4::IfcMoistureDiffusivityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[600]); }
const IfcParse::type_declaration& Ifc4::IfcMoistureDiffusivityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[600]); }
Ifc4::IfcMoistureDiffusivityMeasure::IfcMoistureDiffusivityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMoistureDiffusivityMeasure::IfcMoistureDiffusivityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMoistureDiffusivityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMolecularWeightMeasure
const IfcParse::type_declaration& Ifc4::IfcMolecularWeightMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[601]); }
const IfcParse::type_declaration& Ifc4::IfcMolecularWeightMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[601]); }
Ifc4::IfcMolecularWeightMeasure::IfcMolecularWeightMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMolecularWeightMeasure::IfcMolecularWeightMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMolecularWeightMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMomentOfInertiaMeasure
const IfcParse::type_declaration& Ifc4::IfcMomentOfInertiaMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[602]); }
const IfcParse::type_declaration& Ifc4::IfcMomentOfInertiaMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[602]); }
Ifc4::IfcMomentOfInertiaMeasure::IfcMomentOfInertiaMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMomentOfInertiaMeasure::IfcMomentOfInertiaMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMomentOfInertiaMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMonetaryMeasure
const IfcParse::type_declaration& Ifc4::IfcMonetaryMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[603]); }
const IfcParse::type_declaration& Ifc4::IfcMonetaryMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[603]); }
Ifc4::IfcMonetaryMeasure::IfcMonetaryMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMonetaryMeasure::IfcMonetaryMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMonetaryMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcMonthInYearNumber
const IfcParse::type_declaration& Ifc4::IfcMonthInYearNumber::Class() { return *((IfcParse::type_declaration*)IFC4_types[605]); }
const IfcParse::type_declaration& Ifc4::IfcMonthInYearNumber::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[605]); }
Ifc4::IfcMonthInYearNumber::IfcMonthInYearNumber(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcMonthInYearNumber::IfcMonthInYearNumber(int v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcMonthInYearNumber::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcNonNegativeLengthMeasure
const IfcParse::type_declaration& Ifc4::IfcNonNegativeLengthMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[610]); }
const IfcParse::type_declaration& Ifc4::IfcNonNegativeLengthMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[610]); }
Ifc4::IfcNonNegativeLengthMeasure::IfcNonNegativeLengthMeasure(IfcEntityInstanceData&& e) : IfcLengthMeasure(std::move(e)) {  }
Ifc4::IfcNonNegativeLengthMeasure::IfcNonNegativeLengthMeasure(double v) : IfcLengthMeasure(v) {  }
Ifc4::IfcNonNegativeLengthMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcNormalisedRatioMeasure
const IfcParse::type_declaration& Ifc4::IfcNormalisedRatioMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[611]); }
const IfcParse::type_declaration& Ifc4::IfcNormalisedRatioMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[611]); }
Ifc4::IfcNormalisedRatioMeasure::IfcNormalisedRatioMeasure(IfcEntityInstanceData&& e) : IfcRatioMeasure(std::move(e)) {  }
Ifc4::IfcNormalisedRatioMeasure::IfcNormalisedRatioMeasure(double v) : IfcRatioMeasure(v) {  }
Ifc4::IfcNormalisedRatioMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcNumericMeasure
const IfcParse::type_declaration& Ifc4::IfcNumericMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[613]); }
const IfcParse::type_declaration& Ifc4::IfcNumericMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[613]); }
Ifc4::IfcNumericMeasure::IfcNumericMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcNumericMeasure::IfcNumericMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcNumericMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPHMeasure
const IfcParse::type_declaration& Ifc4::IfcPHMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[649]); }
const IfcParse::type_declaration& Ifc4::IfcPHMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[649]); }
Ifc4::IfcPHMeasure::IfcPHMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcPHMeasure::IfcPHMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcPHMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcParameterValue
const IfcParse::type_declaration& Ifc4::IfcParameterValue::Class() { return *((IfcParse::type_declaration*)IFC4_types[638]); }
const IfcParse::type_declaration& Ifc4::IfcParameterValue::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[638]); }
Ifc4::IfcParameterValue::IfcParameterValue(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcParameterValue::IfcParameterValue(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcParameterValue::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPlanarForceMeasure
const IfcParse::type_declaration& Ifc4::IfcPlanarForceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[668]); }
const IfcParse::type_declaration& Ifc4::IfcPlanarForceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[668]); }
Ifc4::IfcPlanarForceMeasure::IfcPlanarForceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcPlanarForceMeasure::IfcPlanarForceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcPlanarForceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPlaneAngleMeasure
const IfcParse::type_declaration& Ifc4::IfcPlaneAngleMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[670]); }
const IfcParse::type_declaration& Ifc4::IfcPlaneAngleMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[670]); }
Ifc4::IfcPlaneAngleMeasure::IfcPlaneAngleMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcPlaneAngleMeasure::IfcPlaneAngleMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcPlaneAngleMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPositiveInteger
const IfcParse::type_declaration& Ifc4::IfcPositiveInteger::Class() { return *((IfcParse::type_declaration*)IFC4_types[684]); }
const IfcParse::type_declaration& Ifc4::IfcPositiveInteger::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[684]); }
Ifc4::IfcPositiveInteger::IfcPositiveInteger(IfcEntityInstanceData&& e) : IfcInteger(std::move(e)) {  }
Ifc4::IfcPositiveInteger::IfcPositiveInteger(int v) : IfcInteger(v) {  }
Ifc4::IfcPositiveInteger::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPositiveLengthMeasure
const IfcParse::type_declaration& Ifc4::IfcPositiveLengthMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[685]); }
const IfcParse::type_declaration& Ifc4::IfcPositiveLengthMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[685]); }
Ifc4::IfcPositiveLengthMeasure::IfcPositiveLengthMeasure(IfcEntityInstanceData&& e) : IfcLengthMeasure(std::move(e)) {  }
Ifc4::IfcPositiveLengthMeasure::IfcPositiveLengthMeasure(double v) : IfcLengthMeasure(v) {  }
Ifc4::IfcPositiveLengthMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPositivePlaneAngleMeasure
const IfcParse::type_declaration& Ifc4::IfcPositivePlaneAngleMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[686]); }
const IfcParse::type_declaration& Ifc4::IfcPositivePlaneAngleMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[686]); }
Ifc4::IfcPositivePlaneAngleMeasure::IfcPositivePlaneAngleMeasure(IfcEntityInstanceData&& e) : IfcPlaneAngleMeasure(std::move(e)) {  }
Ifc4::IfcPositivePlaneAngleMeasure::IfcPositivePlaneAngleMeasure(double v) : IfcPlaneAngleMeasure(v) {  }
Ifc4::IfcPositivePlaneAngleMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPositiveRatioMeasure
const IfcParse::type_declaration& Ifc4::IfcPositiveRatioMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[687]); }
const IfcParse::type_declaration& Ifc4::IfcPositiveRatioMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[687]); }
Ifc4::IfcPositiveRatioMeasure::IfcPositiveRatioMeasure(IfcEntityInstanceData&& e) : IfcRatioMeasure(std::move(e)) {  }
Ifc4::IfcPositiveRatioMeasure::IfcPositiveRatioMeasure(double v) : IfcRatioMeasure(v) {  }
Ifc4::IfcPositiveRatioMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPowerMeasure
const IfcParse::type_declaration& Ifc4::IfcPowerMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[689]); }
const IfcParse::type_declaration& Ifc4::IfcPowerMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[689]); }
Ifc4::IfcPowerMeasure::IfcPowerMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcPowerMeasure::IfcPowerMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcPowerMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPresentableText
const IfcParse::type_declaration& Ifc4::IfcPresentableText::Class() { return *((IfcParse::type_declaration*)IFC4_types[697]); }
const IfcParse::type_declaration& Ifc4::IfcPresentableText::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[697]); }
Ifc4::IfcPresentableText::IfcPresentableText(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcPresentableText::IfcPresentableText(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcPresentableText::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPressureMeasure
const IfcParse::type_declaration& Ifc4::IfcPressureMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[704]); }
const IfcParse::type_declaration& Ifc4::IfcPressureMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[704]); }
Ifc4::IfcPressureMeasure::IfcPressureMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcPressureMeasure::IfcPressureMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcPressureMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcPropertySetDefinitionSet
const IfcParse::type_declaration& Ifc4::IfcPropertySetDefinitionSet::Class() { return *((IfcParse::type_declaration*)IFC4_types[738]); }
const IfcParse::type_declaration& Ifc4::IfcPropertySetDefinitionSet::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[738]); }
Ifc4::IfcPropertySetDefinitionSet::IfcPropertySetDefinitionSet(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcPropertySetDefinitionSet::IfcPropertySetDefinitionSet(aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v->generalize()); }
Ifc4::IfcPropertySetDefinitionSet::operator aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr() const { aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcPropertySetDefinition >(); }

// Function implementations for IfcRadioActivityMeasure
const IfcParse::type_declaration& Ifc4::IfcRadioActivityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[762]); }
const IfcParse::type_declaration& Ifc4::IfcRadioActivityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[762]); }
Ifc4::IfcRadioActivityMeasure::IfcRadioActivityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcRadioActivityMeasure::IfcRadioActivityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcRadioActivityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcRatioMeasure
const IfcParse::type_declaration& Ifc4::IfcRatioMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[772]); }
const IfcParse::type_declaration& Ifc4::IfcRatioMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[772]); }
Ifc4::IfcRatioMeasure::IfcRatioMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcRatioMeasure::IfcRatioMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcRatioMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcReal
const IfcParse::type_declaration& Ifc4::IfcReal::Class() { return *((IfcParse::type_declaration*)IFC4_types[775]); }
const IfcParse::type_declaration& Ifc4::IfcReal::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[775]); }
Ifc4::IfcReal::IfcReal(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcReal::IfcReal(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcReal::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcRotationalFrequencyMeasure
const IfcParse::type_declaration& Ifc4::IfcRotationalFrequencyMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[866]); }
const IfcParse::type_declaration& Ifc4::IfcRotationalFrequencyMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[866]); }
Ifc4::IfcRotationalFrequencyMeasure::IfcRotationalFrequencyMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcRotationalFrequencyMeasure::IfcRotationalFrequencyMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcRotationalFrequencyMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcRotationalMassMeasure
const IfcParse::type_declaration& Ifc4::IfcRotationalMassMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[867]); }
const IfcParse::type_declaration& Ifc4::IfcRotationalMassMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[867]); }
Ifc4::IfcRotationalMassMeasure::IfcRotationalMassMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcRotationalMassMeasure::IfcRotationalMassMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcRotationalMassMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcRotationalStiffnessMeasure
const IfcParse::type_declaration& Ifc4::IfcRotationalStiffnessMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[868]); }
const IfcParse::type_declaration& Ifc4::IfcRotationalStiffnessMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[868]); }
Ifc4::IfcRotationalStiffnessMeasure::IfcRotationalStiffnessMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcRotationalStiffnessMeasure::IfcRotationalStiffnessMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcRotationalStiffnessMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSectionModulusMeasure
const IfcParse::type_declaration& Ifc4::IfcSectionModulusMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[878]); }
const IfcParse::type_declaration& Ifc4::IfcSectionModulusMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[878]); }
Ifc4::IfcSectionModulusMeasure::IfcSectionModulusMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSectionModulusMeasure::IfcSectionModulusMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSectionModulusMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSectionalAreaIntegralMeasure
const IfcParse::type_declaration& Ifc4::IfcSectionalAreaIntegralMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[876]); }
const IfcParse::type_declaration& Ifc4::IfcSectionalAreaIntegralMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[876]); }
Ifc4::IfcSectionalAreaIntegralMeasure::IfcSectionalAreaIntegralMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSectionalAreaIntegralMeasure::IfcSectionalAreaIntegralMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSectionalAreaIntegralMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcShearModulusMeasure
const IfcParse::type_declaration& Ifc4::IfcShearModulusMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[893]); }
const IfcParse::type_declaration& Ifc4::IfcShearModulusMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[893]); }
Ifc4::IfcShearModulusMeasure::IfcShearModulusMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcShearModulusMeasure::IfcShearModulusMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcShearModulusMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSolidAngleMeasure
const IfcParse::type_declaration& Ifc4::IfcSolidAngleMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[914]); }
const IfcParse::type_declaration& Ifc4::IfcSolidAngleMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[914]); }
Ifc4::IfcSolidAngleMeasure::IfcSolidAngleMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSolidAngleMeasure::IfcSolidAngleMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSolidAngleMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSoundPowerLevelMeasure
const IfcParse::type_declaration& Ifc4::IfcSoundPowerLevelMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[917]); }
const IfcParse::type_declaration& Ifc4::IfcSoundPowerLevelMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[917]); }
Ifc4::IfcSoundPowerLevelMeasure::IfcSoundPowerLevelMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSoundPowerLevelMeasure::IfcSoundPowerLevelMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSoundPowerLevelMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSoundPowerMeasure
const IfcParse::type_declaration& Ifc4::IfcSoundPowerMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[918]); }
const IfcParse::type_declaration& Ifc4::IfcSoundPowerMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[918]); }
Ifc4::IfcSoundPowerMeasure::IfcSoundPowerMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSoundPowerMeasure::IfcSoundPowerMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSoundPowerMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSoundPressureLevelMeasure
const IfcParse::type_declaration& Ifc4::IfcSoundPressureLevelMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[919]); }
const IfcParse::type_declaration& Ifc4::IfcSoundPressureLevelMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[919]); }
Ifc4::IfcSoundPressureLevelMeasure::IfcSoundPressureLevelMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSoundPressureLevelMeasure::IfcSoundPressureLevelMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSoundPressureLevelMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSoundPressureMeasure
const IfcParse::type_declaration& Ifc4::IfcSoundPressureMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[920]); }
const IfcParse::type_declaration& Ifc4::IfcSoundPressureMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[920]); }
Ifc4::IfcSoundPressureMeasure::IfcSoundPressureMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSoundPressureMeasure::IfcSoundPressureMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSoundPressureMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSpecificHeatCapacityMeasure
const IfcParse::type_declaration& Ifc4::IfcSpecificHeatCapacityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[935]); }
const IfcParse::type_declaration& Ifc4::IfcSpecificHeatCapacityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[935]); }
Ifc4::IfcSpecificHeatCapacityMeasure::IfcSpecificHeatCapacityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSpecificHeatCapacityMeasure::IfcSpecificHeatCapacityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSpecificHeatCapacityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSpecularExponent
const IfcParse::type_declaration& Ifc4::IfcSpecularExponent::Class() { return *((IfcParse::type_declaration*)IFC4_types[936]); }
const IfcParse::type_declaration& Ifc4::IfcSpecularExponent::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[936]); }
Ifc4::IfcSpecularExponent::IfcSpecularExponent(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSpecularExponent::IfcSpecularExponent(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSpecularExponent::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcSpecularRoughness
const IfcParse::type_declaration& Ifc4::IfcSpecularRoughness::Class() { return *((IfcParse::type_declaration*)IFC4_types[938]); }
const IfcParse::type_declaration& Ifc4::IfcSpecularRoughness::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[938]); }
Ifc4::IfcSpecularRoughness::IfcSpecularRoughness(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcSpecularRoughness::IfcSpecularRoughness(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcSpecularRoughness::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTemperatureGradientMeasure
const IfcParse::type_declaration& Ifc4::IfcTemperatureGradientMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1043]); }
const IfcParse::type_declaration& Ifc4::IfcTemperatureGradientMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1043]); }
Ifc4::IfcTemperatureGradientMeasure::IfcTemperatureGradientMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTemperatureGradientMeasure::IfcTemperatureGradientMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTemperatureGradientMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTemperatureRateOfChangeMeasure
const IfcParse::type_declaration& Ifc4::IfcTemperatureRateOfChangeMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1044]); }
const IfcParse::type_declaration& Ifc4::IfcTemperatureRateOfChangeMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1044]); }
Ifc4::IfcTemperatureRateOfChangeMeasure::IfcTemperatureRateOfChangeMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTemperatureRateOfChangeMeasure::IfcTemperatureRateOfChangeMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTemperatureRateOfChangeMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcText
const IfcParse::type_declaration& Ifc4::IfcText::Class() { return *((IfcParse::type_declaration*)IFC4_types[1053]); }
const IfcParse::type_declaration& Ifc4::IfcText::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1053]); }
Ifc4::IfcText::IfcText(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcText::IfcText(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcText::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTextAlignment
const IfcParse::type_declaration& Ifc4::IfcTextAlignment::Class() { return *((IfcParse::type_declaration*)IFC4_types[1054]); }
const IfcParse::type_declaration& Ifc4::IfcTextAlignment::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1054]); }
Ifc4::IfcTextAlignment::IfcTextAlignment(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTextAlignment::IfcTextAlignment(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTextAlignment::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTextDecoration
const IfcParse::type_declaration& Ifc4::IfcTextDecoration::Class() { return *((IfcParse::type_declaration*)IFC4_types[1055]); }
const IfcParse::type_declaration& Ifc4::IfcTextDecoration::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1055]); }
Ifc4::IfcTextDecoration::IfcTextDecoration(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTextDecoration::IfcTextDecoration(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTextDecoration::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTextFontName
const IfcParse::type_declaration& Ifc4::IfcTextFontName::Class() { return *((IfcParse::type_declaration*)IFC4_types[1056]); }
const IfcParse::type_declaration& Ifc4::IfcTextFontName::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1056]); }
Ifc4::IfcTextFontName::IfcTextFontName(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTextFontName::IfcTextFontName(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTextFontName::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTextTransformation
const IfcParse::type_declaration& Ifc4::IfcTextTransformation::Class() { return *((IfcParse::type_declaration*)IFC4_types[1065]); }
const IfcParse::type_declaration& Ifc4::IfcTextTransformation::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1065]); }
Ifc4::IfcTextTransformation::IfcTextTransformation(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTextTransformation::IfcTextTransformation(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTextTransformation::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcThermalAdmittanceMeasure
const IfcParse::type_declaration& Ifc4::IfcThermalAdmittanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1071]); }
const IfcParse::type_declaration& Ifc4::IfcThermalAdmittanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1071]); }
Ifc4::IfcThermalAdmittanceMeasure::IfcThermalAdmittanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcThermalAdmittanceMeasure::IfcThermalAdmittanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcThermalAdmittanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcThermalConductivityMeasure
const IfcParse::type_declaration& Ifc4::IfcThermalConductivityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1072]); }
const IfcParse::type_declaration& Ifc4::IfcThermalConductivityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1072]); }
Ifc4::IfcThermalConductivityMeasure::IfcThermalConductivityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcThermalConductivityMeasure::IfcThermalConductivityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcThermalConductivityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcThermalExpansionCoefficientMeasure
const IfcParse::type_declaration& Ifc4::IfcThermalExpansionCoefficientMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1073]); }
const IfcParse::type_declaration& Ifc4::IfcThermalExpansionCoefficientMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1073]); }
Ifc4::IfcThermalExpansionCoefficientMeasure::IfcThermalExpansionCoefficientMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcThermalExpansionCoefficientMeasure::IfcThermalExpansionCoefficientMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcThermalExpansionCoefficientMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcThermalResistanceMeasure
const IfcParse::type_declaration& Ifc4::IfcThermalResistanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1074]); }
const IfcParse::type_declaration& Ifc4::IfcThermalResistanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1074]); }
Ifc4::IfcThermalResistanceMeasure::IfcThermalResistanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcThermalResistanceMeasure::IfcThermalResistanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcThermalResistanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcThermalTransmittanceMeasure
const IfcParse::type_declaration& Ifc4::IfcThermalTransmittanceMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1075]); }
const IfcParse::type_declaration& Ifc4::IfcThermalTransmittanceMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1075]); }
Ifc4::IfcThermalTransmittanceMeasure::IfcThermalTransmittanceMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcThermalTransmittanceMeasure::IfcThermalTransmittanceMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcThermalTransmittanceMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcThermodynamicTemperatureMeasure
const IfcParse::type_declaration& Ifc4::IfcThermodynamicTemperatureMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1076]); }
const IfcParse::type_declaration& Ifc4::IfcThermodynamicTemperatureMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1076]); }
Ifc4::IfcThermodynamicTemperatureMeasure::IfcThermodynamicTemperatureMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcThermodynamicTemperatureMeasure::IfcThermodynamicTemperatureMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcThermodynamicTemperatureMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTime
const IfcParse::type_declaration& Ifc4::IfcTime::Class() { return *((IfcParse::type_declaration*)IFC4_types[1077]); }
const IfcParse::type_declaration& Ifc4::IfcTime::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1077]); }
Ifc4::IfcTime::IfcTime(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTime::IfcTime(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTime::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTimeMeasure
const IfcParse::type_declaration& Ifc4::IfcTimeMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1078]); }
const IfcParse::type_declaration& Ifc4::IfcTimeMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1078]); }
Ifc4::IfcTimeMeasure::IfcTimeMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTimeMeasure::IfcTimeMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTimeMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTimeStamp
const IfcParse::type_declaration& Ifc4::IfcTimeStamp::Class() { return *((IfcParse::type_declaration*)IFC4_types[1084]); }
const IfcParse::type_declaration& Ifc4::IfcTimeStamp::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1084]); }
Ifc4::IfcTimeStamp::IfcTimeStamp(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTimeStamp::IfcTimeStamp(int v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTimeStamp::operator int() const { return data_.get_attribute_value(0); }

// Function implementations for IfcTorqueMeasure
const IfcParse::type_declaration& Ifc4::IfcTorqueMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1088]); }
const IfcParse::type_declaration& Ifc4::IfcTorqueMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1088]); }
Ifc4::IfcTorqueMeasure::IfcTorqueMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcTorqueMeasure::IfcTorqueMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcTorqueMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcURIReference
const IfcParse::type_declaration& Ifc4::IfcURIReference::Class() { return *((IfcParse::type_declaration*)IFC4_types[1119]); }
const IfcParse::type_declaration& Ifc4::IfcURIReference::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1119]); }
Ifc4::IfcURIReference::IfcURIReference(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcURIReference::IfcURIReference(std::string v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcURIReference::operator std::string() const { return data_.get_attribute_value(0); }

// Function implementations for IfcVaporPermeabilityMeasure
const IfcParse::type_declaration& Ifc4::IfcVaporPermeabilityMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1125]); }
const IfcParse::type_declaration& Ifc4::IfcVaporPermeabilityMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1125]); }
Ifc4::IfcVaporPermeabilityMeasure::IfcVaporPermeabilityMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcVaporPermeabilityMeasure::IfcVaporPermeabilityMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcVaporPermeabilityMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcVolumeMeasure
const IfcParse::type_declaration& Ifc4::IfcVolumeMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1138]); }
const IfcParse::type_declaration& Ifc4::IfcVolumeMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1138]); }
Ifc4::IfcVolumeMeasure::IfcVolumeMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcVolumeMeasure::IfcVolumeMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcVolumeMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcVolumetricFlowRateMeasure
const IfcParse::type_declaration& Ifc4::IfcVolumetricFlowRateMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1139]); }
const IfcParse::type_declaration& Ifc4::IfcVolumetricFlowRateMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1139]); }
Ifc4::IfcVolumetricFlowRateMeasure::IfcVolumetricFlowRateMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcVolumetricFlowRateMeasure::IfcVolumetricFlowRateMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcVolumetricFlowRateMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcWarpingConstantMeasure
const IfcParse::type_declaration& Ifc4::IfcWarpingConstantMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1145]); }
const IfcParse::type_declaration& Ifc4::IfcWarpingConstantMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1145]); }
Ifc4::IfcWarpingConstantMeasure::IfcWarpingConstantMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcWarpingConstantMeasure::IfcWarpingConstantMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcWarpingConstantMeasure::operator double() const { return data_.get_attribute_value(0); }

// Function implementations for IfcWarpingMomentMeasure
const IfcParse::type_declaration& Ifc4::IfcWarpingMomentMeasure::Class() { return *((IfcParse::type_declaration*)IFC4_types[1146]); }
const IfcParse::type_declaration& Ifc4::IfcWarpingMomentMeasure::declaration() const { return *((IfcParse::type_declaration*)IFC4_types[1146]); }
Ifc4::IfcWarpingMomentMeasure::IfcWarpingMomentMeasure(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseType(std::move(e)) {  }
Ifc4::IfcWarpingMomentMeasure::IfcWarpingMomentMeasure(double v) : IfcUtil::IfcBaseType() { set_attribute_value(0, v); }
Ifc4::IfcWarpingMomentMeasure::operator double() const { return data_.get_attribute_value(0); }


// Function implementations for IfcActionRequest
boost::optional< ::Ifc4::IfcActionRequestTypeEnum::Value > Ifc4::IfcActionRequest::PredefinedType() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } return ::Ifc4::IfcActionRequestTypeEnum::FromString(data_.get_attribute_value(6)); }
void Ifc4::IfcActionRequest::setPredefinedType(boost::optional< ::Ifc4::IfcActionRequestTypeEnum::Value > v) { if (v) {set_attribute_value(6, EnumerationReference(&::Ifc4::IfcActionRequestTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcActionRequest::Status() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcActionRequest::setStatus(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcActionRequest::LongDescription() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcActionRequest::setLongDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcActionRequest::declaration() const { return *((IfcParse::entity*)IFC4_types[2]); }
const IfcParse::entity& Ifc4::IfcActionRequest::Class() { return *((IfcParse::entity*)IFC4_types[2]); }
Ifc4::IfcActionRequest::IfcActionRequest(IfcEntityInstanceData&& e) : IfcControl(std::move(e)) { }
Ifc4::IfcActionRequest::IfcActionRequest(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< ::Ifc4::IfcActionRequestTypeEnum::Value > v7_PredefinedType, boost::optional< std::string > v8_Status, boost::optional< std::string > v9_LongDescription) : IfcControl(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_PredefinedType) {set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcActionRequestTypeEnum::Class(),(size_t)*v7_PredefinedType))); } if (v8_Status) {set_attribute_value(7, (*v8_Status)); } if (v9_LongDescription) {set_attribute_value(8, (*v9_LongDescription)); }; populate_derived(); }

// Function implementations for IfcActor
::Ifc4::IfcActorSelect* Ifc4::IfcActor::TheActor() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcActor::setTheActor(::Ifc4::IfcActorSelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }

::Ifc4::IfcRelAssignsToActor::list::ptr Ifc4::IfcActor::IsActingUpon() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[799], 6)->as<IfcRelAssignsToActor>(); }

const IfcParse::entity& Ifc4::IfcActor::declaration() const { return *((IfcParse::entity*)IFC4_types[6]); }
const IfcParse::entity& Ifc4::IfcActor::Class() { return *((IfcParse::entity*)IFC4_types[6]); }
Ifc4::IfcActor::IfcActor(IfcEntityInstanceData&& e) : IfcObject(std::move(e)) { }
Ifc4::IfcActor::IfcActor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcActorSelect* v6_TheActor) : IfcObject(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_TheActor ? v6_TheActor->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcActorRole
::Ifc4::IfcRoleEnum::Value Ifc4::IfcActorRole::Role() const {  return ::Ifc4::IfcRoleEnum::FromString(data_.get_attribute_value(0)); }
void Ifc4::IfcActorRole::setRole(::Ifc4::IfcRoleEnum::Value v) { set_attribute_value(0, EnumerationReference(&::Ifc4::IfcRoleEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcActorRole::UserDefinedRole() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcActorRole::setUserDefinedRole(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcActorRole::Description() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcActorRole::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcActorRole::HasExternalReference() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }

const IfcParse::entity& Ifc4::IfcActorRole::declaration() const { return *((IfcParse::entity*)IFC4_types[7]); }
const IfcParse::entity& Ifc4::IfcActorRole::Class() { return *((IfcParse::entity*)IFC4_types[7]); }
Ifc4::IfcActorRole::IfcActorRole(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcActorRole::IfcActorRole(::Ifc4::IfcRoleEnum::Value v1_Role, boost::optional< std::string > v2_UserDefinedRole, boost::optional< std::string > v3_Description) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcRoleEnum::Class(),(size_t)v1_Role))); if (v2_UserDefinedRole) {set_attribute_value(1, (*v2_UserDefinedRole)); } if (v3_Description) {set_attribute_value(2, (*v3_Description)); }; populate_derived(); }

// Function implementations for IfcActuator
boost::optional< ::Ifc4::IfcActuatorTypeEnum::Value > Ifc4::IfcActuator::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcActuatorTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcActuator::setPredefinedType(boost::optional< ::Ifc4::IfcActuatorTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcActuatorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcActuator::declaration() const { return *((IfcParse::entity*)IFC4_types[9]); }
const IfcParse::entity& Ifc4::IfcActuator::Class() { return *((IfcParse::entity*)IFC4_types[9]); }
Ifc4::IfcActuator::IfcActuator(IfcEntityInstanceData&& e) : IfcDistributionControlElement(std::move(e)) { }
Ifc4::IfcActuator::IfcActuator(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcActuatorTypeEnum::Value > v9_PredefinedType) : IfcDistributionControlElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcActuatorTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcActuatorType
::Ifc4::IfcActuatorTypeEnum::Value Ifc4::IfcActuatorType::PredefinedType() const {  return ::Ifc4::IfcActuatorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcActuatorType::setPredefinedType(::Ifc4::IfcActuatorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcActuatorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcActuatorType::declaration() const { return *((IfcParse::entity*)IFC4_types[10]); }
const IfcParse::entity& Ifc4::IfcActuatorType::Class() { return *((IfcParse::entity*)IFC4_types[10]); }
Ifc4::IfcActuatorType::IfcActuatorType(IfcEntityInstanceData&& e) : IfcDistributionControlElementType(std::move(e)) { }
Ifc4::IfcActuatorType::IfcActuatorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcActuatorTypeEnum::Value v10_PredefinedType) : IfcDistributionControlElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcActuatorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcAddress
boost::optional< ::Ifc4::IfcAddressTypeEnum::Value > Ifc4::IfcAddress::Purpose() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } return ::Ifc4::IfcAddressTypeEnum::FromString(data_.get_attribute_value(0)); }
void Ifc4::IfcAddress::setPurpose(boost::optional< ::Ifc4::IfcAddressTypeEnum::Value > v) { if (v) {set_attribute_value(0, EnumerationReference(&::Ifc4::IfcAddressTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcAddress::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcAddress::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcAddress::UserDefinedPurpose() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcAddress::setUserDefinedPurpose(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }

::Ifc4::IfcPerson::list::ptr Ifc4::IfcAddress::OfPerson() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[647], 7)->as<IfcPerson>(); }
::Ifc4::IfcOrganization::list::ptr Ifc4::IfcAddress::OfOrganization() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[629], 4)->as<IfcOrganization>(); }

const IfcParse::entity& Ifc4::IfcAddress::declaration() const { return *((IfcParse::entity*)IFC4_types[12]); }
const IfcParse::entity& Ifc4::IfcAddress::Class() { return *((IfcParse::entity*)IFC4_types[12]); }
Ifc4::IfcAddress::IfcAddress(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcAddress::IfcAddress(boost::optional< ::Ifc4::IfcAddressTypeEnum::Value > v1_Purpose, boost::optional< std::string > v2_Description, boost::optional< std::string > v3_UserDefinedPurpose) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) {  if (v1_Purpose) {set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcAddressTypeEnum::Class(),(size_t)*v1_Purpose))); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_UserDefinedPurpose) {set_attribute_value(2, (*v3_UserDefinedPurpose)); }; populate_derived(); }

// Function implementations for IfcAdvancedBrep


const IfcParse::entity& Ifc4::IfcAdvancedBrep::declaration() const { return *((IfcParse::entity*)IFC4_types[14]); }
const IfcParse::entity& Ifc4::IfcAdvancedBrep::Class() { return *((IfcParse::entity*)IFC4_types[14]); }
Ifc4::IfcAdvancedBrep::IfcAdvancedBrep(IfcEntityInstanceData&& e) : IfcManifoldSolidBrep(std::move(e)) { }
Ifc4::IfcAdvancedBrep::IfcAdvancedBrep(::Ifc4::IfcClosedShell* v1_Outer) : IfcManifoldSolidBrep(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Outer ? v1_Outer->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcAdvancedBrepWithVoids
aggregate_of< ::Ifc4::IfcClosedShell >::ptr Ifc4::IfcAdvancedBrepWithVoids::Voids() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcClosedShell >(); }
void Ifc4::IfcAdvancedBrepWithVoids::setVoids(aggregate_of< ::Ifc4::IfcClosedShell >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcAdvancedBrepWithVoids::declaration() const { return *((IfcParse::entity*)IFC4_types[15]); }
const IfcParse::entity& Ifc4::IfcAdvancedBrepWithVoids::Class() { return *((IfcParse::entity*)IFC4_types[15]); }
Ifc4::IfcAdvancedBrepWithVoids::IfcAdvancedBrepWithVoids(IfcEntityInstanceData&& e) : IfcAdvancedBrep(std::move(e)) { }
Ifc4::IfcAdvancedBrepWithVoids::IfcAdvancedBrepWithVoids(::Ifc4::IfcClosedShell* v1_Outer, aggregate_of< ::Ifc4::IfcClosedShell >::ptr v2_Voids) : IfcAdvancedBrep(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Outer ? v1_Outer->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Voids)->generalize());; populate_derived(); }

// Function implementations for IfcAdvancedFace


const IfcParse::entity& Ifc4::IfcAdvancedFace::declaration() const { return *((IfcParse::entity*)IFC4_types[16]); }
const IfcParse::entity& Ifc4::IfcAdvancedFace::Class() { return *((IfcParse::entity*)IFC4_types[16]); }
Ifc4::IfcAdvancedFace::IfcAdvancedFace(IfcEntityInstanceData&& e) : IfcFaceSurface(std::move(e)) { }
Ifc4::IfcAdvancedFace::IfcAdvancedFace(aggregate_of< ::Ifc4::IfcFaceBound >::ptr v1_Bounds, ::Ifc4::IfcSurface* v2_FaceSurface, bool v3_SameSense) : IfcFaceSurface(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Bounds)->generalize());set_attribute_value(1, v2_FaceSurface ? v2_FaceSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, (v3_SameSense));; populate_derived(); }

// Function implementations for IfcAirTerminal
boost::optional< ::Ifc4::IfcAirTerminalTypeEnum::Value > Ifc4::IfcAirTerminal::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcAirTerminalTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcAirTerminal::setPredefinedType(boost::optional< ::Ifc4::IfcAirTerminalTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcAirTerminalTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcAirTerminal::declaration() const { return *((IfcParse::entity*)IFC4_types[17]); }
const IfcParse::entity& Ifc4::IfcAirTerminal::Class() { return *((IfcParse::entity*)IFC4_types[17]); }
Ifc4::IfcAirTerminal::IfcAirTerminal(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcAirTerminal::IfcAirTerminal(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcAirTerminalTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcAirTerminalTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcAirTerminalBox
boost::optional< ::Ifc4::IfcAirTerminalBoxTypeEnum::Value > Ifc4::IfcAirTerminalBox::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcAirTerminalBoxTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcAirTerminalBox::setPredefinedType(boost::optional< ::Ifc4::IfcAirTerminalBoxTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcAirTerminalBoxTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcAirTerminalBox::declaration() const { return *((IfcParse::entity*)IFC4_types[18]); }
const IfcParse::entity& Ifc4::IfcAirTerminalBox::Class() { return *((IfcParse::entity*)IFC4_types[18]); }
Ifc4::IfcAirTerminalBox::IfcAirTerminalBox(IfcEntityInstanceData&& e) : IfcFlowController(std::move(e)) { }
Ifc4::IfcAirTerminalBox::IfcAirTerminalBox(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcAirTerminalBoxTypeEnum::Value > v9_PredefinedType) : IfcFlowController(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcAirTerminalBoxTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcAirTerminalBoxType
::Ifc4::IfcAirTerminalBoxTypeEnum::Value Ifc4::IfcAirTerminalBoxType::PredefinedType() const {  return ::Ifc4::IfcAirTerminalBoxTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcAirTerminalBoxType::setPredefinedType(::Ifc4::IfcAirTerminalBoxTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcAirTerminalBoxTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcAirTerminalBoxType::declaration() const { return *((IfcParse::entity*)IFC4_types[19]); }
const IfcParse::entity& Ifc4::IfcAirTerminalBoxType::Class() { return *((IfcParse::entity*)IFC4_types[19]); }
Ifc4::IfcAirTerminalBoxType::IfcAirTerminalBoxType(IfcEntityInstanceData&& e) : IfcFlowControllerType(std::move(e)) { }
Ifc4::IfcAirTerminalBoxType::IfcAirTerminalBoxType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcAirTerminalBoxTypeEnum::Value v10_PredefinedType) : IfcFlowControllerType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcAirTerminalBoxTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcAirTerminalType
::Ifc4::IfcAirTerminalTypeEnum::Value Ifc4::IfcAirTerminalType::PredefinedType() const {  return ::Ifc4::IfcAirTerminalTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcAirTerminalType::setPredefinedType(::Ifc4::IfcAirTerminalTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcAirTerminalTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcAirTerminalType::declaration() const { return *((IfcParse::entity*)IFC4_types[21]); }
const IfcParse::entity& Ifc4::IfcAirTerminalType::Class() { return *((IfcParse::entity*)IFC4_types[21]); }
Ifc4::IfcAirTerminalType::IfcAirTerminalType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcAirTerminalType::IfcAirTerminalType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcAirTerminalTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcAirTerminalTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcAirToAirHeatRecovery
boost::optional< ::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value > Ifc4::IfcAirToAirHeatRecovery::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcAirToAirHeatRecovery::setPredefinedType(boost::optional< ::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcAirToAirHeatRecovery::declaration() const { return *((IfcParse::entity*)IFC4_types[23]); }
const IfcParse::entity& Ifc4::IfcAirToAirHeatRecovery::Class() { return *((IfcParse::entity*)IFC4_types[23]); }
Ifc4::IfcAirToAirHeatRecovery::IfcAirToAirHeatRecovery(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcAirToAirHeatRecovery::IfcAirToAirHeatRecovery(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcAirToAirHeatRecoveryType
::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value Ifc4::IfcAirToAirHeatRecoveryType::PredefinedType() const {  return ::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcAirToAirHeatRecoveryType::setPredefinedType(::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcAirToAirHeatRecoveryType::declaration() const { return *((IfcParse::entity*)IFC4_types[24]); }
const IfcParse::entity& Ifc4::IfcAirToAirHeatRecoveryType::Class() { return *((IfcParse::entity*)IFC4_types[24]); }
Ifc4::IfcAirToAirHeatRecoveryType::IfcAirToAirHeatRecoveryType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcAirToAirHeatRecoveryType::IfcAirToAirHeatRecoveryType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcAirToAirHeatRecoveryTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcAlarm
boost::optional< ::Ifc4::IfcAlarmTypeEnum::Value > Ifc4::IfcAlarm::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcAlarmTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcAlarm::setPredefinedType(boost::optional< ::Ifc4::IfcAlarmTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcAlarmTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcAlarm::declaration() const { return *((IfcParse::entity*)IFC4_types[26]); }
const IfcParse::entity& Ifc4::IfcAlarm::Class() { return *((IfcParse::entity*)IFC4_types[26]); }
Ifc4::IfcAlarm::IfcAlarm(IfcEntityInstanceData&& e) : IfcDistributionControlElement(std::move(e)) { }
Ifc4::IfcAlarm::IfcAlarm(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcAlarmTypeEnum::Value > v9_PredefinedType) : IfcDistributionControlElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcAlarmTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcAlarmType
::Ifc4::IfcAlarmTypeEnum::Value Ifc4::IfcAlarmType::PredefinedType() const {  return ::Ifc4::IfcAlarmTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcAlarmType::setPredefinedType(::Ifc4::IfcAlarmTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcAlarmTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcAlarmType::declaration() const { return *((IfcParse::entity*)IFC4_types[27]); }
const IfcParse::entity& Ifc4::IfcAlarmType::Class() { return *((IfcParse::entity*)IFC4_types[27]); }
Ifc4::IfcAlarmType::IfcAlarmType(IfcEntityInstanceData&& e) : IfcDistributionControlElementType(std::move(e)) { }
Ifc4::IfcAlarmType::IfcAlarmType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcAlarmTypeEnum::Value v10_PredefinedType) : IfcDistributionControlElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcAlarmTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcAnnotation

::Ifc4::IfcRelContainedInSpatialStructure::list::ptr Ifc4::IfcAnnotation::ContainedInStructure() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[823], 4)->as<IfcRelContainedInSpatialStructure>(); }

const IfcParse::entity& Ifc4::IfcAnnotation::declaration() const { return *((IfcParse::entity*)IFC4_types[33]); }
const IfcParse::entity& Ifc4::IfcAnnotation::Class() { return *((IfcParse::entity*)IFC4_types[33]); }
Ifc4::IfcAnnotation::IfcAnnotation(IfcEntityInstanceData&& e) : IfcProduct(std::move(e)) { }
Ifc4::IfcAnnotation::IfcAnnotation(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation) : IfcProduct(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcAnnotationFillArea
::Ifc4::IfcCurve* Ifc4::IfcAnnotationFillArea::OuterBoundary() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcAnnotationFillArea::setOuterBoundary(::Ifc4::IfcCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
boost::optional< aggregate_of< ::Ifc4::IfcCurve >::ptr > Ifc4::IfcAnnotationFillArea::InnerBoundaries() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcCurve >(); }
void Ifc4::IfcAnnotationFillArea::setInnerBoundaries(boost::optional< aggregate_of< ::Ifc4::IfcCurve >::ptr > v) { if (v) {set_attribute_value(1, (*v)->generalize());} else {unset_attribute_value(1);} }


const IfcParse::entity& Ifc4::IfcAnnotationFillArea::declaration() const { return *((IfcParse::entity*)IFC4_types[34]); }
const IfcParse::entity& Ifc4::IfcAnnotationFillArea::Class() { return *((IfcParse::entity*)IFC4_types[34]); }
Ifc4::IfcAnnotationFillArea::IfcAnnotationFillArea(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcAnnotationFillArea::IfcAnnotationFillArea(::Ifc4::IfcCurve* v1_OuterBoundary, boost::optional< aggregate_of< ::Ifc4::IfcCurve >::ptr > v2_InnerBoundaries) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_OuterBoundary ? v1_OuterBoundary->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_InnerBoundaries) {set_attribute_value(1, (*v2_InnerBoundaries)->generalize()); }; populate_derived(); }

// Function implementations for IfcApplication
::Ifc4::IfcOrganization* Ifc4::IfcApplication::ApplicationDeveloper() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcOrganization>(true); }
void Ifc4::IfcApplication::setApplicationDeveloper(::Ifc4::IfcOrganization* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
std::string Ifc4::IfcApplication::Version() const {  std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcApplication::setVersion(std::string v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
std::string Ifc4::IfcApplication::ApplicationFullName() const {  std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcApplication::setApplicationFullName(std::string v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
std::string Ifc4::IfcApplication::ApplicationIdentifier() const {  std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcApplication::setApplicationIdentifier(std::string v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcApplication::declaration() const { return *((IfcParse::entity*)IFC4_types[35]); }
const IfcParse::entity& Ifc4::IfcApplication::Class() { return *((IfcParse::entity*)IFC4_types[35]); }
Ifc4::IfcApplication::IfcApplication(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcApplication::IfcApplication(::Ifc4::IfcOrganization* v1_ApplicationDeveloper, std::string v2_Version, std::string v3_ApplicationFullName, std::string v4_ApplicationIdentifier) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_ApplicationDeveloper ? v1_ApplicationDeveloper->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Version));set_attribute_value(2, (v3_ApplicationFullName));set_attribute_value(3, (v4_ApplicationIdentifier));; populate_derived(); }

// Function implementations for IfcAppliedValue
boost::optional< std::string > Ifc4::IfcAppliedValue::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcAppliedValue::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcAppliedValue::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcAppliedValue::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
::Ifc4::IfcAppliedValueSelect* Ifc4::IfcAppliedValue::AppliedValue() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcAppliedValueSelect>(true); }
void Ifc4::IfcAppliedValue::setAppliedValue(::Ifc4::IfcAppliedValueSelect* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcMeasureWithUnit* Ifc4::IfcAppliedValue::UnitBasis() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcMeasureWithUnit>(true); }
void Ifc4::IfcAppliedValue::setUnitBasis(::Ifc4::IfcMeasureWithUnit* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcAppliedValue::ApplicableDate() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcAppliedValue::setApplicableDate(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcAppliedValue::FixedUntilDate() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcAppliedValue::setFixedUntilDate(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcAppliedValue::Category() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcAppliedValue::setCategory(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcAppliedValue::Condition() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcAppliedValue::setCondition(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< ::Ifc4::IfcArithmeticOperatorEnum::Value > Ifc4::IfcAppliedValue::ArithmeticOperator() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcArithmeticOperatorEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcAppliedValue::setArithmeticOperator(boost::optional< ::Ifc4::IfcArithmeticOperatorEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcArithmeticOperatorEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }
boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > Ifc4::IfcAppliedValue::Components() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(9); return es->as< ::Ifc4::IfcAppliedValue >(); }
void Ifc4::IfcAppliedValue::setComponents(boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v) { if (v) {set_attribute_value(9, (*v)->generalize());} else {unset_attribute_value(9);} }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcAppliedValue::HasExternalReference() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }

const IfcParse::entity& Ifc4::IfcAppliedValue::declaration() const { return *((IfcParse::entity*)IFC4_types[36]); }
const IfcParse::entity& Ifc4::IfcAppliedValue::Class() { return *((IfcParse::entity*)IFC4_types[36]); }
Ifc4::IfcAppliedValue::IfcAppliedValue(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcAppliedValue::IfcAppliedValue(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcAppliedValueSelect* v3_AppliedValue, ::Ifc4::IfcMeasureWithUnit* v4_UnitBasis, boost::optional< std::string > v5_ApplicableDate, boost::optional< std::string > v6_FixedUntilDate, boost::optional< std::string > v7_Category, boost::optional< std::string > v8_Condition, boost::optional< ::Ifc4::IfcArithmeticOperatorEnum::Value > v9_ArithmeticOperator, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_Components) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(10))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_AppliedValue ? v3_AppliedValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_UnitBasis ? v4_UnitBasis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_ApplicableDate) {set_attribute_value(4, (*v5_ApplicableDate)); } if (v6_FixedUntilDate) {set_attribute_value(5, (*v6_FixedUntilDate)); } if (v7_Category) {set_attribute_value(6, (*v7_Category)); } if (v8_Condition) {set_attribute_value(7, (*v8_Condition)); } if (v9_ArithmeticOperator) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcArithmeticOperatorEnum::Class(),(size_t)*v9_ArithmeticOperator))); } if (v10_Components) {set_attribute_value(9, (*v10_Components)->generalize()); }; populate_derived(); }

// Function implementations for IfcApproval
boost::optional< std::string > Ifc4::IfcApproval::Identifier() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcApproval::setIdentifier(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcApproval::Name() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcApproval::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcApproval::Description() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcApproval::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::string > Ifc4::IfcApproval::TimeOfApproval() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcApproval::setTimeOfApproval(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcApproval::Status() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcApproval::setStatus(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcApproval::Level() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcApproval::setLevel(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcApproval::Qualifier() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcApproval::setQualifier(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
::Ifc4::IfcActorSelect* Ifc4::IfcApproval::RequestingApproval() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcApproval::setRequestingApproval(::Ifc4::IfcActorSelect* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcActorSelect* Ifc4::IfcApproval::GivingApproval() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcApproval::setGivingApproval(::Ifc4::IfcActorSelect* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcApproval::HasExternalReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }
::Ifc4::IfcRelAssociatesApproval::list::ptr Ifc4::IfcApproval::ApprovedObjects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[807], 5)->as<IfcRelAssociatesApproval>(); }
::Ifc4::IfcResourceApprovalRelationship::list::ptr Ifc4::IfcApproval::ApprovedResources() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[851], 3)->as<IfcResourceApprovalRelationship>(); }
::Ifc4::IfcApprovalRelationship::list::ptr Ifc4::IfcApproval::IsRelatedWith() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[39], 3)->as<IfcApprovalRelationship>(); }
::Ifc4::IfcApprovalRelationship::list::ptr Ifc4::IfcApproval::Relates() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[39], 2)->as<IfcApprovalRelationship>(); }

const IfcParse::entity& Ifc4::IfcApproval::declaration() const { return *((IfcParse::entity*)IFC4_types[38]); }
const IfcParse::entity& Ifc4::IfcApproval::Class() { return *((IfcParse::entity*)IFC4_types[38]); }
Ifc4::IfcApproval::IfcApproval(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcApproval::IfcApproval(boost::optional< std::string > v1_Identifier, boost::optional< std::string > v2_Name, boost::optional< std::string > v3_Description, boost::optional< std::string > v4_TimeOfApproval, boost::optional< std::string > v5_Status, boost::optional< std::string > v6_Level, boost::optional< std::string > v7_Qualifier, ::Ifc4::IfcActorSelect* v8_RequestingApproval, ::Ifc4::IfcActorSelect* v9_GivingApproval) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(9))) {  if (v1_Identifier) {set_attribute_value(0, (*v1_Identifier)); } if (v2_Name) {set_attribute_value(1, (*v2_Name)); } if (v3_Description) {set_attribute_value(2, (*v3_Description)); } if (v4_TimeOfApproval) {set_attribute_value(3, (*v4_TimeOfApproval)); } if (v5_Status) {set_attribute_value(4, (*v5_Status)); } if (v6_Level) {set_attribute_value(5, (*v6_Level)); } if (v7_Qualifier) {set_attribute_value(6, (*v7_Qualifier)); }set_attribute_value(7, v8_RequestingApproval ? v8_RequestingApproval->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, v9_GivingApproval ? v9_GivingApproval->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcApprovalRelationship
::Ifc4::IfcApproval* Ifc4::IfcApprovalRelationship::RelatingApproval() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcApproval>(true); }
void Ifc4::IfcApprovalRelationship::setRelatingApproval(::Ifc4::IfcApproval* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
aggregate_of< ::Ifc4::IfcApproval >::ptr Ifc4::IfcApprovalRelationship::RelatedApprovals() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcApproval >(); }
void Ifc4::IfcApprovalRelationship::setRelatedApprovals(aggregate_of< ::Ifc4::IfcApproval >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcApprovalRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[39]); }
const IfcParse::entity& Ifc4::IfcApprovalRelationship::Class() { return *((IfcParse::entity*)IFC4_types[39]); }
Ifc4::IfcApprovalRelationship::IfcApprovalRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcApprovalRelationship::IfcApprovalRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcApproval* v3_RelatingApproval, aggregate_of< ::Ifc4::IfcApproval >::ptr v4_RelatedApprovals) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_RelatingApproval ? v3_RelatingApproval->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_RelatedApprovals)->generalize());; populate_derived(); }

// Function implementations for IfcArbitraryClosedProfileDef
::Ifc4::IfcCurve* Ifc4::IfcArbitraryClosedProfileDef::OuterCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcArbitraryClosedProfileDef::setOuterCurve(::Ifc4::IfcCurve* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcArbitraryClosedProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[40]); }
const IfcParse::entity& Ifc4::IfcArbitraryClosedProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[40]); }
Ifc4::IfcArbitraryClosedProfileDef::IfcArbitraryClosedProfileDef(IfcEntityInstanceData&& e) : IfcProfileDef(std::move(e)) { }
Ifc4::IfcArbitraryClosedProfileDef::IfcArbitraryClosedProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcCurve* v3_OuterCurve) : IfcProfileDef(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_OuterCurve ? v3_OuterCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcArbitraryOpenProfileDef
::Ifc4::IfcBoundedCurve* Ifc4::IfcArbitraryOpenProfileDef::Curve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcBoundedCurve>(true); }
void Ifc4::IfcArbitraryOpenProfileDef::setCurve(::Ifc4::IfcBoundedCurve* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcArbitraryOpenProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[41]); }
const IfcParse::entity& Ifc4::IfcArbitraryOpenProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[41]); }
Ifc4::IfcArbitraryOpenProfileDef::IfcArbitraryOpenProfileDef(IfcEntityInstanceData&& e) : IfcProfileDef(std::move(e)) { }
Ifc4::IfcArbitraryOpenProfileDef::IfcArbitraryOpenProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcBoundedCurve* v3_Curve) : IfcProfileDef(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Curve ? v3_Curve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcArbitraryProfileDefWithVoids
aggregate_of< ::Ifc4::IfcCurve >::ptr Ifc4::IfcArbitraryProfileDefWithVoids::InnerCurves() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcCurve >(); }
void Ifc4::IfcArbitraryProfileDefWithVoids::setInnerCurves(aggregate_of< ::Ifc4::IfcCurve >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcArbitraryProfileDefWithVoids::declaration() const { return *((IfcParse::entity*)IFC4_types[42]); }
const IfcParse::entity& Ifc4::IfcArbitraryProfileDefWithVoids::Class() { return *((IfcParse::entity*)IFC4_types[42]); }
Ifc4::IfcArbitraryProfileDefWithVoids::IfcArbitraryProfileDefWithVoids(IfcEntityInstanceData&& e) : IfcArbitraryClosedProfileDef(std::move(e)) { }
Ifc4::IfcArbitraryProfileDefWithVoids::IfcArbitraryProfileDefWithVoids(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcCurve* v3_OuterCurve, aggregate_of< ::Ifc4::IfcCurve >::ptr v4_InnerCurves) : IfcArbitraryClosedProfileDef(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_OuterCurve ? v3_OuterCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_InnerCurves)->generalize());; populate_derived(); }

// Function implementations for IfcAsset
boost::optional< std::string > Ifc4::IfcAsset::Identification() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcAsset::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
::Ifc4::IfcCostValue* Ifc4::IfcAsset::OriginalValue() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcCostValue>(true); }
void Ifc4::IfcAsset::setOriginalValue(::Ifc4::IfcCostValue* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
::Ifc4::IfcCostValue* Ifc4::IfcAsset::CurrentValue() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcCostValue>(true); }
void Ifc4::IfcAsset::setCurrentValue(::Ifc4::IfcCostValue* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcCostValue* Ifc4::IfcAsset::TotalReplacementCost() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcCostValue>(true); }
void Ifc4::IfcAsset::setTotalReplacementCost(::Ifc4::IfcCostValue* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }
::Ifc4::IfcActorSelect* Ifc4::IfcAsset::Owner() const { if(data_.get_attribute_value(9).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcAsset::setOwner(::Ifc4::IfcActorSelect* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }
::Ifc4::IfcActorSelect* Ifc4::IfcAsset::User() const { if(data_.get_attribute_value(10).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(10)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcAsset::setUser(::Ifc4::IfcActorSelect* v) { set_attribute_value(10, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(10); }
::Ifc4::IfcPerson* Ifc4::IfcAsset::ResponsiblePerson() const { if(data_.get_attribute_value(11).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(11)))->as<::Ifc4::IfcPerson>(true); }
void Ifc4::IfcAsset::setResponsiblePerson(::Ifc4::IfcPerson* v) { set_attribute_value(11, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(11); }
boost::optional< std::string > Ifc4::IfcAsset::IncorporationDate() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcAsset::setIncorporationDate(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
::Ifc4::IfcCostValue* Ifc4::IfcAsset::DepreciatedValue() const { if(data_.get_attribute_value(13).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(13)))->as<::Ifc4::IfcCostValue>(true); }
void Ifc4::IfcAsset::setDepreciatedValue(::Ifc4::IfcCostValue* v) { set_attribute_value(13, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(13); }


const IfcParse::entity& Ifc4::IfcAsset::declaration() const { return *((IfcParse::entity*)IFC4_types[48]); }
const IfcParse::entity& Ifc4::IfcAsset::Class() { return *((IfcParse::entity*)IFC4_types[48]); }
Ifc4::IfcAsset::IfcAsset(IfcEntityInstanceData&& e) : IfcGroup(std::move(e)) { }
Ifc4::IfcAsset::IfcAsset(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, ::Ifc4::IfcCostValue* v7_OriginalValue, ::Ifc4::IfcCostValue* v8_CurrentValue, ::Ifc4::IfcCostValue* v9_TotalReplacementCost, ::Ifc4::IfcActorSelect* v10_Owner, ::Ifc4::IfcActorSelect* v11_User, ::Ifc4::IfcPerson* v12_ResponsiblePerson, boost::optional< std::string > v13_IncorporationDate, ::Ifc4::IfcCostValue* v14_DepreciatedValue) : IfcGroup(IfcEntityInstanceData(storage_t(14))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); }set_attribute_value(6, v7_OriginalValue ? v7_OriginalValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_CurrentValue ? v8_CurrentValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, v9_TotalReplacementCost ? v9_TotalReplacementCost->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(9, v10_Owner ? v10_Owner->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(10, v11_User ? v11_User->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(11, v12_ResponsiblePerson ? v12_ResponsiblePerson->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v13_IncorporationDate) {set_attribute_value(12, (*v13_IncorporationDate)); }set_attribute_value(13, v14_DepreciatedValue ? v14_DepreciatedValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcAsymmetricIShapeProfileDef
double Ifc4::IfcAsymmetricIShapeProfileDef::BottomFlangeWidth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setBottomFlangeWidth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcAsymmetricIShapeProfileDef::OverallDepth() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setOverallDepth(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
double Ifc4::IfcAsymmetricIShapeProfileDef::WebThickness() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setWebThickness(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcAsymmetricIShapeProfileDef::BottomFlangeThickness() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setBottomFlangeThickness(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
boost::optional< double > Ifc4::IfcAsymmetricIShapeProfileDef::BottomFlangeFilletRadius() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setBottomFlangeFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
double Ifc4::IfcAsymmetricIShapeProfileDef::TopFlangeWidth() const {  double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setTopFlangeWidth(double v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }
boost::optional< double > Ifc4::IfcAsymmetricIShapeProfileDef::TopFlangeThickness() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setTopFlangeThickness(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcAsymmetricIShapeProfileDef::TopFlangeFilletRadius() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setTopFlangeFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcAsymmetricIShapeProfileDef::BottomFlangeEdgeRadius() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setBottomFlangeEdgeRadius(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< double > Ifc4::IfcAsymmetricIShapeProfileDef::BottomFlangeSlope() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setBottomFlangeSlope(boost::optional< double > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< double > Ifc4::IfcAsymmetricIShapeProfileDef::TopFlangeEdgeRadius() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } double v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setTopFlangeEdgeRadius(boost::optional< double > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
boost::optional< double > Ifc4::IfcAsymmetricIShapeProfileDef::TopFlangeSlope() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } double v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcAsymmetricIShapeProfileDef::setTopFlangeSlope(boost::optional< double > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }


const IfcParse::entity& Ifc4::IfcAsymmetricIShapeProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[49]); }
const IfcParse::entity& Ifc4::IfcAsymmetricIShapeProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[49]); }
Ifc4::IfcAsymmetricIShapeProfileDef::IfcAsymmetricIShapeProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcAsymmetricIShapeProfileDef::IfcAsymmetricIShapeProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_BottomFlangeWidth, double v5_OverallDepth, double v6_WebThickness, double v7_BottomFlangeThickness, boost::optional< double > v8_BottomFlangeFilletRadius, double v9_TopFlangeWidth, boost::optional< double > v10_TopFlangeThickness, boost::optional< double > v11_TopFlangeFilletRadius, boost::optional< double > v12_BottomFlangeEdgeRadius, boost::optional< double > v13_BottomFlangeSlope, boost::optional< double > v14_TopFlangeEdgeRadius, boost::optional< double > v15_TopFlangeSlope) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(15))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_BottomFlangeWidth));set_attribute_value(4, (v5_OverallDepth));set_attribute_value(5, (v6_WebThickness));set_attribute_value(6, (v7_BottomFlangeThickness)); if (v8_BottomFlangeFilletRadius) {set_attribute_value(7, (*v8_BottomFlangeFilletRadius)); }set_attribute_value(8, (v9_TopFlangeWidth)); if (v10_TopFlangeThickness) {set_attribute_value(9, (*v10_TopFlangeThickness)); } if (v11_TopFlangeFilletRadius) {set_attribute_value(10, (*v11_TopFlangeFilletRadius)); } if (v12_BottomFlangeEdgeRadius) {set_attribute_value(11, (*v12_BottomFlangeEdgeRadius)); } if (v13_BottomFlangeSlope) {set_attribute_value(12, (*v13_BottomFlangeSlope)); } if (v14_TopFlangeEdgeRadius) {set_attribute_value(13, (*v14_TopFlangeEdgeRadius)); } if (v15_TopFlangeSlope) {set_attribute_value(14, (*v15_TopFlangeSlope)); }; populate_derived(); }

// Function implementations for IfcAudioVisualAppliance
boost::optional< ::Ifc4::IfcAudioVisualApplianceTypeEnum::Value > Ifc4::IfcAudioVisualAppliance::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcAudioVisualApplianceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcAudioVisualAppliance::setPredefinedType(boost::optional< ::Ifc4::IfcAudioVisualApplianceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcAudioVisualApplianceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcAudioVisualAppliance::declaration() const { return *((IfcParse::entity*)IFC4_types[50]); }
const IfcParse::entity& Ifc4::IfcAudioVisualAppliance::Class() { return *((IfcParse::entity*)IFC4_types[50]); }
Ifc4::IfcAudioVisualAppliance::IfcAudioVisualAppliance(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcAudioVisualAppliance::IfcAudioVisualAppliance(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcAudioVisualApplianceTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcAudioVisualApplianceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcAudioVisualApplianceType
::Ifc4::IfcAudioVisualApplianceTypeEnum::Value Ifc4::IfcAudioVisualApplianceType::PredefinedType() const {  return ::Ifc4::IfcAudioVisualApplianceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcAudioVisualApplianceType::setPredefinedType(::Ifc4::IfcAudioVisualApplianceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcAudioVisualApplianceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcAudioVisualApplianceType::declaration() const { return *((IfcParse::entity*)IFC4_types[51]); }
const IfcParse::entity& Ifc4::IfcAudioVisualApplianceType::Class() { return *((IfcParse::entity*)IFC4_types[51]); }
Ifc4::IfcAudioVisualApplianceType::IfcAudioVisualApplianceType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcAudioVisualApplianceType::IfcAudioVisualApplianceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcAudioVisualApplianceTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcAudioVisualApplianceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcAxis1Placement
::Ifc4::IfcDirection* Ifc4::IfcAxis1Placement::Axis() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcAxis1Placement::setAxis(::Ifc4::IfcDirection* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcAxis1Placement::declaration() const { return *((IfcParse::entity*)IFC4_types[53]); }
const IfcParse::entity& Ifc4::IfcAxis1Placement::Class() { return *((IfcParse::entity*)IFC4_types[53]); }
Ifc4::IfcAxis1Placement::IfcAxis1Placement(IfcEntityInstanceData&& e) : IfcPlacement(std::move(e)) { }
Ifc4::IfcAxis1Placement::IfcAxis1Placement(::Ifc4::IfcCartesianPoint* v1_Location, ::Ifc4::IfcDirection* v2_Axis) : IfcPlacement(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Location ? v1_Location->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Axis ? v2_Axis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcAxis2Placement2D
::Ifc4::IfcDirection* Ifc4::IfcAxis2Placement2D::RefDirection() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcAxis2Placement2D::setRefDirection(::Ifc4::IfcDirection* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcAxis2Placement2D::declaration() const { return *((IfcParse::entity*)IFC4_types[55]); }
const IfcParse::entity& Ifc4::IfcAxis2Placement2D::Class() { return *((IfcParse::entity*)IFC4_types[55]); }
Ifc4::IfcAxis2Placement2D::IfcAxis2Placement2D(IfcEntityInstanceData&& e) : IfcPlacement(std::move(e)) { }
Ifc4::IfcAxis2Placement2D::IfcAxis2Placement2D(::Ifc4::IfcCartesianPoint* v1_Location, ::Ifc4::IfcDirection* v2_RefDirection) : IfcPlacement(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Location ? v1_Location->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_RefDirection ? v2_RefDirection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcAxis2Placement3D
::Ifc4::IfcDirection* Ifc4::IfcAxis2Placement3D::Axis() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcAxis2Placement3D::setAxis(::Ifc4::IfcDirection* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcDirection* Ifc4::IfcAxis2Placement3D::RefDirection() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcAxis2Placement3D::setRefDirection(::Ifc4::IfcDirection* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcAxis2Placement3D::declaration() const { return *((IfcParse::entity*)IFC4_types[56]); }
const IfcParse::entity& Ifc4::IfcAxis2Placement3D::Class() { return *((IfcParse::entity*)IFC4_types[56]); }
Ifc4::IfcAxis2Placement3D::IfcAxis2Placement3D(IfcEntityInstanceData&& e) : IfcPlacement(std::move(e)) { }
Ifc4::IfcAxis2Placement3D::IfcAxis2Placement3D(::Ifc4::IfcCartesianPoint* v1_Location, ::Ifc4::IfcDirection* v2_Axis, ::Ifc4::IfcDirection* v3_RefDirection) : IfcPlacement(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Location ? v1_Location->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Axis ? v2_Axis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_RefDirection ? v3_RefDirection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBSplineCurve
int Ifc4::IfcBSplineCurve::Degree() const {  int v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcBSplineCurve::setDegree(int v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr Ifc4::IfcBSplineCurve::ControlPointsList() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcCartesianPoint >(); }
void Ifc4::IfcBSplineCurve::setControlPointsList(aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcBSplineCurveForm::Value Ifc4::IfcBSplineCurve::CurveForm() const {  return ::Ifc4::IfcBSplineCurveForm::FromString(data_.get_attribute_value(2)); }
void Ifc4::IfcBSplineCurve::setCurveForm(::Ifc4::IfcBSplineCurveForm::Value v) { set_attribute_value(2, EnumerationReference(&::Ifc4::IfcBSplineCurveForm::Class(), (size_t) v));if constexpr (false)unset_attribute_value(2); }
boost::logic::tribool Ifc4::IfcBSplineCurve::ClosedCurve() const {  boost::logic::tribool v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcBSplineCurve::setClosedCurve(boost::logic::tribool v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::logic::tribool Ifc4::IfcBSplineCurve::SelfIntersect() const {  boost::logic::tribool v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcBSplineCurve::setSelfIntersect(boost::logic::tribool v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcBSplineCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[85]); }
const IfcParse::entity& Ifc4::IfcBSplineCurve::Class() { return *((IfcParse::entity*)IFC4_types[85]); }
Ifc4::IfcBSplineCurve::IfcBSplineCurve(IfcEntityInstanceData&& e) : IfcBoundedCurve(std::move(e)) { }
Ifc4::IfcBSplineCurve::IfcBSplineCurve(int v1_Degree, aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v2_ControlPointsList, ::Ifc4::IfcBSplineCurveForm::Value v3_CurveForm, boost::logic::tribool v4_ClosedCurve, boost::logic::tribool v5_SelfIntersect) : IfcBoundedCurve(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_Degree));set_attribute_value(1, (v2_ControlPointsList)->generalize());set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcBSplineCurveForm::Class(),(size_t)v3_CurveForm)));set_attribute_value(3, (v4_ClosedCurve));set_attribute_value(4, (v5_SelfIntersect));; populate_derived(); }

// Function implementations for IfcBSplineCurveWithKnots
std::vector< int > /*[2:?]*/ Ifc4::IfcBSplineCurveWithKnots::KnotMultiplicities() const {  std::vector< int > /*[2:?]*/ v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcBSplineCurveWithKnots::setKnotMultiplicities(std::vector< int > /*[2:?]*/ v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
std::vector< double > /*[2:?]*/ Ifc4::IfcBSplineCurveWithKnots::Knots() const {  std::vector< double > /*[2:?]*/ v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcBSplineCurveWithKnots::setKnots(std::vector< double > /*[2:?]*/ v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
::Ifc4::IfcKnotType::Value Ifc4::IfcBSplineCurveWithKnots::KnotSpec() const {  return ::Ifc4::IfcKnotType::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcBSplineCurveWithKnots::setKnotSpec(::Ifc4::IfcKnotType::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcKnotType::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }


const IfcParse::entity& Ifc4::IfcBSplineCurveWithKnots::declaration() const { return *((IfcParse::entity*)IFC4_types[87]); }
const IfcParse::entity& Ifc4::IfcBSplineCurveWithKnots::Class() { return *((IfcParse::entity*)IFC4_types[87]); }
Ifc4::IfcBSplineCurveWithKnots::IfcBSplineCurveWithKnots(IfcEntityInstanceData&& e) : IfcBSplineCurve(std::move(e)) { }
Ifc4::IfcBSplineCurveWithKnots::IfcBSplineCurveWithKnots(int v1_Degree, aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v2_ControlPointsList, ::Ifc4::IfcBSplineCurveForm::Value v3_CurveForm, boost::logic::tribool v4_ClosedCurve, boost::logic::tribool v5_SelfIntersect, std::vector< int > /*[2:?]*/ v6_KnotMultiplicities, std::vector< double > /*[2:?]*/ v7_Knots, ::Ifc4::IfcKnotType::Value v8_KnotSpec) : IfcBSplineCurve(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_Degree));set_attribute_value(1, (v2_ControlPointsList)->generalize());set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcBSplineCurveForm::Class(),(size_t)v3_CurveForm)));set_attribute_value(3, (v4_ClosedCurve));set_attribute_value(4, (v5_SelfIntersect));set_attribute_value(5, (v6_KnotMultiplicities));set_attribute_value(6, (v7_Knots));set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcKnotType::Class(),(size_t)v8_KnotSpec)));; populate_derived(); }

// Function implementations for IfcBSplineSurface
int Ifc4::IfcBSplineSurface::UDegree() const {  int v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcBSplineSurface::setUDegree(int v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
int Ifc4::IfcBSplineSurface::VDegree() const {  int v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcBSplineSurface::setVDegree(int v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
aggregate_of_aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr Ifc4::IfcBSplineSurface::ControlPointsList() const {  aggregate_of_aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcCartesianPoint >(); }
void Ifc4::IfcBSplineSurface::setControlPointsList(aggregate_of_aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcBSplineSurfaceForm::Value Ifc4::IfcBSplineSurface::SurfaceForm() const {  return ::Ifc4::IfcBSplineSurfaceForm::FromString(data_.get_attribute_value(3)); }
void Ifc4::IfcBSplineSurface::setSurfaceForm(::Ifc4::IfcBSplineSurfaceForm::Value v) { set_attribute_value(3, EnumerationReference(&::Ifc4::IfcBSplineSurfaceForm::Class(), (size_t) v));if constexpr (false)unset_attribute_value(3); }
boost::logic::tribool Ifc4::IfcBSplineSurface::UClosed() const {  boost::logic::tribool v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcBSplineSurface::setUClosed(boost::logic::tribool v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
boost::logic::tribool Ifc4::IfcBSplineSurface::VClosed() const {  boost::logic::tribool v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcBSplineSurface::setVClosed(boost::logic::tribool v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
boost::logic::tribool Ifc4::IfcBSplineSurface::SelfIntersect() const {  boost::logic::tribool v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcBSplineSurface::setSelfIntersect(boost::logic::tribool v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcBSplineSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[88]); }
const IfcParse::entity& Ifc4::IfcBSplineSurface::Class() { return *((IfcParse::entity*)IFC4_types[88]); }
Ifc4::IfcBSplineSurface::IfcBSplineSurface(IfcEntityInstanceData&& e) : IfcBoundedSurface(std::move(e)) { }
Ifc4::IfcBSplineSurface::IfcBSplineSurface(int v1_UDegree, int v2_VDegree, aggregate_of_aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v3_ControlPointsList, ::Ifc4::IfcBSplineSurfaceForm::Value v4_SurfaceForm, boost::logic::tribool v5_UClosed, boost::logic::tribool v6_VClosed, boost::logic::tribool v7_SelfIntersect) : IfcBoundedSurface(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_UDegree));set_attribute_value(1, (v2_VDegree));set_attribute_value(2, (v3_ControlPointsList)->generalize());set_attribute_value(3, (EnumerationReference(&::Ifc4::IfcBSplineSurfaceForm::Class(),(size_t)v4_SurfaceForm)));set_attribute_value(4, (v5_UClosed));set_attribute_value(5, (v6_VClosed));set_attribute_value(6, (v7_SelfIntersect));; populate_derived(); }

// Function implementations for IfcBSplineSurfaceWithKnots
std::vector< int > /*[2:?]*/ Ifc4::IfcBSplineSurfaceWithKnots::UMultiplicities() const {  std::vector< int > /*[2:?]*/ v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcBSplineSurfaceWithKnots::setUMultiplicities(std::vector< int > /*[2:?]*/ v) { set_attribute_value(7, v);if constexpr (false)unset_attribute_value(7); }
std::vector< int > /*[2:?]*/ Ifc4::IfcBSplineSurfaceWithKnots::VMultiplicities() const {  std::vector< int > /*[2:?]*/ v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcBSplineSurfaceWithKnots::setVMultiplicities(std::vector< int > /*[2:?]*/ v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }
std::vector< double > /*[2:?]*/ Ifc4::IfcBSplineSurfaceWithKnots::UKnots() const {  std::vector< double > /*[2:?]*/ v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcBSplineSurfaceWithKnots::setUKnots(std::vector< double > /*[2:?]*/ v) { set_attribute_value(9, v);if constexpr (false)unset_attribute_value(9); }
std::vector< double > /*[2:?]*/ Ifc4::IfcBSplineSurfaceWithKnots::VKnots() const {  std::vector< double > /*[2:?]*/ v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcBSplineSurfaceWithKnots::setVKnots(std::vector< double > /*[2:?]*/ v) { set_attribute_value(10, v);if constexpr (false)unset_attribute_value(10); }
::Ifc4::IfcKnotType::Value Ifc4::IfcBSplineSurfaceWithKnots::KnotSpec() const {  return ::Ifc4::IfcKnotType::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcBSplineSurfaceWithKnots::setKnotSpec(::Ifc4::IfcKnotType::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcKnotType::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcBSplineSurfaceWithKnots::declaration() const { return *((IfcParse::entity*)IFC4_types[90]); }
const IfcParse::entity& Ifc4::IfcBSplineSurfaceWithKnots::Class() { return *((IfcParse::entity*)IFC4_types[90]); }
Ifc4::IfcBSplineSurfaceWithKnots::IfcBSplineSurfaceWithKnots(IfcEntityInstanceData&& e) : IfcBSplineSurface(std::move(e)) { }
Ifc4::IfcBSplineSurfaceWithKnots::IfcBSplineSurfaceWithKnots(int v1_UDegree, int v2_VDegree, aggregate_of_aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v3_ControlPointsList, ::Ifc4::IfcBSplineSurfaceForm::Value v4_SurfaceForm, boost::logic::tribool v5_UClosed, boost::logic::tribool v6_VClosed, boost::logic::tribool v7_SelfIntersect, std::vector< int > /*[2:?]*/ v8_UMultiplicities, std::vector< int > /*[2:?]*/ v9_VMultiplicities, std::vector< double > /*[2:?]*/ v10_UKnots, std::vector< double > /*[2:?]*/ v11_VKnots, ::Ifc4::IfcKnotType::Value v12_KnotSpec) : IfcBSplineSurface(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_UDegree));set_attribute_value(1, (v2_VDegree));set_attribute_value(2, (v3_ControlPointsList)->generalize());set_attribute_value(3, (EnumerationReference(&::Ifc4::IfcBSplineSurfaceForm::Class(),(size_t)v4_SurfaceForm)));set_attribute_value(4, (v5_UClosed));set_attribute_value(5, (v6_VClosed));set_attribute_value(6, (v7_SelfIntersect));set_attribute_value(7, (v8_UMultiplicities));set_attribute_value(8, (v9_VMultiplicities));set_attribute_value(9, (v10_UKnots));set_attribute_value(10, (v11_VKnots));set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcKnotType::Class(),(size_t)v12_KnotSpec)));; populate_derived(); }

// Function implementations for IfcBeam
boost::optional< ::Ifc4::IfcBeamTypeEnum::Value > Ifc4::IfcBeam::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcBeamTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcBeam::setPredefinedType(boost::optional< ::Ifc4::IfcBeamTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcBeamTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcBeam::declaration() const { return *((IfcParse::entity*)IFC4_types[57]); }
const IfcParse::entity& Ifc4::IfcBeam::Class() { return *((IfcParse::entity*)IFC4_types[57]); }
Ifc4::IfcBeam::IfcBeam(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcBeam::IfcBeam(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcBeamTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcBeamTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcBeamStandardCase


const IfcParse::entity& Ifc4::IfcBeamStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[58]); }
const IfcParse::entity& Ifc4::IfcBeamStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[58]); }
Ifc4::IfcBeamStandardCase::IfcBeamStandardCase(IfcEntityInstanceData&& e) : IfcBeam(std::move(e)) { }
Ifc4::IfcBeamStandardCase::IfcBeamStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcBeamTypeEnum::Value > v9_PredefinedType) : IfcBeam(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcBeamTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcBeamType
::Ifc4::IfcBeamTypeEnum::Value Ifc4::IfcBeamType::PredefinedType() const {  return ::Ifc4::IfcBeamTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcBeamType::setPredefinedType(::Ifc4::IfcBeamTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcBeamTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcBeamType::declaration() const { return *((IfcParse::entity*)IFC4_types[59]); }
const IfcParse::entity& Ifc4::IfcBeamType::Class() { return *((IfcParse::entity*)IFC4_types[59]); }
Ifc4::IfcBeamType::IfcBeamType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcBeamType::IfcBeamType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcBeamTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcBeamTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcBlobTexture
std::string Ifc4::IfcBlobTexture::RasterFormat() const {  std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcBlobTexture::setRasterFormat(std::string v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
boost::dynamic_bitset<> Ifc4::IfcBlobTexture::RasterCode() const {  boost::dynamic_bitset<> v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcBlobTexture::setRasterCode(boost::dynamic_bitset<> v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcBlobTexture::declaration() const { return *((IfcParse::entity*)IFC4_types[64]); }
const IfcParse::entity& Ifc4::IfcBlobTexture::Class() { return *((IfcParse::entity*)IFC4_types[64]); }
Ifc4::IfcBlobTexture::IfcBlobTexture(IfcEntityInstanceData&& e) : IfcSurfaceTexture(std::move(e)) { }
Ifc4::IfcBlobTexture::IfcBlobTexture(bool v1_RepeatS, bool v2_RepeatT, boost::optional< std::string > v3_Mode, ::Ifc4::IfcCartesianTransformationOperator2D* v4_TextureTransform, boost::optional< std::vector< std::string > /*[1:?]*/ > v5_Parameter, std::string v6_RasterFormat, boost::dynamic_bitset<> v7_RasterCode) : IfcSurfaceTexture(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_RepeatS));set_attribute_value(1, (v2_RepeatT)); if (v3_Mode) {set_attribute_value(2, (*v3_Mode)); }set_attribute_value(3, v4_TextureTransform ? v4_TextureTransform->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Parameter) {set_attribute_value(4, (*v5_Parameter)); }set_attribute_value(5, (v6_RasterFormat));set_attribute_value(6, (v7_RasterCode));; populate_derived(); }

// Function implementations for IfcBlock
double Ifc4::IfcBlock::XLength() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcBlock::setXLength(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcBlock::YLength() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcBlock::setYLength(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcBlock::ZLength() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcBlock::setZLength(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcBlock::declaration() const { return *((IfcParse::entity*)IFC4_types[65]); }
const IfcParse::entity& Ifc4::IfcBlock::Class() { return *((IfcParse::entity*)IFC4_types[65]); }
Ifc4::IfcBlock::IfcBlock(IfcEntityInstanceData&& e) : IfcCsgPrimitive3D(std::move(e)) { }
Ifc4::IfcBlock::IfcBlock(::Ifc4::IfcAxis2Placement3D* v1_Position, double v2_XLength, double v3_YLength, double v4_ZLength) : IfcCsgPrimitive3D(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_XLength));set_attribute_value(2, (v3_YLength));set_attribute_value(3, (v4_ZLength));; populate_derived(); }

// Function implementations for IfcBoiler
boost::optional< ::Ifc4::IfcBoilerTypeEnum::Value > Ifc4::IfcBoiler::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcBoilerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcBoiler::setPredefinedType(boost::optional< ::Ifc4::IfcBoilerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcBoilerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcBoiler::declaration() const { return *((IfcParse::entity*)IFC4_types[66]); }
const IfcParse::entity& Ifc4::IfcBoiler::Class() { return *((IfcParse::entity*)IFC4_types[66]); }
Ifc4::IfcBoiler::IfcBoiler(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcBoiler::IfcBoiler(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcBoilerTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcBoilerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcBoilerType
::Ifc4::IfcBoilerTypeEnum::Value Ifc4::IfcBoilerType::PredefinedType() const {  return ::Ifc4::IfcBoilerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcBoilerType::setPredefinedType(::Ifc4::IfcBoilerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcBoilerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcBoilerType::declaration() const { return *((IfcParse::entity*)IFC4_types[67]); }
const IfcParse::entity& Ifc4::IfcBoilerType::Class() { return *((IfcParse::entity*)IFC4_types[67]); }
Ifc4::IfcBoilerType::IfcBoilerType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcBoilerType::IfcBoilerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcBoilerTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcBoilerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcBooleanClippingResult


const IfcParse::entity& Ifc4::IfcBooleanClippingResult::declaration() const { return *((IfcParse::entity*)IFC4_types[70]); }
const IfcParse::entity& Ifc4::IfcBooleanClippingResult::Class() { return *((IfcParse::entity*)IFC4_types[70]); }
Ifc4::IfcBooleanClippingResult::IfcBooleanClippingResult(IfcEntityInstanceData&& e) : IfcBooleanResult(std::move(e)) { }
Ifc4::IfcBooleanClippingResult::IfcBooleanClippingResult(::Ifc4::IfcBooleanOperator::Value v1_Operator, ::Ifc4::IfcBooleanOperand* v2_FirstOperand, ::Ifc4::IfcBooleanOperand* v3_SecondOperand) : IfcBooleanResult(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcBooleanOperator::Class(),(size_t)v1_Operator)));set_attribute_value(1, v2_FirstOperand ? v2_FirstOperand->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_SecondOperand ? v3_SecondOperand->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBooleanResult
::Ifc4::IfcBooleanOperator::Value Ifc4::IfcBooleanResult::Operator() const {  return ::Ifc4::IfcBooleanOperator::FromString(data_.get_attribute_value(0)); }
void Ifc4::IfcBooleanResult::setOperator(::Ifc4::IfcBooleanOperator::Value v) { set_attribute_value(0, EnumerationReference(&::Ifc4::IfcBooleanOperator::Class(), (size_t) v));if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcBooleanOperand* Ifc4::IfcBooleanResult::FirstOperand() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcBooleanOperand>(true); }
void Ifc4::IfcBooleanResult::setFirstOperand(::Ifc4::IfcBooleanOperand* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcBooleanOperand* Ifc4::IfcBooleanResult::SecondOperand() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcBooleanOperand>(true); }
void Ifc4::IfcBooleanResult::setSecondOperand(::Ifc4::IfcBooleanOperand* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcBooleanResult::declaration() const { return *((IfcParse::entity*)IFC4_types[73]); }
const IfcParse::entity& Ifc4::IfcBooleanResult::Class() { return *((IfcParse::entity*)IFC4_types[73]); }
Ifc4::IfcBooleanResult::IfcBooleanResult(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcBooleanResult::IfcBooleanResult(::Ifc4::IfcBooleanOperator::Value v1_Operator, ::Ifc4::IfcBooleanOperand* v2_FirstOperand, ::Ifc4::IfcBooleanOperand* v3_SecondOperand) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcBooleanOperator::Class(),(size_t)v1_Operator)));set_attribute_value(1, v2_FirstOperand ? v2_FirstOperand->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_SecondOperand ? v3_SecondOperand->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBoundaryCondition
boost::optional< std::string > Ifc4::IfcBoundaryCondition::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcBoundaryCondition::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }


const IfcParse::entity& Ifc4::IfcBoundaryCondition::declaration() const { return *((IfcParse::entity*)IFC4_types[74]); }
const IfcParse::entity& Ifc4::IfcBoundaryCondition::Class() { return *((IfcParse::entity*)IFC4_types[74]); }
Ifc4::IfcBoundaryCondition::IfcBoundaryCondition(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcBoundaryCondition::IfcBoundaryCondition(boost::optional< std::string > v1_Name) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }; populate_derived(); }

// Function implementations for IfcBoundaryCurve


const IfcParse::entity& Ifc4::IfcBoundaryCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[75]); }
const IfcParse::entity& Ifc4::IfcBoundaryCurve::Class() { return *((IfcParse::entity*)IFC4_types[75]); }
Ifc4::IfcBoundaryCurve::IfcBoundaryCurve(IfcEntityInstanceData&& e) : IfcCompositeCurveOnSurface(std::move(e)) { }
Ifc4::IfcBoundaryCurve::IfcBoundaryCurve(aggregate_of< ::Ifc4::IfcCompositeCurveSegment >::ptr v1_Segments, boost::logic::tribool v2_SelfIntersect) : IfcCompositeCurveOnSurface(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_Segments)->generalize());set_attribute_value(1, (v2_SelfIntersect));; populate_derived(); }

// Function implementations for IfcBoundaryEdgeCondition
::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* Ifc4::IfcBoundaryEdgeCondition::TranslationalStiffnessByLengthX() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryEdgeCondition::setTranslationalStiffnessByLengthX(::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* Ifc4::IfcBoundaryEdgeCondition::TranslationalStiffnessByLengthY() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryEdgeCondition::setTranslationalStiffnessByLengthY(::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* Ifc4::IfcBoundaryEdgeCondition::TranslationalStiffnessByLengthZ() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryEdgeCondition::setTranslationalStiffnessByLengthZ(::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* Ifc4::IfcBoundaryEdgeCondition::RotationalStiffnessByLengthX() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryEdgeCondition::setRotationalStiffnessByLengthX(::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* Ifc4::IfcBoundaryEdgeCondition::RotationalStiffnessByLengthY() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryEdgeCondition::setRotationalStiffnessByLengthY(::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* Ifc4::IfcBoundaryEdgeCondition::RotationalStiffnessByLengthZ() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryEdgeCondition::setRotationalStiffnessByLengthZ(::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcBoundaryEdgeCondition::declaration() const { return *((IfcParse::entity*)IFC4_types[76]); }
const IfcParse::entity& Ifc4::IfcBoundaryEdgeCondition::Class() { return *((IfcParse::entity*)IFC4_types[76]); }
Ifc4::IfcBoundaryEdgeCondition::IfcBoundaryEdgeCondition(IfcEntityInstanceData&& e) : IfcBoundaryCondition(std::move(e)) { }
Ifc4::IfcBoundaryEdgeCondition::IfcBoundaryEdgeCondition(boost::optional< std::string > v1_Name, ::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* v2_TranslationalStiffnessByLengthX, ::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* v3_TranslationalStiffnessByLengthY, ::Ifc4::IfcModulusOfTranslationalSubgradeReactionSelect* v4_TranslationalStiffnessByLengthZ, ::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* v5_RotationalStiffnessByLengthX, ::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* v6_RotationalStiffnessByLengthY, ::Ifc4::IfcModulusOfRotationalSubgradeReactionSelect* v7_RotationalStiffnessByLengthZ) : IfcBoundaryCondition(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_TranslationalStiffnessByLengthX ? v2_TranslationalStiffnessByLengthX->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_TranslationalStiffnessByLengthY ? v3_TranslationalStiffnessByLengthY->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_TranslationalStiffnessByLengthZ ? v4_TranslationalStiffnessByLengthZ->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, v5_RotationalStiffnessByLengthX ? v5_RotationalStiffnessByLengthX->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RotationalStiffnessByLengthY ? v6_RotationalStiffnessByLengthY->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_RotationalStiffnessByLengthZ ? v7_RotationalStiffnessByLengthZ->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBoundaryFaceCondition
::Ifc4::IfcModulusOfSubgradeReactionSelect* Ifc4::IfcBoundaryFaceCondition::TranslationalStiffnessByAreaX() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcModulusOfSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryFaceCondition::setTranslationalStiffnessByAreaX(::Ifc4::IfcModulusOfSubgradeReactionSelect* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcModulusOfSubgradeReactionSelect* Ifc4::IfcBoundaryFaceCondition::TranslationalStiffnessByAreaY() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcModulusOfSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryFaceCondition::setTranslationalStiffnessByAreaY(::Ifc4::IfcModulusOfSubgradeReactionSelect* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcModulusOfSubgradeReactionSelect* Ifc4::IfcBoundaryFaceCondition::TranslationalStiffnessByAreaZ() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcModulusOfSubgradeReactionSelect>(true); }
void Ifc4::IfcBoundaryFaceCondition::setTranslationalStiffnessByAreaZ(::Ifc4::IfcModulusOfSubgradeReactionSelect* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcBoundaryFaceCondition::declaration() const { return *((IfcParse::entity*)IFC4_types[77]); }
const IfcParse::entity& Ifc4::IfcBoundaryFaceCondition::Class() { return *((IfcParse::entity*)IFC4_types[77]); }
Ifc4::IfcBoundaryFaceCondition::IfcBoundaryFaceCondition(IfcEntityInstanceData&& e) : IfcBoundaryCondition(std::move(e)) { }
Ifc4::IfcBoundaryFaceCondition::IfcBoundaryFaceCondition(boost::optional< std::string > v1_Name, ::Ifc4::IfcModulusOfSubgradeReactionSelect* v2_TranslationalStiffnessByAreaX, ::Ifc4::IfcModulusOfSubgradeReactionSelect* v3_TranslationalStiffnessByAreaY, ::Ifc4::IfcModulusOfSubgradeReactionSelect* v4_TranslationalStiffnessByAreaZ) : IfcBoundaryCondition(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_TranslationalStiffnessByAreaX ? v2_TranslationalStiffnessByAreaX->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_TranslationalStiffnessByAreaY ? v3_TranslationalStiffnessByAreaY->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_TranslationalStiffnessByAreaZ ? v4_TranslationalStiffnessByAreaZ->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBoundaryNodeCondition
::Ifc4::IfcTranslationalStiffnessSelect* Ifc4::IfcBoundaryNodeCondition::TranslationalStiffnessX() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcTranslationalStiffnessSelect>(true); }
void Ifc4::IfcBoundaryNodeCondition::setTranslationalStiffnessX(::Ifc4::IfcTranslationalStiffnessSelect* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcTranslationalStiffnessSelect* Ifc4::IfcBoundaryNodeCondition::TranslationalStiffnessY() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcTranslationalStiffnessSelect>(true); }
void Ifc4::IfcBoundaryNodeCondition::setTranslationalStiffnessY(::Ifc4::IfcTranslationalStiffnessSelect* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcTranslationalStiffnessSelect* Ifc4::IfcBoundaryNodeCondition::TranslationalStiffnessZ() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcTranslationalStiffnessSelect>(true); }
void Ifc4::IfcBoundaryNodeCondition::setTranslationalStiffnessZ(::Ifc4::IfcTranslationalStiffnessSelect* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcRotationalStiffnessSelect* Ifc4::IfcBoundaryNodeCondition::RotationalStiffnessX() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcRotationalStiffnessSelect>(true); }
void Ifc4::IfcBoundaryNodeCondition::setRotationalStiffnessX(::Ifc4::IfcRotationalStiffnessSelect* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcRotationalStiffnessSelect* Ifc4::IfcBoundaryNodeCondition::RotationalStiffnessY() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcRotationalStiffnessSelect>(true); }
void Ifc4::IfcBoundaryNodeCondition::setRotationalStiffnessY(::Ifc4::IfcRotationalStiffnessSelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcRotationalStiffnessSelect* Ifc4::IfcBoundaryNodeCondition::RotationalStiffnessZ() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcRotationalStiffnessSelect>(true); }
void Ifc4::IfcBoundaryNodeCondition::setRotationalStiffnessZ(::Ifc4::IfcRotationalStiffnessSelect* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcBoundaryNodeCondition::declaration() const { return *((IfcParse::entity*)IFC4_types[78]); }
const IfcParse::entity& Ifc4::IfcBoundaryNodeCondition::Class() { return *((IfcParse::entity*)IFC4_types[78]); }
Ifc4::IfcBoundaryNodeCondition::IfcBoundaryNodeCondition(IfcEntityInstanceData&& e) : IfcBoundaryCondition(std::move(e)) { }
Ifc4::IfcBoundaryNodeCondition::IfcBoundaryNodeCondition(boost::optional< std::string > v1_Name, ::Ifc4::IfcTranslationalStiffnessSelect* v2_TranslationalStiffnessX, ::Ifc4::IfcTranslationalStiffnessSelect* v3_TranslationalStiffnessY, ::Ifc4::IfcTranslationalStiffnessSelect* v4_TranslationalStiffnessZ, ::Ifc4::IfcRotationalStiffnessSelect* v5_RotationalStiffnessX, ::Ifc4::IfcRotationalStiffnessSelect* v6_RotationalStiffnessY, ::Ifc4::IfcRotationalStiffnessSelect* v7_RotationalStiffnessZ) : IfcBoundaryCondition(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_TranslationalStiffnessX ? v2_TranslationalStiffnessX->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_TranslationalStiffnessY ? v3_TranslationalStiffnessY->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_TranslationalStiffnessZ ? v4_TranslationalStiffnessZ->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, v5_RotationalStiffnessX ? v5_RotationalStiffnessX->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RotationalStiffnessY ? v6_RotationalStiffnessY->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_RotationalStiffnessZ ? v7_RotationalStiffnessZ->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBoundaryNodeConditionWarping
::Ifc4::IfcWarpingStiffnessSelect* Ifc4::IfcBoundaryNodeConditionWarping::WarpingStiffness() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcWarpingStiffnessSelect>(true); }
void Ifc4::IfcBoundaryNodeConditionWarping::setWarpingStiffness(::Ifc4::IfcWarpingStiffnessSelect* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }


const IfcParse::entity& Ifc4::IfcBoundaryNodeConditionWarping::declaration() const { return *((IfcParse::entity*)IFC4_types[79]); }
const IfcParse::entity& Ifc4::IfcBoundaryNodeConditionWarping::Class() { return *((IfcParse::entity*)IFC4_types[79]); }
Ifc4::IfcBoundaryNodeConditionWarping::IfcBoundaryNodeConditionWarping(IfcEntityInstanceData&& e) : IfcBoundaryNodeCondition(std::move(e)) { }
Ifc4::IfcBoundaryNodeConditionWarping::IfcBoundaryNodeConditionWarping(boost::optional< std::string > v1_Name, ::Ifc4::IfcTranslationalStiffnessSelect* v2_TranslationalStiffnessX, ::Ifc4::IfcTranslationalStiffnessSelect* v3_TranslationalStiffnessY, ::Ifc4::IfcTranslationalStiffnessSelect* v4_TranslationalStiffnessZ, ::Ifc4::IfcRotationalStiffnessSelect* v5_RotationalStiffnessX, ::Ifc4::IfcRotationalStiffnessSelect* v6_RotationalStiffnessY, ::Ifc4::IfcRotationalStiffnessSelect* v7_RotationalStiffnessZ, ::Ifc4::IfcWarpingStiffnessSelect* v8_WarpingStiffness) : IfcBoundaryNodeCondition(IfcEntityInstanceData(storage_t(8))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_TranslationalStiffnessX ? v2_TranslationalStiffnessX->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_TranslationalStiffnessY ? v3_TranslationalStiffnessY->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_TranslationalStiffnessZ ? v4_TranslationalStiffnessZ->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, v5_RotationalStiffnessX ? v5_RotationalStiffnessX->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RotationalStiffnessY ? v6_RotationalStiffnessY->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_RotationalStiffnessZ ? v7_RotationalStiffnessZ->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_WarpingStiffness ? v8_WarpingStiffness->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBoundedCurve


const IfcParse::entity& Ifc4::IfcBoundedCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[80]); }
const IfcParse::entity& Ifc4::IfcBoundedCurve::Class() { return *((IfcParse::entity*)IFC4_types[80]); }
Ifc4::IfcBoundedCurve::IfcBoundedCurve(IfcEntityInstanceData&& e) : IfcCurve(std::move(e)) { }
Ifc4::IfcBoundedCurve::IfcBoundedCurve() : IfcCurve(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcBoundedSurface


const IfcParse::entity& Ifc4::IfcBoundedSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[81]); }
const IfcParse::entity& Ifc4::IfcBoundedSurface::Class() { return *((IfcParse::entity*)IFC4_types[81]); }
Ifc4::IfcBoundedSurface::IfcBoundedSurface(IfcEntityInstanceData&& e) : IfcSurface(std::move(e)) { }
Ifc4::IfcBoundedSurface::IfcBoundedSurface() : IfcSurface(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcBoundingBox
::Ifc4::IfcCartesianPoint* Ifc4::IfcBoundingBox::Corner() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCartesianPoint>(true); }
void Ifc4::IfcBoundingBox::setCorner(::Ifc4::IfcCartesianPoint* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcBoundingBox::XDim() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcBoundingBox::setXDim(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcBoundingBox::YDim() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcBoundingBox::setYDim(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcBoundingBox::ZDim() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcBoundingBox::setZDim(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcBoundingBox::declaration() const { return *((IfcParse::entity*)IFC4_types[82]); }
const IfcParse::entity& Ifc4::IfcBoundingBox::Class() { return *((IfcParse::entity*)IFC4_types[82]); }
Ifc4::IfcBoundingBox::IfcBoundingBox(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcBoundingBox::IfcBoundingBox(::Ifc4::IfcCartesianPoint* v1_Corner, double v2_XDim, double v3_YDim, double v4_ZDim) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_Corner ? v1_Corner->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_XDim));set_attribute_value(2, (v3_YDim));set_attribute_value(3, (v4_ZDim));; populate_derived(); }

// Function implementations for IfcBoxedHalfSpace
::Ifc4::IfcBoundingBox* Ifc4::IfcBoxedHalfSpace::Enclosure() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcBoundingBox>(true); }
void Ifc4::IfcBoxedHalfSpace::setEnclosure(::Ifc4::IfcBoundingBox* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcBoxedHalfSpace::declaration() const { return *((IfcParse::entity*)IFC4_types[84]); }
const IfcParse::entity& Ifc4::IfcBoxedHalfSpace::Class() { return *((IfcParse::entity*)IFC4_types[84]); }
Ifc4::IfcBoxedHalfSpace::IfcBoxedHalfSpace(IfcEntityInstanceData&& e) : IfcHalfSpaceSolid(std::move(e)) { }
Ifc4::IfcBoxedHalfSpace::IfcBoxedHalfSpace(::Ifc4::IfcSurface* v1_BaseSurface, bool v2_AgreementFlag, ::Ifc4::IfcBoundingBox* v3_Enclosure) : IfcHalfSpaceSolid(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_BaseSurface ? v1_BaseSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_AgreementFlag));set_attribute_value(2, v3_Enclosure ? v3_Enclosure->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBuilding
boost::optional< double > Ifc4::IfcBuilding::ElevationOfRefHeight() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcBuilding::setElevationOfRefHeight(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcBuilding::ElevationOfTerrain() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcBuilding::setElevationOfTerrain(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
::Ifc4::IfcPostalAddress* Ifc4::IfcBuilding::BuildingAddress() const { if(data_.get_attribute_value(11).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(11)))->as<::Ifc4::IfcPostalAddress>(true); }
void Ifc4::IfcBuilding::setBuildingAddress(::Ifc4::IfcPostalAddress* v) { set_attribute_value(11, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcBuilding::declaration() const { return *((IfcParse::entity*)IFC4_types[91]); }
const IfcParse::entity& Ifc4::IfcBuilding::Class() { return *((IfcParse::entity*)IFC4_types[91]); }
Ifc4::IfcBuilding::IfcBuilding(IfcEntityInstanceData&& e) : IfcSpatialStructureElement(std::move(e)) { }
Ifc4::IfcBuilding::IfcBuilding(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName, boost::optional< ::Ifc4::IfcElementCompositionEnum::Value > v9_CompositionType, boost::optional< double > v10_ElevationOfRefHeight, boost::optional< double > v11_ElevationOfTerrain, ::Ifc4::IfcPostalAddress* v12_BuildingAddress) : IfcSpatialStructureElement(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); } if (v9_CompositionType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElementCompositionEnum::Class(),(size_t)*v9_CompositionType))); } if (v10_ElevationOfRefHeight) {set_attribute_value(9, (*v10_ElevationOfRefHeight)); } if (v11_ElevationOfTerrain) {set_attribute_value(10, (*v11_ElevationOfTerrain)); }set_attribute_value(11, v12_BuildingAddress ? v12_BuildingAddress->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcBuildingElement


const IfcParse::entity& Ifc4::IfcBuildingElement::declaration() const { return *((IfcParse::entity*)IFC4_types[92]); }
const IfcParse::entity& Ifc4::IfcBuildingElement::Class() { return *((IfcParse::entity*)IFC4_types[92]); }
Ifc4::IfcBuildingElement::IfcBuildingElement(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcBuildingElement::IfcBuildingElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcBuildingElementPart
boost::optional< ::Ifc4::IfcBuildingElementPartTypeEnum::Value > Ifc4::IfcBuildingElementPart::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcBuildingElementPartTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcBuildingElementPart::setPredefinedType(boost::optional< ::Ifc4::IfcBuildingElementPartTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcBuildingElementPartTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcBuildingElementPart::declaration() const { return *((IfcParse::entity*)IFC4_types[93]); }
const IfcParse::entity& Ifc4::IfcBuildingElementPart::Class() { return *((IfcParse::entity*)IFC4_types[93]); }
Ifc4::IfcBuildingElementPart::IfcBuildingElementPart(IfcEntityInstanceData&& e) : IfcElementComponent(std::move(e)) { }
Ifc4::IfcBuildingElementPart::IfcBuildingElementPart(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcBuildingElementPartTypeEnum::Value > v9_PredefinedType) : IfcElementComponent(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcBuildingElementPartTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcBuildingElementPartType
::Ifc4::IfcBuildingElementPartTypeEnum::Value Ifc4::IfcBuildingElementPartType::PredefinedType() const {  return ::Ifc4::IfcBuildingElementPartTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcBuildingElementPartType::setPredefinedType(::Ifc4::IfcBuildingElementPartTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcBuildingElementPartTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcBuildingElementPartType::declaration() const { return *((IfcParse::entity*)IFC4_types[94]); }
const IfcParse::entity& Ifc4::IfcBuildingElementPartType::Class() { return *((IfcParse::entity*)IFC4_types[94]); }
Ifc4::IfcBuildingElementPartType::IfcBuildingElementPartType(IfcEntityInstanceData&& e) : IfcElementComponentType(std::move(e)) { }
Ifc4::IfcBuildingElementPartType::IfcBuildingElementPartType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcBuildingElementPartTypeEnum::Value v10_PredefinedType) : IfcElementComponentType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcBuildingElementPartTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcBuildingElementProxy
boost::optional< ::Ifc4::IfcBuildingElementProxyTypeEnum::Value > Ifc4::IfcBuildingElementProxy::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcBuildingElementProxyTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcBuildingElementProxy::setPredefinedType(boost::optional< ::Ifc4::IfcBuildingElementProxyTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcBuildingElementProxyTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcBuildingElementProxy::declaration() const { return *((IfcParse::entity*)IFC4_types[96]); }
const IfcParse::entity& Ifc4::IfcBuildingElementProxy::Class() { return *((IfcParse::entity*)IFC4_types[96]); }
Ifc4::IfcBuildingElementProxy::IfcBuildingElementProxy(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcBuildingElementProxy::IfcBuildingElementProxy(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcBuildingElementProxyTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcBuildingElementProxyTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcBuildingElementProxyType
::Ifc4::IfcBuildingElementProxyTypeEnum::Value Ifc4::IfcBuildingElementProxyType::PredefinedType() const {  return ::Ifc4::IfcBuildingElementProxyTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcBuildingElementProxyType::setPredefinedType(::Ifc4::IfcBuildingElementProxyTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcBuildingElementProxyTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcBuildingElementProxyType::declaration() const { return *((IfcParse::entity*)IFC4_types[97]); }
const IfcParse::entity& Ifc4::IfcBuildingElementProxyType::Class() { return *((IfcParse::entity*)IFC4_types[97]); }
Ifc4::IfcBuildingElementProxyType::IfcBuildingElementProxyType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcBuildingElementProxyType::IfcBuildingElementProxyType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcBuildingElementProxyTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcBuildingElementProxyTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcBuildingElementType


const IfcParse::entity& Ifc4::IfcBuildingElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[99]); }
const IfcParse::entity& Ifc4::IfcBuildingElementType::Class() { return *((IfcParse::entity*)IFC4_types[99]); }
Ifc4::IfcBuildingElementType::IfcBuildingElementType(IfcEntityInstanceData&& e) : IfcElementType(std::move(e)) { }
Ifc4::IfcBuildingElementType::IfcBuildingElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcBuildingStorey
boost::optional< double > Ifc4::IfcBuildingStorey::Elevation() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcBuildingStorey::setElevation(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcBuildingStorey::declaration() const { return *((IfcParse::entity*)IFC4_types[100]); }
const IfcParse::entity& Ifc4::IfcBuildingStorey::Class() { return *((IfcParse::entity*)IFC4_types[100]); }
Ifc4::IfcBuildingStorey::IfcBuildingStorey(IfcEntityInstanceData&& e) : IfcSpatialStructureElement(std::move(e)) { }
Ifc4::IfcBuildingStorey::IfcBuildingStorey(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName, boost::optional< ::Ifc4::IfcElementCompositionEnum::Value > v9_CompositionType, boost::optional< double > v10_Elevation) : IfcSpatialStructureElement(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); } if (v9_CompositionType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElementCompositionEnum::Class(),(size_t)*v9_CompositionType))); } if (v10_Elevation) {set_attribute_value(9, (*v10_Elevation)); }; populate_derived(); }

// Function implementations for IfcBuildingSystem
boost::optional< ::Ifc4::IfcBuildingSystemTypeEnum::Value > Ifc4::IfcBuildingSystem::PredefinedType() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } return ::Ifc4::IfcBuildingSystemTypeEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcBuildingSystem::setPredefinedType(boost::optional< ::Ifc4::IfcBuildingSystemTypeEnum::Value > v) { if (v) {set_attribute_value(5, EnumerationReference(&::Ifc4::IfcBuildingSystemTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcBuildingSystem::LongName() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcBuildingSystem::setLongName(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcBuildingSystem::declaration() const { return *((IfcParse::entity*)IFC4_types[101]); }
const IfcParse::entity& Ifc4::IfcBuildingSystem::Class() { return *((IfcParse::entity*)IFC4_types[101]); }
Ifc4::IfcBuildingSystem::IfcBuildingSystem(IfcEntityInstanceData&& e) : IfcSystem(std::move(e)) { }
Ifc4::IfcBuildingSystem::IfcBuildingSystem(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< ::Ifc4::IfcBuildingSystemTypeEnum::Value > v6_PredefinedType, boost::optional< std::string > v7_LongName) : IfcSystem(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_PredefinedType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcBuildingSystemTypeEnum::Class(),(size_t)*v6_PredefinedType))); } if (v7_LongName) {set_attribute_value(6, (*v7_LongName)); }; populate_derived(); }

// Function implementations for IfcBurner
boost::optional< ::Ifc4::IfcBurnerTypeEnum::Value > Ifc4::IfcBurner::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcBurnerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcBurner::setPredefinedType(boost::optional< ::Ifc4::IfcBurnerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcBurnerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcBurner::declaration() const { return *((IfcParse::entity*)IFC4_types[103]); }
const IfcParse::entity& Ifc4::IfcBurner::Class() { return *((IfcParse::entity*)IFC4_types[103]); }
Ifc4::IfcBurner::IfcBurner(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcBurner::IfcBurner(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcBurnerTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcBurnerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcBurnerType
::Ifc4::IfcBurnerTypeEnum::Value Ifc4::IfcBurnerType::PredefinedType() const {  return ::Ifc4::IfcBurnerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcBurnerType::setPredefinedType(::Ifc4::IfcBurnerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcBurnerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcBurnerType::declaration() const { return *((IfcParse::entity*)IFC4_types[104]); }
const IfcParse::entity& Ifc4::IfcBurnerType::Class() { return *((IfcParse::entity*)IFC4_types[104]); }
Ifc4::IfcBurnerType::IfcBurnerType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcBurnerType::IfcBurnerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcBurnerTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcBurnerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCShapeProfileDef
double Ifc4::IfcCShapeProfileDef::Depth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcCShapeProfileDef::setDepth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcCShapeProfileDef::Width() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcCShapeProfileDef::setWidth(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
double Ifc4::IfcCShapeProfileDef::WallThickness() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcCShapeProfileDef::setWallThickness(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcCShapeProfileDef::Girth() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcCShapeProfileDef::setGirth(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
boost::optional< double > Ifc4::IfcCShapeProfileDef::InternalFilletRadius() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcCShapeProfileDef::setInternalFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcCShapeProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[231]); }
const IfcParse::entity& Ifc4::IfcCShapeProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[231]); }
Ifc4::IfcCShapeProfileDef::IfcCShapeProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcCShapeProfileDef::IfcCShapeProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_Depth, double v5_Width, double v6_WallThickness, double v7_Girth, boost::optional< double > v8_InternalFilletRadius) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Depth));set_attribute_value(4, (v5_Width));set_attribute_value(5, (v6_WallThickness));set_attribute_value(6, (v7_Girth)); if (v8_InternalFilletRadius) {set_attribute_value(7, (*v8_InternalFilletRadius)); }; populate_derived(); }

// Function implementations for IfcCableCarrierFitting
boost::optional< ::Ifc4::IfcCableCarrierFittingTypeEnum::Value > Ifc4::IfcCableCarrierFitting::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCableCarrierFittingTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCableCarrierFitting::setPredefinedType(boost::optional< ::Ifc4::IfcCableCarrierFittingTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCableCarrierFittingTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCableCarrierFitting::declaration() const { return *((IfcParse::entity*)IFC4_types[106]); }
const IfcParse::entity& Ifc4::IfcCableCarrierFitting::Class() { return *((IfcParse::entity*)IFC4_types[106]); }
Ifc4::IfcCableCarrierFitting::IfcCableCarrierFitting(IfcEntityInstanceData&& e) : IfcFlowFitting(std::move(e)) { }
Ifc4::IfcCableCarrierFitting::IfcCableCarrierFitting(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCableCarrierFittingTypeEnum::Value > v9_PredefinedType) : IfcFlowFitting(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCableCarrierFittingTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCableCarrierFittingType
::Ifc4::IfcCableCarrierFittingTypeEnum::Value Ifc4::IfcCableCarrierFittingType::PredefinedType() const {  return ::Ifc4::IfcCableCarrierFittingTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCableCarrierFittingType::setPredefinedType(::Ifc4::IfcCableCarrierFittingTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCableCarrierFittingTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCableCarrierFittingType::declaration() const { return *((IfcParse::entity*)IFC4_types[107]); }
const IfcParse::entity& Ifc4::IfcCableCarrierFittingType::Class() { return *((IfcParse::entity*)IFC4_types[107]); }
Ifc4::IfcCableCarrierFittingType::IfcCableCarrierFittingType(IfcEntityInstanceData&& e) : IfcFlowFittingType(std::move(e)) { }
Ifc4::IfcCableCarrierFittingType::IfcCableCarrierFittingType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCableCarrierFittingTypeEnum::Value v10_PredefinedType) : IfcFlowFittingType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCableCarrierFittingTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCableCarrierSegment
boost::optional< ::Ifc4::IfcCableCarrierSegmentTypeEnum::Value > Ifc4::IfcCableCarrierSegment::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCableCarrierSegmentTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCableCarrierSegment::setPredefinedType(boost::optional< ::Ifc4::IfcCableCarrierSegmentTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCableCarrierSegmentTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCableCarrierSegment::declaration() const { return *((IfcParse::entity*)IFC4_types[109]); }
const IfcParse::entity& Ifc4::IfcCableCarrierSegment::Class() { return *((IfcParse::entity*)IFC4_types[109]); }
Ifc4::IfcCableCarrierSegment::IfcCableCarrierSegment(IfcEntityInstanceData&& e) : IfcFlowSegment(std::move(e)) { }
Ifc4::IfcCableCarrierSegment::IfcCableCarrierSegment(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCableCarrierSegmentTypeEnum::Value > v9_PredefinedType) : IfcFlowSegment(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCableCarrierSegmentTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCableCarrierSegmentType
::Ifc4::IfcCableCarrierSegmentTypeEnum::Value Ifc4::IfcCableCarrierSegmentType::PredefinedType() const {  return ::Ifc4::IfcCableCarrierSegmentTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCableCarrierSegmentType::setPredefinedType(::Ifc4::IfcCableCarrierSegmentTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCableCarrierSegmentTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCableCarrierSegmentType::declaration() const { return *((IfcParse::entity*)IFC4_types[110]); }
const IfcParse::entity& Ifc4::IfcCableCarrierSegmentType::Class() { return *((IfcParse::entity*)IFC4_types[110]); }
Ifc4::IfcCableCarrierSegmentType::IfcCableCarrierSegmentType(IfcEntityInstanceData&& e) : IfcFlowSegmentType(std::move(e)) { }
Ifc4::IfcCableCarrierSegmentType::IfcCableCarrierSegmentType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCableCarrierSegmentTypeEnum::Value v10_PredefinedType) : IfcFlowSegmentType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCableCarrierSegmentTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCableFitting
boost::optional< ::Ifc4::IfcCableFittingTypeEnum::Value > Ifc4::IfcCableFitting::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCableFittingTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCableFitting::setPredefinedType(boost::optional< ::Ifc4::IfcCableFittingTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCableFittingTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCableFitting::declaration() const { return *((IfcParse::entity*)IFC4_types[112]); }
const IfcParse::entity& Ifc4::IfcCableFitting::Class() { return *((IfcParse::entity*)IFC4_types[112]); }
Ifc4::IfcCableFitting::IfcCableFitting(IfcEntityInstanceData&& e) : IfcFlowFitting(std::move(e)) { }
Ifc4::IfcCableFitting::IfcCableFitting(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCableFittingTypeEnum::Value > v9_PredefinedType) : IfcFlowFitting(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCableFittingTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCableFittingType
::Ifc4::IfcCableFittingTypeEnum::Value Ifc4::IfcCableFittingType::PredefinedType() const {  return ::Ifc4::IfcCableFittingTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCableFittingType::setPredefinedType(::Ifc4::IfcCableFittingTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCableFittingTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCableFittingType::declaration() const { return *((IfcParse::entity*)IFC4_types[113]); }
const IfcParse::entity& Ifc4::IfcCableFittingType::Class() { return *((IfcParse::entity*)IFC4_types[113]); }
Ifc4::IfcCableFittingType::IfcCableFittingType(IfcEntityInstanceData&& e) : IfcFlowFittingType(std::move(e)) { }
Ifc4::IfcCableFittingType::IfcCableFittingType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCableFittingTypeEnum::Value v10_PredefinedType) : IfcFlowFittingType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCableFittingTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCableSegment
boost::optional< ::Ifc4::IfcCableSegmentTypeEnum::Value > Ifc4::IfcCableSegment::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCableSegmentTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCableSegment::setPredefinedType(boost::optional< ::Ifc4::IfcCableSegmentTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCableSegmentTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCableSegment::declaration() const { return *((IfcParse::entity*)IFC4_types[115]); }
const IfcParse::entity& Ifc4::IfcCableSegment::Class() { return *((IfcParse::entity*)IFC4_types[115]); }
Ifc4::IfcCableSegment::IfcCableSegment(IfcEntityInstanceData&& e) : IfcFlowSegment(std::move(e)) { }
Ifc4::IfcCableSegment::IfcCableSegment(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCableSegmentTypeEnum::Value > v9_PredefinedType) : IfcFlowSegment(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCableSegmentTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCableSegmentType
::Ifc4::IfcCableSegmentTypeEnum::Value Ifc4::IfcCableSegmentType::PredefinedType() const {  return ::Ifc4::IfcCableSegmentTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCableSegmentType::setPredefinedType(::Ifc4::IfcCableSegmentTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCableSegmentTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCableSegmentType::declaration() const { return *((IfcParse::entity*)IFC4_types[116]); }
const IfcParse::entity& Ifc4::IfcCableSegmentType::Class() { return *((IfcParse::entity*)IFC4_types[116]); }
Ifc4::IfcCableSegmentType::IfcCableSegmentType(IfcEntityInstanceData&& e) : IfcFlowSegmentType(std::move(e)) { }
Ifc4::IfcCableSegmentType::IfcCableSegmentType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCableSegmentTypeEnum::Value v10_PredefinedType) : IfcFlowSegmentType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCableSegmentTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCartesianPoint
std::vector< double > /*[1:3]*/ Ifc4::IfcCartesianPoint::Coordinates() const {  std::vector< double > /*[1:3]*/ v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcCartesianPoint::setCoordinates(std::vector< double > /*[1:3]*/ v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcCartesianPoint::declaration() const { return *((IfcParse::entity*)IFC4_types[119]); }
const IfcParse::entity& Ifc4::IfcCartesianPoint::Class() { return *((IfcParse::entity*)IFC4_types[119]); }
Ifc4::IfcCartesianPoint::IfcCartesianPoint(IfcEntityInstanceData&& e) : IfcPoint(std::move(e)) { }
Ifc4::IfcCartesianPoint::IfcCartesianPoint(std::vector< double > /*[1:3]*/ v1_Coordinates) : IfcPoint(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Coordinates));; populate_derived(); }

// Function implementations for IfcCartesianPointList


const IfcParse::entity& Ifc4::IfcCartesianPointList::declaration() const { return *((IfcParse::entity*)IFC4_types[120]); }
const IfcParse::entity& Ifc4::IfcCartesianPointList::Class() { return *((IfcParse::entity*)IFC4_types[120]); }
Ifc4::IfcCartesianPointList::IfcCartesianPointList(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcCartesianPointList::IfcCartesianPointList() : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcCartesianPointList2D
std::vector< std::vector< double > > Ifc4::IfcCartesianPointList2D::CoordList() const {  std::vector< std::vector< double > > v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcCartesianPointList2D::setCoordList(std::vector< std::vector< double > > v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcCartesianPointList2D::declaration() const { return *((IfcParse::entity*)IFC4_types[121]); }
const IfcParse::entity& Ifc4::IfcCartesianPointList2D::Class() { return *((IfcParse::entity*)IFC4_types[121]); }
Ifc4::IfcCartesianPointList2D::IfcCartesianPointList2D(IfcEntityInstanceData&& e) : IfcCartesianPointList(std::move(e)) { }
Ifc4::IfcCartesianPointList2D::IfcCartesianPointList2D(std::vector< std::vector< double > > v1_CoordList) : IfcCartesianPointList(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_CoordList));; populate_derived(); }

// Function implementations for IfcCartesianPointList3D
std::vector< std::vector< double > > Ifc4::IfcCartesianPointList3D::CoordList() const {  std::vector< std::vector< double > > v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcCartesianPointList3D::setCoordList(std::vector< std::vector< double > > v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcCartesianPointList3D::declaration() const { return *((IfcParse::entity*)IFC4_types[122]); }
const IfcParse::entity& Ifc4::IfcCartesianPointList3D::Class() { return *((IfcParse::entity*)IFC4_types[122]); }
Ifc4::IfcCartesianPointList3D::IfcCartesianPointList3D(IfcEntityInstanceData&& e) : IfcCartesianPointList(std::move(e)) { }
Ifc4::IfcCartesianPointList3D::IfcCartesianPointList3D(std::vector< std::vector< double > > v1_CoordList) : IfcCartesianPointList(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_CoordList));; populate_derived(); }

// Function implementations for IfcCartesianTransformationOperator
::Ifc4::IfcDirection* Ifc4::IfcCartesianTransformationOperator::Axis1() const { if(data_.get_attribute_value(0).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcCartesianTransformationOperator::setAxis1(::Ifc4::IfcDirection* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcDirection* Ifc4::IfcCartesianTransformationOperator::Axis2() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcCartesianTransformationOperator::setAxis2(::Ifc4::IfcDirection* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcCartesianPoint* Ifc4::IfcCartesianTransformationOperator::LocalOrigin() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcCartesianPoint>(true); }
void Ifc4::IfcCartesianTransformationOperator::setLocalOrigin(::Ifc4::IfcCartesianPoint* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
boost::optional< double > Ifc4::IfcCartesianTransformationOperator::Scale() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcCartesianTransformationOperator::setScale(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator::declaration() const { return *((IfcParse::entity*)IFC4_types[123]); }
const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator::Class() { return *((IfcParse::entity*)IFC4_types[123]); }
Ifc4::IfcCartesianTransformationOperator::IfcCartesianTransformationOperator(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcCartesianTransformationOperator::IfcCartesianTransformationOperator(::Ifc4::IfcDirection* v1_Axis1, ::Ifc4::IfcDirection* v2_Axis2, ::Ifc4::IfcCartesianPoint* v3_LocalOrigin, boost::optional< double > v4_Scale) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_Axis1 ? v1_Axis1->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Axis2 ? v2_Axis2->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_LocalOrigin ? v3_LocalOrigin->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_Scale) {set_attribute_value(3, (*v4_Scale)); }; populate_derived(); }

// Function implementations for IfcCartesianTransformationOperator2D


const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator2D::declaration() const { return *((IfcParse::entity*)IFC4_types[124]); }
const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator2D::Class() { return *((IfcParse::entity*)IFC4_types[124]); }
Ifc4::IfcCartesianTransformationOperator2D::IfcCartesianTransformationOperator2D(IfcEntityInstanceData&& e) : IfcCartesianTransformationOperator(std::move(e)) { }
Ifc4::IfcCartesianTransformationOperator2D::IfcCartesianTransformationOperator2D(::Ifc4::IfcDirection* v1_Axis1, ::Ifc4::IfcDirection* v2_Axis2, ::Ifc4::IfcCartesianPoint* v3_LocalOrigin, boost::optional< double > v4_Scale) : IfcCartesianTransformationOperator(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_Axis1 ? v1_Axis1->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Axis2 ? v2_Axis2->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_LocalOrigin ? v3_LocalOrigin->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_Scale) {set_attribute_value(3, (*v4_Scale)); }; populate_derived(); }

// Function implementations for IfcCartesianTransformationOperator2DnonUniform
boost::optional< double > Ifc4::IfcCartesianTransformationOperator2DnonUniform::Scale2() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcCartesianTransformationOperator2DnonUniform::setScale2(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator2DnonUniform::declaration() const { return *((IfcParse::entity*)IFC4_types[125]); }
const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator2DnonUniform::Class() { return *((IfcParse::entity*)IFC4_types[125]); }
Ifc4::IfcCartesianTransformationOperator2DnonUniform::IfcCartesianTransformationOperator2DnonUniform(IfcEntityInstanceData&& e) : IfcCartesianTransformationOperator2D(std::move(e)) { }
Ifc4::IfcCartesianTransformationOperator2DnonUniform::IfcCartesianTransformationOperator2DnonUniform(::Ifc4::IfcDirection* v1_Axis1, ::Ifc4::IfcDirection* v2_Axis2, ::Ifc4::IfcCartesianPoint* v3_LocalOrigin, boost::optional< double > v4_Scale, boost::optional< double > v5_Scale2) : IfcCartesianTransformationOperator2D(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_Axis1 ? v1_Axis1->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Axis2 ? v2_Axis2->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_LocalOrigin ? v3_LocalOrigin->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_Scale) {set_attribute_value(3, (*v4_Scale)); } if (v5_Scale2) {set_attribute_value(4, (*v5_Scale2)); }; populate_derived(); }

// Function implementations for IfcCartesianTransformationOperator3D
::Ifc4::IfcDirection* Ifc4::IfcCartesianTransformationOperator3D::Axis3() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcCartesianTransformationOperator3D::setAxis3(::Ifc4::IfcDirection* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator3D::declaration() const { return *((IfcParse::entity*)IFC4_types[126]); }
const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator3D::Class() { return *((IfcParse::entity*)IFC4_types[126]); }
Ifc4::IfcCartesianTransformationOperator3D::IfcCartesianTransformationOperator3D(IfcEntityInstanceData&& e) : IfcCartesianTransformationOperator(std::move(e)) { }
Ifc4::IfcCartesianTransformationOperator3D::IfcCartesianTransformationOperator3D(::Ifc4::IfcDirection* v1_Axis1, ::Ifc4::IfcDirection* v2_Axis2, ::Ifc4::IfcCartesianPoint* v3_LocalOrigin, boost::optional< double > v4_Scale, ::Ifc4::IfcDirection* v5_Axis3) : IfcCartesianTransformationOperator(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_Axis1 ? v1_Axis1->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Axis2 ? v2_Axis2->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_LocalOrigin ? v3_LocalOrigin->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_Scale) {set_attribute_value(3, (*v4_Scale)); }set_attribute_value(4, v5_Axis3 ? v5_Axis3->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcCartesianTransformationOperator3DnonUniform
boost::optional< double > Ifc4::IfcCartesianTransformationOperator3DnonUniform::Scale2() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcCartesianTransformationOperator3DnonUniform::setScale2(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< double > Ifc4::IfcCartesianTransformationOperator3DnonUniform::Scale3() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcCartesianTransformationOperator3DnonUniform::setScale3(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator3DnonUniform::declaration() const { return *((IfcParse::entity*)IFC4_types[127]); }
const IfcParse::entity& Ifc4::IfcCartesianTransformationOperator3DnonUniform::Class() { return *((IfcParse::entity*)IFC4_types[127]); }
Ifc4::IfcCartesianTransformationOperator3DnonUniform::IfcCartesianTransformationOperator3DnonUniform(IfcEntityInstanceData&& e) : IfcCartesianTransformationOperator3D(std::move(e)) { }
Ifc4::IfcCartesianTransformationOperator3DnonUniform::IfcCartesianTransformationOperator3DnonUniform(::Ifc4::IfcDirection* v1_Axis1, ::Ifc4::IfcDirection* v2_Axis2, ::Ifc4::IfcCartesianPoint* v3_LocalOrigin, boost::optional< double > v4_Scale, ::Ifc4::IfcDirection* v5_Axis3, boost::optional< double > v6_Scale2, boost::optional< double > v7_Scale3) : IfcCartesianTransformationOperator3D(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, v1_Axis1 ? v1_Axis1->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Axis2 ? v2_Axis2->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_LocalOrigin ? v3_LocalOrigin->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_Scale) {set_attribute_value(3, (*v4_Scale)); }set_attribute_value(4, v5_Axis3 ? v5_Axis3->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v6_Scale2) {set_attribute_value(5, (*v6_Scale2)); } if (v7_Scale3) {set_attribute_value(6, (*v7_Scale3)); }; populate_derived(); }

// Function implementations for IfcCenterLineProfileDef
double Ifc4::IfcCenterLineProfileDef::Thickness() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcCenterLineProfileDef::setThickness(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcCenterLineProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[128]); }
const IfcParse::entity& Ifc4::IfcCenterLineProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[128]); }
Ifc4::IfcCenterLineProfileDef::IfcCenterLineProfileDef(IfcEntityInstanceData&& e) : IfcArbitraryOpenProfileDef(std::move(e)) { }
Ifc4::IfcCenterLineProfileDef::IfcCenterLineProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcBoundedCurve* v3_Curve, double v4_Thickness) : IfcArbitraryOpenProfileDef(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Curve ? v3_Curve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Thickness));; populate_derived(); }

// Function implementations for IfcChiller
boost::optional< ::Ifc4::IfcChillerTypeEnum::Value > Ifc4::IfcChiller::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcChillerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcChiller::setPredefinedType(boost::optional< ::Ifc4::IfcChillerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcChillerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcChiller::declaration() const { return *((IfcParse::entity*)IFC4_types[130]); }
const IfcParse::entity& Ifc4::IfcChiller::Class() { return *((IfcParse::entity*)IFC4_types[130]); }
Ifc4::IfcChiller::IfcChiller(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcChiller::IfcChiller(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcChillerTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcChillerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcChillerType
::Ifc4::IfcChillerTypeEnum::Value Ifc4::IfcChillerType::PredefinedType() const {  return ::Ifc4::IfcChillerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcChillerType::setPredefinedType(::Ifc4::IfcChillerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcChillerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcChillerType::declaration() const { return *((IfcParse::entity*)IFC4_types[131]); }
const IfcParse::entity& Ifc4::IfcChillerType::Class() { return *((IfcParse::entity*)IFC4_types[131]); }
Ifc4::IfcChillerType::IfcChillerType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcChillerType::IfcChillerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcChillerTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcChillerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcChimney
boost::optional< ::Ifc4::IfcChimneyTypeEnum::Value > Ifc4::IfcChimney::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcChimneyTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcChimney::setPredefinedType(boost::optional< ::Ifc4::IfcChimneyTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcChimneyTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcChimney::declaration() const { return *((IfcParse::entity*)IFC4_types[133]); }
const IfcParse::entity& Ifc4::IfcChimney::Class() { return *((IfcParse::entity*)IFC4_types[133]); }
Ifc4::IfcChimney::IfcChimney(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcChimney::IfcChimney(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcChimneyTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcChimneyTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcChimneyType
::Ifc4::IfcChimneyTypeEnum::Value Ifc4::IfcChimneyType::PredefinedType() const {  return ::Ifc4::IfcChimneyTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcChimneyType::setPredefinedType(::Ifc4::IfcChimneyTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcChimneyTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcChimneyType::declaration() const { return *((IfcParse::entity*)IFC4_types[134]); }
const IfcParse::entity& Ifc4::IfcChimneyType::Class() { return *((IfcParse::entity*)IFC4_types[134]); }
Ifc4::IfcChimneyType::IfcChimneyType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcChimneyType::IfcChimneyType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcChimneyTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcChimneyTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCircle
double Ifc4::IfcCircle::Radius() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcCircle::setRadius(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcCircle::declaration() const { return *((IfcParse::entity*)IFC4_types[136]); }
const IfcParse::entity& Ifc4::IfcCircle::Class() { return *((IfcParse::entity*)IFC4_types[136]); }
Ifc4::IfcCircle::IfcCircle(IfcEntityInstanceData&& e) : IfcConic(std::move(e)) { }
Ifc4::IfcCircle::IfcCircle(::Ifc4::IfcAxis2Placement* v1_Position, double v2_Radius) : IfcConic(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Radius));; populate_derived(); }

// Function implementations for IfcCircleHollowProfileDef
double Ifc4::IfcCircleHollowProfileDef::WallThickness() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcCircleHollowProfileDef::setWallThickness(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcCircleHollowProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[137]); }
const IfcParse::entity& Ifc4::IfcCircleHollowProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[137]); }
Ifc4::IfcCircleHollowProfileDef::IfcCircleHollowProfileDef(IfcEntityInstanceData&& e) : IfcCircleProfileDef(std::move(e)) { }
Ifc4::IfcCircleHollowProfileDef::IfcCircleHollowProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_Radius, double v5_WallThickness) : IfcCircleProfileDef(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Radius));set_attribute_value(4, (v5_WallThickness));; populate_derived(); }

// Function implementations for IfcCircleProfileDef
double Ifc4::IfcCircleProfileDef::Radius() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcCircleProfileDef::setRadius(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcCircleProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[138]); }
const IfcParse::entity& Ifc4::IfcCircleProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[138]); }
Ifc4::IfcCircleProfileDef::IfcCircleProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcCircleProfileDef::IfcCircleProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_Radius) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Radius));; populate_derived(); }

// Function implementations for IfcCivilElement


const IfcParse::entity& Ifc4::IfcCivilElement::declaration() const { return *((IfcParse::entity*)IFC4_types[139]); }
const IfcParse::entity& Ifc4::IfcCivilElement::Class() { return *((IfcParse::entity*)IFC4_types[139]); }
Ifc4::IfcCivilElement::IfcCivilElement(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcCivilElement::IfcCivilElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcCivilElementType


const IfcParse::entity& Ifc4::IfcCivilElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[140]); }
const IfcParse::entity& Ifc4::IfcCivilElementType::Class() { return *((IfcParse::entity*)IFC4_types[140]); }
Ifc4::IfcCivilElementType::IfcCivilElementType(IfcEntityInstanceData&& e) : IfcElementType(std::move(e)) { }
Ifc4::IfcCivilElementType::IfcCivilElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcClassification
boost::optional< std::string > Ifc4::IfcClassification::Source() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcClassification::setSource(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcClassification::Edition() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcClassification::setEdition(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcClassification::EditionDate() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcClassification::setEditionDate(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
std::string Ifc4::IfcClassification::Name() const {  std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcClassification::setName(std::string v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcClassification::Description() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcClassification::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcClassification::Location() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcClassification::setLocation(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcClassification::ReferenceTokens() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcClassification::setReferenceTokens(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }

::Ifc4::IfcRelAssociatesClassification::list::ptr Ifc4::IfcClassification::ClassificationForObjects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[808], 5)->as<IfcRelAssociatesClassification>(); }
::Ifc4::IfcClassificationReference::list::ptr Ifc4::IfcClassification::HasReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[142], 3)->as<IfcClassificationReference>(); }

const IfcParse::entity& Ifc4::IfcClassification::declaration() const { return *((IfcParse::entity*)IFC4_types[141]); }
const IfcParse::entity& Ifc4::IfcClassification::Class() { return *((IfcParse::entity*)IFC4_types[141]); }
Ifc4::IfcClassification::IfcClassification(IfcEntityInstanceData&& e) : IfcExternalInformation(std::move(e)) { }
Ifc4::IfcClassification::IfcClassification(boost::optional< std::string > v1_Source, boost::optional< std::string > v2_Edition, boost::optional< std::string > v3_EditionDate, std::string v4_Name, boost::optional< std::string > v5_Description, boost::optional< std::string > v6_Location, boost::optional< std::vector< std::string > /*[1:?]*/ > v7_ReferenceTokens) : IfcExternalInformation(IfcEntityInstanceData(storage_t(7))) {  if (v1_Source) {set_attribute_value(0, (*v1_Source)); } if (v2_Edition) {set_attribute_value(1, (*v2_Edition)); } if (v3_EditionDate) {set_attribute_value(2, (*v3_EditionDate)); }set_attribute_value(3, (v4_Name)); if (v5_Description) {set_attribute_value(4, (*v5_Description)); } if (v6_Location) {set_attribute_value(5, (*v6_Location)); } if (v7_ReferenceTokens) {set_attribute_value(6, (*v7_ReferenceTokens)); }; populate_derived(); }

// Function implementations for IfcClassificationReference
::Ifc4::IfcClassificationReferenceSelect* Ifc4::IfcClassificationReference::ReferencedSource() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcClassificationReferenceSelect>(true); }
void Ifc4::IfcClassificationReference::setReferencedSource(::Ifc4::IfcClassificationReferenceSelect* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcClassificationReference::Description() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcClassificationReference::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcClassificationReference::Sort() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcClassificationReference::setSort(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }

::Ifc4::IfcRelAssociatesClassification::list::ptr Ifc4::IfcClassificationReference::ClassificationRefForObjects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[808], 5)->as<IfcRelAssociatesClassification>(); }
::Ifc4::IfcClassificationReference::list::ptr Ifc4::IfcClassificationReference::HasReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[142], 3)->as<IfcClassificationReference>(); }

const IfcParse::entity& Ifc4::IfcClassificationReference::declaration() const { return *((IfcParse::entity*)IFC4_types[142]); }
const IfcParse::entity& Ifc4::IfcClassificationReference::Class() { return *((IfcParse::entity*)IFC4_types[142]); }
Ifc4::IfcClassificationReference::IfcClassificationReference(IfcEntityInstanceData&& e) : IfcExternalReference(std::move(e)) { }
Ifc4::IfcClassificationReference::IfcClassificationReference(boost::optional< std::string > v1_Location, boost::optional< std::string > v2_Identification, boost::optional< std::string > v3_Name, ::Ifc4::IfcClassificationReferenceSelect* v4_ReferencedSource, boost::optional< std::string > v5_Description, boost::optional< std::string > v6_Sort) : IfcExternalReference(IfcEntityInstanceData(storage_t(6))) {  if (v1_Location) {set_attribute_value(0, (*v1_Location)); } if (v2_Identification) {set_attribute_value(1, (*v2_Identification)); } if (v3_Name) {set_attribute_value(2, (*v3_Name)); }set_attribute_value(3, v4_ReferencedSource ? v4_ReferencedSource->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Description) {set_attribute_value(4, (*v5_Description)); } if (v6_Sort) {set_attribute_value(5, (*v6_Sort)); }; populate_derived(); }

// Function implementations for IfcClosedShell


const IfcParse::entity& Ifc4::IfcClosedShell::declaration() const { return *((IfcParse::entity*)IFC4_types[145]); }
const IfcParse::entity& Ifc4::IfcClosedShell::Class() { return *((IfcParse::entity*)IFC4_types[145]); }
Ifc4::IfcClosedShell::IfcClosedShell(IfcEntityInstanceData&& e) : IfcConnectedFaceSet(std::move(e)) { }
Ifc4::IfcClosedShell::IfcClosedShell(aggregate_of< ::Ifc4::IfcFace >::ptr v1_CfsFaces) : IfcConnectedFaceSet(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_CfsFaces)->generalize());; populate_derived(); }

// Function implementations for IfcCoil
boost::optional< ::Ifc4::IfcCoilTypeEnum::Value > Ifc4::IfcCoil::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCoilTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCoil::setPredefinedType(boost::optional< ::Ifc4::IfcCoilTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCoilTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCoil::declaration() const { return *((IfcParse::entity*)IFC4_types[146]); }
const IfcParse::entity& Ifc4::IfcCoil::Class() { return *((IfcParse::entity*)IFC4_types[146]); }
Ifc4::IfcCoil::IfcCoil(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcCoil::IfcCoil(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCoilTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCoilTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCoilType
::Ifc4::IfcCoilTypeEnum::Value Ifc4::IfcCoilType::PredefinedType() const {  return ::Ifc4::IfcCoilTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCoilType::setPredefinedType(::Ifc4::IfcCoilTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCoilTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCoilType::declaration() const { return *((IfcParse::entity*)IFC4_types[147]); }
const IfcParse::entity& Ifc4::IfcCoilType::Class() { return *((IfcParse::entity*)IFC4_types[147]); }
Ifc4::IfcCoilType::IfcCoilType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcCoilType::IfcCoilType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCoilTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCoilTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcColourRgb
double Ifc4::IfcColourRgb::Red() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcColourRgb::setRed(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcColourRgb::Green() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcColourRgb::setGreen(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcColourRgb::Blue() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcColourRgb::setBlue(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcColourRgb::declaration() const { return *((IfcParse::entity*)IFC4_types[151]); }
const IfcParse::entity& Ifc4::IfcColourRgb::Class() { return *((IfcParse::entity*)IFC4_types[151]); }
Ifc4::IfcColourRgb::IfcColourRgb(IfcEntityInstanceData&& e) : IfcColourSpecification(std::move(e)) { }
Ifc4::IfcColourRgb::IfcColourRgb(boost::optional< std::string > v1_Name, double v2_Red, double v3_Green, double v4_Blue) : IfcColourSpecification(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, (v2_Red));set_attribute_value(2, (v3_Green));set_attribute_value(3, (v4_Blue));; populate_derived(); }

// Function implementations for IfcColourRgbList
std::vector< std::vector< double > > Ifc4::IfcColourRgbList::ColourList() const {  std::vector< std::vector< double > > v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcColourRgbList::setColourList(std::vector< std::vector< double > > v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcColourRgbList::declaration() const { return *((IfcParse::entity*)IFC4_types[152]); }
const IfcParse::entity& Ifc4::IfcColourRgbList::Class() { return *((IfcParse::entity*)IFC4_types[152]); }
Ifc4::IfcColourRgbList::IfcColourRgbList(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcColourRgbList::IfcColourRgbList(std::vector< std::vector< double > > v1_ColourList) : IfcPresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_ColourList));; populate_derived(); }

// Function implementations for IfcColourSpecification
boost::optional< std::string > Ifc4::IfcColourSpecification::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcColourSpecification::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }


const IfcParse::entity& Ifc4::IfcColourSpecification::declaration() const { return *((IfcParse::entity*)IFC4_types[153]); }
const IfcParse::entity& Ifc4::IfcColourSpecification::Class() { return *((IfcParse::entity*)IFC4_types[153]); }
Ifc4::IfcColourSpecification::IfcColourSpecification(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcColourSpecification::IfcColourSpecification(boost::optional< std::string > v1_Name) : IfcPresentationItem(IfcEntityInstanceData(storage_t(1))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }; populate_derived(); }

// Function implementations for IfcColumn
boost::optional< ::Ifc4::IfcColumnTypeEnum::Value > Ifc4::IfcColumn::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcColumnTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcColumn::setPredefinedType(boost::optional< ::Ifc4::IfcColumnTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcColumnTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcColumn::declaration() const { return *((IfcParse::entity*)IFC4_types[154]); }
const IfcParse::entity& Ifc4::IfcColumn::Class() { return *((IfcParse::entity*)IFC4_types[154]); }
Ifc4::IfcColumn::IfcColumn(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcColumn::IfcColumn(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcColumnTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcColumnTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcColumnStandardCase


const IfcParse::entity& Ifc4::IfcColumnStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[155]); }
const IfcParse::entity& Ifc4::IfcColumnStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[155]); }
Ifc4::IfcColumnStandardCase::IfcColumnStandardCase(IfcEntityInstanceData&& e) : IfcColumn(std::move(e)) { }
Ifc4::IfcColumnStandardCase::IfcColumnStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcColumnTypeEnum::Value > v9_PredefinedType) : IfcColumn(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcColumnTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcColumnType
::Ifc4::IfcColumnTypeEnum::Value Ifc4::IfcColumnType::PredefinedType() const {  return ::Ifc4::IfcColumnTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcColumnType::setPredefinedType(::Ifc4::IfcColumnTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcColumnTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcColumnType::declaration() const { return *((IfcParse::entity*)IFC4_types[156]); }
const IfcParse::entity& Ifc4::IfcColumnType::Class() { return *((IfcParse::entity*)IFC4_types[156]); }
Ifc4::IfcColumnType::IfcColumnType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcColumnType::IfcColumnType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcColumnTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcColumnTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCommunicationsAppliance
boost::optional< ::Ifc4::IfcCommunicationsApplianceTypeEnum::Value > Ifc4::IfcCommunicationsAppliance::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCommunicationsApplianceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCommunicationsAppliance::setPredefinedType(boost::optional< ::Ifc4::IfcCommunicationsApplianceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCommunicationsApplianceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCommunicationsAppliance::declaration() const { return *((IfcParse::entity*)IFC4_types[158]); }
const IfcParse::entity& Ifc4::IfcCommunicationsAppliance::Class() { return *((IfcParse::entity*)IFC4_types[158]); }
Ifc4::IfcCommunicationsAppliance::IfcCommunicationsAppliance(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcCommunicationsAppliance::IfcCommunicationsAppliance(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCommunicationsApplianceTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCommunicationsApplianceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCommunicationsApplianceType
::Ifc4::IfcCommunicationsApplianceTypeEnum::Value Ifc4::IfcCommunicationsApplianceType::PredefinedType() const {  return ::Ifc4::IfcCommunicationsApplianceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCommunicationsApplianceType::setPredefinedType(::Ifc4::IfcCommunicationsApplianceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCommunicationsApplianceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCommunicationsApplianceType::declaration() const { return *((IfcParse::entity*)IFC4_types[159]); }
const IfcParse::entity& Ifc4::IfcCommunicationsApplianceType::Class() { return *((IfcParse::entity*)IFC4_types[159]); }
Ifc4::IfcCommunicationsApplianceType::IfcCommunicationsApplianceType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcCommunicationsApplianceType::IfcCommunicationsApplianceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCommunicationsApplianceTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCommunicationsApplianceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcComplexProperty
std::string Ifc4::IfcComplexProperty::UsageName() const {  std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcComplexProperty::setUsageName(std::string v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
aggregate_of< ::Ifc4::IfcProperty >::ptr Ifc4::IfcComplexProperty::HasProperties() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcProperty >(); }
void Ifc4::IfcComplexProperty::setHasProperties(aggregate_of< ::Ifc4::IfcProperty >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcComplexProperty::declaration() const { return *((IfcParse::entity*)IFC4_types[162]); }
const IfcParse::entity& Ifc4::IfcComplexProperty::Class() { return *((IfcParse::entity*)IFC4_types[162]); }
Ifc4::IfcComplexProperty::IfcComplexProperty(IfcEntityInstanceData&& e) : IfcProperty(std::move(e)) { }
Ifc4::IfcComplexProperty::IfcComplexProperty(std::string v1_Name, boost::optional< std::string > v2_Description, std::string v3_UsageName, aggregate_of< ::Ifc4::IfcProperty >::ptr v4_HasProperties) : IfcProperty(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_UsageName));set_attribute_value(3, (v4_HasProperties)->generalize());; populate_derived(); }

// Function implementations for IfcComplexPropertyTemplate
boost::optional< std::string > Ifc4::IfcComplexPropertyTemplate::UsageName() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcComplexPropertyTemplate::setUsageName(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< ::Ifc4::IfcComplexPropertyTemplateTypeEnum::Value > Ifc4::IfcComplexPropertyTemplate::TemplateType() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } return ::Ifc4::IfcComplexPropertyTemplateTypeEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcComplexPropertyTemplate::setTemplateType(boost::optional< ::Ifc4::IfcComplexPropertyTemplateTypeEnum::Value > v) { if (v) {set_attribute_value(5, EnumerationReference(&::Ifc4::IfcComplexPropertyTemplateTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(5);} }
boost::optional< aggregate_of< ::Ifc4::IfcPropertyTemplate >::ptr > Ifc4::IfcComplexPropertyTemplate::HasPropertyTemplates() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(6); return es->as< ::Ifc4::IfcPropertyTemplate >(); }
void Ifc4::IfcComplexPropertyTemplate::setHasPropertyTemplates(boost::optional< aggregate_of< ::Ifc4::IfcPropertyTemplate >::ptr > v) { if (v) {set_attribute_value(6, (*v)->generalize());} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcComplexPropertyTemplate::declaration() const { return *((IfcParse::entity*)IFC4_types[163]); }
const IfcParse::entity& Ifc4::IfcComplexPropertyTemplate::Class() { return *((IfcParse::entity*)IFC4_types[163]); }
Ifc4::IfcComplexPropertyTemplate::IfcComplexPropertyTemplate(IfcEntityInstanceData&& e) : IfcPropertyTemplate(std::move(e)) { }
Ifc4::IfcComplexPropertyTemplate::IfcComplexPropertyTemplate(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_UsageName, boost::optional< ::Ifc4::IfcComplexPropertyTemplateTypeEnum::Value > v6_TemplateType, boost::optional< aggregate_of< ::Ifc4::IfcPropertyTemplate >::ptr > v7_HasPropertyTemplates) : IfcPropertyTemplate(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_UsageName) {set_attribute_value(4, (*v5_UsageName)); } if (v6_TemplateType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcComplexPropertyTemplateTypeEnum::Class(),(size_t)*v6_TemplateType))); } if (v7_HasPropertyTemplates) {set_attribute_value(6, (*v7_HasPropertyTemplates)->generalize()); }; populate_derived(); }

// Function implementations for IfcCompositeCurve
aggregate_of< ::Ifc4::IfcCompositeCurveSegment >::ptr Ifc4::IfcCompositeCurve::Segments() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcCompositeCurveSegment >(); }
void Ifc4::IfcCompositeCurve::setSegments(aggregate_of< ::Ifc4::IfcCompositeCurveSegment >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }
boost::logic::tribool Ifc4::IfcCompositeCurve::SelfIntersect() const {  boost::logic::tribool v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcCompositeCurve::setSelfIntersect(boost::logic::tribool v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcCompositeCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[165]); }
const IfcParse::entity& Ifc4::IfcCompositeCurve::Class() { return *((IfcParse::entity*)IFC4_types[165]); }
Ifc4::IfcCompositeCurve::IfcCompositeCurve(IfcEntityInstanceData&& e) : IfcBoundedCurve(std::move(e)) { }
Ifc4::IfcCompositeCurve::IfcCompositeCurve(aggregate_of< ::Ifc4::IfcCompositeCurveSegment >::ptr v1_Segments, boost::logic::tribool v2_SelfIntersect) : IfcBoundedCurve(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_Segments)->generalize());set_attribute_value(1, (v2_SelfIntersect));; populate_derived(); }

// Function implementations for IfcCompositeCurveOnSurface


const IfcParse::entity& Ifc4::IfcCompositeCurveOnSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[166]); }
const IfcParse::entity& Ifc4::IfcCompositeCurveOnSurface::Class() { return *((IfcParse::entity*)IFC4_types[166]); }
Ifc4::IfcCompositeCurveOnSurface::IfcCompositeCurveOnSurface(IfcEntityInstanceData&& e) : IfcCompositeCurve(std::move(e)) { }
Ifc4::IfcCompositeCurveOnSurface::IfcCompositeCurveOnSurface(aggregate_of< ::Ifc4::IfcCompositeCurveSegment >::ptr v1_Segments, boost::logic::tribool v2_SelfIntersect) : IfcCompositeCurve(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_Segments)->generalize());set_attribute_value(1, (v2_SelfIntersect));; populate_derived(); }

// Function implementations for IfcCompositeCurveSegment
::Ifc4::IfcTransitionCode::Value Ifc4::IfcCompositeCurveSegment::Transition() const {  return ::Ifc4::IfcTransitionCode::FromString(data_.get_attribute_value(0)); }
void Ifc4::IfcCompositeCurveSegment::setTransition(::Ifc4::IfcTransitionCode::Value v) { set_attribute_value(0, EnumerationReference(&::Ifc4::IfcTransitionCode::Class(), (size_t) v));if constexpr (false)unset_attribute_value(0); }
bool Ifc4::IfcCompositeCurveSegment::SameSense() const {  bool v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcCompositeCurveSegment::setSameSense(bool v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcCurve* Ifc4::IfcCompositeCurveSegment::ParentCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcCompositeCurveSegment::setParentCurve(::Ifc4::IfcCurve* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }

::Ifc4::IfcCompositeCurve::list::ptr Ifc4::IfcCompositeCurveSegment::UsingCurves() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[165], 0)->as<IfcCompositeCurve>(); }

const IfcParse::entity& Ifc4::IfcCompositeCurveSegment::declaration() const { return *((IfcParse::entity*)IFC4_types[167]); }
const IfcParse::entity& Ifc4::IfcCompositeCurveSegment::Class() { return *((IfcParse::entity*)IFC4_types[167]); }
Ifc4::IfcCompositeCurveSegment::IfcCompositeCurveSegment(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcCompositeCurveSegment::IfcCompositeCurveSegment(::Ifc4::IfcTransitionCode::Value v1_Transition, bool v2_SameSense, ::Ifc4::IfcCurve* v3_ParentCurve) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcTransitionCode::Class(),(size_t)v1_Transition)));set_attribute_value(1, (v2_SameSense));set_attribute_value(2, v3_ParentCurve ? v3_ParentCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcCompositeProfileDef
aggregate_of< ::Ifc4::IfcProfileDef >::ptr Ifc4::IfcCompositeProfileDef::Profiles() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcProfileDef >(); }
void Ifc4::IfcCompositeProfileDef::setProfiles(aggregate_of< ::Ifc4::IfcProfileDef >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }
boost::optional< std::string > Ifc4::IfcCompositeProfileDef::Label() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcCompositeProfileDef::setLabel(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcCompositeProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[168]); }
const IfcParse::entity& Ifc4::IfcCompositeProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[168]); }
Ifc4::IfcCompositeProfileDef::IfcCompositeProfileDef(IfcEntityInstanceData&& e) : IfcProfileDef(std::move(e)) { }
Ifc4::IfcCompositeProfileDef::IfcCompositeProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, aggregate_of< ::Ifc4::IfcProfileDef >::ptr v3_Profiles, boost::optional< std::string > v4_Label) : IfcProfileDef(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, (v3_Profiles)->generalize()); if (v4_Label) {set_attribute_value(3, (*v4_Label)); }; populate_derived(); }

// Function implementations for IfcCompressor
boost::optional< ::Ifc4::IfcCompressorTypeEnum::Value > Ifc4::IfcCompressor::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCompressorTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCompressor::setPredefinedType(boost::optional< ::Ifc4::IfcCompressorTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCompressorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCompressor::declaration() const { return *((IfcParse::entity*)IFC4_types[170]); }
const IfcParse::entity& Ifc4::IfcCompressor::Class() { return *((IfcParse::entity*)IFC4_types[170]); }
Ifc4::IfcCompressor::IfcCompressor(IfcEntityInstanceData&& e) : IfcFlowMovingDevice(std::move(e)) { }
Ifc4::IfcCompressor::IfcCompressor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCompressorTypeEnum::Value > v9_PredefinedType) : IfcFlowMovingDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCompressorTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCompressorType
::Ifc4::IfcCompressorTypeEnum::Value Ifc4::IfcCompressorType::PredefinedType() const {  return ::Ifc4::IfcCompressorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCompressorType::setPredefinedType(::Ifc4::IfcCompressorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCompressorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCompressorType::declaration() const { return *((IfcParse::entity*)IFC4_types[171]); }
const IfcParse::entity& Ifc4::IfcCompressorType::Class() { return *((IfcParse::entity*)IFC4_types[171]); }
Ifc4::IfcCompressorType::IfcCompressorType(IfcEntityInstanceData&& e) : IfcFlowMovingDeviceType(std::move(e)) { }
Ifc4::IfcCompressorType::IfcCompressorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCompressorTypeEnum::Value v10_PredefinedType) : IfcFlowMovingDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCompressorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCondenser
boost::optional< ::Ifc4::IfcCondenserTypeEnum::Value > Ifc4::IfcCondenser::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCondenserTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCondenser::setPredefinedType(boost::optional< ::Ifc4::IfcCondenserTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCondenserTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCondenser::declaration() const { return *((IfcParse::entity*)IFC4_types[173]); }
const IfcParse::entity& Ifc4::IfcCondenser::Class() { return *((IfcParse::entity*)IFC4_types[173]); }
Ifc4::IfcCondenser::IfcCondenser(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcCondenser::IfcCondenser(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCondenserTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCondenserTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCondenserType
::Ifc4::IfcCondenserTypeEnum::Value Ifc4::IfcCondenserType::PredefinedType() const {  return ::Ifc4::IfcCondenserTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCondenserType::setPredefinedType(::Ifc4::IfcCondenserTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCondenserTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCondenserType::declaration() const { return *((IfcParse::entity*)IFC4_types[174]); }
const IfcParse::entity& Ifc4::IfcCondenserType::Class() { return *((IfcParse::entity*)IFC4_types[174]); }
Ifc4::IfcCondenserType::IfcCondenserType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcCondenserType::IfcCondenserType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCondenserTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCondenserTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcConic
::Ifc4::IfcAxis2Placement* Ifc4::IfcConic::Position() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcAxis2Placement>(true); }
void Ifc4::IfcConic::setPosition(::Ifc4::IfcAxis2Placement* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcConic::declaration() const { return *((IfcParse::entity*)IFC4_types[176]); }
const IfcParse::entity& Ifc4::IfcConic::Class() { return *((IfcParse::entity*)IFC4_types[176]); }
Ifc4::IfcConic::IfcConic(IfcEntityInstanceData&& e) : IfcCurve(std::move(e)) { }
Ifc4::IfcConic::IfcConic(::Ifc4::IfcAxis2Placement* v1_Position) : IfcCurve(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcConnectedFaceSet
aggregate_of< ::Ifc4::IfcFace >::ptr Ifc4::IfcConnectedFaceSet::CfsFaces() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcFace >(); }
void Ifc4::IfcConnectedFaceSet::setCfsFaces(aggregate_of< ::Ifc4::IfcFace >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcConnectedFaceSet::declaration() const { return *((IfcParse::entity*)IFC4_types[177]); }
const IfcParse::entity& Ifc4::IfcConnectedFaceSet::Class() { return *((IfcParse::entity*)IFC4_types[177]); }
Ifc4::IfcConnectedFaceSet::IfcConnectedFaceSet(IfcEntityInstanceData&& e) : IfcTopologicalRepresentationItem(std::move(e)) { }
Ifc4::IfcConnectedFaceSet::IfcConnectedFaceSet(aggregate_of< ::Ifc4::IfcFace >::ptr v1_CfsFaces) : IfcTopologicalRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_CfsFaces)->generalize());; populate_derived(); }

// Function implementations for IfcConnectionCurveGeometry
::Ifc4::IfcCurveOrEdgeCurve* Ifc4::IfcConnectionCurveGeometry::CurveOnRelatingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurveOrEdgeCurve>(true); }
void Ifc4::IfcConnectionCurveGeometry::setCurveOnRelatingElement(::Ifc4::IfcCurveOrEdgeCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcCurveOrEdgeCurve* Ifc4::IfcConnectionCurveGeometry::CurveOnRelatedElement() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcCurveOrEdgeCurve>(true); }
void Ifc4::IfcConnectionCurveGeometry::setCurveOnRelatedElement(::Ifc4::IfcCurveOrEdgeCurve* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcConnectionCurveGeometry::declaration() const { return *((IfcParse::entity*)IFC4_types[178]); }
const IfcParse::entity& Ifc4::IfcConnectionCurveGeometry::Class() { return *((IfcParse::entity*)IFC4_types[178]); }
Ifc4::IfcConnectionCurveGeometry::IfcConnectionCurveGeometry(IfcEntityInstanceData&& e) : IfcConnectionGeometry(std::move(e)) { }
Ifc4::IfcConnectionCurveGeometry::IfcConnectionCurveGeometry(::Ifc4::IfcCurveOrEdgeCurve* v1_CurveOnRelatingElement, ::Ifc4::IfcCurveOrEdgeCurve* v2_CurveOnRelatedElement) : IfcConnectionGeometry(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_CurveOnRelatingElement ? v1_CurveOnRelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_CurveOnRelatedElement ? v2_CurveOnRelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcConnectionGeometry


const IfcParse::entity& Ifc4::IfcConnectionGeometry::declaration() const { return *((IfcParse::entity*)IFC4_types[179]); }
const IfcParse::entity& Ifc4::IfcConnectionGeometry::Class() { return *((IfcParse::entity*)IFC4_types[179]); }
Ifc4::IfcConnectionGeometry::IfcConnectionGeometry(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcConnectionGeometry::IfcConnectionGeometry() : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcConnectionPointEccentricity
boost::optional< double > Ifc4::IfcConnectionPointEccentricity::EccentricityInX() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcConnectionPointEccentricity::setEccentricityInX(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcConnectionPointEccentricity::EccentricityInY() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcConnectionPointEccentricity::setEccentricityInY(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcConnectionPointEccentricity::EccentricityInZ() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcConnectionPointEccentricity::setEccentricityInZ(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcConnectionPointEccentricity::declaration() const { return *((IfcParse::entity*)IFC4_types[180]); }
const IfcParse::entity& Ifc4::IfcConnectionPointEccentricity::Class() { return *((IfcParse::entity*)IFC4_types[180]); }
Ifc4::IfcConnectionPointEccentricity::IfcConnectionPointEccentricity(IfcEntityInstanceData&& e) : IfcConnectionPointGeometry(std::move(e)) { }
Ifc4::IfcConnectionPointEccentricity::IfcConnectionPointEccentricity(::Ifc4::IfcPointOrVertexPoint* v1_PointOnRelatingElement, ::Ifc4::IfcPointOrVertexPoint* v2_PointOnRelatedElement, boost::optional< double > v3_EccentricityInX, boost::optional< double > v4_EccentricityInY, boost::optional< double > v5_EccentricityInZ) : IfcConnectionPointGeometry(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_PointOnRelatingElement ? v1_PointOnRelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_PointOnRelatedElement ? v2_PointOnRelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_EccentricityInX) {set_attribute_value(2, (*v3_EccentricityInX)); } if (v4_EccentricityInY) {set_attribute_value(3, (*v4_EccentricityInY)); } if (v5_EccentricityInZ) {set_attribute_value(4, (*v5_EccentricityInZ)); }; populate_derived(); }

// Function implementations for IfcConnectionPointGeometry
::Ifc4::IfcPointOrVertexPoint* Ifc4::IfcConnectionPointGeometry::PointOnRelatingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcPointOrVertexPoint>(true); }
void Ifc4::IfcConnectionPointGeometry::setPointOnRelatingElement(::Ifc4::IfcPointOrVertexPoint* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcPointOrVertexPoint* Ifc4::IfcConnectionPointGeometry::PointOnRelatedElement() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcPointOrVertexPoint>(true); }
void Ifc4::IfcConnectionPointGeometry::setPointOnRelatedElement(::Ifc4::IfcPointOrVertexPoint* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcConnectionPointGeometry::declaration() const { return *((IfcParse::entity*)IFC4_types[181]); }
const IfcParse::entity& Ifc4::IfcConnectionPointGeometry::Class() { return *((IfcParse::entity*)IFC4_types[181]); }
Ifc4::IfcConnectionPointGeometry::IfcConnectionPointGeometry(IfcEntityInstanceData&& e) : IfcConnectionGeometry(std::move(e)) { }
Ifc4::IfcConnectionPointGeometry::IfcConnectionPointGeometry(::Ifc4::IfcPointOrVertexPoint* v1_PointOnRelatingElement, ::Ifc4::IfcPointOrVertexPoint* v2_PointOnRelatedElement) : IfcConnectionGeometry(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_PointOnRelatingElement ? v1_PointOnRelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_PointOnRelatedElement ? v2_PointOnRelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcConnectionSurfaceGeometry
::Ifc4::IfcSurfaceOrFaceSurface* Ifc4::IfcConnectionSurfaceGeometry::SurfaceOnRelatingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcSurfaceOrFaceSurface>(true); }
void Ifc4::IfcConnectionSurfaceGeometry::setSurfaceOnRelatingElement(::Ifc4::IfcSurfaceOrFaceSurface* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcSurfaceOrFaceSurface* Ifc4::IfcConnectionSurfaceGeometry::SurfaceOnRelatedElement() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcSurfaceOrFaceSurface>(true); }
void Ifc4::IfcConnectionSurfaceGeometry::setSurfaceOnRelatedElement(::Ifc4::IfcSurfaceOrFaceSurface* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcConnectionSurfaceGeometry::declaration() const { return *((IfcParse::entity*)IFC4_types[182]); }
const IfcParse::entity& Ifc4::IfcConnectionSurfaceGeometry::Class() { return *((IfcParse::entity*)IFC4_types[182]); }
Ifc4::IfcConnectionSurfaceGeometry::IfcConnectionSurfaceGeometry(IfcEntityInstanceData&& e) : IfcConnectionGeometry(std::move(e)) { }
Ifc4::IfcConnectionSurfaceGeometry::IfcConnectionSurfaceGeometry(::Ifc4::IfcSurfaceOrFaceSurface* v1_SurfaceOnRelatingElement, ::Ifc4::IfcSurfaceOrFaceSurface* v2_SurfaceOnRelatedElement) : IfcConnectionGeometry(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_SurfaceOnRelatingElement ? v1_SurfaceOnRelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_SurfaceOnRelatedElement ? v2_SurfaceOnRelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcConnectionVolumeGeometry
::Ifc4::IfcSolidOrShell* Ifc4::IfcConnectionVolumeGeometry::VolumeOnRelatingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcSolidOrShell>(true); }
void Ifc4::IfcConnectionVolumeGeometry::setVolumeOnRelatingElement(::Ifc4::IfcSolidOrShell* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcSolidOrShell* Ifc4::IfcConnectionVolumeGeometry::VolumeOnRelatedElement() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcSolidOrShell>(true); }
void Ifc4::IfcConnectionVolumeGeometry::setVolumeOnRelatedElement(::Ifc4::IfcSolidOrShell* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcConnectionVolumeGeometry::declaration() const { return *((IfcParse::entity*)IFC4_types[184]); }
const IfcParse::entity& Ifc4::IfcConnectionVolumeGeometry::Class() { return *((IfcParse::entity*)IFC4_types[184]); }
Ifc4::IfcConnectionVolumeGeometry::IfcConnectionVolumeGeometry(IfcEntityInstanceData&& e) : IfcConnectionGeometry(std::move(e)) { }
Ifc4::IfcConnectionVolumeGeometry::IfcConnectionVolumeGeometry(::Ifc4::IfcSolidOrShell* v1_VolumeOnRelatingElement, ::Ifc4::IfcSolidOrShell* v2_VolumeOnRelatedElement) : IfcConnectionGeometry(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_VolumeOnRelatingElement ? v1_VolumeOnRelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_VolumeOnRelatedElement ? v2_VolumeOnRelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcConstraint
std::string Ifc4::IfcConstraint::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcConstraint::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcConstraint::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcConstraint::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
::Ifc4::IfcConstraintEnum::Value Ifc4::IfcConstraint::ConstraintGrade() const {  return ::Ifc4::IfcConstraintEnum::FromString(data_.get_attribute_value(2)); }
void Ifc4::IfcConstraint::setConstraintGrade(::Ifc4::IfcConstraintEnum::Value v) { set_attribute_value(2, EnumerationReference(&::Ifc4::IfcConstraintEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(2); }
boost::optional< std::string > Ifc4::IfcConstraint::ConstraintSource() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcConstraint::setConstraintSource(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
::Ifc4::IfcActorSelect* Ifc4::IfcConstraint::CreatingActor() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcConstraint::setCreatingActor(::Ifc4::IfcActorSelect* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
boost::optional< std::string > Ifc4::IfcConstraint::CreationTime() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcConstraint::setCreationTime(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcConstraint::UserDefinedGrade() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcConstraint::setUserDefinedGrade(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcConstraint::HasExternalReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }
::Ifc4::IfcResourceConstraintRelationship::list::ptr Ifc4::IfcConstraint::PropertiesForConstraint() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[852], 2)->as<IfcResourceConstraintRelationship>(); }

const IfcParse::entity& Ifc4::IfcConstraint::declaration() const { return *((IfcParse::entity*)IFC4_types[185]); }
const IfcParse::entity& Ifc4::IfcConstraint::Class() { return *((IfcParse::entity*)IFC4_types[185]); }
Ifc4::IfcConstraint::IfcConstraint(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcConstraint::IfcConstraint(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcConstraintEnum::Value v3_ConstraintGrade, boost::optional< std::string > v4_ConstraintSource, ::Ifc4::IfcActorSelect* v5_CreatingActor, boost::optional< std::string > v6_CreationTime, boost::optional< std::string > v7_UserDefinedGrade) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcConstraintEnum::Class(),(size_t)v3_ConstraintGrade))); if (v4_ConstraintSource) {set_attribute_value(3, (*v4_ConstraintSource)); }set_attribute_value(4, v5_CreatingActor ? v5_CreatingActor->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v6_CreationTime) {set_attribute_value(5, (*v6_CreationTime)); } if (v7_UserDefinedGrade) {set_attribute_value(6, (*v7_UserDefinedGrade)); }; populate_derived(); }

// Function implementations for IfcConstructionEquipmentResource
boost::optional< ::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value > Ifc4::IfcConstructionEquipmentResource::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcConstructionEquipmentResourceTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcConstructionEquipmentResource::setPredefinedType(boost::optional< ::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcConstructionEquipmentResource::declaration() const { return *((IfcParse::entity*)IFC4_types[187]); }
const IfcParse::entity& Ifc4::IfcConstructionEquipmentResource::Class() { return *((IfcParse::entity*)IFC4_types[187]); }
Ifc4::IfcConstructionEquipmentResource::IfcConstructionEquipmentResource(IfcEntityInstanceData&& e) : IfcConstructionResource(std::move(e)) { }
Ifc4::IfcConstructionEquipmentResource::IfcConstructionEquipmentResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, ::Ifc4::IfcResourceTime* v8_Usage, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v9_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v10_BaseQuantity, boost::optional< ::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value > v11_PredefinedType) : IfcConstructionResource(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }set_attribute_value(7, v8_Usage ? v8_Usage->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_BaseCosts) {set_attribute_value(8, (*v9_BaseCosts)->generalize()); }set_attribute_value(9, v10_BaseQuantity ? v10_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcConstructionEquipmentResourceType
::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value Ifc4::IfcConstructionEquipmentResourceType::PredefinedType() const {  return ::Ifc4::IfcConstructionEquipmentResourceTypeEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcConstructionEquipmentResourceType::setPredefinedType(::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcConstructionEquipmentResourceType::declaration() const { return *((IfcParse::entity*)IFC4_types[188]); }
const IfcParse::entity& Ifc4::IfcConstructionEquipmentResourceType::Class() { return *((IfcParse::entity*)IFC4_types[188]); }
Ifc4::IfcConstructionEquipmentResourceType::IfcConstructionEquipmentResourceType(IfcEntityInstanceData&& e) : IfcConstructionResourceType(std::move(e)) { }
Ifc4::IfcConstructionEquipmentResourceType::IfcConstructionEquipmentResourceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ResourceType, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v11_BaseQuantity, ::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Value v12_PredefinedType) : IfcConstructionResourceType(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ResourceType) {set_attribute_value(8, (*v9_ResourceType)); } if (v10_BaseCosts) {set_attribute_value(9, (*v10_BaseCosts)->generalize()); }set_attribute_value(10, v11_BaseQuantity ? v11_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcConstructionEquipmentResourceTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcConstructionMaterialResource
boost::optional< ::Ifc4::IfcConstructionMaterialResourceTypeEnum::Value > Ifc4::IfcConstructionMaterialResource::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcConstructionMaterialResourceTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcConstructionMaterialResource::setPredefinedType(boost::optional< ::Ifc4::IfcConstructionMaterialResourceTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcConstructionMaterialResourceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcConstructionMaterialResource::declaration() const { return *((IfcParse::entity*)IFC4_types[190]); }
const IfcParse::entity& Ifc4::IfcConstructionMaterialResource::Class() { return *((IfcParse::entity*)IFC4_types[190]); }
Ifc4::IfcConstructionMaterialResource::IfcConstructionMaterialResource(IfcEntityInstanceData&& e) : IfcConstructionResource(std::move(e)) { }
Ifc4::IfcConstructionMaterialResource::IfcConstructionMaterialResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, ::Ifc4::IfcResourceTime* v8_Usage, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v9_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v10_BaseQuantity, boost::optional< ::Ifc4::IfcConstructionMaterialResourceTypeEnum::Value > v11_PredefinedType) : IfcConstructionResource(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }set_attribute_value(7, v8_Usage ? v8_Usage->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_BaseCosts) {set_attribute_value(8, (*v9_BaseCosts)->generalize()); }set_attribute_value(9, v10_BaseQuantity ? v10_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcConstructionMaterialResourceTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcConstructionMaterialResourceType
::Ifc4::IfcConstructionMaterialResourceTypeEnum::Value Ifc4::IfcConstructionMaterialResourceType::PredefinedType() const {  return ::Ifc4::IfcConstructionMaterialResourceTypeEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcConstructionMaterialResourceType::setPredefinedType(::Ifc4::IfcConstructionMaterialResourceTypeEnum::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcConstructionMaterialResourceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcConstructionMaterialResourceType::declaration() const { return *((IfcParse::entity*)IFC4_types[191]); }
const IfcParse::entity& Ifc4::IfcConstructionMaterialResourceType::Class() { return *((IfcParse::entity*)IFC4_types[191]); }
Ifc4::IfcConstructionMaterialResourceType::IfcConstructionMaterialResourceType(IfcEntityInstanceData&& e) : IfcConstructionResourceType(std::move(e)) { }
Ifc4::IfcConstructionMaterialResourceType::IfcConstructionMaterialResourceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ResourceType, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v11_BaseQuantity, ::Ifc4::IfcConstructionMaterialResourceTypeEnum::Value v12_PredefinedType) : IfcConstructionResourceType(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ResourceType) {set_attribute_value(8, (*v9_ResourceType)); } if (v10_BaseCosts) {set_attribute_value(9, (*v10_BaseCosts)->generalize()); }set_attribute_value(10, v11_BaseQuantity ? v11_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcConstructionMaterialResourceTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcConstructionProductResource
boost::optional< ::Ifc4::IfcConstructionProductResourceTypeEnum::Value > Ifc4::IfcConstructionProductResource::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcConstructionProductResourceTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcConstructionProductResource::setPredefinedType(boost::optional< ::Ifc4::IfcConstructionProductResourceTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcConstructionProductResourceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcConstructionProductResource::declaration() const { return *((IfcParse::entity*)IFC4_types[193]); }
const IfcParse::entity& Ifc4::IfcConstructionProductResource::Class() { return *((IfcParse::entity*)IFC4_types[193]); }
Ifc4::IfcConstructionProductResource::IfcConstructionProductResource(IfcEntityInstanceData&& e) : IfcConstructionResource(std::move(e)) { }
Ifc4::IfcConstructionProductResource::IfcConstructionProductResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, ::Ifc4::IfcResourceTime* v8_Usage, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v9_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v10_BaseQuantity, boost::optional< ::Ifc4::IfcConstructionProductResourceTypeEnum::Value > v11_PredefinedType) : IfcConstructionResource(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }set_attribute_value(7, v8_Usage ? v8_Usage->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_BaseCosts) {set_attribute_value(8, (*v9_BaseCosts)->generalize()); }set_attribute_value(9, v10_BaseQuantity ? v10_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcConstructionProductResourceTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcConstructionProductResourceType
::Ifc4::IfcConstructionProductResourceTypeEnum::Value Ifc4::IfcConstructionProductResourceType::PredefinedType() const {  return ::Ifc4::IfcConstructionProductResourceTypeEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcConstructionProductResourceType::setPredefinedType(::Ifc4::IfcConstructionProductResourceTypeEnum::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcConstructionProductResourceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcConstructionProductResourceType::declaration() const { return *((IfcParse::entity*)IFC4_types[194]); }
const IfcParse::entity& Ifc4::IfcConstructionProductResourceType::Class() { return *((IfcParse::entity*)IFC4_types[194]); }
Ifc4::IfcConstructionProductResourceType::IfcConstructionProductResourceType(IfcEntityInstanceData&& e) : IfcConstructionResourceType(std::move(e)) { }
Ifc4::IfcConstructionProductResourceType::IfcConstructionProductResourceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ResourceType, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v11_BaseQuantity, ::Ifc4::IfcConstructionProductResourceTypeEnum::Value v12_PredefinedType) : IfcConstructionResourceType(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ResourceType) {set_attribute_value(8, (*v9_ResourceType)); } if (v10_BaseCosts) {set_attribute_value(9, (*v10_BaseCosts)->generalize()); }set_attribute_value(10, v11_BaseQuantity ? v11_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcConstructionProductResourceTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcConstructionResource
::Ifc4::IfcResourceTime* Ifc4::IfcConstructionResource::Usage() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcResourceTime>(true); }
void Ifc4::IfcConstructionResource::setUsage(::Ifc4::IfcResourceTime* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }
boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > Ifc4::IfcConstructionResource::BaseCosts() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(8); return es->as< ::Ifc4::IfcAppliedValue >(); }
void Ifc4::IfcConstructionResource::setBaseCosts(boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v) { if (v) {set_attribute_value(8, (*v)->generalize());} else {unset_attribute_value(8);} }
::Ifc4::IfcPhysicalQuantity* Ifc4::IfcConstructionResource::BaseQuantity() const { if(data_.get_attribute_value(9).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcPhysicalQuantity>(true); }
void Ifc4::IfcConstructionResource::setBaseQuantity(::Ifc4::IfcPhysicalQuantity* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcConstructionResource::declaration() const { return *((IfcParse::entity*)IFC4_types[196]); }
const IfcParse::entity& Ifc4::IfcConstructionResource::Class() { return *((IfcParse::entity*)IFC4_types[196]); }
Ifc4::IfcConstructionResource::IfcConstructionResource(IfcEntityInstanceData&& e) : IfcResource(std::move(e)) { }
Ifc4::IfcConstructionResource::IfcConstructionResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, ::Ifc4::IfcResourceTime* v8_Usage, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v9_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v10_BaseQuantity) : IfcResource(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }set_attribute_value(7, v8_Usage ? v8_Usage->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_BaseCosts) {set_attribute_value(8, (*v9_BaseCosts)->generalize()); }set_attribute_value(9, v10_BaseQuantity ? v10_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcConstructionResourceType
boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > Ifc4::IfcConstructionResourceType::BaseCosts() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(9); return es->as< ::Ifc4::IfcAppliedValue >(); }
void Ifc4::IfcConstructionResourceType::setBaseCosts(boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v) { if (v) {set_attribute_value(9, (*v)->generalize());} else {unset_attribute_value(9);} }
::Ifc4::IfcPhysicalQuantity* Ifc4::IfcConstructionResourceType::BaseQuantity() const { if(data_.get_attribute_value(10).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(10)))->as<::Ifc4::IfcPhysicalQuantity>(true); }
void Ifc4::IfcConstructionResourceType::setBaseQuantity(::Ifc4::IfcPhysicalQuantity* v) { set_attribute_value(10, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(10); }


const IfcParse::entity& Ifc4::IfcConstructionResourceType::declaration() const { return *((IfcParse::entity*)IFC4_types[197]); }
const IfcParse::entity& Ifc4::IfcConstructionResourceType::Class() { return *((IfcParse::entity*)IFC4_types[197]); }
Ifc4::IfcConstructionResourceType::IfcConstructionResourceType(IfcEntityInstanceData&& e) : IfcTypeResource(std::move(e)) { }
Ifc4::IfcConstructionResourceType::IfcConstructionResourceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ResourceType, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v11_BaseQuantity) : IfcTypeResource(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ResourceType) {set_attribute_value(8, (*v9_ResourceType)); } if (v10_BaseCosts) {set_attribute_value(9, (*v10_BaseCosts)->generalize()); }set_attribute_value(10, v11_BaseQuantity ? v11_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcContext
boost::optional< std::string > Ifc4::IfcContext::ObjectType() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcContext::setObjectType(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcContext::LongName() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcContext::setLongName(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcContext::Phase() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcContext::setPhase(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< aggregate_of< ::Ifc4::IfcRepresentationContext >::ptr > Ifc4::IfcContext::RepresentationContexts() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcRepresentationContext >(); }
void Ifc4::IfcContext::setRepresentationContexts(boost::optional< aggregate_of< ::Ifc4::IfcRepresentationContext >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }
::Ifc4::IfcUnitAssignment* Ifc4::IfcContext::UnitsInContext() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcUnitAssignment>(true); }
void Ifc4::IfcContext::setUnitsInContext(::Ifc4::IfcUnitAssignment* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }

::Ifc4::IfcRelDefinesByProperties::list::ptr Ifc4::IfcContext::IsDefinedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[830], 4)->as<IfcRelDefinesByProperties>(); }
::Ifc4::IfcRelDeclares::list::ptr Ifc4::IfcContext::Declares() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[826], 4)->as<IfcRelDeclares>(); }

const IfcParse::entity& Ifc4::IfcContext::declaration() const { return *((IfcParse::entity*)IFC4_types[198]); }
const IfcParse::entity& Ifc4::IfcContext::Class() { return *((IfcParse::entity*)IFC4_types[198]); }
Ifc4::IfcContext::IfcContext(IfcEntityInstanceData&& e) : IfcObjectDefinition(std::move(e)) { }
Ifc4::IfcContext::IfcContext(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_LongName, boost::optional< std::string > v7_Phase, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationContext >::ptr > v8_RepresentationContexts, ::Ifc4::IfcUnitAssignment* v9_UnitsInContext) : IfcObjectDefinition(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_LongName) {set_attribute_value(5, (*v6_LongName)); } if (v7_Phase) {set_attribute_value(6, (*v7_Phase)); } if (v8_RepresentationContexts) {set_attribute_value(7, (*v8_RepresentationContexts)->generalize()); }set_attribute_value(8, v9_UnitsInContext ? v9_UnitsInContext->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcContextDependentUnit
std::string Ifc4::IfcContextDependentUnit::Name() const {  std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcContextDependentUnit::setName(std::string v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcContextDependentUnit::HasExternalReference() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }

const IfcParse::entity& Ifc4::IfcContextDependentUnit::declaration() const { return *((IfcParse::entity*)IFC4_types[200]); }
const IfcParse::entity& Ifc4::IfcContextDependentUnit::Class() { return *((IfcParse::entity*)IFC4_types[200]); }
Ifc4::IfcContextDependentUnit::IfcContextDependentUnit(IfcEntityInstanceData&& e) : IfcNamedUnit(std::move(e)) { }
Ifc4::IfcContextDependentUnit::IfcContextDependentUnit(::Ifc4::IfcDimensionalExponents* v1_Dimensions, ::Ifc4::IfcUnitEnum::Value v2_UnitType, std::string v3_Name) : IfcNamedUnit(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Dimensions ? v1_Dimensions->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcUnitEnum::Class(),(size_t)v2_UnitType)));set_attribute_value(2, (v3_Name));; populate_derived(); }

// Function implementations for IfcControl
boost::optional< std::string > Ifc4::IfcControl::Identification() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcControl::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }

::Ifc4::IfcRelAssignsToControl::list::ptr Ifc4::IfcControl::Controls() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[800], 6)->as<IfcRelAssignsToControl>(); }

const IfcParse::entity& Ifc4::IfcControl::declaration() const { return *((IfcParse::entity*)IFC4_types[201]); }
const IfcParse::entity& Ifc4::IfcControl::Class() { return *((IfcParse::entity*)IFC4_types[201]); }
Ifc4::IfcControl::IfcControl(IfcEntityInstanceData&& e) : IfcObject(std::move(e)) { }
Ifc4::IfcControl::IfcControl(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification) : IfcObject(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); }; populate_derived(); }

// Function implementations for IfcController
boost::optional< ::Ifc4::IfcControllerTypeEnum::Value > Ifc4::IfcController::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcControllerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcController::setPredefinedType(boost::optional< ::Ifc4::IfcControllerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcControllerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcController::declaration() const { return *((IfcParse::entity*)IFC4_types[202]); }
const IfcParse::entity& Ifc4::IfcController::Class() { return *((IfcParse::entity*)IFC4_types[202]); }
Ifc4::IfcController::IfcController(IfcEntityInstanceData&& e) : IfcDistributionControlElement(std::move(e)) { }
Ifc4::IfcController::IfcController(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcControllerTypeEnum::Value > v9_PredefinedType) : IfcDistributionControlElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcControllerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcControllerType
::Ifc4::IfcControllerTypeEnum::Value Ifc4::IfcControllerType::PredefinedType() const {  return ::Ifc4::IfcControllerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcControllerType::setPredefinedType(::Ifc4::IfcControllerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcControllerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcControllerType::declaration() const { return *((IfcParse::entity*)IFC4_types[203]); }
const IfcParse::entity& Ifc4::IfcControllerType::Class() { return *((IfcParse::entity*)IFC4_types[203]); }
Ifc4::IfcControllerType::IfcControllerType(IfcEntityInstanceData&& e) : IfcDistributionControlElementType(std::move(e)) { }
Ifc4::IfcControllerType::IfcControllerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcControllerTypeEnum::Value v10_PredefinedType) : IfcDistributionControlElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcControllerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcConversionBasedUnit
std::string Ifc4::IfcConversionBasedUnit::Name() const {  std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcConversionBasedUnit::setName(std::string v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcMeasureWithUnit* Ifc4::IfcConversionBasedUnit::ConversionFactor() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcMeasureWithUnit>(true); }
void Ifc4::IfcConversionBasedUnit::setConversionFactor(::Ifc4::IfcMeasureWithUnit* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcConversionBasedUnit::HasExternalReference() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }

const IfcParse::entity& Ifc4::IfcConversionBasedUnit::declaration() const { return *((IfcParse::entity*)IFC4_types[205]); }
const IfcParse::entity& Ifc4::IfcConversionBasedUnit::Class() { return *((IfcParse::entity*)IFC4_types[205]); }
Ifc4::IfcConversionBasedUnit::IfcConversionBasedUnit(IfcEntityInstanceData&& e) : IfcNamedUnit(std::move(e)) { }
Ifc4::IfcConversionBasedUnit::IfcConversionBasedUnit(::Ifc4::IfcDimensionalExponents* v1_Dimensions, ::Ifc4::IfcUnitEnum::Value v2_UnitType, std::string v3_Name, ::Ifc4::IfcMeasureWithUnit* v4_ConversionFactor) : IfcNamedUnit(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_Dimensions ? v1_Dimensions->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcUnitEnum::Class(),(size_t)v2_UnitType)));set_attribute_value(2, (v3_Name));set_attribute_value(3, v4_ConversionFactor ? v4_ConversionFactor->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcConversionBasedUnitWithOffset
double Ifc4::IfcConversionBasedUnitWithOffset::ConversionOffset() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcConversionBasedUnitWithOffset::setConversionOffset(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcConversionBasedUnitWithOffset::declaration() const { return *((IfcParse::entity*)IFC4_types[206]); }
const IfcParse::entity& Ifc4::IfcConversionBasedUnitWithOffset::Class() { return *((IfcParse::entity*)IFC4_types[206]); }
Ifc4::IfcConversionBasedUnitWithOffset::IfcConversionBasedUnitWithOffset(IfcEntityInstanceData&& e) : IfcConversionBasedUnit(std::move(e)) { }
Ifc4::IfcConversionBasedUnitWithOffset::IfcConversionBasedUnitWithOffset(::Ifc4::IfcDimensionalExponents* v1_Dimensions, ::Ifc4::IfcUnitEnum::Value v2_UnitType, std::string v3_Name, ::Ifc4::IfcMeasureWithUnit* v4_ConversionFactor, double v5_ConversionOffset) : IfcConversionBasedUnit(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_Dimensions ? v1_Dimensions->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcUnitEnum::Class(),(size_t)v2_UnitType)));set_attribute_value(2, (v3_Name));set_attribute_value(3, v4_ConversionFactor ? v4_ConversionFactor->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, (v5_ConversionOffset));; populate_derived(); }

// Function implementations for IfcCooledBeam
boost::optional< ::Ifc4::IfcCooledBeamTypeEnum::Value > Ifc4::IfcCooledBeam::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCooledBeamTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCooledBeam::setPredefinedType(boost::optional< ::Ifc4::IfcCooledBeamTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCooledBeamTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCooledBeam::declaration() const { return *((IfcParse::entity*)IFC4_types[207]); }
const IfcParse::entity& Ifc4::IfcCooledBeam::Class() { return *((IfcParse::entity*)IFC4_types[207]); }
Ifc4::IfcCooledBeam::IfcCooledBeam(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcCooledBeam::IfcCooledBeam(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCooledBeamTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCooledBeamTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCooledBeamType
::Ifc4::IfcCooledBeamTypeEnum::Value Ifc4::IfcCooledBeamType::PredefinedType() const {  return ::Ifc4::IfcCooledBeamTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCooledBeamType::setPredefinedType(::Ifc4::IfcCooledBeamTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCooledBeamTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCooledBeamType::declaration() const { return *((IfcParse::entity*)IFC4_types[208]); }
const IfcParse::entity& Ifc4::IfcCooledBeamType::Class() { return *((IfcParse::entity*)IFC4_types[208]); }
Ifc4::IfcCooledBeamType::IfcCooledBeamType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcCooledBeamType::IfcCooledBeamType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCooledBeamTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCooledBeamTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCoolingTower
boost::optional< ::Ifc4::IfcCoolingTowerTypeEnum::Value > Ifc4::IfcCoolingTower::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCoolingTowerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCoolingTower::setPredefinedType(boost::optional< ::Ifc4::IfcCoolingTowerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCoolingTowerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCoolingTower::declaration() const { return *((IfcParse::entity*)IFC4_types[210]); }
const IfcParse::entity& Ifc4::IfcCoolingTower::Class() { return *((IfcParse::entity*)IFC4_types[210]); }
Ifc4::IfcCoolingTower::IfcCoolingTower(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcCoolingTower::IfcCoolingTower(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCoolingTowerTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCoolingTowerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCoolingTowerType
::Ifc4::IfcCoolingTowerTypeEnum::Value Ifc4::IfcCoolingTowerType::PredefinedType() const {  return ::Ifc4::IfcCoolingTowerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCoolingTowerType::setPredefinedType(::Ifc4::IfcCoolingTowerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCoolingTowerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCoolingTowerType::declaration() const { return *((IfcParse::entity*)IFC4_types[211]); }
const IfcParse::entity& Ifc4::IfcCoolingTowerType::Class() { return *((IfcParse::entity*)IFC4_types[211]); }
Ifc4::IfcCoolingTowerType::IfcCoolingTowerType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcCoolingTowerType::IfcCoolingTowerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCoolingTowerTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCoolingTowerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCoordinateOperation
::Ifc4::IfcCoordinateReferenceSystemSelect* Ifc4::IfcCoordinateOperation::SourceCRS() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCoordinateReferenceSystemSelect>(true); }
void Ifc4::IfcCoordinateOperation::setSourceCRS(::Ifc4::IfcCoordinateReferenceSystemSelect* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcCoordinateReferenceSystem* Ifc4::IfcCoordinateOperation::TargetCRS() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcCoordinateReferenceSystem>(true); }
void Ifc4::IfcCoordinateOperation::setTargetCRS(::Ifc4::IfcCoordinateReferenceSystem* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcCoordinateOperation::declaration() const { return *((IfcParse::entity*)IFC4_types[213]); }
const IfcParse::entity& Ifc4::IfcCoordinateOperation::Class() { return *((IfcParse::entity*)IFC4_types[213]); }
Ifc4::IfcCoordinateOperation::IfcCoordinateOperation(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcCoordinateOperation::IfcCoordinateOperation(::Ifc4::IfcCoordinateReferenceSystemSelect* v1_SourceCRS, ::Ifc4::IfcCoordinateReferenceSystem* v2_TargetCRS) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_SourceCRS ? v1_SourceCRS->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_TargetCRS ? v2_TargetCRS->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcCoordinateReferenceSystem
std::string Ifc4::IfcCoordinateReferenceSystem::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcCoordinateReferenceSystem::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcCoordinateReferenceSystem::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcCoordinateReferenceSystem::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcCoordinateReferenceSystem::GeodeticDatum() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcCoordinateReferenceSystem::setGeodeticDatum(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::string > Ifc4::IfcCoordinateReferenceSystem::VerticalDatum() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcCoordinateReferenceSystem::setVerticalDatum(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }

::Ifc4::IfcCoordinateOperation::list::ptr Ifc4::IfcCoordinateReferenceSystem::HasCoordinateOperation() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[213], 0)->as<IfcCoordinateOperation>(); }

const IfcParse::entity& Ifc4::IfcCoordinateReferenceSystem::declaration() const { return *((IfcParse::entity*)IFC4_types[214]); }
const IfcParse::entity& Ifc4::IfcCoordinateReferenceSystem::Class() { return *((IfcParse::entity*)IFC4_types[214]); }
Ifc4::IfcCoordinateReferenceSystem::IfcCoordinateReferenceSystem(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcCoordinateReferenceSystem::IfcCoordinateReferenceSystem(std::string v1_Name, boost::optional< std::string > v2_Description, boost::optional< std::string > v3_GeodeticDatum, boost::optional< std::string > v4_VerticalDatum) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_GeodeticDatum) {set_attribute_value(2, (*v3_GeodeticDatum)); } if (v4_VerticalDatum) {set_attribute_value(3, (*v4_VerticalDatum)); }; populate_derived(); }

// Function implementations for IfcCostItem
boost::optional< ::Ifc4::IfcCostItemTypeEnum::Value > Ifc4::IfcCostItem::PredefinedType() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } return ::Ifc4::IfcCostItemTypeEnum::FromString(data_.get_attribute_value(6)); }
void Ifc4::IfcCostItem::setPredefinedType(boost::optional< ::Ifc4::IfcCostItemTypeEnum::Value > v) { if (v) {set_attribute_value(6, EnumerationReference(&::Ifc4::IfcCostItemTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(6);} }
boost::optional< aggregate_of< ::Ifc4::IfcCostValue >::ptr > Ifc4::IfcCostItem::CostValues() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcCostValue >(); }
void Ifc4::IfcCostItem::setCostValues(boost::optional< aggregate_of< ::Ifc4::IfcCostValue >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }
boost::optional< aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr > Ifc4::IfcCostItem::CostQuantities() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(8); return es->as< ::Ifc4::IfcPhysicalQuantity >(); }
void Ifc4::IfcCostItem::setCostQuantities(boost::optional< aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr > v) { if (v) {set_attribute_value(8, (*v)->generalize());} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCostItem::declaration() const { return *((IfcParse::entity*)IFC4_types[216]); }
const IfcParse::entity& Ifc4::IfcCostItem::Class() { return *((IfcParse::entity*)IFC4_types[216]); }
Ifc4::IfcCostItem::IfcCostItem(IfcEntityInstanceData&& e) : IfcControl(std::move(e)) { }
Ifc4::IfcCostItem::IfcCostItem(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< ::Ifc4::IfcCostItemTypeEnum::Value > v7_PredefinedType, boost::optional< aggregate_of< ::Ifc4::IfcCostValue >::ptr > v8_CostValues, boost::optional< aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr > v9_CostQuantities) : IfcControl(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_PredefinedType) {set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcCostItemTypeEnum::Class(),(size_t)*v7_PredefinedType))); } if (v8_CostValues) {set_attribute_value(7, (*v8_CostValues)->generalize()); } if (v9_CostQuantities) {set_attribute_value(8, (*v9_CostQuantities)->generalize()); }; populate_derived(); }

// Function implementations for IfcCostSchedule
boost::optional< ::Ifc4::IfcCostScheduleTypeEnum::Value > Ifc4::IfcCostSchedule::PredefinedType() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } return ::Ifc4::IfcCostScheduleTypeEnum::FromString(data_.get_attribute_value(6)); }
void Ifc4::IfcCostSchedule::setPredefinedType(boost::optional< ::Ifc4::IfcCostScheduleTypeEnum::Value > v) { if (v) {set_attribute_value(6, EnumerationReference(&::Ifc4::IfcCostScheduleTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcCostSchedule::Status() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcCostSchedule::setStatus(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcCostSchedule::SubmittedOn() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcCostSchedule::setSubmittedOn(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< std::string > Ifc4::IfcCostSchedule::UpdateDate() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcCostSchedule::setUpdateDate(boost::optional< std::string > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcCostSchedule::declaration() const { return *((IfcParse::entity*)IFC4_types[218]); }
const IfcParse::entity& Ifc4::IfcCostSchedule::Class() { return *((IfcParse::entity*)IFC4_types[218]); }
Ifc4::IfcCostSchedule::IfcCostSchedule(IfcEntityInstanceData&& e) : IfcControl(std::move(e)) { }
Ifc4::IfcCostSchedule::IfcCostSchedule(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< ::Ifc4::IfcCostScheduleTypeEnum::Value > v7_PredefinedType, boost::optional< std::string > v8_Status, boost::optional< std::string > v9_SubmittedOn, boost::optional< std::string > v10_UpdateDate) : IfcControl(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_PredefinedType) {set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcCostScheduleTypeEnum::Class(),(size_t)*v7_PredefinedType))); } if (v8_Status) {set_attribute_value(7, (*v8_Status)); } if (v9_SubmittedOn) {set_attribute_value(8, (*v9_SubmittedOn)); } if (v10_UpdateDate) {set_attribute_value(9, (*v10_UpdateDate)); }; populate_derived(); }

// Function implementations for IfcCostValue


const IfcParse::entity& Ifc4::IfcCostValue::declaration() const { return *((IfcParse::entity*)IFC4_types[220]); }
const IfcParse::entity& Ifc4::IfcCostValue::Class() { return *((IfcParse::entity*)IFC4_types[220]); }
Ifc4::IfcCostValue::IfcCostValue(IfcEntityInstanceData&& e) : IfcAppliedValue(std::move(e)) { }
Ifc4::IfcCostValue::IfcCostValue(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcAppliedValueSelect* v3_AppliedValue, ::Ifc4::IfcMeasureWithUnit* v4_UnitBasis, boost::optional< std::string > v5_ApplicableDate, boost::optional< std::string > v6_FixedUntilDate, boost::optional< std::string > v7_Category, boost::optional< std::string > v8_Condition, boost::optional< ::Ifc4::IfcArithmeticOperatorEnum::Value > v9_ArithmeticOperator, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_Components) : IfcAppliedValue(IfcEntityInstanceData(storage_t(10))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_AppliedValue ? v3_AppliedValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_UnitBasis ? v4_UnitBasis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_ApplicableDate) {set_attribute_value(4, (*v5_ApplicableDate)); } if (v6_FixedUntilDate) {set_attribute_value(5, (*v6_FixedUntilDate)); } if (v7_Category) {set_attribute_value(6, (*v7_Category)); } if (v8_Condition) {set_attribute_value(7, (*v8_Condition)); } if (v9_ArithmeticOperator) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcArithmeticOperatorEnum::Class(),(size_t)*v9_ArithmeticOperator))); } if (v10_Components) {set_attribute_value(9, (*v10_Components)->generalize()); }; populate_derived(); }

// Function implementations for IfcCovering
boost::optional< ::Ifc4::IfcCoveringTypeEnum::Value > Ifc4::IfcCovering::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCoveringTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCovering::setPredefinedType(boost::optional< ::Ifc4::IfcCoveringTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCoveringTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }

::Ifc4::IfcRelCoversSpaces::list::ptr Ifc4::IfcCovering::CoversSpaces() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[825], 5)->as<IfcRelCoversSpaces>(); }
::Ifc4::IfcRelCoversBldgElements::list::ptr Ifc4::IfcCovering::CoversElements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[824], 5)->as<IfcRelCoversBldgElements>(); }

const IfcParse::entity& Ifc4::IfcCovering::declaration() const { return *((IfcParse::entity*)IFC4_types[222]); }
const IfcParse::entity& Ifc4::IfcCovering::Class() { return *((IfcParse::entity*)IFC4_types[222]); }
Ifc4::IfcCovering::IfcCovering(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcCovering::IfcCovering(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCoveringTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCoveringTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCoveringType
::Ifc4::IfcCoveringTypeEnum::Value Ifc4::IfcCoveringType::PredefinedType() const {  return ::Ifc4::IfcCoveringTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCoveringType::setPredefinedType(::Ifc4::IfcCoveringTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCoveringTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCoveringType::declaration() const { return *((IfcParse::entity*)IFC4_types[223]); }
const IfcParse::entity& Ifc4::IfcCoveringType::Class() { return *((IfcParse::entity*)IFC4_types[223]); }
Ifc4::IfcCoveringType::IfcCoveringType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcCoveringType::IfcCoveringType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCoveringTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCoveringTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCrewResource
boost::optional< ::Ifc4::IfcCrewResourceTypeEnum::Value > Ifc4::IfcCrewResource::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcCrewResourceTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcCrewResource::setPredefinedType(boost::optional< ::Ifc4::IfcCrewResourceTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcCrewResourceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcCrewResource::declaration() const { return *((IfcParse::entity*)IFC4_types[225]); }
const IfcParse::entity& Ifc4::IfcCrewResource::Class() { return *((IfcParse::entity*)IFC4_types[225]); }
Ifc4::IfcCrewResource::IfcCrewResource(IfcEntityInstanceData&& e) : IfcConstructionResource(std::move(e)) { }
Ifc4::IfcCrewResource::IfcCrewResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, ::Ifc4::IfcResourceTime* v8_Usage, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v9_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v10_BaseQuantity, boost::optional< ::Ifc4::IfcCrewResourceTypeEnum::Value > v11_PredefinedType) : IfcConstructionResource(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }set_attribute_value(7, v8_Usage ? v8_Usage->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_BaseCosts) {set_attribute_value(8, (*v9_BaseCosts)->generalize()); }set_attribute_value(9, v10_BaseQuantity ? v10_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcCrewResourceTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCrewResourceType
::Ifc4::IfcCrewResourceTypeEnum::Value Ifc4::IfcCrewResourceType::PredefinedType() const {  return ::Ifc4::IfcCrewResourceTypeEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcCrewResourceType::setPredefinedType(::Ifc4::IfcCrewResourceTypeEnum::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcCrewResourceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcCrewResourceType::declaration() const { return *((IfcParse::entity*)IFC4_types[226]); }
const IfcParse::entity& Ifc4::IfcCrewResourceType::Class() { return *((IfcParse::entity*)IFC4_types[226]); }
Ifc4::IfcCrewResourceType::IfcCrewResourceType(IfcEntityInstanceData&& e) : IfcConstructionResourceType(std::move(e)) { }
Ifc4::IfcCrewResourceType::IfcCrewResourceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ResourceType, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v11_BaseQuantity, ::Ifc4::IfcCrewResourceTypeEnum::Value v12_PredefinedType) : IfcConstructionResourceType(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ResourceType) {set_attribute_value(8, (*v9_ResourceType)); } if (v10_BaseCosts) {set_attribute_value(9, (*v10_BaseCosts)->generalize()); }set_attribute_value(10, v11_BaseQuantity ? v11_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcCrewResourceTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCsgPrimitive3D
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcCsgPrimitive3D::Position() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcCsgPrimitive3D::setPosition(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcCsgPrimitive3D::declaration() const { return *((IfcParse::entity*)IFC4_types[228]); }
const IfcParse::entity& Ifc4::IfcCsgPrimitive3D::Class() { return *((IfcParse::entity*)IFC4_types[228]); }
Ifc4::IfcCsgPrimitive3D::IfcCsgPrimitive3D(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcCsgPrimitive3D::IfcCsgPrimitive3D(::Ifc4::IfcAxis2Placement3D* v1_Position) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcCsgSolid
::Ifc4::IfcCsgSelect* Ifc4::IfcCsgSolid::TreeRootExpression() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCsgSelect>(true); }
void Ifc4::IfcCsgSolid::setTreeRootExpression(::Ifc4::IfcCsgSelect* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcCsgSolid::declaration() const { return *((IfcParse::entity*)IFC4_types[230]); }
const IfcParse::entity& Ifc4::IfcCsgSolid::Class() { return *((IfcParse::entity*)IFC4_types[230]); }
Ifc4::IfcCsgSolid::IfcCsgSolid(IfcEntityInstanceData&& e) : IfcSolidModel(std::move(e)) { }
Ifc4::IfcCsgSolid::IfcCsgSolid(::Ifc4::IfcCsgSelect* v1_TreeRootExpression) : IfcSolidModel(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_TreeRootExpression ? v1_TreeRootExpression->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcCurrencyRelationship
::Ifc4::IfcMonetaryUnit* Ifc4::IfcCurrencyRelationship::RelatingMonetaryUnit() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcMonetaryUnit>(true); }
void Ifc4::IfcCurrencyRelationship::setRelatingMonetaryUnit(::Ifc4::IfcMonetaryUnit* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcMonetaryUnit* Ifc4::IfcCurrencyRelationship::RelatedMonetaryUnit() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcMonetaryUnit>(true); }
void Ifc4::IfcCurrencyRelationship::setRelatedMonetaryUnit(::Ifc4::IfcMonetaryUnit* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcCurrencyRelationship::ExchangeRate() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcCurrencyRelationship::setExchangeRate(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
boost::optional< std::string > Ifc4::IfcCurrencyRelationship::RateDateTime() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcCurrencyRelationship::setRateDateTime(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
::Ifc4::IfcLibraryInformation* Ifc4::IfcCurrencyRelationship::RateSource() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcLibraryInformation>(true); }
void Ifc4::IfcCurrencyRelationship::setRateSource(::Ifc4::IfcLibraryInformation* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcCurrencyRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[232]); }
const IfcParse::entity& Ifc4::IfcCurrencyRelationship::Class() { return *((IfcParse::entity*)IFC4_types[232]); }
Ifc4::IfcCurrencyRelationship::IfcCurrencyRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcCurrencyRelationship::IfcCurrencyRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcMonetaryUnit* v3_RelatingMonetaryUnit, ::Ifc4::IfcMonetaryUnit* v4_RelatedMonetaryUnit, double v5_ExchangeRate, boost::optional< std::string > v6_RateDateTime, ::Ifc4::IfcLibraryInformation* v7_RateSource) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_RelatingMonetaryUnit ? v3_RelatingMonetaryUnit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_RelatedMonetaryUnit ? v4_RelatedMonetaryUnit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, (v5_ExchangeRate)); if (v6_RateDateTime) {set_attribute_value(5, (*v6_RateDateTime)); }set_attribute_value(6, v7_RateSource ? v7_RateSource->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcCurtainWall
boost::optional< ::Ifc4::IfcCurtainWallTypeEnum::Value > Ifc4::IfcCurtainWall::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcCurtainWallTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcCurtainWall::setPredefinedType(boost::optional< ::Ifc4::IfcCurtainWallTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcCurtainWallTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcCurtainWall::declaration() const { return *((IfcParse::entity*)IFC4_types[233]); }
const IfcParse::entity& Ifc4::IfcCurtainWall::Class() { return *((IfcParse::entity*)IFC4_types[233]); }
Ifc4::IfcCurtainWall::IfcCurtainWall(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcCurtainWall::IfcCurtainWall(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcCurtainWallTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcCurtainWallTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcCurtainWallType
::Ifc4::IfcCurtainWallTypeEnum::Value Ifc4::IfcCurtainWallType::PredefinedType() const {  return ::Ifc4::IfcCurtainWallTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcCurtainWallType::setPredefinedType(::Ifc4::IfcCurtainWallTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcCurtainWallTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcCurtainWallType::declaration() const { return *((IfcParse::entity*)IFC4_types[234]); }
const IfcParse::entity& Ifc4::IfcCurtainWallType::Class() { return *((IfcParse::entity*)IFC4_types[234]); }
Ifc4::IfcCurtainWallType::IfcCurtainWallType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcCurtainWallType::IfcCurtainWallType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcCurtainWallTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcCurtainWallTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcCurve


const IfcParse::entity& Ifc4::IfcCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[237]); }
const IfcParse::entity& Ifc4::IfcCurve::Class() { return *((IfcParse::entity*)IFC4_types[237]); }
Ifc4::IfcCurve::IfcCurve(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcCurve::IfcCurve() : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcCurveBoundedPlane
::Ifc4::IfcPlane* Ifc4::IfcCurveBoundedPlane::BasisSurface() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcPlane>(true); }
void Ifc4::IfcCurveBoundedPlane::setBasisSurface(::Ifc4::IfcPlane* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcCurve* Ifc4::IfcCurveBoundedPlane::OuterBoundary() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcCurveBoundedPlane::setOuterBoundary(::Ifc4::IfcCurve* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
aggregate_of< ::Ifc4::IfcCurve >::ptr Ifc4::IfcCurveBoundedPlane::InnerBoundaries() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcCurve >(); }
void Ifc4::IfcCurveBoundedPlane::setInnerBoundaries(aggregate_of< ::Ifc4::IfcCurve >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcCurveBoundedPlane::declaration() const { return *((IfcParse::entity*)IFC4_types[238]); }
const IfcParse::entity& Ifc4::IfcCurveBoundedPlane::Class() { return *((IfcParse::entity*)IFC4_types[238]); }
Ifc4::IfcCurveBoundedPlane::IfcCurveBoundedPlane(IfcEntityInstanceData&& e) : IfcBoundedSurface(std::move(e)) { }
Ifc4::IfcCurveBoundedPlane::IfcCurveBoundedPlane(::Ifc4::IfcPlane* v1_BasisSurface, ::Ifc4::IfcCurve* v2_OuterBoundary, aggregate_of< ::Ifc4::IfcCurve >::ptr v3_InnerBoundaries) : IfcBoundedSurface(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_BasisSurface ? v1_BasisSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_OuterBoundary ? v2_OuterBoundary->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, (v3_InnerBoundaries)->generalize());; populate_derived(); }

// Function implementations for IfcCurveBoundedSurface
::Ifc4::IfcSurface* Ifc4::IfcCurveBoundedSurface::BasisSurface() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcSurface>(true); }
void Ifc4::IfcCurveBoundedSurface::setBasisSurface(::Ifc4::IfcSurface* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcBoundaryCurve >::ptr Ifc4::IfcCurveBoundedSurface::Boundaries() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcBoundaryCurve >(); }
void Ifc4::IfcCurveBoundedSurface::setBoundaries(aggregate_of< ::Ifc4::IfcBoundaryCurve >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
bool Ifc4::IfcCurveBoundedSurface::ImplicitOuter() const {  bool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcCurveBoundedSurface::setImplicitOuter(bool v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcCurveBoundedSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[239]); }
const IfcParse::entity& Ifc4::IfcCurveBoundedSurface::Class() { return *((IfcParse::entity*)IFC4_types[239]); }
Ifc4::IfcCurveBoundedSurface::IfcCurveBoundedSurface(IfcEntityInstanceData&& e) : IfcBoundedSurface(std::move(e)) { }
Ifc4::IfcCurveBoundedSurface::IfcCurveBoundedSurface(::Ifc4::IfcSurface* v1_BasisSurface, aggregate_of< ::Ifc4::IfcBoundaryCurve >::ptr v2_Boundaries, bool v3_ImplicitOuter) : IfcBoundedSurface(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_BasisSurface ? v1_BasisSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Boundaries)->generalize());set_attribute_value(2, (v3_ImplicitOuter));; populate_derived(); }

// Function implementations for IfcCurveStyle
::Ifc4::IfcCurveFontOrScaledCurveFontSelect* Ifc4::IfcCurveStyle::CurveFont() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcCurveFontOrScaledCurveFontSelect>(true); }
void Ifc4::IfcCurveStyle::setCurveFont(::Ifc4::IfcCurveFontOrScaledCurveFontSelect* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcSizeSelect* Ifc4::IfcCurveStyle::CurveWidth() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcSizeSelect>(true); }
void Ifc4::IfcCurveStyle::setCurveWidth(::Ifc4::IfcSizeSelect* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcColour* Ifc4::IfcCurveStyle::CurveColour() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcColour>(true); }
void Ifc4::IfcCurveStyle::setCurveColour(::Ifc4::IfcColour* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< bool > Ifc4::IfcCurveStyle::ModelOrDraughting() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } bool v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcCurveStyle::setModelOrDraughting(boost::optional< bool > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcCurveStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[244]); }
const IfcParse::entity& Ifc4::IfcCurveStyle::Class() { return *((IfcParse::entity*)IFC4_types[244]); }
Ifc4::IfcCurveStyle::IfcCurveStyle(IfcEntityInstanceData&& e) : IfcPresentationStyle(std::move(e)) { }
Ifc4::IfcCurveStyle::IfcCurveStyle(boost::optional< std::string > v1_Name, ::Ifc4::IfcCurveFontOrScaledCurveFontSelect* v2_CurveFont, ::Ifc4::IfcSizeSelect* v3_CurveWidth, ::Ifc4::IfcColour* v4_CurveColour, boost::optional< bool > v5_ModelOrDraughting) : IfcPresentationStyle(IfcEntityInstanceData(storage_t(5))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_CurveFont ? v2_CurveFont->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_CurveWidth ? v3_CurveWidth->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_CurveColour ? v4_CurveColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_ModelOrDraughting) {set_attribute_value(4, (*v5_ModelOrDraughting)); }; populate_derived(); }

// Function implementations for IfcCurveStyleFont
boost::optional< std::string > Ifc4::IfcCurveStyleFont::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcCurveStyleFont::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
aggregate_of< ::Ifc4::IfcCurveStyleFontPattern >::ptr Ifc4::IfcCurveStyleFont::PatternList() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcCurveStyleFontPattern >(); }
void Ifc4::IfcCurveStyleFont::setPatternList(aggregate_of< ::Ifc4::IfcCurveStyleFontPattern >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcCurveStyleFont::declaration() const { return *((IfcParse::entity*)IFC4_types[245]); }
const IfcParse::entity& Ifc4::IfcCurveStyleFont::Class() { return *((IfcParse::entity*)IFC4_types[245]); }
Ifc4::IfcCurveStyleFont::IfcCurveStyleFont(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcCurveStyleFont::IfcCurveStyleFont(boost::optional< std::string > v1_Name, aggregate_of< ::Ifc4::IfcCurveStyleFontPattern >::ptr v2_PatternList) : IfcPresentationItem(IfcEntityInstanceData(storage_t(2))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, (v2_PatternList)->generalize());; populate_derived(); }

// Function implementations for IfcCurveStyleFontAndScaling
boost::optional< std::string > Ifc4::IfcCurveStyleFontAndScaling::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcCurveStyleFontAndScaling::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
::Ifc4::IfcCurveStyleFontSelect* Ifc4::IfcCurveStyleFontAndScaling::CurveFont() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcCurveStyleFontSelect>(true); }
void Ifc4::IfcCurveStyleFontAndScaling::setCurveFont(::Ifc4::IfcCurveStyleFontSelect* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcCurveStyleFontAndScaling::CurveFontScaling() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcCurveStyleFontAndScaling::setCurveFontScaling(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcCurveStyleFontAndScaling::declaration() const { return *((IfcParse::entity*)IFC4_types[246]); }
const IfcParse::entity& Ifc4::IfcCurveStyleFontAndScaling::Class() { return *((IfcParse::entity*)IFC4_types[246]); }
Ifc4::IfcCurveStyleFontAndScaling::IfcCurveStyleFontAndScaling(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcCurveStyleFontAndScaling::IfcCurveStyleFontAndScaling(boost::optional< std::string > v1_Name, ::Ifc4::IfcCurveStyleFontSelect* v2_CurveFont, double v3_CurveFontScaling) : IfcPresentationItem(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_CurveFont ? v2_CurveFont->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, (v3_CurveFontScaling));; populate_derived(); }

// Function implementations for IfcCurveStyleFontPattern
double Ifc4::IfcCurveStyleFontPattern::VisibleSegmentLength() const {  double v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcCurveStyleFontPattern::setVisibleSegmentLength(double v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcCurveStyleFontPattern::InvisibleSegmentLength() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcCurveStyleFontPattern::setInvisibleSegmentLength(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcCurveStyleFontPattern::declaration() const { return *((IfcParse::entity*)IFC4_types[247]); }
const IfcParse::entity& Ifc4::IfcCurveStyleFontPattern::Class() { return *((IfcParse::entity*)IFC4_types[247]); }
Ifc4::IfcCurveStyleFontPattern::IfcCurveStyleFontPattern(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcCurveStyleFontPattern::IfcCurveStyleFontPattern(double v1_VisibleSegmentLength, double v2_InvisibleSegmentLength) : IfcPresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_VisibleSegmentLength));set_attribute_value(1, (v2_InvisibleSegmentLength));; populate_derived(); }

// Function implementations for IfcCylindricalSurface
double Ifc4::IfcCylindricalSurface::Radius() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcCylindricalSurface::setRadius(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcCylindricalSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[249]); }
const IfcParse::entity& Ifc4::IfcCylindricalSurface::Class() { return *((IfcParse::entity*)IFC4_types[249]); }
Ifc4::IfcCylindricalSurface::IfcCylindricalSurface(IfcEntityInstanceData&& e) : IfcElementarySurface(std::move(e)) { }
Ifc4::IfcCylindricalSurface::IfcCylindricalSurface(::Ifc4::IfcAxis2Placement3D* v1_Position, double v2_Radius) : IfcElementarySurface(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Radius));; populate_derived(); }

// Function implementations for IfcDamper
boost::optional< ::Ifc4::IfcDamperTypeEnum::Value > Ifc4::IfcDamper::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcDamperTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcDamper::setPredefinedType(boost::optional< ::Ifc4::IfcDamperTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcDamperTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcDamper::declaration() const { return *((IfcParse::entity*)IFC4_types[250]); }
const IfcParse::entity& Ifc4::IfcDamper::Class() { return *((IfcParse::entity*)IFC4_types[250]); }
Ifc4::IfcDamper::IfcDamper(IfcEntityInstanceData&& e) : IfcFlowController(std::move(e)) { }
Ifc4::IfcDamper::IfcDamper(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcDamperTypeEnum::Value > v9_PredefinedType) : IfcFlowController(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcDamperTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcDamperType
::Ifc4::IfcDamperTypeEnum::Value Ifc4::IfcDamperType::PredefinedType() const {  return ::Ifc4::IfcDamperTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDamperType::setPredefinedType(::Ifc4::IfcDamperTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDamperTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcDamperType::declaration() const { return *((IfcParse::entity*)IFC4_types[251]); }
const IfcParse::entity& Ifc4::IfcDamperType::Class() { return *((IfcParse::entity*)IFC4_types[251]); }
Ifc4::IfcDamperType::IfcDamperType(IfcEntityInstanceData&& e) : IfcFlowControllerType(std::move(e)) { }
Ifc4::IfcDamperType::IfcDamperType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcDamperTypeEnum::Value v10_PredefinedType) : IfcFlowControllerType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDamperTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcDerivedProfileDef
::Ifc4::IfcProfileDef* Ifc4::IfcDerivedProfileDef::ParentProfile() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcDerivedProfileDef::setParentProfile(::Ifc4::IfcProfileDef* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcCartesianTransformationOperator2D* Ifc4::IfcDerivedProfileDef::Operator() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcCartesianTransformationOperator2D>(true); }
void Ifc4::IfcDerivedProfileDef::setOperator(::Ifc4::IfcCartesianTransformationOperator2D* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcDerivedProfileDef::Label() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcDerivedProfileDef::setLabel(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcDerivedProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[260]); }
const IfcParse::entity& Ifc4::IfcDerivedProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[260]); }
Ifc4::IfcDerivedProfileDef::IfcDerivedProfileDef(IfcEntityInstanceData&& e) : IfcProfileDef(std::move(e)) { }
Ifc4::IfcDerivedProfileDef::IfcDerivedProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcProfileDef* v3_ParentProfile, ::Ifc4::IfcCartesianTransformationOperator2D* v4_Operator, boost::optional< std::string > v5_Label) : IfcProfileDef(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_ParentProfile ? v3_ParentProfile->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_Operator ? v4_Operator->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Label) {set_attribute_value(4, (*v5_Label)); }; populate_derived(); }

// Function implementations for IfcDerivedUnit
aggregate_of< ::Ifc4::IfcDerivedUnitElement >::ptr Ifc4::IfcDerivedUnit::Elements() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcDerivedUnitElement >(); }
void Ifc4::IfcDerivedUnit::setElements(aggregate_of< ::Ifc4::IfcDerivedUnitElement >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcDerivedUnitEnum::Value Ifc4::IfcDerivedUnit::UnitType() const {  return ::Ifc4::IfcDerivedUnitEnum::FromString(data_.get_attribute_value(1)); }
void Ifc4::IfcDerivedUnit::setUnitType(::Ifc4::IfcDerivedUnitEnum::Value v) { set_attribute_value(1, EnumerationReference(&::Ifc4::IfcDerivedUnitEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(1); }
boost::optional< std::string > Ifc4::IfcDerivedUnit::UserDefinedType() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcDerivedUnit::setUserDefinedType(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcDerivedUnit::declaration() const { return *((IfcParse::entity*)IFC4_types[261]); }
const IfcParse::entity& Ifc4::IfcDerivedUnit::Class() { return *((IfcParse::entity*)IFC4_types[261]); }
Ifc4::IfcDerivedUnit::IfcDerivedUnit(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcDerivedUnit::IfcDerivedUnit(aggregate_of< ::Ifc4::IfcDerivedUnitElement >::ptr v1_Elements, ::Ifc4::IfcDerivedUnitEnum::Value v2_UnitType, boost::optional< std::string > v3_UserDefinedType) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Elements)->generalize());set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcDerivedUnitEnum::Class(),(size_t)v2_UnitType))); if (v3_UserDefinedType) {set_attribute_value(2, (*v3_UserDefinedType)); }; populate_derived(); }

// Function implementations for IfcDerivedUnitElement
::Ifc4::IfcNamedUnit* Ifc4::IfcDerivedUnitElement::Unit() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcNamedUnit>(true); }
void Ifc4::IfcDerivedUnitElement::setUnit(::Ifc4::IfcNamedUnit* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
int Ifc4::IfcDerivedUnitElement::Exponent() const {  int v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcDerivedUnitElement::setExponent(int v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcDerivedUnitElement::declaration() const { return *((IfcParse::entity*)IFC4_types[262]); }
const IfcParse::entity& Ifc4::IfcDerivedUnitElement::Class() { return *((IfcParse::entity*)IFC4_types[262]); }
Ifc4::IfcDerivedUnitElement::IfcDerivedUnitElement(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcDerivedUnitElement::IfcDerivedUnitElement(::Ifc4::IfcNamedUnit* v1_Unit, int v2_Exponent) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Unit ? v1_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Exponent));; populate_derived(); }

// Function implementations for IfcDimensionalExponents
int Ifc4::IfcDimensionalExponents::LengthExponent() const {  int v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcDimensionalExponents::setLengthExponent(int v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
int Ifc4::IfcDimensionalExponents::MassExponent() const {  int v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcDimensionalExponents::setMassExponent(int v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
int Ifc4::IfcDimensionalExponents::TimeExponent() const {  int v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcDimensionalExponents::setTimeExponent(int v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
int Ifc4::IfcDimensionalExponents::ElectricCurrentExponent() const {  int v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcDimensionalExponents::setElectricCurrentExponent(int v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
int Ifc4::IfcDimensionalExponents::ThermodynamicTemperatureExponent() const {  int v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcDimensionalExponents::setThermodynamicTemperatureExponent(int v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
int Ifc4::IfcDimensionalExponents::AmountOfSubstanceExponent() const {  int v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcDimensionalExponents::setAmountOfSubstanceExponent(int v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
int Ifc4::IfcDimensionalExponents::LuminousIntensityExponent() const {  int v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcDimensionalExponents::setLuminousIntensityExponent(int v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcDimensionalExponents::declaration() const { return *((IfcParse::entity*)IFC4_types[265]); }
const IfcParse::entity& Ifc4::IfcDimensionalExponents::Class() { return *((IfcParse::entity*)IFC4_types[265]); }
Ifc4::IfcDimensionalExponents::IfcDimensionalExponents(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcDimensionalExponents::IfcDimensionalExponents(int v1_LengthExponent, int v2_MassExponent, int v3_TimeExponent, int v4_ElectricCurrentExponent, int v5_ThermodynamicTemperatureExponent, int v6_AmountOfSubstanceExponent, int v7_LuminousIntensityExponent) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_LengthExponent));set_attribute_value(1, (v2_MassExponent));set_attribute_value(2, (v3_TimeExponent));set_attribute_value(3, (v4_ElectricCurrentExponent));set_attribute_value(4, (v5_ThermodynamicTemperatureExponent));set_attribute_value(5, (v6_AmountOfSubstanceExponent));set_attribute_value(6, (v7_LuminousIntensityExponent));; populate_derived(); }

// Function implementations for IfcDirection
std::vector< double > /*[2:3]*/ Ifc4::IfcDirection::DirectionRatios() const {  std::vector< double > /*[2:3]*/ v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcDirection::setDirectionRatios(std::vector< double > /*[2:3]*/ v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcDirection::declaration() const { return *((IfcParse::entity*)IFC4_types[267]); }
const IfcParse::entity& Ifc4::IfcDirection::Class() { return *((IfcParse::entity*)IFC4_types[267]); }
Ifc4::IfcDirection::IfcDirection(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcDirection::IfcDirection(std::vector< double > /*[2:3]*/ v1_DirectionRatios) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_DirectionRatios));; populate_derived(); }

// Function implementations for IfcDiscreteAccessory
boost::optional< ::Ifc4::IfcDiscreteAccessoryTypeEnum::Value > Ifc4::IfcDiscreteAccessory::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcDiscreteAccessoryTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcDiscreteAccessory::setPredefinedType(boost::optional< ::Ifc4::IfcDiscreteAccessoryTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcDiscreteAccessoryTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcDiscreteAccessory::declaration() const { return *((IfcParse::entity*)IFC4_types[269]); }
const IfcParse::entity& Ifc4::IfcDiscreteAccessory::Class() { return *((IfcParse::entity*)IFC4_types[269]); }
Ifc4::IfcDiscreteAccessory::IfcDiscreteAccessory(IfcEntityInstanceData&& e) : IfcElementComponent(std::move(e)) { }
Ifc4::IfcDiscreteAccessory::IfcDiscreteAccessory(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcDiscreteAccessoryTypeEnum::Value > v9_PredefinedType) : IfcElementComponent(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcDiscreteAccessoryTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcDiscreteAccessoryType
::Ifc4::IfcDiscreteAccessoryTypeEnum::Value Ifc4::IfcDiscreteAccessoryType::PredefinedType() const {  return ::Ifc4::IfcDiscreteAccessoryTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDiscreteAccessoryType::setPredefinedType(::Ifc4::IfcDiscreteAccessoryTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDiscreteAccessoryTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcDiscreteAccessoryType::declaration() const { return *((IfcParse::entity*)IFC4_types[270]); }
const IfcParse::entity& Ifc4::IfcDiscreteAccessoryType::Class() { return *((IfcParse::entity*)IFC4_types[270]); }
Ifc4::IfcDiscreteAccessoryType::IfcDiscreteAccessoryType(IfcEntityInstanceData&& e) : IfcElementComponentType(std::move(e)) { }
Ifc4::IfcDiscreteAccessoryType::IfcDiscreteAccessoryType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcDiscreteAccessoryTypeEnum::Value v10_PredefinedType) : IfcElementComponentType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDiscreteAccessoryTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcDistributionChamberElement
boost::optional< ::Ifc4::IfcDistributionChamberElementTypeEnum::Value > Ifc4::IfcDistributionChamberElement::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcDistributionChamberElementTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcDistributionChamberElement::setPredefinedType(boost::optional< ::Ifc4::IfcDistributionChamberElementTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcDistributionChamberElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcDistributionChamberElement::declaration() const { return *((IfcParse::entity*)IFC4_types[272]); }
const IfcParse::entity& Ifc4::IfcDistributionChamberElement::Class() { return *((IfcParse::entity*)IFC4_types[272]); }
Ifc4::IfcDistributionChamberElement::IfcDistributionChamberElement(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcDistributionChamberElement::IfcDistributionChamberElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcDistributionChamberElementTypeEnum::Value > v9_PredefinedType) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcDistributionChamberElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcDistributionChamberElementType
::Ifc4::IfcDistributionChamberElementTypeEnum::Value Ifc4::IfcDistributionChamberElementType::PredefinedType() const {  return ::Ifc4::IfcDistributionChamberElementTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDistributionChamberElementType::setPredefinedType(::Ifc4::IfcDistributionChamberElementTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDistributionChamberElementTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcDistributionChamberElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[273]); }
const IfcParse::entity& Ifc4::IfcDistributionChamberElementType::Class() { return *((IfcParse::entity*)IFC4_types[273]); }
Ifc4::IfcDistributionChamberElementType::IfcDistributionChamberElementType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcDistributionChamberElementType::IfcDistributionChamberElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcDistributionChamberElementTypeEnum::Value v10_PredefinedType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDistributionChamberElementTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcDistributionCircuit


const IfcParse::entity& Ifc4::IfcDistributionCircuit::declaration() const { return *((IfcParse::entity*)IFC4_types[275]); }
const IfcParse::entity& Ifc4::IfcDistributionCircuit::Class() { return *((IfcParse::entity*)IFC4_types[275]); }
Ifc4::IfcDistributionCircuit::IfcDistributionCircuit(IfcEntityInstanceData&& e) : IfcDistributionSystem(std::move(e)) { }
Ifc4::IfcDistributionCircuit::IfcDistributionCircuit(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_LongName, boost::optional< ::Ifc4::IfcDistributionSystemEnum::Value > v7_PredefinedType) : IfcDistributionSystem(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_LongName) {set_attribute_value(5, (*v6_LongName)); } if (v7_PredefinedType) {set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcDistributionSystemEnum::Class(),(size_t)*v7_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcDistributionControlElement

::Ifc4::IfcRelFlowControlElements::list::ptr Ifc4::IfcDistributionControlElement::AssignedToFlowElement() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[834], 4)->as<IfcRelFlowControlElements>(); }

const IfcParse::entity& Ifc4::IfcDistributionControlElement::declaration() const { return *((IfcParse::entity*)IFC4_types[276]); }
const IfcParse::entity& Ifc4::IfcDistributionControlElement::Class() { return *((IfcParse::entity*)IFC4_types[276]); }
Ifc4::IfcDistributionControlElement::IfcDistributionControlElement(IfcEntityInstanceData&& e) : IfcDistributionElement(std::move(e)) { }
Ifc4::IfcDistributionControlElement::IfcDistributionControlElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcDistributionControlElementType


const IfcParse::entity& Ifc4::IfcDistributionControlElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[277]); }
const IfcParse::entity& Ifc4::IfcDistributionControlElementType::Class() { return *((IfcParse::entity*)IFC4_types[277]); }
Ifc4::IfcDistributionControlElementType::IfcDistributionControlElementType(IfcEntityInstanceData&& e) : IfcDistributionElementType(std::move(e)) { }
Ifc4::IfcDistributionControlElementType::IfcDistributionControlElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcDistributionElement

::Ifc4::IfcRelConnectsPortToElement::list::ptr Ifc4::IfcDistributionElement::HasPorts() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[818], 5)->as<IfcRelConnectsPortToElement>(); }

const IfcParse::entity& Ifc4::IfcDistributionElement::declaration() const { return *((IfcParse::entity*)IFC4_types[278]); }
const IfcParse::entity& Ifc4::IfcDistributionElement::Class() { return *((IfcParse::entity*)IFC4_types[278]); }
Ifc4::IfcDistributionElement::IfcDistributionElement(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcDistributionElement::IfcDistributionElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcDistributionElementType


const IfcParse::entity& Ifc4::IfcDistributionElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[279]); }
const IfcParse::entity& Ifc4::IfcDistributionElementType::Class() { return *((IfcParse::entity*)IFC4_types[279]); }
Ifc4::IfcDistributionElementType::IfcDistributionElementType(IfcEntityInstanceData&& e) : IfcElementType(std::move(e)) { }
Ifc4::IfcDistributionElementType::IfcDistributionElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcDistributionFlowElement

::Ifc4::IfcRelFlowControlElements::list::ptr Ifc4::IfcDistributionFlowElement::HasControlElements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[834], 5)->as<IfcRelFlowControlElements>(); }

const IfcParse::entity& Ifc4::IfcDistributionFlowElement::declaration() const { return *((IfcParse::entity*)IFC4_types[280]); }
const IfcParse::entity& Ifc4::IfcDistributionFlowElement::Class() { return *((IfcParse::entity*)IFC4_types[280]); }
Ifc4::IfcDistributionFlowElement::IfcDistributionFlowElement(IfcEntityInstanceData&& e) : IfcDistributionElement(std::move(e)) { }
Ifc4::IfcDistributionFlowElement::IfcDistributionFlowElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcDistributionFlowElementType


const IfcParse::entity& Ifc4::IfcDistributionFlowElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[281]); }
const IfcParse::entity& Ifc4::IfcDistributionFlowElementType::Class() { return *((IfcParse::entity*)IFC4_types[281]); }
Ifc4::IfcDistributionFlowElementType::IfcDistributionFlowElementType(IfcEntityInstanceData&& e) : IfcDistributionElementType(std::move(e)) { }
Ifc4::IfcDistributionFlowElementType::IfcDistributionFlowElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcDistributionPort
boost::optional< ::Ifc4::IfcFlowDirectionEnum::Value > Ifc4::IfcDistributionPort::FlowDirection() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } return ::Ifc4::IfcFlowDirectionEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcDistributionPort::setFlowDirection(boost::optional< ::Ifc4::IfcFlowDirectionEnum::Value > v) { if (v) {set_attribute_value(7, EnumerationReference(&::Ifc4::IfcFlowDirectionEnum::Class(), (size_t) *v));} else {unset_attribute_value(7);} }
boost::optional< ::Ifc4::IfcDistributionPortTypeEnum::Value > Ifc4::IfcDistributionPort::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcDistributionPortTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcDistributionPort::setPredefinedType(boost::optional< ::Ifc4::IfcDistributionPortTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcDistributionPortTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }
boost::optional< ::Ifc4::IfcDistributionSystemEnum::Value > Ifc4::IfcDistributionPort::SystemType() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } return ::Ifc4::IfcDistributionSystemEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDistributionPort::setSystemType(boost::optional< ::Ifc4::IfcDistributionSystemEnum::Value > v) { if (v) {set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDistributionSystemEnum::Class(), (size_t) *v));} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcDistributionPort::declaration() const { return *((IfcParse::entity*)IFC4_types[282]); }
const IfcParse::entity& Ifc4::IfcDistributionPort::Class() { return *((IfcParse::entity*)IFC4_types[282]); }
Ifc4::IfcDistributionPort::IfcDistributionPort(IfcEntityInstanceData&& e) : IfcPort(std::move(e)) { }
Ifc4::IfcDistributionPort::IfcDistributionPort(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< ::Ifc4::IfcFlowDirectionEnum::Value > v8_FlowDirection, boost::optional< ::Ifc4::IfcDistributionPortTypeEnum::Value > v9_PredefinedType, boost::optional< ::Ifc4::IfcDistributionSystemEnum::Value > v10_SystemType) : IfcPort(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_FlowDirection) {set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcFlowDirectionEnum::Class(),(size_t)*v8_FlowDirection))); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcDistributionPortTypeEnum::Class(),(size_t)*v9_PredefinedType))); } if (v10_SystemType) {set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDistributionSystemEnum::Class(),(size_t)*v10_SystemType))); }; populate_derived(); }

// Function implementations for IfcDistributionSystem
boost::optional< std::string > Ifc4::IfcDistributionSystem::LongName() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcDistributionSystem::setLongName(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< ::Ifc4::IfcDistributionSystemEnum::Value > Ifc4::IfcDistributionSystem::PredefinedType() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } return ::Ifc4::IfcDistributionSystemEnum::FromString(data_.get_attribute_value(6)); }
void Ifc4::IfcDistributionSystem::setPredefinedType(boost::optional< ::Ifc4::IfcDistributionSystemEnum::Value > v) { if (v) {set_attribute_value(6, EnumerationReference(&::Ifc4::IfcDistributionSystemEnum::Class(), (size_t) *v));} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcDistributionSystem::declaration() const { return *((IfcParse::entity*)IFC4_types[284]); }
const IfcParse::entity& Ifc4::IfcDistributionSystem::Class() { return *((IfcParse::entity*)IFC4_types[284]); }
Ifc4::IfcDistributionSystem::IfcDistributionSystem(IfcEntityInstanceData&& e) : IfcSystem(std::move(e)) { }
Ifc4::IfcDistributionSystem::IfcDistributionSystem(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_LongName, boost::optional< ::Ifc4::IfcDistributionSystemEnum::Value > v7_PredefinedType) : IfcSystem(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_LongName) {set_attribute_value(5, (*v6_LongName)); } if (v7_PredefinedType) {set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcDistributionSystemEnum::Class(),(size_t)*v7_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcDocumentInformation
std::string Ifc4::IfcDocumentInformation::Identification() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcDocumentInformation::setIdentification(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
std::string Ifc4::IfcDocumentInformation::Name() const {  std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcDocumentInformation::setName(std::string v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< std::string > Ifc4::IfcDocumentInformation::Description() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcDocumentInformation::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::Location() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcDocumentInformation::setLocation(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::Purpose() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcDocumentInformation::setPurpose(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::IntendedUse() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcDocumentInformation::setIntendedUse(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::Scope() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcDocumentInformation::setScope(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::Revision() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcDocumentInformation::setRevision(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
::Ifc4::IfcActorSelect* Ifc4::IfcDocumentInformation::DocumentOwner() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcDocumentInformation::setDocumentOwner(::Ifc4::IfcActorSelect* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }
boost::optional< aggregate_of< ::Ifc4::IfcActorSelect >::ptr > Ifc4::IfcDocumentInformation::Editors() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(9); return es->as< ::Ifc4::IfcActorSelect >(); }
void Ifc4::IfcDocumentInformation::setEditors(boost::optional< aggregate_of< ::Ifc4::IfcActorSelect >::ptr > v) { if (v) {set_attribute_value(9, (*v)->generalize());} else {unset_attribute_value(9);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::CreationTime() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcDocumentInformation::setCreationTime(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::LastRevisionTime() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcDocumentInformation::setLastRevisionTime(boost::optional< std::string > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::ElectronicFormat() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcDocumentInformation::setElectronicFormat(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::ValidFrom() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcDocumentInformation::setValidFrom(boost::optional< std::string > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
boost::optional< std::string > Ifc4::IfcDocumentInformation::ValidUntil() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcDocumentInformation::setValidUntil(boost::optional< std::string > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }
boost::optional< ::Ifc4::IfcDocumentConfidentialityEnum::Value > Ifc4::IfcDocumentInformation::Confidentiality() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } return ::Ifc4::IfcDocumentConfidentialityEnum::FromString(data_.get_attribute_value(15)); }
void Ifc4::IfcDocumentInformation::setConfidentiality(boost::optional< ::Ifc4::IfcDocumentConfidentialityEnum::Value > v) { if (v) {set_attribute_value(15, EnumerationReference(&::Ifc4::IfcDocumentConfidentialityEnum::Class(), (size_t) *v));} else {unset_attribute_value(15);} }
boost::optional< ::Ifc4::IfcDocumentStatusEnum::Value > Ifc4::IfcDocumentInformation::Status() const { if(data_.get_attribute_value(16).isNull()) { return boost::none; } return ::Ifc4::IfcDocumentStatusEnum::FromString(data_.get_attribute_value(16)); }
void Ifc4::IfcDocumentInformation::setStatus(boost::optional< ::Ifc4::IfcDocumentStatusEnum::Value > v) { if (v) {set_attribute_value(16, EnumerationReference(&::Ifc4::IfcDocumentStatusEnum::Class(), (size_t) *v));} else {unset_attribute_value(16);} }

::Ifc4::IfcRelAssociatesDocument::list::ptr Ifc4::IfcDocumentInformation::DocumentInfoForObjects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[810], 5)->as<IfcRelAssociatesDocument>(); }
::Ifc4::IfcDocumentReference::list::ptr Ifc4::IfcDocumentInformation::HasDocumentReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[289], 4)->as<IfcDocumentReference>(); }
::Ifc4::IfcDocumentInformationRelationship::list::ptr Ifc4::IfcDocumentInformation::IsPointedTo() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[288], 3)->as<IfcDocumentInformationRelationship>(); }
::Ifc4::IfcDocumentInformationRelationship::list::ptr Ifc4::IfcDocumentInformation::IsPointer() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[288], 2)->as<IfcDocumentInformationRelationship>(); }

const IfcParse::entity& Ifc4::IfcDocumentInformation::declaration() const { return *((IfcParse::entity*)IFC4_types[287]); }
const IfcParse::entity& Ifc4::IfcDocumentInformation::Class() { return *((IfcParse::entity*)IFC4_types[287]); }
Ifc4::IfcDocumentInformation::IfcDocumentInformation(IfcEntityInstanceData&& e) : IfcExternalInformation(std::move(e)) { }
Ifc4::IfcDocumentInformation::IfcDocumentInformation(std::string v1_Identification, std::string v2_Name, boost::optional< std::string > v3_Description, boost::optional< std::string > v4_Location, boost::optional< std::string > v5_Purpose, boost::optional< std::string > v6_IntendedUse, boost::optional< std::string > v7_Scope, boost::optional< std::string > v8_Revision, ::Ifc4::IfcActorSelect* v9_DocumentOwner, boost::optional< aggregate_of< ::Ifc4::IfcActorSelect >::ptr > v10_Editors, boost::optional< std::string > v11_CreationTime, boost::optional< std::string > v12_LastRevisionTime, boost::optional< std::string > v13_ElectronicFormat, boost::optional< std::string > v14_ValidFrom, boost::optional< std::string > v15_ValidUntil, boost::optional< ::Ifc4::IfcDocumentConfidentialityEnum::Value > v16_Confidentiality, boost::optional< ::Ifc4::IfcDocumentStatusEnum::Value > v17_Status) : IfcExternalInformation(IfcEntityInstanceData(storage_t(17))) { set_attribute_value(0, (v1_Identification));set_attribute_value(1, (v2_Name)); if (v3_Description) {set_attribute_value(2, (*v3_Description)); } if (v4_Location) {set_attribute_value(3, (*v4_Location)); } if (v5_Purpose) {set_attribute_value(4, (*v5_Purpose)); } if (v6_IntendedUse) {set_attribute_value(5, (*v6_IntendedUse)); } if (v7_Scope) {set_attribute_value(6, (*v7_Scope)); } if (v8_Revision) {set_attribute_value(7, (*v8_Revision)); }set_attribute_value(8, v9_DocumentOwner ? v9_DocumentOwner->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v10_Editors) {set_attribute_value(9, (*v10_Editors)->generalize()); } if (v11_CreationTime) {set_attribute_value(10, (*v11_CreationTime)); } if (v12_LastRevisionTime) {set_attribute_value(11, (*v12_LastRevisionTime)); } if (v13_ElectronicFormat) {set_attribute_value(12, (*v13_ElectronicFormat)); } if (v14_ValidFrom) {set_attribute_value(13, (*v14_ValidFrom)); } if (v15_ValidUntil) {set_attribute_value(14, (*v15_ValidUntil)); } if (v16_Confidentiality) {set_attribute_value(15, (EnumerationReference(&::Ifc4::IfcDocumentConfidentialityEnum::Class(),(size_t)*v16_Confidentiality))); } if (v17_Status) {set_attribute_value(16, (EnumerationReference(&::Ifc4::IfcDocumentStatusEnum::Class(),(size_t)*v17_Status))); }; populate_derived(); }

// Function implementations for IfcDocumentInformationRelationship
::Ifc4::IfcDocumentInformation* Ifc4::IfcDocumentInformationRelationship::RelatingDocument() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcDocumentInformation>(true); }
void Ifc4::IfcDocumentInformationRelationship::setRelatingDocument(::Ifc4::IfcDocumentInformation* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
aggregate_of< ::Ifc4::IfcDocumentInformation >::ptr Ifc4::IfcDocumentInformationRelationship::RelatedDocuments() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcDocumentInformation >(); }
void Ifc4::IfcDocumentInformationRelationship::setRelatedDocuments(aggregate_of< ::Ifc4::IfcDocumentInformation >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcDocumentInformationRelationship::RelationshipType() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcDocumentInformationRelationship::setRelationshipType(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcDocumentInformationRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[288]); }
const IfcParse::entity& Ifc4::IfcDocumentInformationRelationship::Class() { return *((IfcParse::entity*)IFC4_types[288]); }
Ifc4::IfcDocumentInformationRelationship::IfcDocumentInformationRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcDocumentInformationRelationship::IfcDocumentInformationRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcDocumentInformation* v3_RelatingDocument, aggregate_of< ::Ifc4::IfcDocumentInformation >::ptr v4_RelatedDocuments, boost::optional< std::string > v5_RelationshipType) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(5))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_RelatingDocument ? v3_RelatingDocument->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_RelatedDocuments)->generalize()); if (v5_RelationshipType) {set_attribute_value(4, (*v5_RelationshipType)); }; populate_derived(); }

// Function implementations for IfcDocumentReference
boost::optional< std::string > Ifc4::IfcDocumentReference::Description() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcDocumentReference::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
::Ifc4::IfcDocumentInformation* Ifc4::IfcDocumentReference::ReferencedDocument() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcDocumentInformation>(true); }
void Ifc4::IfcDocumentReference::setReferencedDocument(::Ifc4::IfcDocumentInformation* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }

::Ifc4::IfcRelAssociatesDocument::list::ptr Ifc4::IfcDocumentReference::DocumentRefForObjects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[810], 5)->as<IfcRelAssociatesDocument>(); }

const IfcParse::entity& Ifc4::IfcDocumentReference::declaration() const { return *((IfcParse::entity*)IFC4_types[289]); }
const IfcParse::entity& Ifc4::IfcDocumentReference::Class() { return *((IfcParse::entity*)IFC4_types[289]); }
Ifc4::IfcDocumentReference::IfcDocumentReference(IfcEntityInstanceData&& e) : IfcExternalReference(std::move(e)) { }
Ifc4::IfcDocumentReference::IfcDocumentReference(boost::optional< std::string > v1_Location, boost::optional< std::string > v2_Identification, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcDocumentInformation* v5_ReferencedDocument) : IfcExternalReference(IfcEntityInstanceData(storage_t(5))) {  if (v1_Location) {set_attribute_value(0, (*v1_Location)); } if (v2_Identification) {set_attribute_value(1, (*v2_Identification)); } if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_ReferencedDocument ? v5_ReferencedDocument->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcDoor
boost::optional< double > Ifc4::IfcDoor::OverallHeight() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcDoor::setOverallHeight(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< double > Ifc4::IfcDoor::OverallWidth() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcDoor::setOverallWidth(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< ::Ifc4::IfcDoorTypeEnum::Value > Ifc4::IfcDoor::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcDoorTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcDoor::setPredefinedType(boost::optional< ::Ifc4::IfcDoorTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcDoorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }
boost::optional< ::Ifc4::IfcDoorTypeOperationEnum::Value > Ifc4::IfcDoor::OperationType() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } return ::Ifc4::IfcDoorTypeOperationEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcDoor::setOperationType(boost::optional< ::Ifc4::IfcDoorTypeOperationEnum::Value > v) { if (v) {set_attribute_value(11, EnumerationReference(&::Ifc4::IfcDoorTypeOperationEnum::Class(), (size_t) *v));} else {unset_attribute_value(11);} }
boost::optional< std::string > Ifc4::IfcDoor::UserDefinedOperationType() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcDoor::setUserDefinedOperationType(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }


const IfcParse::entity& Ifc4::IfcDoor::declaration() const { return *((IfcParse::entity*)IFC4_types[292]); }
const IfcParse::entity& Ifc4::IfcDoor::Class() { return *((IfcParse::entity*)IFC4_types[292]); }
Ifc4::IfcDoor::IfcDoor(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcDoor::IfcDoor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< double > v9_OverallHeight, boost::optional< double > v10_OverallWidth, boost::optional< ::Ifc4::IfcDoorTypeEnum::Value > v11_PredefinedType, boost::optional< ::Ifc4::IfcDoorTypeOperationEnum::Value > v12_OperationType, boost::optional< std::string > v13_UserDefinedOperationType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_OverallHeight) {set_attribute_value(8, (*v9_OverallHeight)); } if (v10_OverallWidth) {set_attribute_value(9, (*v10_OverallWidth)); } if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcDoorTypeEnum::Class(),(size_t)*v11_PredefinedType))); } if (v12_OperationType) {set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcDoorTypeOperationEnum::Class(),(size_t)*v12_OperationType))); } if (v13_UserDefinedOperationType) {set_attribute_value(12, (*v13_UserDefinedOperationType)); }; populate_derived(); }

// Function implementations for IfcDoorLiningProperties
boost::optional< double > Ifc4::IfcDoorLiningProperties::LiningDepth() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcDoorLiningProperties::setLiningDepth(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::LiningThickness() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcDoorLiningProperties::setLiningThickness(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::ThresholdDepth() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcDoorLiningProperties::setThresholdDepth(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::ThresholdThickness() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcDoorLiningProperties::setThresholdThickness(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::TransomThickness() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcDoorLiningProperties::setTransomThickness(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::TransomOffset() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcDoorLiningProperties::setTransomOffset(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::LiningOffset() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcDoorLiningProperties::setLiningOffset(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::ThresholdOffset() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcDoorLiningProperties::setThresholdOffset(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::CasingThickness() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcDoorLiningProperties::setCasingThickness(boost::optional< double > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::CasingDepth() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } double v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcDoorLiningProperties::setCasingDepth(boost::optional< double > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
::Ifc4::IfcShapeAspect* Ifc4::IfcDoorLiningProperties::ShapeAspectStyle() const { if(data_.get_attribute_value(14).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(14)))->as<::Ifc4::IfcShapeAspect>(true); }
void Ifc4::IfcDoorLiningProperties::setShapeAspectStyle(::Ifc4::IfcShapeAspect* v) { set_attribute_value(14, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(14); }
boost::optional< double > Ifc4::IfcDoorLiningProperties::LiningToPanelOffsetX() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } double v = data_.get_attribute_value(15); return v; }
void Ifc4::IfcDoorLiningProperties::setLiningToPanelOffsetX(boost::optional< double > v) { if (v) {set_attribute_value(15, *v);} else {unset_attribute_value(15);} }
boost::optional< double > Ifc4::IfcDoorLiningProperties::LiningToPanelOffsetY() const { if(data_.get_attribute_value(16).isNull()) { return boost::none; } double v = data_.get_attribute_value(16); return v; }
void Ifc4::IfcDoorLiningProperties::setLiningToPanelOffsetY(boost::optional< double > v) { if (v) {set_attribute_value(16, *v);} else {unset_attribute_value(16);} }


const IfcParse::entity& Ifc4::IfcDoorLiningProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[293]); }
const IfcParse::entity& Ifc4::IfcDoorLiningProperties::Class() { return *((IfcParse::entity*)IFC4_types[293]); }
Ifc4::IfcDoorLiningProperties::IfcDoorLiningProperties(IfcEntityInstanceData&& e) : IfcPreDefinedPropertySet(std::move(e)) { }
Ifc4::IfcDoorLiningProperties::IfcDoorLiningProperties(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< double > v5_LiningDepth, boost::optional< double > v6_LiningThickness, boost::optional< double > v7_ThresholdDepth, boost::optional< double > v8_ThresholdThickness, boost::optional< double > v9_TransomThickness, boost::optional< double > v10_TransomOffset, boost::optional< double > v11_LiningOffset, boost::optional< double > v12_ThresholdOffset, boost::optional< double > v13_CasingThickness, boost::optional< double > v14_CasingDepth, ::Ifc4::IfcShapeAspect* v15_ShapeAspectStyle, boost::optional< double > v16_LiningToPanelOffsetX, boost::optional< double > v17_LiningToPanelOffsetY) : IfcPreDefinedPropertySet(IfcEntityInstanceData(storage_t(17))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_LiningDepth) {set_attribute_value(4, (*v5_LiningDepth)); } if (v6_LiningThickness) {set_attribute_value(5, (*v6_LiningThickness)); } if (v7_ThresholdDepth) {set_attribute_value(6, (*v7_ThresholdDepth)); } if (v8_ThresholdThickness) {set_attribute_value(7, (*v8_ThresholdThickness)); } if (v9_TransomThickness) {set_attribute_value(8, (*v9_TransomThickness)); } if (v10_TransomOffset) {set_attribute_value(9, (*v10_TransomOffset)); } if (v11_LiningOffset) {set_attribute_value(10, (*v11_LiningOffset)); } if (v12_ThresholdOffset) {set_attribute_value(11, (*v12_ThresholdOffset)); } if (v13_CasingThickness) {set_attribute_value(12, (*v13_CasingThickness)); } if (v14_CasingDepth) {set_attribute_value(13, (*v14_CasingDepth)); }set_attribute_value(14, v15_ShapeAspectStyle ? v15_ShapeAspectStyle->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v16_LiningToPanelOffsetX) {set_attribute_value(15, (*v16_LiningToPanelOffsetX)); } if (v17_LiningToPanelOffsetY) {set_attribute_value(16, (*v17_LiningToPanelOffsetY)); }; populate_derived(); }

// Function implementations for IfcDoorPanelProperties
boost::optional< double > Ifc4::IfcDoorPanelProperties::PanelDepth() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcDoorPanelProperties::setPanelDepth(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
::Ifc4::IfcDoorPanelOperationEnum::Value Ifc4::IfcDoorPanelProperties::PanelOperation() const {  return ::Ifc4::IfcDoorPanelOperationEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcDoorPanelProperties::setPanelOperation(::Ifc4::IfcDoorPanelOperationEnum::Value v) { set_attribute_value(5, EnumerationReference(&::Ifc4::IfcDoorPanelOperationEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(5); }
boost::optional< double > Ifc4::IfcDoorPanelProperties::PanelWidth() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcDoorPanelProperties::setPanelWidth(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
::Ifc4::IfcDoorPanelPositionEnum::Value Ifc4::IfcDoorPanelProperties::PanelPosition() const {  return ::Ifc4::IfcDoorPanelPositionEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcDoorPanelProperties::setPanelPosition(::Ifc4::IfcDoorPanelPositionEnum::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcDoorPanelPositionEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcShapeAspect* Ifc4::IfcDoorPanelProperties::ShapeAspectStyle() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcShapeAspect>(true); }
void Ifc4::IfcDoorPanelProperties::setShapeAspectStyle(::Ifc4::IfcShapeAspect* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcDoorPanelProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[296]); }
const IfcParse::entity& Ifc4::IfcDoorPanelProperties::Class() { return *((IfcParse::entity*)IFC4_types[296]); }
Ifc4::IfcDoorPanelProperties::IfcDoorPanelProperties(IfcEntityInstanceData&& e) : IfcPreDefinedPropertySet(std::move(e)) { }
Ifc4::IfcDoorPanelProperties::IfcDoorPanelProperties(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< double > v5_PanelDepth, ::Ifc4::IfcDoorPanelOperationEnum::Value v6_PanelOperation, boost::optional< double > v7_PanelWidth, ::Ifc4::IfcDoorPanelPositionEnum::Value v8_PanelPosition, ::Ifc4::IfcShapeAspect* v9_ShapeAspectStyle) : IfcPreDefinedPropertySet(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_PanelDepth) {set_attribute_value(4, (*v5_PanelDepth)); }set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcDoorPanelOperationEnum::Class(),(size_t)v6_PanelOperation))); if (v7_PanelWidth) {set_attribute_value(6, (*v7_PanelWidth)); }set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcDoorPanelPositionEnum::Class(),(size_t)v8_PanelPosition)));set_attribute_value(8, v9_ShapeAspectStyle ? v9_ShapeAspectStyle->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcDoorStandardCase


const IfcParse::entity& Ifc4::IfcDoorStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[297]); }
const IfcParse::entity& Ifc4::IfcDoorStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[297]); }
Ifc4::IfcDoorStandardCase::IfcDoorStandardCase(IfcEntityInstanceData&& e) : IfcDoor(std::move(e)) { }
Ifc4::IfcDoorStandardCase::IfcDoorStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< double > v9_OverallHeight, boost::optional< double > v10_OverallWidth, boost::optional< ::Ifc4::IfcDoorTypeEnum::Value > v11_PredefinedType, boost::optional< ::Ifc4::IfcDoorTypeOperationEnum::Value > v12_OperationType, boost::optional< std::string > v13_UserDefinedOperationType) : IfcDoor(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_OverallHeight) {set_attribute_value(8, (*v9_OverallHeight)); } if (v10_OverallWidth) {set_attribute_value(9, (*v10_OverallWidth)); } if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcDoorTypeEnum::Class(),(size_t)*v11_PredefinedType))); } if (v12_OperationType) {set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcDoorTypeOperationEnum::Class(),(size_t)*v12_OperationType))); } if (v13_UserDefinedOperationType) {set_attribute_value(12, (*v13_UserDefinedOperationType)); }; populate_derived(); }

// Function implementations for IfcDoorStyle
::Ifc4::IfcDoorStyleOperationEnum::Value Ifc4::IfcDoorStyle::OperationType() const {  return ::Ifc4::IfcDoorStyleOperationEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcDoorStyle::setOperationType(::Ifc4::IfcDoorStyleOperationEnum::Value v) { set_attribute_value(8, EnumerationReference(&::Ifc4::IfcDoorStyleOperationEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(8); }
::Ifc4::IfcDoorStyleConstructionEnum::Value Ifc4::IfcDoorStyle::ConstructionType() const {  return ::Ifc4::IfcDoorStyleConstructionEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDoorStyle::setConstructionType(::Ifc4::IfcDoorStyleConstructionEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDoorStyleConstructionEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
bool Ifc4::IfcDoorStyle::ParameterTakesPrecedence() const {  bool v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcDoorStyle::setParameterTakesPrecedence(bool v) { set_attribute_value(10, v);if constexpr (false)unset_attribute_value(10); }
bool Ifc4::IfcDoorStyle::Sizeable() const {  bool v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcDoorStyle::setSizeable(bool v) { set_attribute_value(11, v);if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcDoorStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[298]); }
const IfcParse::entity& Ifc4::IfcDoorStyle::Class() { return *((IfcParse::entity*)IFC4_types[298]); }
Ifc4::IfcDoorStyle::IfcDoorStyle(IfcEntityInstanceData&& e) : IfcTypeProduct(std::move(e)) { }
Ifc4::IfcDoorStyle::IfcDoorStyle(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, ::Ifc4::IfcDoorStyleOperationEnum::Value v9_OperationType, ::Ifc4::IfcDoorStyleConstructionEnum::Value v10_ConstructionType, bool v11_ParameterTakesPrecedence, bool v12_Sizeable) : IfcTypeProduct(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcDoorStyleOperationEnum::Class(),(size_t)v9_OperationType)));set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDoorStyleConstructionEnum::Class(),(size_t)v10_ConstructionType)));set_attribute_value(10, (v11_ParameterTakesPrecedence));set_attribute_value(11, (v12_Sizeable));; populate_derived(); }

// Function implementations for IfcDoorType
::Ifc4::IfcDoorTypeEnum::Value Ifc4::IfcDoorType::PredefinedType() const {  return ::Ifc4::IfcDoorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDoorType::setPredefinedType(::Ifc4::IfcDoorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDoorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
::Ifc4::IfcDoorTypeOperationEnum::Value Ifc4::IfcDoorType::OperationType() const {  return ::Ifc4::IfcDoorTypeOperationEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcDoorType::setOperationType(::Ifc4::IfcDoorTypeOperationEnum::Value v) { set_attribute_value(10, EnumerationReference(&::Ifc4::IfcDoorTypeOperationEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(10); }
boost::optional< bool > Ifc4::IfcDoorType::ParameterTakesPrecedence() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } bool v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcDoorType::setParameterTakesPrecedence(boost::optional< bool > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< std::string > Ifc4::IfcDoorType::UserDefinedOperationType() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcDoorType::setUserDefinedOperationType(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }


const IfcParse::entity& Ifc4::IfcDoorType::declaration() const { return *((IfcParse::entity*)IFC4_types[301]); }
const IfcParse::entity& Ifc4::IfcDoorType::Class() { return *((IfcParse::entity*)IFC4_types[301]); }
Ifc4::IfcDoorType::IfcDoorType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcDoorType::IfcDoorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcDoorTypeEnum::Value v10_PredefinedType, ::Ifc4::IfcDoorTypeOperationEnum::Value v11_OperationType, boost::optional< bool > v12_ParameterTakesPrecedence, boost::optional< std::string > v13_UserDefinedOperationType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDoorTypeEnum::Class(),(size_t)v10_PredefinedType)));set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcDoorTypeOperationEnum::Class(),(size_t)v11_OperationType))); if (v12_ParameterTakesPrecedence) {set_attribute_value(11, (*v12_ParameterTakesPrecedence)); } if (v13_UserDefinedOperationType) {set_attribute_value(12, (*v13_UserDefinedOperationType)); }; populate_derived(); }

// Function implementations for IfcDraughtingPreDefinedColour


const IfcParse::entity& Ifc4::IfcDraughtingPreDefinedColour::declaration() const { return *((IfcParse::entity*)IFC4_types[305]); }
const IfcParse::entity& Ifc4::IfcDraughtingPreDefinedColour::Class() { return *((IfcParse::entity*)IFC4_types[305]); }
Ifc4::IfcDraughtingPreDefinedColour::IfcDraughtingPreDefinedColour(IfcEntityInstanceData&& e) : IfcPreDefinedColour(std::move(e)) { }
Ifc4::IfcDraughtingPreDefinedColour::IfcDraughtingPreDefinedColour(std::string v1_Name) : IfcPreDefinedColour(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Name));; populate_derived(); }

// Function implementations for IfcDraughtingPreDefinedCurveFont


const IfcParse::entity& Ifc4::IfcDraughtingPreDefinedCurveFont::declaration() const { return *((IfcParse::entity*)IFC4_types[306]); }
const IfcParse::entity& Ifc4::IfcDraughtingPreDefinedCurveFont::Class() { return *((IfcParse::entity*)IFC4_types[306]); }
Ifc4::IfcDraughtingPreDefinedCurveFont::IfcDraughtingPreDefinedCurveFont(IfcEntityInstanceData&& e) : IfcPreDefinedCurveFont(std::move(e)) { }
Ifc4::IfcDraughtingPreDefinedCurveFont::IfcDraughtingPreDefinedCurveFont(std::string v1_Name) : IfcPreDefinedCurveFont(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Name));; populate_derived(); }

// Function implementations for IfcDuctFitting
boost::optional< ::Ifc4::IfcDuctFittingTypeEnum::Value > Ifc4::IfcDuctFitting::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcDuctFittingTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcDuctFitting::setPredefinedType(boost::optional< ::Ifc4::IfcDuctFittingTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcDuctFittingTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcDuctFitting::declaration() const { return *((IfcParse::entity*)IFC4_types[307]); }
const IfcParse::entity& Ifc4::IfcDuctFitting::Class() { return *((IfcParse::entity*)IFC4_types[307]); }
Ifc4::IfcDuctFitting::IfcDuctFitting(IfcEntityInstanceData&& e) : IfcFlowFitting(std::move(e)) { }
Ifc4::IfcDuctFitting::IfcDuctFitting(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcDuctFittingTypeEnum::Value > v9_PredefinedType) : IfcFlowFitting(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcDuctFittingTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcDuctFittingType
::Ifc4::IfcDuctFittingTypeEnum::Value Ifc4::IfcDuctFittingType::PredefinedType() const {  return ::Ifc4::IfcDuctFittingTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDuctFittingType::setPredefinedType(::Ifc4::IfcDuctFittingTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDuctFittingTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcDuctFittingType::declaration() const { return *((IfcParse::entity*)IFC4_types[308]); }
const IfcParse::entity& Ifc4::IfcDuctFittingType::Class() { return *((IfcParse::entity*)IFC4_types[308]); }
Ifc4::IfcDuctFittingType::IfcDuctFittingType(IfcEntityInstanceData&& e) : IfcFlowFittingType(std::move(e)) { }
Ifc4::IfcDuctFittingType::IfcDuctFittingType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcDuctFittingTypeEnum::Value v10_PredefinedType) : IfcFlowFittingType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDuctFittingTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcDuctSegment
boost::optional< ::Ifc4::IfcDuctSegmentTypeEnum::Value > Ifc4::IfcDuctSegment::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcDuctSegmentTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcDuctSegment::setPredefinedType(boost::optional< ::Ifc4::IfcDuctSegmentTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcDuctSegmentTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcDuctSegment::declaration() const { return *((IfcParse::entity*)IFC4_types[310]); }
const IfcParse::entity& Ifc4::IfcDuctSegment::Class() { return *((IfcParse::entity*)IFC4_types[310]); }
Ifc4::IfcDuctSegment::IfcDuctSegment(IfcEntityInstanceData&& e) : IfcFlowSegment(std::move(e)) { }
Ifc4::IfcDuctSegment::IfcDuctSegment(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcDuctSegmentTypeEnum::Value > v9_PredefinedType) : IfcFlowSegment(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcDuctSegmentTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcDuctSegmentType
::Ifc4::IfcDuctSegmentTypeEnum::Value Ifc4::IfcDuctSegmentType::PredefinedType() const {  return ::Ifc4::IfcDuctSegmentTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDuctSegmentType::setPredefinedType(::Ifc4::IfcDuctSegmentTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDuctSegmentTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcDuctSegmentType::declaration() const { return *((IfcParse::entity*)IFC4_types[311]); }
const IfcParse::entity& Ifc4::IfcDuctSegmentType::Class() { return *((IfcParse::entity*)IFC4_types[311]); }
Ifc4::IfcDuctSegmentType::IfcDuctSegmentType(IfcEntityInstanceData&& e) : IfcFlowSegmentType(std::move(e)) { }
Ifc4::IfcDuctSegmentType::IfcDuctSegmentType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcDuctSegmentTypeEnum::Value v10_PredefinedType) : IfcFlowSegmentType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDuctSegmentTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcDuctSilencer
boost::optional< ::Ifc4::IfcDuctSilencerTypeEnum::Value > Ifc4::IfcDuctSilencer::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcDuctSilencerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcDuctSilencer::setPredefinedType(boost::optional< ::Ifc4::IfcDuctSilencerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcDuctSilencerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcDuctSilencer::declaration() const { return *((IfcParse::entity*)IFC4_types[313]); }
const IfcParse::entity& Ifc4::IfcDuctSilencer::Class() { return *((IfcParse::entity*)IFC4_types[313]); }
Ifc4::IfcDuctSilencer::IfcDuctSilencer(IfcEntityInstanceData&& e) : IfcFlowTreatmentDevice(std::move(e)) { }
Ifc4::IfcDuctSilencer::IfcDuctSilencer(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcDuctSilencerTypeEnum::Value > v9_PredefinedType) : IfcFlowTreatmentDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcDuctSilencerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcDuctSilencerType
::Ifc4::IfcDuctSilencerTypeEnum::Value Ifc4::IfcDuctSilencerType::PredefinedType() const {  return ::Ifc4::IfcDuctSilencerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcDuctSilencerType::setPredefinedType(::Ifc4::IfcDuctSilencerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcDuctSilencerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcDuctSilencerType::declaration() const { return *((IfcParse::entity*)IFC4_types[314]); }
const IfcParse::entity& Ifc4::IfcDuctSilencerType::Class() { return *((IfcParse::entity*)IFC4_types[314]); }
Ifc4::IfcDuctSilencerType::IfcDuctSilencerType(IfcEntityInstanceData&& e) : IfcFlowTreatmentDeviceType(std::move(e)) { }
Ifc4::IfcDuctSilencerType::IfcDuctSilencerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcDuctSilencerTypeEnum::Value v10_PredefinedType) : IfcFlowTreatmentDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcDuctSilencerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcEdge
::Ifc4::IfcVertex* Ifc4::IfcEdge::EdgeStart() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcVertex>(true); }
void Ifc4::IfcEdge::setEdgeStart(::Ifc4::IfcVertex* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcVertex* Ifc4::IfcEdge::EdgeEnd() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcVertex>(true); }
void Ifc4::IfcEdge::setEdgeEnd(::Ifc4::IfcVertex* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcEdge::declaration() const { return *((IfcParse::entity*)IFC4_types[318]); }
const IfcParse::entity& Ifc4::IfcEdge::Class() { return *((IfcParse::entity*)IFC4_types[318]); }
Ifc4::IfcEdge::IfcEdge(IfcEntityInstanceData&& e) : IfcTopologicalRepresentationItem(std::move(e)) { }
Ifc4::IfcEdge::IfcEdge(::Ifc4::IfcVertex* v1_EdgeStart, ::Ifc4::IfcVertex* v2_EdgeEnd) : IfcTopologicalRepresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_EdgeStart ? v1_EdgeStart->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_EdgeEnd ? v2_EdgeEnd->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcEdgeCurve
::Ifc4::IfcCurve* Ifc4::IfcEdgeCurve::EdgeGeometry() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcEdgeCurve::setEdgeGeometry(::Ifc4::IfcCurve* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
bool Ifc4::IfcEdgeCurve::SameSense() const {  bool v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcEdgeCurve::setSameSense(bool v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcEdgeCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[319]); }
const IfcParse::entity& Ifc4::IfcEdgeCurve::Class() { return *((IfcParse::entity*)IFC4_types[319]); }
Ifc4::IfcEdgeCurve::IfcEdgeCurve(IfcEntityInstanceData&& e) : IfcEdge(std::move(e)) { }
Ifc4::IfcEdgeCurve::IfcEdgeCurve(::Ifc4::IfcVertex* v1_EdgeStart, ::Ifc4::IfcVertex* v2_EdgeEnd, ::Ifc4::IfcCurve* v3_EdgeGeometry, bool v4_SameSense) : IfcEdge(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_EdgeStart ? v1_EdgeStart->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_EdgeEnd ? v2_EdgeEnd->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_EdgeGeometry ? v3_EdgeGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_SameSense));; populate_derived(); }

// Function implementations for IfcEdgeLoop
aggregate_of< ::Ifc4::IfcOrientedEdge >::ptr Ifc4::IfcEdgeLoop::EdgeList() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcOrientedEdge >(); }
void Ifc4::IfcEdgeLoop::setEdgeList(aggregate_of< ::Ifc4::IfcOrientedEdge >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcEdgeLoop::declaration() const { return *((IfcParse::entity*)IFC4_types[320]); }
const IfcParse::entity& Ifc4::IfcEdgeLoop::Class() { return *((IfcParse::entity*)IFC4_types[320]); }
Ifc4::IfcEdgeLoop::IfcEdgeLoop(IfcEntityInstanceData&& e) : IfcLoop(std::move(e)) { }
Ifc4::IfcEdgeLoop::IfcEdgeLoop(aggregate_of< ::Ifc4::IfcOrientedEdge >::ptr v1_EdgeList) : IfcLoop(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_EdgeList)->generalize());; populate_derived(); }

// Function implementations for IfcElectricAppliance
boost::optional< ::Ifc4::IfcElectricApplianceTypeEnum::Value > Ifc4::IfcElectricAppliance::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcElectricApplianceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcElectricAppliance::setPredefinedType(boost::optional< ::Ifc4::IfcElectricApplianceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcElectricApplianceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcElectricAppliance::declaration() const { return *((IfcParse::entity*)IFC4_types[321]); }
const IfcParse::entity& Ifc4::IfcElectricAppliance::Class() { return *((IfcParse::entity*)IFC4_types[321]); }
Ifc4::IfcElectricAppliance::IfcElectricAppliance(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcElectricAppliance::IfcElectricAppliance(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcElectricApplianceTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElectricApplianceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcElectricApplianceType
::Ifc4::IfcElectricApplianceTypeEnum::Value Ifc4::IfcElectricApplianceType::PredefinedType() const {  return ::Ifc4::IfcElectricApplianceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcElectricApplianceType::setPredefinedType(::Ifc4::IfcElectricApplianceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcElectricApplianceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcElectricApplianceType::declaration() const { return *((IfcParse::entity*)IFC4_types[322]); }
const IfcParse::entity& Ifc4::IfcElectricApplianceType::Class() { return *((IfcParse::entity*)IFC4_types[322]); }
Ifc4::IfcElectricApplianceType::IfcElectricApplianceType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcElectricApplianceType::IfcElectricApplianceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcElectricApplianceTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcElectricApplianceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcElectricDistributionBoard
boost::optional< ::Ifc4::IfcElectricDistributionBoardTypeEnum::Value > Ifc4::IfcElectricDistributionBoard::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcElectricDistributionBoardTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcElectricDistributionBoard::setPredefinedType(boost::optional< ::Ifc4::IfcElectricDistributionBoardTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcElectricDistributionBoardTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcElectricDistributionBoard::declaration() const { return *((IfcParse::entity*)IFC4_types[328]); }
const IfcParse::entity& Ifc4::IfcElectricDistributionBoard::Class() { return *((IfcParse::entity*)IFC4_types[328]); }
Ifc4::IfcElectricDistributionBoard::IfcElectricDistributionBoard(IfcEntityInstanceData&& e) : IfcFlowController(std::move(e)) { }
Ifc4::IfcElectricDistributionBoard::IfcElectricDistributionBoard(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcElectricDistributionBoardTypeEnum::Value > v9_PredefinedType) : IfcFlowController(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElectricDistributionBoardTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcElectricDistributionBoardType
::Ifc4::IfcElectricDistributionBoardTypeEnum::Value Ifc4::IfcElectricDistributionBoardType::PredefinedType() const {  return ::Ifc4::IfcElectricDistributionBoardTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcElectricDistributionBoardType::setPredefinedType(::Ifc4::IfcElectricDistributionBoardTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcElectricDistributionBoardTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcElectricDistributionBoardType::declaration() const { return *((IfcParse::entity*)IFC4_types[329]); }
const IfcParse::entity& Ifc4::IfcElectricDistributionBoardType::Class() { return *((IfcParse::entity*)IFC4_types[329]); }
Ifc4::IfcElectricDistributionBoardType::IfcElectricDistributionBoardType(IfcEntityInstanceData&& e) : IfcFlowControllerType(std::move(e)) { }
Ifc4::IfcElectricDistributionBoardType::IfcElectricDistributionBoardType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcElectricDistributionBoardTypeEnum::Value v10_PredefinedType) : IfcFlowControllerType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcElectricDistributionBoardTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcElectricFlowStorageDevice
boost::optional< ::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value > Ifc4::IfcElectricFlowStorageDevice::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcElectricFlowStorageDevice::setPredefinedType(boost::optional< ::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcElectricFlowStorageDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[331]); }
const IfcParse::entity& Ifc4::IfcElectricFlowStorageDevice::Class() { return *((IfcParse::entity*)IFC4_types[331]); }
Ifc4::IfcElectricFlowStorageDevice::IfcElectricFlowStorageDevice(IfcEntityInstanceData&& e) : IfcFlowStorageDevice(std::move(e)) { }
Ifc4::IfcElectricFlowStorageDevice::IfcElectricFlowStorageDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value > v9_PredefinedType) : IfcFlowStorageDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcElectricFlowStorageDeviceType
::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value Ifc4::IfcElectricFlowStorageDeviceType::PredefinedType() const {  return ::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcElectricFlowStorageDeviceType::setPredefinedType(::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcElectricFlowStorageDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[332]); }
const IfcParse::entity& Ifc4::IfcElectricFlowStorageDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[332]); }
Ifc4::IfcElectricFlowStorageDeviceType::IfcElectricFlowStorageDeviceType(IfcEntityInstanceData&& e) : IfcFlowStorageDeviceType(std::move(e)) { }
Ifc4::IfcElectricFlowStorageDeviceType::IfcElectricFlowStorageDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Value v10_PredefinedType) : IfcFlowStorageDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcElectricFlowStorageDeviceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcElectricGenerator
boost::optional< ::Ifc4::IfcElectricGeneratorTypeEnum::Value > Ifc4::IfcElectricGenerator::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcElectricGeneratorTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcElectricGenerator::setPredefinedType(boost::optional< ::Ifc4::IfcElectricGeneratorTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcElectricGeneratorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcElectricGenerator::declaration() const { return *((IfcParse::entity*)IFC4_types[334]); }
const IfcParse::entity& Ifc4::IfcElectricGenerator::Class() { return *((IfcParse::entity*)IFC4_types[334]); }
Ifc4::IfcElectricGenerator::IfcElectricGenerator(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcElectricGenerator::IfcElectricGenerator(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcElectricGeneratorTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElectricGeneratorTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcElectricGeneratorType
::Ifc4::IfcElectricGeneratorTypeEnum::Value Ifc4::IfcElectricGeneratorType::PredefinedType() const {  return ::Ifc4::IfcElectricGeneratorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcElectricGeneratorType::setPredefinedType(::Ifc4::IfcElectricGeneratorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcElectricGeneratorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcElectricGeneratorType::declaration() const { return *((IfcParse::entity*)IFC4_types[335]); }
const IfcParse::entity& Ifc4::IfcElectricGeneratorType::Class() { return *((IfcParse::entity*)IFC4_types[335]); }
Ifc4::IfcElectricGeneratorType::IfcElectricGeneratorType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcElectricGeneratorType::IfcElectricGeneratorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcElectricGeneratorTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcElectricGeneratorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcElectricMotor
boost::optional< ::Ifc4::IfcElectricMotorTypeEnum::Value > Ifc4::IfcElectricMotor::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcElectricMotorTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcElectricMotor::setPredefinedType(boost::optional< ::Ifc4::IfcElectricMotorTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcElectricMotorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcElectricMotor::declaration() const { return *((IfcParse::entity*)IFC4_types[337]); }
const IfcParse::entity& Ifc4::IfcElectricMotor::Class() { return *((IfcParse::entity*)IFC4_types[337]); }
Ifc4::IfcElectricMotor::IfcElectricMotor(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcElectricMotor::IfcElectricMotor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcElectricMotorTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElectricMotorTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcElectricMotorType
::Ifc4::IfcElectricMotorTypeEnum::Value Ifc4::IfcElectricMotorType::PredefinedType() const {  return ::Ifc4::IfcElectricMotorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcElectricMotorType::setPredefinedType(::Ifc4::IfcElectricMotorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcElectricMotorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcElectricMotorType::declaration() const { return *((IfcParse::entity*)IFC4_types[338]); }
const IfcParse::entity& Ifc4::IfcElectricMotorType::Class() { return *((IfcParse::entity*)IFC4_types[338]); }
Ifc4::IfcElectricMotorType::IfcElectricMotorType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcElectricMotorType::IfcElectricMotorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcElectricMotorTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcElectricMotorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcElectricTimeControl
boost::optional< ::Ifc4::IfcElectricTimeControlTypeEnum::Value > Ifc4::IfcElectricTimeControl::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcElectricTimeControlTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcElectricTimeControl::setPredefinedType(boost::optional< ::Ifc4::IfcElectricTimeControlTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcElectricTimeControlTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcElectricTimeControl::declaration() const { return *((IfcParse::entity*)IFC4_types[341]); }
const IfcParse::entity& Ifc4::IfcElectricTimeControl::Class() { return *((IfcParse::entity*)IFC4_types[341]); }
Ifc4::IfcElectricTimeControl::IfcElectricTimeControl(IfcEntityInstanceData&& e) : IfcFlowController(std::move(e)) { }
Ifc4::IfcElectricTimeControl::IfcElectricTimeControl(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcElectricTimeControlTypeEnum::Value > v9_PredefinedType) : IfcFlowController(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElectricTimeControlTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcElectricTimeControlType
::Ifc4::IfcElectricTimeControlTypeEnum::Value Ifc4::IfcElectricTimeControlType::PredefinedType() const {  return ::Ifc4::IfcElectricTimeControlTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcElectricTimeControlType::setPredefinedType(::Ifc4::IfcElectricTimeControlTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcElectricTimeControlTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcElectricTimeControlType::declaration() const { return *((IfcParse::entity*)IFC4_types[342]); }
const IfcParse::entity& Ifc4::IfcElectricTimeControlType::Class() { return *((IfcParse::entity*)IFC4_types[342]); }
Ifc4::IfcElectricTimeControlType::IfcElectricTimeControlType(IfcEntityInstanceData&& e) : IfcFlowControllerType(std::move(e)) { }
Ifc4::IfcElectricTimeControlType::IfcElectricTimeControlType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcElectricTimeControlTypeEnum::Value v10_PredefinedType) : IfcFlowControllerType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcElectricTimeControlTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcElement
boost::optional< std::string > Ifc4::IfcElement::Tag() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcElement::setTag(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }

::Ifc4::IfcRelFillsElement::list::ptr Ifc4::IfcElement::FillsVoids() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[833], 5)->as<IfcRelFillsElement>(); }
::Ifc4::IfcRelConnectsElements::list::ptr Ifc4::IfcElement::ConnectedTo() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[815], 5)->as<IfcRelConnectsElements>(); }
::Ifc4::IfcRelInterferesElements::list::ptr Ifc4::IfcElement::IsInterferedByElements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[835], 5)->as<IfcRelInterferesElements>(); }
::Ifc4::IfcRelInterferesElements::list::ptr Ifc4::IfcElement::InterferesElements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[835], 4)->as<IfcRelInterferesElements>(); }
::Ifc4::IfcRelProjectsElement::list::ptr Ifc4::IfcElement::HasProjections() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[837], 4)->as<IfcRelProjectsElement>(); }
::Ifc4::IfcRelReferencedInSpatialStructure::list::ptr Ifc4::IfcElement::ReferencedInStructures() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[838], 4)->as<IfcRelReferencedInSpatialStructure>(); }
::Ifc4::IfcRelVoidsElement::list::ptr Ifc4::IfcElement::HasOpenings() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[844], 4)->as<IfcRelVoidsElement>(); }
::Ifc4::IfcRelConnectsWithRealizingElements::list::ptr Ifc4::IfcElement::IsConnectionRealization() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[822], 7)->as<IfcRelConnectsWithRealizingElements>(); }
::Ifc4::IfcRelSpaceBoundary::list::ptr Ifc4::IfcElement::ProvidesBoundaries() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[841], 5)->as<IfcRelSpaceBoundary>(); }
::Ifc4::IfcRelConnectsElements::list::ptr Ifc4::IfcElement::ConnectedFrom() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[815], 6)->as<IfcRelConnectsElements>(); }
::Ifc4::IfcRelContainedInSpatialStructure::list::ptr Ifc4::IfcElement::ContainedInStructure() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[823], 4)->as<IfcRelContainedInSpatialStructure>(); }
::Ifc4::IfcRelCoversBldgElements::list::ptr Ifc4::IfcElement::HasCoverings() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[824], 4)->as<IfcRelCoversBldgElements>(); }

const IfcParse::entity& Ifc4::IfcElement::declaration() const { return *((IfcParse::entity*)IFC4_types[345]); }
const IfcParse::entity& Ifc4::IfcElement::Class() { return *((IfcParse::entity*)IFC4_types[345]); }
Ifc4::IfcElement::IfcElement(IfcEntityInstanceData&& e) : IfcProduct(std::move(e)) { }
Ifc4::IfcElement::IfcElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcProduct(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcElementAssembly
boost::optional< ::Ifc4::IfcAssemblyPlaceEnum::Value > Ifc4::IfcElementAssembly::AssemblyPlace() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcAssemblyPlaceEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcElementAssembly::setAssemblyPlace(boost::optional< ::Ifc4::IfcAssemblyPlaceEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcAssemblyPlaceEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }
boost::optional< ::Ifc4::IfcElementAssemblyTypeEnum::Value > Ifc4::IfcElementAssembly::PredefinedType() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } return ::Ifc4::IfcElementAssemblyTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcElementAssembly::setPredefinedType(boost::optional< ::Ifc4::IfcElementAssemblyTypeEnum::Value > v) { if (v) {set_attribute_value(9, EnumerationReference(&::Ifc4::IfcElementAssemblyTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcElementAssembly::declaration() const { return *((IfcParse::entity*)IFC4_types[347]); }
const IfcParse::entity& Ifc4::IfcElementAssembly::Class() { return *((IfcParse::entity*)IFC4_types[347]); }
Ifc4::IfcElementAssembly::IfcElementAssembly(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcElementAssembly::IfcElementAssembly(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcAssemblyPlaceEnum::Value > v9_AssemblyPlace, boost::optional< ::Ifc4::IfcElementAssemblyTypeEnum::Value > v10_PredefinedType) : IfcElement(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_AssemblyPlace) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcAssemblyPlaceEnum::Class(),(size_t)*v9_AssemblyPlace))); } if (v10_PredefinedType) {set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcElementAssemblyTypeEnum::Class(),(size_t)*v10_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcElementAssemblyType
::Ifc4::IfcElementAssemblyTypeEnum::Value Ifc4::IfcElementAssemblyType::PredefinedType() const {  return ::Ifc4::IfcElementAssemblyTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcElementAssemblyType::setPredefinedType(::Ifc4::IfcElementAssemblyTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcElementAssemblyTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcElementAssemblyType::declaration() const { return *((IfcParse::entity*)IFC4_types[348]); }
const IfcParse::entity& Ifc4::IfcElementAssemblyType::Class() { return *((IfcParse::entity*)IFC4_types[348]); }
Ifc4::IfcElementAssemblyType::IfcElementAssemblyType(IfcEntityInstanceData&& e) : IfcElementType(std::move(e)) { }
Ifc4::IfcElementAssemblyType::IfcElementAssemblyType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcElementAssemblyTypeEnum::Value v10_PredefinedType) : IfcElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcElementAssemblyTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcElementComponent


const IfcParse::entity& Ifc4::IfcElementComponent::declaration() const { return *((IfcParse::entity*)IFC4_types[350]); }
const IfcParse::entity& Ifc4::IfcElementComponent::Class() { return *((IfcParse::entity*)IFC4_types[350]); }
Ifc4::IfcElementComponent::IfcElementComponent(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcElementComponent::IfcElementComponent(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcElementComponentType


const IfcParse::entity& Ifc4::IfcElementComponentType::declaration() const { return *((IfcParse::entity*)IFC4_types[351]); }
const IfcParse::entity& Ifc4::IfcElementComponentType::Class() { return *((IfcParse::entity*)IFC4_types[351]); }
Ifc4::IfcElementComponentType::IfcElementComponentType(IfcEntityInstanceData&& e) : IfcElementType(std::move(e)) { }
Ifc4::IfcElementComponentType::IfcElementComponentType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcElementQuantity
boost::optional< std::string > Ifc4::IfcElementQuantity::MethodOfMeasurement() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcElementQuantity::setMethodOfMeasurement(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr Ifc4::IfcElementQuantity::Quantities() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcPhysicalQuantity >(); }
void Ifc4::IfcElementQuantity::setQuantities(aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcElementQuantity::declaration() const { return *((IfcParse::entity*)IFC4_types[353]); }
const IfcParse::entity& Ifc4::IfcElementQuantity::Class() { return *((IfcParse::entity*)IFC4_types[353]); }
Ifc4::IfcElementQuantity::IfcElementQuantity(IfcEntityInstanceData&& e) : IfcQuantitySet(std::move(e)) { }
Ifc4::IfcElementQuantity::IfcElementQuantity(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_MethodOfMeasurement, aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr v6_Quantities) : IfcQuantitySet(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_MethodOfMeasurement) {set_attribute_value(4, (*v5_MethodOfMeasurement)); }set_attribute_value(5, (v6_Quantities)->generalize());; populate_derived(); }

// Function implementations for IfcElementType
boost::optional< std::string > Ifc4::IfcElementType::ElementType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcElementType::setElementType(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[354]); }
const IfcParse::entity& Ifc4::IfcElementType::Class() { return *((IfcParse::entity*)IFC4_types[354]); }
Ifc4::IfcElementType::IfcElementType(IfcEntityInstanceData&& e) : IfcTypeProduct(std::move(e)) { }
Ifc4::IfcElementType::IfcElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcTypeProduct(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcElementarySurface
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcElementarySurface::Position() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcElementarySurface::setPosition(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcElementarySurface::declaration() const { return *((IfcParse::entity*)IFC4_types[346]); }
const IfcParse::entity& Ifc4::IfcElementarySurface::Class() { return *((IfcParse::entity*)IFC4_types[346]); }
Ifc4::IfcElementarySurface::IfcElementarySurface(IfcEntityInstanceData&& e) : IfcSurface(std::move(e)) { }
Ifc4::IfcElementarySurface::IfcElementarySurface(::Ifc4::IfcAxis2Placement3D* v1_Position) : IfcSurface(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcEllipse
double Ifc4::IfcEllipse::SemiAxis1() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcEllipse::setSemiAxis1(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcEllipse::SemiAxis2() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcEllipse::setSemiAxis2(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcEllipse::declaration() const { return *((IfcParse::entity*)IFC4_types[355]); }
const IfcParse::entity& Ifc4::IfcEllipse::Class() { return *((IfcParse::entity*)IFC4_types[355]); }
Ifc4::IfcEllipse::IfcEllipse(IfcEntityInstanceData&& e) : IfcConic(std::move(e)) { }
Ifc4::IfcEllipse::IfcEllipse(::Ifc4::IfcAxis2Placement* v1_Position, double v2_SemiAxis1, double v3_SemiAxis2) : IfcConic(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_SemiAxis1));set_attribute_value(2, (v3_SemiAxis2));; populate_derived(); }

// Function implementations for IfcEllipseProfileDef
double Ifc4::IfcEllipseProfileDef::SemiAxis1() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcEllipseProfileDef::setSemiAxis1(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcEllipseProfileDef::SemiAxis2() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcEllipseProfileDef::setSemiAxis2(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcEllipseProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[356]); }
const IfcParse::entity& Ifc4::IfcEllipseProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[356]); }
Ifc4::IfcEllipseProfileDef::IfcEllipseProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcEllipseProfileDef::IfcEllipseProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_SemiAxis1, double v5_SemiAxis2) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_SemiAxis1));set_attribute_value(4, (v5_SemiAxis2));; populate_derived(); }

// Function implementations for IfcEnergyConversionDevice


const IfcParse::entity& Ifc4::IfcEnergyConversionDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[357]); }
const IfcParse::entity& Ifc4::IfcEnergyConversionDevice::Class() { return *((IfcParse::entity*)IFC4_types[357]); }
Ifc4::IfcEnergyConversionDevice::IfcEnergyConversionDevice(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcEnergyConversionDevice::IfcEnergyConversionDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcEnergyConversionDeviceType


const IfcParse::entity& Ifc4::IfcEnergyConversionDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[358]); }
const IfcParse::entity& Ifc4::IfcEnergyConversionDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[358]); }
Ifc4::IfcEnergyConversionDeviceType::IfcEnergyConversionDeviceType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcEnergyConversionDeviceType::IfcEnergyConversionDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcEngine
boost::optional< ::Ifc4::IfcEngineTypeEnum::Value > Ifc4::IfcEngine::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcEngineTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcEngine::setPredefinedType(boost::optional< ::Ifc4::IfcEngineTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcEngineTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcEngine::declaration() const { return *((IfcParse::entity*)IFC4_types[360]); }
const IfcParse::entity& Ifc4::IfcEngine::Class() { return *((IfcParse::entity*)IFC4_types[360]); }
Ifc4::IfcEngine::IfcEngine(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcEngine::IfcEngine(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcEngineTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcEngineTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcEngineType
::Ifc4::IfcEngineTypeEnum::Value Ifc4::IfcEngineType::PredefinedType() const {  return ::Ifc4::IfcEngineTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcEngineType::setPredefinedType(::Ifc4::IfcEngineTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcEngineTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcEngineType::declaration() const { return *((IfcParse::entity*)IFC4_types[361]); }
const IfcParse::entity& Ifc4::IfcEngineType::Class() { return *((IfcParse::entity*)IFC4_types[361]); }
Ifc4::IfcEngineType::IfcEngineType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcEngineType::IfcEngineType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcEngineTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcEngineTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcEvaporativeCooler
boost::optional< ::Ifc4::IfcEvaporativeCoolerTypeEnum::Value > Ifc4::IfcEvaporativeCooler::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcEvaporativeCoolerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcEvaporativeCooler::setPredefinedType(boost::optional< ::Ifc4::IfcEvaporativeCoolerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcEvaporativeCoolerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcEvaporativeCooler::declaration() const { return *((IfcParse::entity*)IFC4_types[363]); }
const IfcParse::entity& Ifc4::IfcEvaporativeCooler::Class() { return *((IfcParse::entity*)IFC4_types[363]); }
Ifc4::IfcEvaporativeCooler::IfcEvaporativeCooler(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcEvaporativeCooler::IfcEvaporativeCooler(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcEvaporativeCoolerTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcEvaporativeCoolerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcEvaporativeCoolerType
::Ifc4::IfcEvaporativeCoolerTypeEnum::Value Ifc4::IfcEvaporativeCoolerType::PredefinedType() const {  return ::Ifc4::IfcEvaporativeCoolerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcEvaporativeCoolerType::setPredefinedType(::Ifc4::IfcEvaporativeCoolerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcEvaporativeCoolerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcEvaporativeCoolerType::declaration() const { return *((IfcParse::entity*)IFC4_types[364]); }
const IfcParse::entity& Ifc4::IfcEvaporativeCoolerType::Class() { return *((IfcParse::entity*)IFC4_types[364]); }
Ifc4::IfcEvaporativeCoolerType::IfcEvaporativeCoolerType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcEvaporativeCoolerType::IfcEvaporativeCoolerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcEvaporativeCoolerTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcEvaporativeCoolerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcEvaporator
boost::optional< ::Ifc4::IfcEvaporatorTypeEnum::Value > Ifc4::IfcEvaporator::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcEvaporatorTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcEvaporator::setPredefinedType(boost::optional< ::Ifc4::IfcEvaporatorTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcEvaporatorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcEvaporator::declaration() const { return *((IfcParse::entity*)IFC4_types[366]); }
const IfcParse::entity& Ifc4::IfcEvaporator::Class() { return *((IfcParse::entity*)IFC4_types[366]); }
Ifc4::IfcEvaporator::IfcEvaporator(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcEvaporator::IfcEvaporator(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcEvaporatorTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcEvaporatorTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcEvaporatorType
::Ifc4::IfcEvaporatorTypeEnum::Value Ifc4::IfcEvaporatorType::PredefinedType() const {  return ::Ifc4::IfcEvaporatorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcEvaporatorType::setPredefinedType(::Ifc4::IfcEvaporatorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcEvaporatorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcEvaporatorType::declaration() const { return *((IfcParse::entity*)IFC4_types[367]); }
const IfcParse::entity& Ifc4::IfcEvaporatorType::Class() { return *((IfcParse::entity*)IFC4_types[367]); }
Ifc4::IfcEvaporatorType::IfcEvaporatorType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcEvaporatorType::IfcEvaporatorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcEvaporatorTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcEvaporatorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcEvent
boost::optional< ::Ifc4::IfcEventTypeEnum::Value > Ifc4::IfcEvent::PredefinedType() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } return ::Ifc4::IfcEventTypeEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcEvent::setPredefinedType(boost::optional< ::Ifc4::IfcEventTypeEnum::Value > v) { if (v) {set_attribute_value(7, EnumerationReference(&::Ifc4::IfcEventTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(7);} }
boost::optional< ::Ifc4::IfcEventTriggerTypeEnum::Value > Ifc4::IfcEvent::EventTriggerType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcEventTriggerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcEvent::setEventTriggerType(boost::optional< ::Ifc4::IfcEventTriggerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcEventTriggerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }
boost::optional< std::string > Ifc4::IfcEvent::UserDefinedEventTriggerType() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcEvent::setUserDefinedEventTriggerType(boost::optional< std::string > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
::Ifc4::IfcEventTime* Ifc4::IfcEvent::EventOccurenceTime() const { if(data_.get_attribute_value(10).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(10)))->as<::Ifc4::IfcEventTime>(true); }
void Ifc4::IfcEvent::setEventOccurenceTime(::Ifc4::IfcEventTime* v) { set_attribute_value(10, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(10); }


const IfcParse::entity& Ifc4::IfcEvent::declaration() const { return *((IfcParse::entity*)IFC4_types[369]); }
const IfcParse::entity& Ifc4::IfcEvent::Class() { return *((IfcParse::entity*)IFC4_types[369]); }
Ifc4::IfcEvent::IfcEvent(IfcEntityInstanceData&& e) : IfcProcess(std::move(e)) { }
Ifc4::IfcEvent::IfcEvent(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, boost::optional< ::Ifc4::IfcEventTypeEnum::Value > v8_PredefinedType, boost::optional< ::Ifc4::IfcEventTriggerTypeEnum::Value > v9_EventTriggerType, boost::optional< std::string > v10_UserDefinedEventTriggerType, ::Ifc4::IfcEventTime* v11_EventOccurenceTime) : IfcProcess(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); } if (v8_PredefinedType) {set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcEventTypeEnum::Class(),(size_t)*v8_PredefinedType))); } if (v9_EventTriggerType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcEventTriggerTypeEnum::Class(),(size_t)*v9_EventTriggerType))); } if (v10_UserDefinedEventTriggerType) {set_attribute_value(9, (*v10_UserDefinedEventTriggerType)); }set_attribute_value(10, v11_EventOccurenceTime ? v11_EventOccurenceTime->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcEventTime
boost::optional< std::string > Ifc4::IfcEventTime::ActualDate() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcEventTime::setActualDate(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcEventTime::EarlyDate() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcEventTime::setEarlyDate(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcEventTime::LateDate() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcEventTime::setLateDate(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcEventTime::ScheduleDate() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcEventTime::setScheduleDate(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcEventTime::declaration() const { return *((IfcParse::entity*)IFC4_types[370]); }
const IfcParse::entity& Ifc4::IfcEventTime::Class() { return *((IfcParse::entity*)IFC4_types[370]); }
Ifc4::IfcEventTime::IfcEventTime(IfcEntityInstanceData&& e) : IfcSchedulingTime(std::move(e)) { }
Ifc4::IfcEventTime::IfcEventTime(boost::optional< std::string > v1_Name, boost::optional< ::Ifc4::IfcDataOriginEnum::Value > v2_DataOrigin, boost::optional< std::string > v3_UserDefinedDataOrigin, boost::optional< std::string > v4_ActualDate, boost::optional< std::string > v5_EarlyDate, boost::optional< std::string > v6_LateDate, boost::optional< std::string > v7_ScheduleDate) : IfcSchedulingTime(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DataOrigin) {set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)*v2_DataOrigin))); } if (v3_UserDefinedDataOrigin) {set_attribute_value(2, (*v3_UserDefinedDataOrigin)); } if (v4_ActualDate) {set_attribute_value(3, (*v4_ActualDate)); } if (v5_EarlyDate) {set_attribute_value(4, (*v5_EarlyDate)); } if (v6_LateDate) {set_attribute_value(5, (*v6_LateDate)); } if (v7_ScheduleDate) {set_attribute_value(6, (*v7_ScheduleDate)); }; populate_derived(); }

// Function implementations for IfcEventType
::Ifc4::IfcEventTypeEnum::Value Ifc4::IfcEventType::PredefinedType() const {  return ::Ifc4::IfcEventTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcEventType::setPredefinedType(::Ifc4::IfcEventTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcEventTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
::Ifc4::IfcEventTriggerTypeEnum::Value Ifc4::IfcEventType::EventTriggerType() const {  return ::Ifc4::IfcEventTriggerTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcEventType::setEventTriggerType(::Ifc4::IfcEventTriggerTypeEnum::Value v) { set_attribute_value(10, EnumerationReference(&::Ifc4::IfcEventTriggerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(10); }
boost::optional< std::string > Ifc4::IfcEventType::UserDefinedEventTriggerType() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcEventType::setUserDefinedEventTriggerType(boost::optional< std::string > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }


const IfcParse::entity& Ifc4::IfcEventType::declaration() const { return *((IfcParse::entity*)IFC4_types[372]); }
const IfcParse::entity& Ifc4::IfcEventType::Class() { return *((IfcParse::entity*)IFC4_types[372]); }
Ifc4::IfcEventType::IfcEventType(IfcEntityInstanceData&& e) : IfcTypeProcess(std::move(e)) { }
Ifc4::IfcEventType::IfcEventType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ProcessType, ::Ifc4::IfcEventTypeEnum::Value v10_PredefinedType, ::Ifc4::IfcEventTriggerTypeEnum::Value v11_EventTriggerType, boost::optional< std::string > v12_UserDefinedEventTriggerType) : IfcTypeProcess(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ProcessType) {set_attribute_value(8, (*v9_ProcessType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcEventTypeEnum::Class(),(size_t)v10_PredefinedType)));set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcEventTriggerTypeEnum::Class(),(size_t)v11_EventTriggerType))); if (v12_UserDefinedEventTriggerType) {set_attribute_value(11, (*v12_UserDefinedEventTriggerType)); }; populate_derived(); }

// Function implementations for IfcExtendedProperties
boost::optional< std::string > Ifc4::IfcExtendedProperties::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcExtendedProperties::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcExtendedProperties::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcExtendedProperties::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
aggregate_of< ::Ifc4::IfcProperty >::ptr Ifc4::IfcExtendedProperties::Properties() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcProperty >(); }
void Ifc4::IfcExtendedProperties::setProperties(aggregate_of< ::Ifc4::IfcProperty >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcExtendedProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[374]); }
const IfcParse::entity& Ifc4::IfcExtendedProperties::Class() { return *((IfcParse::entity*)IFC4_types[374]); }
Ifc4::IfcExtendedProperties::IfcExtendedProperties(IfcEntityInstanceData&& e) : IfcPropertyAbstraction(std::move(e)) { }
Ifc4::IfcExtendedProperties::IfcExtendedProperties(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcProperty >::ptr v3_Properties) : IfcPropertyAbstraction(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_Properties)->generalize());; populate_derived(); }

// Function implementations for IfcExternalInformation


const IfcParse::entity& Ifc4::IfcExternalInformation::declaration() const { return *((IfcParse::entity*)IFC4_types[375]); }
const IfcParse::entity& Ifc4::IfcExternalInformation::Class() { return *((IfcParse::entity*)IFC4_types[375]); }
Ifc4::IfcExternalInformation::IfcExternalInformation(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcExternalInformation::IfcExternalInformation() : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcExternalReference
boost::optional< std::string > Ifc4::IfcExternalReference::Location() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcExternalReference::setLocation(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcExternalReference::Identification() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcExternalReference::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcExternalReference::Name() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcExternalReference::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcExternalReference::ExternalReferenceForResources() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 2)->as<IfcExternalReferenceRelationship>(); }

const IfcParse::entity& Ifc4::IfcExternalReference::declaration() const { return *((IfcParse::entity*)IFC4_types[379]); }
const IfcParse::entity& Ifc4::IfcExternalReference::Class() { return *((IfcParse::entity*)IFC4_types[379]); }
Ifc4::IfcExternalReference::IfcExternalReference(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcExternalReference::IfcExternalReference(boost::optional< std::string > v1_Location, boost::optional< std::string > v2_Identification, boost::optional< std::string > v3_Name) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) {  if (v1_Location) {set_attribute_value(0, (*v1_Location)); } if (v2_Identification) {set_attribute_value(1, (*v2_Identification)); } if (v3_Name) {set_attribute_value(2, (*v3_Name)); }; populate_derived(); }

// Function implementations for IfcExternalReferenceRelationship
::Ifc4::IfcExternalReference* Ifc4::IfcExternalReferenceRelationship::RelatingReference() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcExternalReference>(true); }
void Ifc4::IfcExternalReferenceRelationship::setRelatingReference(::Ifc4::IfcExternalReference* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr Ifc4::IfcExternalReferenceRelationship::RelatedResourceObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcResourceObjectSelect >(); }
void Ifc4::IfcExternalReferenceRelationship::setRelatedResourceObjects(aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcExternalReferenceRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[380]); }
const IfcParse::entity& Ifc4::IfcExternalReferenceRelationship::Class() { return *((IfcParse::entity*)IFC4_types[380]); }
Ifc4::IfcExternalReferenceRelationship::IfcExternalReferenceRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcExternalReferenceRelationship::IfcExternalReferenceRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcExternalReference* v3_RelatingReference, aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr v4_RelatedResourceObjects) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_RelatingReference ? v3_RelatingReference->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_RelatedResourceObjects)->generalize());; populate_derived(); }

// Function implementations for IfcExternalSpatialElement
boost::optional< ::Ifc4::IfcExternalSpatialElementTypeEnum::Value > Ifc4::IfcExternalSpatialElement::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcExternalSpatialElementTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcExternalSpatialElement::setPredefinedType(boost::optional< ::Ifc4::IfcExternalSpatialElementTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcExternalSpatialElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }

::Ifc4::IfcRelSpaceBoundary::list::ptr Ifc4::IfcExternalSpatialElement::BoundedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[841], 4)->as<IfcRelSpaceBoundary>(); }

const IfcParse::entity& Ifc4::IfcExternalSpatialElement::declaration() const { return *((IfcParse::entity*)IFC4_types[381]); }
const IfcParse::entity& Ifc4::IfcExternalSpatialElement::Class() { return *((IfcParse::entity*)IFC4_types[381]); }
Ifc4::IfcExternalSpatialElement::IfcExternalSpatialElement(IfcEntityInstanceData&& e) : IfcExternalSpatialStructureElement(std::move(e)) { }
Ifc4::IfcExternalSpatialElement::IfcExternalSpatialElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName, boost::optional< ::Ifc4::IfcExternalSpatialElementTypeEnum::Value > v9_PredefinedType) : IfcExternalSpatialStructureElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcExternalSpatialElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcExternalSpatialStructureElement


const IfcParse::entity& Ifc4::IfcExternalSpatialStructureElement::declaration() const { return *((IfcParse::entity*)IFC4_types[383]); }
const IfcParse::entity& Ifc4::IfcExternalSpatialStructureElement::Class() { return *((IfcParse::entity*)IFC4_types[383]); }
Ifc4::IfcExternalSpatialStructureElement::IfcExternalSpatialStructureElement(IfcEntityInstanceData&& e) : IfcSpatialElement(std::move(e)) { }
Ifc4::IfcExternalSpatialStructureElement::IfcExternalSpatialStructureElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName) : IfcSpatialElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); }; populate_derived(); }

// Function implementations for IfcExternallyDefinedHatchStyle


const IfcParse::entity& Ifc4::IfcExternallyDefinedHatchStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[376]); }
const IfcParse::entity& Ifc4::IfcExternallyDefinedHatchStyle::Class() { return *((IfcParse::entity*)IFC4_types[376]); }
Ifc4::IfcExternallyDefinedHatchStyle::IfcExternallyDefinedHatchStyle(IfcEntityInstanceData&& e) : IfcExternalReference(std::move(e)) { }
Ifc4::IfcExternallyDefinedHatchStyle::IfcExternallyDefinedHatchStyle(boost::optional< std::string > v1_Location, boost::optional< std::string > v2_Identification, boost::optional< std::string > v3_Name) : IfcExternalReference(IfcEntityInstanceData(storage_t(3))) {  if (v1_Location) {set_attribute_value(0, (*v1_Location)); } if (v2_Identification) {set_attribute_value(1, (*v2_Identification)); } if (v3_Name) {set_attribute_value(2, (*v3_Name)); }; populate_derived(); }

// Function implementations for IfcExternallyDefinedSurfaceStyle


const IfcParse::entity& Ifc4::IfcExternallyDefinedSurfaceStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[377]); }
const IfcParse::entity& Ifc4::IfcExternallyDefinedSurfaceStyle::Class() { return *((IfcParse::entity*)IFC4_types[377]); }
Ifc4::IfcExternallyDefinedSurfaceStyle::IfcExternallyDefinedSurfaceStyle(IfcEntityInstanceData&& e) : IfcExternalReference(std::move(e)) { }
Ifc4::IfcExternallyDefinedSurfaceStyle::IfcExternallyDefinedSurfaceStyle(boost::optional< std::string > v1_Location, boost::optional< std::string > v2_Identification, boost::optional< std::string > v3_Name) : IfcExternalReference(IfcEntityInstanceData(storage_t(3))) {  if (v1_Location) {set_attribute_value(0, (*v1_Location)); } if (v2_Identification) {set_attribute_value(1, (*v2_Identification)); } if (v3_Name) {set_attribute_value(2, (*v3_Name)); }; populate_derived(); }

// Function implementations for IfcExternallyDefinedTextFont


const IfcParse::entity& Ifc4::IfcExternallyDefinedTextFont::declaration() const { return *((IfcParse::entity*)IFC4_types[378]); }
const IfcParse::entity& Ifc4::IfcExternallyDefinedTextFont::Class() { return *((IfcParse::entity*)IFC4_types[378]); }
Ifc4::IfcExternallyDefinedTextFont::IfcExternallyDefinedTextFont(IfcEntityInstanceData&& e) : IfcExternalReference(std::move(e)) { }
Ifc4::IfcExternallyDefinedTextFont::IfcExternallyDefinedTextFont(boost::optional< std::string > v1_Location, boost::optional< std::string > v2_Identification, boost::optional< std::string > v3_Name) : IfcExternalReference(IfcEntityInstanceData(storage_t(3))) {  if (v1_Location) {set_attribute_value(0, (*v1_Location)); } if (v2_Identification) {set_attribute_value(1, (*v2_Identification)); } if (v3_Name) {set_attribute_value(2, (*v3_Name)); }; populate_derived(); }

// Function implementations for IfcExtrudedAreaSolid
::Ifc4::IfcDirection* Ifc4::IfcExtrudedAreaSolid::ExtrudedDirection() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcExtrudedAreaSolid::setExtrudedDirection(::Ifc4::IfcDirection* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcExtrudedAreaSolid::Depth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcExtrudedAreaSolid::setDepth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcExtrudedAreaSolid::declaration() const { return *((IfcParse::entity*)IFC4_types[384]); }
const IfcParse::entity& Ifc4::IfcExtrudedAreaSolid::Class() { return *((IfcParse::entity*)IFC4_types[384]); }
Ifc4::IfcExtrudedAreaSolid::IfcExtrudedAreaSolid(IfcEntityInstanceData&& e) : IfcSweptAreaSolid(std::move(e)) { }
Ifc4::IfcExtrudedAreaSolid::IfcExtrudedAreaSolid(::Ifc4::IfcProfileDef* v1_SweptArea, ::Ifc4::IfcAxis2Placement3D* v2_Position, ::Ifc4::IfcDirection* v3_ExtrudedDirection, double v4_Depth) : IfcSweptAreaSolid(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_SweptArea ? v1_SweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_ExtrudedDirection ? v3_ExtrudedDirection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Depth));; populate_derived(); }

// Function implementations for IfcExtrudedAreaSolidTapered
::Ifc4::IfcProfileDef* Ifc4::IfcExtrudedAreaSolidTapered::EndSweptArea() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcExtrudedAreaSolidTapered::setEndSweptArea(::Ifc4::IfcProfileDef* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcExtrudedAreaSolidTapered::declaration() const { return *((IfcParse::entity*)IFC4_types[385]); }
const IfcParse::entity& Ifc4::IfcExtrudedAreaSolidTapered::Class() { return *((IfcParse::entity*)IFC4_types[385]); }
Ifc4::IfcExtrudedAreaSolidTapered::IfcExtrudedAreaSolidTapered(IfcEntityInstanceData&& e) : IfcExtrudedAreaSolid(std::move(e)) { }
Ifc4::IfcExtrudedAreaSolidTapered::IfcExtrudedAreaSolidTapered(::Ifc4::IfcProfileDef* v1_SweptArea, ::Ifc4::IfcAxis2Placement3D* v2_Position, ::Ifc4::IfcDirection* v3_ExtrudedDirection, double v4_Depth, ::Ifc4::IfcProfileDef* v5_EndSweptArea) : IfcExtrudedAreaSolid(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_SweptArea ? v1_SweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_ExtrudedDirection ? v3_ExtrudedDirection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Depth));set_attribute_value(4, v5_EndSweptArea ? v5_EndSweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcFace
aggregate_of< ::Ifc4::IfcFaceBound >::ptr Ifc4::IfcFace::Bounds() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcFaceBound >(); }
void Ifc4::IfcFace::setBounds(aggregate_of< ::Ifc4::IfcFaceBound >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }

::Ifc4::IfcTextureMap::list::ptr Ifc4::IfcFace::HasTextureMaps() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[1068], 2)->as<IfcTextureMap>(); }

const IfcParse::entity& Ifc4::IfcFace::declaration() const { return *((IfcParse::entity*)IFC4_types[386]); }
const IfcParse::entity& Ifc4::IfcFace::Class() { return *((IfcParse::entity*)IFC4_types[386]); }
Ifc4::IfcFace::IfcFace(IfcEntityInstanceData&& e) : IfcTopologicalRepresentationItem(std::move(e)) { }
Ifc4::IfcFace::IfcFace(aggregate_of< ::Ifc4::IfcFaceBound >::ptr v1_Bounds) : IfcTopologicalRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Bounds)->generalize());; populate_derived(); }

// Function implementations for IfcFaceBasedSurfaceModel
aggregate_of< ::Ifc4::IfcConnectedFaceSet >::ptr Ifc4::IfcFaceBasedSurfaceModel::FbsmFaces() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcConnectedFaceSet >(); }
void Ifc4::IfcFaceBasedSurfaceModel::setFbsmFaces(aggregate_of< ::Ifc4::IfcConnectedFaceSet >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcFaceBasedSurfaceModel::declaration() const { return *((IfcParse::entity*)IFC4_types[387]); }
const IfcParse::entity& Ifc4::IfcFaceBasedSurfaceModel::Class() { return *((IfcParse::entity*)IFC4_types[387]); }
Ifc4::IfcFaceBasedSurfaceModel::IfcFaceBasedSurfaceModel(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcFaceBasedSurfaceModel::IfcFaceBasedSurfaceModel(aggregate_of< ::Ifc4::IfcConnectedFaceSet >::ptr v1_FbsmFaces) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_FbsmFaces)->generalize());; populate_derived(); }

// Function implementations for IfcFaceBound
::Ifc4::IfcLoop* Ifc4::IfcFaceBound::Bound() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcLoop>(true); }
void Ifc4::IfcFaceBound::setBound(::Ifc4::IfcLoop* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
bool Ifc4::IfcFaceBound::Orientation() const {  bool v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcFaceBound::setOrientation(bool v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcFaceBound::declaration() const { return *((IfcParse::entity*)IFC4_types[388]); }
const IfcParse::entity& Ifc4::IfcFaceBound::Class() { return *((IfcParse::entity*)IFC4_types[388]); }
Ifc4::IfcFaceBound::IfcFaceBound(IfcEntityInstanceData&& e) : IfcTopologicalRepresentationItem(std::move(e)) { }
Ifc4::IfcFaceBound::IfcFaceBound(::Ifc4::IfcLoop* v1_Bound, bool v2_Orientation) : IfcTopologicalRepresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Bound ? v1_Bound->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Orientation));; populate_derived(); }

// Function implementations for IfcFaceOuterBound


const IfcParse::entity& Ifc4::IfcFaceOuterBound::declaration() const { return *((IfcParse::entity*)IFC4_types[389]); }
const IfcParse::entity& Ifc4::IfcFaceOuterBound::Class() { return *((IfcParse::entity*)IFC4_types[389]); }
Ifc4::IfcFaceOuterBound::IfcFaceOuterBound(IfcEntityInstanceData&& e) : IfcFaceBound(std::move(e)) { }
Ifc4::IfcFaceOuterBound::IfcFaceOuterBound(::Ifc4::IfcLoop* v1_Bound, bool v2_Orientation) : IfcFaceBound(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Bound ? v1_Bound->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Orientation));; populate_derived(); }

// Function implementations for IfcFaceSurface
::Ifc4::IfcSurface* Ifc4::IfcFaceSurface::FaceSurface() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcSurface>(true); }
void Ifc4::IfcFaceSurface::setFaceSurface(::Ifc4::IfcSurface* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
bool Ifc4::IfcFaceSurface::SameSense() const {  bool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcFaceSurface::setSameSense(bool v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcFaceSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[390]); }
const IfcParse::entity& Ifc4::IfcFaceSurface::Class() { return *((IfcParse::entity*)IFC4_types[390]); }
Ifc4::IfcFaceSurface::IfcFaceSurface(IfcEntityInstanceData&& e) : IfcFace(std::move(e)) { }
Ifc4::IfcFaceSurface::IfcFaceSurface(aggregate_of< ::Ifc4::IfcFaceBound >::ptr v1_Bounds, ::Ifc4::IfcSurface* v2_FaceSurface, bool v3_SameSense) : IfcFace(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Bounds)->generalize());set_attribute_value(1, v2_FaceSurface ? v2_FaceSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, (v3_SameSense));; populate_derived(); }

// Function implementations for IfcFacetedBrep


const IfcParse::entity& Ifc4::IfcFacetedBrep::declaration() const { return *((IfcParse::entity*)IFC4_types[391]); }
const IfcParse::entity& Ifc4::IfcFacetedBrep::Class() { return *((IfcParse::entity*)IFC4_types[391]); }
Ifc4::IfcFacetedBrep::IfcFacetedBrep(IfcEntityInstanceData&& e) : IfcManifoldSolidBrep(std::move(e)) { }
Ifc4::IfcFacetedBrep::IfcFacetedBrep(::Ifc4::IfcClosedShell* v1_Outer) : IfcManifoldSolidBrep(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Outer ? v1_Outer->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcFacetedBrepWithVoids
aggregate_of< ::Ifc4::IfcClosedShell >::ptr Ifc4::IfcFacetedBrepWithVoids::Voids() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcClosedShell >(); }
void Ifc4::IfcFacetedBrepWithVoids::setVoids(aggregate_of< ::Ifc4::IfcClosedShell >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcFacetedBrepWithVoids::declaration() const { return *((IfcParse::entity*)IFC4_types[392]); }
const IfcParse::entity& Ifc4::IfcFacetedBrepWithVoids::Class() { return *((IfcParse::entity*)IFC4_types[392]); }
Ifc4::IfcFacetedBrepWithVoids::IfcFacetedBrepWithVoids(IfcEntityInstanceData&& e) : IfcFacetedBrep(std::move(e)) { }
Ifc4::IfcFacetedBrepWithVoids::IfcFacetedBrepWithVoids(::Ifc4::IfcClosedShell* v1_Outer, aggregate_of< ::Ifc4::IfcClosedShell >::ptr v2_Voids) : IfcFacetedBrep(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Outer ? v1_Outer->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Voids)->generalize());; populate_derived(); }

// Function implementations for IfcFailureConnectionCondition
boost::optional< double > Ifc4::IfcFailureConnectionCondition::TensionFailureX() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcFailureConnectionCondition::setTensionFailureX(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< double > Ifc4::IfcFailureConnectionCondition::TensionFailureY() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcFailureConnectionCondition::setTensionFailureY(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcFailureConnectionCondition::TensionFailureZ() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcFailureConnectionCondition::setTensionFailureZ(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcFailureConnectionCondition::CompressionFailureX() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcFailureConnectionCondition::setCompressionFailureX(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< double > Ifc4::IfcFailureConnectionCondition::CompressionFailureY() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcFailureConnectionCondition::setCompressionFailureY(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< double > Ifc4::IfcFailureConnectionCondition::CompressionFailureZ() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcFailureConnectionCondition::setCompressionFailureZ(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcFailureConnectionCondition::declaration() const { return *((IfcParse::entity*)IFC4_types[393]); }
const IfcParse::entity& Ifc4::IfcFailureConnectionCondition::Class() { return *((IfcParse::entity*)IFC4_types[393]); }
Ifc4::IfcFailureConnectionCondition::IfcFailureConnectionCondition(IfcEntityInstanceData&& e) : IfcStructuralConnectionCondition(std::move(e)) { }
Ifc4::IfcFailureConnectionCondition::IfcFailureConnectionCondition(boost::optional< std::string > v1_Name, boost::optional< double > v2_TensionFailureX, boost::optional< double > v3_TensionFailureY, boost::optional< double > v4_TensionFailureZ, boost::optional< double > v5_CompressionFailureX, boost::optional< double > v6_CompressionFailureY, boost::optional< double > v7_CompressionFailureZ) : IfcStructuralConnectionCondition(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_TensionFailureX) {set_attribute_value(1, (*v2_TensionFailureX)); } if (v3_TensionFailureY) {set_attribute_value(2, (*v3_TensionFailureY)); } if (v4_TensionFailureZ) {set_attribute_value(3, (*v4_TensionFailureZ)); } if (v5_CompressionFailureX) {set_attribute_value(4, (*v5_CompressionFailureX)); } if (v6_CompressionFailureY) {set_attribute_value(5, (*v6_CompressionFailureY)); } if (v7_CompressionFailureZ) {set_attribute_value(6, (*v7_CompressionFailureZ)); }; populate_derived(); }

// Function implementations for IfcFan
boost::optional< ::Ifc4::IfcFanTypeEnum::Value > Ifc4::IfcFan::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcFanTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcFan::setPredefinedType(boost::optional< ::Ifc4::IfcFanTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcFanTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcFan::declaration() const { return *((IfcParse::entity*)IFC4_types[394]); }
const IfcParse::entity& Ifc4::IfcFan::Class() { return *((IfcParse::entity*)IFC4_types[394]); }
Ifc4::IfcFan::IfcFan(IfcEntityInstanceData&& e) : IfcFlowMovingDevice(std::move(e)) { }
Ifc4::IfcFan::IfcFan(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcFanTypeEnum::Value > v9_PredefinedType) : IfcFlowMovingDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcFanTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcFanType
::Ifc4::IfcFanTypeEnum::Value Ifc4::IfcFanType::PredefinedType() const {  return ::Ifc4::IfcFanTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcFanType::setPredefinedType(::Ifc4::IfcFanTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcFanTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcFanType::declaration() const { return *((IfcParse::entity*)IFC4_types[395]); }
const IfcParse::entity& Ifc4::IfcFanType::Class() { return *((IfcParse::entity*)IFC4_types[395]); }
Ifc4::IfcFanType::IfcFanType(IfcEntityInstanceData&& e) : IfcFlowMovingDeviceType(std::move(e)) { }
Ifc4::IfcFanType::IfcFanType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcFanTypeEnum::Value v10_PredefinedType) : IfcFlowMovingDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcFanTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcFastener
boost::optional< ::Ifc4::IfcFastenerTypeEnum::Value > Ifc4::IfcFastener::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcFastenerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcFastener::setPredefinedType(boost::optional< ::Ifc4::IfcFastenerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcFastenerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcFastener::declaration() const { return *((IfcParse::entity*)IFC4_types[397]); }
const IfcParse::entity& Ifc4::IfcFastener::Class() { return *((IfcParse::entity*)IFC4_types[397]); }
Ifc4::IfcFastener::IfcFastener(IfcEntityInstanceData&& e) : IfcElementComponent(std::move(e)) { }
Ifc4::IfcFastener::IfcFastener(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcFastenerTypeEnum::Value > v9_PredefinedType) : IfcElementComponent(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcFastenerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcFastenerType
::Ifc4::IfcFastenerTypeEnum::Value Ifc4::IfcFastenerType::PredefinedType() const {  return ::Ifc4::IfcFastenerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcFastenerType::setPredefinedType(::Ifc4::IfcFastenerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcFastenerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcFastenerType::declaration() const { return *((IfcParse::entity*)IFC4_types[398]); }
const IfcParse::entity& Ifc4::IfcFastenerType::Class() { return *((IfcParse::entity*)IFC4_types[398]); }
Ifc4::IfcFastenerType::IfcFastenerType(IfcEntityInstanceData&& e) : IfcElementComponentType(std::move(e)) { }
Ifc4::IfcFastenerType::IfcFastenerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcFastenerTypeEnum::Value v10_PredefinedType) : IfcElementComponentType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcFastenerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcFeatureElement


const IfcParse::entity& Ifc4::IfcFeatureElement::declaration() const { return *((IfcParse::entity*)IFC4_types[400]); }
const IfcParse::entity& Ifc4::IfcFeatureElement::Class() { return *((IfcParse::entity*)IFC4_types[400]); }
Ifc4::IfcFeatureElement::IfcFeatureElement(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcFeatureElement::IfcFeatureElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFeatureElementAddition

::Ifc4::IfcRelProjectsElement::list::ptr Ifc4::IfcFeatureElementAddition::ProjectsElements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[837], 5)->as<IfcRelProjectsElement>(); }

const IfcParse::entity& Ifc4::IfcFeatureElementAddition::declaration() const { return *((IfcParse::entity*)IFC4_types[401]); }
const IfcParse::entity& Ifc4::IfcFeatureElementAddition::Class() { return *((IfcParse::entity*)IFC4_types[401]); }
Ifc4::IfcFeatureElementAddition::IfcFeatureElementAddition(IfcEntityInstanceData&& e) : IfcFeatureElement(std::move(e)) { }
Ifc4::IfcFeatureElementAddition::IfcFeatureElementAddition(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcFeatureElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFeatureElementSubtraction

::Ifc4::IfcRelVoidsElement::list::ptr Ifc4::IfcFeatureElementSubtraction::VoidsElements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[844], 5)->as<IfcRelVoidsElement>(); }

const IfcParse::entity& Ifc4::IfcFeatureElementSubtraction::declaration() const { return *((IfcParse::entity*)IFC4_types[402]); }
const IfcParse::entity& Ifc4::IfcFeatureElementSubtraction::Class() { return *((IfcParse::entity*)IFC4_types[402]); }
Ifc4::IfcFeatureElementSubtraction::IfcFeatureElementSubtraction(IfcEntityInstanceData&& e) : IfcFeatureElement(std::move(e)) { }
Ifc4::IfcFeatureElementSubtraction::IfcFeatureElementSubtraction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcFeatureElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFillAreaStyle
aggregate_of< ::Ifc4::IfcFillStyleSelect >::ptr Ifc4::IfcFillAreaStyle::FillStyles() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcFillStyleSelect >(); }
void Ifc4::IfcFillAreaStyle::setFillStyles(aggregate_of< ::Ifc4::IfcFillStyleSelect >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
boost::optional< bool > Ifc4::IfcFillAreaStyle::ModelorDraughting() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } bool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcFillAreaStyle::setModelorDraughting(boost::optional< bool > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcFillAreaStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[403]); }
const IfcParse::entity& Ifc4::IfcFillAreaStyle::Class() { return *((IfcParse::entity*)IFC4_types[403]); }
Ifc4::IfcFillAreaStyle::IfcFillAreaStyle(IfcEntityInstanceData&& e) : IfcPresentationStyle(std::move(e)) { }
Ifc4::IfcFillAreaStyle::IfcFillAreaStyle(boost::optional< std::string > v1_Name, aggregate_of< ::Ifc4::IfcFillStyleSelect >::ptr v2_FillStyles, boost::optional< bool > v3_ModelorDraughting) : IfcPresentationStyle(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, (v2_FillStyles)->generalize()); if (v3_ModelorDraughting) {set_attribute_value(2, (*v3_ModelorDraughting)); }; populate_derived(); }

// Function implementations for IfcFillAreaStyleHatching
::Ifc4::IfcCurveStyle* Ifc4::IfcFillAreaStyleHatching::HatchLineAppearance() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurveStyle>(true); }
void Ifc4::IfcFillAreaStyleHatching::setHatchLineAppearance(::Ifc4::IfcCurveStyle* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcHatchLineDistanceSelect* Ifc4::IfcFillAreaStyleHatching::StartOfNextHatchLine() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcHatchLineDistanceSelect>(true); }
void Ifc4::IfcFillAreaStyleHatching::setStartOfNextHatchLine(::Ifc4::IfcHatchLineDistanceSelect* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcCartesianPoint* Ifc4::IfcFillAreaStyleHatching::PointOfReferenceHatchLine() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcCartesianPoint>(true); }
void Ifc4::IfcFillAreaStyleHatching::setPointOfReferenceHatchLine(::Ifc4::IfcCartesianPoint* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcCartesianPoint* Ifc4::IfcFillAreaStyleHatching::PatternStart() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcCartesianPoint>(true); }
void Ifc4::IfcFillAreaStyleHatching::setPatternStart(::Ifc4::IfcCartesianPoint* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcFillAreaStyleHatching::HatchLineAngle() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcFillAreaStyleHatching::setHatchLineAngle(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcFillAreaStyleHatching::declaration() const { return *((IfcParse::entity*)IFC4_types[404]); }
const IfcParse::entity& Ifc4::IfcFillAreaStyleHatching::Class() { return *((IfcParse::entity*)IFC4_types[404]); }
Ifc4::IfcFillAreaStyleHatching::IfcFillAreaStyleHatching(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcFillAreaStyleHatching::IfcFillAreaStyleHatching(::Ifc4::IfcCurveStyle* v1_HatchLineAppearance, ::Ifc4::IfcHatchLineDistanceSelect* v2_StartOfNextHatchLine, ::Ifc4::IfcCartesianPoint* v3_PointOfReferenceHatchLine, ::Ifc4::IfcCartesianPoint* v4_PatternStart, double v5_HatchLineAngle) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_HatchLineAppearance ? v1_HatchLineAppearance->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_StartOfNextHatchLine ? v2_StartOfNextHatchLine->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_PointOfReferenceHatchLine ? v3_PointOfReferenceHatchLine->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_PatternStart ? v4_PatternStart->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, (v5_HatchLineAngle));; populate_derived(); }

// Function implementations for IfcFillAreaStyleTiles
aggregate_of< ::Ifc4::IfcVector >::ptr Ifc4::IfcFillAreaStyleTiles::TilingPattern() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcVector >(); }
void Ifc4::IfcFillAreaStyleTiles::setTilingPattern(aggregate_of< ::Ifc4::IfcVector >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcStyledItem >::ptr Ifc4::IfcFillAreaStyleTiles::Tiles() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcStyledItem >(); }
void Ifc4::IfcFillAreaStyleTiles::setTiles(aggregate_of< ::Ifc4::IfcStyledItem >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcFillAreaStyleTiles::TilingScale() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcFillAreaStyleTiles::setTilingScale(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcFillAreaStyleTiles::declaration() const { return *((IfcParse::entity*)IFC4_types[405]); }
const IfcParse::entity& Ifc4::IfcFillAreaStyleTiles::Class() { return *((IfcParse::entity*)IFC4_types[405]); }
Ifc4::IfcFillAreaStyleTiles::IfcFillAreaStyleTiles(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcFillAreaStyleTiles::IfcFillAreaStyleTiles(aggregate_of< ::Ifc4::IfcVector >::ptr v1_TilingPattern, aggregate_of< ::Ifc4::IfcStyledItem >::ptr v2_Tiles, double v3_TilingScale) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_TilingPattern)->generalize());set_attribute_value(1, (v2_Tiles)->generalize());set_attribute_value(2, (v3_TilingScale));; populate_derived(); }

// Function implementations for IfcFilter
boost::optional< ::Ifc4::IfcFilterTypeEnum::Value > Ifc4::IfcFilter::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcFilterTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcFilter::setPredefinedType(boost::optional< ::Ifc4::IfcFilterTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcFilterTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcFilter::declaration() const { return *((IfcParse::entity*)IFC4_types[407]); }
const IfcParse::entity& Ifc4::IfcFilter::Class() { return *((IfcParse::entity*)IFC4_types[407]); }
Ifc4::IfcFilter::IfcFilter(IfcEntityInstanceData&& e) : IfcFlowTreatmentDevice(std::move(e)) { }
Ifc4::IfcFilter::IfcFilter(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcFilterTypeEnum::Value > v9_PredefinedType) : IfcFlowTreatmentDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcFilterTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcFilterType
::Ifc4::IfcFilterTypeEnum::Value Ifc4::IfcFilterType::PredefinedType() const {  return ::Ifc4::IfcFilterTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcFilterType::setPredefinedType(::Ifc4::IfcFilterTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcFilterTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcFilterType::declaration() const { return *((IfcParse::entity*)IFC4_types[408]); }
const IfcParse::entity& Ifc4::IfcFilterType::Class() { return *((IfcParse::entity*)IFC4_types[408]); }
Ifc4::IfcFilterType::IfcFilterType(IfcEntityInstanceData&& e) : IfcFlowTreatmentDeviceType(std::move(e)) { }
Ifc4::IfcFilterType::IfcFilterType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcFilterTypeEnum::Value v10_PredefinedType) : IfcFlowTreatmentDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcFilterTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcFireSuppressionTerminal
boost::optional< ::Ifc4::IfcFireSuppressionTerminalTypeEnum::Value > Ifc4::IfcFireSuppressionTerminal::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcFireSuppressionTerminalTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcFireSuppressionTerminal::setPredefinedType(boost::optional< ::Ifc4::IfcFireSuppressionTerminalTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcFireSuppressionTerminalTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcFireSuppressionTerminal::declaration() const { return *((IfcParse::entity*)IFC4_types[410]); }
const IfcParse::entity& Ifc4::IfcFireSuppressionTerminal::Class() { return *((IfcParse::entity*)IFC4_types[410]); }
Ifc4::IfcFireSuppressionTerminal::IfcFireSuppressionTerminal(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcFireSuppressionTerminal::IfcFireSuppressionTerminal(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcFireSuppressionTerminalTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcFireSuppressionTerminalTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcFireSuppressionTerminalType
::Ifc4::IfcFireSuppressionTerminalTypeEnum::Value Ifc4::IfcFireSuppressionTerminalType::PredefinedType() const {  return ::Ifc4::IfcFireSuppressionTerminalTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcFireSuppressionTerminalType::setPredefinedType(::Ifc4::IfcFireSuppressionTerminalTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcFireSuppressionTerminalTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcFireSuppressionTerminalType::declaration() const { return *((IfcParse::entity*)IFC4_types[411]); }
const IfcParse::entity& Ifc4::IfcFireSuppressionTerminalType::Class() { return *((IfcParse::entity*)IFC4_types[411]); }
Ifc4::IfcFireSuppressionTerminalType::IfcFireSuppressionTerminalType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcFireSuppressionTerminalType::IfcFireSuppressionTerminalType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcFireSuppressionTerminalTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcFireSuppressionTerminalTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcFixedReferenceSweptAreaSolid
::Ifc4::IfcCurve* Ifc4::IfcFixedReferenceSweptAreaSolid::Directrix() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcFixedReferenceSweptAreaSolid::setDirectrix(::Ifc4::IfcCurve* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
boost::optional< double > Ifc4::IfcFixedReferenceSweptAreaSolid::StartParam() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcFixedReferenceSweptAreaSolid::setStartParam(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcFixedReferenceSweptAreaSolid::EndParam() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcFixedReferenceSweptAreaSolid::setEndParam(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
::Ifc4::IfcDirection* Ifc4::IfcFixedReferenceSweptAreaSolid::FixedReference() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcFixedReferenceSweptAreaSolid::setFixedReference(::Ifc4::IfcDirection* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcFixedReferenceSweptAreaSolid::declaration() const { return *((IfcParse::entity*)IFC4_types[413]); }
const IfcParse::entity& Ifc4::IfcFixedReferenceSweptAreaSolid::Class() { return *((IfcParse::entity*)IFC4_types[413]); }
Ifc4::IfcFixedReferenceSweptAreaSolid::IfcFixedReferenceSweptAreaSolid(IfcEntityInstanceData&& e) : IfcSweptAreaSolid(std::move(e)) { }
Ifc4::IfcFixedReferenceSweptAreaSolid::IfcFixedReferenceSweptAreaSolid(::Ifc4::IfcProfileDef* v1_SweptArea, ::Ifc4::IfcAxis2Placement3D* v2_Position, ::Ifc4::IfcCurve* v3_Directrix, boost::optional< double > v4_StartParam, boost::optional< double > v5_EndParam, ::Ifc4::IfcDirection* v6_FixedReference) : IfcSweptAreaSolid(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, v1_SweptArea ? v1_SweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_Directrix ? v3_Directrix->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_StartParam) {set_attribute_value(3, (*v4_StartParam)); } if (v5_EndParam) {set_attribute_value(4, (*v5_EndParam)); }set_attribute_value(5, v6_FixedReference ? v6_FixedReference->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcFlowController


const IfcParse::entity& Ifc4::IfcFlowController::declaration() const { return *((IfcParse::entity*)IFC4_types[414]); }
const IfcParse::entity& Ifc4::IfcFlowController::Class() { return *((IfcParse::entity*)IFC4_types[414]); }
Ifc4::IfcFlowController::IfcFlowController(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcFlowController::IfcFlowController(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFlowControllerType


const IfcParse::entity& Ifc4::IfcFlowControllerType::declaration() const { return *((IfcParse::entity*)IFC4_types[415]); }
const IfcParse::entity& Ifc4::IfcFlowControllerType::Class() { return *((IfcParse::entity*)IFC4_types[415]); }
Ifc4::IfcFlowControllerType::IfcFlowControllerType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcFlowControllerType::IfcFlowControllerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcFlowFitting


const IfcParse::entity& Ifc4::IfcFlowFitting::declaration() const { return *((IfcParse::entity*)IFC4_types[417]); }
const IfcParse::entity& Ifc4::IfcFlowFitting::Class() { return *((IfcParse::entity*)IFC4_types[417]); }
Ifc4::IfcFlowFitting::IfcFlowFitting(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcFlowFitting::IfcFlowFitting(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFlowFittingType


const IfcParse::entity& Ifc4::IfcFlowFittingType::declaration() const { return *((IfcParse::entity*)IFC4_types[418]); }
const IfcParse::entity& Ifc4::IfcFlowFittingType::Class() { return *((IfcParse::entity*)IFC4_types[418]); }
Ifc4::IfcFlowFittingType::IfcFlowFittingType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcFlowFittingType::IfcFlowFittingType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcFlowInstrument
boost::optional< ::Ifc4::IfcFlowInstrumentTypeEnum::Value > Ifc4::IfcFlowInstrument::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcFlowInstrumentTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcFlowInstrument::setPredefinedType(boost::optional< ::Ifc4::IfcFlowInstrumentTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcFlowInstrumentTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcFlowInstrument::declaration() const { return *((IfcParse::entity*)IFC4_types[419]); }
const IfcParse::entity& Ifc4::IfcFlowInstrument::Class() { return *((IfcParse::entity*)IFC4_types[419]); }
Ifc4::IfcFlowInstrument::IfcFlowInstrument(IfcEntityInstanceData&& e) : IfcDistributionControlElement(std::move(e)) { }
Ifc4::IfcFlowInstrument::IfcFlowInstrument(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcFlowInstrumentTypeEnum::Value > v9_PredefinedType) : IfcDistributionControlElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcFlowInstrumentTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcFlowInstrumentType
::Ifc4::IfcFlowInstrumentTypeEnum::Value Ifc4::IfcFlowInstrumentType::PredefinedType() const {  return ::Ifc4::IfcFlowInstrumentTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcFlowInstrumentType::setPredefinedType(::Ifc4::IfcFlowInstrumentTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcFlowInstrumentTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcFlowInstrumentType::declaration() const { return *((IfcParse::entity*)IFC4_types[420]); }
const IfcParse::entity& Ifc4::IfcFlowInstrumentType::Class() { return *((IfcParse::entity*)IFC4_types[420]); }
Ifc4::IfcFlowInstrumentType::IfcFlowInstrumentType(IfcEntityInstanceData&& e) : IfcDistributionControlElementType(std::move(e)) { }
Ifc4::IfcFlowInstrumentType::IfcFlowInstrumentType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcFlowInstrumentTypeEnum::Value v10_PredefinedType) : IfcDistributionControlElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcFlowInstrumentTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcFlowMeter
boost::optional< ::Ifc4::IfcFlowMeterTypeEnum::Value > Ifc4::IfcFlowMeter::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcFlowMeterTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcFlowMeter::setPredefinedType(boost::optional< ::Ifc4::IfcFlowMeterTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcFlowMeterTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcFlowMeter::declaration() const { return *((IfcParse::entity*)IFC4_types[422]); }
const IfcParse::entity& Ifc4::IfcFlowMeter::Class() { return *((IfcParse::entity*)IFC4_types[422]); }
Ifc4::IfcFlowMeter::IfcFlowMeter(IfcEntityInstanceData&& e) : IfcFlowController(std::move(e)) { }
Ifc4::IfcFlowMeter::IfcFlowMeter(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcFlowMeterTypeEnum::Value > v9_PredefinedType) : IfcFlowController(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcFlowMeterTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcFlowMeterType
::Ifc4::IfcFlowMeterTypeEnum::Value Ifc4::IfcFlowMeterType::PredefinedType() const {  return ::Ifc4::IfcFlowMeterTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcFlowMeterType::setPredefinedType(::Ifc4::IfcFlowMeterTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcFlowMeterTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcFlowMeterType::declaration() const { return *((IfcParse::entity*)IFC4_types[423]); }
const IfcParse::entity& Ifc4::IfcFlowMeterType::Class() { return *((IfcParse::entity*)IFC4_types[423]); }
Ifc4::IfcFlowMeterType::IfcFlowMeterType(IfcEntityInstanceData&& e) : IfcFlowControllerType(std::move(e)) { }
Ifc4::IfcFlowMeterType::IfcFlowMeterType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcFlowMeterTypeEnum::Value v10_PredefinedType) : IfcFlowControllerType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcFlowMeterTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcFlowMovingDevice


const IfcParse::entity& Ifc4::IfcFlowMovingDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[425]); }
const IfcParse::entity& Ifc4::IfcFlowMovingDevice::Class() { return *((IfcParse::entity*)IFC4_types[425]); }
Ifc4::IfcFlowMovingDevice::IfcFlowMovingDevice(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcFlowMovingDevice::IfcFlowMovingDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFlowMovingDeviceType


const IfcParse::entity& Ifc4::IfcFlowMovingDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[426]); }
const IfcParse::entity& Ifc4::IfcFlowMovingDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[426]); }
Ifc4::IfcFlowMovingDeviceType::IfcFlowMovingDeviceType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcFlowMovingDeviceType::IfcFlowMovingDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcFlowSegment


const IfcParse::entity& Ifc4::IfcFlowSegment::declaration() const { return *((IfcParse::entity*)IFC4_types[427]); }
const IfcParse::entity& Ifc4::IfcFlowSegment::Class() { return *((IfcParse::entity*)IFC4_types[427]); }
Ifc4::IfcFlowSegment::IfcFlowSegment(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcFlowSegment::IfcFlowSegment(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFlowSegmentType


const IfcParse::entity& Ifc4::IfcFlowSegmentType::declaration() const { return *((IfcParse::entity*)IFC4_types[428]); }
const IfcParse::entity& Ifc4::IfcFlowSegmentType::Class() { return *((IfcParse::entity*)IFC4_types[428]); }
Ifc4::IfcFlowSegmentType::IfcFlowSegmentType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcFlowSegmentType::IfcFlowSegmentType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcFlowStorageDevice


const IfcParse::entity& Ifc4::IfcFlowStorageDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[429]); }
const IfcParse::entity& Ifc4::IfcFlowStorageDevice::Class() { return *((IfcParse::entity*)IFC4_types[429]); }
Ifc4::IfcFlowStorageDevice::IfcFlowStorageDevice(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcFlowStorageDevice::IfcFlowStorageDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFlowStorageDeviceType


const IfcParse::entity& Ifc4::IfcFlowStorageDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[430]); }
const IfcParse::entity& Ifc4::IfcFlowStorageDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[430]); }
Ifc4::IfcFlowStorageDeviceType::IfcFlowStorageDeviceType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcFlowStorageDeviceType::IfcFlowStorageDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcFlowTerminal


const IfcParse::entity& Ifc4::IfcFlowTerminal::declaration() const { return *((IfcParse::entity*)IFC4_types[431]); }
const IfcParse::entity& Ifc4::IfcFlowTerminal::Class() { return *((IfcParse::entity*)IFC4_types[431]); }
Ifc4::IfcFlowTerminal::IfcFlowTerminal(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcFlowTerminal::IfcFlowTerminal(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFlowTerminalType


const IfcParse::entity& Ifc4::IfcFlowTerminalType::declaration() const { return *((IfcParse::entity*)IFC4_types[432]); }
const IfcParse::entity& Ifc4::IfcFlowTerminalType::Class() { return *((IfcParse::entity*)IFC4_types[432]); }
Ifc4::IfcFlowTerminalType::IfcFlowTerminalType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcFlowTerminalType::IfcFlowTerminalType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcFlowTreatmentDevice


const IfcParse::entity& Ifc4::IfcFlowTreatmentDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[433]); }
const IfcParse::entity& Ifc4::IfcFlowTreatmentDevice::Class() { return *((IfcParse::entity*)IFC4_types[433]); }
Ifc4::IfcFlowTreatmentDevice::IfcFlowTreatmentDevice(IfcEntityInstanceData&& e) : IfcDistributionFlowElement(std::move(e)) { }
Ifc4::IfcFlowTreatmentDevice::IfcFlowTreatmentDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcDistributionFlowElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFlowTreatmentDeviceType


const IfcParse::entity& Ifc4::IfcFlowTreatmentDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[434]); }
const IfcParse::entity& Ifc4::IfcFlowTreatmentDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[434]); }
Ifc4::IfcFlowTreatmentDeviceType::IfcFlowTreatmentDeviceType(IfcEntityInstanceData&& e) : IfcDistributionFlowElementType(std::move(e)) { }
Ifc4::IfcFlowTreatmentDeviceType::IfcFlowTreatmentDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcDistributionFlowElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcFooting
boost::optional< ::Ifc4::IfcFootingTypeEnum::Value > Ifc4::IfcFooting::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcFootingTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcFooting::setPredefinedType(boost::optional< ::Ifc4::IfcFootingTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcFootingTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcFooting::declaration() const { return *((IfcParse::entity*)IFC4_types[438]); }
const IfcParse::entity& Ifc4::IfcFooting::Class() { return *((IfcParse::entity*)IFC4_types[438]); }
Ifc4::IfcFooting::IfcFooting(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcFooting::IfcFooting(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcFootingTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcFootingTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcFootingType
::Ifc4::IfcFootingTypeEnum::Value Ifc4::IfcFootingType::PredefinedType() const {  return ::Ifc4::IfcFootingTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcFootingType::setPredefinedType(::Ifc4::IfcFootingTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcFootingTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcFootingType::declaration() const { return *((IfcParse::entity*)IFC4_types[439]); }
const IfcParse::entity& Ifc4::IfcFootingType::Class() { return *((IfcParse::entity*)IFC4_types[439]); }
Ifc4::IfcFootingType::IfcFootingType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcFootingType::IfcFootingType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcFootingTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcFootingTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcFurnishingElement


const IfcParse::entity& Ifc4::IfcFurnishingElement::declaration() const { return *((IfcParse::entity*)IFC4_types[443]); }
const IfcParse::entity& Ifc4::IfcFurnishingElement::Class() { return *((IfcParse::entity*)IFC4_types[443]); }
Ifc4::IfcFurnishingElement::IfcFurnishingElement(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcFurnishingElement::IfcFurnishingElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcFurnishingElementType


const IfcParse::entity& Ifc4::IfcFurnishingElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[444]); }
const IfcParse::entity& Ifc4::IfcFurnishingElementType::Class() { return *((IfcParse::entity*)IFC4_types[444]); }
Ifc4::IfcFurnishingElementType::IfcFurnishingElementType(IfcEntityInstanceData&& e) : IfcElementType(std::move(e)) { }
Ifc4::IfcFurnishingElementType::IfcFurnishingElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcFurniture
boost::optional< ::Ifc4::IfcFurnitureTypeEnum::Value > Ifc4::IfcFurniture::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcFurnitureTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcFurniture::setPredefinedType(boost::optional< ::Ifc4::IfcFurnitureTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcFurnitureTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcFurniture::declaration() const { return *((IfcParse::entity*)IFC4_types[445]); }
const IfcParse::entity& Ifc4::IfcFurniture::Class() { return *((IfcParse::entity*)IFC4_types[445]); }
Ifc4::IfcFurniture::IfcFurniture(IfcEntityInstanceData&& e) : IfcFurnishingElement(std::move(e)) { }
Ifc4::IfcFurniture::IfcFurniture(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcFurnitureTypeEnum::Value > v9_PredefinedType) : IfcFurnishingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcFurnitureTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcFurnitureType
::Ifc4::IfcAssemblyPlaceEnum::Value Ifc4::IfcFurnitureType::AssemblyPlace() const {  return ::Ifc4::IfcAssemblyPlaceEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcFurnitureType::setAssemblyPlace(::Ifc4::IfcAssemblyPlaceEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcAssemblyPlaceEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< ::Ifc4::IfcFurnitureTypeEnum::Value > Ifc4::IfcFurnitureType::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcFurnitureTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcFurnitureType::setPredefinedType(boost::optional< ::Ifc4::IfcFurnitureTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcFurnitureTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcFurnitureType::declaration() const { return *((IfcParse::entity*)IFC4_types[446]); }
const IfcParse::entity& Ifc4::IfcFurnitureType::Class() { return *((IfcParse::entity*)IFC4_types[446]); }
Ifc4::IfcFurnitureType::IfcFurnitureType(IfcEntityInstanceData&& e) : IfcFurnishingElementType(std::move(e)) { }
Ifc4::IfcFurnitureType::IfcFurnitureType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcAssemblyPlaceEnum::Value v10_AssemblyPlace, boost::optional< ::Ifc4::IfcFurnitureTypeEnum::Value > v11_PredefinedType) : IfcFurnishingElementType(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcAssemblyPlaceEnum::Class(),(size_t)v10_AssemblyPlace))); if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcFurnitureTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcGeographicElement
boost::optional< ::Ifc4::IfcGeographicElementTypeEnum::Value > Ifc4::IfcGeographicElement::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcGeographicElementTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcGeographicElement::setPredefinedType(boost::optional< ::Ifc4::IfcGeographicElementTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcGeographicElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcGeographicElement::declaration() const { return *((IfcParse::entity*)IFC4_types[448]); }
const IfcParse::entity& Ifc4::IfcGeographicElement::Class() { return *((IfcParse::entity*)IFC4_types[448]); }
Ifc4::IfcGeographicElement::IfcGeographicElement(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcGeographicElement::IfcGeographicElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcGeographicElementTypeEnum::Value > v9_PredefinedType) : IfcElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGeographicElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcGeographicElementType
::Ifc4::IfcGeographicElementTypeEnum::Value Ifc4::IfcGeographicElementType::PredefinedType() const {  return ::Ifc4::IfcGeographicElementTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcGeographicElementType::setPredefinedType(::Ifc4::IfcGeographicElementTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcGeographicElementTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcGeographicElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[449]); }
const IfcParse::entity& Ifc4::IfcGeographicElementType::Class() { return *((IfcParse::entity*)IFC4_types[449]); }
Ifc4::IfcGeographicElementType::IfcGeographicElementType(IfcEntityInstanceData&& e) : IfcElementType(std::move(e)) { }
Ifc4::IfcGeographicElementType::IfcGeographicElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcGeographicElementTypeEnum::Value v10_PredefinedType) : IfcElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcGeographicElementTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcGeometricCurveSet


const IfcParse::entity& Ifc4::IfcGeometricCurveSet::declaration() const { return *((IfcParse::entity*)IFC4_types[451]); }
const IfcParse::entity& Ifc4::IfcGeometricCurveSet::Class() { return *((IfcParse::entity*)IFC4_types[451]); }
Ifc4::IfcGeometricCurveSet::IfcGeometricCurveSet(IfcEntityInstanceData&& e) : IfcGeometricSet(std::move(e)) { }
Ifc4::IfcGeometricCurveSet::IfcGeometricCurveSet(aggregate_of< ::Ifc4::IfcGeometricSetSelect >::ptr v1_Elements) : IfcGeometricSet(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Elements)->generalize());; populate_derived(); }

// Function implementations for IfcGeometricRepresentationContext
int Ifc4::IfcGeometricRepresentationContext::CoordinateSpaceDimension() const {  int v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcGeometricRepresentationContext::setCoordinateSpaceDimension(int v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
boost::optional< double > Ifc4::IfcGeometricRepresentationContext::Precision() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcGeometricRepresentationContext::setPrecision(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
::Ifc4::IfcAxis2Placement* Ifc4::IfcGeometricRepresentationContext::WorldCoordinateSystem() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcAxis2Placement>(true); }
void Ifc4::IfcGeometricRepresentationContext::setWorldCoordinateSystem(::Ifc4::IfcAxis2Placement* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcDirection* Ifc4::IfcGeometricRepresentationContext::TrueNorth() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcGeometricRepresentationContext::setTrueNorth(::Ifc4::IfcDirection* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }

::Ifc4::IfcGeometricRepresentationSubContext::list::ptr Ifc4::IfcGeometricRepresentationContext::HasSubContexts() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[455], 6)->as<IfcGeometricRepresentationSubContext>(); }
::Ifc4::IfcCoordinateOperation::list::ptr Ifc4::IfcGeometricRepresentationContext::HasCoordinateOperation() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[213], 0)->as<IfcCoordinateOperation>(); }

const IfcParse::entity& Ifc4::IfcGeometricRepresentationContext::declaration() const { return *((IfcParse::entity*)IFC4_types[453]); }
const IfcParse::entity& Ifc4::IfcGeometricRepresentationContext::Class() { return *((IfcParse::entity*)IFC4_types[453]); }
Ifc4::IfcGeometricRepresentationContext::IfcGeometricRepresentationContext(IfcEntityInstanceData&& e) : IfcRepresentationContext(std::move(e)) { }
Ifc4::IfcGeometricRepresentationContext::IfcGeometricRepresentationContext(boost::optional< std::string > v1_ContextIdentifier, boost::optional< std::string > v2_ContextType, int v3_CoordinateSpaceDimension, boost::optional< double > v4_Precision, ::Ifc4::IfcAxis2Placement* v5_WorldCoordinateSystem, ::Ifc4::IfcDirection* v6_TrueNorth) : IfcRepresentationContext(IfcEntityInstanceData(storage_t(6))) {  if (v1_ContextIdentifier) {set_attribute_value(0, (*v1_ContextIdentifier)); } if (v2_ContextType) {set_attribute_value(1, (*v2_ContextType)); }set_attribute_value(2, (v3_CoordinateSpaceDimension)); if (v4_Precision) {set_attribute_value(3, (*v4_Precision)); }set_attribute_value(4, v5_WorldCoordinateSystem ? v5_WorldCoordinateSystem->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_TrueNorth ? v6_TrueNorth->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcGeometricRepresentationItem


const IfcParse::entity& Ifc4::IfcGeometricRepresentationItem::declaration() const { return *((IfcParse::entity*)IFC4_types[454]); }
const IfcParse::entity& Ifc4::IfcGeometricRepresentationItem::Class() { return *((IfcParse::entity*)IFC4_types[454]); }
Ifc4::IfcGeometricRepresentationItem::IfcGeometricRepresentationItem(IfcEntityInstanceData&& e) : IfcRepresentationItem(std::move(e)) { }
Ifc4::IfcGeometricRepresentationItem::IfcGeometricRepresentationItem() : IfcRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcGeometricRepresentationSubContext
::Ifc4::IfcGeometricRepresentationContext* Ifc4::IfcGeometricRepresentationSubContext::ParentContext() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcGeometricRepresentationContext>(true); }
void Ifc4::IfcGeometricRepresentationSubContext::setParentContext(::Ifc4::IfcGeometricRepresentationContext* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
boost::optional< double > Ifc4::IfcGeometricRepresentationSubContext::TargetScale() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcGeometricRepresentationSubContext::setTargetScale(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
::Ifc4::IfcGeometricProjectionEnum::Value Ifc4::IfcGeometricRepresentationSubContext::TargetView() const {  return ::Ifc4::IfcGeometricProjectionEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcGeometricRepresentationSubContext::setTargetView(::Ifc4::IfcGeometricProjectionEnum::Value v) { set_attribute_value(8, EnumerationReference(&::Ifc4::IfcGeometricProjectionEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(8); }
boost::optional< std::string > Ifc4::IfcGeometricRepresentationSubContext::UserDefinedTargetView() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcGeometricRepresentationSubContext::setUserDefinedTargetView(boost::optional< std::string > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcGeometricRepresentationSubContext::declaration() const { return *((IfcParse::entity*)IFC4_types[455]); }
const IfcParse::entity& Ifc4::IfcGeometricRepresentationSubContext::Class() { return *((IfcParse::entity*)IFC4_types[455]); }
Ifc4::IfcGeometricRepresentationSubContext::IfcGeometricRepresentationSubContext(IfcEntityInstanceData&& e) : IfcGeometricRepresentationContext(std::move(e)) { }
Ifc4::IfcGeometricRepresentationSubContext::IfcGeometricRepresentationSubContext(boost::optional< std::string > v1_ContextIdentifier, boost::optional< std::string > v2_ContextType, ::Ifc4::IfcGeometricRepresentationContext* v7_ParentContext, boost::optional< double > v8_TargetScale, ::Ifc4::IfcGeometricProjectionEnum::Value v9_TargetView, boost::optional< std::string > v10_UserDefinedTargetView) : IfcGeometricRepresentationContext(IfcEntityInstanceData(storage_t(10))) {  if (v1_ContextIdentifier) {set_attribute_value(0, (*v1_ContextIdentifier)); } if (v2_ContextType) {set_attribute_value(1, (*v2_ContextType)); }set_attribute_value(6, v7_ParentContext ? v7_ParentContext->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_TargetScale) {set_attribute_value(7, (*v8_TargetScale)); }set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGeometricProjectionEnum::Class(),(size_t)v9_TargetView))); if (v10_UserDefinedTargetView) {set_attribute_value(9, (*v10_UserDefinedTargetView)); }; populate_derived(); }

// Function implementations for IfcGeometricSet
aggregate_of< ::Ifc4::IfcGeometricSetSelect >::ptr Ifc4::IfcGeometricSet::Elements() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcGeometricSetSelect >(); }
void Ifc4::IfcGeometricSet::setElements(aggregate_of< ::Ifc4::IfcGeometricSetSelect >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcGeometricSet::declaration() const { return *((IfcParse::entity*)IFC4_types[456]); }
const IfcParse::entity& Ifc4::IfcGeometricSet::Class() { return *((IfcParse::entity*)IFC4_types[456]); }
Ifc4::IfcGeometricSet::IfcGeometricSet(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcGeometricSet::IfcGeometricSet(aggregate_of< ::Ifc4::IfcGeometricSetSelect >::ptr v1_Elements) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Elements)->generalize());; populate_derived(); }

// Function implementations for IfcGrid
aggregate_of< ::Ifc4::IfcGridAxis >::ptr Ifc4::IfcGrid::UAxes() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcGridAxis >(); }
void Ifc4::IfcGrid::setUAxes(aggregate_of< ::Ifc4::IfcGridAxis >::ptr v) { set_attribute_value(7, (v)->generalize());if constexpr (false)unset_attribute_value(7); }
aggregate_of< ::Ifc4::IfcGridAxis >::ptr Ifc4::IfcGrid::VAxes() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(8); return es->as< ::Ifc4::IfcGridAxis >(); }
void Ifc4::IfcGrid::setVAxes(aggregate_of< ::Ifc4::IfcGridAxis >::ptr v) { set_attribute_value(8, (v)->generalize());if constexpr (false)unset_attribute_value(8); }
boost::optional< aggregate_of< ::Ifc4::IfcGridAxis >::ptr > Ifc4::IfcGrid::WAxes() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(9); return es->as< ::Ifc4::IfcGridAxis >(); }
void Ifc4::IfcGrid::setWAxes(boost::optional< aggregate_of< ::Ifc4::IfcGridAxis >::ptr > v) { if (v) {set_attribute_value(9, (*v)->generalize());} else {unset_attribute_value(9);} }
boost::optional< ::Ifc4::IfcGridTypeEnum::Value > Ifc4::IfcGrid::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcGridTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcGrid::setPredefinedType(boost::optional< ::Ifc4::IfcGridTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcGridTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }

::Ifc4::IfcRelContainedInSpatialStructure::list::ptr Ifc4::IfcGrid::ContainedInStructure() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[823], 4)->as<IfcRelContainedInSpatialStructure>(); }

const IfcParse::entity& Ifc4::IfcGrid::declaration() const { return *((IfcParse::entity*)IFC4_types[460]); }
const IfcParse::entity& Ifc4::IfcGrid::Class() { return *((IfcParse::entity*)IFC4_types[460]); }
Ifc4::IfcGrid::IfcGrid(IfcEntityInstanceData&& e) : IfcProduct(std::move(e)) { }
Ifc4::IfcGrid::IfcGrid(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, aggregate_of< ::Ifc4::IfcGridAxis >::ptr v8_UAxes, aggregate_of< ::Ifc4::IfcGridAxis >::ptr v9_VAxes, boost::optional< aggregate_of< ::Ifc4::IfcGridAxis >::ptr > v10_WAxes, boost::optional< ::Ifc4::IfcGridTypeEnum::Value > v11_PredefinedType) : IfcProduct(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (v8_UAxes)->generalize());set_attribute_value(8, (v9_VAxes)->generalize()); if (v10_WAxes) {set_attribute_value(9, (*v10_WAxes)->generalize()); } if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcGridTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcGridAxis
boost::optional< std::string > Ifc4::IfcGridAxis::AxisTag() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcGridAxis::setAxisTag(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
::Ifc4::IfcCurve* Ifc4::IfcGridAxis::AxisCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcGridAxis::setAxisCurve(::Ifc4::IfcCurve* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
bool Ifc4::IfcGridAxis::SameSense() const {  bool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcGridAxis::setSameSense(bool v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }

::Ifc4::IfcGrid::list::ptr Ifc4::IfcGridAxis::PartOfW() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[460], 9)->as<IfcGrid>(); }
::Ifc4::IfcGrid::list::ptr Ifc4::IfcGridAxis::PartOfV() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[460], 8)->as<IfcGrid>(); }
::Ifc4::IfcGrid::list::ptr Ifc4::IfcGridAxis::PartOfU() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[460], 7)->as<IfcGrid>(); }
::Ifc4::IfcVirtualGridIntersection::list::ptr Ifc4::IfcGridAxis::HasIntersections() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[1135], 0)->as<IfcVirtualGridIntersection>(); }

const IfcParse::entity& Ifc4::IfcGridAxis::declaration() const { return *((IfcParse::entity*)IFC4_types[461]); }
const IfcParse::entity& Ifc4::IfcGridAxis::Class() { return *((IfcParse::entity*)IFC4_types[461]); }
Ifc4::IfcGridAxis::IfcGridAxis(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcGridAxis::IfcGridAxis(boost::optional< std::string > v1_AxisTag, ::Ifc4::IfcCurve* v2_AxisCurve, bool v3_SameSense) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) {  if (v1_AxisTag) {set_attribute_value(0, (*v1_AxisTag)); }set_attribute_value(1, v2_AxisCurve ? v2_AxisCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, (v3_SameSense));; populate_derived(); }

// Function implementations for IfcGridPlacement
::Ifc4::IfcVirtualGridIntersection* Ifc4::IfcGridPlacement::PlacementLocation() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcVirtualGridIntersection>(true); }
void Ifc4::IfcGridPlacement::setPlacementLocation(::Ifc4::IfcVirtualGridIntersection* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcGridPlacementDirectionSelect* Ifc4::IfcGridPlacement::PlacementRefDirection() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcGridPlacementDirectionSelect>(true); }
void Ifc4::IfcGridPlacement::setPlacementRefDirection(::Ifc4::IfcGridPlacementDirectionSelect* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcGridPlacement::declaration() const { return *((IfcParse::entity*)IFC4_types[462]); }
const IfcParse::entity& Ifc4::IfcGridPlacement::Class() { return *((IfcParse::entity*)IFC4_types[462]); }
Ifc4::IfcGridPlacement::IfcGridPlacement(IfcEntityInstanceData&& e) : IfcObjectPlacement(std::move(e)) { }
Ifc4::IfcGridPlacement::IfcGridPlacement(::Ifc4::IfcVirtualGridIntersection* v1_PlacementLocation, ::Ifc4::IfcGridPlacementDirectionSelect* v2_PlacementRefDirection) : IfcObjectPlacement(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_PlacementLocation ? v1_PlacementLocation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_PlacementRefDirection ? v2_PlacementRefDirection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcGroup

::Ifc4::IfcRelAssignsToGroup::list::ptr Ifc4::IfcGroup::IsGroupedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[801], 6)->as<IfcRelAssignsToGroup>(); }

const IfcParse::entity& Ifc4::IfcGroup::declaration() const { return *((IfcParse::entity*)IFC4_types[465]); }
const IfcParse::entity& Ifc4::IfcGroup::Class() { return *((IfcParse::entity*)IFC4_types[465]); }
Ifc4::IfcGroup::IfcGroup(IfcEntityInstanceData&& e) : IfcObject(std::move(e)) { }
Ifc4::IfcGroup::IfcGroup(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType) : IfcObject(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }; populate_derived(); }

// Function implementations for IfcHalfSpaceSolid
::Ifc4::IfcSurface* Ifc4::IfcHalfSpaceSolid::BaseSurface() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcSurface>(true); }
void Ifc4::IfcHalfSpaceSolid::setBaseSurface(::Ifc4::IfcSurface* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
bool Ifc4::IfcHalfSpaceSolid::AgreementFlag() const {  bool v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcHalfSpaceSolid::setAgreementFlag(bool v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcHalfSpaceSolid::declaration() const { return *((IfcParse::entity*)IFC4_types[466]); }
const IfcParse::entity& Ifc4::IfcHalfSpaceSolid::Class() { return *((IfcParse::entity*)IFC4_types[466]); }
Ifc4::IfcHalfSpaceSolid::IfcHalfSpaceSolid(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcHalfSpaceSolid::IfcHalfSpaceSolid(::Ifc4::IfcSurface* v1_BaseSurface, bool v2_AgreementFlag) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_BaseSurface ? v1_BaseSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_AgreementFlag));; populate_derived(); }

// Function implementations for IfcHeatExchanger
boost::optional< ::Ifc4::IfcHeatExchangerTypeEnum::Value > Ifc4::IfcHeatExchanger::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcHeatExchangerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcHeatExchanger::setPredefinedType(boost::optional< ::Ifc4::IfcHeatExchangerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcHeatExchangerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcHeatExchanger::declaration() const { return *((IfcParse::entity*)IFC4_types[468]); }
const IfcParse::entity& Ifc4::IfcHeatExchanger::Class() { return *((IfcParse::entity*)IFC4_types[468]); }
Ifc4::IfcHeatExchanger::IfcHeatExchanger(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcHeatExchanger::IfcHeatExchanger(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcHeatExchangerTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcHeatExchangerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcHeatExchangerType
::Ifc4::IfcHeatExchangerTypeEnum::Value Ifc4::IfcHeatExchangerType::PredefinedType() const {  return ::Ifc4::IfcHeatExchangerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcHeatExchangerType::setPredefinedType(::Ifc4::IfcHeatExchangerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcHeatExchangerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcHeatExchangerType::declaration() const { return *((IfcParse::entity*)IFC4_types[469]); }
const IfcParse::entity& Ifc4::IfcHeatExchangerType::Class() { return *((IfcParse::entity*)IFC4_types[469]); }
Ifc4::IfcHeatExchangerType::IfcHeatExchangerType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcHeatExchangerType::IfcHeatExchangerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcHeatExchangerTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcHeatExchangerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcHumidifier
boost::optional< ::Ifc4::IfcHumidifierTypeEnum::Value > Ifc4::IfcHumidifier::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcHumidifierTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcHumidifier::setPredefinedType(boost::optional< ::Ifc4::IfcHumidifierTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcHumidifierTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcHumidifier::declaration() const { return *((IfcParse::entity*)IFC4_types[473]); }
const IfcParse::entity& Ifc4::IfcHumidifier::Class() { return *((IfcParse::entity*)IFC4_types[473]); }
Ifc4::IfcHumidifier::IfcHumidifier(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcHumidifier::IfcHumidifier(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcHumidifierTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcHumidifierTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcHumidifierType
::Ifc4::IfcHumidifierTypeEnum::Value Ifc4::IfcHumidifierType::PredefinedType() const {  return ::Ifc4::IfcHumidifierTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcHumidifierType::setPredefinedType(::Ifc4::IfcHumidifierTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcHumidifierTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcHumidifierType::declaration() const { return *((IfcParse::entity*)IFC4_types[474]); }
const IfcParse::entity& Ifc4::IfcHumidifierType::Class() { return *((IfcParse::entity*)IFC4_types[474]); }
Ifc4::IfcHumidifierType::IfcHumidifierType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcHumidifierType::IfcHumidifierType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcHumidifierTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcHumidifierTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcIShapeProfileDef
double Ifc4::IfcIShapeProfileDef::OverallWidth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcIShapeProfileDef::setOverallWidth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcIShapeProfileDef::OverallDepth() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcIShapeProfileDef::setOverallDepth(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
double Ifc4::IfcIShapeProfileDef::WebThickness() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcIShapeProfileDef::setWebThickness(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcIShapeProfileDef::FlangeThickness() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcIShapeProfileDef::setFlangeThickness(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
boost::optional< double > Ifc4::IfcIShapeProfileDef::FilletRadius() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcIShapeProfileDef::setFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< double > Ifc4::IfcIShapeProfileDef::FlangeEdgeRadius() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcIShapeProfileDef::setFlangeEdgeRadius(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< double > Ifc4::IfcIShapeProfileDef::FlangeSlope() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcIShapeProfileDef::setFlangeSlope(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcIShapeProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[498]); }
const IfcParse::entity& Ifc4::IfcIShapeProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[498]); }
Ifc4::IfcIShapeProfileDef::IfcIShapeProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcIShapeProfileDef::IfcIShapeProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_OverallWidth, double v5_OverallDepth, double v6_WebThickness, double v7_FlangeThickness, boost::optional< double > v8_FilletRadius, boost::optional< double > v9_FlangeEdgeRadius, boost::optional< double > v10_FlangeSlope) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_OverallWidth));set_attribute_value(4, (v5_OverallDepth));set_attribute_value(5, (v6_WebThickness));set_attribute_value(6, (v7_FlangeThickness)); if (v8_FilletRadius) {set_attribute_value(7, (*v8_FilletRadius)); } if (v9_FlangeEdgeRadius) {set_attribute_value(8, (*v9_FlangeEdgeRadius)); } if (v10_FlangeSlope) {set_attribute_value(9, (*v10_FlangeSlope)); }; populate_derived(); }

// Function implementations for IfcImageTexture
std::string Ifc4::IfcImageTexture::URLReference() const {  std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcImageTexture::setURLReference(std::string v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcImageTexture::declaration() const { return *((IfcParse::entity*)IFC4_types[478]); }
const IfcParse::entity& Ifc4::IfcImageTexture::Class() { return *((IfcParse::entity*)IFC4_types[478]); }
Ifc4::IfcImageTexture::IfcImageTexture(IfcEntityInstanceData&& e) : IfcSurfaceTexture(std::move(e)) { }
Ifc4::IfcImageTexture::IfcImageTexture(bool v1_RepeatS, bool v2_RepeatT, boost::optional< std::string > v3_Mode, ::Ifc4::IfcCartesianTransformationOperator2D* v4_TextureTransform, boost::optional< std::vector< std::string > /*[1:?]*/ > v5_Parameter, std::string v6_URLReference) : IfcSurfaceTexture(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_RepeatS));set_attribute_value(1, (v2_RepeatT)); if (v3_Mode) {set_attribute_value(2, (*v3_Mode)); }set_attribute_value(3, v4_TextureTransform ? v4_TextureTransform->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Parameter) {set_attribute_value(4, (*v5_Parameter)); }set_attribute_value(5, (v6_URLReference));; populate_derived(); }

// Function implementations for IfcIndexedColourMap
::Ifc4::IfcTessellatedFaceSet* Ifc4::IfcIndexedColourMap::MappedTo() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcTessellatedFaceSet>(true); }
void Ifc4::IfcIndexedColourMap::setMappedTo(::Ifc4::IfcTessellatedFaceSet* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
boost::optional< double > Ifc4::IfcIndexedColourMap::Opacity() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcIndexedColourMap::setOpacity(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
::Ifc4::IfcColourRgbList* Ifc4::IfcIndexedColourMap::Colours() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcColourRgbList>(true); }
void Ifc4::IfcIndexedColourMap::setColours(::Ifc4::IfcColourRgbList* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
std::vector< int > /*[1:?]*/ Ifc4::IfcIndexedColourMap::ColourIndex() const {  std::vector< int > /*[1:?]*/ v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcIndexedColourMap::setColourIndex(std::vector< int > /*[1:?]*/ v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcIndexedColourMap::declaration() const { return *((IfcParse::entity*)IFC4_types[479]); }
const IfcParse::entity& Ifc4::IfcIndexedColourMap::Class() { return *((IfcParse::entity*)IFC4_types[479]); }
Ifc4::IfcIndexedColourMap::IfcIndexedColourMap(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcIndexedColourMap::IfcIndexedColourMap(::Ifc4::IfcTessellatedFaceSet* v1_MappedTo, boost::optional< double > v2_Opacity, ::Ifc4::IfcColourRgbList* v3_Colours, std::vector< int > /*[1:?]*/ v4_ColourIndex) : IfcPresentationItem(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_MappedTo ? v1_MappedTo->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_Opacity) {set_attribute_value(1, (*v2_Opacity)); }set_attribute_value(2, v3_Colours ? v3_Colours->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_ColourIndex));; populate_derived(); }

// Function implementations for IfcIndexedPolyCurve
::Ifc4::IfcCartesianPointList* Ifc4::IfcIndexedPolyCurve::Points() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCartesianPointList>(true); }
void Ifc4::IfcIndexedPolyCurve::setPoints(::Ifc4::IfcCartesianPointList* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
boost::optional< aggregate_of< ::Ifc4::IfcSegmentIndexSelect >::ptr > Ifc4::IfcIndexedPolyCurve::Segments() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcSegmentIndexSelect >(); }
void Ifc4::IfcIndexedPolyCurve::setSegments(boost::optional< aggregate_of< ::Ifc4::IfcSegmentIndexSelect >::ptr > v) { if (v) {set_attribute_value(1, (*v)->generalize());} else {unset_attribute_value(1);} }
boost::optional< bool > Ifc4::IfcIndexedPolyCurve::SelfIntersect() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } bool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcIndexedPolyCurve::setSelfIntersect(boost::optional< bool > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcIndexedPolyCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[480]); }
const IfcParse::entity& Ifc4::IfcIndexedPolyCurve::Class() { return *((IfcParse::entity*)IFC4_types[480]); }
Ifc4::IfcIndexedPolyCurve::IfcIndexedPolyCurve(IfcEntityInstanceData&& e) : IfcBoundedCurve(std::move(e)) { }
Ifc4::IfcIndexedPolyCurve::IfcIndexedPolyCurve(::Ifc4::IfcCartesianPointList* v1_Points, boost::optional< aggregate_of< ::Ifc4::IfcSegmentIndexSelect >::ptr > v2_Segments, boost::optional< bool > v3_SelfIntersect) : IfcBoundedCurve(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Points ? v1_Points->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_Segments) {set_attribute_value(1, (*v2_Segments)->generalize()); } if (v3_SelfIntersect) {set_attribute_value(2, (*v3_SelfIntersect)); }; populate_derived(); }

// Function implementations for IfcIndexedPolygonalFace
std::vector< int > /*[3:?]*/ Ifc4::IfcIndexedPolygonalFace::CoordIndex() const {  std::vector< int > /*[3:?]*/ v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcIndexedPolygonalFace::setCoordIndex(std::vector< int > /*[3:?]*/ v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }

::Ifc4::IfcPolygonalFaceSet::list::ptr Ifc4::IfcIndexedPolygonalFace::ToFaceSet() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[680], 2)->as<IfcPolygonalFaceSet>(); }

const IfcParse::entity& Ifc4::IfcIndexedPolygonalFace::declaration() const { return *((IfcParse::entity*)IFC4_types[481]); }
const IfcParse::entity& Ifc4::IfcIndexedPolygonalFace::Class() { return *((IfcParse::entity*)IFC4_types[481]); }
Ifc4::IfcIndexedPolygonalFace::IfcIndexedPolygonalFace(IfcEntityInstanceData&& e) : IfcTessellatedItem(std::move(e)) { }
Ifc4::IfcIndexedPolygonalFace::IfcIndexedPolygonalFace(std::vector< int > /*[3:?]*/ v1_CoordIndex) : IfcTessellatedItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_CoordIndex));; populate_derived(); }

// Function implementations for IfcIndexedPolygonalFaceWithVoids
std::vector< std::vector< int > > Ifc4::IfcIndexedPolygonalFaceWithVoids::InnerCoordIndices() const {  std::vector< std::vector< int > > v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcIndexedPolygonalFaceWithVoids::setInnerCoordIndices(std::vector< std::vector< int > > v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcIndexedPolygonalFaceWithVoids::declaration() const { return *((IfcParse::entity*)IFC4_types[482]); }
const IfcParse::entity& Ifc4::IfcIndexedPolygonalFaceWithVoids::Class() { return *((IfcParse::entity*)IFC4_types[482]); }
Ifc4::IfcIndexedPolygonalFaceWithVoids::IfcIndexedPolygonalFaceWithVoids(IfcEntityInstanceData&& e) : IfcIndexedPolygonalFace(std::move(e)) { }
Ifc4::IfcIndexedPolygonalFaceWithVoids::IfcIndexedPolygonalFaceWithVoids(std::vector< int > /*[3:?]*/ v1_CoordIndex, std::vector< std::vector< int > > v2_InnerCoordIndices) : IfcIndexedPolygonalFace(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_CoordIndex));set_attribute_value(1, (v2_InnerCoordIndices));; populate_derived(); }

// Function implementations for IfcIndexedTextureMap
::Ifc4::IfcTessellatedFaceSet* Ifc4::IfcIndexedTextureMap::MappedTo() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcTessellatedFaceSet>(true); }
void Ifc4::IfcIndexedTextureMap::setMappedTo(::Ifc4::IfcTessellatedFaceSet* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcTextureVertexList* Ifc4::IfcIndexedTextureMap::TexCoords() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcTextureVertexList>(true); }
void Ifc4::IfcIndexedTextureMap::setTexCoords(::Ifc4::IfcTextureVertexList* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcIndexedTextureMap::declaration() const { return *((IfcParse::entity*)IFC4_types[483]); }
const IfcParse::entity& Ifc4::IfcIndexedTextureMap::Class() { return *((IfcParse::entity*)IFC4_types[483]); }
Ifc4::IfcIndexedTextureMap::IfcIndexedTextureMap(IfcEntityInstanceData&& e) : IfcTextureCoordinate(std::move(e)) { }
Ifc4::IfcIndexedTextureMap::IfcIndexedTextureMap(aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr v1_Maps, ::Ifc4::IfcTessellatedFaceSet* v2_MappedTo, ::Ifc4::IfcTextureVertexList* v3_TexCoords) : IfcTextureCoordinate(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Maps)->generalize());set_attribute_value(1, v2_MappedTo ? v2_MappedTo->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_TexCoords ? v3_TexCoords->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcIndexedTriangleTextureMap
boost::optional< std::vector< std::vector< int > > > Ifc4::IfcIndexedTriangleTextureMap::TexCoordIndex() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::vector< std::vector< int > > v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcIndexedTriangleTextureMap::setTexCoordIndex(boost::optional< std::vector< std::vector< int > > > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcIndexedTriangleTextureMap::declaration() const { return *((IfcParse::entity*)IFC4_types[484]); }
const IfcParse::entity& Ifc4::IfcIndexedTriangleTextureMap::Class() { return *((IfcParse::entity*)IFC4_types[484]); }
Ifc4::IfcIndexedTriangleTextureMap::IfcIndexedTriangleTextureMap(IfcEntityInstanceData&& e) : IfcIndexedTextureMap(std::move(e)) { }
Ifc4::IfcIndexedTriangleTextureMap::IfcIndexedTriangleTextureMap(aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr v1_Maps, ::Ifc4::IfcTessellatedFaceSet* v2_MappedTo, ::Ifc4::IfcTextureVertexList* v3_TexCoords, boost::optional< std::vector< std::vector< int > > > v4_TexCoordIndex) : IfcIndexedTextureMap(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_Maps)->generalize());set_attribute_value(1, v2_MappedTo ? v2_MappedTo->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_TexCoords ? v3_TexCoords->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_TexCoordIndex) {set_attribute_value(3, (*v4_TexCoordIndex)); }; populate_derived(); }

// Function implementations for IfcInterceptor
boost::optional< ::Ifc4::IfcInterceptorTypeEnum::Value > Ifc4::IfcInterceptor::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcInterceptorTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcInterceptor::setPredefinedType(boost::optional< ::Ifc4::IfcInterceptorTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcInterceptorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcInterceptor::declaration() const { return *((IfcParse::entity*)IFC4_types[488]); }
const IfcParse::entity& Ifc4::IfcInterceptor::Class() { return *((IfcParse::entity*)IFC4_types[488]); }
Ifc4::IfcInterceptor::IfcInterceptor(IfcEntityInstanceData&& e) : IfcFlowTreatmentDevice(std::move(e)) { }
Ifc4::IfcInterceptor::IfcInterceptor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcInterceptorTypeEnum::Value > v9_PredefinedType) : IfcFlowTreatmentDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcInterceptorTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcInterceptorType
::Ifc4::IfcInterceptorTypeEnum::Value Ifc4::IfcInterceptorType::PredefinedType() const {  return ::Ifc4::IfcInterceptorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcInterceptorType::setPredefinedType(::Ifc4::IfcInterceptorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcInterceptorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcInterceptorType::declaration() const { return *((IfcParse::entity*)IFC4_types[489]); }
const IfcParse::entity& Ifc4::IfcInterceptorType::Class() { return *((IfcParse::entity*)IFC4_types[489]); }
Ifc4::IfcInterceptorType::IfcInterceptorType(IfcEntityInstanceData&& e) : IfcFlowTreatmentDeviceType(std::move(e)) { }
Ifc4::IfcInterceptorType::IfcInterceptorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcInterceptorTypeEnum::Value v10_PredefinedType) : IfcFlowTreatmentDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcInterceptorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcIntersectionCurve


const IfcParse::entity& Ifc4::IfcIntersectionCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[492]); }
const IfcParse::entity& Ifc4::IfcIntersectionCurve::Class() { return *((IfcParse::entity*)IFC4_types[492]); }
Ifc4::IfcIntersectionCurve::IfcIntersectionCurve(IfcEntityInstanceData&& e) : IfcSurfaceCurve(std::move(e)) { }
Ifc4::IfcIntersectionCurve::IfcIntersectionCurve(::Ifc4::IfcCurve* v1_Curve3D, aggregate_of< ::Ifc4::IfcPcurve >::ptr v2_AssociatedGeometry, ::Ifc4::IfcPreferredSurfaceCurveRepresentation::Value v3_MasterRepresentation) : IfcSurfaceCurve(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Curve3D ? v1_Curve3D->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_AssociatedGeometry)->generalize());set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcPreferredSurfaceCurveRepresentation::Class(),(size_t)v3_MasterRepresentation)));; populate_derived(); }

// Function implementations for IfcInventory
boost::optional< ::Ifc4::IfcInventoryTypeEnum::Value > Ifc4::IfcInventory::PredefinedType() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } return ::Ifc4::IfcInventoryTypeEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcInventory::setPredefinedType(boost::optional< ::Ifc4::IfcInventoryTypeEnum::Value > v) { if (v) {set_attribute_value(5, EnumerationReference(&::Ifc4::IfcInventoryTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(5);} }
::Ifc4::IfcActorSelect* Ifc4::IfcInventory::Jurisdiction() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcInventory::setJurisdiction(::Ifc4::IfcActorSelect* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
boost::optional< aggregate_of< ::Ifc4::IfcPerson >::ptr > Ifc4::IfcInventory::ResponsiblePersons() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcPerson >(); }
void Ifc4::IfcInventory::setResponsiblePersons(boost::optional< aggregate_of< ::Ifc4::IfcPerson >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcInventory::LastUpdateDate() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcInventory::setLastUpdateDate(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
::Ifc4::IfcCostValue* Ifc4::IfcInventory::CurrentValue() const { if(data_.get_attribute_value(9).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcCostValue>(true); }
void Ifc4::IfcInventory::setCurrentValue(::Ifc4::IfcCostValue* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }
::Ifc4::IfcCostValue* Ifc4::IfcInventory::OriginalValue() const { if(data_.get_attribute_value(10).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(10)))->as<::Ifc4::IfcCostValue>(true); }
void Ifc4::IfcInventory::setOriginalValue(::Ifc4::IfcCostValue* v) { set_attribute_value(10, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(10); }


const IfcParse::entity& Ifc4::IfcInventory::declaration() const { return *((IfcParse::entity*)IFC4_types[493]); }
const IfcParse::entity& Ifc4::IfcInventory::Class() { return *((IfcParse::entity*)IFC4_types[493]); }
Ifc4::IfcInventory::IfcInventory(IfcEntityInstanceData&& e) : IfcGroup(std::move(e)) { }
Ifc4::IfcInventory::IfcInventory(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< ::Ifc4::IfcInventoryTypeEnum::Value > v6_PredefinedType, ::Ifc4::IfcActorSelect* v7_Jurisdiction, boost::optional< aggregate_of< ::Ifc4::IfcPerson >::ptr > v8_ResponsiblePersons, boost::optional< std::string > v9_LastUpdateDate, ::Ifc4::IfcCostValue* v10_CurrentValue, ::Ifc4::IfcCostValue* v11_OriginalValue) : IfcGroup(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_PredefinedType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcInventoryTypeEnum::Class(),(size_t)*v6_PredefinedType))); }set_attribute_value(6, v7_Jurisdiction ? v7_Jurisdiction->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_ResponsiblePersons) {set_attribute_value(7, (*v8_ResponsiblePersons)->generalize()); } if (v9_LastUpdateDate) {set_attribute_value(8, (*v9_LastUpdateDate)); }set_attribute_value(9, v10_CurrentValue ? v10_CurrentValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(10, v11_OriginalValue ? v11_OriginalValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcIrregularTimeSeries
aggregate_of< ::Ifc4::IfcIrregularTimeSeriesValue >::ptr Ifc4::IfcIrregularTimeSeries::Values() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(8); return es->as< ::Ifc4::IfcIrregularTimeSeriesValue >(); }
void Ifc4::IfcIrregularTimeSeries::setValues(aggregate_of< ::Ifc4::IfcIrregularTimeSeriesValue >::ptr v) { set_attribute_value(8, (v)->generalize());if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcIrregularTimeSeries::declaration() const { return *((IfcParse::entity*)IFC4_types[496]); }
const IfcParse::entity& Ifc4::IfcIrregularTimeSeries::Class() { return *((IfcParse::entity*)IFC4_types[496]); }
Ifc4::IfcIrregularTimeSeries::IfcIrregularTimeSeries(IfcEntityInstanceData&& e) : IfcTimeSeries(std::move(e)) { }
Ifc4::IfcIrregularTimeSeries::IfcIrregularTimeSeries(std::string v1_Name, boost::optional< std::string > v2_Description, std::string v3_StartTime, std::string v4_EndTime, ::Ifc4::IfcTimeSeriesDataTypeEnum::Value v5_TimeSeriesDataType, ::Ifc4::IfcDataOriginEnum::Value v6_DataOrigin, boost::optional< std::string > v7_UserDefinedDataOrigin, ::Ifc4::IfcUnit* v8_Unit, aggregate_of< ::Ifc4::IfcIrregularTimeSeriesValue >::ptr v9_Values) : IfcTimeSeries(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_StartTime));set_attribute_value(3, (v4_EndTime));set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcTimeSeriesDataTypeEnum::Class(),(size_t)v5_TimeSeriesDataType)));set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)v6_DataOrigin))); if (v7_UserDefinedDataOrigin) {set_attribute_value(6, (*v7_UserDefinedDataOrigin)); }set_attribute_value(7, v8_Unit ? v8_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (v9_Values)->generalize());; populate_derived(); }

// Function implementations for IfcIrregularTimeSeriesValue
std::string Ifc4::IfcIrregularTimeSeriesValue::TimeStamp() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcIrregularTimeSeriesValue::setTimeStamp(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcValue >::ptr Ifc4::IfcIrregularTimeSeriesValue::ListValues() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcValue >(); }
void Ifc4::IfcIrregularTimeSeriesValue::setListValues(aggregate_of< ::Ifc4::IfcValue >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcIrregularTimeSeriesValue::declaration() const { return *((IfcParse::entity*)IFC4_types[497]); }
const IfcParse::entity& Ifc4::IfcIrregularTimeSeriesValue::Class() { return *((IfcParse::entity*)IFC4_types[497]); }
Ifc4::IfcIrregularTimeSeriesValue::IfcIrregularTimeSeriesValue(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcIrregularTimeSeriesValue::IfcIrregularTimeSeriesValue(std::string v1_TimeStamp, aggregate_of< ::Ifc4::IfcValue >::ptr v2_ListValues) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_TimeStamp));set_attribute_value(1, (v2_ListValues)->generalize());; populate_derived(); }

// Function implementations for IfcJunctionBox
boost::optional< ::Ifc4::IfcJunctionBoxTypeEnum::Value > Ifc4::IfcJunctionBox::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcJunctionBoxTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcJunctionBox::setPredefinedType(boost::optional< ::Ifc4::IfcJunctionBoxTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcJunctionBoxTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcJunctionBox::declaration() const { return *((IfcParse::entity*)IFC4_types[500]); }
const IfcParse::entity& Ifc4::IfcJunctionBox::Class() { return *((IfcParse::entity*)IFC4_types[500]); }
Ifc4::IfcJunctionBox::IfcJunctionBox(IfcEntityInstanceData&& e) : IfcFlowFitting(std::move(e)) { }
Ifc4::IfcJunctionBox::IfcJunctionBox(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcJunctionBoxTypeEnum::Value > v9_PredefinedType) : IfcFlowFitting(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcJunctionBoxTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcJunctionBoxType
::Ifc4::IfcJunctionBoxTypeEnum::Value Ifc4::IfcJunctionBoxType::PredefinedType() const {  return ::Ifc4::IfcJunctionBoxTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcJunctionBoxType::setPredefinedType(::Ifc4::IfcJunctionBoxTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcJunctionBoxTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcJunctionBoxType::declaration() const { return *((IfcParse::entity*)IFC4_types[501]); }
const IfcParse::entity& Ifc4::IfcJunctionBoxType::Class() { return *((IfcParse::entity*)IFC4_types[501]); }
Ifc4::IfcJunctionBoxType::IfcJunctionBoxType(IfcEntityInstanceData&& e) : IfcFlowFittingType(std::move(e)) { }
Ifc4::IfcJunctionBoxType::IfcJunctionBoxType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcJunctionBoxTypeEnum::Value v10_PredefinedType) : IfcFlowFittingType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcJunctionBoxTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcLShapeProfileDef
double Ifc4::IfcLShapeProfileDef::Depth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcLShapeProfileDef::setDepth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< double > Ifc4::IfcLShapeProfileDef::Width() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcLShapeProfileDef::setWidth(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
double Ifc4::IfcLShapeProfileDef::Thickness() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcLShapeProfileDef::setThickness(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
boost::optional< double > Ifc4::IfcLShapeProfileDef::FilletRadius() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcLShapeProfileDef::setFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< double > Ifc4::IfcLShapeProfileDef::EdgeRadius() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcLShapeProfileDef::setEdgeRadius(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< double > Ifc4::IfcLShapeProfileDef::LegSlope() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcLShapeProfileDef::setLegSlope(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcLShapeProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[545]); }
const IfcParse::entity& Ifc4::IfcLShapeProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[545]); }
Ifc4::IfcLShapeProfileDef::IfcLShapeProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcLShapeProfileDef::IfcLShapeProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_Depth, boost::optional< double > v5_Width, double v6_Thickness, boost::optional< double > v7_FilletRadius, boost::optional< double > v8_EdgeRadius, boost::optional< double > v9_LegSlope) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Depth)); if (v5_Width) {set_attribute_value(4, (*v5_Width)); }set_attribute_value(5, (v6_Thickness)); if (v7_FilletRadius) {set_attribute_value(6, (*v7_FilletRadius)); } if (v8_EdgeRadius) {set_attribute_value(7, (*v8_EdgeRadius)); } if (v9_LegSlope) {set_attribute_value(8, (*v9_LegSlope)); }; populate_derived(); }

// Function implementations for IfcLaborResource
boost::optional< ::Ifc4::IfcLaborResourceTypeEnum::Value > Ifc4::IfcLaborResource::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcLaborResourceTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcLaborResource::setPredefinedType(boost::optional< ::Ifc4::IfcLaborResourceTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcLaborResourceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcLaborResource::declaration() const { return *((IfcParse::entity*)IFC4_types[506]); }
const IfcParse::entity& Ifc4::IfcLaborResource::Class() { return *((IfcParse::entity*)IFC4_types[506]); }
Ifc4::IfcLaborResource::IfcLaborResource(IfcEntityInstanceData&& e) : IfcConstructionResource(std::move(e)) { }
Ifc4::IfcLaborResource::IfcLaborResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, ::Ifc4::IfcResourceTime* v8_Usage, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v9_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v10_BaseQuantity, boost::optional< ::Ifc4::IfcLaborResourceTypeEnum::Value > v11_PredefinedType) : IfcConstructionResource(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }set_attribute_value(7, v8_Usage ? v8_Usage->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_BaseCosts) {set_attribute_value(8, (*v9_BaseCosts)->generalize()); }set_attribute_value(9, v10_BaseQuantity ? v10_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcLaborResourceTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcLaborResourceType
::Ifc4::IfcLaborResourceTypeEnum::Value Ifc4::IfcLaborResourceType::PredefinedType() const {  return ::Ifc4::IfcLaborResourceTypeEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcLaborResourceType::setPredefinedType(::Ifc4::IfcLaborResourceTypeEnum::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcLaborResourceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcLaborResourceType::declaration() const { return *((IfcParse::entity*)IFC4_types[507]); }
const IfcParse::entity& Ifc4::IfcLaborResourceType::Class() { return *((IfcParse::entity*)IFC4_types[507]); }
Ifc4::IfcLaborResourceType::IfcLaborResourceType(IfcEntityInstanceData&& e) : IfcConstructionResourceType(std::move(e)) { }
Ifc4::IfcLaborResourceType::IfcLaborResourceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ResourceType, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v11_BaseQuantity, ::Ifc4::IfcLaborResourceTypeEnum::Value v12_PredefinedType) : IfcConstructionResourceType(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ResourceType) {set_attribute_value(8, (*v9_ResourceType)); } if (v10_BaseCosts) {set_attribute_value(9, (*v10_BaseCosts)->generalize()); }set_attribute_value(10, v11_BaseQuantity ? v11_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcLaborResourceTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcLagTime
::Ifc4::IfcTimeOrRatioSelect* Ifc4::IfcLagTime::LagValue() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcTimeOrRatioSelect>(true); }
void Ifc4::IfcLagTime::setLagValue(::Ifc4::IfcTimeOrRatioSelect* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcTaskDurationEnum::Value Ifc4::IfcLagTime::DurationType() const {  return ::Ifc4::IfcTaskDurationEnum::FromString(data_.get_attribute_value(4)); }
void Ifc4::IfcLagTime::setDurationType(::Ifc4::IfcTaskDurationEnum::Value v) { set_attribute_value(4, EnumerationReference(&::Ifc4::IfcTaskDurationEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcLagTime::declaration() const { return *((IfcParse::entity*)IFC4_types[509]); }
const IfcParse::entity& Ifc4::IfcLagTime::Class() { return *((IfcParse::entity*)IFC4_types[509]); }
Ifc4::IfcLagTime::IfcLagTime(IfcEntityInstanceData&& e) : IfcSchedulingTime(std::move(e)) { }
Ifc4::IfcLagTime::IfcLagTime(boost::optional< std::string > v1_Name, boost::optional< ::Ifc4::IfcDataOriginEnum::Value > v2_DataOrigin, boost::optional< std::string > v3_UserDefinedDataOrigin, ::Ifc4::IfcTimeOrRatioSelect* v4_LagValue, ::Ifc4::IfcTaskDurationEnum::Value v5_DurationType) : IfcSchedulingTime(IfcEntityInstanceData(storage_t(5))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DataOrigin) {set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)*v2_DataOrigin))); } if (v3_UserDefinedDataOrigin) {set_attribute_value(2, (*v3_UserDefinedDataOrigin)); }set_attribute_value(3, v4_LagValue ? v4_LagValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcTaskDurationEnum::Class(),(size_t)v5_DurationType)));; populate_derived(); }

// Function implementations for IfcLamp
boost::optional< ::Ifc4::IfcLampTypeEnum::Value > Ifc4::IfcLamp::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcLampTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcLamp::setPredefinedType(boost::optional< ::Ifc4::IfcLampTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcLampTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcLamp::declaration() const { return *((IfcParse::entity*)IFC4_types[510]); }
const IfcParse::entity& Ifc4::IfcLamp::Class() { return *((IfcParse::entity*)IFC4_types[510]); }
Ifc4::IfcLamp::IfcLamp(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcLamp::IfcLamp(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcLampTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcLampTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcLampType
::Ifc4::IfcLampTypeEnum::Value Ifc4::IfcLampType::PredefinedType() const {  return ::Ifc4::IfcLampTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcLampType::setPredefinedType(::Ifc4::IfcLampTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcLampTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcLampType::declaration() const { return *((IfcParse::entity*)IFC4_types[511]); }
const IfcParse::entity& Ifc4::IfcLampType::Class() { return *((IfcParse::entity*)IFC4_types[511]); }
Ifc4::IfcLampType::IfcLampType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcLampType::IfcLampType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcLampTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcLampTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcLibraryInformation
std::string Ifc4::IfcLibraryInformation::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcLibraryInformation::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcLibraryInformation::Version() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcLibraryInformation::setVersion(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
::Ifc4::IfcActorSelect* Ifc4::IfcLibraryInformation::Publisher() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcActorSelect>(true); }
void Ifc4::IfcLibraryInformation::setPublisher(::Ifc4::IfcActorSelect* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
boost::optional< std::string > Ifc4::IfcLibraryInformation::VersionDate() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcLibraryInformation::setVersionDate(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcLibraryInformation::Location() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcLibraryInformation::setLocation(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcLibraryInformation::Description() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcLibraryInformation::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }

::Ifc4::IfcRelAssociatesLibrary::list::ptr Ifc4::IfcLibraryInformation::LibraryInfoForObjects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[811], 5)->as<IfcRelAssociatesLibrary>(); }
::Ifc4::IfcLibraryReference::list::ptr Ifc4::IfcLibraryInformation::HasLibraryReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[518], 5)->as<IfcLibraryReference>(); }

const IfcParse::entity& Ifc4::IfcLibraryInformation::declaration() const { return *((IfcParse::entity*)IFC4_types[517]); }
const IfcParse::entity& Ifc4::IfcLibraryInformation::Class() { return *((IfcParse::entity*)IFC4_types[517]); }
Ifc4::IfcLibraryInformation::IfcLibraryInformation(IfcEntityInstanceData&& e) : IfcExternalInformation(std::move(e)) { }
Ifc4::IfcLibraryInformation::IfcLibraryInformation(std::string v1_Name, boost::optional< std::string > v2_Version, ::Ifc4::IfcActorSelect* v3_Publisher, boost::optional< std::string > v4_VersionDate, boost::optional< std::string > v5_Location, boost::optional< std::string > v6_Description) : IfcExternalInformation(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_Name)); if (v2_Version) {set_attribute_value(1, (*v2_Version)); }set_attribute_value(2, v3_Publisher ? v3_Publisher->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_VersionDate) {set_attribute_value(3, (*v4_VersionDate)); } if (v5_Location) {set_attribute_value(4, (*v5_Location)); } if (v6_Description) {set_attribute_value(5, (*v6_Description)); }; populate_derived(); }

// Function implementations for IfcLibraryReference
boost::optional< std::string > Ifc4::IfcLibraryReference::Description() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcLibraryReference::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcLibraryReference::Language() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcLibraryReference::setLanguage(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
::Ifc4::IfcLibraryInformation* Ifc4::IfcLibraryReference::ReferencedLibrary() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcLibraryInformation>(true); }
void Ifc4::IfcLibraryReference::setReferencedLibrary(::Ifc4::IfcLibraryInformation* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }

::Ifc4::IfcRelAssociatesLibrary::list::ptr Ifc4::IfcLibraryReference::LibraryRefForObjects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[811], 5)->as<IfcRelAssociatesLibrary>(); }

const IfcParse::entity& Ifc4::IfcLibraryReference::declaration() const { return *((IfcParse::entity*)IFC4_types[518]); }
const IfcParse::entity& Ifc4::IfcLibraryReference::Class() { return *((IfcParse::entity*)IFC4_types[518]); }
Ifc4::IfcLibraryReference::IfcLibraryReference(IfcEntityInstanceData&& e) : IfcExternalReference(std::move(e)) { }
Ifc4::IfcLibraryReference::IfcLibraryReference(boost::optional< std::string > v1_Location, boost::optional< std::string > v2_Identification, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_Language, ::Ifc4::IfcLibraryInformation* v6_ReferencedLibrary) : IfcExternalReference(IfcEntityInstanceData(storage_t(6))) {  if (v1_Location) {set_attribute_value(0, (*v1_Location)); } if (v2_Identification) {set_attribute_value(1, (*v2_Identification)); } if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_Language) {set_attribute_value(4, (*v5_Language)); }set_attribute_value(5, v6_ReferencedLibrary ? v6_ReferencedLibrary->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcLightDistributionData
double Ifc4::IfcLightDistributionData::MainPlaneAngle() const {  double v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcLightDistributionData::setMainPlaneAngle(double v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
std::vector< double > /*[1:?]*/ Ifc4::IfcLightDistributionData::SecondaryPlaneAngle() const {  std::vector< double > /*[1:?]*/ v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcLightDistributionData::setSecondaryPlaneAngle(std::vector< double > /*[1:?]*/ v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
std::vector< double > /*[1:?]*/ Ifc4::IfcLightDistributionData::LuminousIntensity() const {  std::vector< double > /*[1:?]*/ v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcLightDistributionData::setLuminousIntensity(std::vector< double > /*[1:?]*/ v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcLightDistributionData::declaration() const { return *((IfcParse::entity*)IFC4_types[521]); }
const IfcParse::entity& Ifc4::IfcLightDistributionData::Class() { return *((IfcParse::entity*)IFC4_types[521]); }
Ifc4::IfcLightDistributionData::IfcLightDistributionData(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcLightDistributionData::IfcLightDistributionData(double v1_MainPlaneAngle, std::vector< double > /*[1:?]*/ v2_SecondaryPlaneAngle, std::vector< double > /*[1:?]*/ v3_LuminousIntensity) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_MainPlaneAngle));set_attribute_value(1, (v2_SecondaryPlaneAngle));set_attribute_value(2, (v3_LuminousIntensity));; populate_derived(); }

// Function implementations for IfcLightFixture
boost::optional< ::Ifc4::IfcLightFixtureTypeEnum::Value > Ifc4::IfcLightFixture::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcLightFixtureTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcLightFixture::setPredefinedType(boost::optional< ::Ifc4::IfcLightFixtureTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcLightFixtureTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcLightFixture::declaration() const { return *((IfcParse::entity*)IFC4_types[524]); }
const IfcParse::entity& Ifc4::IfcLightFixture::Class() { return *((IfcParse::entity*)IFC4_types[524]); }
Ifc4::IfcLightFixture::IfcLightFixture(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcLightFixture::IfcLightFixture(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcLightFixtureTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcLightFixtureTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcLightFixtureType
::Ifc4::IfcLightFixtureTypeEnum::Value Ifc4::IfcLightFixtureType::PredefinedType() const {  return ::Ifc4::IfcLightFixtureTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcLightFixtureType::setPredefinedType(::Ifc4::IfcLightFixtureTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcLightFixtureTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcLightFixtureType::declaration() const { return *((IfcParse::entity*)IFC4_types[525]); }
const IfcParse::entity& Ifc4::IfcLightFixtureType::Class() { return *((IfcParse::entity*)IFC4_types[525]); }
Ifc4::IfcLightFixtureType::IfcLightFixtureType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcLightFixtureType::IfcLightFixtureType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcLightFixtureTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcLightFixtureTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcLightIntensityDistribution
::Ifc4::IfcLightDistributionCurveEnum::Value Ifc4::IfcLightIntensityDistribution::LightDistributionCurve() const {  return ::Ifc4::IfcLightDistributionCurveEnum::FromString(data_.get_attribute_value(0)); }
void Ifc4::IfcLightIntensityDistribution::setLightDistributionCurve(::Ifc4::IfcLightDistributionCurveEnum::Value v) { set_attribute_value(0, EnumerationReference(&::Ifc4::IfcLightDistributionCurveEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcLightDistributionData >::ptr Ifc4::IfcLightIntensityDistribution::DistributionData() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcLightDistributionData >(); }
void Ifc4::IfcLightIntensityDistribution::setDistributionData(aggregate_of< ::Ifc4::IfcLightDistributionData >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcLightIntensityDistribution::declaration() const { return *((IfcParse::entity*)IFC4_types[527]); }
const IfcParse::entity& Ifc4::IfcLightIntensityDistribution::Class() { return *((IfcParse::entity*)IFC4_types[527]); }
Ifc4::IfcLightIntensityDistribution::IfcLightIntensityDistribution(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcLightIntensityDistribution::IfcLightIntensityDistribution(::Ifc4::IfcLightDistributionCurveEnum::Value v1_LightDistributionCurve, aggregate_of< ::Ifc4::IfcLightDistributionData >::ptr v2_DistributionData) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcLightDistributionCurveEnum::Class(),(size_t)v1_LightDistributionCurve)));set_attribute_value(1, (v2_DistributionData)->generalize());; populate_derived(); }

// Function implementations for IfcLightSource
boost::optional< std::string > Ifc4::IfcLightSource::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcLightSource::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
::Ifc4::IfcColourRgb* Ifc4::IfcLightSource::LightColour() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcColourRgb>(true); }
void Ifc4::IfcLightSource::setLightColour(::Ifc4::IfcColourRgb* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
boost::optional< double > Ifc4::IfcLightSource::AmbientIntensity() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcLightSource::setAmbientIntensity(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcLightSource::Intensity() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcLightSource::setIntensity(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcLightSource::declaration() const { return *((IfcParse::entity*)IFC4_types[528]); }
const IfcParse::entity& Ifc4::IfcLightSource::Class() { return *((IfcParse::entity*)IFC4_types[528]); }
Ifc4::IfcLightSource::IfcLightSource(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcLightSource::IfcLightSource(boost::optional< std::string > v1_Name, ::Ifc4::IfcColourRgb* v2_LightColour, boost::optional< double > v3_AmbientIntensity, boost::optional< double > v4_Intensity) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_LightColour ? v2_LightColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_AmbientIntensity) {set_attribute_value(2, (*v3_AmbientIntensity)); } if (v4_Intensity) {set_attribute_value(3, (*v4_Intensity)); }; populate_derived(); }

// Function implementations for IfcLightSourceAmbient


const IfcParse::entity& Ifc4::IfcLightSourceAmbient::declaration() const { return *((IfcParse::entity*)IFC4_types[529]); }
const IfcParse::entity& Ifc4::IfcLightSourceAmbient::Class() { return *((IfcParse::entity*)IFC4_types[529]); }
Ifc4::IfcLightSourceAmbient::IfcLightSourceAmbient(IfcEntityInstanceData&& e) : IfcLightSource(std::move(e)) { }
Ifc4::IfcLightSourceAmbient::IfcLightSourceAmbient(boost::optional< std::string > v1_Name, ::Ifc4::IfcColourRgb* v2_LightColour, boost::optional< double > v3_AmbientIntensity, boost::optional< double > v4_Intensity) : IfcLightSource(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_LightColour ? v2_LightColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_AmbientIntensity) {set_attribute_value(2, (*v3_AmbientIntensity)); } if (v4_Intensity) {set_attribute_value(3, (*v4_Intensity)); }; populate_derived(); }

// Function implementations for IfcLightSourceDirectional
::Ifc4::IfcDirection* Ifc4::IfcLightSourceDirectional::Orientation() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcLightSourceDirectional::setOrientation(::Ifc4::IfcDirection* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcLightSourceDirectional::declaration() const { return *((IfcParse::entity*)IFC4_types[530]); }
const IfcParse::entity& Ifc4::IfcLightSourceDirectional::Class() { return *((IfcParse::entity*)IFC4_types[530]); }
Ifc4::IfcLightSourceDirectional::IfcLightSourceDirectional(IfcEntityInstanceData&& e) : IfcLightSource(std::move(e)) { }
Ifc4::IfcLightSourceDirectional::IfcLightSourceDirectional(boost::optional< std::string > v1_Name, ::Ifc4::IfcColourRgb* v2_LightColour, boost::optional< double > v3_AmbientIntensity, boost::optional< double > v4_Intensity, ::Ifc4::IfcDirection* v5_Orientation) : IfcLightSource(IfcEntityInstanceData(storage_t(5))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_LightColour ? v2_LightColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_AmbientIntensity) {set_attribute_value(2, (*v3_AmbientIntensity)); } if (v4_Intensity) {set_attribute_value(3, (*v4_Intensity)); }set_attribute_value(4, v5_Orientation ? v5_Orientation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcLightSourceGoniometric
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcLightSourceGoniometric::Position() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcLightSourceGoniometric::setPosition(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcColourRgb* Ifc4::IfcLightSourceGoniometric::ColourAppearance() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcColourRgb>(true); }
void Ifc4::IfcLightSourceGoniometric::setColourAppearance(::Ifc4::IfcColourRgb* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcLightSourceGoniometric::ColourTemperature() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcLightSourceGoniometric::setColourTemperature(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
double Ifc4::IfcLightSourceGoniometric::LuminousFlux() const {  double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcLightSourceGoniometric::setLuminousFlux(double v) { set_attribute_value(7, v);if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcLightEmissionSourceEnum::Value Ifc4::IfcLightSourceGoniometric::LightEmissionSource() const {  return ::Ifc4::IfcLightEmissionSourceEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcLightSourceGoniometric::setLightEmissionSource(::Ifc4::IfcLightEmissionSourceEnum::Value v) { set_attribute_value(8, EnumerationReference(&::Ifc4::IfcLightEmissionSourceEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(8); }
::Ifc4::IfcLightDistributionDataSourceSelect* Ifc4::IfcLightSourceGoniometric::LightDistributionDataSource() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcLightDistributionDataSourceSelect>(true); }
void Ifc4::IfcLightSourceGoniometric::setLightDistributionDataSource(::Ifc4::IfcLightDistributionDataSourceSelect* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcLightSourceGoniometric::declaration() const { return *((IfcParse::entity*)IFC4_types[531]); }
const IfcParse::entity& Ifc4::IfcLightSourceGoniometric::Class() { return *((IfcParse::entity*)IFC4_types[531]); }
Ifc4::IfcLightSourceGoniometric::IfcLightSourceGoniometric(IfcEntityInstanceData&& e) : IfcLightSource(std::move(e)) { }
Ifc4::IfcLightSourceGoniometric::IfcLightSourceGoniometric(boost::optional< std::string > v1_Name, ::Ifc4::IfcColourRgb* v2_LightColour, boost::optional< double > v3_AmbientIntensity, boost::optional< double > v4_Intensity, ::Ifc4::IfcAxis2Placement3D* v5_Position, ::Ifc4::IfcColourRgb* v6_ColourAppearance, double v7_ColourTemperature, double v8_LuminousFlux, ::Ifc4::IfcLightEmissionSourceEnum::Value v9_LightEmissionSource, ::Ifc4::IfcLightDistributionDataSourceSelect* v10_LightDistributionDataSource) : IfcLightSource(IfcEntityInstanceData(storage_t(10))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_LightColour ? v2_LightColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_AmbientIntensity) {set_attribute_value(2, (*v3_AmbientIntensity)); } if (v4_Intensity) {set_attribute_value(3, (*v4_Intensity)); }set_attribute_value(4, v5_Position ? v5_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_ColourAppearance ? v6_ColourAppearance->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, (v7_ColourTemperature));set_attribute_value(7, (v8_LuminousFlux));set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcLightEmissionSourceEnum::Class(),(size_t)v9_LightEmissionSource)));set_attribute_value(9, v10_LightDistributionDataSource ? v10_LightDistributionDataSource->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcLightSourcePositional
::Ifc4::IfcCartesianPoint* Ifc4::IfcLightSourcePositional::Position() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcCartesianPoint>(true); }
void Ifc4::IfcLightSourcePositional::setPosition(::Ifc4::IfcCartesianPoint* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
double Ifc4::IfcLightSourcePositional::Radius() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcLightSourcePositional::setRadius(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcLightSourcePositional::ConstantAttenuation() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcLightSourcePositional::setConstantAttenuation(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
double Ifc4::IfcLightSourcePositional::DistanceAttenuation() const {  double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcLightSourcePositional::setDistanceAttenuation(double v) { set_attribute_value(7, v);if constexpr (false)unset_attribute_value(7); }
double Ifc4::IfcLightSourcePositional::QuadricAttenuation() const {  double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcLightSourcePositional::setQuadricAttenuation(double v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcLightSourcePositional::declaration() const { return *((IfcParse::entity*)IFC4_types[532]); }
const IfcParse::entity& Ifc4::IfcLightSourcePositional::Class() { return *((IfcParse::entity*)IFC4_types[532]); }
Ifc4::IfcLightSourcePositional::IfcLightSourcePositional(IfcEntityInstanceData&& e) : IfcLightSource(std::move(e)) { }
Ifc4::IfcLightSourcePositional::IfcLightSourcePositional(boost::optional< std::string > v1_Name, ::Ifc4::IfcColourRgb* v2_LightColour, boost::optional< double > v3_AmbientIntensity, boost::optional< double > v4_Intensity, ::Ifc4::IfcCartesianPoint* v5_Position, double v6_Radius, double v7_ConstantAttenuation, double v8_DistanceAttenuation, double v9_QuadricAttenuation) : IfcLightSource(IfcEntityInstanceData(storage_t(9))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_LightColour ? v2_LightColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_AmbientIntensity) {set_attribute_value(2, (*v3_AmbientIntensity)); } if (v4_Intensity) {set_attribute_value(3, (*v4_Intensity)); }set_attribute_value(4, v5_Position ? v5_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_Radius));set_attribute_value(6, (v7_ConstantAttenuation));set_attribute_value(7, (v8_DistanceAttenuation));set_attribute_value(8, (v9_QuadricAttenuation));; populate_derived(); }

// Function implementations for IfcLightSourceSpot
::Ifc4::IfcDirection* Ifc4::IfcLightSourceSpot::Orientation() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcLightSourceSpot::setOrientation(::Ifc4::IfcDirection* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }
boost::optional< double > Ifc4::IfcLightSourceSpot::ConcentrationExponent() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcLightSourceSpot::setConcentrationExponent(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
double Ifc4::IfcLightSourceSpot::SpreadAngle() const {  double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcLightSourceSpot::setSpreadAngle(double v) { set_attribute_value(11, v);if constexpr (false)unset_attribute_value(11); }
double Ifc4::IfcLightSourceSpot::BeamWidthAngle() const {  double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcLightSourceSpot::setBeamWidthAngle(double v) { set_attribute_value(12, v);if constexpr (false)unset_attribute_value(12); }


const IfcParse::entity& Ifc4::IfcLightSourceSpot::declaration() const { return *((IfcParse::entity*)IFC4_types[533]); }
const IfcParse::entity& Ifc4::IfcLightSourceSpot::Class() { return *((IfcParse::entity*)IFC4_types[533]); }
Ifc4::IfcLightSourceSpot::IfcLightSourceSpot(IfcEntityInstanceData&& e) : IfcLightSourcePositional(std::move(e)) { }
Ifc4::IfcLightSourceSpot::IfcLightSourceSpot(boost::optional< std::string > v1_Name, ::Ifc4::IfcColourRgb* v2_LightColour, boost::optional< double > v3_AmbientIntensity, boost::optional< double > v4_Intensity, ::Ifc4::IfcCartesianPoint* v5_Position, double v6_Radius, double v7_ConstantAttenuation, double v8_DistanceAttenuation, double v9_QuadricAttenuation, ::Ifc4::IfcDirection* v10_Orientation, boost::optional< double > v11_ConcentrationExponent, double v12_SpreadAngle, double v13_BeamWidthAngle) : IfcLightSourcePositional(IfcEntityInstanceData(storage_t(13))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_LightColour ? v2_LightColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_AmbientIntensity) {set_attribute_value(2, (*v3_AmbientIntensity)); } if (v4_Intensity) {set_attribute_value(3, (*v4_Intensity)); }set_attribute_value(4, v5_Position ? v5_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_Radius));set_attribute_value(6, (v7_ConstantAttenuation));set_attribute_value(7, (v8_DistanceAttenuation));set_attribute_value(8, (v9_QuadricAttenuation));set_attribute_value(9, v10_Orientation ? v10_Orientation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v11_ConcentrationExponent) {set_attribute_value(10, (*v11_ConcentrationExponent)); }set_attribute_value(11, (v12_SpreadAngle));set_attribute_value(12, (v13_BeamWidthAngle));; populate_derived(); }

// Function implementations for IfcLine
::Ifc4::IfcCartesianPoint* Ifc4::IfcLine::Pnt() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCartesianPoint>(true); }
void Ifc4::IfcLine::setPnt(::Ifc4::IfcCartesianPoint* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcVector* Ifc4::IfcLine::Dir() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcVector>(true); }
void Ifc4::IfcLine::setDir(::Ifc4::IfcVector* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcLine::declaration() const { return *((IfcParse::entity*)IFC4_types[534]); }
const IfcParse::entity& Ifc4::IfcLine::Class() { return *((IfcParse::entity*)IFC4_types[534]); }
Ifc4::IfcLine::IfcLine(IfcEntityInstanceData&& e) : IfcCurve(std::move(e)) { }
Ifc4::IfcLine::IfcLine(::Ifc4::IfcCartesianPoint* v1_Pnt, ::Ifc4::IfcVector* v2_Dir) : IfcCurve(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Pnt ? v1_Pnt->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Dir ? v2_Dir->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcLocalPlacement
::Ifc4::IfcObjectPlacement* Ifc4::IfcLocalPlacement::PlacementRelTo() const { if(data_.get_attribute_value(0).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcObjectPlacement>(true); }
void Ifc4::IfcLocalPlacement::setPlacementRelTo(::Ifc4::IfcObjectPlacement* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcAxis2Placement* Ifc4::IfcLocalPlacement::RelativePlacement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcAxis2Placement>(true); }
void Ifc4::IfcLocalPlacement::setRelativePlacement(::Ifc4::IfcAxis2Placement* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcLocalPlacement::declaration() const { return *((IfcParse::entity*)IFC4_types[541]); }
const IfcParse::entity& Ifc4::IfcLocalPlacement::Class() { return *((IfcParse::entity*)IFC4_types[541]); }
Ifc4::IfcLocalPlacement::IfcLocalPlacement(IfcEntityInstanceData&& e) : IfcObjectPlacement(std::move(e)) { }
Ifc4::IfcLocalPlacement::IfcLocalPlacement(::Ifc4::IfcObjectPlacement* v1_PlacementRelTo, ::Ifc4::IfcAxis2Placement* v2_RelativePlacement) : IfcObjectPlacement(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_PlacementRelTo ? v1_PlacementRelTo->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_RelativePlacement ? v2_RelativePlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcLoop


const IfcParse::entity& Ifc4::IfcLoop::declaration() const { return *((IfcParse::entity*)IFC4_types[544]); }
const IfcParse::entity& Ifc4::IfcLoop::Class() { return *((IfcParse::entity*)IFC4_types[544]); }
Ifc4::IfcLoop::IfcLoop(IfcEntityInstanceData&& e) : IfcTopologicalRepresentationItem(std::move(e)) { }
Ifc4::IfcLoop::IfcLoop() : IfcTopologicalRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcManifoldSolidBrep
::Ifc4::IfcClosedShell* Ifc4::IfcManifoldSolidBrep::Outer() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcClosedShell>(true); }
void Ifc4::IfcManifoldSolidBrep::setOuter(::Ifc4::IfcClosedShell* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcManifoldSolidBrep::declaration() const { return *((IfcParse::entity*)IFC4_types[551]); }
const IfcParse::entity& Ifc4::IfcManifoldSolidBrep::Class() { return *((IfcParse::entity*)IFC4_types[551]); }
Ifc4::IfcManifoldSolidBrep::IfcManifoldSolidBrep(IfcEntityInstanceData&& e) : IfcSolidModel(std::move(e)) { }
Ifc4::IfcManifoldSolidBrep::IfcManifoldSolidBrep(::Ifc4::IfcClosedShell* v1_Outer) : IfcSolidModel(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Outer ? v1_Outer->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcMapConversion
double Ifc4::IfcMapConversion::Eastings() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcMapConversion::setEastings(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcMapConversion::Northings() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcMapConversion::setNorthings(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcMapConversion::OrthogonalHeight() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcMapConversion::setOrthogonalHeight(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
boost::optional< double > Ifc4::IfcMapConversion::XAxisAbscissa() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcMapConversion::setXAxisAbscissa(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< double > Ifc4::IfcMapConversion::XAxisOrdinate() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcMapConversion::setXAxisOrdinate(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< double > Ifc4::IfcMapConversion::Scale() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcMapConversion::setScale(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcMapConversion::declaration() const { return *((IfcParse::entity*)IFC4_types[552]); }
const IfcParse::entity& Ifc4::IfcMapConversion::Class() { return *((IfcParse::entity*)IFC4_types[552]); }
Ifc4::IfcMapConversion::IfcMapConversion(IfcEntityInstanceData&& e) : IfcCoordinateOperation(std::move(e)) { }
Ifc4::IfcMapConversion::IfcMapConversion(::Ifc4::IfcCoordinateReferenceSystemSelect* v1_SourceCRS, ::Ifc4::IfcCoordinateReferenceSystem* v2_TargetCRS, double v3_Eastings, double v4_Northings, double v5_OrthogonalHeight, boost::optional< double > v6_XAxisAbscissa, boost::optional< double > v7_XAxisOrdinate, boost::optional< double > v8_Scale) : IfcCoordinateOperation(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, v1_SourceCRS ? v1_SourceCRS->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_TargetCRS ? v2_TargetCRS->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, (v3_Eastings));set_attribute_value(3, (v4_Northings));set_attribute_value(4, (v5_OrthogonalHeight)); if (v6_XAxisAbscissa) {set_attribute_value(5, (*v6_XAxisAbscissa)); } if (v7_XAxisOrdinate) {set_attribute_value(6, (*v7_XAxisOrdinate)); } if (v8_Scale) {set_attribute_value(7, (*v8_Scale)); }; populate_derived(); }

// Function implementations for IfcMappedItem
::Ifc4::IfcRepresentationMap* Ifc4::IfcMappedItem::MappingSource() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcRepresentationMap>(true); }
void Ifc4::IfcMappedItem::setMappingSource(::Ifc4::IfcRepresentationMap* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcCartesianTransformationOperator* Ifc4::IfcMappedItem::MappingTarget() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcCartesianTransformationOperator>(true); }
void Ifc4::IfcMappedItem::setMappingTarget(::Ifc4::IfcCartesianTransformationOperator* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcMappedItem::declaration() const { return *((IfcParse::entity*)IFC4_types[553]); }
const IfcParse::entity& Ifc4::IfcMappedItem::Class() { return *((IfcParse::entity*)IFC4_types[553]); }
Ifc4::IfcMappedItem::IfcMappedItem(IfcEntityInstanceData&& e) : IfcRepresentationItem(std::move(e)) { }
Ifc4::IfcMappedItem::IfcMappedItem(::Ifc4::IfcRepresentationMap* v1_MappingSource, ::Ifc4::IfcCartesianTransformationOperator* v2_MappingTarget) : IfcRepresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_MappingSource ? v1_MappingSource->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_MappingTarget ? v2_MappingTarget->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcMaterial
std::string Ifc4::IfcMaterial::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcMaterial::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcMaterial::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcMaterial::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcMaterial::Category() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcMaterial::setCategory(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }

::Ifc4::IfcMaterialDefinitionRepresentation::list::ptr Ifc4::IfcMaterial::HasRepresentation() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[563], 3)->as<IfcMaterialDefinitionRepresentation>(); }
::Ifc4::IfcMaterialRelationship::list::ptr Ifc4::IfcMaterial::IsRelatedWith() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[575], 3)->as<IfcMaterialRelationship>(); }
::Ifc4::IfcMaterialRelationship::list::ptr Ifc4::IfcMaterial::RelatesTo() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[575], 2)->as<IfcMaterialRelationship>(); }

const IfcParse::entity& Ifc4::IfcMaterial::declaration() const { return *((IfcParse::entity*)IFC4_types[558]); }
const IfcParse::entity& Ifc4::IfcMaterial::Class() { return *((IfcParse::entity*)IFC4_types[558]); }
Ifc4::IfcMaterial::IfcMaterial(IfcEntityInstanceData&& e) : IfcMaterialDefinition(std::move(e)) { }
Ifc4::IfcMaterial::IfcMaterial(std::string v1_Name, boost::optional< std::string > v2_Description, boost::optional< std::string > v3_Category) : IfcMaterialDefinition(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_Category) {set_attribute_value(2, (*v3_Category)); }; populate_derived(); }

// Function implementations for IfcMaterialClassificationRelationship
aggregate_of< ::Ifc4::IfcClassificationSelect >::ptr Ifc4::IfcMaterialClassificationRelationship::MaterialClassifications() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcClassificationSelect >(); }
void Ifc4::IfcMaterialClassificationRelationship::setMaterialClassifications(aggregate_of< ::Ifc4::IfcClassificationSelect >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcMaterial* Ifc4::IfcMaterialClassificationRelationship::ClassifiedMaterial() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcMaterial>(true); }
void Ifc4::IfcMaterialClassificationRelationship::setClassifiedMaterial(::Ifc4::IfcMaterial* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcMaterialClassificationRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[559]); }
const IfcParse::entity& Ifc4::IfcMaterialClassificationRelationship::Class() { return *((IfcParse::entity*)IFC4_types[559]); }
Ifc4::IfcMaterialClassificationRelationship::IfcMaterialClassificationRelationship(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcMaterialClassificationRelationship::IfcMaterialClassificationRelationship(aggregate_of< ::Ifc4::IfcClassificationSelect >::ptr v1_MaterialClassifications, ::Ifc4::IfcMaterial* v2_ClassifiedMaterial) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_MaterialClassifications)->generalize());set_attribute_value(1, v2_ClassifiedMaterial ? v2_ClassifiedMaterial->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcMaterialConstituent
boost::optional< std::string > Ifc4::IfcMaterialConstituent::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcMaterialConstituent::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcMaterialConstituent::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcMaterialConstituent::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
::Ifc4::IfcMaterial* Ifc4::IfcMaterialConstituent::Material() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcMaterial>(true); }
void Ifc4::IfcMaterialConstituent::setMaterial(::Ifc4::IfcMaterial* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
boost::optional< double > Ifc4::IfcMaterialConstituent::Fraction() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcMaterialConstituent::setFraction(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcMaterialConstituent::Category() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcMaterialConstituent::setCategory(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }

::Ifc4::IfcMaterialConstituentSet::list::ptr Ifc4::IfcMaterialConstituent::ToMaterialConstituentSet() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[561], 2)->as<IfcMaterialConstituentSet>(); }

const IfcParse::entity& Ifc4::IfcMaterialConstituent::declaration() const { return *((IfcParse::entity*)IFC4_types[560]); }
const IfcParse::entity& Ifc4::IfcMaterialConstituent::Class() { return *((IfcParse::entity*)IFC4_types[560]); }
Ifc4::IfcMaterialConstituent::IfcMaterialConstituent(IfcEntityInstanceData&& e) : IfcMaterialDefinition(std::move(e)) { }
Ifc4::IfcMaterialConstituent::IfcMaterialConstituent(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcMaterial* v3_Material, boost::optional< double > v4_Fraction, boost::optional< std::string > v5_Category) : IfcMaterialDefinition(IfcEntityInstanceData(storage_t(5))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Material ? v3_Material->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_Fraction) {set_attribute_value(3, (*v4_Fraction)); } if (v5_Category) {set_attribute_value(4, (*v5_Category)); }; populate_derived(); }

// Function implementations for IfcMaterialConstituentSet
boost::optional< std::string > Ifc4::IfcMaterialConstituentSet::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcMaterialConstituentSet::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcMaterialConstituentSet::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcMaterialConstituentSet::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< aggregate_of< ::Ifc4::IfcMaterialConstituent >::ptr > Ifc4::IfcMaterialConstituentSet::MaterialConstituents() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcMaterialConstituent >(); }
void Ifc4::IfcMaterialConstituentSet::setMaterialConstituents(boost::optional< aggregate_of< ::Ifc4::IfcMaterialConstituent >::ptr > v) { if (v) {set_attribute_value(2, (*v)->generalize());} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcMaterialConstituentSet::declaration() const { return *((IfcParse::entity*)IFC4_types[561]); }
const IfcParse::entity& Ifc4::IfcMaterialConstituentSet::Class() { return *((IfcParse::entity*)IFC4_types[561]); }
Ifc4::IfcMaterialConstituentSet::IfcMaterialConstituentSet(IfcEntityInstanceData&& e) : IfcMaterialDefinition(std::move(e)) { }
Ifc4::IfcMaterialConstituentSet::IfcMaterialConstituentSet(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, boost::optional< aggregate_of< ::Ifc4::IfcMaterialConstituent >::ptr > v3_MaterialConstituents) : IfcMaterialDefinition(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_MaterialConstituents) {set_attribute_value(2, (*v3_MaterialConstituents)->generalize()); }; populate_derived(); }

// Function implementations for IfcMaterialDefinition

::Ifc4::IfcRelAssociatesMaterial::list::ptr Ifc4::IfcMaterialDefinition::AssociatedTo() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[812], 5)->as<IfcRelAssociatesMaterial>(); }
::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcMaterialDefinition::HasExternalReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }
::Ifc4::IfcMaterialProperties::list::ptr Ifc4::IfcMaterialDefinition::HasProperties() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[574], 3)->as<IfcMaterialProperties>(); }

const IfcParse::entity& Ifc4::IfcMaterialDefinition::declaration() const { return *((IfcParse::entity*)IFC4_types[562]); }
const IfcParse::entity& Ifc4::IfcMaterialDefinition::Class() { return *((IfcParse::entity*)IFC4_types[562]); }
Ifc4::IfcMaterialDefinition::IfcMaterialDefinition(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcMaterialDefinition::IfcMaterialDefinition() : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcMaterialDefinitionRepresentation
::Ifc4::IfcMaterial* Ifc4::IfcMaterialDefinitionRepresentation::RepresentedMaterial() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcMaterial>(true); }
void Ifc4::IfcMaterialDefinitionRepresentation::setRepresentedMaterial(::Ifc4::IfcMaterial* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcMaterialDefinitionRepresentation::declaration() const { return *((IfcParse::entity*)IFC4_types[563]); }
const IfcParse::entity& Ifc4::IfcMaterialDefinitionRepresentation::Class() { return *((IfcParse::entity*)IFC4_types[563]); }
Ifc4::IfcMaterialDefinitionRepresentation::IfcMaterialDefinitionRepresentation(IfcEntityInstanceData&& e) : IfcProductRepresentation(std::move(e)) { }
Ifc4::IfcMaterialDefinitionRepresentation::IfcMaterialDefinitionRepresentation(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcRepresentation >::ptr v3_Representations, ::Ifc4::IfcMaterial* v4_RepresentedMaterial) : IfcProductRepresentation(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_Representations)->generalize());set_attribute_value(3, v4_RepresentedMaterial ? v4_RepresentedMaterial->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcMaterialLayer
::Ifc4::IfcMaterial* Ifc4::IfcMaterialLayer::Material() const { if(data_.get_attribute_value(0).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcMaterial>(true); }
void Ifc4::IfcMaterialLayer::setMaterial(::Ifc4::IfcMaterial* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcMaterialLayer::LayerThickness() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcMaterialLayer::setLayerThickness(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< boost::logic::tribool > Ifc4::IfcMaterialLayer::IsVentilated() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } boost::logic::tribool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcMaterialLayer::setIsVentilated(boost::optional< boost::logic::tribool > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::string > Ifc4::IfcMaterialLayer::Name() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcMaterialLayer::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcMaterialLayer::Description() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcMaterialLayer::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcMaterialLayer::Category() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcMaterialLayer::setCategory(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< int > Ifc4::IfcMaterialLayer::Priority() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } int v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcMaterialLayer::setPriority(boost::optional< int > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }

::Ifc4::IfcMaterialLayerSet::list::ptr Ifc4::IfcMaterialLayer::ToMaterialLayerSet() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[565], 0)->as<IfcMaterialLayerSet>(); }

const IfcParse::entity& Ifc4::IfcMaterialLayer::declaration() const { return *((IfcParse::entity*)IFC4_types[564]); }
const IfcParse::entity& Ifc4::IfcMaterialLayer::Class() { return *((IfcParse::entity*)IFC4_types[564]); }
Ifc4::IfcMaterialLayer::IfcMaterialLayer(IfcEntityInstanceData&& e) : IfcMaterialDefinition(std::move(e)) { }
Ifc4::IfcMaterialLayer::IfcMaterialLayer(::Ifc4::IfcMaterial* v1_Material, double v2_LayerThickness, boost::optional< boost::logic::tribool > v3_IsVentilated, boost::optional< std::string > v4_Name, boost::optional< std::string > v5_Description, boost::optional< std::string > v6_Category, boost::optional< int > v7_Priority) : IfcMaterialDefinition(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, v1_Material ? v1_Material->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_LayerThickness)); if (v3_IsVentilated) {set_attribute_value(2, (*v3_IsVentilated)); } if (v4_Name) {set_attribute_value(3, (*v4_Name)); } if (v5_Description) {set_attribute_value(4, (*v5_Description)); } if (v6_Category) {set_attribute_value(5, (*v6_Category)); } if (v7_Priority) {set_attribute_value(6, (*v7_Priority)); }; populate_derived(); }

// Function implementations for IfcMaterialLayerSet
aggregate_of< ::Ifc4::IfcMaterialLayer >::ptr Ifc4::IfcMaterialLayerSet::MaterialLayers() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcMaterialLayer >(); }
void Ifc4::IfcMaterialLayerSet::setMaterialLayers(aggregate_of< ::Ifc4::IfcMaterialLayer >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcMaterialLayerSet::LayerSetName() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcMaterialLayerSet::setLayerSetName(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcMaterialLayerSet::Description() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcMaterialLayerSet::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcMaterialLayerSet::declaration() const { return *((IfcParse::entity*)IFC4_types[565]); }
const IfcParse::entity& Ifc4::IfcMaterialLayerSet::Class() { return *((IfcParse::entity*)IFC4_types[565]); }
Ifc4::IfcMaterialLayerSet::IfcMaterialLayerSet(IfcEntityInstanceData&& e) : IfcMaterialDefinition(std::move(e)) { }
Ifc4::IfcMaterialLayerSet::IfcMaterialLayerSet(aggregate_of< ::Ifc4::IfcMaterialLayer >::ptr v1_MaterialLayers, boost::optional< std::string > v2_LayerSetName, boost::optional< std::string > v3_Description) : IfcMaterialDefinition(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_MaterialLayers)->generalize()); if (v2_LayerSetName) {set_attribute_value(1, (*v2_LayerSetName)); } if (v3_Description) {set_attribute_value(2, (*v3_Description)); }; populate_derived(); }

// Function implementations for IfcMaterialLayerSetUsage
::Ifc4::IfcMaterialLayerSet* Ifc4::IfcMaterialLayerSetUsage::ForLayerSet() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcMaterialLayerSet>(true); }
void Ifc4::IfcMaterialLayerSetUsage::setForLayerSet(::Ifc4::IfcMaterialLayerSet* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcLayerSetDirectionEnum::Value Ifc4::IfcMaterialLayerSetUsage::LayerSetDirection() const {  return ::Ifc4::IfcLayerSetDirectionEnum::FromString(data_.get_attribute_value(1)); }
void Ifc4::IfcMaterialLayerSetUsage::setLayerSetDirection(::Ifc4::IfcLayerSetDirectionEnum::Value v) { set_attribute_value(1, EnumerationReference(&::Ifc4::IfcLayerSetDirectionEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcDirectionSenseEnum::Value Ifc4::IfcMaterialLayerSetUsage::DirectionSense() const {  return ::Ifc4::IfcDirectionSenseEnum::FromString(data_.get_attribute_value(2)); }
void Ifc4::IfcMaterialLayerSetUsage::setDirectionSense(::Ifc4::IfcDirectionSenseEnum::Value v) { set_attribute_value(2, EnumerationReference(&::Ifc4::IfcDirectionSenseEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcMaterialLayerSetUsage::OffsetFromReferenceLine() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcMaterialLayerSetUsage::setOffsetFromReferenceLine(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< double > Ifc4::IfcMaterialLayerSetUsage::ReferenceExtent() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcMaterialLayerSetUsage::setReferenceExtent(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcMaterialLayerSetUsage::declaration() const { return *((IfcParse::entity*)IFC4_types[566]); }
const IfcParse::entity& Ifc4::IfcMaterialLayerSetUsage::Class() { return *((IfcParse::entity*)IFC4_types[566]); }
Ifc4::IfcMaterialLayerSetUsage::IfcMaterialLayerSetUsage(IfcEntityInstanceData&& e) : IfcMaterialUsageDefinition(std::move(e)) { }
Ifc4::IfcMaterialLayerSetUsage::IfcMaterialLayerSetUsage(::Ifc4::IfcMaterialLayerSet* v1_ForLayerSet, ::Ifc4::IfcLayerSetDirectionEnum::Value v2_LayerSetDirection, ::Ifc4::IfcDirectionSenseEnum::Value v3_DirectionSense, double v4_OffsetFromReferenceLine, boost::optional< double > v5_ReferenceExtent) : IfcMaterialUsageDefinition(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_ForLayerSet ? v1_ForLayerSet->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcLayerSetDirectionEnum::Class(),(size_t)v2_LayerSetDirection)));set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcDirectionSenseEnum::Class(),(size_t)v3_DirectionSense)));set_attribute_value(3, (v4_OffsetFromReferenceLine)); if (v5_ReferenceExtent) {set_attribute_value(4, (*v5_ReferenceExtent)); }; populate_derived(); }

// Function implementations for IfcMaterialLayerWithOffsets
::Ifc4::IfcLayerSetDirectionEnum::Value Ifc4::IfcMaterialLayerWithOffsets::OffsetDirection() const {  return ::Ifc4::IfcLayerSetDirectionEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcMaterialLayerWithOffsets::setOffsetDirection(::Ifc4::IfcLayerSetDirectionEnum::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcLayerSetDirectionEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }
std::vector< double > /*[1:2]*/ Ifc4::IfcMaterialLayerWithOffsets::OffsetValues() const {  std::vector< double > /*[1:2]*/ v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcMaterialLayerWithOffsets::setOffsetValues(std::vector< double > /*[1:2]*/ v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcMaterialLayerWithOffsets::declaration() const { return *((IfcParse::entity*)IFC4_types[567]); }
const IfcParse::entity& Ifc4::IfcMaterialLayerWithOffsets::Class() { return *((IfcParse::entity*)IFC4_types[567]); }
Ifc4::IfcMaterialLayerWithOffsets::IfcMaterialLayerWithOffsets(IfcEntityInstanceData&& e) : IfcMaterialLayer(std::move(e)) { }
Ifc4::IfcMaterialLayerWithOffsets::IfcMaterialLayerWithOffsets(::Ifc4::IfcMaterial* v1_Material, double v2_LayerThickness, boost::optional< boost::logic::tribool > v3_IsVentilated, boost::optional< std::string > v4_Name, boost::optional< std::string > v5_Description, boost::optional< std::string > v6_Category, boost::optional< int > v7_Priority, ::Ifc4::IfcLayerSetDirectionEnum::Value v8_OffsetDirection, std::vector< double > /*[1:2]*/ v9_OffsetValues) : IfcMaterialLayer(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, v1_Material ? v1_Material->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_LayerThickness)); if (v3_IsVentilated) {set_attribute_value(2, (*v3_IsVentilated)); } if (v4_Name) {set_attribute_value(3, (*v4_Name)); } if (v5_Description) {set_attribute_value(4, (*v5_Description)); } if (v6_Category) {set_attribute_value(5, (*v6_Category)); } if (v7_Priority) {set_attribute_value(6, (*v7_Priority)); }set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcLayerSetDirectionEnum::Class(),(size_t)v8_OffsetDirection)));set_attribute_value(8, (v9_OffsetValues));; populate_derived(); }

// Function implementations for IfcMaterialList
aggregate_of< ::Ifc4::IfcMaterial >::ptr Ifc4::IfcMaterialList::Materials() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcMaterial >(); }
void Ifc4::IfcMaterialList::setMaterials(aggregate_of< ::Ifc4::IfcMaterial >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcMaterialList::declaration() const { return *((IfcParse::entity*)IFC4_types[568]); }
const IfcParse::entity& Ifc4::IfcMaterialList::Class() { return *((IfcParse::entity*)IFC4_types[568]); }
Ifc4::IfcMaterialList::IfcMaterialList(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcMaterialList::IfcMaterialList(aggregate_of< ::Ifc4::IfcMaterial >::ptr v1_Materials) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Materials)->generalize());; populate_derived(); }

// Function implementations for IfcMaterialProfile
boost::optional< std::string > Ifc4::IfcMaterialProfile::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcMaterialProfile::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcMaterialProfile::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcMaterialProfile::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
::Ifc4::IfcMaterial* Ifc4::IfcMaterialProfile::Material() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcMaterial>(true); }
void Ifc4::IfcMaterialProfile::setMaterial(::Ifc4::IfcMaterial* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcProfileDef* Ifc4::IfcMaterialProfile::Profile() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcMaterialProfile::setProfile(::Ifc4::IfcProfileDef* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< int > Ifc4::IfcMaterialProfile::Priority() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } int v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcMaterialProfile::setPriority(boost::optional< int > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcMaterialProfile::Category() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcMaterialProfile::setCategory(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }

::Ifc4::IfcMaterialProfileSet::list::ptr Ifc4::IfcMaterialProfile::ToMaterialProfileSet() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[570], 2)->as<IfcMaterialProfileSet>(); }

const IfcParse::entity& Ifc4::IfcMaterialProfile::declaration() const { return *((IfcParse::entity*)IFC4_types[569]); }
const IfcParse::entity& Ifc4::IfcMaterialProfile::Class() { return *((IfcParse::entity*)IFC4_types[569]); }
Ifc4::IfcMaterialProfile::IfcMaterialProfile(IfcEntityInstanceData&& e) : IfcMaterialDefinition(std::move(e)) { }
Ifc4::IfcMaterialProfile::IfcMaterialProfile(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcMaterial* v3_Material, ::Ifc4::IfcProfileDef* v4_Profile, boost::optional< int > v5_Priority, boost::optional< std::string > v6_Category) : IfcMaterialDefinition(IfcEntityInstanceData(storage_t(6))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Material ? v3_Material->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_Profile ? v4_Profile->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Priority) {set_attribute_value(4, (*v5_Priority)); } if (v6_Category) {set_attribute_value(5, (*v6_Category)); }; populate_derived(); }

// Function implementations for IfcMaterialProfileSet
boost::optional< std::string > Ifc4::IfcMaterialProfileSet::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcMaterialProfileSet::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcMaterialProfileSet::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcMaterialProfileSet::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
aggregate_of< ::Ifc4::IfcMaterialProfile >::ptr Ifc4::IfcMaterialProfileSet::MaterialProfiles() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcMaterialProfile >(); }
void Ifc4::IfcMaterialProfileSet::setMaterialProfiles(aggregate_of< ::Ifc4::IfcMaterialProfile >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcCompositeProfileDef* Ifc4::IfcMaterialProfileSet::CompositeProfile() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcCompositeProfileDef>(true); }
void Ifc4::IfcMaterialProfileSet::setCompositeProfile(::Ifc4::IfcCompositeProfileDef* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcMaterialProfileSet::declaration() const { return *((IfcParse::entity*)IFC4_types[570]); }
const IfcParse::entity& Ifc4::IfcMaterialProfileSet::Class() { return *((IfcParse::entity*)IFC4_types[570]); }
Ifc4::IfcMaterialProfileSet::IfcMaterialProfileSet(IfcEntityInstanceData&& e) : IfcMaterialDefinition(std::move(e)) { }
Ifc4::IfcMaterialProfileSet::IfcMaterialProfileSet(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcMaterialProfile >::ptr v3_MaterialProfiles, ::Ifc4::IfcCompositeProfileDef* v4_CompositeProfile) : IfcMaterialDefinition(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_MaterialProfiles)->generalize());set_attribute_value(3, v4_CompositeProfile ? v4_CompositeProfile->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcMaterialProfileSetUsage
::Ifc4::IfcMaterialProfileSet* Ifc4::IfcMaterialProfileSetUsage::ForProfileSet() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcMaterialProfileSet>(true); }
void Ifc4::IfcMaterialProfileSetUsage::setForProfileSet(::Ifc4::IfcMaterialProfileSet* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
boost::optional< int > Ifc4::IfcMaterialProfileSetUsage::CardinalPoint() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } int v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcMaterialProfileSetUsage::setCardinalPoint(boost::optional< int > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< double > Ifc4::IfcMaterialProfileSetUsage::ReferenceExtent() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcMaterialProfileSetUsage::setReferenceExtent(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcMaterialProfileSetUsage::declaration() const { return *((IfcParse::entity*)IFC4_types[571]); }
const IfcParse::entity& Ifc4::IfcMaterialProfileSetUsage::Class() { return *((IfcParse::entity*)IFC4_types[571]); }
Ifc4::IfcMaterialProfileSetUsage::IfcMaterialProfileSetUsage(IfcEntityInstanceData&& e) : IfcMaterialUsageDefinition(std::move(e)) { }
Ifc4::IfcMaterialProfileSetUsage::IfcMaterialProfileSetUsage(::Ifc4::IfcMaterialProfileSet* v1_ForProfileSet, boost::optional< int > v2_CardinalPoint, boost::optional< double > v3_ReferenceExtent) : IfcMaterialUsageDefinition(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_ForProfileSet ? v1_ForProfileSet->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_CardinalPoint) {set_attribute_value(1, (*v2_CardinalPoint)); } if (v3_ReferenceExtent) {set_attribute_value(2, (*v3_ReferenceExtent)); }; populate_derived(); }

// Function implementations for IfcMaterialProfileSetUsageTapering
::Ifc4::IfcMaterialProfileSet* Ifc4::IfcMaterialProfileSetUsageTapering::ForProfileEndSet() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcMaterialProfileSet>(true); }
void Ifc4::IfcMaterialProfileSetUsageTapering::setForProfileEndSet(::Ifc4::IfcMaterialProfileSet* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< int > Ifc4::IfcMaterialProfileSetUsageTapering::CardinalEndPoint() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } int v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcMaterialProfileSetUsageTapering::setCardinalEndPoint(boost::optional< int > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcMaterialProfileSetUsageTapering::declaration() const { return *((IfcParse::entity*)IFC4_types[572]); }
const IfcParse::entity& Ifc4::IfcMaterialProfileSetUsageTapering::Class() { return *((IfcParse::entity*)IFC4_types[572]); }
Ifc4::IfcMaterialProfileSetUsageTapering::IfcMaterialProfileSetUsageTapering(IfcEntityInstanceData&& e) : IfcMaterialProfileSetUsage(std::move(e)) { }
Ifc4::IfcMaterialProfileSetUsageTapering::IfcMaterialProfileSetUsageTapering(::Ifc4::IfcMaterialProfileSet* v1_ForProfileSet, boost::optional< int > v2_CardinalPoint, boost::optional< double > v3_ReferenceExtent, ::Ifc4::IfcMaterialProfileSet* v4_ForProfileEndSet, boost::optional< int > v5_CardinalEndPoint) : IfcMaterialProfileSetUsage(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_ForProfileSet ? v1_ForProfileSet->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_CardinalPoint) {set_attribute_value(1, (*v2_CardinalPoint)); } if (v3_ReferenceExtent) {set_attribute_value(2, (*v3_ReferenceExtent)); }set_attribute_value(3, v4_ForProfileEndSet ? v4_ForProfileEndSet->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_CardinalEndPoint) {set_attribute_value(4, (*v5_CardinalEndPoint)); }; populate_derived(); }

// Function implementations for IfcMaterialProfileWithOffsets
std::vector< double > /*[1:2]*/ Ifc4::IfcMaterialProfileWithOffsets::OffsetValues() const {  std::vector< double > /*[1:2]*/ v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcMaterialProfileWithOffsets::setOffsetValues(std::vector< double > /*[1:2]*/ v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcMaterialProfileWithOffsets::declaration() const { return *((IfcParse::entity*)IFC4_types[573]); }
const IfcParse::entity& Ifc4::IfcMaterialProfileWithOffsets::Class() { return *((IfcParse::entity*)IFC4_types[573]); }
Ifc4::IfcMaterialProfileWithOffsets::IfcMaterialProfileWithOffsets(IfcEntityInstanceData&& e) : IfcMaterialProfile(std::move(e)) { }
Ifc4::IfcMaterialProfileWithOffsets::IfcMaterialProfileWithOffsets(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcMaterial* v3_Material, ::Ifc4::IfcProfileDef* v4_Profile, boost::optional< int > v5_Priority, boost::optional< std::string > v6_Category, std::vector< double > /*[1:2]*/ v7_OffsetValues) : IfcMaterialProfile(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Material ? v3_Material->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_Profile ? v4_Profile->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Priority) {set_attribute_value(4, (*v5_Priority)); } if (v6_Category) {set_attribute_value(5, (*v6_Category)); }set_attribute_value(6, (v7_OffsetValues));; populate_derived(); }

// Function implementations for IfcMaterialProperties
::Ifc4::IfcMaterialDefinition* Ifc4::IfcMaterialProperties::Material() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcMaterialDefinition>(true); }
void Ifc4::IfcMaterialProperties::setMaterial(::Ifc4::IfcMaterialDefinition* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcMaterialProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[574]); }
const IfcParse::entity& Ifc4::IfcMaterialProperties::Class() { return *((IfcParse::entity*)IFC4_types[574]); }
Ifc4::IfcMaterialProperties::IfcMaterialProperties(IfcEntityInstanceData&& e) : IfcExtendedProperties(std::move(e)) { }
Ifc4::IfcMaterialProperties::IfcMaterialProperties(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcProperty >::ptr v3_Properties, ::Ifc4::IfcMaterialDefinition* v4_Material) : IfcExtendedProperties(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_Properties)->generalize());set_attribute_value(3, v4_Material ? v4_Material->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcMaterialRelationship
::Ifc4::IfcMaterial* Ifc4::IfcMaterialRelationship::RelatingMaterial() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcMaterial>(true); }
void Ifc4::IfcMaterialRelationship::setRelatingMaterial(::Ifc4::IfcMaterial* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
aggregate_of< ::Ifc4::IfcMaterial >::ptr Ifc4::IfcMaterialRelationship::RelatedMaterials() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcMaterial >(); }
void Ifc4::IfcMaterialRelationship::setRelatedMaterials(aggregate_of< ::Ifc4::IfcMaterial >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcMaterialRelationship::Expression() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcMaterialRelationship::setExpression(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcMaterialRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[575]); }
const IfcParse::entity& Ifc4::IfcMaterialRelationship::Class() { return *((IfcParse::entity*)IFC4_types[575]); }
Ifc4::IfcMaterialRelationship::IfcMaterialRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcMaterialRelationship::IfcMaterialRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcMaterial* v3_RelatingMaterial, aggregate_of< ::Ifc4::IfcMaterial >::ptr v4_RelatedMaterials, boost::optional< std::string > v5_Expression) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(5))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_RelatingMaterial ? v3_RelatingMaterial->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_RelatedMaterials)->generalize()); if (v5_Expression) {set_attribute_value(4, (*v5_Expression)); }; populate_derived(); }

// Function implementations for IfcMaterialUsageDefinition

::Ifc4::IfcRelAssociatesMaterial::list::ptr Ifc4::IfcMaterialUsageDefinition::AssociatedTo() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[812], 5)->as<IfcRelAssociatesMaterial>(); }

const IfcParse::entity& Ifc4::IfcMaterialUsageDefinition::declaration() const { return *((IfcParse::entity*)IFC4_types[577]); }
const IfcParse::entity& Ifc4::IfcMaterialUsageDefinition::Class() { return *((IfcParse::entity*)IFC4_types[577]); }
Ifc4::IfcMaterialUsageDefinition::IfcMaterialUsageDefinition(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcMaterialUsageDefinition::IfcMaterialUsageDefinition() : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcMeasureWithUnit
::Ifc4::IfcValue* Ifc4::IfcMeasureWithUnit::ValueComponent() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcValue>(true); }
void Ifc4::IfcMeasureWithUnit::setValueComponent(::Ifc4::IfcValue* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcUnit* Ifc4::IfcMeasureWithUnit::UnitComponent() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcMeasureWithUnit::setUnitComponent(::Ifc4::IfcUnit* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcMeasureWithUnit::declaration() const { return *((IfcParse::entity*)IFC4_types[579]); }
const IfcParse::entity& Ifc4::IfcMeasureWithUnit::Class() { return *((IfcParse::entity*)IFC4_types[579]); }
Ifc4::IfcMeasureWithUnit::IfcMeasureWithUnit(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcMeasureWithUnit::IfcMeasureWithUnit(::Ifc4::IfcValue* v1_ValueComponent, ::Ifc4::IfcUnit* v2_UnitComponent) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_ValueComponent ? v1_ValueComponent->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_UnitComponent ? v2_UnitComponent->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcMechanicalFastener
boost::optional< double > Ifc4::IfcMechanicalFastener::NominalDiameter() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcMechanicalFastener::setNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< double > Ifc4::IfcMechanicalFastener::NominalLength() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcMechanicalFastener::setNominalLength(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< ::Ifc4::IfcMechanicalFastenerTypeEnum::Value > Ifc4::IfcMechanicalFastener::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcMechanicalFastenerTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcMechanicalFastener::setPredefinedType(boost::optional< ::Ifc4::IfcMechanicalFastenerTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcMechanicalFastenerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcMechanicalFastener::declaration() const { return *((IfcParse::entity*)IFC4_types[580]); }
const IfcParse::entity& Ifc4::IfcMechanicalFastener::Class() { return *((IfcParse::entity*)IFC4_types[580]); }
Ifc4::IfcMechanicalFastener::IfcMechanicalFastener(IfcEntityInstanceData&& e) : IfcElementComponent(std::move(e)) { }
Ifc4::IfcMechanicalFastener::IfcMechanicalFastener(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< double > v9_NominalDiameter, boost::optional< double > v10_NominalLength, boost::optional< ::Ifc4::IfcMechanicalFastenerTypeEnum::Value > v11_PredefinedType) : IfcElementComponent(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_NominalDiameter) {set_attribute_value(8, (*v9_NominalDiameter)); } if (v10_NominalLength) {set_attribute_value(9, (*v10_NominalLength)); } if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcMechanicalFastenerTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcMechanicalFastenerType
::Ifc4::IfcMechanicalFastenerTypeEnum::Value Ifc4::IfcMechanicalFastenerType::PredefinedType() const {  return ::Ifc4::IfcMechanicalFastenerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcMechanicalFastenerType::setPredefinedType(::Ifc4::IfcMechanicalFastenerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcMechanicalFastenerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< double > Ifc4::IfcMechanicalFastenerType::NominalDiameter() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcMechanicalFastenerType::setNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcMechanicalFastenerType::NominalLength() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcMechanicalFastenerType::setNominalLength(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }


const IfcParse::entity& Ifc4::IfcMechanicalFastenerType::declaration() const { return *((IfcParse::entity*)IFC4_types[581]); }
const IfcParse::entity& Ifc4::IfcMechanicalFastenerType::Class() { return *((IfcParse::entity*)IFC4_types[581]); }
Ifc4::IfcMechanicalFastenerType::IfcMechanicalFastenerType(IfcEntityInstanceData&& e) : IfcElementComponentType(std::move(e)) { }
Ifc4::IfcMechanicalFastenerType::IfcMechanicalFastenerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcMechanicalFastenerTypeEnum::Value v10_PredefinedType, boost::optional< double > v11_NominalDiameter, boost::optional< double > v12_NominalLength) : IfcElementComponentType(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcMechanicalFastenerTypeEnum::Class(),(size_t)v10_PredefinedType))); if (v11_NominalDiameter) {set_attribute_value(10, (*v11_NominalDiameter)); } if (v12_NominalLength) {set_attribute_value(11, (*v12_NominalLength)); }; populate_derived(); }

// Function implementations for IfcMedicalDevice
boost::optional< ::Ifc4::IfcMedicalDeviceTypeEnum::Value > Ifc4::IfcMedicalDevice::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcMedicalDeviceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcMedicalDevice::setPredefinedType(boost::optional< ::Ifc4::IfcMedicalDeviceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcMedicalDeviceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcMedicalDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[583]); }
const IfcParse::entity& Ifc4::IfcMedicalDevice::Class() { return *((IfcParse::entity*)IFC4_types[583]); }
Ifc4::IfcMedicalDevice::IfcMedicalDevice(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcMedicalDevice::IfcMedicalDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcMedicalDeviceTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcMedicalDeviceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcMedicalDeviceType
::Ifc4::IfcMedicalDeviceTypeEnum::Value Ifc4::IfcMedicalDeviceType::PredefinedType() const {  return ::Ifc4::IfcMedicalDeviceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcMedicalDeviceType::setPredefinedType(::Ifc4::IfcMedicalDeviceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcMedicalDeviceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcMedicalDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[584]); }
const IfcParse::entity& Ifc4::IfcMedicalDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[584]); }
Ifc4::IfcMedicalDeviceType::IfcMedicalDeviceType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcMedicalDeviceType::IfcMedicalDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcMedicalDeviceTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcMedicalDeviceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcMember
boost::optional< ::Ifc4::IfcMemberTypeEnum::Value > Ifc4::IfcMember::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcMemberTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcMember::setPredefinedType(boost::optional< ::Ifc4::IfcMemberTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcMemberTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcMember::declaration() const { return *((IfcParse::entity*)IFC4_types[586]); }
const IfcParse::entity& Ifc4::IfcMember::Class() { return *((IfcParse::entity*)IFC4_types[586]); }
Ifc4::IfcMember::IfcMember(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcMember::IfcMember(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcMemberTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcMemberTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcMemberStandardCase


const IfcParse::entity& Ifc4::IfcMemberStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[587]); }
const IfcParse::entity& Ifc4::IfcMemberStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[587]); }
Ifc4::IfcMemberStandardCase::IfcMemberStandardCase(IfcEntityInstanceData&& e) : IfcMember(std::move(e)) { }
Ifc4::IfcMemberStandardCase::IfcMemberStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcMemberTypeEnum::Value > v9_PredefinedType) : IfcMember(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcMemberTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcMemberType
::Ifc4::IfcMemberTypeEnum::Value Ifc4::IfcMemberType::PredefinedType() const {  return ::Ifc4::IfcMemberTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcMemberType::setPredefinedType(::Ifc4::IfcMemberTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcMemberTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcMemberType::declaration() const { return *((IfcParse::entity*)IFC4_types[588]); }
const IfcParse::entity& Ifc4::IfcMemberType::Class() { return *((IfcParse::entity*)IFC4_types[588]); }
Ifc4::IfcMemberType::IfcMemberType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcMemberType::IfcMemberType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcMemberTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcMemberTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcMetric
::Ifc4::IfcBenchmarkEnum::Value Ifc4::IfcMetric::Benchmark() const {  return ::Ifc4::IfcBenchmarkEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcMetric::setBenchmark(::Ifc4::IfcBenchmarkEnum::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcBenchmarkEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }
boost::optional< std::string > Ifc4::IfcMetric::ValueSource() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcMetric::setValueSource(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
::Ifc4::IfcMetricValueSelect* Ifc4::IfcMetric::DataValue() const { if(data_.get_attribute_value(9).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcMetricValueSelect>(true); }
void Ifc4::IfcMetric::setDataValue(::Ifc4::IfcMetricValueSelect* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }
::Ifc4::IfcReference* Ifc4::IfcMetric::ReferencePath() const { if(data_.get_attribute_value(10).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(10)))->as<::Ifc4::IfcReference>(true); }
void Ifc4::IfcMetric::setReferencePath(::Ifc4::IfcReference* v) { set_attribute_value(10, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(10); }


const IfcParse::entity& Ifc4::IfcMetric::declaration() const { return *((IfcParse::entity*)IFC4_types[590]); }
const IfcParse::entity& Ifc4::IfcMetric::Class() { return *((IfcParse::entity*)IFC4_types[590]); }
Ifc4::IfcMetric::IfcMetric(IfcEntityInstanceData&& e) : IfcConstraint(std::move(e)) { }
Ifc4::IfcMetric::IfcMetric(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcConstraintEnum::Value v3_ConstraintGrade, boost::optional< std::string > v4_ConstraintSource, ::Ifc4::IfcActorSelect* v5_CreatingActor, boost::optional< std::string > v6_CreationTime, boost::optional< std::string > v7_UserDefinedGrade, ::Ifc4::IfcBenchmarkEnum::Value v8_Benchmark, boost::optional< std::string > v9_ValueSource, ::Ifc4::IfcMetricValueSelect* v10_DataValue, ::Ifc4::IfcReference* v11_ReferencePath) : IfcConstraint(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcConstraintEnum::Class(),(size_t)v3_ConstraintGrade))); if (v4_ConstraintSource) {set_attribute_value(3, (*v4_ConstraintSource)); }set_attribute_value(4, v5_CreatingActor ? v5_CreatingActor->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v6_CreationTime) {set_attribute_value(5, (*v6_CreationTime)); } if (v7_UserDefinedGrade) {set_attribute_value(6, (*v7_UserDefinedGrade)); }set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcBenchmarkEnum::Class(),(size_t)v8_Benchmark))); if (v9_ValueSource) {set_attribute_value(8, (*v9_ValueSource)); }set_attribute_value(9, v10_DataValue ? v10_DataValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(10, v11_ReferencePath ? v11_ReferencePath->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcMirroredProfileDef


const IfcParse::entity& Ifc4::IfcMirroredProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[592]); }
const IfcParse::entity& Ifc4::IfcMirroredProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[592]); }
Ifc4::IfcMirroredProfileDef::IfcMirroredProfileDef(IfcEntityInstanceData&& e) : IfcDerivedProfileDef(std::move(e)) { }
Ifc4::IfcMirroredProfileDef::IfcMirroredProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcProfileDef* v3_ParentProfile, boost::optional< std::string > v5_Label) : IfcDerivedProfileDef(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_ParentProfile ? v3_ParentProfile->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Label) {set_attribute_value(4, (*v5_Label)); }; populate_derived(); }

// Function implementations for IfcMonetaryUnit
std::string Ifc4::IfcMonetaryUnit::Currency() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcMonetaryUnit::setCurrency(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcMonetaryUnit::declaration() const { return *((IfcParse::entity*)IFC4_types[604]); }
const IfcParse::entity& Ifc4::IfcMonetaryUnit::Class() { return *((IfcParse::entity*)IFC4_types[604]); }
Ifc4::IfcMonetaryUnit::IfcMonetaryUnit(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcMonetaryUnit::IfcMonetaryUnit(std::string v1_Currency) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Currency));; populate_derived(); }

// Function implementations for IfcMotorConnection
boost::optional< ::Ifc4::IfcMotorConnectionTypeEnum::Value > Ifc4::IfcMotorConnection::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcMotorConnectionTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcMotorConnection::setPredefinedType(boost::optional< ::Ifc4::IfcMotorConnectionTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcMotorConnectionTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcMotorConnection::declaration() const { return *((IfcParse::entity*)IFC4_types[606]); }
const IfcParse::entity& Ifc4::IfcMotorConnection::Class() { return *((IfcParse::entity*)IFC4_types[606]); }
Ifc4::IfcMotorConnection::IfcMotorConnection(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcMotorConnection::IfcMotorConnection(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcMotorConnectionTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcMotorConnectionTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcMotorConnectionType
::Ifc4::IfcMotorConnectionTypeEnum::Value Ifc4::IfcMotorConnectionType::PredefinedType() const {  return ::Ifc4::IfcMotorConnectionTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcMotorConnectionType::setPredefinedType(::Ifc4::IfcMotorConnectionTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcMotorConnectionTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcMotorConnectionType::declaration() const { return *((IfcParse::entity*)IFC4_types[607]); }
const IfcParse::entity& Ifc4::IfcMotorConnectionType::Class() { return *((IfcParse::entity*)IFC4_types[607]); }
Ifc4::IfcMotorConnectionType::IfcMotorConnectionType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcMotorConnectionType::IfcMotorConnectionType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcMotorConnectionTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcMotorConnectionTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcNamedUnit
::Ifc4::IfcDimensionalExponents* Ifc4::IfcNamedUnit::Dimensions() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcDimensionalExponents>(true); }
void Ifc4::IfcNamedUnit::setDimensions(::Ifc4::IfcDimensionalExponents* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcUnitEnum::Value Ifc4::IfcNamedUnit::UnitType() const {  return ::Ifc4::IfcUnitEnum::FromString(data_.get_attribute_value(1)); }
void Ifc4::IfcNamedUnit::setUnitType(::Ifc4::IfcUnitEnum::Value v) { set_attribute_value(1, EnumerationReference(&::Ifc4::IfcUnitEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcNamedUnit::declaration() const { return *((IfcParse::entity*)IFC4_types[609]); }
const IfcParse::entity& Ifc4::IfcNamedUnit::Class() { return *((IfcParse::entity*)IFC4_types[609]); }
Ifc4::IfcNamedUnit::IfcNamedUnit(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcNamedUnit::IfcNamedUnit(::Ifc4::IfcDimensionalExponents* v1_Dimensions, ::Ifc4::IfcUnitEnum::Value v2_UnitType) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Dimensions ? v1_Dimensions->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcUnitEnum::Class(),(size_t)v2_UnitType)));; populate_derived(); }

// Function implementations for IfcObject
boost::optional< std::string > Ifc4::IfcObject::ObjectType() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcObject::setObjectType(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }

::Ifc4::IfcRelDefinesByObject::list::ptr Ifc4::IfcObject::IsDeclaredBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[829], 4)->as<IfcRelDefinesByObject>(); }
::Ifc4::IfcRelDefinesByObject::list::ptr Ifc4::IfcObject::Declares() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[829], 5)->as<IfcRelDefinesByObject>(); }
::Ifc4::IfcRelDefinesByType::list::ptr Ifc4::IfcObject::IsTypedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[832], 4)->as<IfcRelDefinesByType>(); }
::Ifc4::IfcRelDefinesByProperties::list::ptr Ifc4::IfcObject::IsDefinedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[830], 4)->as<IfcRelDefinesByProperties>(); }

const IfcParse::entity& Ifc4::IfcObject::declaration() const { return *((IfcParse::entity*)IFC4_types[614]); }
const IfcParse::entity& Ifc4::IfcObject::Class() { return *((IfcParse::entity*)IFC4_types[614]); }
Ifc4::IfcObject::IfcObject(IfcEntityInstanceData&& e) : IfcObjectDefinition(std::move(e)) { }
Ifc4::IfcObject::IfcObject(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType) : IfcObjectDefinition(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }; populate_derived(); }

// Function implementations for IfcObjectDefinition

::Ifc4::IfcRelAssigns::list::ptr Ifc4::IfcObjectDefinition::HasAssignments() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[798], 4)->as<IfcRelAssigns>(); }
::Ifc4::IfcRelNests::list::ptr Ifc4::IfcObjectDefinition::Nests() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[836], 5)->as<IfcRelNests>(); }
::Ifc4::IfcRelNests::list::ptr Ifc4::IfcObjectDefinition::IsNestedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[836], 4)->as<IfcRelNests>(); }
::Ifc4::IfcRelDeclares::list::ptr Ifc4::IfcObjectDefinition::HasContext() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[826], 5)->as<IfcRelDeclares>(); }
::Ifc4::IfcRelAggregates::list::ptr Ifc4::IfcObjectDefinition::IsDecomposedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[797], 4)->as<IfcRelAggregates>(); }
::Ifc4::IfcRelAggregates::list::ptr Ifc4::IfcObjectDefinition::Decomposes() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[797], 5)->as<IfcRelAggregates>(); }
::Ifc4::IfcRelAssociates::list::ptr Ifc4::IfcObjectDefinition::HasAssociations() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[806], 4)->as<IfcRelAssociates>(); }

const IfcParse::entity& Ifc4::IfcObjectDefinition::declaration() const { return *((IfcParse::entity*)IFC4_types[615]); }
const IfcParse::entity& Ifc4::IfcObjectDefinition::Class() { return *((IfcParse::entity*)IFC4_types[615]); }
Ifc4::IfcObjectDefinition::IfcObjectDefinition(IfcEntityInstanceData&& e) : IfcRoot(std::move(e)) { }
Ifc4::IfcObjectDefinition::IfcObjectDefinition(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcRoot(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcObjectPlacement

::Ifc4::IfcProduct::list::ptr Ifc4::IfcObjectPlacement::PlacesObject() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[710], 5)->as<IfcProduct>(); }
::Ifc4::IfcLocalPlacement::list::ptr Ifc4::IfcObjectPlacement::ReferencedByPlacements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[541], 0)->as<IfcLocalPlacement>(); }

const IfcParse::entity& Ifc4::IfcObjectPlacement::declaration() const { return *((IfcParse::entity*)IFC4_types[618]); }
const IfcParse::entity& Ifc4::IfcObjectPlacement::Class() { return *((IfcParse::entity*)IFC4_types[618]); }
Ifc4::IfcObjectPlacement::IfcObjectPlacement(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcObjectPlacement::IfcObjectPlacement() : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcObjective
boost::optional< aggregate_of< ::Ifc4::IfcConstraint >::ptr > Ifc4::IfcObjective::BenchmarkValues() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcConstraint >(); }
void Ifc4::IfcObjective::setBenchmarkValues(boost::optional< aggregate_of< ::Ifc4::IfcConstraint >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }
boost::optional< ::Ifc4::IfcLogicalOperatorEnum::Value > Ifc4::IfcObjective::LogicalAggregator() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcLogicalOperatorEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcObjective::setLogicalAggregator(boost::optional< ::Ifc4::IfcLogicalOperatorEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcLogicalOperatorEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }
::Ifc4::IfcObjectiveEnum::Value Ifc4::IfcObjective::ObjectiveQualifier() const {  return ::Ifc4::IfcObjectiveEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcObjective::setObjectiveQualifier(::Ifc4::IfcObjectiveEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcObjectiveEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< std::string > Ifc4::IfcObjective::UserDefinedQualifier() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcObjective::setUserDefinedQualifier(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcObjective::declaration() const { return *((IfcParse::entity*)IFC4_types[616]); }
const IfcParse::entity& Ifc4::IfcObjective::Class() { return *((IfcParse::entity*)IFC4_types[616]); }
Ifc4::IfcObjective::IfcObjective(IfcEntityInstanceData&& e) : IfcConstraint(std::move(e)) { }
Ifc4::IfcObjective::IfcObjective(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcConstraintEnum::Value v3_ConstraintGrade, boost::optional< std::string > v4_ConstraintSource, ::Ifc4::IfcActorSelect* v5_CreatingActor, boost::optional< std::string > v6_CreationTime, boost::optional< std::string > v7_UserDefinedGrade, boost::optional< aggregate_of< ::Ifc4::IfcConstraint >::ptr > v8_BenchmarkValues, boost::optional< ::Ifc4::IfcLogicalOperatorEnum::Value > v9_LogicalAggregator, ::Ifc4::IfcObjectiveEnum::Value v10_ObjectiveQualifier, boost::optional< std::string > v11_UserDefinedQualifier) : IfcConstraint(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcConstraintEnum::Class(),(size_t)v3_ConstraintGrade))); if (v4_ConstraintSource) {set_attribute_value(3, (*v4_ConstraintSource)); }set_attribute_value(4, v5_CreatingActor ? v5_CreatingActor->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v6_CreationTime) {set_attribute_value(5, (*v6_CreationTime)); } if (v7_UserDefinedGrade) {set_attribute_value(6, (*v7_UserDefinedGrade)); } if (v8_BenchmarkValues) {set_attribute_value(7, (*v8_BenchmarkValues)->generalize()); } if (v9_LogicalAggregator) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcLogicalOperatorEnum::Class(),(size_t)*v9_LogicalAggregator))); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcObjectiveEnum::Class(),(size_t)v10_ObjectiveQualifier))); if (v11_UserDefinedQualifier) {set_attribute_value(10, (*v11_UserDefinedQualifier)); }; populate_derived(); }

// Function implementations for IfcOccupant
boost::optional< ::Ifc4::IfcOccupantTypeEnum::Value > Ifc4::IfcOccupant::PredefinedType() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } return ::Ifc4::IfcOccupantTypeEnum::FromString(data_.get_attribute_value(6)); }
void Ifc4::IfcOccupant::setPredefinedType(boost::optional< ::Ifc4::IfcOccupantTypeEnum::Value > v) { if (v) {set_attribute_value(6, EnumerationReference(&::Ifc4::IfcOccupantTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcOccupant::declaration() const { return *((IfcParse::entity*)IFC4_types[621]); }
const IfcParse::entity& Ifc4::IfcOccupant::Class() { return *((IfcParse::entity*)IFC4_types[621]); }
Ifc4::IfcOccupant::IfcOccupant(IfcEntityInstanceData&& e) : IfcActor(std::move(e)) { }
Ifc4::IfcOccupant::IfcOccupant(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcActorSelect* v6_TheActor, boost::optional< ::Ifc4::IfcOccupantTypeEnum::Value > v7_PredefinedType) : IfcActor(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_TheActor ? v6_TheActor->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v7_PredefinedType) {set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcOccupantTypeEnum::Class(),(size_t)*v7_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcOffsetCurve2D
::Ifc4::IfcCurve* Ifc4::IfcOffsetCurve2D::BasisCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcOffsetCurve2D::setBasisCurve(::Ifc4::IfcCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcOffsetCurve2D::Distance() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcOffsetCurve2D::setDistance(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::logic::tribool Ifc4::IfcOffsetCurve2D::SelfIntersect() const {  boost::logic::tribool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcOffsetCurve2D::setSelfIntersect(boost::logic::tribool v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcOffsetCurve2D::declaration() const { return *((IfcParse::entity*)IFC4_types[623]); }
const IfcParse::entity& Ifc4::IfcOffsetCurve2D::Class() { return *((IfcParse::entity*)IFC4_types[623]); }
Ifc4::IfcOffsetCurve2D::IfcOffsetCurve2D(IfcEntityInstanceData&& e) : IfcCurve(std::move(e)) { }
Ifc4::IfcOffsetCurve2D::IfcOffsetCurve2D(::Ifc4::IfcCurve* v1_BasisCurve, double v2_Distance, boost::logic::tribool v3_SelfIntersect) : IfcCurve(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_BasisCurve ? v1_BasisCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Distance));set_attribute_value(2, (v3_SelfIntersect));; populate_derived(); }

// Function implementations for IfcOffsetCurve3D
::Ifc4::IfcCurve* Ifc4::IfcOffsetCurve3D::BasisCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcOffsetCurve3D::setBasisCurve(::Ifc4::IfcCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcOffsetCurve3D::Distance() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcOffsetCurve3D::setDistance(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::logic::tribool Ifc4::IfcOffsetCurve3D::SelfIntersect() const {  boost::logic::tribool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcOffsetCurve3D::setSelfIntersect(boost::logic::tribool v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcDirection* Ifc4::IfcOffsetCurve3D::RefDirection() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcOffsetCurve3D::setRefDirection(::Ifc4::IfcDirection* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcOffsetCurve3D::declaration() const { return *((IfcParse::entity*)IFC4_types[624]); }
const IfcParse::entity& Ifc4::IfcOffsetCurve3D::Class() { return *((IfcParse::entity*)IFC4_types[624]); }
Ifc4::IfcOffsetCurve3D::IfcOffsetCurve3D(IfcEntityInstanceData&& e) : IfcCurve(std::move(e)) { }
Ifc4::IfcOffsetCurve3D::IfcOffsetCurve3D(::Ifc4::IfcCurve* v1_BasisCurve, double v2_Distance, boost::logic::tribool v3_SelfIntersect, ::Ifc4::IfcDirection* v4_RefDirection) : IfcCurve(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_BasisCurve ? v1_BasisCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Distance));set_attribute_value(2, (v3_SelfIntersect));set_attribute_value(3, v4_RefDirection ? v4_RefDirection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcOpenShell


const IfcParse::entity& Ifc4::IfcOpenShell::declaration() const { return *((IfcParse::entity*)IFC4_types[628]); }
const IfcParse::entity& Ifc4::IfcOpenShell::Class() { return *((IfcParse::entity*)IFC4_types[628]); }
Ifc4::IfcOpenShell::IfcOpenShell(IfcEntityInstanceData&& e) : IfcConnectedFaceSet(std::move(e)) { }
Ifc4::IfcOpenShell::IfcOpenShell(aggregate_of< ::Ifc4::IfcFace >::ptr v1_CfsFaces) : IfcConnectedFaceSet(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_CfsFaces)->generalize());; populate_derived(); }

// Function implementations for IfcOpeningElement
boost::optional< ::Ifc4::IfcOpeningElementTypeEnum::Value > Ifc4::IfcOpeningElement::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcOpeningElementTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcOpeningElement::setPredefinedType(boost::optional< ::Ifc4::IfcOpeningElementTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcOpeningElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }

::Ifc4::IfcRelFillsElement::list::ptr Ifc4::IfcOpeningElement::HasFillings() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[833], 4)->as<IfcRelFillsElement>(); }

const IfcParse::entity& Ifc4::IfcOpeningElement::declaration() const { return *((IfcParse::entity*)IFC4_types[625]); }
const IfcParse::entity& Ifc4::IfcOpeningElement::Class() { return *((IfcParse::entity*)IFC4_types[625]); }
Ifc4::IfcOpeningElement::IfcOpeningElement(IfcEntityInstanceData&& e) : IfcFeatureElementSubtraction(std::move(e)) { }
Ifc4::IfcOpeningElement::IfcOpeningElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcOpeningElementTypeEnum::Value > v9_PredefinedType) : IfcFeatureElementSubtraction(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcOpeningElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcOpeningStandardCase


const IfcParse::entity& Ifc4::IfcOpeningStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[627]); }
const IfcParse::entity& Ifc4::IfcOpeningStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[627]); }
Ifc4::IfcOpeningStandardCase::IfcOpeningStandardCase(IfcEntityInstanceData&& e) : IfcOpeningElement(std::move(e)) { }
Ifc4::IfcOpeningStandardCase::IfcOpeningStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcOpeningElementTypeEnum::Value > v9_PredefinedType) : IfcOpeningElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcOpeningElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcOrganization
boost::optional< std::string > Ifc4::IfcOrganization::Identification() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcOrganization::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
std::string Ifc4::IfcOrganization::Name() const {  std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcOrganization::setName(std::string v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< std::string > Ifc4::IfcOrganization::Description() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcOrganization::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > Ifc4::IfcOrganization::Roles() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcActorRole >(); }
void Ifc4::IfcOrganization::setRoles(boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > v) { if (v) {set_attribute_value(3, (*v)->generalize());} else {unset_attribute_value(3);} }
boost::optional< aggregate_of< ::Ifc4::IfcAddress >::ptr > Ifc4::IfcOrganization::Addresses() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcAddress >(); }
void Ifc4::IfcOrganization::setAddresses(boost::optional< aggregate_of< ::Ifc4::IfcAddress >::ptr > v) { if (v) {set_attribute_value(4, (*v)->generalize());} else {unset_attribute_value(4);} }

::Ifc4::IfcOrganizationRelationship::list::ptr Ifc4::IfcOrganization::IsRelatedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[630], 3)->as<IfcOrganizationRelationship>(); }
::Ifc4::IfcOrganizationRelationship::list::ptr Ifc4::IfcOrganization::Relates() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[630], 2)->as<IfcOrganizationRelationship>(); }
::Ifc4::IfcPersonAndOrganization::list::ptr Ifc4::IfcOrganization::Engages() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[648], 1)->as<IfcPersonAndOrganization>(); }

const IfcParse::entity& Ifc4::IfcOrganization::declaration() const { return *((IfcParse::entity*)IFC4_types[629]); }
const IfcParse::entity& Ifc4::IfcOrganization::Class() { return *((IfcParse::entity*)IFC4_types[629]); }
Ifc4::IfcOrganization::IfcOrganization(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcOrganization::IfcOrganization(boost::optional< std::string > v1_Identification, std::string v2_Name, boost::optional< std::string > v3_Description, boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > v4_Roles, boost::optional< aggregate_of< ::Ifc4::IfcAddress >::ptr > v5_Addresses) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(5))) {  if (v1_Identification) {set_attribute_value(0, (*v1_Identification)); }set_attribute_value(1, (v2_Name)); if (v3_Description) {set_attribute_value(2, (*v3_Description)); } if (v4_Roles) {set_attribute_value(3, (*v4_Roles)->generalize()); } if (v5_Addresses) {set_attribute_value(4, (*v5_Addresses)->generalize()); }; populate_derived(); }

// Function implementations for IfcOrganizationRelationship
::Ifc4::IfcOrganization* Ifc4::IfcOrganizationRelationship::RelatingOrganization() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcOrganization>(true); }
void Ifc4::IfcOrganizationRelationship::setRelatingOrganization(::Ifc4::IfcOrganization* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
aggregate_of< ::Ifc4::IfcOrganization >::ptr Ifc4::IfcOrganizationRelationship::RelatedOrganizations() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcOrganization >(); }
void Ifc4::IfcOrganizationRelationship::setRelatedOrganizations(aggregate_of< ::Ifc4::IfcOrganization >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcOrganizationRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[630]); }
const IfcParse::entity& Ifc4::IfcOrganizationRelationship::Class() { return *((IfcParse::entity*)IFC4_types[630]); }
Ifc4::IfcOrganizationRelationship::IfcOrganizationRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcOrganizationRelationship::IfcOrganizationRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcOrganization* v3_RelatingOrganization, aggregate_of< ::Ifc4::IfcOrganization >::ptr v4_RelatedOrganizations) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_RelatingOrganization ? v3_RelatingOrganization->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_RelatedOrganizations)->generalize());; populate_derived(); }

// Function implementations for IfcOrientedEdge
::Ifc4::IfcEdge* Ifc4::IfcOrientedEdge::EdgeElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcEdge>(true); }
void Ifc4::IfcOrientedEdge::setEdgeElement(::Ifc4::IfcEdge* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
bool Ifc4::IfcOrientedEdge::Orientation() const {  bool v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcOrientedEdge::setOrientation(bool v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcOrientedEdge::declaration() const { return *((IfcParse::entity*)IFC4_types[631]); }
const IfcParse::entity& Ifc4::IfcOrientedEdge::Class() { return *((IfcParse::entity*)IFC4_types[631]); }
Ifc4::IfcOrientedEdge::IfcOrientedEdge(IfcEntityInstanceData&& e) : IfcEdge(std::move(e)) { }
Ifc4::IfcOrientedEdge::IfcOrientedEdge(::Ifc4::IfcEdge* v3_EdgeElement, bool v4_Orientation) : IfcEdge(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(2, v3_EdgeElement ? v3_EdgeElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Orientation));; populate_derived(); }

// Function implementations for IfcOuterBoundaryCurve


const IfcParse::entity& Ifc4::IfcOuterBoundaryCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[632]); }
const IfcParse::entity& Ifc4::IfcOuterBoundaryCurve::Class() { return *((IfcParse::entity*)IFC4_types[632]); }
Ifc4::IfcOuterBoundaryCurve::IfcOuterBoundaryCurve(IfcEntityInstanceData&& e) : IfcBoundaryCurve(std::move(e)) { }
Ifc4::IfcOuterBoundaryCurve::IfcOuterBoundaryCurve(aggregate_of< ::Ifc4::IfcCompositeCurveSegment >::ptr v1_Segments, boost::logic::tribool v2_SelfIntersect) : IfcBoundaryCurve(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_Segments)->generalize());set_attribute_value(1, (v2_SelfIntersect));; populate_derived(); }

// Function implementations for IfcOutlet
boost::optional< ::Ifc4::IfcOutletTypeEnum::Value > Ifc4::IfcOutlet::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcOutletTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcOutlet::setPredefinedType(boost::optional< ::Ifc4::IfcOutletTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcOutletTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcOutlet::declaration() const { return *((IfcParse::entity*)IFC4_types[633]); }
const IfcParse::entity& Ifc4::IfcOutlet::Class() { return *((IfcParse::entity*)IFC4_types[633]); }
Ifc4::IfcOutlet::IfcOutlet(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcOutlet::IfcOutlet(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcOutletTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcOutletTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcOutletType
::Ifc4::IfcOutletTypeEnum::Value Ifc4::IfcOutletType::PredefinedType() const {  return ::Ifc4::IfcOutletTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcOutletType::setPredefinedType(::Ifc4::IfcOutletTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcOutletTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcOutletType::declaration() const { return *((IfcParse::entity*)IFC4_types[634]); }
const IfcParse::entity& Ifc4::IfcOutletType::Class() { return *((IfcParse::entity*)IFC4_types[634]); }
Ifc4::IfcOutletType::IfcOutletType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcOutletType::IfcOutletType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcOutletTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcOutletTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcOwnerHistory
::Ifc4::IfcPersonAndOrganization* Ifc4::IfcOwnerHistory::OwningUser() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcPersonAndOrganization>(true); }
void Ifc4::IfcOwnerHistory::setOwningUser(::Ifc4::IfcPersonAndOrganization* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcApplication* Ifc4::IfcOwnerHistory::OwningApplication() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcApplication>(true); }
void Ifc4::IfcOwnerHistory::setOwningApplication(::Ifc4::IfcApplication* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
boost::optional< ::Ifc4::IfcStateEnum::Value > Ifc4::IfcOwnerHistory::State() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } return ::Ifc4::IfcStateEnum::FromString(data_.get_attribute_value(2)); }
void Ifc4::IfcOwnerHistory::setState(boost::optional< ::Ifc4::IfcStateEnum::Value > v) { if (v) {set_attribute_value(2, EnumerationReference(&::Ifc4::IfcStateEnum::Class(), (size_t) *v));} else {unset_attribute_value(2);} }
boost::optional< ::Ifc4::IfcChangeActionEnum::Value > Ifc4::IfcOwnerHistory::ChangeAction() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } return ::Ifc4::IfcChangeActionEnum::FromString(data_.get_attribute_value(3)); }
void Ifc4::IfcOwnerHistory::setChangeAction(boost::optional< ::Ifc4::IfcChangeActionEnum::Value > v) { if (v) {set_attribute_value(3, EnumerationReference(&::Ifc4::IfcChangeActionEnum::Class(), (size_t) *v));} else {unset_attribute_value(3);} }
boost::optional< int > Ifc4::IfcOwnerHistory::LastModifiedDate() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } int v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcOwnerHistory::setLastModifiedDate(boost::optional< int > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
::Ifc4::IfcPersonAndOrganization* Ifc4::IfcOwnerHistory::LastModifyingUser() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcPersonAndOrganization>(true); }
void Ifc4::IfcOwnerHistory::setLastModifyingUser(::Ifc4::IfcPersonAndOrganization* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcApplication* Ifc4::IfcOwnerHistory::LastModifyingApplication() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcApplication>(true); }
void Ifc4::IfcOwnerHistory::setLastModifyingApplication(::Ifc4::IfcApplication* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
int Ifc4::IfcOwnerHistory::CreationDate() const {  int v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcOwnerHistory::setCreationDate(int v) { set_attribute_value(7, v);if constexpr (false)unset_attribute_value(7); }


const IfcParse::entity& Ifc4::IfcOwnerHistory::declaration() const { return *((IfcParse::entity*)IFC4_types[636]); }
const IfcParse::entity& Ifc4::IfcOwnerHistory::Class() { return *((IfcParse::entity*)IFC4_types[636]); }
Ifc4::IfcOwnerHistory::IfcOwnerHistory(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcOwnerHistory::IfcOwnerHistory(::Ifc4::IfcPersonAndOrganization* v1_OwningUser, ::Ifc4::IfcApplication* v2_OwningApplication, boost::optional< ::Ifc4::IfcStateEnum::Value > v3_State, boost::optional< ::Ifc4::IfcChangeActionEnum::Value > v4_ChangeAction, boost::optional< int > v5_LastModifiedDate, ::Ifc4::IfcPersonAndOrganization* v6_LastModifyingUser, ::Ifc4::IfcApplication* v7_LastModifyingApplication, int v8_CreationDate) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, v1_OwningUser ? v1_OwningUser->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_OwningApplication ? v2_OwningApplication->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_State) {set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcStateEnum::Class(),(size_t)*v3_State))); } if (v4_ChangeAction) {set_attribute_value(3, (EnumerationReference(&::Ifc4::IfcChangeActionEnum::Class(),(size_t)*v4_ChangeAction))); } if (v5_LastModifiedDate) {set_attribute_value(4, (*v5_LastModifiedDate)); }set_attribute_value(5, v6_LastModifyingUser ? v6_LastModifyingUser->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_LastModifyingApplication ? v7_LastModifyingApplication->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (v8_CreationDate));; populate_derived(); }

// Function implementations for IfcParameterizedProfileDef
::Ifc4::IfcAxis2Placement2D* Ifc4::IfcParameterizedProfileDef::Position() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcAxis2Placement2D>(true); }
void Ifc4::IfcParameterizedProfileDef::setPosition(::Ifc4::IfcAxis2Placement2D* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcParameterizedProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[637]); }
const IfcParse::entity& Ifc4::IfcParameterizedProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[637]); }
Ifc4::IfcParameterizedProfileDef::IfcParameterizedProfileDef(IfcEntityInstanceData&& e) : IfcProfileDef(std::move(e)) { }
Ifc4::IfcParameterizedProfileDef::IfcParameterizedProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position) : IfcProfileDef(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPath
aggregate_of< ::Ifc4::IfcOrientedEdge >::ptr Ifc4::IfcPath::EdgeList() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcOrientedEdge >(); }
void Ifc4::IfcPath::setEdgeList(aggregate_of< ::Ifc4::IfcOrientedEdge >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcPath::declaration() const { return *((IfcParse::entity*)IFC4_types[639]); }
const IfcParse::entity& Ifc4::IfcPath::Class() { return *((IfcParse::entity*)IFC4_types[639]); }
Ifc4::IfcPath::IfcPath(IfcEntityInstanceData&& e) : IfcTopologicalRepresentationItem(std::move(e)) { }
Ifc4::IfcPath::IfcPath(aggregate_of< ::Ifc4::IfcOrientedEdge >::ptr v1_EdgeList) : IfcTopologicalRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_EdgeList)->generalize());; populate_derived(); }

// Function implementations for IfcPcurve
::Ifc4::IfcSurface* Ifc4::IfcPcurve::BasisSurface() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcSurface>(true); }
void Ifc4::IfcPcurve::setBasisSurface(::Ifc4::IfcSurface* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcCurve* Ifc4::IfcPcurve::ReferenceCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcPcurve::setReferenceCurve(::Ifc4::IfcCurve* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcPcurve::declaration() const { return *((IfcParse::entity*)IFC4_types[640]); }
const IfcParse::entity& Ifc4::IfcPcurve::Class() { return *((IfcParse::entity*)IFC4_types[640]); }
Ifc4::IfcPcurve::IfcPcurve(IfcEntityInstanceData&& e) : IfcCurve(std::move(e)) { }
Ifc4::IfcPcurve::IfcPcurve(::Ifc4::IfcSurface* v1_BasisSurface, ::Ifc4::IfcCurve* v2_ReferenceCurve) : IfcCurve(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_BasisSurface ? v1_BasisSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_ReferenceCurve ? v2_ReferenceCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPerformanceHistory
std::string Ifc4::IfcPerformanceHistory::LifeCyclePhase() const {  std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcPerformanceHistory::setLifeCyclePhase(std::string v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
boost::optional< ::Ifc4::IfcPerformanceHistoryTypeEnum::Value > Ifc4::IfcPerformanceHistory::PredefinedType() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } return ::Ifc4::IfcPerformanceHistoryTypeEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcPerformanceHistory::setPredefinedType(boost::optional< ::Ifc4::IfcPerformanceHistoryTypeEnum::Value > v) { if (v) {set_attribute_value(7, EnumerationReference(&::Ifc4::IfcPerformanceHistoryTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcPerformanceHistory::declaration() const { return *((IfcParse::entity*)IFC4_types[641]); }
const IfcParse::entity& Ifc4::IfcPerformanceHistory::Class() { return *((IfcParse::entity*)IFC4_types[641]); }
Ifc4::IfcPerformanceHistory::IfcPerformanceHistory(IfcEntityInstanceData&& e) : IfcControl(std::move(e)) { }
Ifc4::IfcPerformanceHistory::IfcPerformanceHistory(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, std::string v7_LifeCyclePhase, boost::optional< ::Ifc4::IfcPerformanceHistoryTypeEnum::Value > v8_PredefinedType) : IfcControl(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); }set_attribute_value(6, (v7_LifeCyclePhase)); if (v8_PredefinedType) {set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcPerformanceHistoryTypeEnum::Class(),(size_t)*v8_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcPermeableCoveringProperties
::Ifc4::IfcPermeableCoveringOperationEnum::Value Ifc4::IfcPermeableCoveringProperties::OperationType() const {  return ::Ifc4::IfcPermeableCoveringOperationEnum::FromString(data_.get_attribute_value(4)); }
void Ifc4::IfcPermeableCoveringProperties::setOperationType(::Ifc4::IfcPermeableCoveringOperationEnum::Value v) { set_attribute_value(4, EnumerationReference(&::Ifc4::IfcPermeableCoveringOperationEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcWindowPanelPositionEnum::Value Ifc4::IfcPermeableCoveringProperties::PanelPosition() const {  return ::Ifc4::IfcWindowPanelPositionEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcPermeableCoveringProperties::setPanelPosition(::Ifc4::IfcWindowPanelPositionEnum::Value v) { set_attribute_value(5, EnumerationReference(&::Ifc4::IfcWindowPanelPositionEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(5); }
boost::optional< double > Ifc4::IfcPermeableCoveringProperties::FrameDepth() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcPermeableCoveringProperties::setFrameDepth(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< double > Ifc4::IfcPermeableCoveringProperties::FrameThickness() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcPermeableCoveringProperties::setFrameThickness(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
::Ifc4::IfcShapeAspect* Ifc4::IfcPermeableCoveringProperties::ShapeAspectStyle() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcShapeAspect>(true); }
void Ifc4::IfcPermeableCoveringProperties::setShapeAspectStyle(::Ifc4::IfcShapeAspect* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcPermeableCoveringProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[644]); }
const IfcParse::entity& Ifc4::IfcPermeableCoveringProperties::Class() { return *((IfcParse::entity*)IFC4_types[644]); }
Ifc4::IfcPermeableCoveringProperties::IfcPermeableCoveringProperties(IfcEntityInstanceData&& e) : IfcPreDefinedPropertySet(std::move(e)) { }
Ifc4::IfcPermeableCoveringProperties::IfcPermeableCoveringProperties(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcPermeableCoveringOperationEnum::Value v5_OperationType, ::Ifc4::IfcWindowPanelPositionEnum::Value v6_PanelPosition, boost::optional< double > v7_FrameDepth, boost::optional< double > v8_FrameThickness, ::Ifc4::IfcShapeAspect* v9_ShapeAspectStyle) : IfcPreDefinedPropertySet(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcPermeableCoveringOperationEnum::Class(),(size_t)v5_OperationType)));set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcWindowPanelPositionEnum::Class(),(size_t)v6_PanelPosition))); if (v7_FrameDepth) {set_attribute_value(6, (*v7_FrameDepth)); } if (v8_FrameThickness) {set_attribute_value(7, (*v8_FrameThickness)); }set_attribute_value(8, v9_ShapeAspectStyle ? v9_ShapeAspectStyle->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPermit
boost::optional< ::Ifc4::IfcPermitTypeEnum::Value > Ifc4::IfcPermit::PredefinedType() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } return ::Ifc4::IfcPermitTypeEnum::FromString(data_.get_attribute_value(6)); }
void Ifc4::IfcPermit::setPredefinedType(boost::optional< ::Ifc4::IfcPermitTypeEnum::Value > v) { if (v) {set_attribute_value(6, EnumerationReference(&::Ifc4::IfcPermitTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcPermit::Status() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcPermit::setStatus(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcPermit::LongDescription() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcPermit::setLongDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcPermit::declaration() const { return *((IfcParse::entity*)IFC4_types[645]); }
const IfcParse::entity& Ifc4::IfcPermit::Class() { return *((IfcParse::entity*)IFC4_types[645]); }
Ifc4::IfcPermit::IfcPermit(IfcEntityInstanceData&& e) : IfcControl(std::move(e)) { }
Ifc4::IfcPermit::IfcPermit(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< ::Ifc4::IfcPermitTypeEnum::Value > v7_PredefinedType, boost::optional< std::string > v8_Status, boost::optional< std::string > v9_LongDescription) : IfcControl(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_PredefinedType) {set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcPermitTypeEnum::Class(),(size_t)*v7_PredefinedType))); } if (v8_Status) {set_attribute_value(7, (*v8_Status)); } if (v9_LongDescription) {set_attribute_value(8, (*v9_LongDescription)); }; populate_derived(); }

// Function implementations for IfcPerson
boost::optional< std::string > Ifc4::IfcPerson::Identification() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcPerson::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcPerson::FamilyName() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcPerson::setFamilyName(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcPerson::GivenName() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcPerson::setGivenName(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcPerson::MiddleNames() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcPerson::setMiddleNames(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcPerson::PrefixTitles() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcPerson::setPrefixTitles(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcPerson::SuffixTitles() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcPerson::setSuffixTitles(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > Ifc4::IfcPerson::Roles() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(6); return es->as< ::Ifc4::IfcActorRole >(); }
void Ifc4::IfcPerson::setRoles(boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > v) { if (v) {set_attribute_value(6, (*v)->generalize());} else {unset_attribute_value(6);} }
boost::optional< aggregate_of< ::Ifc4::IfcAddress >::ptr > Ifc4::IfcPerson::Addresses() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcAddress >(); }
void Ifc4::IfcPerson::setAddresses(boost::optional< aggregate_of< ::Ifc4::IfcAddress >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }

::Ifc4::IfcPersonAndOrganization::list::ptr Ifc4::IfcPerson::EngagedIn() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[648], 0)->as<IfcPersonAndOrganization>(); }

const IfcParse::entity& Ifc4::IfcPerson::declaration() const { return *((IfcParse::entity*)IFC4_types[647]); }
const IfcParse::entity& Ifc4::IfcPerson::Class() { return *((IfcParse::entity*)IFC4_types[647]); }
Ifc4::IfcPerson::IfcPerson(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcPerson::IfcPerson(boost::optional< std::string > v1_Identification, boost::optional< std::string > v2_FamilyName, boost::optional< std::string > v3_GivenName, boost::optional< std::vector< std::string > /*[1:?]*/ > v4_MiddleNames, boost::optional< std::vector< std::string > /*[1:?]*/ > v5_PrefixTitles, boost::optional< std::vector< std::string > /*[1:?]*/ > v6_SuffixTitles, boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > v7_Roles, boost::optional< aggregate_of< ::Ifc4::IfcAddress >::ptr > v8_Addresses) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(8))) {  if (v1_Identification) {set_attribute_value(0, (*v1_Identification)); } if (v2_FamilyName) {set_attribute_value(1, (*v2_FamilyName)); } if (v3_GivenName) {set_attribute_value(2, (*v3_GivenName)); } if (v4_MiddleNames) {set_attribute_value(3, (*v4_MiddleNames)); } if (v5_PrefixTitles) {set_attribute_value(4, (*v5_PrefixTitles)); } if (v6_SuffixTitles) {set_attribute_value(5, (*v6_SuffixTitles)); } if (v7_Roles) {set_attribute_value(6, (*v7_Roles)->generalize()); } if (v8_Addresses) {set_attribute_value(7, (*v8_Addresses)->generalize()); }; populate_derived(); }

// Function implementations for IfcPersonAndOrganization
::Ifc4::IfcPerson* Ifc4::IfcPersonAndOrganization::ThePerson() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcPerson>(true); }
void Ifc4::IfcPersonAndOrganization::setThePerson(::Ifc4::IfcPerson* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcOrganization* Ifc4::IfcPersonAndOrganization::TheOrganization() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcOrganization>(true); }
void Ifc4::IfcPersonAndOrganization::setTheOrganization(::Ifc4::IfcOrganization* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > Ifc4::IfcPersonAndOrganization::Roles() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcActorRole >(); }
void Ifc4::IfcPersonAndOrganization::setRoles(boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > v) { if (v) {set_attribute_value(2, (*v)->generalize());} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcPersonAndOrganization::declaration() const { return *((IfcParse::entity*)IFC4_types[648]); }
const IfcParse::entity& Ifc4::IfcPersonAndOrganization::Class() { return *((IfcParse::entity*)IFC4_types[648]); }
Ifc4::IfcPersonAndOrganization::IfcPersonAndOrganization(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcPersonAndOrganization::IfcPersonAndOrganization(::Ifc4::IfcPerson* v1_ThePerson, ::Ifc4::IfcOrganization* v2_TheOrganization, boost::optional< aggregate_of< ::Ifc4::IfcActorRole >::ptr > v3_Roles) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_ThePerson ? v1_ThePerson->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_TheOrganization ? v2_TheOrganization->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Roles) {set_attribute_value(2, (*v3_Roles)->generalize()); }; populate_derived(); }

// Function implementations for IfcPhysicalComplexQuantity
aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr Ifc4::IfcPhysicalComplexQuantity::HasQuantities() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcPhysicalQuantity >(); }
void Ifc4::IfcPhysicalComplexQuantity::setHasQuantities(aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }
std::string Ifc4::IfcPhysicalComplexQuantity::Discrimination() const {  std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcPhysicalComplexQuantity::setDiscrimination(std::string v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcPhysicalComplexQuantity::Quality() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcPhysicalComplexQuantity::setQuality(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcPhysicalComplexQuantity::Usage() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcPhysicalComplexQuantity::setUsage(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }


const IfcParse::entity& Ifc4::IfcPhysicalComplexQuantity::declaration() const { return *((IfcParse::entity*)IFC4_types[650]); }
const IfcParse::entity& Ifc4::IfcPhysicalComplexQuantity::Class() { return *((IfcParse::entity*)IFC4_types[650]); }
Ifc4::IfcPhysicalComplexQuantity::IfcPhysicalComplexQuantity(IfcEntityInstanceData&& e) : IfcPhysicalQuantity(std::move(e)) { }
Ifc4::IfcPhysicalComplexQuantity::IfcPhysicalComplexQuantity(std::string v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcPhysicalQuantity >::ptr v3_HasQuantities, std::string v4_Discrimination, boost::optional< std::string > v5_Quality, boost::optional< std::string > v6_Usage) : IfcPhysicalQuantity(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_HasQuantities)->generalize());set_attribute_value(3, (v4_Discrimination)); if (v5_Quality) {set_attribute_value(4, (*v5_Quality)); } if (v6_Usage) {set_attribute_value(5, (*v6_Usage)); }; populate_derived(); }

// Function implementations for IfcPhysicalQuantity
std::string Ifc4::IfcPhysicalQuantity::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcPhysicalQuantity::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcPhysicalQuantity::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcPhysicalQuantity::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcPhysicalQuantity::HasExternalReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }
::Ifc4::IfcPhysicalComplexQuantity::list::ptr Ifc4::IfcPhysicalQuantity::PartOfComplex() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[650], 2)->as<IfcPhysicalComplexQuantity>(); }

const IfcParse::entity& Ifc4::IfcPhysicalQuantity::declaration() const { return *((IfcParse::entity*)IFC4_types[652]); }
const IfcParse::entity& Ifc4::IfcPhysicalQuantity::Class() { return *((IfcParse::entity*)IFC4_types[652]); }
Ifc4::IfcPhysicalQuantity::IfcPhysicalQuantity(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcPhysicalQuantity::IfcPhysicalQuantity(std::string v1_Name, boost::optional< std::string > v2_Description) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }; populate_derived(); }

// Function implementations for IfcPhysicalSimpleQuantity
::Ifc4::IfcNamedUnit* Ifc4::IfcPhysicalSimpleQuantity::Unit() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcNamedUnit>(true); }
void Ifc4::IfcPhysicalSimpleQuantity::setUnit(::Ifc4::IfcNamedUnit* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcPhysicalSimpleQuantity::declaration() const { return *((IfcParse::entity*)IFC4_types[653]); }
const IfcParse::entity& Ifc4::IfcPhysicalSimpleQuantity::Class() { return *((IfcParse::entity*)IFC4_types[653]); }
Ifc4::IfcPhysicalSimpleQuantity::IfcPhysicalSimpleQuantity(IfcEntityInstanceData&& e) : IfcPhysicalQuantity(std::move(e)) { }
Ifc4::IfcPhysicalSimpleQuantity::IfcPhysicalSimpleQuantity(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcNamedUnit* v3_Unit) : IfcPhysicalQuantity(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Unit ? v3_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPile
boost::optional< ::Ifc4::IfcPileTypeEnum::Value > Ifc4::IfcPile::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcPileTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcPile::setPredefinedType(boost::optional< ::Ifc4::IfcPileTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcPileTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }
boost::optional< ::Ifc4::IfcPileConstructionEnum::Value > Ifc4::IfcPile::ConstructionType() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } return ::Ifc4::IfcPileConstructionEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcPile::setConstructionType(boost::optional< ::Ifc4::IfcPileConstructionEnum::Value > v) { if (v) {set_attribute_value(9, EnumerationReference(&::Ifc4::IfcPileConstructionEnum::Class(), (size_t) *v));} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcPile::declaration() const { return *((IfcParse::entity*)IFC4_types[654]); }
const IfcParse::entity& Ifc4::IfcPile::Class() { return *((IfcParse::entity*)IFC4_types[654]); }
Ifc4::IfcPile::IfcPile(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcPile::IfcPile(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcPileTypeEnum::Value > v9_PredefinedType, boost::optional< ::Ifc4::IfcPileConstructionEnum::Value > v10_ConstructionType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcPileTypeEnum::Class(),(size_t)*v9_PredefinedType))); } if (v10_ConstructionType) {set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcPileConstructionEnum::Class(),(size_t)*v10_ConstructionType))); }; populate_derived(); }

// Function implementations for IfcPileType
::Ifc4::IfcPileTypeEnum::Value Ifc4::IfcPileType::PredefinedType() const {  return ::Ifc4::IfcPileTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcPileType::setPredefinedType(::Ifc4::IfcPileTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcPileTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcPileType::declaration() const { return *((IfcParse::entity*)IFC4_types[656]); }
const IfcParse::entity& Ifc4::IfcPileType::Class() { return *((IfcParse::entity*)IFC4_types[656]); }
Ifc4::IfcPileType::IfcPileType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcPileType::IfcPileType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcPileTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcPileTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcPipeFitting
boost::optional< ::Ifc4::IfcPipeFittingTypeEnum::Value > Ifc4::IfcPipeFitting::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcPipeFittingTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcPipeFitting::setPredefinedType(boost::optional< ::Ifc4::IfcPipeFittingTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcPipeFittingTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcPipeFitting::declaration() const { return *((IfcParse::entity*)IFC4_types[658]); }
const IfcParse::entity& Ifc4::IfcPipeFitting::Class() { return *((IfcParse::entity*)IFC4_types[658]); }
Ifc4::IfcPipeFitting::IfcPipeFitting(IfcEntityInstanceData&& e) : IfcFlowFitting(std::move(e)) { }
Ifc4::IfcPipeFitting::IfcPipeFitting(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcPipeFittingTypeEnum::Value > v9_PredefinedType) : IfcFlowFitting(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcPipeFittingTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcPipeFittingType
::Ifc4::IfcPipeFittingTypeEnum::Value Ifc4::IfcPipeFittingType::PredefinedType() const {  return ::Ifc4::IfcPipeFittingTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcPipeFittingType::setPredefinedType(::Ifc4::IfcPipeFittingTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcPipeFittingTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcPipeFittingType::declaration() const { return *((IfcParse::entity*)IFC4_types[659]); }
const IfcParse::entity& Ifc4::IfcPipeFittingType::Class() { return *((IfcParse::entity*)IFC4_types[659]); }
Ifc4::IfcPipeFittingType::IfcPipeFittingType(IfcEntityInstanceData&& e) : IfcFlowFittingType(std::move(e)) { }
Ifc4::IfcPipeFittingType::IfcPipeFittingType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcPipeFittingTypeEnum::Value v10_PredefinedType) : IfcFlowFittingType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcPipeFittingTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcPipeSegment
boost::optional< ::Ifc4::IfcPipeSegmentTypeEnum::Value > Ifc4::IfcPipeSegment::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcPipeSegmentTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcPipeSegment::setPredefinedType(boost::optional< ::Ifc4::IfcPipeSegmentTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcPipeSegmentTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcPipeSegment::declaration() const { return *((IfcParse::entity*)IFC4_types[661]); }
const IfcParse::entity& Ifc4::IfcPipeSegment::Class() { return *((IfcParse::entity*)IFC4_types[661]); }
Ifc4::IfcPipeSegment::IfcPipeSegment(IfcEntityInstanceData&& e) : IfcFlowSegment(std::move(e)) { }
Ifc4::IfcPipeSegment::IfcPipeSegment(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcPipeSegmentTypeEnum::Value > v9_PredefinedType) : IfcFlowSegment(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcPipeSegmentTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcPipeSegmentType
::Ifc4::IfcPipeSegmentTypeEnum::Value Ifc4::IfcPipeSegmentType::PredefinedType() const {  return ::Ifc4::IfcPipeSegmentTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcPipeSegmentType::setPredefinedType(::Ifc4::IfcPipeSegmentTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcPipeSegmentTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcPipeSegmentType::declaration() const { return *((IfcParse::entity*)IFC4_types[662]); }
const IfcParse::entity& Ifc4::IfcPipeSegmentType::Class() { return *((IfcParse::entity*)IFC4_types[662]); }
Ifc4::IfcPipeSegmentType::IfcPipeSegmentType(IfcEntityInstanceData&& e) : IfcFlowSegmentType(std::move(e)) { }
Ifc4::IfcPipeSegmentType::IfcPipeSegmentType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcPipeSegmentTypeEnum::Value v10_PredefinedType) : IfcFlowSegmentType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcPipeSegmentTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcPixelTexture
int Ifc4::IfcPixelTexture::Width() const {  int v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcPixelTexture::setWidth(int v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
int Ifc4::IfcPixelTexture::Height() const {  int v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcPixelTexture::setHeight(int v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
int Ifc4::IfcPixelTexture::ColourComponents() const {  int v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcPixelTexture::setColourComponents(int v) { set_attribute_value(7, v);if constexpr (false)unset_attribute_value(7); }
std::vector< boost::dynamic_bitset<> > /*[1:?]*/ Ifc4::IfcPixelTexture::Pixel() const {  std::vector< boost::dynamic_bitset<> > /*[1:?]*/ v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcPixelTexture::setPixel(std::vector< boost::dynamic_bitset<> > /*[1:?]*/ v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcPixelTexture::declaration() const { return *((IfcParse::entity*)IFC4_types[664]); }
const IfcParse::entity& Ifc4::IfcPixelTexture::Class() { return *((IfcParse::entity*)IFC4_types[664]); }
Ifc4::IfcPixelTexture::IfcPixelTexture(IfcEntityInstanceData&& e) : IfcSurfaceTexture(std::move(e)) { }
Ifc4::IfcPixelTexture::IfcPixelTexture(bool v1_RepeatS, bool v2_RepeatT, boost::optional< std::string > v3_Mode, ::Ifc4::IfcCartesianTransformationOperator2D* v4_TextureTransform, boost::optional< std::vector< std::string > /*[1:?]*/ > v5_Parameter, int v6_Width, int v7_Height, int v8_ColourComponents, std::vector< boost::dynamic_bitset<> > /*[1:?]*/ v9_Pixel) : IfcSurfaceTexture(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_RepeatS));set_attribute_value(1, (v2_RepeatT)); if (v3_Mode) {set_attribute_value(2, (*v3_Mode)); }set_attribute_value(3, v4_TextureTransform ? v4_TextureTransform->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Parameter) {set_attribute_value(4, (*v5_Parameter)); }set_attribute_value(5, (v6_Width));set_attribute_value(6, (v7_Height));set_attribute_value(7, (v8_ColourComponents));set_attribute_value(8, (v9_Pixel));; populate_derived(); }

// Function implementations for IfcPlacement
::Ifc4::IfcCartesianPoint* Ifc4::IfcPlacement::Location() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCartesianPoint>(true); }
void Ifc4::IfcPlacement::setLocation(::Ifc4::IfcCartesianPoint* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcPlacement::declaration() const { return *((IfcParse::entity*)IFC4_types[665]); }
const IfcParse::entity& Ifc4::IfcPlacement::Class() { return *((IfcParse::entity*)IFC4_types[665]); }
Ifc4::IfcPlacement::IfcPlacement(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcPlacement::IfcPlacement(::Ifc4::IfcCartesianPoint* v1_Location) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Location ? v1_Location->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPlanarBox
::Ifc4::IfcAxis2Placement* Ifc4::IfcPlanarBox::Placement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcAxis2Placement>(true); }
void Ifc4::IfcPlanarBox::setPlacement(::Ifc4::IfcAxis2Placement* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcPlanarBox::declaration() const { return *((IfcParse::entity*)IFC4_types[666]); }
const IfcParse::entity& Ifc4::IfcPlanarBox::Class() { return *((IfcParse::entity*)IFC4_types[666]); }
Ifc4::IfcPlanarBox::IfcPlanarBox(IfcEntityInstanceData&& e) : IfcPlanarExtent(std::move(e)) { }
Ifc4::IfcPlanarBox::IfcPlanarBox(double v1_SizeInX, double v2_SizeInY, ::Ifc4::IfcAxis2Placement* v3_Placement) : IfcPlanarExtent(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_SizeInX));set_attribute_value(1, (v2_SizeInY));set_attribute_value(2, v3_Placement ? v3_Placement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPlanarExtent
double Ifc4::IfcPlanarExtent::SizeInX() const {  double v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcPlanarExtent::setSizeInX(double v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcPlanarExtent::SizeInY() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcPlanarExtent::setSizeInY(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcPlanarExtent::declaration() const { return *((IfcParse::entity*)IFC4_types[667]); }
const IfcParse::entity& Ifc4::IfcPlanarExtent::Class() { return *((IfcParse::entity*)IFC4_types[667]); }
Ifc4::IfcPlanarExtent::IfcPlanarExtent(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcPlanarExtent::IfcPlanarExtent(double v1_SizeInX, double v2_SizeInY) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_SizeInX));set_attribute_value(1, (v2_SizeInY));; populate_derived(); }

// Function implementations for IfcPlane


const IfcParse::entity& Ifc4::IfcPlane::declaration() const { return *((IfcParse::entity*)IFC4_types[669]); }
const IfcParse::entity& Ifc4::IfcPlane::Class() { return *((IfcParse::entity*)IFC4_types[669]); }
Ifc4::IfcPlane::IfcPlane(IfcEntityInstanceData&& e) : IfcElementarySurface(std::move(e)) { }
Ifc4::IfcPlane::IfcPlane(::Ifc4::IfcAxis2Placement3D* v1_Position) : IfcElementarySurface(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPlate
boost::optional< ::Ifc4::IfcPlateTypeEnum::Value > Ifc4::IfcPlate::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcPlateTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcPlate::setPredefinedType(boost::optional< ::Ifc4::IfcPlateTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcPlateTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcPlate::declaration() const { return *((IfcParse::entity*)IFC4_types[671]); }
const IfcParse::entity& Ifc4::IfcPlate::Class() { return *((IfcParse::entity*)IFC4_types[671]); }
Ifc4::IfcPlate::IfcPlate(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcPlate::IfcPlate(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcPlateTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcPlateTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcPlateStandardCase


const IfcParse::entity& Ifc4::IfcPlateStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[672]); }
const IfcParse::entity& Ifc4::IfcPlateStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[672]); }
Ifc4::IfcPlateStandardCase::IfcPlateStandardCase(IfcEntityInstanceData&& e) : IfcPlate(std::move(e)) { }
Ifc4::IfcPlateStandardCase::IfcPlateStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcPlateTypeEnum::Value > v9_PredefinedType) : IfcPlate(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcPlateTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcPlateType
::Ifc4::IfcPlateTypeEnum::Value Ifc4::IfcPlateType::PredefinedType() const {  return ::Ifc4::IfcPlateTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcPlateType::setPredefinedType(::Ifc4::IfcPlateTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcPlateTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcPlateType::declaration() const { return *((IfcParse::entity*)IFC4_types[673]); }
const IfcParse::entity& Ifc4::IfcPlateType::Class() { return *((IfcParse::entity*)IFC4_types[673]); }
Ifc4::IfcPlateType::IfcPlateType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcPlateType::IfcPlateType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcPlateTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcPlateTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcPoint


const IfcParse::entity& Ifc4::IfcPoint::declaration() const { return *((IfcParse::entity*)IFC4_types[675]); }
const IfcParse::entity& Ifc4::IfcPoint::Class() { return *((IfcParse::entity*)IFC4_types[675]); }
Ifc4::IfcPoint::IfcPoint(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcPoint::IfcPoint() : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcPointOnCurve
::Ifc4::IfcCurve* Ifc4::IfcPointOnCurve::BasisCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcPointOnCurve::setBasisCurve(::Ifc4::IfcCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcPointOnCurve::PointParameter() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcPointOnCurve::setPointParameter(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcPointOnCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[676]); }
const IfcParse::entity& Ifc4::IfcPointOnCurve::Class() { return *((IfcParse::entity*)IFC4_types[676]); }
Ifc4::IfcPointOnCurve::IfcPointOnCurve(IfcEntityInstanceData&& e) : IfcPoint(std::move(e)) { }
Ifc4::IfcPointOnCurve::IfcPointOnCurve(::Ifc4::IfcCurve* v1_BasisCurve, double v2_PointParameter) : IfcPoint(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_BasisCurve ? v1_BasisCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_PointParameter));; populate_derived(); }

// Function implementations for IfcPointOnSurface
::Ifc4::IfcSurface* Ifc4::IfcPointOnSurface::BasisSurface() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcSurface>(true); }
void Ifc4::IfcPointOnSurface::setBasisSurface(::Ifc4::IfcSurface* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcPointOnSurface::PointParameterU() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcPointOnSurface::setPointParameterU(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcPointOnSurface::PointParameterV() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcPointOnSurface::setPointParameterV(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcPointOnSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[677]); }
const IfcParse::entity& Ifc4::IfcPointOnSurface::Class() { return *((IfcParse::entity*)IFC4_types[677]); }
Ifc4::IfcPointOnSurface::IfcPointOnSurface(IfcEntityInstanceData&& e) : IfcPoint(std::move(e)) { }
Ifc4::IfcPointOnSurface::IfcPointOnSurface(::Ifc4::IfcSurface* v1_BasisSurface, double v2_PointParameterU, double v3_PointParameterV) : IfcPoint(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_BasisSurface ? v1_BasisSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_PointParameterU));set_attribute_value(2, (v3_PointParameterV));; populate_derived(); }

// Function implementations for IfcPolyLoop
aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr Ifc4::IfcPolyLoop::Polygon() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcCartesianPoint >(); }
void Ifc4::IfcPolyLoop::setPolygon(aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcPolyLoop::declaration() const { return *((IfcParse::entity*)IFC4_types[682]); }
const IfcParse::entity& Ifc4::IfcPolyLoop::Class() { return *((IfcParse::entity*)IFC4_types[682]); }
Ifc4::IfcPolyLoop::IfcPolyLoop(IfcEntityInstanceData&& e) : IfcLoop(std::move(e)) { }
Ifc4::IfcPolyLoop::IfcPolyLoop(aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v1_Polygon) : IfcLoop(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Polygon)->generalize());; populate_derived(); }

// Function implementations for IfcPolygonalBoundedHalfSpace
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcPolygonalBoundedHalfSpace::Position() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcPolygonalBoundedHalfSpace::setPosition(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcBoundedCurve* Ifc4::IfcPolygonalBoundedHalfSpace::PolygonalBoundary() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcBoundedCurve>(true); }
void Ifc4::IfcPolygonalBoundedHalfSpace::setPolygonalBoundary(::Ifc4::IfcBoundedCurve* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcPolygonalBoundedHalfSpace::declaration() const { return *((IfcParse::entity*)IFC4_types[679]); }
const IfcParse::entity& Ifc4::IfcPolygonalBoundedHalfSpace::Class() { return *((IfcParse::entity*)IFC4_types[679]); }
Ifc4::IfcPolygonalBoundedHalfSpace::IfcPolygonalBoundedHalfSpace(IfcEntityInstanceData&& e) : IfcHalfSpaceSolid(std::move(e)) { }
Ifc4::IfcPolygonalBoundedHalfSpace::IfcPolygonalBoundedHalfSpace(::Ifc4::IfcSurface* v1_BaseSurface, bool v2_AgreementFlag, ::Ifc4::IfcAxis2Placement3D* v3_Position, ::Ifc4::IfcBoundedCurve* v4_PolygonalBoundary) : IfcHalfSpaceSolid(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_BaseSurface ? v1_BaseSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_AgreementFlag));set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_PolygonalBoundary ? v4_PolygonalBoundary->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPolygonalFaceSet
boost::optional< bool > Ifc4::IfcPolygonalFaceSet::Closed() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } bool v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcPolygonalFaceSet::setClosed(boost::optional< bool > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
aggregate_of< ::Ifc4::IfcIndexedPolygonalFace >::ptr Ifc4::IfcPolygonalFaceSet::Faces() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcIndexedPolygonalFace >(); }
void Ifc4::IfcPolygonalFaceSet::setFaces(aggregate_of< ::Ifc4::IfcIndexedPolygonalFace >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }
boost::optional< std::vector< int > /*[1:?]*/ > Ifc4::IfcPolygonalFaceSet::PnIndex() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::vector< int > /*[1:?]*/ v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcPolygonalFaceSet::setPnIndex(boost::optional< std::vector< int > /*[1:?]*/ > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcPolygonalFaceSet::declaration() const { return *((IfcParse::entity*)IFC4_types[680]); }
const IfcParse::entity& Ifc4::IfcPolygonalFaceSet::Class() { return *((IfcParse::entity*)IFC4_types[680]); }
Ifc4::IfcPolygonalFaceSet::IfcPolygonalFaceSet(IfcEntityInstanceData&& e) : IfcTessellatedFaceSet(std::move(e)) { }
Ifc4::IfcPolygonalFaceSet::IfcPolygonalFaceSet(::Ifc4::IfcCartesianPointList3D* v1_Coordinates, boost::optional< bool > v2_Closed, aggregate_of< ::Ifc4::IfcIndexedPolygonalFace >::ptr v3_Faces, boost::optional< std::vector< int > /*[1:?]*/ > v4_PnIndex) : IfcTessellatedFaceSet(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_Coordinates ? v1_Coordinates->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_Closed) {set_attribute_value(1, (*v2_Closed)); }set_attribute_value(2, (v3_Faces)->generalize()); if (v4_PnIndex) {set_attribute_value(3, (*v4_PnIndex)); }; populate_derived(); }

// Function implementations for IfcPolyline
aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr Ifc4::IfcPolyline::Points() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcCartesianPoint >(); }
void Ifc4::IfcPolyline::setPoints(aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcPolyline::declaration() const { return *((IfcParse::entity*)IFC4_types[681]); }
const IfcParse::entity& Ifc4::IfcPolyline::Class() { return *((IfcParse::entity*)IFC4_types[681]); }
Ifc4::IfcPolyline::IfcPolyline(IfcEntityInstanceData&& e) : IfcBoundedCurve(std::move(e)) { }
Ifc4::IfcPolyline::IfcPolyline(aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v1_Points) : IfcBoundedCurve(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Points)->generalize());; populate_derived(); }

// Function implementations for IfcPort

::Ifc4::IfcRelConnectsPortToElement::list::ptr Ifc4::IfcPort::ContainedIn() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[818], 4)->as<IfcRelConnectsPortToElement>(); }
::Ifc4::IfcRelConnectsPorts::list::ptr Ifc4::IfcPort::ConnectedFrom() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[817], 5)->as<IfcRelConnectsPorts>(); }
::Ifc4::IfcRelConnectsPorts::list::ptr Ifc4::IfcPort::ConnectedTo() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[817], 4)->as<IfcRelConnectsPorts>(); }

const IfcParse::entity& Ifc4::IfcPort::declaration() const { return *((IfcParse::entity*)IFC4_types[683]); }
const IfcParse::entity& Ifc4::IfcPort::Class() { return *((IfcParse::entity*)IFC4_types[683]); }
Ifc4::IfcPort::IfcPort(IfcEntityInstanceData&& e) : IfcProduct(std::move(e)) { }
Ifc4::IfcPort::IfcPort(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation) : IfcProduct(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPostalAddress
boost::optional< std::string > Ifc4::IfcPostalAddress::InternalLocation() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcPostalAddress::setInternalLocation(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcPostalAddress::AddressLines() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcPostalAddress::setAddressLines(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcPostalAddress::PostalBox() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcPostalAddress::setPostalBox(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcPostalAddress::Town() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcPostalAddress::setTown(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcPostalAddress::Region() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcPostalAddress::setRegion(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcPostalAddress::PostalCode() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcPostalAddress::setPostalCode(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< std::string > Ifc4::IfcPostalAddress::Country() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcPostalAddress::setCountry(boost::optional< std::string > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcPostalAddress::declaration() const { return *((IfcParse::entity*)IFC4_types[688]); }
const IfcParse::entity& Ifc4::IfcPostalAddress::Class() { return *((IfcParse::entity*)IFC4_types[688]); }
Ifc4::IfcPostalAddress::IfcPostalAddress(IfcEntityInstanceData&& e) : IfcAddress(std::move(e)) { }
Ifc4::IfcPostalAddress::IfcPostalAddress(boost::optional< ::Ifc4::IfcAddressTypeEnum::Value > v1_Purpose, boost::optional< std::string > v2_Description, boost::optional< std::string > v3_UserDefinedPurpose, boost::optional< std::string > v4_InternalLocation, boost::optional< std::vector< std::string > /*[1:?]*/ > v5_AddressLines, boost::optional< std::string > v6_PostalBox, boost::optional< std::string > v7_Town, boost::optional< std::string > v8_Region, boost::optional< std::string > v9_PostalCode, boost::optional< std::string > v10_Country) : IfcAddress(IfcEntityInstanceData(storage_t(10))) {  if (v1_Purpose) {set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcAddressTypeEnum::Class(),(size_t)*v1_Purpose))); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_UserDefinedPurpose) {set_attribute_value(2, (*v3_UserDefinedPurpose)); } if (v4_InternalLocation) {set_attribute_value(3, (*v4_InternalLocation)); } if (v5_AddressLines) {set_attribute_value(4, (*v5_AddressLines)); } if (v6_PostalBox) {set_attribute_value(5, (*v6_PostalBox)); } if (v7_Town) {set_attribute_value(6, (*v7_Town)); } if (v8_Region) {set_attribute_value(7, (*v8_Region)); } if (v9_PostalCode) {set_attribute_value(8, (*v9_PostalCode)); } if (v10_Country) {set_attribute_value(9, (*v10_Country)); }; populate_derived(); }

// Function implementations for IfcPreDefinedColour


const IfcParse::entity& Ifc4::IfcPreDefinedColour::declaration() const { return *((IfcParse::entity*)IFC4_types[690]); }
const IfcParse::entity& Ifc4::IfcPreDefinedColour::Class() { return *((IfcParse::entity*)IFC4_types[690]); }
Ifc4::IfcPreDefinedColour::IfcPreDefinedColour(IfcEntityInstanceData&& e) : IfcPreDefinedItem(std::move(e)) { }
Ifc4::IfcPreDefinedColour::IfcPreDefinedColour(std::string v1_Name) : IfcPreDefinedItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Name));; populate_derived(); }

// Function implementations for IfcPreDefinedCurveFont


const IfcParse::entity& Ifc4::IfcPreDefinedCurveFont::declaration() const { return *((IfcParse::entity*)IFC4_types[691]); }
const IfcParse::entity& Ifc4::IfcPreDefinedCurveFont::Class() { return *((IfcParse::entity*)IFC4_types[691]); }
Ifc4::IfcPreDefinedCurveFont::IfcPreDefinedCurveFont(IfcEntityInstanceData&& e) : IfcPreDefinedItem(std::move(e)) { }
Ifc4::IfcPreDefinedCurveFont::IfcPreDefinedCurveFont(std::string v1_Name) : IfcPreDefinedItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Name));; populate_derived(); }

// Function implementations for IfcPreDefinedItem
std::string Ifc4::IfcPreDefinedItem::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcPreDefinedItem::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcPreDefinedItem::declaration() const { return *((IfcParse::entity*)IFC4_types[692]); }
const IfcParse::entity& Ifc4::IfcPreDefinedItem::Class() { return *((IfcParse::entity*)IFC4_types[692]); }
Ifc4::IfcPreDefinedItem::IfcPreDefinedItem(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcPreDefinedItem::IfcPreDefinedItem(std::string v1_Name) : IfcPresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Name));; populate_derived(); }

// Function implementations for IfcPreDefinedProperties


const IfcParse::entity& Ifc4::IfcPreDefinedProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[693]); }
const IfcParse::entity& Ifc4::IfcPreDefinedProperties::Class() { return *((IfcParse::entity*)IFC4_types[693]); }
Ifc4::IfcPreDefinedProperties::IfcPreDefinedProperties(IfcEntityInstanceData&& e) : IfcPropertyAbstraction(std::move(e)) { }
Ifc4::IfcPreDefinedProperties::IfcPreDefinedProperties() : IfcPropertyAbstraction(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcPreDefinedPropertySet


const IfcParse::entity& Ifc4::IfcPreDefinedPropertySet::declaration() const { return *((IfcParse::entity*)IFC4_types[694]); }
const IfcParse::entity& Ifc4::IfcPreDefinedPropertySet::Class() { return *((IfcParse::entity*)IFC4_types[694]); }
Ifc4::IfcPreDefinedPropertySet::IfcPreDefinedPropertySet(IfcEntityInstanceData&& e) : IfcPropertySetDefinition(std::move(e)) { }
Ifc4::IfcPreDefinedPropertySet::IfcPreDefinedPropertySet(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcPropertySetDefinition(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcPreDefinedTextFont


const IfcParse::entity& Ifc4::IfcPreDefinedTextFont::declaration() const { return *((IfcParse::entity*)IFC4_types[695]); }
const IfcParse::entity& Ifc4::IfcPreDefinedTextFont::Class() { return *((IfcParse::entity*)IFC4_types[695]); }
Ifc4::IfcPreDefinedTextFont::IfcPreDefinedTextFont(IfcEntityInstanceData&& e) : IfcPreDefinedItem(std::move(e)) { }
Ifc4::IfcPreDefinedTextFont::IfcPreDefinedTextFont(std::string v1_Name) : IfcPreDefinedItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Name));; populate_derived(); }

// Function implementations for IfcPresentationItem


const IfcParse::entity& Ifc4::IfcPresentationItem::declaration() const { return *((IfcParse::entity*)IFC4_types[698]); }
const IfcParse::entity& Ifc4::IfcPresentationItem::Class() { return *((IfcParse::entity*)IFC4_types[698]); }
Ifc4::IfcPresentationItem::IfcPresentationItem(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcPresentationItem::IfcPresentationItem() : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcPresentationLayerAssignment
std::string Ifc4::IfcPresentationLayerAssignment::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcPresentationLayerAssignment::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcPresentationLayerAssignment::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcPresentationLayerAssignment::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
aggregate_of< ::Ifc4::IfcLayeredItem >::ptr Ifc4::IfcPresentationLayerAssignment::AssignedItems() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcLayeredItem >(); }
void Ifc4::IfcPresentationLayerAssignment::setAssignedItems(aggregate_of< ::Ifc4::IfcLayeredItem >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }
boost::optional< std::string > Ifc4::IfcPresentationLayerAssignment::Identifier() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcPresentationLayerAssignment::setIdentifier(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcPresentationLayerAssignment::declaration() const { return *((IfcParse::entity*)IFC4_types[699]); }
const IfcParse::entity& Ifc4::IfcPresentationLayerAssignment::Class() { return *((IfcParse::entity*)IFC4_types[699]); }
Ifc4::IfcPresentationLayerAssignment::IfcPresentationLayerAssignment(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcPresentationLayerAssignment::IfcPresentationLayerAssignment(std::string v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcLayeredItem >::ptr v3_AssignedItems, boost::optional< std::string > v4_Identifier) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_AssignedItems)->generalize()); if (v4_Identifier) {set_attribute_value(3, (*v4_Identifier)); }; populate_derived(); }

// Function implementations for IfcPresentationLayerWithStyle
boost::logic::tribool Ifc4::IfcPresentationLayerWithStyle::LayerOn() const {  boost::logic::tribool v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcPresentationLayerWithStyle::setLayerOn(boost::logic::tribool v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
boost::logic::tribool Ifc4::IfcPresentationLayerWithStyle::LayerFrozen() const {  boost::logic::tribool v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcPresentationLayerWithStyle::setLayerFrozen(boost::logic::tribool v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
boost::logic::tribool Ifc4::IfcPresentationLayerWithStyle::LayerBlocked() const {  boost::logic::tribool v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcPresentationLayerWithStyle::setLayerBlocked(boost::logic::tribool v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
aggregate_of< ::Ifc4::IfcPresentationStyle >::ptr Ifc4::IfcPresentationLayerWithStyle::LayerStyles() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcPresentationStyle >(); }
void Ifc4::IfcPresentationLayerWithStyle::setLayerStyles(aggregate_of< ::Ifc4::IfcPresentationStyle >::ptr v) { set_attribute_value(7, (v)->generalize());if constexpr (false)unset_attribute_value(7); }


const IfcParse::entity& Ifc4::IfcPresentationLayerWithStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[700]); }
const IfcParse::entity& Ifc4::IfcPresentationLayerWithStyle::Class() { return *((IfcParse::entity*)IFC4_types[700]); }
Ifc4::IfcPresentationLayerWithStyle::IfcPresentationLayerWithStyle(IfcEntityInstanceData&& e) : IfcPresentationLayerAssignment(std::move(e)) { }
Ifc4::IfcPresentationLayerWithStyle::IfcPresentationLayerWithStyle(std::string v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcLayeredItem >::ptr v3_AssignedItems, boost::optional< std::string > v4_Identifier, boost::logic::tribool v5_LayerOn, boost::logic::tribool v6_LayerFrozen, boost::logic::tribool v7_LayerBlocked, aggregate_of< ::Ifc4::IfcPresentationStyle >::ptr v8_LayerStyles) : IfcPresentationLayerAssignment(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_AssignedItems)->generalize()); if (v4_Identifier) {set_attribute_value(3, (*v4_Identifier)); }set_attribute_value(4, (v5_LayerOn));set_attribute_value(5, (v6_LayerFrozen));set_attribute_value(6, (v7_LayerBlocked));set_attribute_value(7, (v8_LayerStyles)->generalize());; populate_derived(); }

// Function implementations for IfcPresentationStyle
boost::optional< std::string > Ifc4::IfcPresentationStyle::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcPresentationStyle::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }


const IfcParse::entity& Ifc4::IfcPresentationStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[701]); }
const IfcParse::entity& Ifc4::IfcPresentationStyle::Class() { return *((IfcParse::entity*)IFC4_types[701]); }
Ifc4::IfcPresentationStyle::IfcPresentationStyle(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcPresentationStyle::IfcPresentationStyle(boost::optional< std::string > v1_Name) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }; populate_derived(); }

// Function implementations for IfcPresentationStyleAssignment
aggregate_of< ::Ifc4::IfcPresentationStyleSelect >::ptr Ifc4::IfcPresentationStyleAssignment::Styles() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcPresentationStyleSelect >(); }
void Ifc4::IfcPresentationStyleAssignment::setStyles(aggregate_of< ::Ifc4::IfcPresentationStyleSelect >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcPresentationStyleAssignment::declaration() const { return *((IfcParse::entity*)IFC4_types[702]); }
const IfcParse::entity& Ifc4::IfcPresentationStyleAssignment::Class() { return *((IfcParse::entity*)IFC4_types[702]); }
Ifc4::IfcPresentationStyleAssignment::IfcPresentationStyleAssignment(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcPresentationStyleAssignment::IfcPresentationStyleAssignment(aggregate_of< ::Ifc4::IfcPresentationStyleSelect >::ptr v1_Styles) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Styles)->generalize());; populate_derived(); }

// Function implementations for IfcProcedure
boost::optional< ::Ifc4::IfcProcedureTypeEnum::Value > Ifc4::IfcProcedure::PredefinedType() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } return ::Ifc4::IfcProcedureTypeEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcProcedure::setPredefinedType(boost::optional< ::Ifc4::IfcProcedureTypeEnum::Value > v) { if (v) {set_attribute_value(7, EnumerationReference(&::Ifc4::IfcProcedureTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcProcedure::declaration() const { return *((IfcParse::entity*)IFC4_types[705]); }
const IfcParse::entity& Ifc4::IfcProcedure::Class() { return *((IfcParse::entity*)IFC4_types[705]); }
Ifc4::IfcProcedure::IfcProcedure(IfcEntityInstanceData&& e) : IfcProcess(std::move(e)) { }
Ifc4::IfcProcedure::IfcProcedure(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, boost::optional< ::Ifc4::IfcProcedureTypeEnum::Value > v8_PredefinedType) : IfcProcess(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); } if (v8_PredefinedType) {set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcProcedureTypeEnum::Class(),(size_t)*v8_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcProcedureType
::Ifc4::IfcProcedureTypeEnum::Value Ifc4::IfcProcedureType::PredefinedType() const {  return ::Ifc4::IfcProcedureTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcProcedureType::setPredefinedType(::Ifc4::IfcProcedureTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcProcedureTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcProcedureType::declaration() const { return *((IfcParse::entity*)IFC4_types[706]); }
const IfcParse::entity& Ifc4::IfcProcedureType::Class() { return *((IfcParse::entity*)IFC4_types[706]); }
Ifc4::IfcProcedureType::IfcProcedureType(IfcEntityInstanceData&& e) : IfcTypeProcess(std::move(e)) { }
Ifc4::IfcProcedureType::IfcProcedureType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ProcessType, ::Ifc4::IfcProcedureTypeEnum::Value v10_PredefinedType) : IfcTypeProcess(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ProcessType) {set_attribute_value(8, (*v9_ProcessType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcProcedureTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcProcess
boost::optional< std::string > Ifc4::IfcProcess::Identification() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcProcess::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcProcess::LongDescription() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcProcess::setLongDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }

::Ifc4::IfcRelSequence::list::ptr Ifc4::IfcProcess::IsPredecessorTo() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[839], 4)->as<IfcRelSequence>(); }
::Ifc4::IfcRelSequence::list::ptr Ifc4::IfcProcess::IsSuccessorFrom() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[839], 5)->as<IfcRelSequence>(); }
::Ifc4::IfcRelAssignsToProcess::list::ptr Ifc4::IfcProcess::OperatesOn() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[803], 6)->as<IfcRelAssignsToProcess>(); }

const IfcParse::entity& Ifc4::IfcProcess::declaration() const { return *((IfcParse::entity*)IFC4_types[708]); }
const IfcParse::entity& Ifc4::IfcProcess::Class() { return *((IfcParse::entity*)IFC4_types[708]); }
Ifc4::IfcProcess::IfcProcess(IfcEntityInstanceData&& e) : IfcObject(std::move(e)) { }
Ifc4::IfcProcess::IfcProcess(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription) : IfcObject(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }; populate_derived(); }

// Function implementations for IfcProduct
::Ifc4::IfcObjectPlacement* Ifc4::IfcProduct::ObjectPlacement() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcObjectPlacement>(true); }
void Ifc4::IfcProduct::setObjectPlacement(::Ifc4::IfcObjectPlacement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcProductRepresentation* Ifc4::IfcProduct::Representation() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcProductRepresentation>(true); }
void Ifc4::IfcProduct::setRepresentation(::Ifc4::IfcProductRepresentation* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }

::Ifc4::IfcRelAssignsToProduct::list::ptr Ifc4::IfcProduct::ReferencedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[804], 6)->as<IfcRelAssignsToProduct>(); }

const IfcParse::entity& Ifc4::IfcProduct::declaration() const { return *((IfcParse::entity*)IFC4_types[710]); }
const IfcParse::entity& Ifc4::IfcProduct::Class() { return *((IfcParse::entity*)IFC4_types[710]); }
Ifc4::IfcProduct::IfcProduct(IfcEntityInstanceData&& e) : IfcObject(std::move(e)) { }
Ifc4::IfcProduct::IfcProduct(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation) : IfcObject(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcProductDefinitionShape

::Ifc4::IfcProduct::list::ptr Ifc4::IfcProductDefinitionShape::ShapeOfProduct() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[710], 6)->as<IfcProduct>(); }
::Ifc4::IfcShapeAspect::list::ptr Ifc4::IfcProductDefinitionShape::HasShapeAspects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[890], 4)->as<IfcShapeAspect>(); }

const IfcParse::entity& Ifc4::IfcProductDefinitionShape::declaration() const { return *((IfcParse::entity*)IFC4_types[711]); }
const IfcParse::entity& Ifc4::IfcProductDefinitionShape::Class() { return *((IfcParse::entity*)IFC4_types[711]); }
Ifc4::IfcProductDefinitionShape::IfcProductDefinitionShape(IfcEntityInstanceData&& e) : IfcProductRepresentation(std::move(e)) { }
Ifc4::IfcProductDefinitionShape::IfcProductDefinitionShape(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcRepresentation >::ptr v3_Representations) : IfcProductRepresentation(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_Representations)->generalize());; populate_derived(); }

// Function implementations for IfcProductRepresentation
boost::optional< std::string > Ifc4::IfcProductRepresentation::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcProductRepresentation::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcProductRepresentation::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcProductRepresentation::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
aggregate_of< ::Ifc4::IfcRepresentation >::ptr Ifc4::IfcProductRepresentation::Representations() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcRepresentation >(); }
void Ifc4::IfcProductRepresentation::setRepresentations(aggregate_of< ::Ifc4::IfcRepresentation >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcProductRepresentation::declaration() const { return *((IfcParse::entity*)IFC4_types[712]); }
const IfcParse::entity& Ifc4::IfcProductRepresentation::Class() { return *((IfcParse::entity*)IFC4_types[712]); }
Ifc4::IfcProductRepresentation::IfcProductRepresentation(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcProductRepresentation::IfcProductRepresentation(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcRepresentation >::ptr v3_Representations) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_Representations)->generalize());; populate_derived(); }

// Function implementations for IfcProfileDef
::Ifc4::IfcProfileTypeEnum::Value Ifc4::IfcProfileDef::ProfileType() const {  return ::Ifc4::IfcProfileTypeEnum::FromString(data_.get_attribute_value(0)); }
void Ifc4::IfcProfileDef::setProfileType(::Ifc4::IfcProfileTypeEnum::Value v) { set_attribute_value(0, EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcProfileDef::ProfileName() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcProfileDef::setProfileName(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcProfileDef::HasExternalReference() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }
::Ifc4::IfcProfileProperties::list::ptr Ifc4::IfcProfileDef::HasProperties() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[716], 3)->as<IfcProfileProperties>(); }

const IfcParse::entity& Ifc4::IfcProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[715]); }
const IfcParse::entity& Ifc4::IfcProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[715]); }
Ifc4::IfcProfileDef::IfcProfileDef(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcProfileDef::IfcProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }; populate_derived(); }

// Function implementations for IfcProfileProperties
::Ifc4::IfcProfileDef* Ifc4::IfcProfileProperties::ProfileDefinition() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcProfileProperties::setProfileDefinition(::Ifc4::IfcProfileDef* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcProfileProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[716]); }
const IfcParse::entity& Ifc4::IfcProfileProperties::Class() { return *((IfcParse::entity*)IFC4_types[716]); }
Ifc4::IfcProfileProperties::IfcProfileProperties(IfcEntityInstanceData&& e) : IfcExtendedProperties(std::move(e)) { }
Ifc4::IfcProfileProperties::IfcProfileProperties(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcProperty >::ptr v3_Properties, ::Ifc4::IfcProfileDef* v4_ProfileDefinition) : IfcExtendedProperties(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_Properties)->generalize());set_attribute_value(3, v4_ProfileDefinition ? v4_ProfileDefinition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcProject


const IfcParse::entity& Ifc4::IfcProject::declaration() const { return *((IfcParse::entity*)IFC4_types[718]); }
const IfcParse::entity& Ifc4::IfcProject::Class() { return *((IfcParse::entity*)IFC4_types[718]); }
Ifc4::IfcProject::IfcProject(IfcEntityInstanceData&& e) : IfcContext(std::move(e)) { }
Ifc4::IfcProject::IfcProject(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_LongName, boost::optional< std::string > v7_Phase, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationContext >::ptr > v8_RepresentationContexts, ::Ifc4::IfcUnitAssignment* v9_UnitsInContext) : IfcContext(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_LongName) {set_attribute_value(5, (*v6_LongName)); } if (v7_Phase) {set_attribute_value(6, (*v7_Phase)); } if (v8_RepresentationContexts) {set_attribute_value(7, (*v8_RepresentationContexts)->generalize()); }set_attribute_value(8, v9_UnitsInContext ? v9_UnitsInContext->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcProjectLibrary


const IfcParse::entity& Ifc4::IfcProjectLibrary::declaration() const { return *((IfcParse::entity*)IFC4_types[723]); }
const IfcParse::entity& Ifc4::IfcProjectLibrary::Class() { return *((IfcParse::entity*)IFC4_types[723]); }
Ifc4::IfcProjectLibrary::IfcProjectLibrary(IfcEntityInstanceData&& e) : IfcContext(std::move(e)) { }
Ifc4::IfcProjectLibrary::IfcProjectLibrary(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_LongName, boost::optional< std::string > v7_Phase, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationContext >::ptr > v8_RepresentationContexts, ::Ifc4::IfcUnitAssignment* v9_UnitsInContext) : IfcContext(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_LongName) {set_attribute_value(5, (*v6_LongName)); } if (v7_Phase) {set_attribute_value(6, (*v7_Phase)); } if (v8_RepresentationContexts) {set_attribute_value(7, (*v8_RepresentationContexts)->generalize()); }set_attribute_value(8, v9_UnitsInContext ? v9_UnitsInContext->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcProjectOrder
boost::optional< ::Ifc4::IfcProjectOrderTypeEnum::Value > Ifc4::IfcProjectOrder::PredefinedType() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } return ::Ifc4::IfcProjectOrderTypeEnum::FromString(data_.get_attribute_value(6)); }
void Ifc4::IfcProjectOrder::setPredefinedType(boost::optional< ::Ifc4::IfcProjectOrderTypeEnum::Value > v) { if (v) {set_attribute_value(6, EnumerationReference(&::Ifc4::IfcProjectOrderTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcProjectOrder::Status() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcProjectOrder::setStatus(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcProjectOrder::LongDescription() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcProjectOrder::setLongDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcProjectOrder::declaration() const { return *((IfcParse::entity*)IFC4_types[724]); }
const IfcParse::entity& Ifc4::IfcProjectOrder::Class() { return *((IfcParse::entity*)IFC4_types[724]); }
Ifc4::IfcProjectOrder::IfcProjectOrder(IfcEntityInstanceData&& e) : IfcControl(std::move(e)) { }
Ifc4::IfcProjectOrder::IfcProjectOrder(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< ::Ifc4::IfcProjectOrderTypeEnum::Value > v7_PredefinedType, boost::optional< std::string > v8_Status, boost::optional< std::string > v9_LongDescription) : IfcControl(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_PredefinedType) {set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcProjectOrderTypeEnum::Class(),(size_t)*v7_PredefinedType))); } if (v8_Status) {set_attribute_value(7, (*v8_Status)); } if (v9_LongDescription) {set_attribute_value(8, (*v9_LongDescription)); }; populate_derived(); }

// Function implementations for IfcProjectedCRS
boost::optional< std::string > Ifc4::IfcProjectedCRS::MapProjection() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcProjectedCRS::setMapProjection(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcProjectedCRS::MapZone() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcProjectedCRS::setMapZone(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
::Ifc4::IfcNamedUnit* Ifc4::IfcProjectedCRS::MapUnit() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcNamedUnit>(true); }
void Ifc4::IfcProjectedCRS::setMapUnit(::Ifc4::IfcNamedUnit* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcProjectedCRS::declaration() const { return *((IfcParse::entity*)IFC4_types[719]); }
const IfcParse::entity& Ifc4::IfcProjectedCRS::Class() { return *((IfcParse::entity*)IFC4_types[719]); }
Ifc4::IfcProjectedCRS::IfcProjectedCRS(IfcEntityInstanceData&& e) : IfcCoordinateReferenceSystem(std::move(e)) { }
Ifc4::IfcProjectedCRS::IfcProjectedCRS(std::string v1_Name, boost::optional< std::string > v2_Description, boost::optional< std::string > v3_GeodeticDatum, boost::optional< std::string > v4_VerticalDatum, boost::optional< std::string > v5_MapProjection, boost::optional< std::string > v6_MapZone, ::Ifc4::IfcNamedUnit* v7_MapUnit) : IfcCoordinateReferenceSystem(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_GeodeticDatum) {set_attribute_value(2, (*v3_GeodeticDatum)); } if (v4_VerticalDatum) {set_attribute_value(3, (*v4_VerticalDatum)); } if (v5_MapProjection) {set_attribute_value(4, (*v5_MapProjection)); } if (v6_MapZone) {set_attribute_value(5, (*v6_MapZone)); }set_attribute_value(6, v7_MapUnit ? v7_MapUnit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcProjectionElement
boost::optional< ::Ifc4::IfcProjectionElementTypeEnum::Value > Ifc4::IfcProjectionElement::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcProjectionElementTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcProjectionElement::setPredefinedType(boost::optional< ::Ifc4::IfcProjectionElementTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcProjectionElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcProjectionElement::declaration() const { return *((IfcParse::entity*)IFC4_types[721]); }
const IfcParse::entity& Ifc4::IfcProjectionElement::Class() { return *((IfcParse::entity*)IFC4_types[721]); }
Ifc4::IfcProjectionElement::IfcProjectionElement(IfcEntityInstanceData&& e) : IfcFeatureElementAddition(std::move(e)) { }
Ifc4::IfcProjectionElement::IfcProjectionElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcProjectionElementTypeEnum::Value > v9_PredefinedType) : IfcFeatureElementAddition(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcProjectionElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcProperty
std::string Ifc4::IfcProperty::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcProperty::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcProperty::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcProperty::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }

::Ifc4::IfcPropertySet::list::ptr Ifc4::IfcProperty::PartOfPset() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[735], 4)->as<IfcPropertySet>(); }
::Ifc4::IfcPropertyDependencyRelationship::list::ptr Ifc4::IfcProperty::PropertyForDependance() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[730], 2)->as<IfcPropertyDependencyRelationship>(); }
::Ifc4::IfcPropertyDependencyRelationship::list::ptr Ifc4::IfcProperty::PropertyDependsOn() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[730], 3)->as<IfcPropertyDependencyRelationship>(); }
::Ifc4::IfcComplexProperty::list::ptr Ifc4::IfcProperty::PartOfComplex() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[162], 3)->as<IfcComplexProperty>(); }
::Ifc4::IfcResourceConstraintRelationship::list::ptr Ifc4::IfcProperty::HasConstraints() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[852], 3)->as<IfcResourceConstraintRelationship>(); }
::Ifc4::IfcResourceApprovalRelationship::list::ptr Ifc4::IfcProperty::HasApprovals() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[851], 2)->as<IfcResourceApprovalRelationship>(); }

const IfcParse::entity& Ifc4::IfcProperty::declaration() const { return *((IfcParse::entity*)IFC4_types[726]); }
const IfcParse::entity& Ifc4::IfcProperty::Class() { return *((IfcParse::entity*)IFC4_types[726]); }
Ifc4::IfcProperty::IfcProperty(IfcEntityInstanceData&& e) : IfcPropertyAbstraction(std::move(e)) { }
Ifc4::IfcProperty::IfcProperty(std::string v1_Name, boost::optional< std::string > v2_Description) : IfcPropertyAbstraction(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }; populate_derived(); }

// Function implementations for IfcPropertyAbstraction

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcPropertyAbstraction::HasExternalReferences() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }

const IfcParse::entity& Ifc4::IfcPropertyAbstraction::declaration() const { return *((IfcParse::entity*)IFC4_types[727]); }
const IfcParse::entity& Ifc4::IfcPropertyAbstraction::Class() { return *((IfcParse::entity*)IFC4_types[727]); }
Ifc4::IfcPropertyAbstraction::IfcPropertyAbstraction(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcPropertyAbstraction::IfcPropertyAbstraction() : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcPropertyBoundedValue
::Ifc4::IfcValue* Ifc4::IfcPropertyBoundedValue::UpperBoundValue() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcValue>(true); }
void Ifc4::IfcPropertyBoundedValue::setUpperBoundValue(::Ifc4::IfcValue* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcValue* Ifc4::IfcPropertyBoundedValue::LowerBoundValue() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcValue>(true); }
void Ifc4::IfcPropertyBoundedValue::setLowerBoundValue(::Ifc4::IfcValue* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcUnit* Ifc4::IfcPropertyBoundedValue::Unit() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcPropertyBoundedValue::setUnit(::Ifc4::IfcUnit* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcValue* Ifc4::IfcPropertyBoundedValue::SetPointValue() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcValue>(true); }
void Ifc4::IfcPropertyBoundedValue::setSetPointValue(::Ifc4::IfcValue* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcPropertyBoundedValue::declaration() const { return *((IfcParse::entity*)IFC4_types[728]); }
const IfcParse::entity& Ifc4::IfcPropertyBoundedValue::Class() { return *((IfcParse::entity*)IFC4_types[728]); }
Ifc4::IfcPropertyBoundedValue::IfcPropertyBoundedValue(IfcEntityInstanceData&& e) : IfcSimpleProperty(std::move(e)) { }
Ifc4::IfcPropertyBoundedValue::IfcPropertyBoundedValue(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcValue* v3_UpperBoundValue, ::Ifc4::IfcValue* v4_LowerBoundValue, ::Ifc4::IfcUnit* v5_Unit, ::Ifc4::IfcValue* v6_SetPointValue) : IfcSimpleProperty(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_UpperBoundValue ? v3_UpperBoundValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_LowerBoundValue ? v4_LowerBoundValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, v5_Unit ? v5_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_SetPointValue ? v6_SetPointValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPropertyDefinition

::Ifc4::IfcRelDeclares::list::ptr Ifc4::IfcPropertyDefinition::HasContext() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[826], 5)->as<IfcRelDeclares>(); }
::Ifc4::IfcRelAssociates::list::ptr Ifc4::IfcPropertyDefinition::HasAssociations() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[806], 4)->as<IfcRelAssociates>(); }

const IfcParse::entity& Ifc4::IfcPropertyDefinition::declaration() const { return *((IfcParse::entity*)IFC4_types[729]); }
const IfcParse::entity& Ifc4::IfcPropertyDefinition::Class() { return *((IfcParse::entity*)IFC4_types[729]); }
Ifc4::IfcPropertyDefinition::IfcPropertyDefinition(IfcEntityInstanceData&& e) : IfcRoot(std::move(e)) { }
Ifc4::IfcPropertyDefinition::IfcPropertyDefinition(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcRoot(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcPropertyDependencyRelationship
::Ifc4::IfcProperty* Ifc4::IfcPropertyDependencyRelationship::DependingProperty() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcProperty>(true); }
void Ifc4::IfcPropertyDependencyRelationship::setDependingProperty(::Ifc4::IfcProperty* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcProperty* Ifc4::IfcPropertyDependencyRelationship::DependantProperty() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcProperty>(true); }
void Ifc4::IfcPropertyDependencyRelationship::setDependantProperty(::Ifc4::IfcProperty* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcPropertyDependencyRelationship::Expression() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcPropertyDependencyRelationship::setExpression(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcPropertyDependencyRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[730]); }
const IfcParse::entity& Ifc4::IfcPropertyDependencyRelationship::Class() { return *((IfcParse::entity*)IFC4_types[730]); }
Ifc4::IfcPropertyDependencyRelationship::IfcPropertyDependencyRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcPropertyDependencyRelationship::IfcPropertyDependencyRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcProperty* v3_DependingProperty, ::Ifc4::IfcProperty* v4_DependantProperty, boost::optional< std::string > v5_Expression) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(5))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_DependingProperty ? v3_DependingProperty->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_DependantProperty ? v4_DependantProperty->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Expression) {set_attribute_value(4, (*v5_Expression)); }; populate_derived(); }

// Function implementations for IfcPropertyEnumeratedValue
boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > Ifc4::IfcPropertyEnumeratedValue::EnumerationValues() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcValue >(); }
void Ifc4::IfcPropertyEnumeratedValue::setEnumerationValues(boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v) { if (v) {set_attribute_value(2, (*v)->generalize());} else {unset_attribute_value(2);} }
::Ifc4::IfcPropertyEnumeration* Ifc4::IfcPropertyEnumeratedValue::EnumerationReference() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcPropertyEnumeration>(true); }
void Ifc4::IfcPropertyEnumeratedValue::setEnumerationReference(::Ifc4::IfcPropertyEnumeration* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcPropertyEnumeratedValue::declaration() const { return *((IfcParse::entity*)IFC4_types[731]); }
const IfcParse::entity& Ifc4::IfcPropertyEnumeratedValue::Class() { return *((IfcParse::entity*)IFC4_types[731]); }
Ifc4::IfcPropertyEnumeratedValue::IfcPropertyEnumeratedValue(IfcEntityInstanceData&& e) : IfcSimpleProperty(std::move(e)) { }
Ifc4::IfcPropertyEnumeratedValue::IfcPropertyEnumeratedValue(std::string v1_Name, boost::optional< std::string > v2_Description, boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v3_EnumerationValues, ::Ifc4::IfcPropertyEnumeration* v4_EnumerationReference) : IfcSimpleProperty(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_EnumerationValues) {set_attribute_value(2, (*v3_EnumerationValues)->generalize()); }set_attribute_value(3, v4_EnumerationReference ? v4_EnumerationReference->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPropertyEnumeration
std::string Ifc4::IfcPropertyEnumeration::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcPropertyEnumeration::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcValue >::ptr Ifc4::IfcPropertyEnumeration::EnumerationValues() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcValue >(); }
void Ifc4::IfcPropertyEnumeration::setEnumerationValues(aggregate_of< ::Ifc4::IfcValue >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcUnit* Ifc4::IfcPropertyEnumeration::Unit() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcPropertyEnumeration::setUnit(::Ifc4::IfcUnit* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcPropertyEnumeration::declaration() const { return *((IfcParse::entity*)IFC4_types[732]); }
const IfcParse::entity& Ifc4::IfcPropertyEnumeration::Class() { return *((IfcParse::entity*)IFC4_types[732]); }
Ifc4::IfcPropertyEnumeration::IfcPropertyEnumeration(IfcEntityInstanceData&& e) : IfcPropertyAbstraction(std::move(e)) { }
Ifc4::IfcPropertyEnumeration::IfcPropertyEnumeration(std::string v1_Name, aggregate_of< ::Ifc4::IfcValue >::ptr v2_EnumerationValues, ::Ifc4::IfcUnit* v3_Unit) : IfcPropertyAbstraction(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Name));set_attribute_value(1, (v2_EnumerationValues)->generalize());set_attribute_value(2, v3_Unit ? v3_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPropertyListValue
boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > Ifc4::IfcPropertyListValue::ListValues() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcValue >(); }
void Ifc4::IfcPropertyListValue::setListValues(boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v) { if (v) {set_attribute_value(2, (*v)->generalize());} else {unset_attribute_value(2);} }
::Ifc4::IfcUnit* Ifc4::IfcPropertyListValue::Unit() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcPropertyListValue::setUnit(::Ifc4::IfcUnit* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcPropertyListValue::declaration() const { return *((IfcParse::entity*)IFC4_types[733]); }
const IfcParse::entity& Ifc4::IfcPropertyListValue::Class() { return *((IfcParse::entity*)IFC4_types[733]); }
Ifc4::IfcPropertyListValue::IfcPropertyListValue(IfcEntityInstanceData&& e) : IfcSimpleProperty(std::move(e)) { }
Ifc4::IfcPropertyListValue::IfcPropertyListValue(std::string v1_Name, boost::optional< std::string > v2_Description, boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v3_ListValues, ::Ifc4::IfcUnit* v4_Unit) : IfcSimpleProperty(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_ListValues) {set_attribute_value(2, (*v3_ListValues)->generalize()); }set_attribute_value(3, v4_Unit ? v4_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPropertyReferenceValue
boost::optional< std::string > Ifc4::IfcPropertyReferenceValue::UsageName() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcPropertyReferenceValue::setUsageName(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
::Ifc4::IfcObjectReferenceSelect* Ifc4::IfcPropertyReferenceValue::PropertyReference() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcObjectReferenceSelect>(true); }
void Ifc4::IfcPropertyReferenceValue::setPropertyReference(::Ifc4::IfcObjectReferenceSelect* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcPropertyReferenceValue::declaration() const { return *((IfcParse::entity*)IFC4_types[734]); }
const IfcParse::entity& Ifc4::IfcPropertyReferenceValue::Class() { return *((IfcParse::entity*)IFC4_types[734]); }
Ifc4::IfcPropertyReferenceValue::IfcPropertyReferenceValue(IfcEntityInstanceData&& e) : IfcSimpleProperty(std::move(e)) { }
Ifc4::IfcPropertyReferenceValue::IfcPropertyReferenceValue(std::string v1_Name, boost::optional< std::string > v2_Description, boost::optional< std::string > v3_UsageName, ::Ifc4::IfcObjectReferenceSelect* v4_PropertyReference) : IfcSimpleProperty(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_UsageName) {set_attribute_value(2, (*v3_UsageName)); }set_attribute_value(3, v4_PropertyReference ? v4_PropertyReference->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPropertySet
aggregate_of< ::Ifc4::IfcProperty >::ptr Ifc4::IfcPropertySet::HasProperties() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcProperty >(); }
void Ifc4::IfcPropertySet::setHasProperties(aggregate_of< ::Ifc4::IfcProperty >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcPropertySet::declaration() const { return *((IfcParse::entity*)IFC4_types[735]); }
const IfcParse::entity& Ifc4::IfcPropertySet::Class() { return *((IfcParse::entity*)IFC4_types[735]); }
Ifc4::IfcPropertySet::IfcPropertySet(IfcEntityInstanceData&& e) : IfcPropertySetDefinition(std::move(e)) { }
Ifc4::IfcPropertySet::IfcPropertySet(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcProperty >::ptr v5_HasProperties) : IfcPropertySetDefinition(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_HasProperties)->generalize());; populate_derived(); }

// Function implementations for IfcPropertySetDefinition

::Ifc4::IfcTypeObject::list::ptr Ifc4::IfcPropertySetDefinition::DefinesType() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[1106], 5)->as<IfcTypeObject>(); }
::Ifc4::IfcRelDefinesByTemplate::list::ptr Ifc4::IfcPropertySetDefinition::IsDefinedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[831], 4)->as<IfcRelDefinesByTemplate>(); }
::Ifc4::IfcRelDefinesByProperties::list::ptr Ifc4::IfcPropertySetDefinition::DefinesOccurrence() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[830], 5)->as<IfcRelDefinesByProperties>(); }

const IfcParse::entity& Ifc4::IfcPropertySetDefinition::declaration() const { return *((IfcParse::entity*)IFC4_types[736]); }
const IfcParse::entity& Ifc4::IfcPropertySetDefinition::Class() { return *((IfcParse::entity*)IFC4_types[736]); }
Ifc4::IfcPropertySetDefinition::IfcPropertySetDefinition(IfcEntityInstanceData&& e) : IfcPropertyDefinition(std::move(e)) { }
Ifc4::IfcPropertySetDefinition::IfcPropertySetDefinition(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcPropertyDefinition(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcPropertySetTemplate
boost::optional< ::Ifc4::IfcPropertySetTemplateTypeEnum::Value > Ifc4::IfcPropertySetTemplate::TemplateType() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } return ::Ifc4::IfcPropertySetTemplateTypeEnum::FromString(data_.get_attribute_value(4)); }
void Ifc4::IfcPropertySetTemplate::setTemplateType(boost::optional< ::Ifc4::IfcPropertySetTemplateTypeEnum::Value > v) { if (v) {set_attribute_value(4, EnumerationReference(&::Ifc4::IfcPropertySetTemplateTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcPropertySetTemplate::ApplicableEntity() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcPropertySetTemplate::setApplicableEntity(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
aggregate_of< ::Ifc4::IfcPropertyTemplate >::ptr Ifc4::IfcPropertySetTemplate::HasPropertyTemplates() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(6); return es->as< ::Ifc4::IfcPropertyTemplate >(); }
void Ifc4::IfcPropertySetTemplate::setHasPropertyTemplates(aggregate_of< ::Ifc4::IfcPropertyTemplate >::ptr v) { set_attribute_value(6, (v)->generalize());if constexpr (false)unset_attribute_value(6); }

::Ifc4::IfcRelDefinesByTemplate::list::ptr Ifc4::IfcPropertySetTemplate::Defines() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[831], 5)->as<IfcRelDefinesByTemplate>(); }

const IfcParse::entity& Ifc4::IfcPropertySetTemplate::declaration() const { return *((IfcParse::entity*)IFC4_types[739]); }
const IfcParse::entity& Ifc4::IfcPropertySetTemplate::Class() { return *((IfcParse::entity*)IFC4_types[739]); }
Ifc4::IfcPropertySetTemplate::IfcPropertySetTemplate(IfcEntityInstanceData&& e) : IfcPropertyTemplateDefinition(std::move(e)) { }
Ifc4::IfcPropertySetTemplate::IfcPropertySetTemplate(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< ::Ifc4::IfcPropertySetTemplateTypeEnum::Value > v5_TemplateType, boost::optional< std::string > v6_ApplicableEntity, aggregate_of< ::Ifc4::IfcPropertyTemplate >::ptr v7_HasPropertyTemplates) : IfcPropertyTemplateDefinition(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_TemplateType) {set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcPropertySetTemplateTypeEnum::Class(),(size_t)*v5_TemplateType))); } if (v6_ApplicableEntity) {set_attribute_value(5, (*v6_ApplicableEntity)); }set_attribute_value(6, (v7_HasPropertyTemplates)->generalize());; populate_derived(); }

// Function implementations for IfcPropertySingleValue
::Ifc4::IfcValue* Ifc4::IfcPropertySingleValue::NominalValue() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcValue>(true); }
void Ifc4::IfcPropertySingleValue::setNominalValue(::Ifc4::IfcValue* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcUnit* Ifc4::IfcPropertySingleValue::Unit() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcPropertySingleValue::setUnit(::Ifc4::IfcUnit* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcPropertySingleValue::declaration() const { return *((IfcParse::entity*)IFC4_types[741]); }
const IfcParse::entity& Ifc4::IfcPropertySingleValue::Class() { return *((IfcParse::entity*)IFC4_types[741]); }
Ifc4::IfcPropertySingleValue::IfcPropertySingleValue(IfcEntityInstanceData&& e) : IfcSimpleProperty(std::move(e)) { }
Ifc4::IfcPropertySingleValue::IfcPropertySingleValue(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcValue* v3_NominalValue, ::Ifc4::IfcUnit* v4_Unit) : IfcSimpleProperty(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_NominalValue ? v3_NominalValue->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_Unit ? v4_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcPropertyTableValue
boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > Ifc4::IfcPropertyTableValue::DefiningValues() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcValue >(); }
void Ifc4::IfcPropertyTableValue::setDefiningValues(boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v) { if (v) {set_attribute_value(2, (*v)->generalize());} else {unset_attribute_value(2);} }
boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > Ifc4::IfcPropertyTableValue::DefinedValues() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcValue >(); }
void Ifc4::IfcPropertyTableValue::setDefinedValues(boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v) { if (v) {set_attribute_value(3, (*v)->generalize());} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcPropertyTableValue::Expression() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcPropertyTableValue::setExpression(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
::Ifc4::IfcUnit* Ifc4::IfcPropertyTableValue::DefiningUnit() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcPropertyTableValue::setDefiningUnit(::Ifc4::IfcUnit* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcUnit* Ifc4::IfcPropertyTableValue::DefinedUnit() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcPropertyTableValue::setDefinedUnit(::Ifc4::IfcUnit* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
boost::optional< ::Ifc4::IfcCurveInterpolationEnum::Value > Ifc4::IfcPropertyTableValue::CurveInterpolation() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } return ::Ifc4::IfcCurveInterpolationEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcPropertyTableValue::setCurveInterpolation(boost::optional< ::Ifc4::IfcCurveInterpolationEnum::Value > v) { if (v) {set_attribute_value(7, EnumerationReference(&::Ifc4::IfcCurveInterpolationEnum::Class(), (size_t) *v));} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcPropertyTableValue::declaration() const { return *((IfcParse::entity*)IFC4_types[742]); }
const IfcParse::entity& Ifc4::IfcPropertyTableValue::Class() { return *((IfcParse::entity*)IFC4_types[742]); }
Ifc4::IfcPropertyTableValue::IfcPropertyTableValue(IfcEntityInstanceData&& e) : IfcSimpleProperty(std::move(e)) { }
Ifc4::IfcPropertyTableValue::IfcPropertyTableValue(std::string v1_Name, boost::optional< std::string > v2_Description, boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v3_DefiningValues, boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v4_DefinedValues, boost::optional< std::string > v5_Expression, ::Ifc4::IfcUnit* v6_DefiningUnit, ::Ifc4::IfcUnit* v7_DefinedUnit, boost::optional< ::Ifc4::IfcCurveInterpolationEnum::Value > v8_CurveInterpolation) : IfcSimpleProperty(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_DefiningValues) {set_attribute_value(2, (*v3_DefiningValues)->generalize()); } if (v4_DefinedValues) {set_attribute_value(3, (*v4_DefinedValues)->generalize()); } if (v5_Expression) {set_attribute_value(4, (*v5_Expression)); }set_attribute_value(5, v6_DefiningUnit ? v6_DefiningUnit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_DefinedUnit ? v7_DefinedUnit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_CurveInterpolation) {set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcCurveInterpolationEnum::Class(),(size_t)*v8_CurveInterpolation))); }; populate_derived(); }

// Function implementations for IfcPropertyTemplate

::Ifc4::IfcComplexPropertyTemplate::list::ptr Ifc4::IfcPropertyTemplate::PartOfComplexTemplate() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[163], 6)->as<IfcComplexPropertyTemplate>(); }
::Ifc4::IfcPropertySetTemplate::list::ptr Ifc4::IfcPropertyTemplate::PartOfPsetTemplate() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[739], 6)->as<IfcPropertySetTemplate>(); }

const IfcParse::entity& Ifc4::IfcPropertyTemplate::declaration() const { return *((IfcParse::entity*)IFC4_types[743]); }
const IfcParse::entity& Ifc4::IfcPropertyTemplate::Class() { return *((IfcParse::entity*)IFC4_types[743]); }
Ifc4::IfcPropertyTemplate::IfcPropertyTemplate(IfcEntityInstanceData&& e) : IfcPropertyTemplateDefinition(std::move(e)) { }
Ifc4::IfcPropertyTemplate::IfcPropertyTemplate(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcPropertyTemplateDefinition(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcPropertyTemplateDefinition


const IfcParse::entity& Ifc4::IfcPropertyTemplateDefinition::declaration() const { return *((IfcParse::entity*)IFC4_types[744]); }
const IfcParse::entity& Ifc4::IfcPropertyTemplateDefinition::Class() { return *((IfcParse::entity*)IFC4_types[744]); }
Ifc4::IfcPropertyTemplateDefinition::IfcPropertyTemplateDefinition(IfcEntityInstanceData&& e) : IfcPropertyDefinition(std::move(e)) { }
Ifc4::IfcPropertyTemplateDefinition::IfcPropertyTemplateDefinition(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcPropertyDefinition(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcProtectiveDevice
boost::optional< ::Ifc4::IfcProtectiveDeviceTypeEnum::Value > Ifc4::IfcProtectiveDevice::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcProtectiveDeviceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcProtectiveDevice::setPredefinedType(boost::optional< ::Ifc4::IfcProtectiveDeviceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcProtectiveDeviceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcProtectiveDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[745]); }
const IfcParse::entity& Ifc4::IfcProtectiveDevice::Class() { return *((IfcParse::entity*)IFC4_types[745]); }
Ifc4::IfcProtectiveDevice::IfcProtectiveDevice(IfcEntityInstanceData&& e) : IfcFlowController(std::move(e)) { }
Ifc4::IfcProtectiveDevice::IfcProtectiveDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcProtectiveDeviceTypeEnum::Value > v9_PredefinedType) : IfcFlowController(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcProtectiveDeviceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcProtectiveDeviceTrippingUnit
boost::optional< ::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value > Ifc4::IfcProtectiveDeviceTrippingUnit::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcProtectiveDeviceTrippingUnit::setPredefinedType(boost::optional< ::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcProtectiveDeviceTrippingUnit::declaration() const { return *((IfcParse::entity*)IFC4_types[746]); }
const IfcParse::entity& Ifc4::IfcProtectiveDeviceTrippingUnit::Class() { return *((IfcParse::entity*)IFC4_types[746]); }
Ifc4::IfcProtectiveDeviceTrippingUnit::IfcProtectiveDeviceTrippingUnit(IfcEntityInstanceData&& e) : IfcDistributionControlElement(std::move(e)) { }
Ifc4::IfcProtectiveDeviceTrippingUnit::IfcProtectiveDeviceTrippingUnit(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value > v9_PredefinedType) : IfcDistributionControlElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcProtectiveDeviceTrippingUnitType
::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value Ifc4::IfcProtectiveDeviceTrippingUnitType::PredefinedType() const {  return ::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcProtectiveDeviceTrippingUnitType::setPredefinedType(::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcProtectiveDeviceTrippingUnitType::declaration() const { return *((IfcParse::entity*)IFC4_types[747]); }
const IfcParse::entity& Ifc4::IfcProtectiveDeviceTrippingUnitType::Class() { return *((IfcParse::entity*)IFC4_types[747]); }
Ifc4::IfcProtectiveDeviceTrippingUnitType::IfcProtectiveDeviceTrippingUnitType(IfcEntityInstanceData&& e) : IfcDistributionControlElementType(std::move(e)) { }
Ifc4::IfcProtectiveDeviceTrippingUnitType::IfcProtectiveDeviceTrippingUnitType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Value v10_PredefinedType) : IfcDistributionControlElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcProtectiveDeviceTrippingUnitTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcProtectiveDeviceType
::Ifc4::IfcProtectiveDeviceTypeEnum::Value Ifc4::IfcProtectiveDeviceType::PredefinedType() const {  return ::Ifc4::IfcProtectiveDeviceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcProtectiveDeviceType::setPredefinedType(::Ifc4::IfcProtectiveDeviceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcProtectiveDeviceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcProtectiveDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[749]); }
const IfcParse::entity& Ifc4::IfcProtectiveDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[749]); }
Ifc4::IfcProtectiveDeviceType::IfcProtectiveDeviceType(IfcEntityInstanceData&& e) : IfcFlowControllerType(std::move(e)) { }
Ifc4::IfcProtectiveDeviceType::IfcProtectiveDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcProtectiveDeviceTypeEnum::Value v10_PredefinedType) : IfcFlowControllerType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcProtectiveDeviceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcProxy
::Ifc4::IfcObjectTypeEnum::Value Ifc4::IfcProxy::ProxyType() const {  return ::Ifc4::IfcObjectTypeEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcProxy::setProxyType(::Ifc4::IfcObjectTypeEnum::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }
boost::optional< std::string > Ifc4::IfcProxy::Tag() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcProxy::setTag(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcProxy::declaration() const { return *((IfcParse::entity*)IFC4_types[751]); }
const IfcParse::entity& Ifc4::IfcProxy::Class() { return *((IfcParse::entity*)IFC4_types[751]); }
Ifc4::IfcProxy::IfcProxy(IfcEntityInstanceData&& e) : IfcProduct(std::move(e)) { }
Ifc4::IfcProxy::IfcProxy(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcObjectTypeEnum::Value v8_ProxyType, boost::optional< std::string > v9_Tag) : IfcProduct(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)v8_ProxyType))); if (v9_Tag) {set_attribute_value(8, (*v9_Tag)); }; populate_derived(); }

// Function implementations for IfcPump
boost::optional< ::Ifc4::IfcPumpTypeEnum::Value > Ifc4::IfcPump::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcPumpTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcPump::setPredefinedType(boost::optional< ::Ifc4::IfcPumpTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcPumpTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcPump::declaration() const { return *((IfcParse::entity*)IFC4_types[752]); }
const IfcParse::entity& Ifc4::IfcPump::Class() { return *((IfcParse::entity*)IFC4_types[752]); }
Ifc4::IfcPump::IfcPump(IfcEntityInstanceData&& e) : IfcFlowMovingDevice(std::move(e)) { }
Ifc4::IfcPump::IfcPump(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcPumpTypeEnum::Value > v9_PredefinedType) : IfcFlowMovingDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcPumpTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcPumpType
::Ifc4::IfcPumpTypeEnum::Value Ifc4::IfcPumpType::PredefinedType() const {  return ::Ifc4::IfcPumpTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcPumpType::setPredefinedType(::Ifc4::IfcPumpTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcPumpTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcPumpType::declaration() const { return *((IfcParse::entity*)IFC4_types[753]); }
const IfcParse::entity& Ifc4::IfcPumpType::Class() { return *((IfcParse::entity*)IFC4_types[753]); }
Ifc4::IfcPumpType::IfcPumpType(IfcEntityInstanceData&& e) : IfcFlowMovingDeviceType(std::move(e)) { }
Ifc4::IfcPumpType::IfcPumpType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcPumpTypeEnum::Value v10_PredefinedType) : IfcFlowMovingDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcPumpTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcQuantityArea
double Ifc4::IfcQuantityArea::AreaValue() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcQuantityArea::setAreaValue(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcQuantityArea::Formula() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcQuantityArea::setFormula(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcQuantityArea::declaration() const { return *((IfcParse::entity*)IFC4_types[755]); }
const IfcParse::entity& Ifc4::IfcQuantityArea::Class() { return *((IfcParse::entity*)IFC4_types[755]); }
Ifc4::IfcQuantityArea::IfcQuantityArea(IfcEntityInstanceData&& e) : IfcPhysicalSimpleQuantity(std::move(e)) { }
Ifc4::IfcQuantityArea::IfcQuantityArea(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcNamedUnit* v3_Unit, double v4_AreaValue, boost::optional< std::string > v5_Formula) : IfcPhysicalSimpleQuantity(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Unit ? v3_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_AreaValue)); if (v5_Formula) {set_attribute_value(4, (*v5_Formula)); }; populate_derived(); }

// Function implementations for IfcQuantityCount
double Ifc4::IfcQuantityCount::CountValue() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcQuantityCount::setCountValue(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcQuantityCount::Formula() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcQuantityCount::setFormula(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcQuantityCount::declaration() const { return *((IfcParse::entity*)IFC4_types[756]); }
const IfcParse::entity& Ifc4::IfcQuantityCount::Class() { return *((IfcParse::entity*)IFC4_types[756]); }
Ifc4::IfcQuantityCount::IfcQuantityCount(IfcEntityInstanceData&& e) : IfcPhysicalSimpleQuantity(std::move(e)) { }
Ifc4::IfcQuantityCount::IfcQuantityCount(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcNamedUnit* v3_Unit, double v4_CountValue, boost::optional< std::string > v5_Formula) : IfcPhysicalSimpleQuantity(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Unit ? v3_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_CountValue)); if (v5_Formula) {set_attribute_value(4, (*v5_Formula)); }; populate_derived(); }

// Function implementations for IfcQuantityLength
double Ifc4::IfcQuantityLength::LengthValue() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcQuantityLength::setLengthValue(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcQuantityLength::Formula() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcQuantityLength::setFormula(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcQuantityLength::declaration() const { return *((IfcParse::entity*)IFC4_types[757]); }
const IfcParse::entity& Ifc4::IfcQuantityLength::Class() { return *((IfcParse::entity*)IFC4_types[757]); }
Ifc4::IfcQuantityLength::IfcQuantityLength(IfcEntityInstanceData&& e) : IfcPhysicalSimpleQuantity(std::move(e)) { }
Ifc4::IfcQuantityLength::IfcQuantityLength(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcNamedUnit* v3_Unit, double v4_LengthValue, boost::optional< std::string > v5_Formula) : IfcPhysicalSimpleQuantity(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Unit ? v3_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_LengthValue)); if (v5_Formula) {set_attribute_value(4, (*v5_Formula)); }; populate_derived(); }

// Function implementations for IfcQuantitySet


const IfcParse::entity& Ifc4::IfcQuantitySet::declaration() const { return *((IfcParse::entity*)IFC4_types[758]); }
const IfcParse::entity& Ifc4::IfcQuantitySet::Class() { return *((IfcParse::entity*)IFC4_types[758]); }
Ifc4::IfcQuantitySet::IfcQuantitySet(IfcEntityInstanceData&& e) : IfcPropertySetDefinition(std::move(e)) { }
Ifc4::IfcQuantitySet::IfcQuantitySet(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcPropertySetDefinition(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcQuantityTime
double Ifc4::IfcQuantityTime::TimeValue() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcQuantityTime::setTimeValue(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcQuantityTime::Formula() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcQuantityTime::setFormula(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcQuantityTime::declaration() const { return *((IfcParse::entity*)IFC4_types[759]); }
const IfcParse::entity& Ifc4::IfcQuantityTime::Class() { return *((IfcParse::entity*)IFC4_types[759]); }
Ifc4::IfcQuantityTime::IfcQuantityTime(IfcEntityInstanceData&& e) : IfcPhysicalSimpleQuantity(std::move(e)) { }
Ifc4::IfcQuantityTime::IfcQuantityTime(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcNamedUnit* v3_Unit, double v4_TimeValue, boost::optional< std::string > v5_Formula) : IfcPhysicalSimpleQuantity(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Unit ? v3_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_TimeValue)); if (v5_Formula) {set_attribute_value(4, (*v5_Formula)); }; populate_derived(); }

// Function implementations for IfcQuantityVolume
double Ifc4::IfcQuantityVolume::VolumeValue() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcQuantityVolume::setVolumeValue(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcQuantityVolume::Formula() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcQuantityVolume::setFormula(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcQuantityVolume::declaration() const { return *((IfcParse::entity*)IFC4_types[760]); }
const IfcParse::entity& Ifc4::IfcQuantityVolume::Class() { return *((IfcParse::entity*)IFC4_types[760]); }
Ifc4::IfcQuantityVolume::IfcQuantityVolume(IfcEntityInstanceData&& e) : IfcPhysicalSimpleQuantity(std::move(e)) { }
Ifc4::IfcQuantityVolume::IfcQuantityVolume(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcNamedUnit* v3_Unit, double v4_VolumeValue, boost::optional< std::string > v5_Formula) : IfcPhysicalSimpleQuantity(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Unit ? v3_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_VolumeValue)); if (v5_Formula) {set_attribute_value(4, (*v5_Formula)); }; populate_derived(); }

// Function implementations for IfcQuantityWeight
double Ifc4::IfcQuantityWeight::WeightValue() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcQuantityWeight::setWeightValue(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcQuantityWeight::Formula() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcQuantityWeight::setFormula(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcQuantityWeight::declaration() const { return *((IfcParse::entity*)IFC4_types[761]); }
const IfcParse::entity& Ifc4::IfcQuantityWeight::Class() { return *((IfcParse::entity*)IFC4_types[761]); }
Ifc4::IfcQuantityWeight::IfcQuantityWeight(IfcEntityInstanceData&& e) : IfcPhysicalSimpleQuantity(std::move(e)) { }
Ifc4::IfcQuantityWeight::IfcQuantityWeight(std::string v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcNamedUnit* v3_Unit, double v4_WeightValue, boost::optional< std::string > v5_Formula) : IfcPhysicalSimpleQuantity(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_Unit ? v3_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_WeightValue)); if (v5_Formula) {set_attribute_value(4, (*v5_Formula)); }; populate_derived(); }

// Function implementations for IfcRailing
boost::optional< ::Ifc4::IfcRailingTypeEnum::Value > Ifc4::IfcRailing::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcRailingTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcRailing::setPredefinedType(boost::optional< ::Ifc4::IfcRailingTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcRailingTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcRailing::declaration() const { return *((IfcParse::entity*)IFC4_types[763]); }
const IfcParse::entity& Ifc4::IfcRailing::Class() { return *((IfcParse::entity*)IFC4_types[763]); }
Ifc4::IfcRailing::IfcRailing(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcRailing::IfcRailing(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcRailingTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcRailingTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcRailingType
::Ifc4::IfcRailingTypeEnum::Value Ifc4::IfcRailingType::PredefinedType() const {  return ::Ifc4::IfcRailingTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcRailingType::setPredefinedType(::Ifc4::IfcRailingTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcRailingTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcRailingType::declaration() const { return *((IfcParse::entity*)IFC4_types[764]); }
const IfcParse::entity& Ifc4::IfcRailingType::Class() { return *((IfcParse::entity*)IFC4_types[764]); }
Ifc4::IfcRailingType::IfcRailingType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcRailingType::IfcRailingType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcRailingTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcRailingTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcRamp
boost::optional< ::Ifc4::IfcRampTypeEnum::Value > Ifc4::IfcRamp::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcRampTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcRamp::setPredefinedType(boost::optional< ::Ifc4::IfcRampTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcRampTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcRamp::declaration() const { return *((IfcParse::entity*)IFC4_types[766]); }
const IfcParse::entity& Ifc4::IfcRamp::Class() { return *((IfcParse::entity*)IFC4_types[766]); }
Ifc4::IfcRamp::IfcRamp(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcRamp::IfcRamp(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcRampTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcRampTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcRampFlight
boost::optional< ::Ifc4::IfcRampFlightTypeEnum::Value > Ifc4::IfcRampFlight::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcRampFlightTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcRampFlight::setPredefinedType(boost::optional< ::Ifc4::IfcRampFlightTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcRampFlightTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcRampFlight::declaration() const { return *((IfcParse::entity*)IFC4_types[767]); }
const IfcParse::entity& Ifc4::IfcRampFlight::Class() { return *((IfcParse::entity*)IFC4_types[767]); }
Ifc4::IfcRampFlight::IfcRampFlight(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcRampFlight::IfcRampFlight(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcRampFlightTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcRampFlightTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcRampFlightType
::Ifc4::IfcRampFlightTypeEnum::Value Ifc4::IfcRampFlightType::PredefinedType() const {  return ::Ifc4::IfcRampFlightTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcRampFlightType::setPredefinedType(::Ifc4::IfcRampFlightTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcRampFlightTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcRampFlightType::declaration() const { return *((IfcParse::entity*)IFC4_types[768]); }
const IfcParse::entity& Ifc4::IfcRampFlightType::Class() { return *((IfcParse::entity*)IFC4_types[768]); }
Ifc4::IfcRampFlightType::IfcRampFlightType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcRampFlightType::IfcRampFlightType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcRampFlightTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcRampFlightTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcRampType
::Ifc4::IfcRampTypeEnum::Value Ifc4::IfcRampType::PredefinedType() const {  return ::Ifc4::IfcRampTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcRampType::setPredefinedType(::Ifc4::IfcRampTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcRampTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcRampType::declaration() const { return *((IfcParse::entity*)IFC4_types[770]); }
const IfcParse::entity& Ifc4::IfcRampType::Class() { return *((IfcParse::entity*)IFC4_types[770]); }
Ifc4::IfcRampType::IfcRampType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcRampType::IfcRampType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcRampTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcRampTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcRationalBSplineCurveWithKnots
std::vector< double > /*[2:?]*/ Ifc4::IfcRationalBSplineCurveWithKnots::WeightsData() const {  std::vector< double > /*[2:?]*/ v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcRationalBSplineCurveWithKnots::setWeightsData(std::vector< double > /*[2:?]*/ v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcRationalBSplineCurveWithKnots::declaration() const { return *((IfcParse::entity*)IFC4_types[773]); }
const IfcParse::entity& Ifc4::IfcRationalBSplineCurveWithKnots::Class() { return *((IfcParse::entity*)IFC4_types[773]); }
Ifc4::IfcRationalBSplineCurveWithKnots::IfcRationalBSplineCurveWithKnots(IfcEntityInstanceData&& e) : IfcBSplineCurveWithKnots(std::move(e)) { }
Ifc4::IfcRationalBSplineCurveWithKnots::IfcRationalBSplineCurveWithKnots(int v1_Degree, aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v2_ControlPointsList, ::Ifc4::IfcBSplineCurveForm::Value v3_CurveForm, boost::logic::tribool v4_ClosedCurve, boost::logic::tribool v5_SelfIntersect, std::vector< int > /*[2:?]*/ v6_KnotMultiplicities, std::vector< double > /*[2:?]*/ v7_Knots, ::Ifc4::IfcKnotType::Value v8_KnotSpec, std::vector< double > /*[2:?]*/ v9_WeightsData) : IfcBSplineCurveWithKnots(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_Degree));set_attribute_value(1, (v2_ControlPointsList)->generalize());set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcBSplineCurveForm::Class(),(size_t)v3_CurveForm)));set_attribute_value(3, (v4_ClosedCurve));set_attribute_value(4, (v5_SelfIntersect));set_attribute_value(5, (v6_KnotMultiplicities));set_attribute_value(6, (v7_Knots));set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcKnotType::Class(),(size_t)v8_KnotSpec)));set_attribute_value(8, (v9_WeightsData));; populate_derived(); }

// Function implementations for IfcRationalBSplineSurfaceWithKnots
std::vector< std::vector< double > > Ifc4::IfcRationalBSplineSurfaceWithKnots::WeightsData() const {  std::vector< std::vector< double > > v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcRationalBSplineSurfaceWithKnots::setWeightsData(std::vector< std::vector< double > > v) { set_attribute_value(12, v);if constexpr (false)unset_attribute_value(12); }


const IfcParse::entity& Ifc4::IfcRationalBSplineSurfaceWithKnots::declaration() const { return *((IfcParse::entity*)IFC4_types[774]); }
const IfcParse::entity& Ifc4::IfcRationalBSplineSurfaceWithKnots::Class() { return *((IfcParse::entity*)IFC4_types[774]); }
Ifc4::IfcRationalBSplineSurfaceWithKnots::IfcRationalBSplineSurfaceWithKnots(IfcEntityInstanceData&& e) : IfcBSplineSurfaceWithKnots(std::move(e)) { }
Ifc4::IfcRationalBSplineSurfaceWithKnots::IfcRationalBSplineSurfaceWithKnots(int v1_UDegree, int v2_VDegree, aggregate_of_aggregate_of< ::Ifc4::IfcCartesianPoint >::ptr v3_ControlPointsList, ::Ifc4::IfcBSplineSurfaceForm::Value v4_SurfaceForm, boost::logic::tribool v5_UClosed, boost::logic::tribool v6_VClosed, boost::logic::tribool v7_SelfIntersect, std::vector< int > /*[2:?]*/ v8_UMultiplicities, std::vector< int > /*[2:?]*/ v9_VMultiplicities, std::vector< double > /*[2:?]*/ v10_UKnots, std::vector< double > /*[2:?]*/ v11_VKnots, ::Ifc4::IfcKnotType::Value v12_KnotSpec, std::vector< std::vector< double > > v13_WeightsData) : IfcBSplineSurfaceWithKnots(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_UDegree));set_attribute_value(1, (v2_VDegree));set_attribute_value(2, (v3_ControlPointsList)->generalize());set_attribute_value(3, (EnumerationReference(&::Ifc4::IfcBSplineSurfaceForm::Class(),(size_t)v4_SurfaceForm)));set_attribute_value(4, (v5_UClosed));set_attribute_value(5, (v6_VClosed));set_attribute_value(6, (v7_SelfIntersect));set_attribute_value(7, (v8_UMultiplicities));set_attribute_value(8, (v9_VMultiplicities));set_attribute_value(9, (v10_UKnots));set_attribute_value(10, (v11_VKnots));set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcKnotType::Class(),(size_t)v12_KnotSpec)));set_attribute_value(12, (v13_WeightsData));; populate_derived(); }

// Function implementations for IfcRectangleHollowProfileDef
double Ifc4::IfcRectangleHollowProfileDef::WallThickness() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcRectangleHollowProfileDef::setWallThickness(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
boost::optional< double > Ifc4::IfcRectangleHollowProfileDef::InnerFilletRadius() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcRectangleHollowProfileDef::setInnerFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< double > Ifc4::IfcRectangleHollowProfileDef::OuterFilletRadius() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcRectangleHollowProfileDef::setOuterFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcRectangleHollowProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[776]); }
const IfcParse::entity& Ifc4::IfcRectangleHollowProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[776]); }
Ifc4::IfcRectangleHollowProfileDef::IfcRectangleHollowProfileDef(IfcEntityInstanceData&& e) : IfcRectangleProfileDef(std::move(e)) { }
Ifc4::IfcRectangleHollowProfileDef::IfcRectangleHollowProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_XDim, double v5_YDim, double v6_WallThickness, boost::optional< double > v7_InnerFilletRadius, boost::optional< double > v8_OuterFilletRadius) : IfcRectangleProfileDef(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_XDim));set_attribute_value(4, (v5_YDim));set_attribute_value(5, (v6_WallThickness)); if (v7_InnerFilletRadius) {set_attribute_value(6, (*v7_InnerFilletRadius)); } if (v8_OuterFilletRadius) {set_attribute_value(7, (*v8_OuterFilletRadius)); }; populate_derived(); }

// Function implementations for IfcRectangleProfileDef
double Ifc4::IfcRectangleProfileDef::XDim() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcRectangleProfileDef::setXDim(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcRectangleProfileDef::YDim() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcRectangleProfileDef::setYDim(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcRectangleProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[777]); }
const IfcParse::entity& Ifc4::IfcRectangleProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[777]); }
Ifc4::IfcRectangleProfileDef::IfcRectangleProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcRectangleProfileDef::IfcRectangleProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_XDim, double v5_YDim) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_XDim));set_attribute_value(4, (v5_YDim));; populate_derived(); }

// Function implementations for IfcRectangularPyramid
double Ifc4::IfcRectangularPyramid::XLength() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcRectangularPyramid::setXLength(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcRectangularPyramid::YLength() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcRectangularPyramid::setYLength(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcRectangularPyramid::Height() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcRectangularPyramid::setHeight(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcRectangularPyramid::declaration() const { return *((IfcParse::entity*)IFC4_types[778]); }
const IfcParse::entity& Ifc4::IfcRectangularPyramid::Class() { return *((IfcParse::entity*)IFC4_types[778]); }
Ifc4::IfcRectangularPyramid::IfcRectangularPyramid(IfcEntityInstanceData&& e) : IfcCsgPrimitive3D(std::move(e)) { }
Ifc4::IfcRectangularPyramid::IfcRectangularPyramid(::Ifc4::IfcAxis2Placement3D* v1_Position, double v2_XLength, double v3_YLength, double v4_Height) : IfcCsgPrimitive3D(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_XLength));set_attribute_value(2, (v3_YLength));set_attribute_value(3, (v4_Height));; populate_derived(); }

// Function implementations for IfcRectangularTrimmedSurface
::Ifc4::IfcSurface* Ifc4::IfcRectangularTrimmedSurface::BasisSurface() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcSurface>(true); }
void Ifc4::IfcRectangularTrimmedSurface::setBasisSurface(::Ifc4::IfcSurface* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcRectangularTrimmedSurface::U1() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcRectangularTrimmedSurface::setU1(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcRectangularTrimmedSurface::V1() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcRectangularTrimmedSurface::setV1(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcRectangularTrimmedSurface::U2() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcRectangularTrimmedSurface::setU2(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcRectangularTrimmedSurface::V2() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcRectangularTrimmedSurface::setV2(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
bool Ifc4::IfcRectangularTrimmedSurface::Usense() const {  bool v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcRectangularTrimmedSurface::setUsense(bool v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
bool Ifc4::IfcRectangularTrimmedSurface::Vsense() const {  bool v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcRectangularTrimmedSurface::setVsense(bool v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcRectangularTrimmedSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[779]); }
const IfcParse::entity& Ifc4::IfcRectangularTrimmedSurface::Class() { return *((IfcParse::entity*)IFC4_types[779]); }
Ifc4::IfcRectangularTrimmedSurface::IfcRectangularTrimmedSurface(IfcEntityInstanceData&& e) : IfcBoundedSurface(std::move(e)) { }
Ifc4::IfcRectangularTrimmedSurface::IfcRectangularTrimmedSurface(::Ifc4::IfcSurface* v1_BasisSurface, double v2_U1, double v3_V1, double v4_U2, double v5_V2, bool v6_Usense, bool v7_Vsense) : IfcBoundedSurface(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, v1_BasisSurface ? v1_BasisSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_U1));set_attribute_value(2, (v3_V1));set_attribute_value(3, (v4_U2));set_attribute_value(4, (v5_V2));set_attribute_value(5, (v6_Usense));set_attribute_value(6, (v7_Vsense));; populate_derived(); }

// Function implementations for IfcRecurrencePattern
::Ifc4::IfcRecurrenceTypeEnum::Value Ifc4::IfcRecurrencePattern::RecurrenceType() const {  return ::Ifc4::IfcRecurrenceTypeEnum::FromString(data_.get_attribute_value(0)); }
void Ifc4::IfcRecurrencePattern::setRecurrenceType(::Ifc4::IfcRecurrenceTypeEnum::Value v) { set_attribute_value(0, EnumerationReference(&::Ifc4::IfcRecurrenceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(0); }
boost::optional< std::vector< int > /*[1:?]*/ > Ifc4::IfcRecurrencePattern::DayComponent() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::vector< int > /*[1:?]*/ v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcRecurrencePattern::setDayComponent(boost::optional< std::vector< int > /*[1:?]*/ > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::vector< int > /*[1:?]*/ > Ifc4::IfcRecurrencePattern::WeekdayComponent() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::vector< int > /*[1:?]*/ v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcRecurrencePattern::setWeekdayComponent(boost::optional< std::vector< int > /*[1:?]*/ > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::vector< int > /*[1:?]*/ > Ifc4::IfcRecurrencePattern::MonthComponent() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::vector< int > /*[1:?]*/ v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcRecurrencePattern::setMonthComponent(boost::optional< std::vector< int > /*[1:?]*/ > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< int > Ifc4::IfcRecurrencePattern::Position() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } int v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcRecurrencePattern::setPosition(boost::optional< int > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< int > Ifc4::IfcRecurrencePattern::Interval() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } int v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcRecurrencePattern::setInterval(boost::optional< int > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< int > Ifc4::IfcRecurrencePattern::Occurrences() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } int v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcRecurrencePattern::setOccurrences(boost::optional< int > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< aggregate_of< ::Ifc4::IfcTimePeriod >::ptr > Ifc4::IfcRecurrencePattern::TimePeriods() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcTimePeriod >(); }
void Ifc4::IfcRecurrencePattern::setTimePeriods(boost::optional< aggregate_of< ::Ifc4::IfcTimePeriod >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcRecurrencePattern::declaration() const { return *((IfcParse::entity*)IFC4_types[780]); }
const IfcParse::entity& Ifc4::IfcRecurrencePattern::Class() { return *((IfcParse::entity*)IFC4_types[780]); }
Ifc4::IfcRecurrencePattern::IfcRecurrencePattern(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcRecurrencePattern::IfcRecurrencePattern(::Ifc4::IfcRecurrenceTypeEnum::Value v1_RecurrenceType, boost::optional< std::vector< int > /*[1:?]*/ > v2_DayComponent, boost::optional< std::vector< int > /*[1:?]*/ > v3_WeekdayComponent, boost::optional< std::vector< int > /*[1:?]*/ > v4_MonthComponent, boost::optional< int > v5_Position, boost::optional< int > v6_Interval, boost::optional< int > v7_Occurrences, boost::optional< aggregate_of< ::Ifc4::IfcTimePeriod >::ptr > v8_TimePeriods) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcRecurrenceTypeEnum::Class(),(size_t)v1_RecurrenceType))); if (v2_DayComponent) {set_attribute_value(1, (*v2_DayComponent)); } if (v3_WeekdayComponent) {set_attribute_value(2, (*v3_WeekdayComponent)); } if (v4_MonthComponent) {set_attribute_value(3, (*v4_MonthComponent)); } if (v5_Position) {set_attribute_value(4, (*v5_Position)); } if (v6_Interval) {set_attribute_value(5, (*v6_Interval)); } if (v7_Occurrences) {set_attribute_value(6, (*v7_Occurrences)); } if (v8_TimePeriods) {set_attribute_value(7, (*v8_TimePeriods)->generalize()); }; populate_derived(); }

// Function implementations for IfcReference
boost::optional< std::string > Ifc4::IfcReference::TypeIdentifier() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcReference::setTypeIdentifier(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcReference::AttributeIdentifier() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcReference::setAttributeIdentifier(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcReference::InstanceName() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcReference::setInstanceName(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::vector< int > /*[1:?]*/ > Ifc4::IfcReference::ListPositions() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::vector< int > /*[1:?]*/ v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcReference::setListPositions(boost::optional< std::vector< int > /*[1:?]*/ > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
::Ifc4::IfcReference* Ifc4::IfcReference::InnerReference() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcReference>(true); }
void Ifc4::IfcReference::setInnerReference(::Ifc4::IfcReference* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcReference::declaration() const { return *((IfcParse::entity*)IFC4_types[782]); }
const IfcParse::entity& Ifc4::IfcReference::Class() { return *((IfcParse::entity*)IFC4_types[782]); }
Ifc4::IfcReference::IfcReference(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcReference::IfcReference(boost::optional< std::string > v1_TypeIdentifier, boost::optional< std::string > v2_AttributeIdentifier, boost::optional< std::string > v3_InstanceName, boost::optional< std::vector< int > /*[1:?]*/ > v4_ListPositions, ::Ifc4::IfcReference* v5_InnerReference) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(5))) {  if (v1_TypeIdentifier) {set_attribute_value(0, (*v1_TypeIdentifier)); } if (v2_AttributeIdentifier) {set_attribute_value(1, (*v2_AttributeIdentifier)); } if (v3_InstanceName) {set_attribute_value(2, (*v3_InstanceName)); } if (v4_ListPositions) {set_attribute_value(3, (*v4_ListPositions)); }set_attribute_value(4, v5_InnerReference ? v5_InnerReference->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRegularTimeSeries
double Ifc4::IfcRegularTimeSeries::TimeStep() const {  double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcRegularTimeSeries::setTimeStep(double v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }
aggregate_of< ::Ifc4::IfcTimeSeriesValue >::ptr Ifc4::IfcRegularTimeSeries::Values() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(9); return es->as< ::Ifc4::IfcTimeSeriesValue >(); }
void Ifc4::IfcRegularTimeSeries::setValues(aggregate_of< ::Ifc4::IfcTimeSeriesValue >::ptr v) { set_attribute_value(9, (v)->generalize());if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcRegularTimeSeries::declaration() const { return *((IfcParse::entity*)IFC4_types[784]); }
const IfcParse::entity& Ifc4::IfcRegularTimeSeries::Class() { return *((IfcParse::entity*)IFC4_types[784]); }
Ifc4::IfcRegularTimeSeries::IfcRegularTimeSeries(IfcEntityInstanceData&& e) : IfcTimeSeries(std::move(e)) { }
Ifc4::IfcRegularTimeSeries::IfcRegularTimeSeries(std::string v1_Name, boost::optional< std::string > v2_Description, std::string v3_StartTime, std::string v4_EndTime, ::Ifc4::IfcTimeSeriesDataTypeEnum::Value v5_TimeSeriesDataType, ::Ifc4::IfcDataOriginEnum::Value v6_DataOrigin, boost::optional< std::string > v7_UserDefinedDataOrigin, ::Ifc4::IfcUnit* v8_Unit, double v9_TimeStep, aggregate_of< ::Ifc4::IfcTimeSeriesValue >::ptr v10_Values) : IfcTimeSeries(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_StartTime));set_attribute_value(3, (v4_EndTime));set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcTimeSeriesDataTypeEnum::Class(),(size_t)v5_TimeSeriesDataType)));set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)v6_DataOrigin))); if (v7_UserDefinedDataOrigin) {set_attribute_value(6, (*v7_UserDefinedDataOrigin)); }set_attribute_value(7, v8_Unit ? v8_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (v9_TimeStep));set_attribute_value(9, (v10_Values)->generalize());; populate_derived(); }

// Function implementations for IfcReinforcementBarProperties
double Ifc4::IfcReinforcementBarProperties::TotalCrossSectionArea() const {  double v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcReinforcementBarProperties::setTotalCrossSectionArea(double v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
std::string Ifc4::IfcReinforcementBarProperties::SteelGrade() const {  std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcReinforcementBarProperties::setSteelGrade(std::string v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > Ifc4::IfcReinforcementBarProperties::BarSurface() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } return ::Ifc4::IfcReinforcingBarSurfaceEnum::FromString(data_.get_attribute_value(2)); }
void Ifc4::IfcReinforcementBarProperties::setBarSurface(boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > v) { if (v) {set_attribute_value(2, EnumerationReference(&::Ifc4::IfcReinforcingBarSurfaceEnum::Class(), (size_t) *v));} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcReinforcementBarProperties::EffectiveDepth() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcReinforcementBarProperties::setEffectiveDepth(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcReinforcementBarProperties::NominalBarDiameter() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcReinforcementBarProperties::setNominalBarDiameter(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< double > Ifc4::IfcReinforcementBarProperties::BarCount() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcReinforcementBarProperties::setBarCount(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }


const IfcParse::entity& Ifc4::IfcReinforcementBarProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[785]); }
const IfcParse::entity& Ifc4::IfcReinforcementBarProperties::Class() { return *((IfcParse::entity*)IFC4_types[785]); }
Ifc4::IfcReinforcementBarProperties::IfcReinforcementBarProperties(IfcEntityInstanceData&& e) : IfcPreDefinedProperties(std::move(e)) { }
Ifc4::IfcReinforcementBarProperties::IfcReinforcementBarProperties(double v1_TotalCrossSectionArea, std::string v2_SteelGrade, boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > v3_BarSurface, boost::optional< double > v4_EffectiveDepth, boost::optional< double > v5_NominalBarDiameter, boost::optional< double > v6_BarCount) : IfcPreDefinedProperties(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_TotalCrossSectionArea));set_attribute_value(1, (v2_SteelGrade)); if (v3_BarSurface) {set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcReinforcingBarSurfaceEnum::Class(),(size_t)*v3_BarSurface))); } if (v4_EffectiveDepth) {set_attribute_value(3, (*v4_EffectiveDepth)); } if (v5_NominalBarDiameter) {set_attribute_value(4, (*v5_NominalBarDiameter)); } if (v6_BarCount) {set_attribute_value(5, (*v6_BarCount)); }; populate_derived(); }

// Function implementations for IfcReinforcementDefinitionProperties
boost::optional< std::string > Ifc4::IfcReinforcementDefinitionProperties::DefinitionType() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcReinforcementDefinitionProperties::setDefinitionType(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
aggregate_of< ::Ifc4::IfcSectionReinforcementProperties >::ptr Ifc4::IfcReinforcementDefinitionProperties::ReinforcementSectionDefinitions() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcSectionReinforcementProperties >(); }
void Ifc4::IfcReinforcementDefinitionProperties::setReinforcementSectionDefinitions(aggregate_of< ::Ifc4::IfcSectionReinforcementProperties >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcReinforcementDefinitionProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[786]); }
const IfcParse::entity& Ifc4::IfcReinforcementDefinitionProperties::Class() { return *((IfcParse::entity*)IFC4_types[786]); }
Ifc4::IfcReinforcementDefinitionProperties::IfcReinforcementDefinitionProperties(IfcEntityInstanceData&& e) : IfcPreDefinedPropertySet(std::move(e)) { }
Ifc4::IfcReinforcementDefinitionProperties::IfcReinforcementDefinitionProperties(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_DefinitionType, aggregate_of< ::Ifc4::IfcSectionReinforcementProperties >::ptr v6_ReinforcementSectionDefinitions) : IfcPreDefinedPropertySet(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_DefinitionType) {set_attribute_value(4, (*v5_DefinitionType)); }set_attribute_value(5, (v6_ReinforcementSectionDefinitions)->generalize());; populate_derived(); }

// Function implementations for IfcReinforcingBar
boost::optional< double > Ifc4::IfcReinforcingBar::NominalDiameter() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcReinforcingBar::setNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcReinforcingBar::CrossSectionArea() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcReinforcingBar::setCrossSectionArea(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcReinforcingBar::BarLength() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcReinforcingBar::setBarLength(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< ::Ifc4::IfcReinforcingBarTypeEnum::Value > Ifc4::IfcReinforcingBar::PredefinedType() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } return ::Ifc4::IfcReinforcingBarTypeEnum::FromString(data_.get_attribute_value(12)); }
void Ifc4::IfcReinforcingBar::setPredefinedType(boost::optional< ::Ifc4::IfcReinforcingBarTypeEnum::Value > v) { if (v) {set_attribute_value(12, EnumerationReference(&::Ifc4::IfcReinforcingBarTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(12);} }
boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > Ifc4::IfcReinforcingBar::BarSurface() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } return ::Ifc4::IfcReinforcingBarSurfaceEnum::FromString(data_.get_attribute_value(13)); }
void Ifc4::IfcReinforcingBar::setBarSurface(boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > v) { if (v) {set_attribute_value(13, EnumerationReference(&::Ifc4::IfcReinforcingBarSurfaceEnum::Class(), (size_t) *v));} else {unset_attribute_value(13);} }


const IfcParse::entity& Ifc4::IfcReinforcingBar::declaration() const { return *((IfcParse::entity*)IFC4_types[787]); }
const IfcParse::entity& Ifc4::IfcReinforcingBar::Class() { return *((IfcParse::entity*)IFC4_types[787]); }
Ifc4::IfcReinforcingBar::IfcReinforcingBar(IfcEntityInstanceData&& e) : IfcReinforcingElement(std::move(e)) { }
Ifc4::IfcReinforcingBar::IfcReinforcingBar(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_SteelGrade, boost::optional< double > v10_NominalDiameter, boost::optional< double > v11_CrossSectionArea, boost::optional< double > v12_BarLength, boost::optional< ::Ifc4::IfcReinforcingBarTypeEnum::Value > v13_PredefinedType, boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > v14_BarSurface) : IfcReinforcingElement(IfcEntityInstanceData(storage_t(14))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_SteelGrade) {set_attribute_value(8, (*v9_SteelGrade)); } if (v10_NominalDiameter) {set_attribute_value(9, (*v10_NominalDiameter)); } if (v11_CrossSectionArea) {set_attribute_value(10, (*v11_CrossSectionArea)); } if (v12_BarLength) {set_attribute_value(11, (*v12_BarLength)); } if (v13_PredefinedType) {set_attribute_value(12, (EnumerationReference(&::Ifc4::IfcReinforcingBarTypeEnum::Class(),(size_t)*v13_PredefinedType))); } if (v14_BarSurface) {set_attribute_value(13, (EnumerationReference(&::Ifc4::IfcReinforcingBarSurfaceEnum::Class(),(size_t)*v14_BarSurface))); }; populate_derived(); }

// Function implementations for IfcReinforcingBarType
::Ifc4::IfcReinforcingBarTypeEnum::Value Ifc4::IfcReinforcingBarType::PredefinedType() const {  return ::Ifc4::IfcReinforcingBarTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcReinforcingBarType::setPredefinedType(::Ifc4::IfcReinforcingBarTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcReinforcingBarTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< double > Ifc4::IfcReinforcingBarType::NominalDiameter() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcReinforcingBarType::setNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcReinforcingBarType::CrossSectionArea() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcReinforcingBarType::setCrossSectionArea(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< double > Ifc4::IfcReinforcingBarType::BarLength() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcReinforcingBarType::setBarLength(boost::optional< double > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > Ifc4::IfcReinforcingBarType::BarSurface() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } return ::Ifc4::IfcReinforcingBarSurfaceEnum::FromString(data_.get_attribute_value(13)); }
void Ifc4::IfcReinforcingBarType::setBarSurface(boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > v) { if (v) {set_attribute_value(13, EnumerationReference(&::Ifc4::IfcReinforcingBarSurfaceEnum::Class(), (size_t) *v));} else {unset_attribute_value(13);} }
boost::optional< std::string > Ifc4::IfcReinforcingBarType::BendingShapeCode() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcReinforcingBarType::setBendingShapeCode(boost::optional< std::string > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }
boost::optional< aggregate_of< ::Ifc4::IfcBendingParameterSelect >::ptr > Ifc4::IfcReinforcingBarType::BendingParameters() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(15); return es->as< ::Ifc4::IfcBendingParameterSelect >(); }
void Ifc4::IfcReinforcingBarType::setBendingParameters(boost::optional< aggregate_of< ::Ifc4::IfcBendingParameterSelect >::ptr > v) { if (v) {set_attribute_value(15, (*v)->generalize());} else {unset_attribute_value(15);} }


const IfcParse::entity& Ifc4::IfcReinforcingBarType::declaration() const { return *((IfcParse::entity*)IFC4_types[790]); }
const IfcParse::entity& Ifc4::IfcReinforcingBarType::Class() { return *((IfcParse::entity*)IFC4_types[790]); }
Ifc4::IfcReinforcingBarType::IfcReinforcingBarType(IfcEntityInstanceData&& e) : IfcReinforcingElementType(std::move(e)) { }
Ifc4::IfcReinforcingBarType::IfcReinforcingBarType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcReinforcingBarTypeEnum::Value v10_PredefinedType, boost::optional< double > v11_NominalDiameter, boost::optional< double > v12_CrossSectionArea, boost::optional< double > v13_BarLength, boost::optional< ::Ifc4::IfcReinforcingBarSurfaceEnum::Value > v14_BarSurface, boost::optional< std::string > v15_BendingShapeCode, boost::optional< aggregate_of< ::Ifc4::IfcBendingParameterSelect >::ptr > v16_BendingParameters) : IfcReinforcingElementType(IfcEntityInstanceData(storage_t(16))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcReinforcingBarTypeEnum::Class(),(size_t)v10_PredefinedType))); if (v11_NominalDiameter) {set_attribute_value(10, (*v11_NominalDiameter)); } if (v12_CrossSectionArea) {set_attribute_value(11, (*v12_CrossSectionArea)); } if (v13_BarLength) {set_attribute_value(12, (*v13_BarLength)); } if (v14_BarSurface) {set_attribute_value(13, (EnumerationReference(&::Ifc4::IfcReinforcingBarSurfaceEnum::Class(),(size_t)*v14_BarSurface))); } if (v15_BendingShapeCode) {set_attribute_value(14, (*v15_BendingShapeCode)); } if (v16_BendingParameters) {set_attribute_value(15, (*v16_BendingParameters)->generalize()); }; populate_derived(); }

// Function implementations for IfcReinforcingElement
boost::optional< std::string > Ifc4::IfcReinforcingElement::SteelGrade() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcReinforcingElement::setSteelGrade(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcReinforcingElement::declaration() const { return *((IfcParse::entity*)IFC4_types[792]); }
const IfcParse::entity& Ifc4::IfcReinforcingElement::Class() { return *((IfcParse::entity*)IFC4_types[792]); }
Ifc4::IfcReinforcingElement::IfcReinforcingElement(IfcEntityInstanceData&& e) : IfcElementComponent(std::move(e)) { }
Ifc4::IfcReinforcingElement::IfcReinforcingElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_SteelGrade) : IfcElementComponent(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_SteelGrade) {set_attribute_value(8, (*v9_SteelGrade)); }; populate_derived(); }

// Function implementations for IfcReinforcingElementType


const IfcParse::entity& Ifc4::IfcReinforcingElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[793]); }
const IfcParse::entity& Ifc4::IfcReinforcingElementType::Class() { return *((IfcParse::entity*)IFC4_types[793]); }
Ifc4::IfcReinforcingElementType::IfcReinforcingElementType(IfcEntityInstanceData&& e) : IfcElementComponentType(std::move(e)) { }
Ifc4::IfcReinforcingElementType::IfcReinforcingElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcElementComponentType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcReinforcingMesh
boost::optional< double > Ifc4::IfcReinforcingMesh::MeshLength() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcReinforcingMesh::setMeshLength(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcReinforcingMesh::MeshWidth() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcReinforcingMesh::setMeshWidth(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcReinforcingMesh::LongitudinalBarNominalDiameter() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcReinforcingMesh::setLongitudinalBarNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< double > Ifc4::IfcReinforcingMesh::TransverseBarNominalDiameter() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcReinforcingMesh::setTransverseBarNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< double > Ifc4::IfcReinforcingMesh::LongitudinalBarCrossSectionArea() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } double v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcReinforcingMesh::setLongitudinalBarCrossSectionArea(boost::optional< double > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
boost::optional< double > Ifc4::IfcReinforcingMesh::TransverseBarCrossSectionArea() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } double v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcReinforcingMesh::setTransverseBarCrossSectionArea(boost::optional< double > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }
boost::optional< double > Ifc4::IfcReinforcingMesh::LongitudinalBarSpacing() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } double v = data_.get_attribute_value(15); return v; }
void Ifc4::IfcReinforcingMesh::setLongitudinalBarSpacing(boost::optional< double > v) { if (v) {set_attribute_value(15, *v);} else {unset_attribute_value(15);} }
boost::optional< double > Ifc4::IfcReinforcingMesh::TransverseBarSpacing() const { if(data_.get_attribute_value(16).isNull()) { return boost::none; } double v = data_.get_attribute_value(16); return v; }
void Ifc4::IfcReinforcingMesh::setTransverseBarSpacing(boost::optional< double > v) { if (v) {set_attribute_value(16, *v);} else {unset_attribute_value(16);} }
boost::optional< ::Ifc4::IfcReinforcingMeshTypeEnum::Value > Ifc4::IfcReinforcingMesh::PredefinedType() const { if(data_.get_attribute_value(17).isNull()) { return boost::none; } return ::Ifc4::IfcReinforcingMeshTypeEnum::FromString(data_.get_attribute_value(17)); }
void Ifc4::IfcReinforcingMesh::setPredefinedType(boost::optional< ::Ifc4::IfcReinforcingMeshTypeEnum::Value > v) { if (v) {set_attribute_value(17, EnumerationReference(&::Ifc4::IfcReinforcingMeshTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(17);} }


const IfcParse::entity& Ifc4::IfcReinforcingMesh::declaration() const { return *((IfcParse::entity*)IFC4_types[794]); }
const IfcParse::entity& Ifc4::IfcReinforcingMesh::Class() { return *((IfcParse::entity*)IFC4_types[794]); }
Ifc4::IfcReinforcingMesh::IfcReinforcingMesh(IfcEntityInstanceData&& e) : IfcReinforcingElement(std::move(e)) { }
Ifc4::IfcReinforcingMesh::IfcReinforcingMesh(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_SteelGrade, boost::optional< double > v10_MeshLength, boost::optional< double > v11_MeshWidth, boost::optional< double > v12_LongitudinalBarNominalDiameter, boost::optional< double > v13_TransverseBarNominalDiameter, boost::optional< double > v14_LongitudinalBarCrossSectionArea, boost::optional< double > v15_TransverseBarCrossSectionArea, boost::optional< double > v16_LongitudinalBarSpacing, boost::optional< double > v17_TransverseBarSpacing, boost::optional< ::Ifc4::IfcReinforcingMeshTypeEnum::Value > v18_PredefinedType) : IfcReinforcingElement(IfcEntityInstanceData(storage_t(18))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_SteelGrade) {set_attribute_value(8, (*v9_SteelGrade)); } if (v10_MeshLength) {set_attribute_value(9, (*v10_MeshLength)); } if (v11_MeshWidth) {set_attribute_value(10, (*v11_MeshWidth)); } if (v12_LongitudinalBarNominalDiameter) {set_attribute_value(11, (*v12_LongitudinalBarNominalDiameter)); } if (v13_TransverseBarNominalDiameter) {set_attribute_value(12, (*v13_TransverseBarNominalDiameter)); } if (v14_LongitudinalBarCrossSectionArea) {set_attribute_value(13, (*v14_LongitudinalBarCrossSectionArea)); } if (v15_TransverseBarCrossSectionArea) {set_attribute_value(14, (*v15_TransverseBarCrossSectionArea)); } if (v16_LongitudinalBarSpacing) {set_attribute_value(15, (*v16_LongitudinalBarSpacing)); } if (v17_TransverseBarSpacing) {set_attribute_value(16, (*v17_TransverseBarSpacing)); } if (v18_PredefinedType) {set_attribute_value(17, (EnumerationReference(&::Ifc4::IfcReinforcingMeshTypeEnum::Class(),(size_t)*v18_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcReinforcingMeshType
::Ifc4::IfcReinforcingMeshTypeEnum::Value Ifc4::IfcReinforcingMeshType::PredefinedType() const {  return ::Ifc4::IfcReinforcingMeshTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcReinforcingMeshType::setPredefinedType(::Ifc4::IfcReinforcingMeshTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcReinforcingMeshTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< double > Ifc4::IfcReinforcingMeshType::MeshLength() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcReinforcingMeshType::setMeshLength(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcReinforcingMeshType::MeshWidth() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcReinforcingMeshType::setMeshWidth(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< double > Ifc4::IfcReinforcingMeshType::LongitudinalBarNominalDiameter() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcReinforcingMeshType::setLongitudinalBarNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< double > Ifc4::IfcReinforcingMeshType::TransverseBarNominalDiameter() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } double v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcReinforcingMeshType::setTransverseBarNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
boost::optional< double > Ifc4::IfcReinforcingMeshType::LongitudinalBarCrossSectionArea() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } double v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcReinforcingMeshType::setLongitudinalBarCrossSectionArea(boost::optional< double > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }
boost::optional< double > Ifc4::IfcReinforcingMeshType::TransverseBarCrossSectionArea() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } double v = data_.get_attribute_value(15); return v; }
void Ifc4::IfcReinforcingMeshType::setTransverseBarCrossSectionArea(boost::optional< double > v) { if (v) {set_attribute_value(15, *v);} else {unset_attribute_value(15);} }
boost::optional< double > Ifc4::IfcReinforcingMeshType::LongitudinalBarSpacing() const { if(data_.get_attribute_value(16).isNull()) { return boost::none; } double v = data_.get_attribute_value(16); return v; }
void Ifc4::IfcReinforcingMeshType::setLongitudinalBarSpacing(boost::optional< double > v) { if (v) {set_attribute_value(16, *v);} else {unset_attribute_value(16);} }
boost::optional< double > Ifc4::IfcReinforcingMeshType::TransverseBarSpacing() const { if(data_.get_attribute_value(17).isNull()) { return boost::none; } double v = data_.get_attribute_value(17); return v; }
void Ifc4::IfcReinforcingMeshType::setTransverseBarSpacing(boost::optional< double > v) { if (v) {set_attribute_value(17, *v);} else {unset_attribute_value(17);} }
boost::optional< std::string > Ifc4::IfcReinforcingMeshType::BendingShapeCode() const { if(data_.get_attribute_value(18).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(18); return v; }
void Ifc4::IfcReinforcingMeshType::setBendingShapeCode(boost::optional< std::string > v) { if (v) {set_attribute_value(18, *v);} else {unset_attribute_value(18);} }
boost::optional< aggregate_of< ::Ifc4::IfcBendingParameterSelect >::ptr > Ifc4::IfcReinforcingMeshType::BendingParameters() const { if(data_.get_attribute_value(19).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(19); return es->as< ::Ifc4::IfcBendingParameterSelect >(); }
void Ifc4::IfcReinforcingMeshType::setBendingParameters(boost::optional< aggregate_of< ::Ifc4::IfcBendingParameterSelect >::ptr > v) { if (v) {set_attribute_value(19, (*v)->generalize());} else {unset_attribute_value(19);} }


const IfcParse::entity& Ifc4::IfcReinforcingMeshType::declaration() const { return *((IfcParse::entity*)IFC4_types[795]); }
const IfcParse::entity& Ifc4::IfcReinforcingMeshType::Class() { return *((IfcParse::entity*)IFC4_types[795]); }
Ifc4::IfcReinforcingMeshType::IfcReinforcingMeshType(IfcEntityInstanceData&& e) : IfcReinforcingElementType(std::move(e)) { }
Ifc4::IfcReinforcingMeshType::IfcReinforcingMeshType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcReinforcingMeshTypeEnum::Value v10_PredefinedType, boost::optional< double > v11_MeshLength, boost::optional< double > v12_MeshWidth, boost::optional< double > v13_LongitudinalBarNominalDiameter, boost::optional< double > v14_TransverseBarNominalDiameter, boost::optional< double > v15_LongitudinalBarCrossSectionArea, boost::optional< double > v16_TransverseBarCrossSectionArea, boost::optional< double > v17_LongitudinalBarSpacing, boost::optional< double > v18_TransverseBarSpacing, boost::optional< std::string > v19_BendingShapeCode, boost::optional< aggregate_of< ::Ifc4::IfcBendingParameterSelect >::ptr > v20_BendingParameters) : IfcReinforcingElementType(IfcEntityInstanceData(storage_t(20))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcReinforcingMeshTypeEnum::Class(),(size_t)v10_PredefinedType))); if (v11_MeshLength) {set_attribute_value(10, (*v11_MeshLength)); } if (v12_MeshWidth) {set_attribute_value(11, (*v12_MeshWidth)); } if (v13_LongitudinalBarNominalDiameter) {set_attribute_value(12, (*v13_LongitudinalBarNominalDiameter)); } if (v14_TransverseBarNominalDiameter) {set_attribute_value(13, (*v14_TransverseBarNominalDiameter)); } if (v15_LongitudinalBarCrossSectionArea) {set_attribute_value(14, (*v15_LongitudinalBarCrossSectionArea)); } if (v16_TransverseBarCrossSectionArea) {set_attribute_value(15, (*v16_TransverseBarCrossSectionArea)); } if (v17_LongitudinalBarSpacing) {set_attribute_value(16, (*v17_LongitudinalBarSpacing)); } if (v18_TransverseBarSpacing) {set_attribute_value(17, (*v18_TransverseBarSpacing)); } if (v19_BendingShapeCode) {set_attribute_value(18, (*v19_BendingShapeCode)); } if (v20_BendingParameters) {set_attribute_value(19, (*v20_BendingParameters)->generalize()); }; populate_derived(); }

// Function implementations for IfcRelAggregates
::Ifc4::IfcObjectDefinition* Ifc4::IfcRelAggregates::RelatingObject() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcObjectDefinition>(true); }
void Ifc4::IfcRelAggregates::setRelatingObject(::Ifc4::IfcObjectDefinition* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr Ifc4::IfcRelAggregates::RelatedObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcObjectDefinition >(); }
void Ifc4::IfcRelAggregates::setRelatedObjects(aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelAggregates::declaration() const { return *((IfcParse::entity*)IFC4_types[797]); }
const IfcParse::entity& Ifc4::IfcRelAggregates::Class() { return *((IfcParse::entity*)IFC4_types[797]); }
Ifc4::IfcRelAggregates::IfcRelAggregates(IfcEntityInstanceData&& e) : IfcRelDecomposes(std::move(e)) { }
Ifc4::IfcRelAggregates::IfcRelAggregates(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcObjectDefinition* v5_RelatingObject, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v6_RelatedObjects) : IfcRelDecomposes(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingObject ? v5_RelatingObject->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_RelatedObjects)->generalize());; populate_derived(); }

// Function implementations for IfcRelAssigns
aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr Ifc4::IfcRelAssigns::RelatedObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcObjectDefinition >(); }
void Ifc4::IfcRelAssigns::setRelatedObjects(aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }
boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > Ifc4::IfcRelAssigns::RelatedObjectsType() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } return ::Ifc4::IfcObjectTypeEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcRelAssigns::setRelatedObjectsType(boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v) { if (v) {set_attribute_value(5, EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(5);} }


const IfcParse::entity& Ifc4::IfcRelAssigns::declaration() const { return *((IfcParse::entity*)IFC4_types[798]); }
const IfcParse::entity& Ifc4::IfcRelAssigns::Class() { return *((IfcParse::entity*)IFC4_types[798]); }
Ifc4::IfcRelAssigns::IfcRelAssigns(IfcEntityInstanceData&& e) : IfcRelationship(std::move(e)) { }
Ifc4::IfcRelAssigns::IfcRelAssigns(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v6_RelatedObjectsType) : IfcRelationship(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_RelatedObjectsType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)*v6_RelatedObjectsType))); }; populate_derived(); }

// Function implementations for IfcRelAssignsToActor
::Ifc4::IfcActor* Ifc4::IfcRelAssignsToActor::RelatingActor() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcActor>(true); }
void Ifc4::IfcRelAssignsToActor::setRelatingActor(::Ifc4::IfcActor* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
::Ifc4::IfcActorRole* Ifc4::IfcRelAssignsToActor::ActingRole() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcActorRole>(true); }
void Ifc4::IfcRelAssignsToActor::setActingRole(::Ifc4::IfcActorRole* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }


const IfcParse::entity& Ifc4::IfcRelAssignsToActor::declaration() const { return *((IfcParse::entity*)IFC4_types[799]); }
const IfcParse::entity& Ifc4::IfcRelAssignsToActor::Class() { return *((IfcParse::entity*)IFC4_types[799]); }
Ifc4::IfcRelAssignsToActor::IfcRelAssignsToActor(IfcEntityInstanceData&& e) : IfcRelAssigns(std::move(e)) { }
Ifc4::IfcRelAssignsToActor::IfcRelAssignsToActor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v6_RelatedObjectsType, ::Ifc4::IfcActor* v7_RelatingActor, ::Ifc4::IfcActorRole* v8_ActingRole) : IfcRelAssigns(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_RelatedObjectsType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)*v6_RelatedObjectsType))); }set_attribute_value(6, v7_RelatingActor ? v7_RelatingActor->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_ActingRole ? v8_ActingRole->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssignsToControl
::Ifc4::IfcControl* Ifc4::IfcRelAssignsToControl::RelatingControl() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcControl>(true); }
void Ifc4::IfcRelAssignsToControl::setRelatingControl(::Ifc4::IfcControl* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcRelAssignsToControl::declaration() const { return *((IfcParse::entity*)IFC4_types[800]); }
const IfcParse::entity& Ifc4::IfcRelAssignsToControl::Class() { return *((IfcParse::entity*)IFC4_types[800]); }
Ifc4::IfcRelAssignsToControl::IfcRelAssignsToControl(IfcEntityInstanceData&& e) : IfcRelAssigns(std::move(e)) { }
Ifc4::IfcRelAssignsToControl::IfcRelAssignsToControl(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v6_RelatedObjectsType, ::Ifc4::IfcControl* v7_RelatingControl) : IfcRelAssigns(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_RelatedObjectsType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)*v6_RelatedObjectsType))); }set_attribute_value(6, v7_RelatingControl ? v7_RelatingControl->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssignsToGroup
::Ifc4::IfcGroup* Ifc4::IfcRelAssignsToGroup::RelatingGroup() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcGroup>(true); }
void Ifc4::IfcRelAssignsToGroup::setRelatingGroup(::Ifc4::IfcGroup* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcRelAssignsToGroup::declaration() const { return *((IfcParse::entity*)IFC4_types[801]); }
const IfcParse::entity& Ifc4::IfcRelAssignsToGroup::Class() { return *((IfcParse::entity*)IFC4_types[801]); }
Ifc4::IfcRelAssignsToGroup::IfcRelAssignsToGroup(IfcEntityInstanceData&& e) : IfcRelAssigns(std::move(e)) { }
Ifc4::IfcRelAssignsToGroup::IfcRelAssignsToGroup(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v6_RelatedObjectsType, ::Ifc4::IfcGroup* v7_RelatingGroup) : IfcRelAssigns(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_RelatedObjectsType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)*v6_RelatedObjectsType))); }set_attribute_value(6, v7_RelatingGroup ? v7_RelatingGroup->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssignsToGroupByFactor
double Ifc4::IfcRelAssignsToGroupByFactor::Factor() const {  double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcRelAssignsToGroupByFactor::setFactor(double v) { set_attribute_value(7, v);if constexpr (false)unset_attribute_value(7); }


const IfcParse::entity& Ifc4::IfcRelAssignsToGroupByFactor::declaration() const { return *((IfcParse::entity*)IFC4_types[802]); }
const IfcParse::entity& Ifc4::IfcRelAssignsToGroupByFactor::Class() { return *((IfcParse::entity*)IFC4_types[802]); }
Ifc4::IfcRelAssignsToGroupByFactor::IfcRelAssignsToGroupByFactor(IfcEntityInstanceData&& e) : IfcRelAssignsToGroup(std::move(e)) { }
Ifc4::IfcRelAssignsToGroupByFactor::IfcRelAssignsToGroupByFactor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v6_RelatedObjectsType, ::Ifc4::IfcGroup* v7_RelatingGroup, double v8_Factor) : IfcRelAssignsToGroup(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_RelatedObjectsType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)*v6_RelatedObjectsType))); }set_attribute_value(6, v7_RelatingGroup ? v7_RelatingGroup->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (v8_Factor));; populate_derived(); }

// Function implementations for IfcRelAssignsToProcess
::Ifc4::IfcProcessSelect* Ifc4::IfcRelAssignsToProcess::RelatingProcess() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcProcessSelect>(true); }
void Ifc4::IfcRelAssignsToProcess::setRelatingProcess(::Ifc4::IfcProcessSelect* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
::Ifc4::IfcMeasureWithUnit* Ifc4::IfcRelAssignsToProcess::QuantityInProcess() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcMeasureWithUnit>(true); }
void Ifc4::IfcRelAssignsToProcess::setQuantityInProcess(::Ifc4::IfcMeasureWithUnit* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }


const IfcParse::entity& Ifc4::IfcRelAssignsToProcess::declaration() const { return *((IfcParse::entity*)IFC4_types[803]); }
const IfcParse::entity& Ifc4::IfcRelAssignsToProcess::Class() { return *((IfcParse::entity*)IFC4_types[803]); }
Ifc4::IfcRelAssignsToProcess::IfcRelAssignsToProcess(IfcEntityInstanceData&& e) : IfcRelAssigns(std::move(e)) { }
Ifc4::IfcRelAssignsToProcess::IfcRelAssignsToProcess(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v6_RelatedObjectsType, ::Ifc4::IfcProcessSelect* v7_RelatingProcess, ::Ifc4::IfcMeasureWithUnit* v8_QuantityInProcess) : IfcRelAssigns(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_RelatedObjectsType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)*v6_RelatedObjectsType))); }set_attribute_value(6, v7_RelatingProcess ? v7_RelatingProcess->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_QuantityInProcess ? v8_QuantityInProcess->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssignsToProduct
::Ifc4::IfcProductSelect* Ifc4::IfcRelAssignsToProduct::RelatingProduct() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcProductSelect>(true); }
void Ifc4::IfcRelAssignsToProduct::setRelatingProduct(::Ifc4::IfcProductSelect* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcRelAssignsToProduct::declaration() const { return *((IfcParse::entity*)IFC4_types[804]); }
const IfcParse::entity& Ifc4::IfcRelAssignsToProduct::Class() { return *((IfcParse::entity*)IFC4_types[804]); }
Ifc4::IfcRelAssignsToProduct::IfcRelAssignsToProduct(IfcEntityInstanceData&& e) : IfcRelAssigns(std::move(e)) { }
Ifc4::IfcRelAssignsToProduct::IfcRelAssignsToProduct(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v6_RelatedObjectsType, ::Ifc4::IfcProductSelect* v7_RelatingProduct) : IfcRelAssigns(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_RelatedObjectsType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)*v6_RelatedObjectsType))); }set_attribute_value(6, v7_RelatingProduct ? v7_RelatingProduct->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssignsToResource
::Ifc4::IfcResourceSelect* Ifc4::IfcRelAssignsToResource::RelatingResource() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcResourceSelect>(true); }
void Ifc4::IfcRelAssignsToResource::setRelatingResource(::Ifc4::IfcResourceSelect* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcRelAssignsToResource::declaration() const { return *((IfcParse::entity*)IFC4_types[805]); }
const IfcParse::entity& Ifc4::IfcRelAssignsToResource::Class() { return *((IfcParse::entity*)IFC4_types[805]); }
Ifc4::IfcRelAssignsToResource::IfcRelAssignsToResource(IfcEntityInstanceData&& e) : IfcRelAssigns(std::move(e)) { }
Ifc4::IfcRelAssignsToResource::IfcRelAssignsToResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, boost::optional< ::Ifc4::IfcObjectTypeEnum::Value > v6_RelatedObjectsType, ::Ifc4::IfcResourceSelect* v7_RelatingResource) : IfcRelAssigns(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_RelatedObjectsType) {set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcObjectTypeEnum::Class(),(size_t)*v6_RelatedObjectsType))); }set_attribute_value(6, v7_RelatingResource ? v7_RelatingResource->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssociates
aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr Ifc4::IfcRelAssociates::RelatedObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcDefinitionSelect >(); }
void Ifc4::IfcRelAssociates::setRelatedObjects(aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcRelAssociates::declaration() const { return *((IfcParse::entity*)IFC4_types[806]); }
const IfcParse::entity& Ifc4::IfcRelAssociates::Class() { return *((IfcParse::entity*)IFC4_types[806]); }
Ifc4::IfcRelAssociates::IfcRelAssociates(IfcEntityInstanceData&& e) : IfcRelationship(std::move(e)) { }
Ifc4::IfcRelAssociates::IfcRelAssociates(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v5_RelatedObjects) : IfcRelationship(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());; populate_derived(); }

// Function implementations for IfcRelAssociatesApproval
::Ifc4::IfcApproval* Ifc4::IfcRelAssociatesApproval::RelatingApproval() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcApproval>(true); }
void Ifc4::IfcRelAssociatesApproval::setRelatingApproval(::Ifc4::IfcApproval* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelAssociatesApproval::declaration() const { return *((IfcParse::entity*)IFC4_types[807]); }
const IfcParse::entity& Ifc4::IfcRelAssociatesApproval::Class() { return *((IfcParse::entity*)IFC4_types[807]); }
Ifc4::IfcRelAssociatesApproval::IfcRelAssociatesApproval(IfcEntityInstanceData&& e) : IfcRelAssociates(std::move(e)) { }
Ifc4::IfcRelAssociatesApproval::IfcRelAssociatesApproval(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v5_RelatedObjects, ::Ifc4::IfcApproval* v6_RelatingApproval) : IfcRelAssociates(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());set_attribute_value(5, v6_RelatingApproval ? v6_RelatingApproval->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssociatesClassification
::Ifc4::IfcClassificationSelect* Ifc4::IfcRelAssociatesClassification::RelatingClassification() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcClassificationSelect>(true); }
void Ifc4::IfcRelAssociatesClassification::setRelatingClassification(::Ifc4::IfcClassificationSelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelAssociatesClassification::declaration() const { return *((IfcParse::entity*)IFC4_types[808]); }
const IfcParse::entity& Ifc4::IfcRelAssociatesClassification::Class() { return *((IfcParse::entity*)IFC4_types[808]); }
Ifc4::IfcRelAssociatesClassification::IfcRelAssociatesClassification(IfcEntityInstanceData&& e) : IfcRelAssociates(std::move(e)) { }
Ifc4::IfcRelAssociatesClassification::IfcRelAssociatesClassification(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v5_RelatedObjects, ::Ifc4::IfcClassificationSelect* v6_RelatingClassification) : IfcRelAssociates(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());set_attribute_value(5, v6_RelatingClassification ? v6_RelatingClassification->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssociatesConstraint
boost::optional< std::string > Ifc4::IfcRelAssociatesConstraint::Intent() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcRelAssociatesConstraint::setIntent(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
::Ifc4::IfcConstraint* Ifc4::IfcRelAssociatesConstraint::RelatingConstraint() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcConstraint>(true); }
void Ifc4::IfcRelAssociatesConstraint::setRelatingConstraint(::Ifc4::IfcConstraint* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcRelAssociatesConstraint::declaration() const { return *((IfcParse::entity*)IFC4_types[809]); }
const IfcParse::entity& Ifc4::IfcRelAssociatesConstraint::Class() { return *((IfcParse::entity*)IFC4_types[809]); }
Ifc4::IfcRelAssociatesConstraint::IfcRelAssociatesConstraint(IfcEntityInstanceData&& e) : IfcRelAssociates(std::move(e)) { }
Ifc4::IfcRelAssociatesConstraint::IfcRelAssociatesConstraint(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v5_RelatedObjects, boost::optional< std::string > v6_Intent, ::Ifc4::IfcConstraint* v7_RelatingConstraint) : IfcRelAssociates(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize()); if (v6_Intent) {set_attribute_value(5, (*v6_Intent)); }set_attribute_value(6, v7_RelatingConstraint ? v7_RelatingConstraint->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssociatesDocument
::Ifc4::IfcDocumentSelect* Ifc4::IfcRelAssociatesDocument::RelatingDocument() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcDocumentSelect>(true); }
void Ifc4::IfcRelAssociatesDocument::setRelatingDocument(::Ifc4::IfcDocumentSelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelAssociatesDocument::declaration() const { return *((IfcParse::entity*)IFC4_types[810]); }
const IfcParse::entity& Ifc4::IfcRelAssociatesDocument::Class() { return *((IfcParse::entity*)IFC4_types[810]); }
Ifc4::IfcRelAssociatesDocument::IfcRelAssociatesDocument(IfcEntityInstanceData&& e) : IfcRelAssociates(std::move(e)) { }
Ifc4::IfcRelAssociatesDocument::IfcRelAssociatesDocument(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v5_RelatedObjects, ::Ifc4::IfcDocumentSelect* v6_RelatingDocument) : IfcRelAssociates(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());set_attribute_value(5, v6_RelatingDocument ? v6_RelatingDocument->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssociatesLibrary
::Ifc4::IfcLibrarySelect* Ifc4::IfcRelAssociatesLibrary::RelatingLibrary() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcLibrarySelect>(true); }
void Ifc4::IfcRelAssociatesLibrary::setRelatingLibrary(::Ifc4::IfcLibrarySelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelAssociatesLibrary::declaration() const { return *((IfcParse::entity*)IFC4_types[811]); }
const IfcParse::entity& Ifc4::IfcRelAssociatesLibrary::Class() { return *((IfcParse::entity*)IFC4_types[811]); }
Ifc4::IfcRelAssociatesLibrary::IfcRelAssociatesLibrary(IfcEntityInstanceData&& e) : IfcRelAssociates(std::move(e)) { }
Ifc4::IfcRelAssociatesLibrary::IfcRelAssociatesLibrary(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v5_RelatedObjects, ::Ifc4::IfcLibrarySelect* v6_RelatingLibrary) : IfcRelAssociates(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());set_attribute_value(5, v6_RelatingLibrary ? v6_RelatingLibrary->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelAssociatesMaterial
::Ifc4::IfcMaterialSelect* Ifc4::IfcRelAssociatesMaterial::RelatingMaterial() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcMaterialSelect>(true); }
void Ifc4::IfcRelAssociatesMaterial::setRelatingMaterial(::Ifc4::IfcMaterialSelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelAssociatesMaterial::declaration() const { return *((IfcParse::entity*)IFC4_types[812]); }
const IfcParse::entity& Ifc4::IfcRelAssociatesMaterial::Class() { return *((IfcParse::entity*)IFC4_types[812]); }
Ifc4::IfcRelAssociatesMaterial::IfcRelAssociatesMaterial(IfcEntityInstanceData&& e) : IfcRelAssociates(std::move(e)) { }
Ifc4::IfcRelAssociatesMaterial::IfcRelAssociatesMaterial(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v5_RelatedObjects, ::Ifc4::IfcMaterialSelect* v6_RelatingMaterial) : IfcRelAssociates(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());set_attribute_value(5, v6_RelatingMaterial ? v6_RelatingMaterial->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelConnects


const IfcParse::entity& Ifc4::IfcRelConnects::declaration() const { return *((IfcParse::entity*)IFC4_types[814]); }
const IfcParse::entity& Ifc4::IfcRelConnects::Class() { return *((IfcParse::entity*)IFC4_types[814]); }
Ifc4::IfcRelConnects::IfcRelConnects(IfcEntityInstanceData&& e) : IfcRelationship(std::move(e)) { }
Ifc4::IfcRelConnects::IfcRelConnects(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcRelationship(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcRelConnectsElements
::Ifc4::IfcConnectionGeometry* Ifc4::IfcRelConnectsElements::ConnectionGeometry() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcConnectionGeometry>(true); }
void Ifc4::IfcRelConnectsElements::setConnectionGeometry(::Ifc4::IfcConnectionGeometry* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcElement* Ifc4::IfcRelConnectsElements::RelatingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelConnectsElements::setRelatingElement(::Ifc4::IfcElement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcElement* Ifc4::IfcRelConnectsElements::RelatedElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelConnectsElements::setRelatedElement(::Ifc4::IfcElement* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcRelConnectsElements::declaration() const { return *((IfcParse::entity*)IFC4_types[815]); }
const IfcParse::entity& Ifc4::IfcRelConnectsElements::Class() { return *((IfcParse::entity*)IFC4_types[815]); }
Ifc4::IfcRelConnectsElements::IfcRelConnectsElements(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelConnectsElements::IfcRelConnectsElements(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcConnectionGeometry* v5_ConnectionGeometry, ::Ifc4::IfcElement* v6_RelatingElement, ::Ifc4::IfcElement* v7_RelatedElement) : IfcRelConnects(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_ConnectionGeometry ? v5_ConnectionGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatingElement ? v6_RelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_RelatedElement ? v7_RelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelConnectsPathElements
std::vector< int > /*[0:?]*/ Ifc4::IfcRelConnectsPathElements::RelatingPriorities() const {  std::vector< int > /*[0:?]*/ v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcRelConnectsPathElements::setRelatingPriorities(std::vector< int > /*[0:?]*/ v) { set_attribute_value(7, v);if constexpr (false)unset_attribute_value(7); }
std::vector< int > /*[0:?]*/ Ifc4::IfcRelConnectsPathElements::RelatedPriorities() const {  std::vector< int > /*[0:?]*/ v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcRelConnectsPathElements::setRelatedPriorities(std::vector< int > /*[0:?]*/ v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }
::Ifc4::IfcConnectionTypeEnum::Value Ifc4::IfcRelConnectsPathElements::RelatedConnectionType() const {  return ::Ifc4::IfcConnectionTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcRelConnectsPathElements::setRelatedConnectionType(::Ifc4::IfcConnectionTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcConnectionTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
::Ifc4::IfcConnectionTypeEnum::Value Ifc4::IfcRelConnectsPathElements::RelatingConnectionType() const {  return ::Ifc4::IfcConnectionTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcRelConnectsPathElements::setRelatingConnectionType(::Ifc4::IfcConnectionTypeEnum::Value v) { set_attribute_value(10, EnumerationReference(&::Ifc4::IfcConnectionTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(10); }


const IfcParse::entity& Ifc4::IfcRelConnectsPathElements::declaration() const { return *((IfcParse::entity*)IFC4_types[816]); }
const IfcParse::entity& Ifc4::IfcRelConnectsPathElements::Class() { return *((IfcParse::entity*)IFC4_types[816]); }
Ifc4::IfcRelConnectsPathElements::IfcRelConnectsPathElements(IfcEntityInstanceData&& e) : IfcRelConnectsElements(std::move(e)) { }
Ifc4::IfcRelConnectsPathElements::IfcRelConnectsPathElements(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcConnectionGeometry* v5_ConnectionGeometry, ::Ifc4::IfcElement* v6_RelatingElement, ::Ifc4::IfcElement* v7_RelatedElement, std::vector< int > /*[0:?]*/ v8_RelatingPriorities, std::vector< int > /*[0:?]*/ v9_RelatedPriorities, ::Ifc4::IfcConnectionTypeEnum::Value v10_RelatedConnectionType, ::Ifc4::IfcConnectionTypeEnum::Value v11_RelatingConnectionType) : IfcRelConnectsElements(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_ConnectionGeometry ? v5_ConnectionGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatingElement ? v6_RelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_RelatedElement ? v7_RelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (v8_RelatingPriorities));set_attribute_value(8, (v9_RelatedPriorities));set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcConnectionTypeEnum::Class(),(size_t)v10_RelatedConnectionType)));set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcConnectionTypeEnum::Class(),(size_t)v11_RelatingConnectionType)));; populate_derived(); }

// Function implementations for IfcRelConnectsPortToElement
::Ifc4::IfcPort* Ifc4::IfcRelConnectsPortToElement::RelatingPort() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcPort>(true); }
void Ifc4::IfcRelConnectsPortToElement::setRelatingPort(::Ifc4::IfcPort* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcDistributionElement* Ifc4::IfcRelConnectsPortToElement::RelatedElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcDistributionElement>(true); }
void Ifc4::IfcRelConnectsPortToElement::setRelatedElement(::Ifc4::IfcDistributionElement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelConnectsPortToElement::declaration() const { return *((IfcParse::entity*)IFC4_types[818]); }
const IfcParse::entity& Ifc4::IfcRelConnectsPortToElement::Class() { return *((IfcParse::entity*)IFC4_types[818]); }
Ifc4::IfcRelConnectsPortToElement::IfcRelConnectsPortToElement(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelConnectsPortToElement::IfcRelConnectsPortToElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcPort* v5_RelatingPort, ::Ifc4::IfcDistributionElement* v6_RelatedElement) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingPort ? v5_RelatingPort->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedElement ? v6_RelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelConnectsPorts
::Ifc4::IfcPort* Ifc4::IfcRelConnectsPorts::RelatingPort() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcPort>(true); }
void Ifc4::IfcRelConnectsPorts::setRelatingPort(::Ifc4::IfcPort* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcPort* Ifc4::IfcRelConnectsPorts::RelatedPort() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcPort>(true); }
void Ifc4::IfcRelConnectsPorts::setRelatedPort(::Ifc4::IfcPort* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcElement* Ifc4::IfcRelConnectsPorts::RealizingElement() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelConnectsPorts::setRealizingElement(::Ifc4::IfcElement* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcRelConnectsPorts::declaration() const { return *((IfcParse::entity*)IFC4_types[817]); }
const IfcParse::entity& Ifc4::IfcRelConnectsPorts::Class() { return *((IfcParse::entity*)IFC4_types[817]); }
Ifc4::IfcRelConnectsPorts::IfcRelConnectsPorts(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelConnectsPorts::IfcRelConnectsPorts(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcPort* v5_RelatingPort, ::Ifc4::IfcPort* v6_RelatedPort, ::Ifc4::IfcElement* v7_RealizingElement) : IfcRelConnects(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingPort ? v5_RelatingPort->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedPort ? v6_RelatedPort->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_RealizingElement ? v7_RealizingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelConnectsStructuralActivity
::Ifc4::IfcStructuralActivityAssignmentSelect* Ifc4::IfcRelConnectsStructuralActivity::RelatingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcStructuralActivityAssignmentSelect>(true); }
void Ifc4::IfcRelConnectsStructuralActivity::setRelatingElement(::Ifc4::IfcStructuralActivityAssignmentSelect* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcStructuralActivity* Ifc4::IfcRelConnectsStructuralActivity::RelatedStructuralActivity() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcStructuralActivity>(true); }
void Ifc4::IfcRelConnectsStructuralActivity::setRelatedStructuralActivity(::Ifc4::IfcStructuralActivity* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelConnectsStructuralActivity::declaration() const { return *((IfcParse::entity*)IFC4_types[819]); }
const IfcParse::entity& Ifc4::IfcRelConnectsStructuralActivity::Class() { return *((IfcParse::entity*)IFC4_types[819]); }
Ifc4::IfcRelConnectsStructuralActivity::IfcRelConnectsStructuralActivity(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelConnectsStructuralActivity::IfcRelConnectsStructuralActivity(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcStructuralActivityAssignmentSelect* v5_RelatingElement, ::Ifc4::IfcStructuralActivity* v6_RelatedStructuralActivity) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingElement ? v5_RelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedStructuralActivity ? v6_RelatedStructuralActivity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelConnectsStructuralMember
::Ifc4::IfcStructuralMember* Ifc4::IfcRelConnectsStructuralMember::RelatingStructuralMember() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcStructuralMember>(true); }
void Ifc4::IfcRelConnectsStructuralMember::setRelatingStructuralMember(::Ifc4::IfcStructuralMember* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcStructuralConnection* Ifc4::IfcRelConnectsStructuralMember::RelatedStructuralConnection() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcStructuralConnection>(true); }
void Ifc4::IfcRelConnectsStructuralMember::setRelatedStructuralConnection(::Ifc4::IfcStructuralConnection* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcBoundaryCondition* Ifc4::IfcRelConnectsStructuralMember::AppliedCondition() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcBoundaryCondition>(true); }
void Ifc4::IfcRelConnectsStructuralMember::setAppliedCondition(::Ifc4::IfcBoundaryCondition* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
::Ifc4::IfcStructuralConnectionCondition* Ifc4::IfcRelConnectsStructuralMember::AdditionalConditions() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcStructuralConnectionCondition>(true); }
void Ifc4::IfcRelConnectsStructuralMember::setAdditionalConditions(::Ifc4::IfcStructuralConnectionCondition* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }
boost::optional< double > Ifc4::IfcRelConnectsStructuralMember::SupportedLength() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcRelConnectsStructuralMember::setSupportedLength(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcRelConnectsStructuralMember::ConditionCoordinateSystem() const { if(data_.get_attribute_value(9).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcRelConnectsStructuralMember::setConditionCoordinateSystem(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcRelConnectsStructuralMember::declaration() const { return *((IfcParse::entity*)IFC4_types[820]); }
const IfcParse::entity& Ifc4::IfcRelConnectsStructuralMember::Class() { return *((IfcParse::entity*)IFC4_types[820]); }
Ifc4::IfcRelConnectsStructuralMember::IfcRelConnectsStructuralMember(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelConnectsStructuralMember::IfcRelConnectsStructuralMember(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcStructuralMember* v5_RelatingStructuralMember, ::Ifc4::IfcStructuralConnection* v6_RelatedStructuralConnection, ::Ifc4::IfcBoundaryCondition* v7_AppliedCondition, ::Ifc4::IfcStructuralConnectionCondition* v8_AdditionalConditions, boost::optional< double > v9_SupportedLength, ::Ifc4::IfcAxis2Placement3D* v10_ConditionCoordinateSystem) : IfcRelConnects(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingStructuralMember ? v5_RelatingStructuralMember->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedStructuralConnection ? v6_RelatedStructuralConnection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_AppliedCondition ? v7_AppliedCondition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AdditionalConditions ? v8_AdditionalConditions->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_SupportedLength) {set_attribute_value(8, (*v9_SupportedLength)); }set_attribute_value(9, v10_ConditionCoordinateSystem ? v10_ConditionCoordinateSystem->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelConnectsWithEccentricity
::Ifc4::IfcConnectionGeometry* Ifc4::IfcRelConnectsWithEccentricity::ConnectionConstraint() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(10)))->as<::Ifc4::IfcConnectionGeometry>(true); }
void Ifc4::IfcRelConnectsWithEccentricity::setConnectionConstraint(::Ifc4::IfcConnectionGeometry* v) { set_attribute_value(10, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(10); }


const IfcParse::entity& Ifc4::IfcRelConnectsWithEccentricity::declaration() const { return *((IfcParse::entity*)IFC4_types[821]); }
const IfcParse::entity& Ifc4::IfcRelConnectsWithEccentricity::Class() { return *((IfcParse::entity*)IFC4_types[821]); }
Ifc4::IfcRelConnectsWithEccentricity::IfcRelConnectsWithEccentricity(IfcEntityInstanceData&& e) : IfcRelConnectsStructuralMember(std::move(e)) { }
Ifc4::IfcRelConnectsWithEccentricity::IfcRelConnectsWithEccentricity(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcStructuralMember* v5_RelatingStructuralMember, ::Ifc4::IfcStructuralConnection* v6_RelatedStructuralConnection, ::Ifc4::IfcBoundaryCondition* v7_AppliedCondition, ::Ifc4::IfcStructuralConnectionCondition* v8_AdditionalConditions, boost::optional< double > v9_SupportedLength, ::Ifc4::IfcAxis2Placement3D* v10_ConditionCoordinateSystem, ::Ifc4::IfcConnectionGeometry* v11_ConnectionConstraint) : IfcRelConnectsStructuralMember(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingStructuralMember ? v5_RelatingStructuralMember->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedStructuralConnection ? v6_RelatedStructuralConnection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_AppliedCondition ? v7_AppliedCondition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AdditionalConditions ? v8_AdditionalConditions->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_SupportedLength) {set_attribute_value(8, (*v9_SupportedLength)); }set_attribute_value(9, v10_ConditionCoordinateSystem ? v10_ConditionCoordinateSystem->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(10, v11_ConnectionConstraint ? v11_ConnectionConstraint->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelConnectsWithRealizingElements
aggregate_of< ::Ifc4::IfcElement >::ptr Ifc4::IfcRelConnectsWithRealizingElements::RealizingElements() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcElement >(); }
void Ifc4::IfcRelConnectsWithRealizingElements::setRealizingElements(aggregate_of< ::Ifc4::IfcElement >::ptr v) { set_attribute_value(7, (v)->generalize());if constexpr (false)unset_attribute_value(7); }
boost::optional< std::string > Ifc4::IfcRelConnectsWithRealizingElements::ConnectionType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcRelConnectsWithRealizingElements::setConnectionType(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcRelConnectsWithRealizingElements::declaration() const { return *((IfcParse::entity*)IFC4_types[822]); }
const IfcParse::entity& Ifc4::IfcRelConnectsWithRealizingElements::Class() { return *((IfcParse::entity*)IFC4_types[822]); }
Ifc4::IfcRelConnectsWithRealizingElements::IfcRelConnectsWithRealizingElements(IfcEntityInstanceData&& e) : IfcRelConnectsElements(std::move(e)) { }
Ifc4::IfcRelConnectsWithRealizingElements::IfcRelConnectsWithRealizingElements(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcConnectionGeometry* v5_ConnectionGeometry, ::Ifc4::IfcElement* v6_RelatingElement, ::Ifc4::IfcElement* v7_RelatedElement, aggregate_of< ::Ifc4::IfcElement >::ptr v8_RealizingElements, boost::optional< std::string > v9_ConnectionType) : IfcRelConnectsElements(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_ConnectionGeometry ? v5_ConnectionGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatingElement ? v6_RelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_RelatedElement ? v7_RelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (v8_RealizingElements)->generalize()); if (v9_ConnectionType) {set_attribute_value(8, (*v9_ConnectionType)); }; populate_derived(); }

// Function implementations for IfcRelContainedInSpatialStructure
aggregate_of< ::Ifc4::IfcProduct >::ptr Ifc4::IfcRelContainedInSpatialStructure::RelatedElements() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcProduct >(); }
void Ifc4::IfcRelContainedInSpatialStructure::setRelatedElements(aggregate_of< ::Ifc4::IfcProduct >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcSpatialElement* Ifc4::IfcRelContainedInSpatialStructure::RelatingStructure() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcSpatialElement>(true); }
void Ifc4::IfcRelContainedInSpatialStructure::setRelatingStructure(::Ifc4::IfcSpatialElement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelContainedInSpatialStructure::declaration() const { return *((IfcParse::entity*)IFC4_types[823]); }
const IfcParse::entity& Ifc4::IfcRelContainedInSpatialStructure::Class() { return *((IfcParse::entity*)IFC4_types[823]); }
Ifc4::IfcRelContainedInSpatialStructure::IfcRelContainedInSpatialStructure(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelContainedInSpatialStructure::IfcRelContainedInSpatialStructure(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcProduct >::ptr v5_RelatedElements, ::Ifc4::IfcSpatialElement* v6_RelatingStructure) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedElements)->generalize());set_attribute_value(5, v6_RelatingStructure ? v6_RelatingStructure->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelCoversBldgElements
::Ifc4::IfcElement* Ifc4::IfcRelCoversBldgElements::RelatingBuildingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelCoversBldgElements::setRelatingBuildingElement(::Ifc4::IfcElement* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
aggregate_of< ::Ifc4::IfcCovering >::ptr Ifc4::IfcRelCoversBldgElements::RelatedCoverings() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcCovering >(); }
void Ifc4::IfcRelCoversBldgElements::setRelatedCoverings(aggregate_of< ::Ifc4::IfcCovering >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelCoversBldgElements::declaration() const { return *((IfcParse::entity*)IFC4_types[824]); }
const IfcParse::entity& Ifc4::IfcRelCoversBldgElements::Class() { return *((IfcParse::entity*)IFC4_types[824]); }
Ifc4::IfcRelCoversBldgElements::IfcRelCoversBldgElements(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelCoversBldgElements::IfcRelCoversBldgElements(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcElement* v5_RelatingBuildingElement, aggregate_of< ::Ifc4::IfcCovering >::ptr v6_RelatedCoverings) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingBuildingElement ? v5_RelatingBuildingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_RelatedCoverings)->generalize());; populate_derived(); }

// Function implementations for IfcRelCoversSpaces
::Ifc4::IfcSpace* Ifc4::IfcRelCoversSpaces::RelatingSpace() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcSpace>(true); }
void Ifc4::IfcRelCoversSpaces::setRelatingSpace(::Ifc4::IfcSpace* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
aggregate_of< ::Ifc4::IfcCovering >::ptr Ifc4::IfcRelCoversSpaces::RelatedCoverings() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcCovering >(); }
void Ifc4::IfcRelCoversSpaces::setRelatedCoverings(aggregate_of< ::Ifc4::IfcCovering >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelCoversSpaces::declaration() const { return *((IfcParse::entity*)IFC4_types[825]); }
const IfcParse::entity& Ifc4::IfcRelCoversSpaces::Class() { return *((IfcParse::entity*)IFC4_types[825]); }
Ifc4::IfcRelCoversSpaces::IfcRelCoversSpaces(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelCoversSpaces::IfcRelCoversSpaces(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcSpace* v5_RelatingSpace, aggregate_of< ::Ifc4::IfcCovering >::ptr v6_RelatedCoverings) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingSpace ? v5_RelatingSpace->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_RelatedCoverings)->generalize());; populate_derived(); }

// Function implementations for IfcRelDeclares
::Ifc4::IfcContext* Ifc4::IfcRelDeclares::RelatingContext() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcContext>(true); }
void Ifc4::IfcRelDeclares::setRelatingContext(::Ifc4::IfcContext* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr Ifc4::IfcRelDeclares::RelatedDefinitions() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcDefinitionSelect >(); }
void Ifc4::IfcRelDeclares::setRelatedDefinitions(aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelDeclares::declaration() const { return *((IfcParse::entity*)IFC4_types[826]); }
const IfcParse::entity& Ifc4::IfcRelDeclares::Class() { return *((IfcParse::entity*)IFC4_types[826]); }
Ifc4::IfcRelDeclares::IfcRelDeclares(IfcEntityInstanceData&& e) : IfcRelationship(std::move(e)) { }
Ifc4::IfcRelDeclares::IfcRelDeclares(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcContext* v5_RelatingContext, aggregate_of< ::Ifc4::IfcDefinitionSelect >::ptr v6_RelatedDefinitions) : IfcRelationship(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingContext ? v5_RelatingContext->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_RelatedDefinitions)->generalize());; populate_derived(); }

// Function implementations for IfcRelDecomposes


const IfcParse::entity& Ifc4::IfcRelDecomposes::declaration() const { return *((IfcParse::entity*)IFC4_types[827]); }
const IfcParse::entity& Ifc4::IfcRelDecomposes::Class() { return *((IfcParse::entity*)IFC4_types[827]); }
Ifc4::IfcRelDecomposes::IfcRelDecomposes(IfcEntityInstanceData&& e) : IfcRelationship(std::move(e)) { }
Ifc4::IfcRelDecomposes::IfcRelDecomposes(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcRelationship(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcRelDefines


const IfcParse::entity& Ifc4::IfcRelDefines::declaration() const { return *((IfcParse::entity*)IFC4_types[828]); }
const IfcParse::entity& Ifc4::IfcRelDefines::Class() { return *((IfcParse::entity*)IFC4_types[828]); }
Ifc4::IfcRelDefines::IfcRelDefines(IfcEntityInstanceData&& e) : IfcRelationship(std::move(e)) { }
Ifc4::IfcRelDefines::IfcRelDefines(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcRelationship(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcRelDefinesByObject
aggregate_of< ::Ifc4::IfcObject >::ptr Ifc4::IfcRelDefinesByObject::RelatedObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcObject >(); }
void Ifc4::IfcRelDefinesByObject::setRelatedObjects(aggregate_of< ::Ifc4::IfcObject >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcObject* Ifc4::IfcRelDefinesByObject::RelatingObject() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcObject>(true); }
void Ifc4::IfcRelDefinesByObject::setRelatingObject(::Ifc4::IfcObject* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelDefinesByObject::declaration() const { return *((IfcParse::entity*)IFC4_types[829]); }
const IfcParse::entity& Ifc4::IfcRelDefinesByObject::Class() { return *((IfcParse::entity*)IFC4_types[829]); }
Ifc4::IfcRelDefinesByObject::IfcRelDefinesByObject(IfcEntityInstanceData&& e) : IfcRelDefines(std::move(e)) { }
Ifc4::IfcRelDefinesByObject::IfcRelDefinesByObject(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObject >::ptr v5_RelatedObjects, ::Ifc4::IfcObject* v6_RelatingObject) : IfcRelDefines(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());set_attribute_value(5, v6_RelatingObject ? v6_RelatingObject->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelDefinesByProperties
aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr Ifc4::IfcRelDefinesByProperties::RelatedObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcObjectDefinition >(); }
void Ifc4::IfcRelDefinesByProperties::setRelatedObjects(aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcPropertySetDefinitionSelect* Ifc4::IfcRelDefinesByProperties::RelatingPropertyDefinition() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcPropertySetDefinitionSelect>(true); }
void Ifc4::IfcRelDefinesByProperties::setRelatingPropertyDefinition(::Ifc4::IfcPropertySetDefinitionSelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelDefinesByProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[830]); }
const IfcParse::entity& Ifc4::IfcRelDefinesByProperties::Class() { return *((IfcParse::entity*)IFC4_types[830]); }
Ifc4::IfcRelDefinesByProperties::IfcRelDefinesByProperties(IfcEntityInstanceData&& e) : IfcRelDefines(std::move(e)) { }
Ifc4::IfcRelDefinesByProperties::IfcRelDefinesByProperties(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v5_RelatedObjects, ::Ifc4::IfcPropertySetDefinitionSelect* v6_RelatingPropertyDefinition) : IfcRelDefines(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());set_attribute_value(5, v6_RelatingPropertyDefinition ? v6_RelatingPropertyDefinition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelDefinesByTemplate
aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr Ifc4::IfcRelDefinesByTemplate::RelatedPropertySets() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcPropertySetDefinition >(); }
void Ifc4::IfcRelDefinesByTemplate::setRelatedPropertySets(aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcPropertySetTemplate* Ifc4::IfcRelDefinesByTemplate::RelatingTemplate() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcPropertySetTemplate>(true); }
void Ifc4::IfcRelDefinesByTemplate::setRelatingTemplate(::Ifc4::IfcPropertySetTemplate* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelDefinesByTemplate::declaration() const { return *((IfcParse::entity*)IFC4_types[831]); }
const IfcParse::entity& Ifc4::IfcRelDefinesByTemplate::Class() { return *((IfcParse::entity*)IFC4_types[831]); }
Ifc4::IfcRelDefinesByTemplate::IfcRelDefinesByTemplate(IfcEntityInstanceData&& e) : IfcRelDefines(std::move(e)) { }
Ifc4::IfcRelDefinesByTemplate::IfcRelDefinesByTemplate(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr v5_RelatedPropertySets, ::Ifc4::IfcPropertySetTemplate* v6_RelatingTemplate) : IfcRelDefines(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedPropertySets)->generalize());set_attribute_value(5, v6_RelatingTemplate ? v6_RelatingTemplate->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelDefinesByType
aggregate_of< ::Ifc4::IfcObject >::ptr Ifc4::IfcRelDefinesByType::RelatedObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcObject >(); }
void Ifc4::IfcRelDefinesByType::setRelatedObjects(aggregate_of< ::Ifc4::IfcObject >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcTypeObject* Ifc4::IfcRelDefinesByType::RelatingType() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcTypeObject>(true); }
void Ifc4::IfcRelDefinesByType::setRelatingType(::Ifc4::IfcTypeObject* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelDefinesByType::declaration() const { return *((IfcParse::entity*)IFC4_types[832]); }
const IfcParse::entity& Ifc4::IfcRelDefinesByType::Class() { return *((IfcParse::entity*)IFC4_types[832]); }
Ifc4::IfcRelDefinesByType::IfcRelDefinesByType(IfcEntityInstanceData&& e) : IfcRelDefines(std::move(e)) { }
Ifc4::IfcRelDefinesByType::IfcRelDefinesByType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcObject >::ptr v5_RelatedObjects, ::Ifc4::IfcTypeObject* v6_RelatingType) : IfcRelDefines(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedObjects)->generalize());set_attribute_value(5, v6_RelatingType ? v6_RelatingType->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelFillsElement
::Ifc4::IfcOpeningElement* Ifc4::IfcRelFillsElement::RelatingOpeningElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcOpeningElement>(true); }
void Ifc4::IfcRelFillsElement::setRelatingOpeningElement(::Ifc4::IfcOpeningElement* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcElement* Ifc4::IfcRelFillsElement::RelatedBuildingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelFillsElement::setRelatedBuildingElement(::Ifc4::IfcElement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelFillsElement::declaration() const { return *((IfcParse::entity*)IFC4_types[833]); }
const IfcParse::entity& Ifc4::IfcRelFillsElement::Class() { return *((IfcParse::entity*)IFC4_types[833]); }
Ifc4::IfcRelFillsElement::IfcRelFillsElement(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelFillsElement::IfcRelFillsElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcOpeningElement* v5_RelatingOpeningElement, ::Ifc4::IfcElement* v6_RelatedBuildingElement) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingOpeningElement ? v5_RelatingOpeningElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedBuildingElement ? v6_RelatedBuildingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelFlowControlElements
aggregate_of< ::Ifc4::IfcDistributionControlElement >::ptr Ifc4::IfcRelFlowControlElements::RelatedControlElements() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcDistributionControlElement >(); }
void Ifc4::IfcRelFlowControlElements::setRelatedControlElements(aggregate_of< ::Ifc4::IfcDistributionControlElement >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcDistributionFlowElement* Ifc4::IfcRelFlowControlElements::RelatingFlowElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcDistributionFlowElement>(true); }
void Ifc4::IfcRelFlowControlElements::setRelatingFlowElement(::Ifc4::IfcDistributionFlowElement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelFlowControlElements::declaration() const { return *((IfcParse::entity*)IFC4_types[834]); }
const IfcParse::entity& Ifc4::IfcRelFlowControlElements::Class() { return *((IfcParse::entity*)IFC4_types[834]); }
Ifc4::IfcRelFlowControlElements::IfcRelFlowControlElements(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelFlowControlElements::IfcRelFlowControlElements(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcDistributionControlElement >::ptr v5_RelatedControlElements, ::Ifc4::IfcDistributionFlowElement* v6_RelatingFlowElement) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedControlElements)->generalize());set_attribute_value(5, v6_RelatingFlowElement ? v6_RelatingFlowElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelInterferesElements
::Ifc4::IfcElement* Ifc4::IfcRelInterferesElements::RelatingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelInterferesElements::setRelatingElement(::Ifc4::IfcElement* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcElement* Ifc4::IfcRelInterferesElements::RelatedElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelInterferesElements::setRelatedElement(::Ifc4::IfcElement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcConnectionGeometry* Ifc4::IfcRelInterferesElements::InterferenceGeometry() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcConnectionGeometry>(true); }
void Ifc4::IfcRelInterferesElements::setInterferenceGeometry(::Ifc4::IfcConnectionGeometry* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
boost::optional< std::string > Ifc4::IfcRelInterferesElements::InterferenceType() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcRelInterferesElements::setInterferenceType(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::logic::tribool Ifc4::IfcRelInterferesElements::ImpliedOrder() const {  boost::logic::tribool v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcRelInterferesElements::setImpliedOrder(boost::logic::tribool v) { set_attribute_value(8, v);if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcRelInterferesElements::declaration() const { return *((IfcParse::entity*)IFC4_types[835]); }
const IfcParse::entity& Ifc4::IfcRelInterferesElements::Class() { return *((IfcParse::entity*)IFC4_types[835]); }
Ifc4::IfcRelInterferesElements::IfcRelInterferesElements(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelInterferesElements::IfcRelInterferesElements(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcElement* v5_RelatingElement, ::Ifc4::IfcElement* v6_RelatedElement, ::Ifc4::IfcConnectionGeometry* v7_InterferenceGeometry, boost::optional< std::string > v8_InterferenceType, boost::logic::tribool v9_ImpliedOrder) : IfcRelConnects(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingElement ? v5_RelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedElement ? v6_RelatedElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_InterferenceGeometry ? v7_InterferenceGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_InterferenceType) {set_attribute_value(7, (*v8_InterferenceType)); }set_attribute_value(8, (v9_ImpliedOrder));; populate_derived(); }

// Function implementations for IfcRelNests
::Ifc4::IfcObjectDefinition* Ifc4::IfcRelNests::RelatingObject() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcObjectDefinition>(true); }
void Ifc4::IfcRelNests::setRelatingObject(::Ifc4::IfcObjectDefinition* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr Ifc4::IfcRelNests::RelatedObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcObjectDefinition >(); }
void Ifc4::IfcRelNests::setRelatedObjects(aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelNests::declaration() const { return *((IfcParse::entity*)IFC4_types[836]); }
const IfcParse::entity& Ifc4::IfcRelNests::Class() { return *((IfcParse::entity*)IFC4_types[836]); }
Ifc4::IfcRelNests::IfcRelNests(IfcEntityInstanceData&& e) : IfcRelDecomposes(std::move(e)) { }
Ifc4::IfcRelNests::IfcRelNests(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcObjectDefinition* v5_RelatingObject, aggregate_of< ::Ifc4::IfcObjectDefinition >::ptr v6_RelatedObjects) : IfcRelDecomposes(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingObject ? v5_RelatingObject->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_RelatedObjects)->generalize());; populate_derived(); }

// Function implementations for IfcRelProjectsElement
::Ifc4::IfcElement* Ifc4::IfcRelProjectsElement::RelatingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelProjectsElement::setRelatingElement(::Ifc4::IfcElement* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcFeatureElementAddition* Ifc4::IfcRelProjectsElement::RelatedFeatureElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcFeatureElementAddition>(true); }
void Ifc4::IfcRelProjectsElement::setRelatedFeatureElement(::Ifc4::IfcFeatureElementAddition* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelProjectsElement::declaration() const { return *((IfcParse::entity*)IFC4_types[837]); }
const IfcParse::entity& Ifc4::IfcRelProjectsElement::Class() { return *((IfcParse::entity*)IFC4_types[837]); }
Ifc4::IfcRelProjectsElement::IfcRelProjectsElement(IfcEntityInstanceData&& e) : IfcRelDecomposes(std::move(e)) { }
Ifc4::IfcRelProjectsElement::IfcRelProjectsElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcElement* v5_RelatingElement, ::Ifc4::IfcFeatureElementAddition* v6_RelatedFeatureElement) : IfcRelDecomposes(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingElement ? v5_RelatingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedFeatureElement ? v6_RelatedFeatureElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelReferencedInSpatialStructure
aggregate_of< ::Ifc4::IfcProduct >::ptr Ifc4::IfcRelReferencedInSpatialStructure::RelatedElements() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(4); return es->as< ::Ifc4::IfcProduct >(); }
void Ifc4::IfcRelReferencedInSpatialStructure::setRelatedElements(aggregate_of< ::Ifc4::IfcProduct >::ptr v) { set_attribute_value(4, (v)->generalize());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcSpatialElement* Ifc4::IfcRelReferencedInSpatialStructure::RelatingStructure() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcSpatialElement>(true); }
void Ifc4::IfcRelReferencedInSpatialStructure::setRelatingStructure(::Ifc4::IfcSpatialElement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelReferencedInSpatialStructure::declaration() const { return *((IfcParse::entity*)IFC4_types[838]); }
const IfcParse::entity& Ifc4::IfcRelReferencedInSpatialStructure::Class() { return *((IfcParse::entity*)IFC4_types[838]); }
Ifc4::IfcRelReferencedInSpatialStructure::IfcRelReferencedInSpatialStructure(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelReferencedInSpatialStructure::IfcRelReferencedInSpatialStructure(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, aggregate_of< ::Ifc4::IfcProduct >::ptr v5_RelatedElements, ::Ifc4::IfcSpatialElement* v6_RelatingStructure) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (v5_RelatedElements)->generalize());set_attribute_value(5, v6_RelatingStructure ? v6_RelatingStructure->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelSequence
::Ifc4::IfcProcess* Ifc4::IfcRelSequence::RelatingProcess() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcProcess>(true); }
void Ifc4::IfcRelSequence::setRelatingProcess(::Ifc4::IfcProcess* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcProcess* Ifc4::IfcRelSequence::RelatedProcess() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcProcess>(true); }
void Ifc4::IfcRelSequence::setRelatedProcess(::Ifc4::IfcProcess* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcLagTime* Ifc4::IfcRelSequence::TimeLag() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcLagTime>(true); }
void Ifc4::IfcRelSequence::setTimeLag(::Ifc4::IfcLagTime* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
boost::optional< ::Ifc4::IfcSequenceEnum::Value > Ifc4::IfcRelSequence::SequenceType() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } return ::Ifc4::IfcSequenceEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcRelSequence::setSequenceType(boost::optional< ::Ifc4::IfcSequenceEnum::Value > v) { if (v) {set_attribute_value(7, EnumerationReference(&::Ifc4::IfcSequenceEnum::Class(), (size_t) *v));} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcRelSequence::UserDefinedSequenceType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcRelSequence::setUserDefinedSequenceType(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcRelSequence::declaration() const { return *((IfcParse::entity*)IFC4_types[839]); }
const IfcParse::entity& Ifc4::IfcRelSequence::Class() { return *((IfcParse::entity*)IFC4_types[839]); }
Ifc4::IfcRelSequence::IfcRelSequence(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelSequence::IfcRelSequence(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcProcess* v5_RelatingProcess, ::Ifc4::IfcProcess* v6_RelatedProcess, ::Ifc4::IfcLagTime* v7_TimeLag, boost::optional< ::Ifc4::IfcSequenceEnum::Value > v8_SequenceType, boost::optional< std::string > v9_UserDefinedSequenceType) : IfcRelConnects(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingProcess ? v5_RelatingProcess->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedProcess ? v6_RelatedProcess->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_TimeLag ? v7_TimeLag->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_SequenceType) {set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcSequenceEnum::Class(),(size_t)*v8_SequenceType))); } if (v9_UserDefinedSequenceType) {set_attribute_value(8, (*v9_UserDefinedSequenceType)); }; populate_derived(); }

// Function implementations for IfcRelServicesBuildings
::Ifc4::IfcSystem* Ifc4::IfcRelServicesBuildings::RelatingSystem() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcSystem>(true); }
void Ifc4::IfcRelServicesBuildings::setRelatingSystem(::Ifc4::IfcSystem* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
aggregate_of< ::Ifc4::IfcSpatialElement >::ptr Ifc4::IfcRelServicesBuildings::RelatedBuildings() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcSpatialElement >(); }
void Ifc4::IfcRelServicesBuildings::setRelatedBuildings(aggregate_of< ::Ifc4::IfcSpatialElement >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelServicesBuildings::declaration() const { return *((IfcParse::entity*)IFC4_types[840]); }
const IfcParse::entity& Ifc4::IfcRelServicesBuildings::Class() { return *((IfcParse::entity*)IFC4_types[840]); }
Ifc4::IfcRelServicesBuildings::IfcRelServicesBuildings(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelServicesBuildings::IfcRelServicesBuildings(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcSystem* v5_RelatingSystem, aggregate_of< ::Ifc4::IfcSpatialElement >::ptr v6_RelatedBuildings) : IfcRelConnects(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingSystem ? v5_RelatingSystem->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_RelatedBuildings)->generalize());; populate_derived(); }

// Function implementations for IfcRelSpaceBoundary
::Ifc4::IfcSpaceBoundarySelect* Ifc4::IfcRelSpaceBoundary::RelatingSpace() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcSpaceBoundarySelect>(true); }
void Ifc4::IfcRelSpaceBoundary::setRelatingSpace(::Ifc4::IfcSpaceBoundarySelect* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcElement* Ifc4::IfcRelSpaceBoundary::RelatedBuildingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelSpaceBoundary::setRelatedBuildingElement(::Ifc4::IfcElement* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcConnectionGeometry* Ifc4::IfcRelSpaceBoundary::ConnectionGeometry() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcConnectionGeometry>(true); }
void Ifc4::IfcRelSpaceBoundary::setConnectionGeometry(::Ifc4::IfcConnectionGeometry* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
::Ifc4::IfcPhysicalOrVirtualEnum::Value Ifc4::IfcRelSpaceBoundary::PhysicalOrVirtualBoundary() const {  return ::Ifc4::IfcPhysicalOrVirtualEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcRelSpaceBoundary::setPhysicalOrVirtualBoundary(::Ifc4::IfcPhysicalOrVirtualEnum::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcPhysicalOrVirtualEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcInternalOrExternalEnum::Value Ifc4::IfcRelSpaceBoundary::InternalOrExternalBoundary() const {  return ::Ifc4::IfcInternalOrExternalEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcRelSpaceBoundary::setInternalOrExternalBoundary(::Ifc4::IfcInternalOrExternalEnum::Value v) { set_attribute_value(8, EnumerationReference(&::Ifc4::IfcInternalOrExternalEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcRelSpaceBoundary::declaration() const { return *((IfcParse::entity*)IFC4_types[841]); }
const IfcParse::entity& Ifc4::IfcRelSpaceBoundary::Class() { return *((IfcParse::entity*)IFC4_types[841]); }
Ifc4::IfcRelSpaceBoundary::IfcRelSpaceBoundary(IfcEntityInstanceData&& e) : IfcRelConnects(std::move(e)) { }
Ifc4::IfcRelSpaceBoundary::IfcRelSpaceBoundary(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcSpaceBoundarySelect* v5_RelatingSpace, ::Ifc4::IfcElement* v6_RelatedBuildingElement, ::Ifc4::IfcConnectionGeometry* v7_ConnectionGeometry, ::Ifc4::IfcPhysicalOrVirtualEnum::Value v8_PhysicalOrVirtualBoundary, ::Ifc4::IfcInternalOrExternalEnum::Value v9_InternalOrExternalBoundary) : IfcRelConnects(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingSpace ? v5_RelatingSpace->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedBuildingElement ? v6_RelatedBuildingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_ConnectionGeometry ? v7_ConnectionGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcPhysicalOrVirtualEnum::Class(),(size_t)v8_PhysicalOrVirtualBoundary)));set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcInternalOrExternalEnum::Class(),(size_t)v9_InternalOrExternalBoundary)));; populate_derived(); }

// Function implementations for IfcRelSpaceBoundary1stLevel
::Ifc4::IfcRelSpaceBoundary1stLevel* Ifc4::IfcRelSpaceBoundary1stLevel::ParentBoundary() const { if(data_.get_attribute_value(9).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcRelSpaceBoundary1stLevel>(true); }
void Ifc4::IfcRelSpaceBoundary1stLevel::setParentBoundary(::Ifc4::IfcRelSpaceBoundary1stLevel* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }

::Ifc4::IfcRelSpaceBoundary1stLevel::list::ptr Ifc4::IfcRelSpaceBoundary1stLevel::InnerBoundaries() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[842], 9)->as<IfcRelSpaceBoundary1stLevel>(); }

const IfcParse::entity& Ifc4::IfcRelSpaceBoundary1stLevel::declaration() const { return *((IfcParse::entity*)IFC4_types[842]); }
const IfcParse::entity& Ifc4::IfcRelSpaceBoundary1stLevel::Class() { return *((IfcParse::entity*)IFC4_types[842]); }
Ifc4::IfcRelSpaceBoundary1stLevel::IfcRelSpaceBoundary1stLevel(IfcEntityInstanceData&& e) : IfcRelSpaceBoundary(std::move(e)) { }
Ifc4::IfcRelSpaceBoundary1stLevel::IfcRelSpaceBoundary1stLevel(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcSpaceBoundarySelect* v5_RelatingSpace, ::Ifc4::IfcElement* v6_RelatedBuildingElement, ::Ifc4::IfcConnectionGeometry* v7_ConnectionGeometry, ::Ifc4::IfcPhysicalOrVirtualEnum::Value v8_PhysicalOrVirtualBoundary, ::Ifc4::IfcInternalOrExternalEnum::Value v9_InternalOrExternalBoundary, ::Ifc4::IfcRelSpaceBoundary1stLevel* v10_ParentBoundary) : IfcRelSpaceBoundary(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingSpace ? v5_RelatingSpace->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedBuildingElement ? v6_RelatedBuildingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_ConnectionGeometry ? v7_ConnectionGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcPhysicalOrVirtualEnum::Class(),(size_t)v8_PhysicalOrVirtualBoundary)));set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcInternalOrExternalEnum::Class(),(size_t)v9_InternalOrExternalBoundary)));set_attribute_value(9, v10_ParentBoundary ? v10_ParentBoundary->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelSpaceBoundary2ndLevel
::Ifc4::IfcRelSpaceBoundary2ndLevel* Ifc4::IfcRelSpaceBoundary2ndLevel::CorrespondingBoundary() const { if(data_.get_attribute_value(10).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(10)))->as<::Ifc4::IfcRelSpaceBoundary2ndLevel>(true); }
void Ifc4::IfcRelSpaceBoundary2ndLevel::setCorrespondingBoundary(::Ifc4::IfcRelSpaceBoundary2ndLevel* v) { set_attribute_value(10, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(10); }

::Ifc4::IfcRelSpaceBoundary2ndLevel::list::ptr Ifc4::IfcRelSpaceBoundary2ndLevel::Corresponds() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[843], 10)->as<IfcRelSpaceBoundary2ndLevel>(); }

const IfcParse::entity& Ifc4::IfcRelSpaceBoundary2ndLevel::declaration() const { return *((IfcParse::entity*)IFC4_types[843]); }
const IfcParse::entity& Ifc4::IfcRelSpaceBoundary2ndLevel::Class() { return *((IfcParse::entity*)IFC4_types[843]); }
Ifc4::IfcRelSpaceBoundary2ndLevel::IfcRelSpaceBoundary2ndLevel(IfcEntityInstanceData&& e) : IfcRelSpaceBoundary1stLevel(std::move(e)) { }
Ifc4::IfcRelSpaceBoundary2ndLevel::IfcRelSpaceBoundary2ndLevel(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcSpaceBoundarySelect* v5_RelatingSpace, ::Ifc4::IfcElement* v6_RelatedBuildingElement, ::Ifc4::IfcConnectionGeometry* v7_ConnectionGeometry, ::Ifc4::IfcPhysicalOrVirtualEnum::Value v8_PhysicalOrVirtualBoundary, ::Ifc4::IfcInternalOrExternalEnum::Value v9_InternalOrExternalBoundary, ::Ifc4::IfcRelSpaceBoundary1stLevel* v10_ParentBoundary, ::Ifc4::IfcRelSpaceBoundary2ndLevel* v11_CorrespondingBoundary) : IfcRelSpaceBoundary1stLevel(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingSpace ? v5_RelatingSpace->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedBuildingElement ? v6_RelatedBuildingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_ConnectionGeometry ? v7_ConnectionGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcPhysicalOrVirtualEnum::Class(),(size_t)v8_PhysicalOrVirtualBoundary)));set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcInternalOrExternalEnum::Class(),(size_t)v9_InternalOrExternalBoundary)));set_attribute_value(9, v10_ParentBoundary ? v10_ParentBoundary->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(10, v11_CorrespondingBoundary ? v11_CorrespondingBoundary->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelVoidsElement
::Ifc4::IfcElement* Ifc4::IfcRelVoidsElement::RelatingBuildingElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcElement>(true); }
void Ifc4::IfcRelVoidsElement::setRelatingBuildingElement(::Ifc4::IfcElement* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcFeatureElementSubtraction* Ifc4::IfcRelVoidsElement::RelatedOpeningElement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcFeatureElementSubtraction>(true); }
void Ifc4::IfcRelVoidsElement::setRelatedOpeningElement(::Ifc4::IfcFeatureElementSubtraction* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRelVoidsElement::declaration() const { return *((IfcParse::entity*)IFC4_types[844]); }
const IfcParse::entity& Ifc4::IfcRelVoidsElement::Class() { return *((IfcParse::entity*)IFC4_types[844]); }
Ifc4::IfcRelVoidsElement::IfcRelVoidsElement(IfcEntityInstanceData&& e) : IfcRelDecomposes(std::move(e)) { }
Ifc4::IfcRelVoidsElement::IfcRelVoidsElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcElement* v5_RelatingBuildingElement, ::Ifc4::IfcFeatureElementSubtraction* v6_RelatedOpeningElement) : IfcRelDecomposes(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, v5_RelatingBuildingElement ? v5_RelatingBuildingElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_RelatedOpeningElement ? v6_RelatedOpeningElement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRelationship


const IfcParse::entity& Ifc4::IfcRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[813]); }
const IfcParse::entity& Ifc4::IfcRelationship::Class() { return *((IfcParse::entity*)IFC4_types[813]); }
Ifc4::IfcRelationship::IfcRelationship(IfcEntityInstanceData&& e) : IfcRoot(std::move(e)) { }
Ifc4::IfcRelationship::IfcRelationship(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcRoot(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcReparametrisedCompositeCurveSegment
double Ifc4::IfcReparametrisedCompositeCurveSegment::ParamLength() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcReparametrisedCompositeCurveSegment::setParamLength(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcReparametrisedCompositeCurveSegment::declaration() const { return *((IfcParse::entity*)IFC4_types[845]); }
const IfcParse::entity& Ifc4::IfcReparametrisedCompositeCurveSegment::Class() { return *((IfcParse::entity*)IFC4_types[845]); }
Ifc4::IfcReparametrisedCompositeCurveSegment::IfcReparametrisedCompositeCurveSegment(IfcEntityInstanceData&& e) : IfcCompositeCurveSegment(std::move(e)) { }
Ifc4::IfcReparametrisedCompositeCurveSegment::IfcReparametrisedCompositeCurveSegment(::Ifc4::IfcTransitionCode::Value v1_Transition, bool v2_SameSense, ::Ifc4::IfcCurve* v3_ParentCurve, double v4_ParamLength) : IfcCompositeCurveSegment(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcTransitionCode::Class(),(size_t)v1_Transition)));set_attribute_value(1, (v2_SameSense));set_attribute_value(2, v3_ParentCurve ? v3_ParentCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_ParamLength));; populate_derived(); }

// Function implementations for IfcRepresentation
::Ifc4::IfcRepresentationContext* Ifc4::IfcRepresentation::ContextOfItems() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcRepresentationContext>(true); }
void Ifc4::IfcRepresentation::setContextOfItems(::Ifc4::IfcRepresentationContext* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcRepresentation::RepresentationIdentifier() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcRepresentation::setRepresentationIdentifier(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcRepresentation::RepresentationType() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcRepresentation::setRepresentationType(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
aggregate_of< ::Ifc4::IfcRepresentationItem >::ptr Ifc4::IfcRepresentation::Items() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcRepresentationItem >(); }
void Ifc4::IfcRepresentation::setItems(aggregate_of< ::Ifc4::IfcRepresentationItem >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }

::Ifc4::IfcRepresentationMap::list::ptr Ifc4::IfcRepresentation::RepresentationMap() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[849], 1)->as<IfcRepresentationMap>(); }
::Ifc4::IfcPresentationLayerAssignment::list::ptr Ifc4::IfcRepresentation::LayerAssignments() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[699], 2)->as<IfcPresentationLayerAssignment>(); }
::Ifc4::IfcProductRepresentation::list::ptr Ifc4::IfcRepresentation::OfProductRepresentation() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[712], 2)->as<IfcProductRepresentation>(); }

const IfcParse::entity& Ifc4::IfcRepresentation::declaration() const { return *((IfcParse::entity*)IFC4_types[846]); }
const IfcParse::entity& Ifc4::IfcRepresentation::Class() { return *((IfcParse::entity*)IFC4_types[846]); }
Ifc4::IfcRepresentation::IfcRepresentation(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcRepresentation::IfcRepresentation(::Ifc4::IfcRepresentationContext* v1_ContextOfItems, boost::optional< std::string > v2_RepresentationIdentifier, boost::optional< std::string > v3_RepresentationType, aggregate_of< ::Ifc4::IfcRepresentationItem >::ptr v4_Items) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_ContextOfItems ? v1_ContextOfItems->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_RepresentationIdentifier) {set_attribute_value(1, (*v2_RepresentationIdentifier)); } if (v3_RepresentationType) {set_attribute_value(2, (*v3_RepresentationType)); }set_attribute_value(3, (v4_Items)->generalize());; populate_derived(); }

// Function implementations for IfcRepresentationContext
boost::optional< std::string > Ifc4::IfcRepresentationContext::ContextIdentifier() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcRepresentationContext::setContextIdentifier(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcRepresentationContext::ContextType() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcRepresentationContext::setContextType(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }

::Ifc4::IfcRepresentation::list::ptr Ifc4::IfcRepresentationContext::RepresentationsInContext() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[846], 0)->as<IfcRepresentation>(); }

const IfcParse::entity& Ifc4::IfcRepresentationContext::declaration() const { return *((IfcParse::entity*)IFC4_types[847]); }
const IfcParse::entity& Ifc4::IfcRepresentationContext::Class() { return *((IfcParse::entity*)IFC4_types[847]); }
Ifc4::IfcRepresentationContext::IfcRepresentationContext(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcRepresentationContext::IfcRepresentationContext(boost::optional< std::string > v1_ContextIdentifier, boost::optional< std::string > v2_ContextType) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) {  if (v1_ContextIdentifier) {set_attribute_value(0, (*v1_ContextIdentifier)); } if (v2_ContextType) {set_attribute_value(1, (*v2_ContextType)); }; populate_derived(); }

// Function implementations for IfcRepresentationItem

::Ifc4::IfcPresentationLayerAssignment::list::ptr Ifc4::IfcRepresentationItem::LayerAssignment() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[699], 2)->as<IfcPresentationLayerAssignment>(); }
::Ifc4::IfcStyledItem::list::ptr Ifc4::IfcRepresentationItem::StyledByItem() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[994], 0)->as<IfcStyledItem>(); }

const IfcParse::entity& Ifc4::IfcRepresentationItem::declaration() const { return *((IfcParse::entity*)IFC4_types[848]); }
const IfcParse::entity& Ifc4::IfcRepresentationItem::Class() { return *((IfcParse::entity*)IFC4_types[848]); }
Ifc4::IfcRepresentationItem::IfcRepresentationItem(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcRepresentationItem::IfcRepresentationItem() : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcRepresentationMap
::Ifc4::IfcAxis2Placement* Ifc4::IfcRepresentationMap::MappingOrigin() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcAxis2Placement>(true); }
void Ifc4::IfcRepresentationMap::setMappingOrigin(::Ifc4::IfcAxis2Placement* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcRepresentation* Ifc4::IfcRepresentationMap::MappedRepresentation() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcRepresentation>(true); }
void Ifc4::IfcRepresentationMap::setMappedRepresentation(::Ifc4::IfcRepresentation* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }

::Ifc4::IfcShapeAspect::list::ptr Ifc4::IfcRepresentationMap::HasShapeAspects() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[890], 4)->as<IfcShapeAspect>(); }
::Ifc4::IfcMappedItem::list::ptr Ifc4::IfcRepresentationMap::MapUsage() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[553], 0)->as<IfcMappedItem>(); }

const IfcParse::entity& Ifc4::IfcRepresentationMap::declaration() const { return *((IfcParse::entity*)IFC4_types[849]); }
const IfcParse::entity& Ifc4::IfcRepresentationMap::Class() { return *((IfcParse::entity*)IFC4_types[849]); }
Ifc4::IfcRepresentationMap::IfcRepresentationMap(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcRepresentationMap::IfcRepresentationMap(::Ifc4::IfcAxis2Placement* v1_MappingOrigin, ::Ifc4::IfcRepresentation* v2_MappedRepresentation) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_MappingOrigin ? v1_MappingOrigin->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_MappedRepresentation ? v2_MappedRepresentation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcResource
boost::optional< std::string > Ifc4::IfcResource::Identification() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcResource::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcResource::LongDescription() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcResource::setLongDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }

::Ifc4::IfcRelAssignsToResource::list::ptr Ifc4::IfcResource::ResourceOf() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[805], 6)->as<IfcRelAssignsToResource>(); }

const IfcParse::entity& Ifc4::IfcResource::declaration() const { return *((IfcParse::entity*)IFC4_types[850]); }
const IfcParse::entity& Ifc4::IfcResource::Class() { return *((IfcParse::entity*)IFC4_types[850]); }
Ifc4::IfcResource::IfcResource(IfcEntityInstanceData&& e) : IfcObject(std::move(e)) { }
Ifc4::IfcResource::IfcResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription) : IfcObject(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }; populate_derived(); }

// Function implementations for IfcResourceApprovalRelationship
aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr Ifc4::IfcResourceApprovalRelationship::RelatedResourceObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcResourceObjectSelect >(); }
void Ifc4::IfcResourceApprovalRelationship::setRelatedResourceObjects(aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcApproval* Ifc4::IfcResourceApprovalRelationship::RelatingApproval() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcApproval>(true); }
void Ifc4::IfcResourceApprovalRelationship::setRelatingApproval(::Ifc4::IfcApproval* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcResourceApprovalRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[851]); }
const IfcParse::entity& Ifc4::IfcResourceApprovalRelationship::Class() { return *((IfcParse::entity*)IFC4_types[851]); }
Ifc4::IfcResourceApprovalRelationship::IfcResourceApprovalRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcResourceApprovalRelationship::IfcResourceApprovalRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr v3_RelatedResourceObjects, ::Ifc4::IfcApproval* v4_RelatingApproval) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_RelatedResourceObjects)->generalize());set_attribute_value(3, v4_RelatingApproval ? v4_RelatingApproval->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcResourceConstraintRelationship
::Ifc4::IfcConstraint* Ifc4::IfcResourceConstraintRelationship::RelatingConstraint() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcConstraint>(true); }
void Ifc4::IfcResourceConstraintRelationship::setRelatingConstraint(::Ifc4::IfcConstraint* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr Ifc4::IfcResourceConstraintRelationship::RelatedResourceObjects() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(3); return es->as< ::Ifc4::IfcResourceObjectSelect >(); }
void Ifc4::IfcResourceConstraintRelationship::setRelatedResourceObjects(aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr v) { set_attribute_value(3, (v)->generalize());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcResourceConstraintRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[852]); }
const IfcParse::entity& Ifc4::IfcResourceConstraintRelationship::Class() { return *((IfcParse::entity*)IFC4_types[852]); }
Ifc4::IfcResourceConstraintRelationship::IfcResourceConstraintRelationship(IfcEntityInstanceData&& e) : IfcResourceLevelRelationship(std::move(e)) { }
Ifc4::IfcResourceConstraintRelationship::IfcResourceConstraintRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description, ::Ifc4::IfcConstraint* v3_RelatingConstraint, aggregate_of< ::Ifc4::IfcResourceObjectSelect >::ptr v4_RelatedResourceObjects) : IfcResourceLevelRelationship(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, v3_RelatingConstraint ? v3_RelatingConstraint->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_RelatedResourceObjects)->generalize());; populate_derived(); }

// Function implementations for IfcResourceLevelRelationship
boost::optional< std::string > Ifc4::IfcResourceLevelRelationship::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcResourceLevelRelationship::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcResourceLevelRelationship::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcResourceLevelRelationship::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }


const IfcParse::entity& Ifc4::IfcResourceLevelRelationship::declaration() const { return *((IfcParse::entity*)IFC4_types[853]); }
const IfcParse::entity& Ifc4::IfcResourceLevelRelationship::Class() { return *((IfcParse::entity*)IFC4_types[853]); }
Ifc4::IfcResourceLevelRelationship::IfcResourceLevelRelationship(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcResourceLevelRelationship::IfcResourceLevelRelationship(boost::optional< std::string > v1_Name, boost::optional< std::string > v2_Description) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); }; populate_derived(); }

// Function implementations for IfcResourceTime
boost::optional< std::string > Ifc4::IfcResourceTime::ScheduleWork() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcResourceTime::setScheduleWork(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcResourceTime::ScheduleUsage() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcResourceTime::setScheduleUsage(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcResourceTime::ScheduleStart() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcResourceTime::setScheduleStart(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcResourceTime::ScheduleFinish() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcResourceTime::setScheduleFinish(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcResourceTime::ScheduleContour() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcResourceTime::setScheduleContour(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcResourceTime::LevelingDelay() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcResourceTime::setLevelingDelay(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< bool > Ifc4::IfcResourceTime::IsOverAllocated() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } bool v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcResourceTime::setIsOverAllocated(boost::optional< bool > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< std::string > Ifc4::IfcResourceTime::StatusTime() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcResourceTime::setStatusTime(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< std::string > Ifc4::IfcResourceTime::ActualWork() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcResourceTime::setActualWork(boost::optional< std::string > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< double > Ifc4::IfcResourceTime::ActualUsage() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcResourceTime::setActualUsage(boost::optional< double > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< std::string > Ifc4::IfcResourceTime::ActualStart() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcResourceTime::setActualStart(boost::optional< std::string > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
boost::optional< std::string > Ifc4::IfcResourceTime::ActualFinish() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcResourceTime::setActualFinish(boost::optional< std::string > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }
boost::optional< std::string > Ifc4::IfcResourceTime::RemainingWork() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(15); return v; }
void Ifc4::IfcResourceTime::setRemainingWork(boost::optional< std::string > v) { if (v) {set_attribute_value(15, *v);} else {unset_attribute_value(15);} }
boost::optional< double > Ifc4::IfcResourceTime::RemainingUsage() const { if(data_.get_attribute_value(16).isNull()) { return boost::none; } double v = data_.get_attribute_value(16); return v; }
void Ifc4::IfcResourceTime::setRemainingUsage(boost::optional< double > v) { if (v) {set_attribute_value(16, *v);} else {unset_attribute_value(16);} }
boost::optional< double > Ifc4::IfcResourceTime::Completion() const { if(data_.get_attribute_value(17).isNull()) { return boost::none; } double v = data_.get_attribute_value(17); return v; }
void Ifc4::IfcResourceTime::setCompletion(boost::optional< double > v) { if (v) {set_attribute_value(17, *v);} else {unset_attribute_value(17);} }


const IfcParse::entity& Ifc4::IfcResourceTime::declaration() const { return *((IfcParse::entity*)IFC4_types[856]); }
const IfcParse::entity& Ifc4::IfcResourceTime::Class() { return *((IfcParse::entity*)IFC4_types[856]); }
Ifc4::IfcResourceTime::IfcResourceTime(IfcEntityInstanceData&& e) : IfcSchedulingTime(std::move(e)) { }
Ifc4::IfcResourceTime::IfcResourceTime(boost::optional< std::string > v1_Name, boost::optional< ::Ifc4::IfcDataOriginEnum::Value > v2_DataOrigin, boost::optional< std::string > v3_UserDefinedDataOrigin, boost::optional< std::string > v4_ScheduleWork, boost::optional< double > v5_ScheduleUsage, boost::optional< std::string > v6_ScheduleStart, boost::optional< std::string > v7_ScheduleFinish, boost::optional< std::string > v8_ScheduleContour, boost::optional< std::string > v9_LevelingDelay, boost::optional< bool > v10_IsOverAllocated, boost::optional< std::string > v11_StatusTime, boost::optional< std::string > v12_ActualWork, boost::optional< double > v13_ActualUsage, boost::optional< std::string > v14_ActualStart, boost::optional< std::string > v15_ActualFinish, boost::optional< std::string > v16_RemainingWork, boost::optional< double > v17_RemainingUsage, boost::optional< double > v18_Completion) : IfcSchedulingTime(IfcEntityInstanceData(storage_t(18))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DataOrigin) {set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)*v2_DataOrigin))); } if (v3_UserDefinedDataOrigin) {set_attribute_value(2, (*v3_UserDefinedDataOrigin)); } if (v4_ScheduleWork) {set_attribute_value(3, (*v4_ScheduleWork)); } if (v5_ScheduleUsage) {set_attribute_value(4, (*v5_ScheduleUsage)); } if (v6_ScheduleStart) {set_attribute_value(5, (*v6_ScheduleStart)); } if (v7_ScheduleFinish) {set_attribute_value(6, (*v7_ScheduleFinish)); } if (v8_ScheduleContour) {set_attribute_value(7, (*v8_ScheduleContour)); } if (v9_LevelingDelay) {set_attribute_value(8, (*v9_LevelingDelay)); } if (v10_IsOverAllocated) {set_attribute_value(9, (*v10_IsOverAllocated)); } if (v11_StatusTime) {set_attribute_value(10, (*v11_StatusTime)); } if (v12_ActualWork) {set_attribute_value(11, (*v12_ActualWork)); } if (v13_ActualUsage) {set_attribute_value(12, (*v13_ActualUsage)); } if (v14_ActualStart) {set_attribute_value(13, (*v14_ActualStart)); } if (v15_ActualFinish) {set_attribute_value(14, (*v15_ActualFinish)); } if (v16_RemainingWork) {set_attribute_value(15, (*v16_RemainingWork)); } if (v17_RemainingUsage) {set_attribute_value(16, (*v17_RemainingUsage)); } if (v18_Completion) {set_attribute_value(17, (*v18_Completion)); }; populate_derived(); }

// Function implementations for IfcRevolvedAreaSolid
::Ifc4::IfcAxis1Placement* Ifc4::IfcRevolvedAreaSolid::Axis() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcAxis1Placement>(true); }
void Ifc4::IfcRevolvedAreaSolid::setAxis(::Ifc4::IfcAxis1Placement* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcRevolvedAreaSolid::Angle() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcRevolvedAreaSolid::setAngle(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcRevolvedAreaSolid::declaration() const { return *((IfcParse::entity*)IFC4_types[857]); }
const IfcParse::entity& Ifc4::IfcRevolvedAreaSolid::Class() { return *((IfcParse::entity*)IFC4_types[857]); }
Ifc4::IfcRevolvedAreaSolid::IfcRevolvedAreaSolid(IfcEntityInstanceData&& e) : IfcSweptAreaSolid(std::move(e)) { }
Ifc4::IfcRevolvedAreaSolid::IfcRevolvedAreaSolid(::Ifc4::IfcProfileDef* v1_SweptArea, ::Ifc4::IfcAxis2Placement3D* v2_Position, ::Ifc4::IfcAxis1Placement* v3_Axis, double v4_Angle) : IfcSweptAreaSolid(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_SweptArea ? v1_SweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_Axis ? v3_Axis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Angle));; populate_derived(); }

// Function implementations for IfcRevolvedAreaSolidTapered
::Ifc4::IfcProfileDef* Ifc4::IfcRevolvedAreaSolidTapered::EndSweptArea() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcRevolvedAreaSolidTapered::setEndSweptArea(::Ifc4::IfcProfileDef* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcRevolvedAreaSolidTapered::declaration() const { return *((IfcParse::entity*)IFC4_types[858]); }
const IfcParse::entity& Ifc4::IfcRevolvedAreaSolidTapered::Class() { return *((IfcParse::entity*)IFC4_types[858]); }
Ifc4::IfcRevolvedAreaSolidTapered::IfcRevolvedAreaSolidTapered(IfcEntityInstanceData&& e) : IfcRevolvedAreaSolid(std::move(e)) { }
Ifc4::IfcRevolvedAreaSolidTapered::IfcRevolvedAreaSolidTapered(::Ifc4::IfcProfileDef* v1_SweptArea, ::Ifc4::IfcAxis2Placement3D* v2_Position, ::Ifc4::IfcAxis1Placement* v3_Axis, double v4_Angle, ::Ifc4::IfcProfileDef* v5_EndSweptArea) : IfcRevolvedAreaSolid(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_SweptArea ? v1_SweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_Axis ? v3_Axis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Angle));set_attribute_value(4, v5_EndSweptArea ? v5_EndSweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcRightCircularCone
double Ifc4::IfcRightCircularCone::Height() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcRightCircularCone::setHeight(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcRightCircularCone::BottomRadius() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcRightCircularCone::setBottomRadius(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcRightCircularCone::declaration() const { return *((IfcParse::entity*)IFC4_types[859]); }
const IfcParse::entity& Ifc4::IfcRightCircularCone::Class() { return *((IfcParse::entity*)IFC4_types[859]); }
Ifc4::IfcRightCircularCone::IfcRightCircularCone(IfcEntityInstanceData&& e) : IfcCsgPrimitive3D(std::move(e)) { }
Ifc4::IfcRightCircularCone::IfcRightCircularCone(::Ifc4::IfcAxis2Placement3D* v1_Position, double v2_Height, double v3_BottomRadius) : IfcCsgPrimitive3D(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Height));set_attribute_value(2, (v3_BottomRadius));; populate_derived(); }

// Function implementations for IfcRightCircularCylinder
double Ifc4::IfcRightCircularCylinder::Height() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcRightCircularCylinder::setHeight(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcRightCircularCylinder::Radius() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcRightCircularCylinder::setRadius(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcRightCircularCylinder::declaration() const { return *((IfcParse::entity*)IFC4_types[860]); }
const IfcParse::entity& Ifc4::IfcRightCircularCylinder::Class() { return *((IfcParse::entity*)IFC4_types[860]); }
Ifc4::IfcRightCircularCylinder::IfcRightCircularCylinder(IfcEntityInstanceData&& e) : IfcCsgPrimitive3D(std::move(e)) { }
Ifc4::IfcRightCircularCylinder::IfcRightCircularCylinder(::Ifc4::IfcAxis2Placement3D* v1_Position, double v2_Height, double v3_Radius) : IfcCsgPrimitive3D(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Height));set_attribute_value(2, (v3_Radius));; populate_derived(); }

// Function implementations for IfcRoof
boost::optional< ::Ifc4::IfcRoofTypeEnum::Value > Ifc4::IfcRoof::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcRoofTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcRoof::setPredefinedType(boost::optional< ::Ifc4::IfcRoofTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcRoofTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcRoof::declaration() const { return *((IfcParse::entity*)IFC4_types[862]); }
const IfcParse::entity& Ifc4::IfcRoof::Class() { return *((IfcParse::entity*)IFC4_types[862]); }
Ifc4::IfcRoof::IfcRoof(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcRoof::IfcRoof(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcRoofTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcRoofTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcRoofType
::Ifc4::IfcRoofTypeEnum::Value Ifc4::IfcRoofType::PredefinedType() const {  return ::Ifc4::IfcRoofTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcRoofType::setPredefinedType(::Ifc4::IfcRoofTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcRoofTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcRoofType::declaration() const { return *((IfcParse::entity*)IFC4_types[863]); }
const IfcParse::entity& Ifc4::IfcRoofType::Class() { return *((IfcParse::entity*)IFC4_types[863]); }
Ifc4::IfcRoofType::IfcRoofType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcRoofType::IfcRoofType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcRoofTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcRoofTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcRoot
std::string Ifc4::IfcRoot::GlobalId() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcRoot::setGlobalId(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcOwnerHistory* Ifc4::IfcRoot::OwnerHistory() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcOwnerHistory>(true); }
void Ifc4::IfcRoot::setOwnerHistory(::Ifc4::IfcOwnerHistory* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
boost::optional< std::string > Ifc4::IfcRoot::Name() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcRoot::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::string > Ifc4::IfcRoot::Description() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcRoot::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcRoot::declaration() const { return *((IfcParse::entity*)IFC4_types[865]); }
const IfcParse::entity& Ifc4::IfcRoot::Class() { return *((IfcParse::entity*)IFC4_types[865]); }
Ifc4::IfcRoot::IfcRoot(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcRoot::IfcRoot(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }; populate_derived(); }

// Function implementations for IfcRoundedRectangleProfileDef
double Ifc4::IfcRoundedRectangleProfileDef::RoundingRadius() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcRoundedRectangleProfileDef::setRoundingRadius(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcRoundedRectangleProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[870]); }
const IfcParse::entity& Ifc4::IfcRoundedRectangleProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[870]); }
Ifc4::IfcRoundedRectangleProfileDef::IfcRoundedRectangleProfileDef(IfcEntityInstanceData&& e) : IfcRectangleProfileDef(std::move(e)) { }
Ifc4::IfcRoundedRectangleProfileDef::IfcRoundedRectangleProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_XDim, double v5_YDim, double v6_RoundingRadius) : IfcRectangleProfileDef(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_XDim));set_attribute_value(4, (v5_YDim));set_attribute_value(5, (v6_RoundingRadius));; populate_derived(); }

// Function implementations for IfcSIUnit
boost::optional< ::Ifc4::IfcSIPrefix::Value > Ifc4::IfcSIUnit::Prefix() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } return ::Ifc4::IfcSIPrefix::FromString(data_.get_attribute_value(2)); }
void Ifc4::IfcSIUnit::setPrefix(boost::optional< ::Ifc4::IfcSIPrefix::Value > v) { if (v) {set_attribute_value(2, EnumerationReference(&::Ifc4::IfcSIPrefix::Class(), (size_t) *v));} else {unset_attribute_value(2);} }
::Ifc4::IfcSIUnitName::Value Ifc4::IfcSIUnit::Name() const {  return ::Ifc4::IfcSIUnitName::FromString(data_.get_attribute_value(3)); }
void Ifc4::IfcSIUnit::setName(::Ifc4::IfcSIUnitName::Value v) { set_attribute_value(3, EnumerationReference(&::Ifc4::IfcSIUnitName::Class(), (size_t) v));if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcSIUnit::declaration() const { return *((IfcParse::entity*)IFC4_types[902]); }
const IfcParse::entity& Ifc4::IfcSIUnit::Class() { return *((IfcParse::entity*)IFC4_types[902]); }
Ifc4::IfcSIUnit::IfcSIUnit(IfcEntityInstanceData&& e) : IfcNamedUnit(std::move(e)) { }
Ifc4::IfcSIUnit::IfcSIUnit(::Ifc4::IfcUnitEnum::Value v2_UnitType, boost::optional< ::Ifc4::IfcSIPrefix::Value > v3_Prefix, ::Ifc4::IfcSIUnitName::Value v4_Name) : IfcNamedUnit(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcUnitEnum::Class(),(size_t)v2_UnitType))); if (v3_Prefix) {set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcSIPrefix::Class(),(size_t)*v3_Prefix))); }set_attribute_value(3, (EnumerationReference(&::Ifc4::IfcSIUnitName::Class(),(size_t)v4_Name)));; populate_derived(); }

// Function implementations for IfcSanitaryTerminal
boost::optional< ::Ifc4::IfcSanitaryTerminalTypeEnum::Value > Ifc4::IfcSanitaryTerminal::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSanitaryTerminalTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSanitaryTerminal::setPredefinedType(boost::optional< ::Ifc4::IfcSanitaryTerminalTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSanitaryTerminalTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSanitaryTerminal::declaration() const { return *((IfcParse::entity*)IFC4_types[871]); }
const IfcParse::entity& Ifc4::IfcSanitaryTerminal::Class() { return *((IfcParse::entity*)IFC4_types[871]); }
Ifc4::IfcSanitaryTerminal::IfcSanitaryTerminal(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcSanitaryTerminal::IfcSanitaryTerminal(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSanitaryTerminalTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSanitaryTerminalTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSanitaryTerminalType
::Ifc4::IfcSanitaryTerminalTypeEnum::Value Ifc4::IfcSanitaryTerminalType::PredefinedType() const {  return ::Ifc4::IfcSanitaryTerminalTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSanitaryTerminalType::setPredefinedType(::Ifc4::IfcSanitaryTerminalTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSanitaryTerminalTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcSanitaryTerminalType::declaration() const { return *((IfcParse::entity*)IFC4_types[872]); }
const IfcParse::entity& Ifc4::IfcSanitaryTerminalType::Class() { return *((IfcParse::entity*)IFC4_types[872]); }
Ifc4::IfcSanitaryTerminalType::IfcSanitaryTerminalType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcSanitaryTerminalType::IfcSanitaryTerminalType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcSanitaryTerminalTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSanitaryTerminalTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcSchedulingTime
boost::optional< std::string > Ifc4::IfcSchedulingTime::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcSchedulingTime::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< ::Ifc4::IfcDataOriginEnum::Value > Ifc4::IfcSchedulingTime::DataOrigin() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } return ::Ifc4::IfcDataOriginEnum::FromString(data_.get_attribute_value(1)); }
void Ifc4::IfcSchedulingTime::setDataOrigin(boost::optional< ::Ifc4::IfcDataOriginEnum::Value > v) { if (v) {set_attribute_value(1, EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(), (size_t) *v));} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcSchedulingTime::UserDefinedDataOrigin() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcSchedulingTime::setUserDefinedDataOrigin(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcSchedulingTime::declaration() const { return *((IfcParse::entity*)IFC4_types[874]); }
const IfcParse::entity& Ifc4::IfcSchedulingTime::Class() { return *((IfcParse::entity*)IFC4_types[874]); }
Ifc4::IfcSchedulingTime::IfcSchedulingTime(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcSchedulingTime::IfcSchedulingTime(boost::optional< std::string > v1_Name, boost::optional< ::Ifc4::IfcDataOriginEnum::Value > v2_DataOrigin, boost::optional< std::string > v3_UserDefinedDataOrigin) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DataOrigin) {set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)*v2_DataOrigin))); } if (v3_UserDefinedDataOrigin) {set_attribute_value(2, (*v3_UserDefinedDataOrigin)); }; populate_derived(); }

// Function implementations for IfcSeamCurve


const IfcParse::entity& Ifc4::IfcSeamCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[875]); }
const IfcParse::entity& Ifc4::IfcSeamCurve::Class() { return *((IfcParse::entity*)IFC4_types[875]); }
Ifc4::IfcSeamCurve::IfcSeamCurve(IfcEntityInstanceData&& e) : IfcSurfaceCurve(std::move(e)) { }
Ifc4::IfcSeamCurve::IfcSeamCurve(::Ifc4::IfcCurve* v1_Curve3D, aggregate_of< ::Ifc4::IfcPcurve >::ptr v2_AssociatedGeometry, ::Ifc4::IfcPreferredSurfaceCurveRepresentation::Value v3_MasterRepresentation) : IfcSurfaceCurve(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Curve3D ? v1_Curve3D->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_AssociatedGeometry)->generalize());set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcPreferredSurfaceCurveRepresentation::Class(),(size_t)v3_MasterRepresentation)));; populate_derived(); }

// Function implementations for IfcSectionProperties
::Ifc4::IfcSectionTypeEnum::Value Ifc4::IfcSectionProperties::SectionType() const {  return ::Ifc4::IfcSectionTypeEnum::FromString(data_.get_attribute_value(0)); }
void Ifc4::IfcSectionProperties::setSectionType(::Ifc4::IfcSectionTypeEnum::Value v) { set_attribute_value(0, EnumerationReference(&::Ifc4::IfcSectionTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcProfileDef* Ifc4::IfcSectionProperties::StartProfile() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcSectionProperties::setStartProfile(::Ifc4::IfcProfileDef* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcProfileDef* Ifc4::IfcSectionProperties::EndProfile() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcSectionProperties::setEndProfile(::Ifc4::IfcProfileDef* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcSectionProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[879]); }
const IfcParse::entity& Ifc4::IfcSectionProperties::Class() { return *((IfcParse::entity*)IFC4_types[879]); }
Ifc4::IfcSectionProperties::IfcSectionProperties(IfcEntityInstanceData&& e) : IfcPreDefinedProperties(std::move(e)) { }
Ifc4::IfcSectionProperties::IfcSectionProperties(::Ifc4::IfcSectionTypeEnum::Value v1_SectionType, ::Ifc4::IfcProfileDef* v2_StartProfile, ::Ifc4::IfcProfileDef* v3_EndProfile) : IfcPreDefinedProperties(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcSectionTypeEnum::Class(),(size_t)v1_SectionType)));set_attribute_value(1, v2_StartProfile ? v2_StartProfile->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_EndProfile ? v3_EndProfile->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcSectionReinforcementProperties
double Ifc4::IfcSectionReinforcementProperties::LongitudinalStartPosition() const {  double v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcSectionReinforcementProperties::setLongitudinalStartPosition(double v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcSectionReinforcementProperties::LongitudinalEndPosition() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSectionReinforcementProperties::setLongitudinalEndPosition(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< double > Ifc4::IfcSectionReinforcementProperties::TransversePosition() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcSectionReinforcementProperties::setTransversePosition(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
::Ifc4::IfcReinforcingBarRoleEnum::Value Ifc4::IfcSectionReinforcementProperties::ReinforcementRole() const {  return ::Ifc4::IfcReinforcingBarRoleEnum::FromString(data_.get_attribute_value(3)); }
void Ifc4::IfcSectionReinforcementProperties::setReinforcementRole(::Ifc4::IfcReinforcingBarRoleEnum::Value v) { set_attribute_value(3, EnumerationReference(&::Ifc4::IfcReinforcingBarRoleEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcSectionProperties* Ifc4::IfcSectionReinforcementProperties::SectionDefinition() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcSectionProperties>(true); }
void Ifc4::IfcSectionReinforcementProperties::setSectionDefinition(::Ifc4::IfcSectionProperties* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
aggregate_of< ::Ifc4::IfcReinforcementBarProperties >::ptr Ifc4::IfcSectionReinforcementProperties::CrossSectionReinforcementDefinitions() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcReinforcementBarProperties >(); }
void Ifc4::IfcSectionReinforcementProperties::setCrossSectionReinforcementDefinitions(aggregate_of< ::Ifc4::IfcReinforcementBarProperties >::ptr v) { set_attribute_value(5, (v)->generalize());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcSectionReinforcementProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[880]); }
const IfcParse::entity& Ifc4::IfcSectionReinforcementProperties::Class() { return *((IfcParse::entity*)IFC4_types[880]); }
Ifc4::IfcSectionReinforcementProperties::IfcSectionReinforcementProperties(IfcEntityInstanceData&& e) : IfcPreDefinedProperties(std::move(e)) { }
Ifc4::IfcSectionReinforcementProperties::IfcSectionReinforcementProperties(double v1_LongitudinalStartPosition, double v2_LongitudinalEndPosition, boost::optional< double > v3_TransversePosition, ::Ifc4::IfcReinforcingBarRoleEnum::Value v4_ReinforcementRole, ::Ifc4::IfcSectionProperties* v5_SectionDefinition, aggregate_of< ::Ifc4::IfcReinforcementBarProperties >::ptr v6_CrossSectionReinforcementDefinitions) : IfcPreDefinedProperties(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_LongitudinalStartPosition));set_attribute_value(1, (v2_LongitudinalEndPosition)); if (v3_TransversePosition) {set_attribute_value(2, (*v3_TransversePosition)); }set_attribute_value(3, (EnumerationReference(&::Ifc4::IfcReinforcingBarRoleEnum::Class(),(size_t)v4_ReinforcementRole)));set_attribute_value(4, v5_SectionDefinition ? v5_SectionDefinition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, (v6_CrossSectionReinforcementDefinitions)->generalize());; populate_derived(); }

// Function implementations for IfcSectionedSpine
::Ifc4::IfcCompositeCurve* Ifc4::IfcSectionedSpine::SpineCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCompositeCurve>(true); }
void Ifc4::IfcSectionedSpine::setSpineCurve(::Ifc4::IfcCompositeCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcProfileDef >::ptr Ifc4::IfcSectionedSpine::CrossSections() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcProfileDef >(); }
void Ifc4::IfcSectionedSpine::setCrossSections(aggregate_of< ::Ifc4::IfcProfileDef >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
aggregate_of< ::Ifc4::IfcAxis2Placement3D >::ptr Ifc4::IfcSectionedSpine::CrossSectionPositions() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcAxis2Placement3D >(); }
void Ifc4::IfcSectionedSpine::setCrossSectionPositions(aggregate_of< ::Ifc4::IfcAxis2Placement3D >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcSectionedSpine::declaration() const { return *((IfcParse::entity*)IFC4_types[877]); }
const IfcParse::entity& Ifc4::IfcSectionedSpine::Class() { return *((IfcParse::entity*)IFC4_types[877]); }
Ifc4::IfcSectionedSpine::IfcSectionedSpine(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcSectionedSpine::IfcSectionedSpine(::Ifc4::IfcCompositeCurve* v1_SpineCurve, aggregate_of< ::Ifc4::IfcProfileDef >::ptr v2_CrossSections, aggregate_of< ::Ifc4::IfcAxis2Placement3D >::ptr v3_CrossSectionPositions) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_SpineCurve ? v1_SpineCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_CrossSections)->generalize());set_attribute_value(2, (v3_CrossSectionPositions)->generalize());; populate_derived(); }

// Function implementations for IfcSensor
boost::optional< ::Ifc4::IfcSensorTypeEnum::Value > Ifc4::IfcSensor::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSensorTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSensor::setPredefinedType(boost::optional< ::Ifc4::IfcSensorTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSensorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSensor::declaration() const { return *((IfcParse::entity*)IFC4_types[883]); }
const IfcParse::entity& Ifc4::IfcSensor::Class() { return *((IfcParse::entity*)IFC4_types[883]); }
Ifc4::IfcSensor::IfcSensor(IfcEntityInstanceData&& e) : IfcDistributionControlElement(std::move(e)) { }
Ifc4::IfcSensor::IfcSensor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSensorTypeEnum::Value > v9_PredefinedType) : IfcDistributionControlElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSensorTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSensorType
::Ifc4::IfcSensorTypeEnum::Value Ifc4::IfcSensorType::PredefinedType() const {  return ::Ifc4::IfcSensorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSensorType::setPredefinedType(::Ifc4::IfcSensorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSensorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcSensorType::declaration() const { return *((IfcParse::entity*)IFC4_types[884]); }
const IfcParse::entity& Ifc4::IfcSensorType::Class() { return *((IfcParse::entity*)IFC4_types[884]); }
Ifc4::IfcSensorType::IfcSensorType(IfcEntityInstanceData&& e) : IfcDistributionControlElementType(std::move(e)) { }
Ifc4::IfcSensorType::IfcSensorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcSensorTypeEnum::Value v10_PredefinedType) : IfcDistributionControlElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSensorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcShadingDevice
boost::optional< ::Ifc4::IfcShadingDeviceTypeEnum::Value > Ifc4::IfcShadingDevice::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcShadingDeviceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcShadingDevice::setPredefinedType(boost::optional< ::Ifc4::IfcShadingDeviceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcShadingDeviceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcShadingDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[887]); }
const IfcParse::entity& Ifc4::IfcShadingDevice::Class() { return *((IfcParse::entity*)IFC4_types[887]); }
Ifc4::IfcShadingDevice::IfcShadingDevice(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcShadingDevice::IfcShadingDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcShadingDeviceTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcShadingDeviceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcShadingDeviceType
::Ifc4::IfcShadingDeviceTypeEnum::Value Ifc4::IfcShadingDeviceType::PredefinedType() const {  return ::Ifc4::IfcShadingDeviceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcShadingDeviceType::setPredefinedType(::Ifc4::IfcShadingDeviceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcShadingDeviceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcShadingDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[888]); }
const IfcParse::entity& Ifc4::IfcShadingDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[888]); }
Ifc4::IfcShadingDeviceType::IfcShadingDeviceType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcShadingDeviceType::IfcShadingDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcShadingDeviceTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcShadingDeviceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcShapeAspect
aggregate_of< ::Ifc4::IfcShapeModel >::ptr Ifc4::IfcShapeAspect::ShapeRepresentations() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcShapeModel >(); }
void Ifc4::IfcShapeAspect::setShapeRepresentations(aggregate_of< ::Ifc4::IfcShapeModel >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcShapeAspect::Name() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcShapeAspect::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcShapeAspect::Description() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcShapeAspect::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::logic::tribool Ifc4::IfcShapeAspect::ProductDefinitional() const {  boost::logic::tribool v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcShapeAspect::setProductDefinitional(boost::logic::tribool v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcProductRepresentationSelect* Ifc4::IfcShapeAspect::PartOfProductDefinitionShape() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcProductRepresentationSelect>(true); }
void Ifc4::IfcShapeAspect::setPartOfProductDefinitionShape(::Ifc4::IfcProductRepresentationSelect* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcShapeAspect::declaration() const { return *((IfcParse::entity*)IFC4_types[890]); }
const IfcParse::entity& Ifc4::IfcShapeAspect::Class() { return *((IfcParse::entity*)IFC4_types[890]); }
Ifc4::IfcShapeAspect::IfcShapeAspect(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcShapeAspect::IfcShapeAspect(aggregate_of< ::Ifc4::IfcShapeModel >::ptr v1_ShapeRepresentations, boost::optional< std::string > v2_Name, boost::optional< std::string > v3_Description, boost::logic::tribool v4_ProductDefinitional, ::Ifc4::IfcProductRepresentationSelect* v5_PartOfProductDefinitionShape) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_ShapeRepresentations)->generalize()); if (v2_Name) {set_attribute_value(1, (*v2_Name)); } if (v3_Description) {set_attribute_value(2, (*v3_Description)); }set_attribute_value(3, (v4_ProductDefinitional));set_attribute_value(4, v5_PartOfProductDefinitionShape ? v5_PartOfProductDefinitionShape->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcShapeModel

::Ifc4::IfcShapeAspect::list::ptr Ifc4::IfcShapeModel::OfShapeAspect() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[890], 0)->as<IfcShapeAspect>(); }

const IfcParse::entity& Ifc4::IfcShapeModel::declaration() const { return *((IfcParse::entity*)IFC4_types[891]); }
const IfcParse::entity& Ifc4::IfcShapeModel::Class() { return *((IfcParse::entity*)IFC4_types[891]); }
Ifc4::IfcShapeModel::IfcShapeModel(IfcEntityInstanceData&& e) : IfcRepresentation(std::move(e)) { }
Ifc4::IfcShapeModel::IfcShapeModel(::Ifc4::IfcRepresentationContext* v1_ContextOfItems, boost::optional< std::string > v2_RepresentationIdentifier, boost::optional< std::string > v3_RepresentationType, aggregate_of< ::Ifc4::IfcRepresentationItem >::ptr v4_Items) : IfcRepresentation(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_ContextOfItems ? v1_ContextOfItems->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_RepresentationIdentifier) {set_attribute_value(1, (*v2_RepresentationIdentifier)); } if (v3_RepresentationType) {set_attribute_value(2, (*v3_RepresentationType)); }set_attribute_value(3, (v4_Items)->generalize());; populate_derived(); }

// Function implementations for IfcShapeRepresentation


const IfcParse::entity& Ifc4::IfcShapeRepresentation::declaration() const { return *((IfcParse::entity*)IFC4_types[892]); }
const IfcParse::entity& Ifc4::IfcShapeRepresentation::Class() { return *((IfcParse::entity*)IFC4_types[892]); }
Ifc4::IfcShapeRepresentation::IfcShapeRepresentation(IfcEntityInstanceData&& e) : IfcShapeModel(std::move(e)) { }
Ifc4::IfcShapeRepresentation::IfcShapeRepresentation(::Ifc4::IfcRepresentationContext* v1_ContextOfItems, boost::optional< std::string > v2_RepresentationIdentifier, boost::optional< std::string > v3_RepresentationType, aggregate_of< ::Ifc4::IfcRepresentationItem >::ptr v4_Items) : IfcShapeModel(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_ContextOfItems ? v1_ContextOfItems->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_RepresentationIdentifier) {set_attribute_value(1, (*v2_RepresentationIdentifier)); } if (v3_RepresentationType) {set_attribute_value(2, (*v3_RepresentationType)); }set_attribute_value(3, (v4_Items)->generalize());; populate_derived(); }

// Function implementations for IfcShellBasedSurfaceModel
aggregate_of< ::Ifc4::IfcShell >::ptr Ifc4::IfcShellBasedSurfaceModel::SbsmBoundary() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcShell >(); }
void Ifc4::IfcShellBasedSurfaceModel::setSbsmBoundary(aggregate_of< ::Ifc4::IfcShell >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcShellBasedSurfaceModel::declaration() const { return *((IfcParse::entity*)IFC4_types[895]); }
const IfcParse::entity& Ifc4::IfcShellBasedSurfaceModel::Class() { return *((IfcParse::entity*)IFC4_types[895]); }
Ifc4::IfcShellBasedSurfaceModel::IfcShellBasedSurfaceModel(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcShellBasedSurfaceModel::IfcShellBasedSurfaceModel(aggregate_of< ::Ifc4::IfcShell >::ptr v1_SbsmBoundary) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_SbsmBoundary)->generalize());; populate_derived(); }

// Function implementations for IfcSimpleProperty


const IfcParse::entity& Ifc4::IfcSimpleProperty::declaration() const { return *((IfcParse::entity*)IFC4_types[896]); }
const IfcParse::entity& Ifc4::IfcSimpleProperty::Class() { return *((IfcParse::entity*)IFC4_types[896]); }
Ifc4::IfcSimpleProperty::IfcSimpleProperty(IfcEntityInstanceData&& e) : IfcProperty(std::move(e)) { }
Ifc4::IfcSimpleProperty::IfcSimpleProperty(std::string v1_Name, boost::optional< std::string > v2_Description) : IfcProperty(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }; populate_derived(); }

// Function implementations for IfcSimplePropertyTemplate
boost::optional< ::Ifc4::IfcSimplePropertyTemplateTypeEnum::Value > Ifc4::IfcSimplePropertyTemplate::TemplateType() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } return ::Ifc4::IfcSimplePropertyTemplateTypeEnum::FromString(data_.get_attribute_value(4)); }
void Ifc4::IfcSimplePropertyTemplate::setTemplateType(boost::optional< ::Ifc4::IfcSimplePropertyTemplateTypeEnum::Value > v) { if (v) {set_attribute_value(4, EnumerationReference(&::Ifc4::IfcSimplePropertyTemplateTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcSimplePropertyTemplate::PrimaryMeasureType() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcSimplePropertyTemplate::setPrimaryMeasureType(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcSimplePropertyTemplate::SecondaryMeasureType() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcSimplePropertyTemplate::setSecondaryMeasureType(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
::Ifc4::IfcPropertyEnumeration* Ifc4::IfcSimplePropertyTemplate::Enumerators() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcPropertyEnumeration>(true); }
void Ifc4::IfcSimplePropertyTemplate::setEnumerators(::Ifc4::IfcPropertyEnumeration* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcUnit* Ifc4::IfcSimplePropertyTemplate::PrimaryUnit() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcSimplePropertyTemplate::setPrimaryUnit(::Ifc4::IfcUnit* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }
::Ifc4::IfcUnit* Ifc4::IfcSimplePropertyTemplate::SecondaryUnit() const { if(data_.get_attribute_value(9).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcSimplePropertyTemplate::setSecondaryUnit(::Ifc4::IfcUnit* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }
boost::optional< std::string > Ifc4::IfcSimplePropertyTemplate::Expression() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcSimplePropertyTemplate::setExpression(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< ::Ifc4::IfcStateEnum::Value > Ifc4::IfcSimplePropertyTemplate::AccessState() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } return ::Ifc4::IfcStateEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcSimplePropertyTemplate::setAccessState(boost::optional< ::Ifc4::IfcStateEnum::Value > v) { if (v) {set_attribute_value(11, EnumerationReference(&::Ifc4::IfcStateEnum::Class(), (size_t) *v));} else {unset_attribute_value(11);} }


const IfcParse::entity& Ifc4::IfcSimplePropertyTemplate::declaration() const { return *((IfcParse::entity*)IFC4_types[897]); }
const IfcParse::entity& Ifc4::IfcSimplePropertyTemplate::Class() { return *((IfcParse::entity*)IFC4_types[897]); }
Ifc4::IfcSimplePropertyTemplate::IfcSimplePropertyTemplate(IfcEntityInstanceData&& e) : IfcPropertyTemplate(std::move(e)) { }
Ifc4::IfcSimplePropertyTemplate::IfcSimplePropertyTemplate(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< ::Ifc4::IfcSimplePropertyTemplateTypeEnum::Value > v5_TemplateType, boost::optional< std::string > v6_PrimaryMeasureType, boost::optional< std::string > v7_SecondaryMeasureType, ::Ifc4::IfcPropertyEnumeration* v8_Enumerators, ::Ifc4::IfcUnit* v9_PrimaryUnit, ::Ifc4::IfcUnit* v10_SecondaryUnit, boost::optional< std::string > v11_Expression, boost::optional< ::Ifc4::IfcStateEnum::Value > v12_AccessState) : IfcPropertyTemplate(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_TemplateType) {set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcSimplePropertyTemplateTypeEnum::Class(),(size_t)*v5_TemplateType))); } if (v6_PrimaryMeasureType) {set_attribute_value(5, (*v6_PrimaryMeasureType)); } if (v7_SecondaryMeasureType) {set_attribute_value(6, (*v7_SecondaryMeasureType)); }set_attribute_value(7, v8_Enumerators ? v8_Enumerators->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, v9_PrimaryUnit ? v9_PrimaryUnit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(9, v10_SecondaryUnit ? v10_SecondaryUnit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v11_Expression) {set_attribute_value(10, (*v11_Expression)); } if (v12_AccessState) {set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcStateEnum::Class(),(size_t)*v12_AccessState))); }; populate_derived(); }

// Function implementations for IfcSite
boost::optional< std::vector< int > /*[3:4]*/ > Ifc4::IfcSite::RefLatitude() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } std::vector< int > /*[3:4]*/ v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcSite::setRefLatitude(boost::optional< std::vector< int > /*[3:4]*/ > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< std::vector< int > /*[3:4]*/ > Ifc4::IfcSite::RefLongitude() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::vector< int > /*[3:4]*/ v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcSite::setRefLongitude(boost::optional< std::vector< int > /*[3:4]*/ > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcSite::RefElevation() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcSite::setRefElevation(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< std::string > Ifc4::IfcSite::LandTitleNumber() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcSite::setLandTitleNumber(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
::Ifc4::IfcPostalAddress* Ifc4::IfcSite::SiteAddress() const { if(data_.get_attribute_value(13).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(13)))->as<::Ifc4::IfcPostalAddress>(true); }
void Ifc4::IfcSite::setSiteAddress(::Ifc4::IfcPostalAddress* v) { set_attribute_value(13, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(13); }


const IfcParse::entity& Ifc4::IfcSite::declaration() const { return *((IfcParse::entity*)IFC4_types[901]); }
const IfcParse::entity& Ifc4::IfcSite::Class() { return *((IfcParse::entity*)IFC4_types[901]); }
Ifc4::IfcSite::IfcSite(IfcEntityInstanceData&& e) : IfcSpatialStructureElement(std::move(e)) { }
Ifc4::IfcSite::IfcSite(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName, boost::optional< ::Ifc4::IfcElementCompositionEnum::Value > v9_CompositionType, boost::optional< std::vector< int > /*[3:4]*/ > v10_RefLatitude, boost::optional< std::vector< int > /*[3:4]*/ > v11_RefLongitude, boost::optional< double > v12_RefElevation, boost::optional< std::string > v13_LandTitleNumber, ::Ifc4::IfcPostalAddress* v14_SiteAddress) : IfcSpatialStructureElement(IfcEntityInstanceData(storage_t(14))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); } if (v9_CompositionType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElementCompositionEnum::Class(),(size_t)*v9_CompositionType))); } if (v10_RefLatitude) {set_attribute_value(9, (*v10_RefLatitude)); } if (v11_RefLongitude) {set_attribute_value(10, (*v11_RefLongitude)); } if (v12_RefElevation) {set_attribute_value(11, (*v12_RefElevation)); } if (v13_LandTitleNumber) {set_attribute_value(12, (*v13_LandTitleNumber)); }set_attribute_value(13, v14_SiteAddress ? v14_SiteAddress->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcSlab
boost::optional< ::Ifc4::IfcSlabTypeEnum::Value > Ifc4::IfcSlab::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSlabTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSlab::setPredefinedType(boost::optional< ::Ifc4::IfcSlabTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSlabTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSlab::declaration() const { return *((IfcParse::entity*)IFC4_types[905]); }
const IfcParse::entity& Ifc4::IfcSlab::Class() { return *((IfcParse::entity*)IFC4_types[905]); }
Ifc4::IfcSlab::IfcSlab(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcSlab::IfcSlab(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSlabTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSlabTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSlabElementedCase


const IfcParse::entity& Ifc4::IfcSlabElementedCase::declaration() const { return *((IfcParse::entity*)IFC4_types[906]); }
const IfcParse::entity& Ifc4::IfcSlabElementedCase::Class() { return *((IfcParse::entity*)IFC4_types[906]); }
Ifc4::IfcSlabElementedCase::IfcSlabElementedCase(IfcEntityInstanceData&& e) : IfcSlab(std::move(e)) { }
Ifc4::IfcSlabElementedCase::IfcSlabElementedCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSlabTypeEnum::Value > v9_PredefinedType) : IfcSlab(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSlabTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSlabStandardCase


const IfcParse::entity& Ifc4::IfcSlabStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[907]); }
const IfcParse::entity& Ifc4::IfcSlabStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[907]); }
Ifc4::IfcSlabStandardCase::IfcSlabStandardCase(IfcEntityInstanceData&& e) : IfcSlab(std::move(e)) { }
Ifc4::IfcSlabStandardCase::IfcSlabStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSlabTypeEnum::Value > v9_PredefinedType) : IfcSlab(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSlabTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSlabType
::Ifc4::IfcSlabTypeEnum::Value Ifc4::IfcSlabType::PredefinedType() const {  return ::Ifc4::IfcSlabTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSlabType::setPredefinedType(::Ifc4::IfcSlabTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSlabTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcSlabType::declaration() const { return *((IfcParse::entity*)IFC4_types[908]); }
const IfcParse::entity& Ifc4::IfcSlabType::Class() { return *((IfcParse::entity*)IFC4_types[908]); }
Ifc4::IfcSlabType::IfcSlabType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcSlabType::IfcSlabType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcSlabTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSlabTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcSlippageConnectionCondition
boost::optional< double > Ifc4::IfcSlippageConnectionCondition::SlippageX() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSlippageConnectionCondition::setSlippageX(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< double > Ifc4::IfcSlippageConnectionCondition::SlippageY() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcSlippageConnectionCondition::setSlippageY(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcSlippageConnectionCondition::SlippageZ() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcSlippageConnectionCondition::setSlippageZ(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcSlippageConnectionCondition::declaration() const { return *((IfcParse::entity*)IFC4_types[910]); }
const IfcParse::entity& Ifc4::IfcSlippageConnectionCondition::Class() { return *((IfcParse::entity*)IFC4_types[910]); }
Ifc4::IfcSlippageConnectionCondition::IfcSlippageConnectionCondition(IfcEntityInstanceData&& e) : IfcStructuralConnectionCondition(std::move(e)) { }
Ifc4::IfcSlippageConnectionCondition::IfcSlippageConnectionCondition(boost::optional< std::string > v1_Name, boost::optional< double > v2_SlippageX, boost::optional< double > v3_SlippageY, boost::optional< double > v4_SlippageZ) : IfcStructuralConnectionCondition(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_SlippageX) {set_attribute_value(1, (*v2_SlippageX)); } if (v3_SlippageY) {set_attribute_value(2, (*v3_SlippageY)); } if (v4_SlippageZ) {set_attribute_value(3, (*v4_SlippageZ)); }; populate_derived(); }

// Function implementations for IfcSolarDevice
boost::optional< ::Ifc4::IfcSolarDeviceTypeEnum::Value > Ifc4::IfcSolarDevice::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSolarDeviceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSolarDevice::setPredefinedType(boost::optional< ::Ifc4::IfcSolarDeviceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSolarDeviceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSolarDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[911]); }
const IfcParse::entity& Ifc4::IfcSolarDevice::Class() { return *((IfcParse::entity*)IFC4_types[911]); }
Ifc4::IfcSolarDevice::IfcSolarDevice(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcSolarDevice::IfcSolarDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSolarDeviceTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSolarDeviceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSolarDeviceType
::Ifc4::IfcSolarDeviceTypeEnum::Value Ifc4::IfcSolarDeviceType::PredefinedType() const {  return ::Ifc4::IfcSolarDeviceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSolarDeviceType::setPredefinedType(::Ifc4::IfcSolarDeviceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSolarDeviceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcSolarDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[912]); }
const IfcParse::entity& Ifc4::IfcSolarDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[912]); }
Ifc4::IfcSolarDeviceType::IfcSolarDeviceType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcSolarDeviceType::IfcSolarDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcSolarDeviceTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSolarDeviceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcSolidModel


const IfcParse::entity& Ifc4::IfcSolidModel::declaration() const { return *((IfcParse::entity*)IFC4_types[915]); }
const IfcParse::entity& Ifc4::IfcSolidModel::Class() { return *((IfcParse::entity*)IFC4_types[915]); }
Ifc4::IfcSolidModel::IfcSolidModel(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcSolidModel::IfcSolidModel() : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcSpace
boost::optional< ::Ifc4::IfcSpaceTypeEnum::Value > Ifc4::IfcSpace::PredefinedType() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } return ::Ifc4::IfcSpaceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSpace::setPredefinedType(boost::optional< ::Ifc4::IfcSpaceTypeEnum::Value > v) { if (v) {set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSpaceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcSpace::ElevationWithFlooring() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcSpace::setElevationWithFlooring(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }

::Ifc4::IfcRelCoversSpaces::list::ptr Ifc4::IfcSpace::HasCoverings() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[825], 4)->as<IfcRelCoversSpaces>(); }
::Ifc4::IfcRelSpaceBoundary::list::ptr Ifc4::IfcSpace::BoundedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[841], 4)->as<IfcRelSpaceBoundary>(); }

const IfcParse::entity& Ifc4::IfcSpace::declaration() const { return *((IfcParse::entity*)IFC4_types[921]); }
const IfcParse::entity& Ifc4::IfcSpace::Class() { return *((IfcParse::entity*)IFC4_types[921]); }
Ifc4::IfcSpace::IfcSpace(IfcEntityInstanceData&& e) : IfcSpatialStructureElement(std::move(e)) { }
Ifc4::IfcSpace::IfcSpace(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName, boost::optional< ::Ifc4::IfcElementCompositionEnum::Value > v9_CompositionType, boost::optional< ::Ifc4::IfcSpaceTypeEnum::Value > v10_PredefinedType, boost::optional< double > v11_ElevationWithFlooring) : IfcSpatialStructureElement(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); } if (v9_CompositionType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElementCompositionEnum::Class(),(size_t)*v9_CompositionType))); } if (v10_PredefinedType) {set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSpaceTypeEnum::Class(),(size_t)*v10_PredefinedType))); } if (v11_ElevationWithFlooring) {set_attribute_value(10, (*v11_ElevationWithFlooring)); }; populate_derived(); }

// Function implementations for IfcSpaceHeater
boost::optional< ::Ifc4::IfcSpaceHeaterTypeEnum::Value > Ifc4::IfcSpaceHeater::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSpaceHeaterTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSpaceHeater::setPredefinedType(boost::optional< ::Ifc4::IfcSpaceHeaterTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSpaceHeaterTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSpaceHeater::declaration() const { return *((IfcParse::entity*)IFC4_types[923]); }
const IfcParse::entity& Ifc4::IfcSpaceHeater::Class() { return *((IfcParse::entity*)IFC4_types[923]); }
Ifc4::IfcSpaceHeater::IfcSpaceHeater(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcSpaceHeater::IfcSpaceHeater(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSpaceHeaterTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSpaceHeaterTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSpaceHeaterType
::Ifc4::IfcSpaceHeaterTypeEnum::Value Ifc4::IfcSpaceHeaterType::PredefinedType() const {  return ::Ifc4::IfcSpaceHeaterTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSpaceHeaterType::setPredefinedType(::Ifc4::IfcSpaceHeaterTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSpaceHeaterTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcSpaceHeaterType::declaration() const { return *((IfcParse::entity*)IFC4_types[924]); }
const IfcParse::entity& Ifc4::IfcSpaceHeaterType::Class() { return *((IfcParse::entity*)IFC4_types[924]); }
Ifc4::IfcSpaceHeaterType::IfcSpaceHeaterType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcSpaceHeaterType::IfcSpaceHeaterType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcSpaceHeaterTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSpaceHeaterTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcSpaceType
::Ifc4::IfcSpaceTypeEnum::Value Ifc4::IfcSpaceType::PredefinedType() const {  return ::Ifc4::IfcSpaceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSpaceType::setPredefinedType(::Ifc4::IfcSpaceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSpaceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< std::string > Ifc4::IfcSpaceType::LongName() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcSpaceType::setLongName(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcSpaceType::declaration() const { return *((IfcParse::entity*)IFC4_types[926]); }
const IfcParse::entity& Ifc4::IfcSpaceType::Class() { return *((IfcParse::entity*)IFC4_types[926]); }
Ifc4::IfcSpaceType::IfcSpaceType(IfcEntityInstanceData&& e) : IfcSpatialStructureElementType(std::move(e)) { }
Ifc4::IfcSpaceType::IfcSpaceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcSpaceTypeEnum::Value v10_PredefinedType, boost::optional< std::string > v11_LongName) : IfcSpatialStructureElementType(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSpaceTypeEnum::Class(),(size_t)v10_PredefinedType))); if (v11_LongName) {set_attribute_value(10, (*v11_LongName)); }; populate_derived(); }

// Function implementations for IfcSpatialElement
boost::optional< std::string > Ifc4::IfcSpatialElement::LongName() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcSpatialElement::setLongName(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }

::Ifc4::IfcRelContainedInSpatialStructure::list::ptr Ifc4::IfcSpatialElement::ContainsElements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[823], 5)->as<IfcRelContainedInSpatialStructure>(); }
::Ifc4::IfcRelServicesBuildings::list::ptr Ifc4::IfcSpatialElement::ServicedBySystems() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[840], 5)->as<IfcRelServicesBuildings>(); }
::Ifc4::IfcRelReferencedInSpatialStructure::list::ptr Ifc4::IfcSpatialElement::ReferencesElements() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[838], 5)->as<IfcRelReferencedInSpatialStructure>(); }

const IfcParse::entity& Ifc4::IfcSpatialElement::declaration() const { return *((IfcParse::entity*)IFC4_types[928]); }
const IfcParse::entity& Ifc4::IfcSpatialElement::Class() { return *((IfcParse::entity*)IFC4_types[928]); }
Ifc4::IfcSpatialElement::IfcSpatialElement(IfcEntityInstanceData&& e) : IfcProduct(std::move(e)) { }
Ifc4::IfcSpatialElement::IfcSpatialElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName) : IfcProduct(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); }; populate_derived(); }

// Function implementations for IfcSpatialElementType
boost::optional< std::string > Ifc4::IfcSpatialElementType::ElementType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcSpatialElementType::setElementType(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSpatialElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[929]); }
const IfcParse::entity& Ifc4::IfcSpatialElementType::Class() { return *((IfcParse::entity*)IFC4_types[929]); }
Ifc4::IfcSpatialElementType::IfcSpatialElementType(IfcEntityInstanceData&& e) : IfcTypeProduct(std::move(e)) { }
Ifc4::IfcSpatialElementType::IfcSpatialElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcTypeProduct(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcSpatialStructureElement
boost::optional< ::Ifc4::IfcElementCompositionEnum::Value > Ifc4::IfcSpatialStructureElement::CompositionType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcElementCompositionEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSpatialStructureElement::setCompositionType(boost::optional< ::Ifc4::IfcElementCompositionEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcElementCompositionEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSpatialStructureElement::declaration() const { return *((IfcParse::entity*)IFC4_types[930]); }
const IfcParse::entity& Ifc4::IfcSpatialStructureElement::Class() { return *((IfcParse::entity*)IFC4_types[930]); }
Ifc4::IfcSpatialStructureElement::IfcSpatialStructureElement(IfcEntityInstanceData&& e) : IfcSpatialElement(std::move(e)) { }
Ifc4::IfcSpatialStructureElement::IfcSpatialStructureElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName, boost::optional< ::Ifc4::IfcElementCompositionEnum::Value > v9_CompositionType) : IfcSpatialElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); } if (v9_CompositionType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcElementCompositionEnum::Class(),(size_t)*v9_CompositionType))); }; populate_derived(); }

// Function implementations for IfcSpatialStructureElementType


const IfcParse::entity& Ifc4::IfcSpatialStructureElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[931]); }
const IfcParse::entity& Ifc4::IfcSpatialStructureElementType::Class() { return *((IfcParse::entity*)IFC4_types[931]); }
Ifc4::IfcSpatialStructureElementType::IfcSpatialStructureElementType(IfcEntityInstanceData&& e) : IfcSpatialElementType(std::move(e)) { }
Ifc4::IfcSpatialStructureElementType::IfcSpatialStructureElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType) : IfcSpatialElementType(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }; populate_derived(); }

// Function implementations for IfcSpatialZone
boost::optional< ::Ifc4::IfcSpatialZoneTypeEnum::Value > Ifc4::IfcSpatialZone::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSpatialZoneTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSpatialZone::setPredefinedType(boost::optional< ::Ifc4::IfcSpatialZoneTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSpatialZoneTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSpatialZone::declaration() const { return *((IfcParse::entity*)IFC4_types[932]); }
const IfcParse::entity& Ifc4::IfcSpatialZone::Class() { return *((IfcParse::entity*)IFC4_types[932]); }
Ifc4::IfcSpatialZone::IfcSpatialZone(IfcEntityInstanceData&& e) : IfcSpatialElement(std::move(e)) { }
Ifc4::IfcSpatialZone::IfcSpatialZone(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_LongName, boost::optional< ::Ifc4::IfcSpatialZoneTypeEnum::Value > v9_PredefinedType) : IfcSpatialElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LongName) {set_attribute_value(7, (*v8_LongName)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSpatialZoneTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSpatialZoneType
::Ifc4::IfcSpatialZoneTypeEnum::Value Ifc4::IfcSpatialZoneType::PredefinedType() const {  return ::Ifc4::IfcSpatialZoneTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSpatialZoneType::setPredefinedType(::Ifc4::IfcSpatialZoneTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSpatialZoneTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< std::string > Ifc4::IfcSpatialZoneType::LongName() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcSpatialZoneType::setLongName(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcSpatialZoneType::declaration() const { return *((IfcParse::entity*)IFC4_types[933]); }
const IfcParse::entity& Ifc4::IfcSpatialZoneType::Class() { return *((IfcParse::entity*)IFC4_types[933]); }
Ifc4::IfcSpatialZoneType::IfcSpatialZoneType(IfcEntityInstanceData&& e) : IfcSpatialElementType(std::move(e)) { }
Ifc4::IfcSpatialZoneType::IfcSpatialZoneType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcSpatialZoneTypeEnum::Value v10_PredefinedType, boost::optional< std::string > v11_LongName) : IfcSpatialElementType(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSpatialZoneTypeEnum::Class(),(size_t)v10_PredefinedType))); if (v11_LongName) {set_attribute_value(10, (*v11_LongName)); }; populate_derived(); }

// Function implementations for IfcSphere
double Ifc4::IfcSphere::Radius() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSphere::setRadius(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcSphere::declaration() const { return *((IfcParse::entity*)IFC4_types[939]); }
const IfcParse::entity& Ifc4::IfcSphere::Class() { return *((IfcParse::entity*)IFC4_types[939]); }
Ifc4::IfcSphere::IfcSphere(IfcEntityInstanceData&& e) : IfcCsgPrimitive3D(std::move(e)) { }
Ifc4::IfcSphere::IfcSphere(::Ifc4::IfcAxis2Placement3D* v1_Position, double v2_Radius) : IfcCsgPrimitive3D(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Radius));; populate_derived(); }

// Function implementations for IfcSphericalSurface
double Ifc4::IfcSphericalSurface::Radius() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSphericalSurface::setRadius(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcSphericalSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[940]); }
const IfcParse::entity& Ifc4::IfcSphericalSurface::Class() { return *((IfcParse::entity*)IFC4_types[940]); }
Ifc4::IfcSphericalSurface::IfcSphericalSurface(IfcEntityInstanceData&& e) : IfcElementarySurface(std::move(e)) { }
Ifc4::IfcSphericalSurface::IfcSphericalSurface(::Ifc4::IfcAxis2Placement3D* v1_Position, double v2_Radius) : IfcElementarySurface(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Radius));; populate_derived(); }

// Function implementations for IfcStackTerminal
boost::optional< ::Ifc4::IfcStackTerminalTypeEnum::Value > Ifc4::IfcStackTerminal::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcStackTerminalTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcStackTerminal::setPredefinedType(boost::optional< ::Ifc4::IfcStackTerminalTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcStackTerminalTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcStackTerminal::declaration() const { return *((IfcParse::entity*)IFC4_types[941]); }
const IfcParse::entity& Ifc4::IfcStackTerminal::Class() { return *((IfcParse::entity*)IFC4_types[941]); }
Ifc4::IfcStackTerminal::IfcStackTerminal(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcStackTerminal::IfcStackTerminal(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcStackTerminalTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcStackTerminalTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcStackTerminalType
::Ifc4::IfcStackTerminalTypeEnum::Value Ifc4::IfcStackTerminalType::PredefinedType() const {  return ::Ifc4::IfcStackTerminalTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcStackTerminalType::setPredefinedType(::Ifc4::IfcStackTerminalTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcStackTerminalTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcStackTerminalType::declaration() const { return *((IfcParse::entity*)IFC4_types[942]); }
const IfcParse::entity& Ifc4::IfcStackTerminalType::Class() { return *((IfcParse::entity*)IFC4_types[942]); }
Ifc4::IfcStackTerminalType::IfcStackTerminalType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcStackTerminalType::IfcStackTerminalType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcStackTerminalTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcStackTerminalTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStair
boost::optional< ::Ifc4::IfcStairTypeEnum::Value > Ifc4::IfcStair::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcStairTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcStair::setPredefinedType(boost::optional< ::Ifc4::IfcStairTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcStairTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcStair::declaration() const { return *((IfcParse::entity*)IFC4_types[944]); }
const IfcParse::entity& Ifc4::IfcStair::Class() { return *((IfcParse::entity*)IFC4_types[944]); }
Ifc4::IfcStair::IfcStair(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcStair::IfcStair(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcStairTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcStairTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcStairFlight
boost::optional< int > Ifc4::IfcStairFlight::NumberOfRisers() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } int v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcStairFlight::setNumberOfRisers(boost::optional< int > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< int > Ifc4::IfcStairFlight::NumberOfTreads() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } int v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcStairFlight::setNumberOfTreads(boost::optional< int > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcStairFlight::RiserHeight() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcStairFlight::setRiserHeight(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcStairFlight::TreadLength() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcStairFlight::setTreadLength(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< ::Ifc4::IfcStairFlightTypeEnum::Value > Ifc4::IfcStairFlight::PredefinedType() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } return ::Ifc4::IfcStairFlightTypeEnum::FromString(data_.get_attribute_value(12)); }
void Ifc4::IfcStairFlight::setPredefinedType(boost::optional< ::Ifc4::IfcStairFlightTypeEnum::Value > v) { if (v) {set_attribute_value(12, EnumerationReference(&::Ifc4::IfcStairFlightTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(12);} }


const IfcParse::entity& Ifc4::IfcStairFlight::declaration() const { return *((IfcParse::entity*)IFC4_types[945]); }
const IfcParse::entity& Ifc4::IfcStairFlight::Class() { return *((IfcParse::entity*)IFC4_types[945]); }
Ifc4::IfcStairFlight::IfcStairFlight(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcStairFlight::IfcStairFlight(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< int > v9_NumberOfRisers, boost::optional< int > v10_NumberOfTreads, boost::optional< double > v11_RiserHeight, boost::optional< double > v12_TreadLength, boost::optional< ::Ifc4::IfcStairFlightTypeEnum::Value > v13_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_NumberOfRisers) {set_attribute_value(8, (*v9_NumberOfRisers)); } if (v10_NumberOfTreads) {set_attribute_value(9, (*v10_NumberOfTreads)); } if (v11_RiserHeight) {set_attribute_value(10, (*v11_RiserHeight)); } if (v12_TreadLength) {set_attribute_value(11, (*v12_TreadLength)); } if (v13_PredefinedType) {set_attribute_value(12, (EnumerationReference(&::Ifc4::IfcStairFlightTypeEnum::Class(),(size_t)*v13_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcStairFlightType
::Ifc4::IfcStairFlightTypeEnum::Value Ifc4::IfcStairFlightType::PredefinedType() const {  return ::Ifc4::IfcStairFlightTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcStairFlightType::setPredefinedType(::Ifc4::IfcStairFlightTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcStairFlightTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcStairFlightType::declaration() const { return *((IfcParse::entity*)IFC4_types[946]); }
const IfcParse::entity& Ifc4::IfcStairFlightType::Class() { return *((IfcParse::entity*)IFC4_types[946]); }
Ifc4::IfcStairFlightType::IfcStairFlightType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcStairFlightType::IfcStairFlightType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcStairFlightTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcStairFlightTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStairType
::Ifc4::IfcStairTypeEnum::Value Ifc4::IfcStairType::PredefinedType() const {  return ::Ifc4::IfcStairTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcStairType::setPredefinedType(::Ifc4::IfcStairTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcStairTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcStairType::declaration() const { return *((IfcParse::entity*)IFC4_types[948]); }
const IfcParse::entity& Ifc4::IfcStairType::Class() { return *((IfcParse::entity*)IFC4_types[948]); }
Ifc4::IfcStairType::IfcStairType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcStairType::IfcStairType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcStairTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcStairTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStructuralAction
boost::optional< bool > Ifc4::IfcStructuralAction::DestabilizingLoad() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } bool v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcStructuralAction::setDestabilizingLoad(boost::optional< bool > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcStructuralAction::declaration() const { return *((IfcParse::entity*)IFC4_types[951]); }
const IfcParse::entity& Ifc4::IfcStructuralAction::Class() { return *((IfcParse::entity*)IFC4_types[951]); }
Ifc4::IfcStructuralAction::IfcStructuralAction(IfcEntityInstanceData&& e) : IfcStructuralActivity(std::move(e)) { }
Ifc4::IfcStructuralAction::IfcStructuralAction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal, boost::optional< bool > v10_DestabilizingLoad) : IfcStructuralActivity(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal))); if (v10_DestabilizingLoad) {set_attribute_value(9, (*v10_DestabilizingLoad)); }; populate_derived(); }

// Function implementations for IfcStructuralActivity
::Ifc4::IfcStructuralLoad* Ifc4::IfcStructuralActivity::AppliedLoad() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcStructuralLoad>(true); }
void Ifc4::IfcStructuralActivity::setAppliedLoad(::Ifc4::IfcStructuralLoad* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcGlobalOrLocalEnum::Value Ifc4::IfcStructuralActivity::GlobalOrLocal() const {  return ::Ifc4::IfcGlobalOrLocalEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcStructuralActivity::setGlobalOrLocal(::Ifc4::IfcGlobalOrLocalEnum::Value v) { set_attribute_value(8, EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(8); }

::Ifc4::IfcRelConnectsStructuralActivity::list::ptr Ifc4::IfcStructuralActivity::AssignedToStructuralItem() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[819], 5)->as<IfcRelConnectsStructuralActivity>(); }

const IfcParse::entity& Ifc4::IfcStructuralActivity::declaration() const { return *((IfcParse::entity*)IFC4_types[952]); }
const IfcParse::entity& Ifc4::IfcStructuralActivity::Class() { return *((IfcParse::entity*)IFC4_types[952]); }
Ifc4::IfcStructuralActivity::IfcStructuralActivity(IfcEntityInstanceData&& e) : IfcProduct(std::move(e)) { }
Ifc4::IfcStructuralActivity::IfcStructuralActivity(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal) : IfcProduct(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal)));; populate_derived(); }

// Function implementations for IfcStructuralAnalysisModel
::Ifc4::IfcAnalysisModelTypeEnum::Value Ifc4::IfcStructuralAnalysisModel::PredefinedType() const {  return ::Ifc4::IfcAnalysisModelTypeEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcStructuralAnalysisModel::setPredefinedType(::Ifc4::IfcAnalysisModelTypeEnum::Value v) { set_attribute_value(5, EnumerationReference(&::Ifc4::IfcAnalysisModelTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcStructuralAnalysisModel::OrientationOf2DPlane() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcStructuralAnalysisModel::setOrientationOf2DPlane(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
boost::optional< aggregate_of< ::Ifc4::IfcStructuralLoadGroup >::ptr > Ifc4::IfcStructuralAnalysisModel::LoadedBy() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcStructuralLoadGroup >(); }
void Ifc4::IfcStructuralAnalysisModel::setLoadedBy(boost::optional< aggregate_of< ::Ifc4::IfcStructuralLoadGroup >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }
boost::optional< aggregate_of< ::Ifc4::IfcStructuralResultGroup >::ptr > Ifc4::IfcStructuralAnalysisModel::HasResults() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(8); return es->as< ::Ifc4::IfcStructuralResultGroup >(); }
void Ifc4::IfcStructuralAnalysisModel::setHasResults(boost::optional< aggregate_of< ::Ifc4::IfcStructuralResultGroup >::ptr > v) { if (v) {set_attribute_value(8, (*v)->generalize());} else {unset_attribute_value(8);} }
::Ifc4::IfcObjectPlacement* Ifc4::IfcStructuralAnalysisModel::SharedPlacement() const { if(data_.get_attribute_value(9).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(9)))->as<::Ifc4::IfcObjectPlacement>(true); }
void Ifc4::IfcStructuralAnalysisModel::setSharedPlacement(::Ifc4::IfcObjectPlacement* v) { set_attribute_value(9, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcStructuralAnalysisModel::declaration() const { return *((IfcParse::entity*)IFC4_types[954]); }
const IfcParse::entity& Ifc4::IfcStructuralAnalysisModel::Class() { return *((IfcParse::entity*)IFC4_types[954]); }
Ifc4::IfcStructuralAnalysisModel::IfcStructuralAnalysisModel(IfcEntityInstanceData&& e) : IfcSystem(std::move(e)) { }
Ifc4::IfcStructuralAnalysisModel::IfcStructuralAnalysisModel(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcAnalysisModelTypeEnum::Value v6_PredefinedType, ::Ifc4::IfcAxis2Placement3D* v7_OrientationOf2DPlane, boost::optional< aggregate_of< ::Ifc4::IfcStructuralLoadGroup >::ptr > v8_LoadedBy, boost::optional< aggregate_of< ::Ifc4::IfcStructuralResultGroup >::ptr > v9_HasResults, ::Ifc4::IfcObjectPlacement* v10_SharedPlacement) : IfcSystem(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcAnalysisModelTypeEnum::Class(),(size_t)v6_PredefinedType)));set_attribute_value(6, v7_OrientationOf2DPlane ? v7_OrientationOf2DPlane->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_LoadedBy) {set_attribute_value(7, (*v8_LoadedBy)->generalize()); } if (v9_HasResults) {set_attribute_value(8, (*v9_HasResults)->generalize()); }set_attribute_value(9, v10_SharedPlacement ? v10_SharedPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralConnection
::Ifc4::IfcBoundaryCondition* Ifc4::IfcStructuralConnection::AppliedCondition() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcBoundaryCondition>(true); }
void Ifc4::IfcStructuralConnection::setAppliedCondition(::Ifc4::IfcBoundaryCondition* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }

::Ifc4::IfcRelConnectsStructuralMember::list::ptr Ifc4::IfcStructuralConnection::ConnectsStructuralMembers() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[820], 5)->as<IfcRelConnectsStructuralMember>(); }

const IfcParse::entity& Ifc4::IfcStructuralConnection::declaration() const { return *((IfcParse::entity*)IFC4_types[955]); }
const IfcParse::entity& Ifc4::IfcStructuralConnection::Class() { return *((IfcParse::entity*)IFC4_types[955]); }
Ifc4::IfcStructuralConnection::IfcStructuralConnection(IfcEntityInstanceData&& e) : IfcStructuralItem(std::move(e)) { }
Ifc4::IfcStructuralConnection::IfcStructuralConnection(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcBoundaryCondition* v8_AppliedCondition) : IfcStructuralItem(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedCondition ? v8_AppliedCondition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralConnectionCondition
boost::optional< std::string > Ifc4::IfcStructuralConnectionCondition::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcStructuralConnectionCondition::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }


const IfcParse::entity& Ifc4::IfcStructuralConnectionCondition::declaration() const { return *((IfcParse::entity*)IFC4_types[956]); }
const IfcParse::entity& Ifc4::IfcStructuralConnectionCondition::Class() { return *((IfcParse::entity*)IFC4_types[956]); }
Ifc4::IfcStructuralConnectionCondition::IfcStructuralConnectionCondition(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcStructuralConnectionCondition::IfcStructuralConnectionCondition(boost::optional< std::string > v1_Name) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }; populate_derived(); }

// Function implementations for IfcStructuralCurveAction
boost::optional< ::Ifc4::IfcProjectedOrTrueLengthEnum::Value > Ifc4::IfcStructuralCurveAction::ProjectedOrTrue() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcProjectedOrTrueLengthEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcStructuralCurveAction::setProjectedOrTrue(boost::optional< ::Ifc4::IfcProjectedOrTrueLengthEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcProjectedOrTrueLengthEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }
::Ifc4::IfcStructuralCurveActivityTypeEnum::Value Ifc4::IfcStructuralCurveAction::PredefinedType() const {  return ::Ifc4::IfcStructuralCurveActivityTypeEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcStructuralCurveAction::setPredefinedType(::Ifc4::IfcStructuralCurveActivityTypeEnum::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcStructuralCurveActivityTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcStructuralCurveAction::declaration() const { return *((IfcParse::entity*)IFC4_types[957]); }
const IfcParse::entity& Ifc4::IfcStructuralCurveAction::Class() { return *((IfcParse::entity*)IFC4_types[957]); }
Ifc4::IfcStructuralCurveAction::IfcStructuralCurveAction(IfcEntityInstanceData&& e) : IfcStructuralAction(std::move(e)) { }
Ifc4::IfcStructuralCurveAction::IfcStructuralCurveAction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal, boost::optional< bool > v10_DestabilizingLoad, boost::optional< ::Ifc4::IfcProjectedOrTrueLengthEnum::Value > v11_ProjectedOrTrue, ::Ifc4::IfcStructuralCurveActivityTypeEnum::Value v12_PredefinedType) : IfcStructuralAction(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal))); if (v10_DestabilizingLoad) {set_attribute_value(9, (*v10_DestabilizingLoad)); } if (v11_ProjectedOrTrue) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcProjectedOrTrueLengthEnum::Class(),(size_t)*v11_ProjectedOrTrue))); }set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcStructuralCurveActivityTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStructuralCurveConnection
::Ifc4::IfcDirection* Ifc4::IfcStructuralCurveConnection::Axis() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcStructuralCurveConnection::setAxis(::Ifc4::IfcDirection* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcStructuralCurveConnection::declaration() const { return *((IfcParse::entity*)IFC4_types[959]); }
const IfcParse::entity& Ifc4::IfcStructuralCurveConnection::Class() { return *((IfcParse::entity*)IFC4_types[959]); }
Ifc4::IfcStructuralCurveConnection::IfcStructuralCurveConnection(IfcEntityInstanceData&& e) : IfcStructuralConnection(std::move(e)) { }
Ifc4::IfcStructuralCurveConnection::IfcStructuralCurveConnection(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcBoundaryCondition* v8_AppliedCondition, ::Ifc4::IfcDirection* v9_Axis) : IfcStructuralConnection(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedCondition ? v8_AppliedCondition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, v9_Axis ? v9_Axis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralCurveMember
::Ifc4::IfcStructuralCurveMemberTypeEnum::Value Ifc4::IfcStructuralCurveMember::PredefinedType() const {  return ::Ifc4::IfcStructuralCurveMemberTypeEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcStructuralCurveMember::setPredefinedType(::Ifc4::IfcStructuralCurveMemberTypeEnum::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcStructuralCurveMemberTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcDirection* Ifc4::IfcStructuralCurveMember::Axis() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcStructuralCurveMember::setAxis(::Ifc4::IfcDirection* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcStructuralCurveMember::declaration() const { return *((IfcParse::entity*)IFC4_types[960]); }
const IfcParse::entity& Ifc4::IfcStructuralCurveMember::Class() { return *((IfcParse::entity*)IFC4_types[960]); }
Ifc4::IfcStructuralCurveMember::IfcStructuralCurveMember(IfcEntityInstanceData&& e) : IfcStructuralMember(std::move(e)) { }
Ifc4::IfcStructuralCurveMember::IfcStructuralCurveMember(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralCurveMemberTypeEnum::Value v8_PredefinedType, ::Ifc4::IfcDirection* v9_Axis) : IfcStructuralMember(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcStructuralCurveMemberTypeEnum::Class(),(size_t)v8_PredefinedType)));set_attribute_value(8, v9_Axis ? v9_Axis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralCurveMemberVarying


const IfcParse::entity& Ifc4::IfcStructuralCurveMemberVarying::declaration() const { return *((IfcParse::entity*)IFC4_types[962]); }
const IfcParse::entity& Ifc4::IfcStructuralCurveMemberVarying::Class() { return *((IfcParse::entity*)IFC4_types[962]); }
Ifc4::IfcStructuralCurveMemberVarying::IfcStructuralCurveMemberVarying(IfcEntityInstanceData&& e) : IfcStructuralCurveMember(std::move(e)) { }
Ifc4::IfcStructuralCurveMemberVarying::IfcStructuralCurveMemberVarying(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralCurveMemberTypeEnum::Value v8_PredefinedType, ::Ifc4::IfcDirection* v9_Axis) : IfcStructuralCurveMember(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcStructuralCurveMemberTypeEnum::Class(),(size_t)v8_PredefinedType)));set_attribute_value(8, v9_Axis ? v9_Axis->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralCurveReaction
::Ifc4::IfcStructuralCurveActivityTypeEnum::Value Ifc4::IfcStructuralCurveReaction::PredefinedType() const {  return ::Ifc4::IfcStructuralCurveActivityTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcStructuralCurveReaction::setPredefinedType(::Ifc4::IfcStructuralCurveActivityTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcStructuralCurveActivityTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcStructuralCurveReaction::declaration() const { return *((IfcParse::entity*)IFC4_types[963]); }
const IfcParse::entity& Ifc4::IfcStructuralCurveReaction::Class() { return *((IfcParse::entity*)IFC4_types[963]); }
Ifc4::IfcStructuralCurveReaction::IfcStructuralCurveReaction(IfcEntityInstanceData&& e) : IfcStructuralReaction(std::move(e)) { }
Ifc4::IfcStructuralCurveReaction::IfcStructuralCurveReaction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal, ::Ifc4::IfcStructuralCurveActivityTypeEnum::Value v10_PredefinedType) : IfcStructuralReaction(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal)));set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcStructuralCurveActivityTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStructuralItem

::Ifc4::IfcRelConnectsStructuralActivity::list::ptr Ifc4::IfcStructuralItem::AssignedStructuralActivity() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[819], 4)->as<IfcRelConnectsStructuralActivity>(); }

const IfcParse::entity& Ifc4::IfcStructuralItem::declaration() const { return *((IfcParse::entity*)IFC4_types[964]); }
const IfcParse::entity& Ifc4::IfcStructuralItem::Class() { return *((IfcParse::entity*)IFC4_types[964]); }
Ifc4::IfcStructuralItem::IfcStructuralItem(IfcEntityInstanceData&& e) : IfcProduct(std::move(e)) { }
Ifc4::IfcStructuralItem::IfcStructuralItem(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation) : IfcProduct(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralLinearAction


const IfcParse::entity& Ifc4::IfcStructuralLinearAction::declaration() const { return *((IfcParse::entity*)IFC4_types[965]); }
const IfcParse::entity& Ifc4::IfcStructuralLinearAction::Class() { return *((IfcParse::entity*)IFC4_types[965]); }
Ifc4::IfcStructuralLinearAction::IfcStructuralLinearAction(IfcEntityInstanceData&& e) : IfcStructuralCurveAction(std::move(e)) { }
Ifc4::IfcStructuralLinearAction::IfcStructuralLinearAction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal, boost::optional< bool > v10_DestabilizingLoad, boost::optional< ::Ifc4::IfcProjectedOrTrueLengthEnum::Value > v11_ProjectedOrTrue, ::Ifc4::IfcStructuralCurveActivityTypeEnum::Value v12_PredefinedType) : IfcStructuralCurveAction(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal))); if (v10_DestabilizingLoad) {set_attribute_value(9, (*v10_DestabilizingLoad)); } if (v11_ProjectedOrTrue) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcProjectedOrTrueLengthEnum::Class(),(size_t)*v11_ProjectedOrTrue))); }set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcStructuralCurveActivityTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStructuralLoad
boost::optional< std::string > Ifc4::IfcStructuralLoad::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcStructuralLoad::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }


const IfcParse::entity& Ifc4::IfcStructuralLoad::declaration() const { return *((IfcParse::entity*)IFC4_types[966]); }
const IfcParse::entity& Ifc4::IfcStructuralLoad::Class() { return *((IfcParse::entity*)IFC4_types[966]); }
Ifc4::IfcStructuralLoad::IfcStructuralLoad(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcStructuralLoad::IfcStructuralLoad(boost::optional< std::string > v1_Name) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadCase
boost::optional< std::vector< double > /*[3:3]*/ > Ifc4::IfcStructuralLoadCase::SelfWeightCoefficients() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::vector< double > /*[3:3]*/ v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcStructuralLoadCase::setSelfWeightCoefficients(boost::optional< std::vector< double > /*[3:3]*/ > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadCase::declaration() const { return *((IfcParse::entity*)IFC4_types[967]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadCase::Class() { return *((IfcParse::entity*)IFC4_types[967]); }
Ifc4::IfcStructuralLoadCase::IfcStructuralLoadCase(IfcEntityInstanceData&& e) : IfcStructuralLoadGroup(std::move(e)) { }
Ifc4::IfcStructuralLoadCase::IfcStructuralLoadCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcLoadGroupTypeEnum::Value v6_PredefinedType, ::Ifc4::IfcActionTypeEnum::Value v7_ActionType, ::Ifc4::IfcActionSourceTypeEnum::Value v8_ActionSource, boost::optional< double > v9_Coefficient, boost::optional< std::string > v10_Purpose, boost::optional< std::vector< double > /*[3:3]*/ > v11_SelfWeightCoefficients) : IfcStructuralLoadGroup(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcLoadGroupTypeEnum::Class(),(size_t)v6_PredefinedType)));set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcActionTypeEnum::Class(),(size_t)v7_ActionType)));set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcActionSourceTypeEnum::Class(),(size_t)v8_ActionSource))); if (v9_Coefficient) {set_attribute_value(8, (*v9_Coefficient)); } if (v10_Purpose) {set_attribute_value(9, (*v10_Purpose)); } if (v11_SelfWeightCoefficients) {set_attribute_value(10, (*v11_SelfWeightCoefficients)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadConfiguration
aggregate_of< ::Ifc4::IfcStructuralLoadOrResult >::ptr Ifc4::IfcStructuralLoadConfiguration::Values() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcStructuralLoadOrResult >(); }
void Ifc4::IfcStructuralLoadConfiguration::setValues(aggregate_of< ::Ifc4::IfcStructuralLoadOrResult >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
boost::optional< std::vector< std::vector< double > > > Ifc4::IfcStructuralLoadConfiguration::Locations() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::vector< std::vector< double > > v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcStructuralLoadConfiguration::setLocations(boost::optional< std::vector< std::vector< double > > > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadConfiguration::declaration() const { return *((IfcParse::entity*)IFC4_types[968]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadConfiguration::Class() { return *((IfcParse::entity*)IFC4_types[968]); }
Ifc4::IfcStructuralLoadConfiguration::IfcStructuralLoadConfiguration(IfcEntityInstanceData&& e) : IfcStructuralLoad(std::move(e)) { }
Ifc4::IfcStructuralLoadConfiguration::IfcStructuralLoadConfiguration(boost::optional< std::string > v1_Name, aggregate_of< ::Ifc4::IfcStructuralLoadOrResult >::ptr v2_Values, boost::optional< std::vector< std::vector< double > > > v3_Locations) : IfcStructuralLoad(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, (v2_Values)->generalize()); if (v3_Locations) {set_attribute_value(2, (*v3_Locations)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadGroup
::Ifc4::IfcLoadGroupTypeEnum::Value Ifc4::IfcStructuralLoadGroup::PredefinedType() const {  return ::Ifc4::IfcLoadGroupTypeEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcStructuralLoadGroup::setPredefinedType(::Ifc4::IfcLoadGroupTypeEnum::Value v) { set_attribute_value(5, EnumerationReference(&::Ifc4::IfcLoadGroupTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcActionTypeEnum::Value Ifc4::IfcStructuralLoadGroup::ActionType() const {  return ::Ifc4::IfcActionTypeEnum::FromString(data_.get_attribute_value(6)); }
void Ifc4::IfcStructuralLoadGroup::setActionType(::Ifc4::IfcActionTypeEnum::Value v) { set_attribute_value(6, EnumerationReference(&::Ifc4::IfcActionTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(6); }
::Ifc4::IfcActionSourceTypeEnum::Value Ifc4::IfcStructuralLoadGroup::ActionSource() const {  return ::Ifc4::IfcActionSourceTypeEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcStructuralLoadGroup::setActionSource(::Ifc4::IfcActionSourceTypeEnum::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcActionSourceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }
boost::optional< double > Ifc4::IfcStructuralLoadGroup::Coefficient() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcStructuralLoadGroup::setCoefficient(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< std::string > Ifc4::IfcStructuralLoadGroup::Purpose() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcStructuralLoadGroup::setPurpose(boost::optional< std::string > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }

::Ifc4::IfcStructuralResultGroup::list::ptr Ifc4::IfcStructuralLoadGroup::SourceOfResultGroup() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[985], 6)->as<IfcStructuralResultGroup>(); }
::Ifc4::IfcStructuralAnalysisModel::list::ptr Ifc4::IfcStructuralLoadGroup::LoadGroupFor() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[954], 7)->as<IfcStructuralAnalysisModel>(); }

const IfcParse::entity& Ifc4::IfcStructuralLoadGroup::declaration() const { return *((IfcParse::entity*)IFC4_types[969]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadGroup::Class() { return *((IfcParse::entity*)IFC4_types[969]); }
Ifc4::IfcStructuralLoadGroup::IfcStructuralLoadGroup(IfcEntityInstanceData&& e) : IfcGroup(std::move(e)) { }
Ifc4::IfcStructuralLoadGroup::IfcStructuralLoadGroup(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcLoadGroupTypeEnum::Value v6_PredefinedType, ::Ifc4::IfcActionTypeEnum::Value v7_ActionType, ::Ifc4::IfcActionSourceTypeEnum::Value v8_ActionSource, boost::optional< double > v9_Coefficient, boost::optional< std::string > v10_Purpose) : IfcGroup(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcLoadGroupTypeEnum::Class(),(size_t)v6_PredefinedType)));set_attribute_value(6, (EnumerationReference(&::Ifc4::IfcActionTypeEnum::Class(),(size_t)v7_ActionType)));set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcActionSourceTypeEnum::Class(),(size_t)v8_ActionSource))); if (v9_Coefficient) {set_attribute_value(8, (*v9_Coefficient)); } if (v10_Purpose) {set_attribute_value(9, (*v10_Purpose)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadLinearForce
boost::optional< double > Ifc4::IfcStructuralLoadLinearForce::LinearForceX() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcStructuralLoadLinearForce::setLinearForceX(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< double > Ifc4::IfcStructuralLoadLinearForce::LinearForceY() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcStructuralLoadLinearForce::setLinearForceY(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcStructuralLoadLinearForce::LinearForceZ() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcStructuralLoadLinearForce::setLinearForceZ(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcStructuralLoadLinearForce::LinearMomentX() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcStructuralLoadLinearForce::setLinearMomentX(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< double > Ifc4::IfcStructuralLoadLinearForce::LinearMomentY() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcStructuralLoadLinearForce::setLinearMomentY(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< double > Ifc4::IfcStructuralLoadLinearForce::LinearMomentZ() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcStructuralLoadLinearForce::setLinearMomentZ(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadLinearForce::declaration() const { return *((IfcParse::entity*)IFC4_types[970]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadLinearForce::Class() { return *((IfcParse::entity*)IFC4_types[970]); }
Ifc4::IfcStructuralLoadLinearForce::IfcStructuralLoadLinearForce(IfcEntityInstanceData&& e) : IfcStructuralLoadStatic(std::move(e)) { }
Ifc4::IfcStructuralLoadLinearForce::IfcStructuralLoadLinearForce(boost::optional< std::string > v1_Name, boost::optional< double > v2_LinearForceX, boost::optional< double > v3_LinearForceY, boost::optional< double > v4_LinearForceZ, boost::optional< double > v5_LinearMomentX, boost::optional< double > v6_LinearMomentY, boost::optional< double > v7_LinearMomentZ) : IfcStructuralLoadStatic(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_LinearForceX) {set_attribute_value(1, (*v2_LinearForceX)); } if (v3_LinearForceY) {set_attribute_value(2, (*v3_LinearForceY)); } if (v4_LinearForceZ) {set_attribute_value(3, (*v4_LinearForceZ)); } if (v5_LinearMomentX) {set_attribute_value(4, (*v5_LinearMomentX)); } if (v6_LinearMomentY) {set_attribute_value(5, (*v6_LinearMomentY)); } if (v7_LinearMomentZ) {set_attribute_value(6, (*v7_LinearMomentZ)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadOrResult


const IfcParse::entity& Ifc4::IfcStructuralLoadOrResult::declaration() const { return *((IfcParse::entity*)IFC4_types[971]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadOrResult::Class() { return *((IfcParse::entity*)IFC4_types[971]); }
Ifc4::IfcStructuralLoadOrResult::IfcStructuralLoadOrResult(IfcEntityInstanceData&& e) : IfcStructuralLoad(std::move(e)) { }
Ifc4::IfcStructuralLoadOrResult::IfcStructuralLoadOrResult(boost::optional< std::string > v1_Name) : IfcStructuralLoad(IfcEntityInstanceData(storage_t(1))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadPlanarForce
boost::optional< double > Ifc4::IfcStructuralLoadPlanarForce::PlanarForceX() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcStructuralLoadPlanarForce::setPlanarForceX(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< double > Ifc4::IfcStructuralLoadPlanarForce::PlanarForceY() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcStructuralLoadPlanarForce::setPlanarForceY(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcStructuralLoadPlanarForce::PlanarForceZ() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcStructuralLoadPlanarForce::setPlanarForceZ(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadPlanarForce::declaration() const { return *((IfcParse::entity*)IFC4_types[972]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadPlanarForce::Class() { return *((IfcParse::entity*)IFC4_types[972]); }
Ifc4::IfcStructuralLoadPlanarForce::IfcStructuralLoadPlanarForce(IfcEntityInstanceData&& e) : IfcStructuralLoadStatic(std::move(e)) { }
Ifc4::IfcStructuralLoadPlanarForce::IfcStructuralLoadPlanarForce(boost::optional< std::string > v1_Name, boost::optional< double > v2_PlanarForceX, boost::optional< double > v3_PlanarForceY, boost::optional< double > v4_PlanarForceZ) : IfcStructuralLoadStatic(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_PlanarForceX) {set_attribute_value(1, (*v2_PlanarForceX)); } if (v3_PlanarForceY) {set_attribute_value(2, (*v3_PlanarForceY)); } if (v4_PlanarForceZ) {set_attribute_value(3, (*v4_PlanarForceZ)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadSingleDisplacement
boost::optional< double > Ifc4::IfcStructuralLoadSingleDisplacement::DisplacementX() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcStructuralLoadSingleDisplacement::setDisplacementX(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleDisplacement::DisplacementY() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcStructuralLoadSingleDisplacement::setDisplacementY(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleDisplacement::DisplacementZ() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcStructuralLoadSingleDisplacement::setDisplacementZ(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleDisplacement::RotationalDisplacementRX() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcStructuralLoadSingleDisplacement::setRotationalDisplacementRX(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleDisplacement::RotationalDisplacementRY() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcStructuralLoadSingleDisplacement::setRotationalDisplacementRY(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleDisplacement::RotationalDisplacementRZ() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcStructuralLoadSingleDisplacement::setRotationalDisplacementRZ(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadSingleDisplacement::declaration() const { return *((IfcParse::entity*)IFC4_types[973]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadSingleDisplacement::Class() { return *((IfcParse::entity*)IFC4_types[973]); }
Ifc4::IfcStructuralLoadSingleDisplacement::IfcStructuralLoadSingleDisplacement(IfcEntityInstanceData&& e) : IfcStructuralLoadStatic(std::move(e)) { }
Ifc4::IfcStructuralLoadSingleDisplacement::IfcStructuralLoadSingleDisplacement(boost::optional< std::string > v1_Name, boost::optional< double > v2_DisplacementX, boost::optional< double > v3_DisplacementY, boost::optional< double > v4_DisplacementZ, boost::optional< double > v5_RotationalDisplacementRX, boost::optional< double > v6_RotationalDisplacementRY, boost::optional< double > v7_RotationalDisplacementRZ) : IfcStructuralLoadStatic(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DisplacementX) {set_attribute_value(1, (*v2_DisplacementX)); } if (v3_DisplacementY) {set_attribute_value(2, (*v3_DisplacementY)); } if (v4_DisplacementZ) {set_attribute_value(3, (*v4_DisplacementZ)); } if (v5_RotationalDisplacementRX) {set_attribute_value(4, (*v5_RotationalDisplacementRX)); } if (v6_RotationalDisplacementRY) {set_attribute_value(5, (*v6_RotationalDisplacementRY)); } if (v7_RotationalDisplacementRZ) {set_attribute_value(6, (*v7_RotationalDisplacementRZ)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadSingleDisplacementDistortion
boost::optional< double > Ifc4::IfcStructuralLoadSingleDisplacementDistortion::Distortion() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcStructuralLoadSingleDisplacementDistortion::setDistortion(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadSingleDisplacementDistortion::declaration() const { return *((IfcParse::entity*)IFC4_types[974]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadSingleDisplacementDistortion::Class() { return *((IfcParse::entity*)IFC4_types[974]); }
Ifc4::IfcStructuralLoadSingleDisplacementDistortion::IfcStructuralLoadSingleDisplacementDistortion(IfcEntityInstanceData&& e) : IfcStructuralLoadSingleDisplacement(std::move(e)) { }
Ifc4::IfcStructuralLoadSingleDisplacementDistortion::IfcStructuralLoadSingleDisplacementDistortion(boost::optional< std::string > v1_Name, boost::optional< double > v2_DisplacementX, boost::optional< double > v3_DisplacementY, boost::optional< double > v4_DisplacementZ, boost::optional< double > v5_RotationalDisplacementRX, boost::optional< double > v6_RotationalDisplacementRY, boost::optional< double > v7_RotationalDisplacementRZ, boost::optional< double > v8_Distortion) : IfcStructuralLoadSingleDisplacement(IfcEntityInstanceData(storage_t(8))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DisplacementX) {set_attribute_value(1, (*v2_DisplacementX)); } if (v3_DisplacementY) {set_attribute_value(2, (*v3_DisplacementY)); } if (v4_DisplacementZ) {set_attribute_value(3, (*v4_DisplacementZ)); } if (v5_RotationalDisplacementRX) {set_attribute_value(4, (*v5_RotationalDisplacementRX)); } if (v6_RotationalDisplacementRY) {set_attribute_value(5, (*v6_RotationalDisplacementRY)); } if (v7_RotationalDisplacementRZ) {set_attribute_value(6, (*v7_RotationalDisplacementRZ)); } if (v8_Distortion) {set_attribute_value(7, (*v8_Distortion)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadSingleForce
boost::optional< double > Ifc4::IfcStructuralLoadSingleForce::ForceX() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcStructuralLoadSingleForce::setForceX(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleForce::ForceY() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcStructuralLoadSingleForce::setForceY(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleForce::ForceZ() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcStructuralLoadSingleForce::setForceZ(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleForce::MomentX() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcStructuralLoadSingleForce::setMomentX(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleForce::MomentY() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcStructuralLoadSingleForce::setMomentY(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< double > Ifc4::IfcStructuralLoadSingleForce::MomentZ() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcStructuralLoadSingleForce::setMomentZ(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadSingleForce::declaration() const { return *((IfcParse::entity*)IFC4_types[975]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadSingleForce::Class() { return *((IfcParse::entity*)IFC4_types[975]); }
Ifc4::IfcStructuralLoadSingleForce::IfcStructuralLoadSingleForce(IfcEntityInstanceData&& e) : IfcStructuralLoadStatic(std::move(e)) { }
Ifc4::IfcStructuralLoadSingleForce::IfcStructuralLoadSingleForce(boost::optional< std::string > v1_Name, boost::optional< double > v2_ForceX, boost::optional< double > v3_ForceY, boost::optional< double > v4_ForceZ, boost::optional< double > v5_MomentX, boost::optional< double > v6_MomentY, boost::optional< double > v7_MomentZ) : IfcStructuralLoadStatic(IfcEntityInstanceData(storage_t(7))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_ForceX) {set_attribute_value(1, (*v2_ForceX)); } if (v3_ForceY) {set_attribute_value(2, (*v3_ForceY)); } if (v4_ForceZ) {set_attribute_value(3, (*v4_ForceZ)); } if (v5_MomentX) {set_attribute_value(4, (*v5_MomentX)); } if (v6_MomentY) {set_attribute_value(5, (*v6_MomentY)); } if (v7_MomentZ) {set_attribute_value(6, (*v7_MomentZ)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadSingleForceWarping
boost::optional< double > Ifc4::IfcStructuralLoadSingleForceWarping::WarpingMoment() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcStructuralLoadSingleForceWarping::setWarpingMoment(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadSingleForceWarping::declaration() const { return *((IfcParse::entity*)IFC4_types[976]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadSingleForceWarping::Class() { return *((IfcParse::entity*)IFC4_types[976]); }
Ifc4::IfcStructuralLoadSingleForceWarping::IfcStructuralLoadSingleForceWarping(IfcEntityInstanceData&& e) : IfcStructuralLoadSingleForce(std::move(e)) { }
Ifc4::IfcStructuralLoadSingleForceWarping::IfcStructuralLoadSingleForceWarping(boost::optional< std::string > v1_Name, boost::optional< double > v2_ForceX, boost::optional< double > v3_ForceY, boost::optional< double > v4_ForceZ, boost::optional< double > v5_MomentX, boost::optional< double > v6_MomentY, boost::optional< double > v7_MomentZ, boost::optional< double > v8_WarpingMoment) : IfcStructuralLoadSingleForce(IfcEntityInstanceData(storage_t(8))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_ForceX) {set_attribute_value(1, (*v2_ForceX)); } if (v3_ForceY) {set_attribute_value(2, (*v3_ForceY)); } if (v4_ForceZ) {set_attribute_value(3, (*v4_ForceZ)); } if (v5_MomentX) {set_attribute_value(4, (*v5_MomentX)); } if (v6_MomentY) {set_attribute_value(5, (*v6_MomentY)); } if (v7_MomentZ) {set_attribute_value(6, (*v7_MomentZ)); } if (v8_WarpingMoment) {set_attribute_value(7, (*v8_WarpingMoment)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadStatic


const IfcParse::entity& Ifc4::IfcStructuralLoadStatic::declaration() const { return *((IfcParse::entity*)IFC4_types[977]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadStatic::Class() { return *((IfcParse::entity*)IFC4_types[977]); }
Ifc4::IfcStructuralLoadStatic::IfcStructuralLoadStatic(IfcEntityInstanceData&& e) : IfcStructuralLoadOrResult(std::move(e)) { }
Ifc4::IfcStructuralLoadStatic::IfcStructuralLoadStatic(boost::optional< std::string > v1_Name) : IfcStructuralLoadOrResult(IfcEntityInstanceData(storage_t(1))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }; populate_derived(); }

// Function implementations for IfcStructuralLoadTemperature
boost::optional< double > Ifc4::IfcStructuralLoadTemperature::DeltaTConstant() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcStructuralLoadTemperature::setDeltaTConstant(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< double > Ifc4::IfcStructuralLoadTemperature::DeltaTY() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcStructuralLoadTemperature::setDeltaTY(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcStructuralLoadTemperature::DeltaTZ() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcStructuralLoadTemperature::setDeltaTZ(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcStructuralLoadTemperature::declaration() const { return *((IfcParse::entity*)IFC4_types[978]); }
const IfcParse::entity& Ifc4::IfcStructuralLoadTemperature::Class() { return *((IfcParse::entity*)IFC4_types[978]); }
Ifc4::IfcStructuralLoadTemperature::IfcStructuralLoadTemperature(IfcEntityInstanceData&& e) : IfcStructuralLoadStatic(std::move(e)) { }
Ifc4::IfcStructuralLoadTemperature::IfcStructuralLoadTemperature(boost::optional< std::string > v1_Name, boost::optional< double > v2_DeltaTConstant, boost::optional< double > v3_DeltaTY, boost::optional< double > v4_DeltaTZ) : IfcStructuralLoadStatic(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DeltaTConstant) {set_attribute_value(1, (*v2_DeltaTConstant)); } if (v3_DeltaTY) {set_attribute_value(2, (*v3_DeltaTY)); } if (v4_DeltaTZ) {set_attribute_value(3, (*v4_DeltaTZ)); }; populate_derived(); }

// Function implementations for IfcStructuralMember

::Ifc4::IfcRelConnectsStructuralMember::list::ptr Ifc4::IfcStructuralMember::ConnectedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[820], 4)->as<IfcRelConnectsStructuralMember>(); }

const IfcParse::entity& Ifc4::IfcStructuralMember::declaration() const { return *((IfcParse::entity*)IFC4_types[979]); }
const IfcParse::entity& Ifc4::IfcStructuralMember::Class() { return *((IfcParse::entity*)IFC4_types[979]); }
Ifc4::IfcStructuralMember::IfcStructuralMember(IfcEntityInstanceData&& e) : IfcStructuralItem(std::move(e)) { }
Ifc4::IfcStructuralMember::IfcStructuralMember(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation) : IfcStructuralItem(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralPlanarAction


const IfcParse::entity& Ifc4::IfcStructuralPlanarAction::declaration() const { return *((IfcParse::entity*)IFC4_types[980]); }
const IfcParse::entity& Ifc4::IfcStructuralPlanarAction::Class() { return *((IfcParse::entity*)IFC4_types[980]); }
Ifc4::IfcStructuralPlanarAction::IfcStructuralPlanarAction(IfcEntityInstanceData&& e) : IfcStructuralSurfaceAction(std::move(e)) { }
Ifc4::IfcStructuralPlanarAction::IfcStructuralPlanarAction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal, boost::optional< bool > v10_DestabilizingLoad, boost::optional< ::Ifc4::IfcProjectedOrTrueLengthEnum::Value > v11_ProjectedOrTrue, ::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value v12_PredefinedType) : IfcStructuralSurfaceAction(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal))); if (v10_DestabilizingLoad) {set_attribute_value(9, (*v10_DestabilizingLoad)); } if (v11_ProjectedOrTrue) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcProjectedOrTrueLengthEnum::Class(),(size_t)*v11_ProjectedOrTrue))); }set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStructuralPointAction


const IfcParse::entity& Ifc4::IfcStructuralPointAction::declaration() const { return *((IfcParse::entity*)IFC4_types[981]); }
const IfcParse::entity& Ifc4::IfcStructuralPointAction::Class() { return *((IfcParse::entity*)IFC4_types[981]); }
Ifc4::IfcStructuralPointAction::IfcStructuralPointAction(IfcEntityInstanceData&& e) : IfcStructuralAction(std::move(e)) { }
Ifc4::IfcStructuralPointAction::IfcStructuralPointAction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal, boost::optional< bool > v10_DestabilizingLoad) : IfcStructuralAction(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal))); if (v10_DestabilizingLoad) {set_attribute_value(9, (*v10_DestabilizingLoad)); }; populate_derived(); }

// Function implementations for IfcStructuralPointConnection
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcStructuralPointConnection::ConditionCoordinateSystem() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcStructuralPointConnection::setConditionCoordinateSystem(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcStructuralPointConnection::declaration() const { return *((IfcParse::entity*)IFC4_types[982]); }
const IfcParse::entity& Ifc4::IfcStructuralPointConnection::Class() { return *((IfcParse::entity*)IFC4_types[982]); }
Ifc4::IfcStructuralPointConnection::IfcStructuralPointConnection(IfcEntityInstanceData&& e) : IfcStructuralConnection(std::move(e)) { }
Ifc4::IfcStructuralPointConnection::IfcStructuralPointConnection(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcBoundaryCondition* v8_AppliedCondition, ::Ifc4::IfcAxis2Placement3D* v9_ConditionCoordinateSystem) : IfcStructuralConnection(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedCondition ? v8_AppliedCondition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, v9_ConditionCoordinateSystem ? v9_ConditionCoordinateSystem->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralPointReaction


const IfcParse::entity& Ifc4::IfcStructuralPointReaction::declaration() const { return *((IfcParse::entity*)IFC4_types[983]); }
const IfcParse::entity& Ifc4::IfcStructuralPointReaction::Class() { return *((IfcParse::entity*)IFC4_types[983]); }
Ifc4::IfcStructuralPointReaction::IfcStructuralPointReaction(IfcEntityInstanceData&& e) : IfcStructuralReaction(std::move(e)) { }
Ifc4::IfcStructuralPointReaction::IfcStructuralPointReaction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal) : IfcStructuralReaction(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal)));; populate_derived(); }

// Function implementations for IfcStructuralReaction


const IfcParse::entity& Ifc4::IfcStructuralReaction::declaration() const { return *((IfcParse::entity*)IFC4_types[984]); }
const IfcParse::entity& Ifc4::IfcStructuralReaction::Class() { return *((IfcParse::entity*)IFC4_types[984]); }
Ifc4::IfcStructuralReaction::IfcStructuralReaction(IfcEntityInstanceData&& e) : IfcStructuralActivity(std::move(e)) { }
Ifc4::IfcStructuralReaction::IfcStructuralReaction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal) : IfcStructuralActivity(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal)));; populate_derived(); }

// Function implementations for IfcStructuralResultGroup
::Ifc4::IfcAnalysisTheoryTypeEnum::Value Ifc4::IfcStructuralResultGroup::TheoryType() const {  return ::Ifc4::IfcAnalysisTheoryTypeEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcStructuralResultGroup::setTheoryType(::Ifc4::IfcAnalysisTheoryTypeEnum::Value v) { set_attribute_value(5, EnumerationReference(&::Ifc4::IfcAnalysisTheoryTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcStructuralLoadGroup* Ifc4::IfcStructuralResultGroup::ResultForLoadGroup() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcStructuralLoadGroup>(true); }
void Ifc4::IfcStructuralResultGroup::setResultForLoadGroup(::Ifc4::IfcStructuralLoadGroup* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
bool Ifc4::IfcStructuralResultGroup::IsLinear() const {  bool v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcStructuralResultGroup::setIsLinear(bool v) { set_attribute_value(7, v);if constexpr (false)unset_attribute_value(7); }

::Ifc4::IfcStructuralAnalysisModel::list::ptr Ifc4::IfcStructuralResultGroup::ResultGroupFor() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[954], 8)->as<IfcStructuralAnalysisModel>(); }

const IfcParse::entity& Ifc4::IfcStructuralResultGroup::declaration() const { return *((IfcParse::entity*)IFC4_types[985]); }
const IfcParse::entity& Ifc4::IfcStructuralResultGroup::Class() { return *((IfcParse::entity*)IFC4_types[985]); }
Ifc4::IfcStructuralResultGroup::IfcStructuralResultGroup(IfcEntityInstanceData&& e) : IfcGroup(std::move(e)) { }
Ifc4::IfcStructuralResultGroup::IfcStructuralResultGroup(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcAnalysisTheoryTypeEnum::Value v6_TheoryType, ::Ifc4::IfcStructuralLoadGroup* v7_ResultForLoadGroup, bool v8_IsLinear) : IfcGroup(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcAnalysisTheoryTypeEnum::Class(),(size_t)v6_TheoryType)));set_attribute_value(6, v7_ResultForLoadGroup ? v7_ResultForLoadGroup->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (v8_IsLinear));; populate_derived(); }

// Function implementations for IfcStructuralSurfaceAction
boost::optional< ::Ifc4::IfcProjectedOrTrueLengthEnum::Value > Ifc4::IfcStructuralSurfaceAction::ProjectedOrTrue() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcProjectedOrTrueLengthEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcStructuralSurfaceAction::setProjectedOrTrue(boost::optional< ::Ifc4::IfcProjectedOrTrueLengthEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcProjectedOrTrueLengthEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }
::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value Ifc4::IfcStructuralSurfaceAction::PredefinedType() const {  return ::Ifc4::IfcStructuralSurfaceActivityTypeEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcStructuralSurfaceAction::setPredefinedType(::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcStructuralSurfaceAction::declaration() const { return *((IfcParse::entity*)IFC4_types[986]); }
const IfcParse::entity& Ifc4::IfcStructuralSurfaceAction::Class() { return *((IfcParse::entity*)IFC4_types[986]); }
Ifc4::IfcStructuralSurfaceAction::IfcStructuralSurfaceAction(IfcEntityInstanceData&& e) : IfcStructuralAction(std::move(e)) { }
Ifc4::IfcStructuralSurfaceAction::IfcStructuralSurfaceAction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal, boost::optional< bool > v10_DestabilizingLoad, boost::optional< ::Ifc4::IfcProjectedOrTrueLengthEnum::Value > v11_ProjectedOrTrue, ::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value v12_PredefinedType) : IfcStructuralAction(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal))); if (v10_DestabilizingLoad) {set_attribute_value(9, (*v10_DestabilizingLoad)); } if (v11_ProjectedOrTrue) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcProjectedOrTrueLengthEnum::Class(),(size_t)*v11_ProjectedOrTrue))); }set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStructuralSurfaceConnection


const IfcParse::entity& Ifc4::IfcStructuralSurfaceConnection::declaration() const { return *((IfcParse::entity*)IFC4_types[988]); }
const IfcParse::entity& Ifc4::IfcStructuralSurfaceConnection::Class() { return *((IfcParse::entity*)IFC4_types[988]); }
Ifc4::IfcStructuralSurfaceConnection::IfcStructuralSurfaceConnection(IfcEntityInstanceData&& e) : IfcStructuralConnection(std::move(e)) { }
Ifc4::IfcStructuralSurfaceConnection::IfcStructuralSurfaceConnection(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcBoundaryCondition* v8_AppliedCondition) : IfcStructuralConnection(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedCondition ? v8_AppliedCondition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcStructuralSurfaceMember
::Ifc4::IfcStructuralSurfaceMemberTypeEnum::Value Ifc4::IfcStructuralSurfaceMember::PredefinedType() const {  return ::Ifc4::IfcStructuralSurfaceMemberTypeEnum::FromString(data_.get_attribute_value(7)); }
void Ifc4::IfcStructuralSurfaceMember::setPredefinedType(::Ifc4::IfcStructuralSurfaceMemberTypeEnum::Value v) { set_attribute_value(7, EnumerationReference(&::Ifc4::IfcStructuralSurfaceMemberTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(7); }
boost::optional< double > Ifc4::IfcStructuralSurfaceMember::Thickness() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcStructuralSurfaceMember::setThickness(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcStructuralSurfaceMember::declaration() const { return *((IfcParse::entity*)IFC4_types[989]); }
const IfcParse::entity& Ifc4::IfcStructuralSurfaceMember::Class() { return *((IfcParse::entity*)IFC4_types[989]); }
Ifc4::IfcStructuralSurfaceMember::IfcStructuralSurfaceMember(IfcEntityInstanceData&& e) : IfcStructuralMember(std::move(e)) { }
Ifc4::IfcStructuralSurfaceMember::IfcStructuralSurfaceMember(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralSurfaceMemberTypeEnum::Value v8_PredefinedType, boost::optional< double > v9_Thickness) : IfcStructuralMember(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcStructuralSurfaceMemberTypeEnum::Class(),(size_t)v8_PredefinedType))); if (v9_Thickness) {set_attribute_value(8, (*v9_Thickness)); }; populate_derived(); }

// Function implementations for IfcStructuralSurfaceMemberVarying


const IfcParse::entity& Ifc4::IfcStructuralSurfaceMemberVarying::declaration() const { return *((IfcParse::entity*)IFC4_types[991]); }
const IfcParse::entity& Ifc4::IfcStructuralSurfaceMemberVarying::Class() { return *((IfcParse::entity*)IFC4_types[991]); }
Ifc4::IfcStructuralSurfaceMemberVarying::IfcStructuralSurfaceMemberVarying(IfcEntityInstanceData&& e) : IfcStructuralSurfaceMember(std::move(e)) { }
Ifc4::IfcStructuralSurfaceMemberVarying::IfcStructuralSurfaceMemberVarying(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralSurfaceMemberTypeEnum::Value v8_PredefinedType, boost::optional< double > v9_Thickness) : IfcStructuralSurfaceMember(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, (EnumerationReference(&::Ifc4::IfcStructuralSurfaceMemberTypeEnum::Class(),(size_t)v8_PredefinedType))); if (v9_Thickness) {set_attribute_value(8, (*v9_Thickness)); }; populate_derived(); }

// Function implementations for IfcStructuralSurfaceReaction
::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value Ifc4::IfcStructuralSurfaceReaction::PredefinedType() const {  return ::Ifc4::IfcStructuralSurfaceActivityTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcStructuralSurfaceReaction::setPredefinedType(::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcStructuralSurfaceReaction::declaration() const { return *((IfcParse::entity*)IFC4_types[992]); }
const IfcParse::entity& Ifc4::IfcStructuralSurfaceReaction::Class() { return *((IfcParse::entity*)IFC4_types[992]); }
Ifc4::IfcStructuralSurfaceReaction::IfcStructuralSurfaceReaction(IfcEntityInstanceData&& e) : IfcStructuralReaction(std::move(e)) { }
Ifc4::IfcStructuralSurfaceReaction::IfcStructuralSurfaceReaction(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, ::Ifc4::IfcStructuralLoad* v8_AppliedLoad, ::Ifc4::IfcGlobalOrLocalEnum::Value v9_GlobalOrLocal, ::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Value v10_PredefinedType) : IfcStructuralReaction(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_AppliedLoad ? v8_AppliedLoad->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcGlobalOrLocalEnum::Class(),(size_t)v9_GlobalOrLocal)));set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcStructuralSurfaceActivityTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcStyleModel


const IfcParse::entity& Ifc4::IfcStyleModel::declaration() const { return *((IfcParse::entity*)IFC4_types[996]); }
const IfcParse::entity& Ifc4::IfcStyleModel::Class() { return *((IfcParse::entity*)IFC4_types[996]); }
Ifc4::IfcStyleModel::IfcStyleModel(IfcEntityInstanceData&& e) : IfcRepresentation(std::move(e)) { }
Ifc4::IfcStyleModel::IfcStyleModel(::Ifc4::IfcRepresentationContext* v1_ContextOfItems, boost::optional< std::string > v2_RepresentationIdentifier, boost::optional< std::string > v3_RepresentationType, aggregate_of< ::Ifc4::IfcRepresentationItem >::ptr v4_Items) : IfcRepresentation(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_ContextOfItems ? v1_ContextOfItems->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_RepresentationIdentifier) {set_attribute_value(1, (*v2_RepresentationIdentifier)); } if (v3_RepresentationType) {set_attribute_value(2, (*v3_RepresentationType)); }set_attribute_value(3, (v4_Items)->generalize());; populate_derived(); }

// Function implementations for IfcStyledItem
::Ifc4::IfcRepresentationItem* Ifc4::IfcStyledItem::Item() const { if(data_.get_attribute_value(0).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcRepresentationItem>(true); }
void Ifc4::IfcStyledItem::setItem(::Ifc4::IfcRepresentationItem* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcStyleAssignmentSelect >::ptr Ifc4::IfcStyledItem::Styles() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcStyleAssignmentSelect >(); }
void Ifc4::IfcStyledItem::setStyles(aggregate_of< ::Ifc4::IfcStyleAssignmentSelect >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
boost::optional< std::string > Ifc4::IfcStyledItem::Name() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcStyledItem::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcStyledItem::declaration() const { return *((IfcParse::entity*)IFC4_types[994]); }
const IfcParse::entity& Ifc4::IfcStyledItem::Class() { return *((IfcParse::entity*)IFC4_types[994]); }
Ifc4::IfcStyledItem::IfcStyledItem(IfcEntityInstanceData&& e) : IfcRepresentationItem(std::move(e)) { }
Ifc4::IfcStyledItem::IfcStyledItem(::Ifc4::IfcRepresentationItem* v1_Item, aggregate_of< ::Ifc4::IfcStyleAssignmentSelect >::ptr v2_Styles, boost::optional< std::string > v3_Name) : IfcRepresentationItem(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Item ? v1_Item->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Styles)->generalize()); if (v3_Name) {set_attribute_value(2, (*v3_Name)); }; populate_derived(); }

// Function implementations for IfcStyledRepresentation


const IfcParse::entity& Ifc4::IfcStyledRepresentation::declaration() const { return *((IfcParse::entity*)IFC4_types[995]); }
const IfcParse::entity& Ifc4::IfcStyledRepresentation::Class() { return *((IfcParse::entity*)IFC4_types[995]); }
Ifc4::IfcStyledRepresentation::IfcStyledRepresentation(IfcEntityInstanceData&& e) : IfcStyleModel(std::move(e)) { }
Ifc4::IfcStyledRepresentation::IfcStyledRepresentation(::Ifc4::IfcRepresentationContext* v1_ContextOfItems, boost::optional< std::string > v2_RepresentationIdentifier, boost::optional< std::string > v3_RepresentationType, aggregate_of< ::Ifc4::IfcRepresentationItem >::ptr v4_Items) : IfcStyleModel(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_ContextOfItems ? v1_ContextOfItems->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_RepresentationIdentifier) {set_attribute_value(1, (*v2_RepresentationIdentifier)); } if (v3_RepresentationType) {set_attribute_value(2, (*v3_RepresentationType)); }set_attribute_value(3, (v4_Items)->generalize());; populate_derived(); }

// Function implementations for IfcSubContractResource
boost::optional< ::Ifc4::IfcSubContractResourceTypeEnum::Value > Ifc4::IfcSubContractResource::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcSubContractResourceTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcSubContractResource::setPredefinedType(boost::optional< ::Ifc4::IfcSubContractResourceTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcSubContractResourceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcSubContractResource::declaration() const { return *((IfcParse::entity*)IFC4_types[997]); }
const IfcParse::entity& Ifc4::IfcSubContractResource::Class() { return *((IfcParse::entity*)IFC4_types[997]); }
Ifc4::IfcSubContractResource::IfcSubContractResource(IfcEntityInstanceData&& e) : IfcConstructionResource(std::move(e)) { }
Ifc4::IfcSubContractResource::IfcSubContractResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, ::Ifc4::IfcResourceTime* v8_Usage, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v9_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v10_BaseQuantity, boost::optional< ::Ifc4::IfcSubContractResourceTypeEnum::Value > v11_PredefinedType) : IfcConstructionResource(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); }set_attribute_value(7, v8_Usage ? v8_Usage->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v9_BaseCosts) {set_attribute_value(8, (*v9_BaseCosts)->generalize()); }set_attribute_value(9, v10_BaseQuantity ? v10_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcSubContractResourceTypeEnum::Class(),(size_t)*v11_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSubContractResourceType
::Ifc4::IfcSubContractResourceTypeEnum::Value Ifc4::IfcSubContractResourceType::PredefinedType() const {  return ::Ifc4::IfcSubContractResourceTypeEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcSubContractResourceType::setPredefinedType(::Ifc4::IfcSubContractResourceTypeEnum::Value v) { set_attribute_value(11, EnumerationReference(&::Ifc4::IfcSubContractResourceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcSubContractResourceType::declaration() const { return *((IfcParse::entity*)IFC4_types[998]); }
const IfcParse::entity& Ifc4::IfcSubContractResourceType::Class() { return *((IfcParse::entity*)IFC4_types[998]); }
Ifc4::IfcSubContractResourceType::IfcSubContractResourceType(IfcEntityInstanceData&& e) : IfcConstructionResourceType(std::move(e)) { }
Ifc4::IfcSubContractResourceType::IfcSubContractResourceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ResourceType, boost::optional< aggregate_of< ::Ifc4::IfcAppliedValue >::ptr > v10_BaseCosts, ::Ifc4::IfcPhysicalQuantity* v11_BaseQuantity, ::Ifc4::IfcSubContractResourceTypeEnum::Value v12_PredefinedType) : IfcConstructionResourceType(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ResourceType) {set_attribute_value(8, (*v9_ResourceType)); } if (v10_BaseCosts) {set_attribute_value(9, (*v10_BaseCosts)->generalize()); }set_attribute_value(10, v11_BaseQuantity ? v11_BaseQuantity->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcSubContractResourceTypeEnum::Class(),(size_t)v12_PredefinedType)));; populate_derived(); }

// Function implementations for IfcSubedge
::Ifc4::IfcEdge* Ifc4::IfcSubedge::ParentEdge() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcEdge>(true); }
void Ifc4::IfcSubedge::setParentEdge(::Ifc4::IfcEdge* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcSubedge::declaration() const { return *((IfcParse::entity*)IFC4_types[1000]); }
const IfcParse::entity& Ifc4::IfcSubedge::Class() { return *((IfcParse::entity*)IFC4_types[1000]); }
Ifc4::IfcSubedge::IfcSubedge(IfcEntityInstanceData&& e) : IfcEdge(std::move(e)) { }
Ifc4::IfcSubedge::IfcSubedge(::Ifc4::IfcVertex* v1_EdgeStart, ::Ifc4::IfcVertex* v2_EdgeEnd, ::Ifc4::IfcEdge* v3_ParentEdge) : IfcEdge(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_EdgeStart ? v1_EdgeStart->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_EdgeEnd ? v2_EdgeEnd->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_ParentEdge ? v3_ParentEdge->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcSurface


const IfcParse::entity& Ifc4::IfcSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[1001]); }
const IfcParse::entity& Ifc4::IfcSurface::Class() { return *((IfcParse::entity*)IFC4_types[1001]); }
Ifc4::IfcSurface::IfcSurface(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcSurface::IfcSurface() : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcSurfaceCurve
::Ifc4::IfcCurve* Ifc4::IfcSurfaceCurve::Curve3D() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcSurfaceCurve::setCurve3D(::Ifc4::IfcCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcPcurve >::ptr Ifc4::IfcSurfaceCurve::AssociatedGeometry() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcPcurve >(); }
void Ifc4::IfcSurfaceCurve::setAssociatedGeometry(aggregate_of< ::Ifc4::IfcPcurve >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcPreferredSurfaceCurveRepresentation::Value Ifc4::IfcSurfaceCurve::MasterRepresentation() const {  return ::Ifc4::IfcPreferredSurfaceCurveRepresentation::FromString(data_.get_attribute_value(2)); }
void Ifc4::IfcSurfaceCurve::setMasterRepresentation(::Ifc4::IfcPreferredSurfaceCurveRepresentation::Value v) { set_attribute_value(2, EnumerationReference(&::Ifc4::IfcPreferredSurfaceCurveRepresentation::Class(), (size_t) v));if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcSurfaceCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[1002]); }
const IfcParse::entity& Ifc4::IfcSurfaceCurve::Class() { return *((IfcParse::entity*)IFC4_types[1002]); }
Ifc4::IfcSurfaceCurve::IfcSurfaceCurve(IfcEntityInstanceData&& e) : IfcCurve(std::move(e)) { }
Ifc4::IfcSurfaceCurve::IfcSurfaceCurve(::Ifc4::IfcCurve* v1_Curve3D, aggregate_of< ::Ifc4::IfcPcurve >::ptr v2_AssociatedGeometry, ::Ifc4::IfcPreferredSurfaceCurveRepresentation::Value v3_MasterRepresentation) : IfcCurve(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Curve3D ? v1_Curve3D->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_AssociatedGeometry)->generalize());set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcPreferredSurfaceCurveRepresentation::Class(),(size_t)v3_MasterRepresentation)));; populate_derived(); }

// Function implementations for IfcSurfaceCurveSweptAreaSolid
::Ifc4::IfcCurve* Ifc4::IfcSurfaceCurveSweptAreaSolid::Directrix() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcSurfaceCurveSweptAreaSolid::setDirectrix(::Ifc4::IfcCurve* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
boost::optional< double > Ifc4::IfcSurfaceCurveSweptAreaSolid::StartParam() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcSurfaceCurveSweptAreaSolid::setStartParam(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcSurfaceCurveSweptAreaSolid::EndParam() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcSurfaceCurveSweptAreaSolid::setEndParam(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
::Ifc4::IfcSurface* Ifc4::IfcSurfaceCurveSweptAreaSolid::ReferenceSurface() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcSurface>(true); }
void Ifc4::IfcSurfaceCurveSweptAreaSolid::setReferenceSurface(::Ifc4::IfcSurface* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcSurfaceCurveSweptAreaSolid::declaration() const { return *((IfcParse::entity*)IFC4_types[1003]); }
const IfcParse::entity& Ifc4::IfcSurfaceCurveSweptAreaSolid::Class() { return *((IfcParse::entity*)IFC4_types[1003]); }
Ifc4::IfcSurfaceCurveSweptAreaSolid::IfcSurfaceCurveSweptAreaSolid(IfcEntityInstanceData&& e) : IfcSweptAreaSolid(std::move(e)) { }
Ifc4::IfcSurfaceCurveSweptAreaSolid::IfcSurfaceCurveSweptAreaSolid(::Ifc4::IfcProfileDef* v1_SweptArea, ::Ifc4::IfcAxis2Placement3D* v2_Position, ::Ifc4::IfcCurve* v3_Directrix, boost::optional< double > v4_StartParam, boost::optional< double > v5_EndParam, ::Ifc4::IfcSurface* v6_ReferenceSurface) : IfcSweptAreaSolid(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, v1_SweptArea ? v1_SweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_Directrix ? v3_Directrix->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v4_StartParam) {set_attribute_value(3, (*v4_StartParam)); } if (v5_EndParam) {set_attribute_value(4, (*v5_EndParam)); }set_attribute_value(5, v6_ReferenceSurface ? v6_ReferenceSurface->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcSurfaceFeature
boost::optional< ::Ifc4::IfcSurfaceFeatureTypeEnum::Value > Ifc4::IfcSurfaceFeature::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSurfaceFeatureTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSurfaceFeature::setPredefinedType(boost::optional< ::Ifc4::IfcSurfaceFeatureTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSurfaceFeatureTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSurfaceFeature::declaration() const { return *((IfcParse::entity*)IFC4_types[1004]); }
const IfcParse::entity& Ifc4::IfcSurfaceFeature::Class() { return *((IfcParse::entity*)IFC4_types[1004]); }
Ifc4::IfcSurfaceFeature::IfcSurfaceFeature(IfcEntityInstanceData&& e) : IfcFeatureElement(std::move(e)) { }
Ifc4::IfcSurfaceFeature::IfcSurfaceFeature(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSurfaceFeatureTypeEnum::Value > v9_PredefinedType) : IfcFeatureElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSurfaceFeatureTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSurfaceOfLinearExtrusion
::Ifc4::IfcDirection* Ifc4::IfcSurfaceOfLinearExtrusion::ExtrudedDirection() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcSurfaceOfLinearExtrusion::setExtrudedDirection(::Ifc4::IfcDirection* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
double Ifc4::IfcSurfaceOfLinearExtrusion::Depth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcSurfaceOfLinearExtrusion::setDepth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcSurfaceOfLinearExtrusion::declaration() const { return *((IfcParse::entity*)IFC4_types[1006]); }
const IfcParse::entity& Ifc4::IfcSurfaceOfLinearExtrusion::Class() { return *((IfcParse::entity*)IFC4_types[1006]); }
Ifc4::IfcSurfaceOfLinearExtrusion::IfcSurfaceOfLinearExtrusion(IfcEntityInstanceData&& e) : IfcSweptSurface(std::move(e)) { }
Ifc4::IfcSurfaceOfLinearExtrusion::IfcSurfaceOfLinearExtrusion(::Ifc4::IfcProfileDef* v1_SweptCurve, ::Ifc4::IfcAxis2Placement3D* v2_Position, ::Ifc4::IfcDirection* v3_ExtrudedDirection, double v4_Depth) : IfcSweptSurface(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_SweptCurve ? v1_SweptCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_ExtrudedDirection ? v3_ExtrudedDirection->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Depth));; populate_derived(); }

// Function implementations for IfcSurfaceOfRevolution
::Ifc4::IfcAxis1Placement* Ifc4::IfcSurfaceOfRevolution::AxisPosition() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcAxis1Placement>(true); }
void Ifc4::IfcSurfaceOfRevolution::setAxisPosition(::Ifc4::IfcAxis1Placement* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcSurfaceOfRevolution::declaration() const { return *((IfcParse::entity*)IFC4_types[1007]); }
const IfcParse::entity& Ifc4::IfcSurfaceOfRevolution::Class() { return *((IfcParse::entity*)IFC4_types[1007]); }
Ifc4::IfcSurfaceOfRevolution::IfcSurfaceOfRevolution(IfcEntityInstanceData&& e) : IfcSweptSurface(std::move(e)) { }
Ifc4::IfcSurfaceOfRevolution::IfcSurfaceOfRevolution(::Ifc4::IfcProfileDef* v1_SweptCurve, ::Ifc4::IfcAxis2Placement3D* v2_Position, ::Ifc4::IfcAxis1Placement* v3_AxisPosition) : IfcSweptSurface(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_SweptCurve ? v1_SweptCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_AxisPosition ? v3_AxisPosition->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcSurfaceReinforcementArea
boost::optional< std::vector< double > /*[2:3]*/ > Ifc4::IfcSurfaceReinforcementArea::SurfaceReinforcement1() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::vector< double > /*[2:3]*/ v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSurfaceReinforcementArea::setSurfaceReinforcement1(boost::optional< std::vector< double > /*[2:3]*/ > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::vector< double > /*[2:3]*/ > Ifc4::IfcSurfaceReinforcementArea::SurfaceReinforcement2() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::vector< double > /*[2:3]*/ v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcSurfaceReinforcementArea::setSurfaceReinforcement2(boost::optional< std::vector< double > /*[2:3]*/ > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcSurfaceReinforcementArea::ShearReinforcement() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcSurfaceReinforcementArea::setShearReinforcement(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }


const IfcParse::entity& Ifc4::IfcSurfaceReinforcementArea::declaration() const { return *((IfcParse::entity*)IFC4_types[1009]); }
const IfcParse::entity& Ifc4::IfcSurfaceReinforcementArea::Class() { return *((IfcParse::entity*)IFC4_types[1009]); }
Ifc4::IfcSurfaceReinforcementArea::IfcSurfaceReinforcementArea(IfcEntityInstanceData&& e) : IfcStructuralLoadOrResult(std::move(e)) { }
Ifc4::IfcSurfaceReinforcementArea::IfcSurfaceReinforcementArea(boost::optional< std::string > v1_Name, boost::optional< std::vector< double > /*[2:3]*/ > v2_SurfaceReinforcement1, boost::optional< std::vector< double > /*[2:3]*/ > v3_SurfaceReinforcement2, boost::optional< double > v4_ShearReinforcement) : IfcStructuralLoadOrResult(IfcEntityInstanceData(storage_t(4))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_SurfaceReinforcement1) {set_attribute_value(1, (*v2_SurfaceReinforcement1)); } if (v3_SurfaceReinforcement2) {set_attribute_value(2, (*v3_SurfaceReinforcement2)); } if (v4_ShearReinforcement) {set_attribute_value(3, (*v4_ShearReinforcement)); }; populate_derived(); }

// Function implementations for IfcSurfaceStyle
::Ifc4::IfcSurfaceSide::Value Ifc4::IfcSurfaceStyle::Side() const {  return ::Ifc4::IfcSurfaceSide::FromString(data_.get_attribute_value(1)); }
void Ifc4::IfcSurfaceStyle::setSide(::Ifc4::IfcSurfaceSide::Value v) { set_attribute_value(1, EnumerationReference(&::Ifc4::IfcSurfaceSide::Class(), (size_t) v));if constexpr (false)unset_attribute_value(1); }
aggregate_of< ::Ifc4::IfcSurfaceStyleElementSelect >::ptr Ifc4::IfcSurfaceStyle::Styles() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcSurfaceStyleElementSelect >(); }
void Ifc4::IfcSurfaceStyle::setStyles(aggregate_of< ::Ifc4::IfcSurfaceStyleElementSelect >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcSurfaceStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[1011]); }
const IfcParse::entity& Ifc4::IfcSurfaceStyle::Class() { return *((IfcParse::entity*)IFC4_types[1011]); }
Ifc4::IfcSurfaceStyle::IfcSurfaceStyle(IfcEntityInstanceData&& e) : IfcPresentationStyle(std::move(e)) { }
Ifc4::IfcSurfaceStyle::IfcSurfaceStyle(boost::optional< std::string > v1_Name, ::Ifc4::IfcSurfaceSide::Value v2_Side, aggregate_of< ::Ifc4::IfcSurfaceStyleElementSelect >::ptr v3_Styles) : IfcPresentationStyle(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcSurfaceSide::Class(),(size_t)v2_Side)));set_attribute_value(2, (v3_Styles)->generalize());; populate_derived(); }

// Function implementations for IfcSurfaceStyleLighting
::Ifc4::IfcColourRgb* Ifc4::IfcSurfaceStyleLighting::DiffuseTransmissionColour() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcColourRgb>(true); }
void Ifc4::IfcSurfaceStyleLighting::setDiffuseTransmissionColour(::Ifc4::IfcColourRgb* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcColourRgb* Ifc4::IfcSurfaceStyleLighting::DiffuseReflectionColour() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcColourRgb>(true); }
void Ifc4::IfcSurfaceStyleLighting::setDiffuseReflectionColour(::Ifc4::IfcColourRgb* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcColourRgb* Ifc4::IfcSurfaceStyleLighting::TransmissionColour() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcColourRgb>(true); }
void Ifc4::IfcSurfaceStyleLighting::setTransmissionColour(::Ifc4::IfcColourRgb* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcColourRgb* Ifc4::IfcSurfaceStyleLighting::ReflectanceColour() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcColourRgb>(true); }
void Ifc4::IfcSurfaceStyleLighting::setReflectanceColour(::Ifc4::IfcColourRgb* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }


const IfcParse::entity& Ifc4::IfcSurfaceStyleLighting::declaration() const { return *((IfcParse::entity*)IFC4_types[1013]); }
const IfcParse::entity& Ifc4::IfcSurfaceStyleLighting::Class() { return *((IfcParse::entity*)IFC4_types[1013]); }
Ifc4::IfcSurfaceStyleLighting::IfcSurfaceStyleLighting(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcSurfaceStyleLighting::IfcSurfaceStyleLighting(::Ifc4::IfcColourRgb* v1_DiffuseTransmissionColour, ::Ifc4::IfcColourRgb* v2_DiffuseReflectionColour, ::Ifc4::IfcColourRgb* v3_TransmissionColour, ::Ifc4::IfcColourRgb* v4_ReflectanceColour) : IfcPresentationItem(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_DiffuseTransmissionColour ? v1_DiffuseTransmissionColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_DiffuseReflectionColour ? v2_DiffuseReflectionColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_TransmissionColour ? v3_TransmissionColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_ReflectanceColour ? v4_ReflectanceColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcSurfaceStyleRefraction
boost::optional< double > Ifc4::IfcSurfaceStyleRefraction::RefractionIndex() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } double v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcSurfaceStyleRefraction::setRefractionIndex(boost::optional< double > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< double > Ifc4::IfcSurfaceStyleRefraction::DispersionFactor() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSurfaceStyleRefraction::setDispersionFactor(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }


const IfcParse::entity& Ifc4::IfcSurfaceStyleRefraction::declaration() const { return *((IfcParse::entity*)IFC4_types[1014]); }
const IfcParse::entity& Ifc4::IfcSurfaceStyleRefraction::Class() { return *((IfcParse::entity*)IFC4_types[1014]); }
Ifc4::IfcSurfaceStyleRefraction::IfcSurfaceStyleRefraction(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcSurfaceStyleRefraction::IfcSurfaceStyleRefraction(boost::optional< double > v1_RefractionIndex, boost::optional< double > v2_DispersionFactor) : IfcPresentationItem(IfcEntityInstanceData(storage_t(2))) {  if (v1_RefractionIndex) {set_attribute_value(0, (*v1_RefractionIndex)); } if (v2_DispersionFactor) {set_attribute_value(1, (*v2_DispersionFactor)); }; populate_derived(); }

// Function implementations for IfcSurfaceStyleRendering
::Ifc4::IfcColourOrFactor* Ifc4::IfcSurfaceStyleRendering::DiffuseColour() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcColourOrFactor>(true); }
void Ifc4::IfcSurfaceStyleRendering::setDiffuseColour(::Ifc4::IfcColourOrFactor* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcColourOrFactor* Ifc4::IfcSurfaceStyleRendering::TransmissionColour() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcColourOrFactor>(true); }
void Ifc4::IfcSurfaceStyleRendering::setTransmissionColour(::Ifc4::IfcColourOrFactor* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcColourOrFactor* Ifc4::IfcSurfaceStyleRendering::DiffuseTransmissionColour() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcColourOrFactor>(true); }
void Ifc4::IfcSurfaceStyleRendering::setDiffuseTransmissionColour(::Ifc4::IfcColourOrFactor* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcColourOrFactor* Ifc4::IfcSurfaceStyleRendering::ReflectionColour() const { if(data_.get_attribute_value(5).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcColourOrFactor>(true); }
void Ifc4::IfcSurfaceStyleRendering::setReflectionColour(::Ifc4::IfcColourOrFactor* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }
::Ifc4::IfcColourOrFactor* Ifc4::IfcSurfaceStyleRendering::SpecularColour() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcColourOrFactor>(true); }
void Ifc4::IfcSurfaceStyleRendering::setSpecularColour(::Ifc4::IfcColourOrFactor* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }
::Ifc4::IfcSpecularHighlightSelect* Ifc4::IfcSurfaceStyleRendering::SpecularHighlight() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcSpecularHighlightSelect>(true); }
void Ifc4::IfcSurfaceStyleRendering::setSpecularHighlight(::Ifc4::IfcSpecularHighlightSelect* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }
::Ifc4::IfcReflectanceMethodEnum::Value Ifc4::IfcSurfaceStyleRendering::ReflectanceMethod() const {  return ::Ifc4::IfcReflectanceMethodEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSurfaceStyleRendering::setReflectanceMethod(::Ifc4::IfcReflectanceMethodEnum::Value v) { set_attribute_value(8, EnumerationReference(&::Ifc4::IfcReflectanceMethodEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcSurfaceStyleRendering::declaration() const { return *((IfcParse::entity*)IFC4_types[1015]); }
const IfcParse::entity& Ifc4::IfcSurfaceStyleRendering::Class() { return *((IfcParse::entity*)IFC4_types[1015]); }
Ifc4::IfcSurfaceStyleRendering::IfcSurfaceStyleRendering(IfcEntityInstanceData&& e) : IfcSurfaceStyleShading(std::move(e)) { }
Ifc4::IfcSurfaceStyleRendering::IfcSurfaceStyleRendering(::Ifc4::IfcColourRgb* v1_SurfaceColour, boost::optional< double > v2_Transparency, ::Ifc4::IfcColourOrFactor* v3_DiffuseColour, ::Ifc4::IfcColourOrFactor* v4_TransmissionColour, ::Ifc4::IfcColourOrFactor* v5_DiffuseTransmissionColour, ::Ifc4::IfcColourOrFactor* v6_ReflectionColour, ::Ifc4::IfcColourOrFactor* v7_SpecularColour, ::Ifc4::IfcSpecularHighlightSelect* v8_SpecularHighlight, ::Ifc4::IfcReflectanceMethodEnum::Value v9_ReflectanceMethod) : IfcSurfaceStyleShading(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, v1_SurfaceColour ? v1_SurfaceColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_Transparency) {set_attribute_value(1, (*v2_Transparency)); }set_attribute_value(2, v3_DiffuseColour ? v3_DiffuseColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_TransmissionColour ? v4_TransmissionColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, v5_DiffuseTransmissionColour ? v5_DiffuseTransmissionColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(5, v6_ReflectionColour ? v6_ReflectionColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_SpecularColour ? v7_SpecularColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(7, v8_SpecularHighlight ? v8_SpecularHighlight->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcReflectanceMethodEnum::Class(),(size_t)v9_ReflectanceMethod)));; populate_derived(); }

// Function implementations for IfcSurfaceStyleShading
::Ifc4::IfcColourRgb* Ifc4::IfcSurfaceStyleShading::SurfaceColour() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcColourRgb>(true); }
void Ifc4::IfcSurfaceStyleShading::setSurfaceColour(::Ifc4::IfcColourRgb* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
boost::optional< double > Ifc4::IfcSurfaceStyleShading::Transparency() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSurfaceStyleShading::setTransparency(boost::optional< double > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }


const IfcParse::entity& Ifc4::IfcSurfaceStyleShading::declaration() const { return *((IfcParse::entity*)IFC4_types[1016]); }
const IfcParse::entity& Ifc4::IfcSurfaceStyleShading::Class() { return *((IfcParse::entity*)IFC4_types[1016]); }
Ifc4::IfcSurfaceStyleShading::IfcSurfaceStyleShading(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcSurfaceStyleShading::IfcSurfaceStyleShading(::Ifc4::IfcColourRgb* v1_SurfaceColour, boost::optional< double > v2_Transparency) : IfcPresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_SurfaceColour ? v1_SurfaceColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_Transparency) {set_attribute_value(1, (*v2_Transparency)); }; populate_derived(); }

// Function implementations for IfcSurfaceStyleWithTextures
aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr Ifc4::IfcSurfaceStyleWithTextures::Textures() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcSurfaceTexture >(); }
void Ifc4::IfcSurfaceStyleWithTextures::setTextures(aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcSurfaceStyleWithTextures::declaration() const { return *((IfcParse::entity*)IFC4_types[1017]); }
const IfcParse::entity& Ifc4::IfcSurfaceStyleWithTextures::Class() { return *((IfcParse::entity*)IFC4_types[1017]); }
Ifc4::IfcSurfaceStyleWithTextures::IfcSurfaceStyleWithTextures(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcSurfaceStyleWithTextures::IfcSurfaceStyleWithTextures(aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr v1_Textures) : IfcPresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Textures)->generalize());; populate_derived(); }

// Function implementations for IfcSurfaceTexture
bool Ifc4::IfcSurfaceTexture::RepeatS() const {  bool v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcSurfaceTexture::setRepeatS(bool v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
bool Ifc4::IfcSurfaceTexture::RepeatT() const {  bool v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSurfaceTexture::setRepeatT(bool v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< std::string > Ifc4::IfcSurfaceTexture::Mode() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcSurfaceTexture::setMode(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
::Ifc4::IfcCartesianTransformationOperator2D* Ifc4::IfcSurfaceTexture::TextureTransform() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcCartesianTransformationOperator2D>(true); }
void Ifc4::IfcSurfaceTexture::setTextureTransform(::Ifc4::IfcCartesianTransformationOperator2D* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcSurfaceTexture::Parameter() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcSurfaceTexture::setParameter(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }

::Ifc4::IfcTextureCoordinate::list::ptr Ifc4::IfcSurfaceTexture::IsMappedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[1066], 0)->as<IfcTextureCoordinate>(); }
::Ifc4::IfcSurfaceStyleWithTextures::list::ptr Ifc4::IfcSurfaceTexture::UsedInStyles() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[1017], 0)->as<IfcSurfaceStyleWithTextures>(); }

const IfcParse::entity& Ifc4::IfcSurfaceTexture::declaration() const { return *((IfcParse::entity*)IFC4_types[1018]); }
const IfcParse::entity& Ifc4::IfcSurfaceTexture::Class() { return *((IfcParse::entity*)IFC4_types[1018]); }
Ifc4::IfcSurfaceTexture::IfcSurfaceTexture(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcSurfaceTexture::IfcSurfaceTexture(bool v1_RepeatS, bool v2_RepeatT, boost::optional< std::string > v3_Mode, ::Ifc4::IfcCartesianTransformationOperator2D* v4_TextureTransform, boost::optional< std::vector< std::string > /*[1:?]*/ > v5_Parameter) : IfcPresentationItem(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_RepeatS));set_attribute_value(1, (v2_RepeatT)); if (v3_Mode) {set_attribute_value(2, (*v3_Mode)); }set_attribute_value(3, v4_TextureTransform ? v4_TextureTransform->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Parameter) {set_attribute_value(4, (*v5_Parameter)); }; populate_derived(); }

// Function implementations for IfcSweptAreaSolid
::Ifc4::IfcProfileDef* Ifc4::IfcSweptAreaSolid::SweptArea() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcSweptAreaSolid::setSweptArea(::Ifc4::IfcProfileDef* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcSweptAreaSolid::Position() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcSweptAreaSolid::setPosition(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcSweptAreaSolid::declaration() const { return *((IfcParse::entity*)IFC4_types[1019]); }
const IfcParse::entity& Ifc4::IfcSweptAreaSolid::Class() { return *((IfcParse::entity*)IFC4_types[1019]); }
Ifc4::IfcSweptAreaSolid::IfcSweptAreaSolid(IfcEntityInstanceData&& e) : IfcSolidModel(std::move(e)) { }
Ifc4::IfcSweptAreaSolid::IfcSweptAreaSolid(::Ifc4::IfcProfileDef* v1_SweptArea, ::Ifc4::IfcAxis2Placement3D* v2_Position) : IfcSolidModel(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_SweptArea ? v1_SweptArea->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcSweptDiskSolid
::Ifc4::IfcCurve* Ifc4::IfcSweptDiskSolid::Directrix() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcSweptDiskSolid::setDirectrix(::Ifc4::IfcCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcSweptDiskSolid::Radius() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcSweptDiskSolid::setRadius(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< double > Ifc4::IfcSweptDiskSolid::InnerRadius() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcSweptDiskSolid::setInnerRadius(boost::optional< double > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< double > Ifc4::IfcSweptDiskSolid::StartParam() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcSweptDiskSolid::setStartParam(boost::optional< double > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< double > Ifc4::IfcSweptDiskSolid::EndParam() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcSweptDiskSolid::setEndParam(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcSweptDiskSolid::declaration() const { return *((IfcParse::entity*)IFC4_types[1020]); }
const IfcParse::entity& Ifc4::IfcSweptDiskSolid::Class() { return *((IfcParse::entity*)IFC4_types[1020]); }
Ifc4::IfcSweptDiskSolid::IfcSweptDiskSolid(IfcEntityInstanceData&& e) : IfcSolidModel(std::move(e)) { }
Ifc4::IfcSweptDiskSolid::IfcSweptDiskSolid(::Ifc4::IfcCurve* v1_Directrix, double v2_Radius, boost::optional< double > v3_InnerRadius, boost::optional< double > v4_StartParam, boost::optional< double > v5_EndParam) : IfcSolidModel(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_Directrix ? v1_Directrix->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Radius)); if (v3_InnerRadius) {set_attribute_value(2, (*v3_InnerRadius)); } if (v4_StartParam) {set_attribute_value(3, (*v4_StartParam)); } if (v5_EndParam) {set_attribute_value(4, (*v5_EndParam)); }; populate_derived(); }

// Function implementations for IfcSweptDiskSolidPolygonal
boost::optional< double > Ifc4::IfcSweptDiskSolidPolygonal::FilletRadius() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcSweptDiskSolidPolygonal::setFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }


const IfcParse::entity& Ifc4::IfcSweptDiskSolidPolygonal::declaration() const { return *((IfcParse::entity*)IFC4_types[1021]); }
const IfcParse::entity& Ifc4::IfcSweptDiskSolidPolygonal::Class() { return *((IfcParse::entity*)IFC4_types[1021]); }
Ifc4::IfcSweptDiskSolidPolygonal::IfcSweptDiskSolidPolygonal(IfcEntityInstanceData&& e) : IfcSweptDiskSolid(std::move(e)) { }
Ifc4::IfcSweptDiskSolidPolygonal::IfcSweptDiskSolidPolygonal(::Ifc4::IfcCurve* v1_Directrix, double v2_Radius, boost::optional< double > v3_InnerRadius, boost::optional< double > v4_StartParam, boost::optional< double > v5_EndParam, boost::optional< double > v6_FilletRadius) : IfcSweptDiskSolid(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, v1_Directrix ? v1_Directrix->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Radius)); if (v3_InnerRadius) {set_attribute_value(2, (*v3_InnerRadius)); } if (v4_StartParam) {set_attribute_value(3, (*v4_StartParam)); } if (v5_EndParam) {set_attribute_value(4, (*v5_EndParam)); } if (v6_FilletRadius) {set_attribute_value(5, (*v6_FilletRadius)); }; populate_derived(); }

// Function implementations for IfcSweptSurface
::Ifc4::IfcProfileDef* Ifc4::IfcSweptSurface::SweptCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcProfileDef>(true); }
void Ifc4::IfcSweptSurface::setSweptCurve(::Ifc4::IfcProfileDef* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcAxis2Placement3D* Ifc4::IfcSweptSurface::Position() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcAxis2Placement3D>(true); }
void Ifc4::IfcSweptSurface::setPosition(::Ifc4::IfcAxis2Placement3D* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcSweptSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[1022]); }
const IfcParse::entity& Ifc4::IfcSweptSurface::Class() { return *((IfcParse::entity*)IFC4_types[1022]); }
Ifc4::IfcSweptSurface::IfcSweptSurface(IfcEntityInstanceData&& e) : IfcSurface(std::move(e)) { }
Ifc4::IfcSweptSurface::IfcSweptSurface(::Ifc4::IfcProfileDef* v1_SweptCurve, ::Ifc4::IfcAxis2Placement3D* v2_Position) : IfcSurface(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_SweptCurve ? v1_SweptCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_Position ? v2_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcSwitchingDevice
boost::optional< ::Ifc4::IfcSwitchingDeviceTypeEnum::Value > Ifc4::IfcSwitchingDevice::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSwitchingDeviceTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSwitchingDevice::setPredefinedType(boost::optional< ::Ifc4::IfcSwitchingDeviceTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSwitchingDeviceTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSwitchingDevice::declaration() const { return *((IfcParse::entity*)IFC4_types[1023]); }
const IfcParse::entity& Ifc4::IfcSwitchingDevice::Class() { return *((IfcParse::entity*)IFC4_types[1023]); }
Ifc4::IfcSwitchingDevice::IfcSwitchingDevice(IfcEntityInstanceData&& e) : IfcFlowController(std::move(e)) { }
Ifc4::IfcSwitchingDevice::IfcSwitchingDevice(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSwitchingDeviceTypeEnum::Value > v9_PredefinedType) : IfcFlowController(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSwitchingDeviceTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSwitchingDeviceType
::Ifc4::IfcSwitchingDeviceTypeEnum::Value Ifc4::IfcSwitchingDeviceType::PredefinedType() const {  return ::Ifc4::IfcSwitchingDeviceTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSwitchingDeviceType::setPredefinedType(::Ifc4::IfcSwitchingDeviceTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSwitchingDeviceTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcSwitchingDeviceType::declaration() const { return *((IfcParse::entity*)IFC4_types[1024]); }
const IfcParse::entity& Ifc4::IfcSwitchingDeviceType::Class() { return *((IfcParse::entity*)IFC4_types[1024]); }
Ifc4::IfcSwitchingDeviceType::IfcSwitchingDeviceType(IfcEntityInstanceData&& e) : IfcFlowControllerType(std::move(e)) { }
Ifc4::IfcSwitchingDeviceType::IfcSwitchingDeviceType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcSwitchingDeviceTypeEnum::Value v10_PredefinedType) : IfcFlowControllerType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSwitchingDeviceTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcSystem

::Ifc4::IfcRelServicesBuildings::list::ptr Ifc4::IfcSystem::ServicesBuildings() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[840], 4)->as<IfcRelServicesBuildings>(); }

const IfcParse::entity& Ifc4::IfcSystem::declaration() const { return *((IfcParse::entity*)IFC4_types[1026]); }
const IfcParse::entity& Ifc4::IfcSystem::Class() { return *((IfcParse::entity*)IFC4_types[1026]); }
Ifc4::IfcSystem::IfcSystem(IfcEntityInstanceData&& e) : IfcGroup(std::move(e)) { }
Ifc4::IfcSystem::IfcSystem(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType) : IfcGroup(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }; populate_derived(); }

// Function implementations for IfcSystemFurnitureElement
boost::optional< ::Ifc4::IfcSystemFurnitureElementTypeEnum::Value > Ifc4::IfcSystemFurnitureElement::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcSystemFurnitureElementTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcSystemFurnitureElement::setPredefinedType(boost::optional< ::Ifc4::IfcSystemFurnitureElementTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcSystemFurnitureElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcSystemFurnitureElement::declaration() const { return *((IfcParse::entity*)IFC4_types[1027]); }
const IfcParse::entity& Ifc4::IfcSystemFurnitureElement::Class() { return *((IfcParse::entity*)IFC4_types[1027]); }
Ifc4::IfcSystemFurnitureElement::IfcSystemFurnitureElement(IfcEntityInstanceData&& e) : IfcFurnishingElement(std::move(e)) { }
Ifc4::IfcSystemFurnitureElement::IfcSystemFurnitureElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcSystemFurnitureElementTypeEnum::Value > v9_PredefinedType) : IfcFurnishingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcSystemFurnitureElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcSystemFurnitureElementType
boost::optional< ::Ifc4::IfcSystemFurnitureElementTypeEnum::Value > Ifc4::IfcSystemFurnitureElementType::PredefinedType() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } return ::Ifc4::IfcSystemFurnitureElementTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcSystemFurnitureElementType::setPredefinedType(boost::optional< ::Ifc4::IfcSystemFurnitureElementTypeEnum::Value > v) { if (v) {set_attribute_value(9, EnumerationReference(&::Ifc4::IfcSystemFurnitureElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcSystemFurnitureElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[1028]); }
const IfcParse::entity& Ifc4::IfcSystemFurnitureElementType::Class() { return *((IfcParse::entity*)IFC4_types[1028]); }
Ifc4::IfcSystemFurnitureElementType::IfcSystemFurnitureElementType(IfcEntityInstanceData&& e) : IfcFurnishingElementType(std::move(e)) { }
Ifc4::IfcSystemFurnitureElementType::IfcSystemFurnitureElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, boost::optional< ::Ifc4::IfcSystemFurnitureElementTypeEnum::Value > v10_PredefinedType) : IfcFurnishingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); } if (v10_PredefinedType) {set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcSystemFurnitureElementTypeEnum::Class(),(size_t)*v10_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcTShapeProfileDef
double Ifc4::IfcTShapeProfileDef::Depth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcTShapeProfileDef::setDepth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcTShapeProfileDef::FlangeWidth() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTShapeProfileDef::setFlangeWidth(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
double Ifc4::IfcTShapeProfileDef::WebThickness() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcTShapeProfileDef::setWebThickness(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcTShapeProfileDef::FlangeThickness() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcTShapeProfileDef::setFlangeThickness(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
boost::optional< double > Ifc4::IfcTShapeProfileDef::FilletRadius() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcTShapeProfileDef::setFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< double > Ifc4::IfcTShapeProfileDef::FlangeEdgeRadius() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcTShapeProfileDef::setFlangeEdgeRadius(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< double > Ifc4::IfcTShapeProfileDef::WebEdgeRadius() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcTShapeProfileDef::setWebEdgeRadius(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcTShapeProfileDef::WebSlope() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcTShapeProfileDef::setWebSlope(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcTShapeProfileDef::FlangeSlope() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcTShapeProfileDef::setFlangeSlope(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }


const IfcParse::entity& Ifc4::IfcTShapeProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[1102]); }
const IfcParse::entity& Ifc4::IfcTShapeProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[1102]); }
Ifc4::IfcTShapeProfileDef::IfcTShapeProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcTShapeProfileDef::IfcTShapeProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_Depth, double v5_FlangeWidth, double v6_WebThickness, double v7_FlangeThickness, boost::optional< double > v8_FilletRadius, boost::optional< double > v9_FlangeEdgeRadius, boost::optional< double > v10_WebEdgeRadius, boost::optional< double > v11_WebSlope, boost::optional< double > v12_FlangeSlope) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Depth));set_attribute_value(4, (v5_FlangeWidth));set_attribute_value(5, (v6_WebThickness));set_attribute_value(6, (v7_FlangeThickness)); if (v8_FilletRadius) {set_attribute_value(7, (*v8_FilletRadius)); } if (v9_FlangeEdgeRadius) {set_attribute_value(8, (*v9_FlangeEdgeRadius)); } if (v10_WebEdgeRadius) {set_attribute_value(9, (*v10_WebEdgeRadius)); } if (v11_WebSlope) {set_attribute_value(10, (*v11_WebSlope)); } if (v12_FlangeSlope) {set_attribute_value(11, (*v12_FlangeSlope)); }; populate_derived(); }

// Function implementations for IfcTable
boost::optional< std::string > Ifc4::IfcTable::Name() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcTable::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< aggregate_of< ::Ifc4::IfcTableRow >::ptr > Ifc4::IfcTable::Rows() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcTableRow >(); }
void Ifc4::IfcTable::setRows(boost::optional< aggregate_of< ::Ifc4::IfcTableRow >::ptr > v) { if (v) {set_attribute_value(1, (*v)->generalize());} else {unset_attribute_value(1);} }
boost::optional< aggregate_of< ::Ifc4::IfcTableColumn >::ptr > Ifc4::IfcTable::Columns() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcTableColumn >(); }
void Ifc4::IfcTable::setColumns(boost::optional< aggregate_of< ::Ifc4::IfcTableColumn >::ptr > v) { if (v) {set_attribute_value(2, (*v)->generalize());} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcTable::declaration() const { return *((IfcParse::entity*)IFC4_types[1030]); }
const IfcParse::entity& Ifc4::IfcTable::Class() { return *((IfcParse::entity*)IFC4_types[1030]); }
Ifc4::IfcTable::IfcTable(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcTable::IfcTable(boost::optional< std::string > v1_Name, boost::optional< aggregate_of< ::Ifc4::IfcTableRow >::ptr > v2_Rows, boost::optional< aggregate_of< ::Ifc4::IfcTableColumn >::ptr > v3_Columns) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(3))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_Rows) {set_attribute_value(1, (*v2_Rows)->generalize()); } if (v3_Columns) {set_attribute_value(2, (*v3_Columns)->generalize()); }; populate_derived(); }

// Function implementations for IfcTableColumn
boost::optional< std::string > Ifc4::IfcTableColumn::Identifier() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcTableColumn::setIdentifier(boost::optional< std::string > v) { if (v) {set_attribute_value(0, *v);} else {unset_attribute_value(0);} }
boost::optional< std::string > Ifc4::IfcTableColumn::Name() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcTableColumn::setName(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcTableColumn::Description() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcTableColumn::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
::Ifc4::IfcUnit* Ifc4::IfcTableColumn::Unit() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcTableColumn::setUnit(::Ifc4::IfcUnit* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcReference* Ifc4::IfcTableColumn::ReferencePath() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcReference>(true); }
void Ifc4::IfcTableColumn::setReferencePath(::Ifc4::IfcReference* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcTableColumn::declaration() const { return *((IfcParse::entity*)IFC4_types[1031]); }
const IfcParse::entity& Ifc4::IfcTableColumn::Class() { return *((IfcParse::entity*)IFC4_types[1031]); }
Ifc4::IfcTableColumn::IfcTableColumn(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcTableColumn::IfcTableColumn(boost::optional< std::string > v1_Identifier, boost::optional< std::string > v2_Name, boost::optional< std::string > v3_Description, ::Ifc4::IfcUnit* v4_Unit, ::Ifc4::IfcReference* v5_ReferencePath) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(5))) {  if (v1_Identifier) {set_attribute_value(0, (*v1_Identifier)); } if (v2_Name) {set_attribute_value(1, (*v2_Name)); } if (v3_Description) {set_attribute_value(2, (*v3_Description)); }set_attribute_value(3, v4_Unit ? v4_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, v5_ReferencePath ? v5_ReferencePath->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcTableRow
boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > Ifc4::IfcTableRow::RowCells() const { if(data_.get_attribute_value(0).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcValue >(); }
void Ifc4::IfcTableRow::setRowCells(boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v) { if (v) {set_attribute_value(0, (*v)->generalize());} else {unset_attribute_value(0);} }
boost::optional< bool > Ifc4::IfcTableRow::IsHeading() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } bool v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcTableRow::setIsHeading(boost::optional< bool > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }


const IfcParse::entity& Ifc4::IfcTableRow::declaration() const { return *((IfcParse::entity*)IFC4_types[1032]); }
const IfcParse::entity& Ifc4::IfcTableRow::Class() { return *((IfcParse::entity*)IFC4_types[1032]); }
Ifc4::IfcTableRow::IfcTableRow(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcTableRow::IfcTableRow(boost::optional< aggregate_of< ::Ifc4::IfcValue >::ptr > v1_RowCells, boost::optional< bool > v2_IsHeading) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) {  if (v1_RowCells) {set_attribute_value(0, (*v1_RowCells)->generalize()); } if (v2_IsHeading) {set_attribute_value(1, (*v2_IsHeading)); }; populate_derived(); }

// Function implementations for IfcTank
boost::optional< ::Ifc4::IfcTankTypeEnum::Value > Ifc4::IfcTank::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcTankTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcTank::setPredefinedType(boost::optional< ::Ifc4::IfcTankTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcTankTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcTank::declaration() const { return *((IfcParse::entity*)IFC4_types[1033]); }
const IfcParse::entity& Ifc4::IfcTank::Class() { return *((IfcParse::entity*)IFC4_types[1033]); }
Ifc4::IfcTank::IfcTank(IfcEntityInstanceData&& e) : IfcFlowStorageDevice(std::move(e)) { }
Ifc4::IfcTank::IfcTank(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcTankTypeEnum::Value > v9_PredefinedType) : IfcFlowStorageDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcTankTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcTankType
::Ifc4::IfcTankTypeEnum::Value Ifc4::IfcTankType::PredefinedType() const {  return ::Ifc4::IfcTankTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTankType::setPredefinedType(::Ifc4::IfcTankTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTankTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcTankType::declaration() const { return *((IfcParse::entity*)IFC4_types[1034]); }
const IfcParse::entity& Ifc4::IfcTankType::Class() { return *((IfcParse::entity*)IFC4_types[1034]); }
Ifc4::IfcTankType::IfcTankType(IfcEntityInstanceData&& e) : IfcFlowStorageDeviceType(std::move(e)) { }
Ifc4::IfcTankType::IfcTankType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcTankTypeEnum::Value v10_PredefinedType) : IfcFlowStorageDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTankTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcTask
boost::optional< std::string > Ifc4::IfcTask::Status() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcTask::setStatus(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcTask::WorkMethod() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcTask::setWorkMethod(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
bool Ifc4::IfcTask::IsMilestone() const {  bool v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcTask::setIsMilestone(bool v) { set_attribute_value(9, v);if constexpr (false)unset_attribute_value(9); }
boost::optional< int > Ifc4::IfcTask::Priority() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } int v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcTask::setPriority(boost::optional< int > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
::Ifc4::IfcTaskTime* Ifc4::IfcTask::TaskTime() const { if(data_.get_attribute_value(11).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(11)))->as<::Ifc4::IfcTaskTime>(true); }
void Ifc4::IfcTask::setTaskTime(::Ifc4::IfcTaskTime* v) { set_attribute_value(11, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(11); }
boost::optional< ::Ifc4::IfcTaskTypeEnum::Value > Ifc4::IfcTask::PredefinedType() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } return ::Ifc4::IfcTaskTypeEnum::FromString(data_.get_attribute_value(12)); }
void Ifc4::IfcTask::setPredefinedType(boost::optional< ::Ifc4::IfcTaskTypeEnum::Value > v) { if (v) {set_attribute_value(12, EnumerationReference(&::Ifc4::IfcTaskTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(12);} }


const IfcParse::entity& Ifc4::IfcTask::declaration() const { return *((IfcParse::entity*)IFC4_types[1036]); }
const IfcParse::entity& Ifc4::IfcTask::Class() { return *((IfcParse::entity*)IFC4_types[1036]); }
Ifc4::IfcTask::IfcTask(IfcEntityInstanceData&& e) : IfcProcess(std::move(e)) { }
Ifc4::IfcTask::IfcTask(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< std::string > v7_LongDescription, boost::optional< std::string > v8_Status, boost::optional< std::string > v9_WorkMethod, bool v10_IsMilestone, boost::optional< int > v11_Priority, ::Ifc4::IfcTaskTime* v12_TaskTime, boost::optional< ::Ifc4::IfcTaskTypeEnum::Value > v13_PredefinedType) : IfcProcess(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_LongDescription) {set_attribute_value(6, (*v7_LongDescription)); } if (v8_Status) {set_attribute_value(7, (*v8_Status)); } if (v9_WorkMethod) {set_attribute_value(8, (*v9_WorkMethod)); }set_attribute_value(9, (v10_IsMilestone)); if (v11_Priority) {set_attribute_value(10, (*v11_Priority)); }set_attribute_value(11, v12_TaskTime ? v12_TaskTime->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v13_PredefinedType) {set_attribute_value(12, (EnumerationReference(&::Ifc4::IfcTaskTypeEnum::Class(),(size_t)*v13_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcTaskTime
boost::optional< ::Ifc4::IfcTaskDurationEnum::Value > Ifc4::IfcTaskTime::DurationType() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } return ::Ifc4::IfcTaskDurationEnum::FromString(data_.get_attribute_value(3)); }
void Ifc4::IfcTaskTime::setDurationType(boost::optional< ::Ifc4::IfcTaskDurationEnum::Value > v) { if (v) {set_attribute_value(3, EnumerationReference(&::Ifc4::IfcTaskDurationEnum::Class(), (size_t) *v));} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcTaskTime::ScheduleDuration() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTaskTime::setScheduleDuration(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcTaskTime::ScheduleStart() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcTaskTime::setScheduleStart(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::string > Ifc4::IfcTaskTime::ScheduleFinish() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcTaskTime::setScheduleFinish(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcTaskTime::EarlyStart() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcTaskTime::setEarlyStart(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcTaskTime::EarlyFinish() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcTaskTime::setEarlyFinish(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< std::string > Ifc4::IfcTaskTime::LateStart() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcTaskTime::setLateStart(boost::optional< std::string > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< std::string > Ifc4::IfcTaskTime::LateFinish() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcTaskTime::setLateFinish(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< std::string > Ifc4::IfcTaskTime::FreeFloat() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcTaskTime::setFreeFloat(boost::optional< std::string > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< std::string > Ifc4::IfcTaskTime::TotalFloat() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcTaskTime::setTotalFloat(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< bool > Ifc4::IfcTaskTime::IsCritical() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } bool v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcTaskTime::setIsCritical(boost::optional< bool > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
boost::optional< std::string > Ifc4::IfcTaskTime::StatusTime() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcTaskTime::setStatusTime(boost::optional< std::string > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }
boost::optional< std::string > Ifc4::IfcTaskTime::ActualDuration() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(15); return v; }
void Ifc4::IfcTaskTime::setActualDuration(boost::optional< std::string > v) { if (v) {set_attribute_value(15, *v);} else {unset_attribute_value(15);} }
boost::optional< std::string > Ifc4::IfcTaskTime::ActualStart() const { if(data_.get_attribute_value(16).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(16); return v; }
void Ifc4::IfcTaskTime::setActualStart(boost::optional< std::string > v) { if (v) {set_attribute_value(16, *v);} else {unset_attribute_value(16);} }
boost::optional< std::string > Ifc4::IfcTaskTime::ActualFinish() const { if(data_.get_attribute_value(17).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(17); return v; }
void Ifc4::IfcTaskTime::setActualFinish(boost::optional< std::string > v) { if (v) {set_attribute_value(17, *v);} else {unset_attribute_value(17);} }
boost::optional< std::string > Ifc4::IfcTaskTime::RemainingTime() const { if(data_.get_attribute_value(18).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(18); return v; }
void Ifc4::IfcTaskTime::setRemainingTime(boost::optional< std::string > v) { if (v) {set_attribute_value(18, *v);} else {unset_attribute_value(18);} }
boost::optional< double > Ifc4::IfcTaskTime::Completion() const { if(data_.get_attribute_value(19).isNull()) { return boost::none; } double v = data_.get_attribute_value(19); return v; }
void Ifc4::IfcTaskTime::setCompletion(boost::optional< double > v) { if (v) {set_attribute_value(19, *v);} else {unset_attribute_value(19);} }


const IfcParse::entity& Ifc4::IfcTaskTime::declaration() const { return *((IfcParse::entity*)IFC4_types[1038]); }
const IfcParse::entity& Ifc4::IfcTaskTime::Class() { return *((IfcParse::entity*)IFC4_types[1038]); }
Ifc4::IfcTaskTime::IfcTaskTime(IfcEntityInstanceData&& e) : IfcSchedulingTime(std::move(e)) { }
Ifc4::IfcTaskTime::IfcTaskTime(boost::optional< std::string > v1_Name, boost::optional< ::Ifc4::IfcDataOriginEnum::Value > v2_DataOrigin, boost::optional< std::string > v3_UserDefinedDataOrigin, boost::optional< ::Ifc4::IfcTaskDurationEnum::Value > v4_DurationType, boost::optional< std::string > v5_ScheduleDuration, boost::optional< std::string > v6_ScheduleStart, boost::optional< std::string > v7_ScheduleFinish, boost::optional< std::string > v8_EarlyStart, boost::optional< std::string > v9_EarlyFinish, boost::optional< std::string > v10_LateStart, boost::optional< std::string > v11_LateFinish, boost::optional< std::string > v12_FreeFloat, boost::optional< std::string > v13_TotalFloat, boost::optional< bool > v14_IsCritical, boost::optional< std::string > v15_StatusTime, boost::optional< std::string > v16_ActualDuration, boost::optional< std::string > v17_ActualStart, boost::optional< std::string > v18_ActualFinish, boost::optional< std::string > v19_RemainingTime, boost::optional< double > v20_Completion) : IfcSchedulingTime(IfcEntityInstanceData(storage_t(20))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DataOrigin) {set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)*v2_DataOrigin))); } if (v3_UserDefinedDataOrigin) {set_attribute_value(2, (*v3_UserDefinedDataOrigin)); } if (v4_DurationType) {set_attribute_value(3, (EnumerationReference(&::Ifc4::IfcTaskDurationEnum::Class(),(size_t)*v4_DurationType))); } if (v5_ScheduleDuration) {set_attribute_value(4, (*v5_ScheduleDuration)); } if (v6_ScheduleStart) {set_attribute_value(5, (*v6_ScheduleStart)); } if (v7_ScheduleFinish) {set_attribute_value(6, (*v7_ScheduleFinish)); } if (v8_EarlyStart) {set_attribute_value(7, (*v8_EarlyStart)); } if (v9_EarlyFinish) {set_attribute_value(8, (*v9_EarlyFinish)); } if (v10_LateStart) {set_attribute_value(9, (*v10_LateStart)); } if (v11_LateFinish) {set_attribute_value(10, (*v11_LateFinish)); } if (v12_FreeFloat) {set_attribute_value(11, (*v12_FreeFloat)); } if (v13_TotalFloat) {set_attribute_value(12, (*v13_TotalFloat)); } if (v14_IsCritical) {set_attribute_value(13, (*v14_IsCritical)); } if (v15_StatusTime) {set_attribute_value(14, (*v15_StatusTime)); } if (v16_ActualDuration) {set_attribute_value(15, (*v16_ActualDuration)); } if (v17_ActualStart) {set_attribute_value(16, (*v17_ActualStart)); } if (v18_ActualFinish) {set_attribute_value(17, (*v18_ActualFinish)); } if (v19_RemainingTime) {set_attribute_value(18, (*v19_RemainingTime)); } if (v20_Completion) {set_attribute_value(19, (*v20_Completion)); }; populate_derived(); }

// Function implementations for IfcTaskTimeRecurring
::Ifc4::IfcRecurrencePattern* Ifc4::IfcTaskTimeRecurring::Recurrence() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(20)))->as<::Ifc4::IfcRecurrencePattern>(true); }
void Ifc4::IfcTaskTimeRecurring::setRecurrence(::Ifc4::IfcRecurrencePattern* v) { set_attribute_value(20, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(20); }


const IfcParse::entity& Ifc4::IfcTaskTimeRecurring::declaration() const { return *((IfcParse::entity*)IFC4_types[1039]); }
const IfcParse::entity& Ifc4::IfcTaskTimeRecurring::Class() { return *((IfcParse::entity*)IFC4_types[1039]); }
Ifc4::IfcTaskTimeRecurring::IfcTaskTimeRecurring(IfcEntityInstanceData&& e) : IfcTaskTime(std::move(e)) { }
Ifc4::IfcTaskTimeRecurring::IfcTaskTimeRecurring(boost::optional< std::string > v1_Name, boost::optional< ::Ifc4::IfcDataOriginEnum::Value > v2_DataOrigin, boost::optional< std::string > v3_UserDefinedDataOrigin, boost::optional< ::Ifc4::IfcTaskDurationEnum::Value > v4_DurationType, boost::optional< std::string > v5_ScheduleDuration, boost::optional< std::string > v6_ScheduleStart, boost::optional< std::string > v7_ScheduleFinish, boost::optional< std::string > v8_EarlyStart, boost::optional< std::string > v9_EarlyFinish, boost::optional< std::string > v10_LateStart, boost::optional< std::string > v11_LateFinish, boost::optional< std::string > v12_FreeFloat, boost::optional< std::string > v13_TotalFloat, boost::optional< bool > v14_IsCritical, boost::optional< std::string > v15_StatusTime, boost::optional< std::string > v16_ActualDuration, boost::optional< std::string > v17_ActualStart, boost::optional< std::string > v18_ActualFinish, boost::optional< std::string > v19_RemainingTime, boost::optional< double > v20_Completion, ::Ifc4::IfcRecurrencePattern* v21_Recurrence) : IfcTaskTime(IfcEntityInstanceData(storage_t(21))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DataOrigin) {set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)*v2_DataOrigin))); } if (v3_UserDefinedDataOrigin) {set_attribute_value(2, (*v3_UserDefinedDataOrigin)); } if (v4_DurationType) {set_attribute_value(3, (EnumerationReference(&::Ifc4::IfcTaskDurationEnum::Class(),(size_t)*v4_DurationType))); } if (v5_ScheduleDuration) {set_attribute_value(4, (*v5_ScheduleDuration)); } if (v6_ScheduleStart) {set_attribute_value(5, (*v6_ScheduleStart)); } if (v7_ScheduleFinish) {set_attribute_value(6, (*v7_ScheduleFinish)); } if (v8_EarlyStart) {set_attribute_value(7, (*v8_EarlyStart)); } if (v9_EarlyFinish) {set_attribute_value(8, (*v9_EarlyFinish)); } if (v10_LateStart) {set_attribute_value(9, (*v10_LateStart)); } if (v11_LateFinish) {set_attribute_value(10, (*v11_LateFinish)); } if (v12_FreeFloat) {set_attribute_value(11, (*v12_FreeFloat)); } if (v13_TotalFloat) {set_attribute_value(12, (*v13_TotalFloat)); } if (v14_IsCritical) {set_attribute_value(13, (*v14_IsCritical)); } if (v15_StatusTime) {set_attribute_value(14, (*v15_StatusTime)); } if (v16_ActualDuration) {set_attribute_value(15, (*v16_ActualDuration)); } if (v17_ActualStart) {set_attribute_value(16, (*v17_ActualStart)); } if (v18_ActualFinish) {set_attribute_value(17, (*v18_ActualFinish)); } if (v19_RemainingTime) {set_attribute_value(18, (*v19_RemainingTime)); } if (v20_Completion) {set_attribute_value(19, (*v20_Completion)); }set_attribute_value(20, v21_Recurrence ? v21_Recurrence->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcTaskType
::Ifc4::IfcTaskTypeEnum::Value Ifc4::IfcTaskType::PredefinedType() const {  return ::Ifc4::IfcTaskTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTaskType::setPredefinedType(::Ifc4::IfcTaskTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTaskTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< std::string > Ifc4::IfcTaskType::WorkMethod() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcTaskType::setWorkMethod(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }


const IfcParse::entity& Ifc4::IfcTaskType::declaration() const { return *((IfcParse::entity*)IFC4_types[1040]); }
const IfcParse::entity& Ifc4::IfcTaskType::Class() { return *((IfcParse::entity*)IFC4_types[1040]); }
Ifc4::IfcTaskType::IfcTaskType(IfcEntityInstanceData&& e) : IfcTypeProcess(std::move(e)) { }
Ifc4::IfcTaskType::IfcTaskType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ProcessType, ::Ifc4::IfcTaskTypeEnum::Value v10_PredefinedType, boost::optional< std::string > v11_WorkMethod) : IfcTypeProcess(IfcEntityInstanceData(storage_t(11))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ProcessType) {set_attribute_value(8, (*v9_ProcessType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTaskTypeEnum::Class(),(size_t)v10_PredefinedType))); if (v11_WorkMethod) {set_attribute_value(10, (*v11_WorkMethod)); }; populate_derived(); }

// Function implementations for IfcTelecomAddress
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcTelecomAddress::TelephoneNumbers() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcTelecomAddress::setTelephoneNumbers(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcTelecomAddress::FacsimileNumbers() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTelecomAddress::setFacsimileNumbers(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcTelecomAddress::PagerNumber() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcTelecomAddress::setPagerNumber(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcTelecomAddress::ElectronicMailAddresses() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcTelecomAddress::setElectronicMailAddresses(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcTelecomAddress::WWWHomePageURL() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcTelecomAddress::setWWWHomePageURL(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::vector< std::string > /*[1:?]*/ > Ifc4::IfcTelecomAddress::MessagingIDs() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcTelecomAddress::setMessagingIDs(boost::optional< std::vector< std::string > /*[1:?]*/ > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcTelecomAddress::declaration() const { return *((IfcParse::entity*)IFC4_types[1042]); }
const IfcParse::entity& Ifc4::IfcTelecomAddress::Class() { return *((IfcParse::entity*)IFC4_types[1042]); }
Ifc4::IfcTelecomAddress::IfcTelecomAddress(IfcEntityInstanceData&& e) : IfcAddress(std::move(e)) { }
Ifc4::IfcTelecomAddress::IfcTelecomAddress(boost::optional< ::Ifc4::IfcAddressTypeEnum::Value > v1_Purpose, boost::optional< std::string > v2_Description, boost::optional< std::string > v3_UserDefinedPurpose, boost::optional< std::vector< std::string > /*[1:?]*/ > v4_TelephoneNumbers, boost::optional< std::vector< std::string > /*[1:?]*/ > v5_FacsimileNumbers, boost::optional< std::string > v6_PagerNumber, boost::optional< std::vector< std::string > /*[1:?]*/ > v7_ElectronicMailAddresses, boost::optional< std::string > v8_WWWHomePageURL, boost::optional< std::vector< std::string > /*[1:?]*/ > v9_MessagingIDs) : IfcAddress(IfcEntityInstanceData(storage_t(9))) {  if (v1_Purpose) {set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcAddressTypeEnum::Class(),(size_t)*v1_Purpose))); } if (v2_Description) {set_attribute_value(1, (*v2_Description)); } if (v3_UserDefinedPurpose) {set_attribute_value(2, (*v3_UserDefinedPurpose)); } if (v4_TelephoneNumbers) {set_attribute_value(3, (*v4_TelephoneNumbers)); } if (v5_FacsimileNumbers) {set_attribute_value(4, (*v5_FacsimileNumbers)); } if (v6_PagerNumber) {set_attribute_value(5, (*v6_PagerNumber)); } if (v7_ElectronicMailAddresses) {set_attribute_value(6, (*v7_ElectronicMailAddresses)); } if (v8_WWWHomePageURL) {set_attribute_value(7, (*v8_WWWHomePageURL)); } if (v9_MessagingIDs) {set_attribute_value(8, (*v9_MessagingIDs)); }; populate_derived(); }

// Function implementations for IfcTendon
boost::optional< ::Ifc4::IfcTendonTypeEnum::Value > Ifc4::IfcTendon::PredefinedType() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } return ::Ifc4::IfcTendonTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTendon::setPredefinedType(boost::optional< ::Ifc4::IfcTendonTypeEnum::Value > v) { if (v) {set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTendonTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcTendon::NominalDiameter() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcTendon::setNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcTendon::CrossSectionArea() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcTendon::setCrossSectionArea(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< double > Ifc4::IfcTendon::TensionForce() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcTendon::setTensionForce(boost::optional< double > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }
boost::optional< double > Ifc4::IfcTendon::PreStress() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } double v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcTendon::setPreStress(boost::optional< double > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
boost::optional< double > Ifc4::IfcTendon::FrictionCoefficient() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } double v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcTendon::setFrictionCoefficient(boost::optional< double > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }
boost::optional< double > Ifc4::IfcTendon::AnchorageSlip() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } double v = data_.get_attribute_value(15); return v; }
void Ifc4::IfcTendon::setAnchorageSlip(boost::optional< double > v) { if (v) {set_attribute_value(15, *v);} else {unset_attribute_value(15);} }
boost::optional< double > Ifc4::IfcTendon::MinCurvatureRadius() const { if(data_.get_attribute_value(16).isNull()) { return boost::none; } double v = data_.get_attribute_value(16); return v; }
void Ifc4::IfcTendon::setMinCurvatureRadius(boost::optional< double > v) { if (v) {set_attribute_value(16, *v);} else {unset_attribute_value(16);} }


const IfcParse::entity& Ifc4::IfcTendon::declaration() const { return *((IfcParse::entity*)IFC4_types[1045]); }
const IfcParse::entity& Ifc4::IfcTendon::Class() { return *((IfcParse::entity*)IFC4_types[1045]); }
Ifc4::IfcTendon::IfcTendon(IfcEntityInstanceData&& e) : IfcReinforcingElement(std::move(e)) { }
Ifc4::IfcTendon::IfcTendon(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_SteelGrade, boost::optional< ::Ifc4::IfcTendonTypeEnum::Value > v10_PredefinedType, boost::optional< double > v11_NominalDiameter, boost::optional< double > v12_CrossSectionArea, boost::optional< double > v13_TensionForce, boost::optional< double > v14_PreStress, boost::optional< double > v15_FrictionCoefficient, boost::optional< double > v16_AnchorageSlip, boost::optional< double > v17_MinCurvatureRadius) : IfcReinforcingElement(IfcEntityInstanceData(storage_t(17))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_SteelGrade) {set_attribute_value(8, (*v9_SteelGrade)); } if (v10_PredefinedType) {set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTendonTypeEnum::Class(),(size_t)*v10_PredefinedType))); } if (v11_NominalDiameter) {set_attribute_value(10, (*v11_NominalDiameter)); } if (v12_CrossSectionArea) {set_attribute_value(11, (*v12_CrossSectionArea)); } if (v13_TensionForce) {set_attribute_value(12, (*v13_TensionForce)); } if (v14_PreStress) {set_attribute_value(13, (*v14_PreStress)); } if (v15_FrictionCoefficient) {set_attribute_value(14, (*v15_FrictionCoefficient)); } if (v16_AnchorageSlip) {set_attribute_value(15, (*v16_AnchorageSlip)); } if (v17_MinCurvatureRadius) {set_attribute_value(16, (*v17_MinCurvatureRadius)); }; populate_derived(); }

// Function implementations for IfcTendonAnchor
boost::optional< ::Ifc4::IfcTendonAnchorTypeEnum::Value > Ifc4::IfcTendonAnchor::PredefinedType() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } return ::Ifc4::IfcTendonAnchorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTendonAnchor::setPredefinedType(boost::optional< ::Ifc4::IfcTendonAnchorTypeEnum::Value > v) { if (v) {set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTendonAnchorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcTendonAnchor::declaration() const { return *((IfcParse::entity*)IFC4_types[1046]); }
const IfcParse::entity& Ifc4::IfcTendonAnchor::Class() { return *((IfcParse::entity*)IFC4_types[1046]); }
Ifc4::IfcTendonAnchor::IfcTendonAnchor(IfcEntityInstanceData&& e) : IfcReinforcingElement(std::move(e)) { }
Ifc4::IfcTendonAnchor::IfcTendonAnchor(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_SteelGrade, boost::optional< ::Ifc4::IfcTendonAnchorTypeEnum::Value > v10_PredefinedType) : IfcReinforcingElement(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_SteelGrade) {set_attribute_value(8, (*v9_SteelGrade)); } if (v10_PredefinedType) {set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTendonAnchorTypeEnum::Class(),(size_t)*v10_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcTendonAnchorType
::Ifc4::IfcTendonAnchorTypeEnum::Value Ifc4::IfcTendonAnchorType::PredefinedType() const {  return ::Ifc4::IfcTendonAnchorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTendonAnchorType::setPredefinedType(::Ifc4::IfcTendonAnchorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTendonAnchorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcTendonAnchorType::declaration() const { return *((IfcParse::entity*)IFC4_types[1047]); }
const IfcParse::entity& Ifc4::IfcTendonAnchorType::Class() { return *((IfcParse::entity*)IFC4_types[1047]); }
Ifc4::IfcTendonAnchorType::IfcTendonAnchorType(IfcEntityInstanceData&& e) : IfcReinforcingElementType(std::move(e)) { }
Ifc4::IfcTendonAnchorType::IfcTendonAnchorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcTendonAnchorTypeEnum::Value v10_PredefinedType) : IfcReinforcingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTendonAnchorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcTendonType
::Ifc4::IfcTendonTypeEnum::Value Ifc4::IfcTendonType::PredefinedType() const {  return ::Ifc4::IfcTendonTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTendonType::setPredefinedType(::Ifc4::IfcTendonTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTendonTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
boost::optional< double > Ifc4::IfcTendonType::NominalDiameter() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcTendonType::setNominalDiameter(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcTendonType::CrossSectionArea() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcTendonType::setCrossSectionArea(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< double > Ifc4::IfcTendonType::SheathDiameter() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } double v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcTendonType::setSheathDiameter(boost::optional< double > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }


const IfcParse::entity& Ifc4::IfcTendonType::declaration() const { return *((IfcParse::entity*)IFC4_types[1049]); }
const IfcParse::entity& Ifc4::IfcTendonType::Class() { return *((IfcParse::entity*)IFC4_types[1049]); }
Ifc4::IfcTendonType::IfcTendonType(IfcEntityInstanceData&& e) : IfcReinforcingElementType(std::move(e)) { }
Ifc4::IfcTendonType::IfcTendonType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcTendonTypeEnum::Value v10_PredefinedType, boost::optional< double > v11_NominalDiameter, boost::optional< double > v12_CrossSectionArea, boost::optional< double > v13_SheathDiameter) : IfcReinforcingElementType(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTendonTypeEnum::Class(),(size_t)v10_PredefinedType))); if (v11_NominalDiameter) {set_attribute_value(10, (*v11_NominalDiameter)); } if (v12_CrossSectionArea) {set_attribute_value(11, (*v12_CrossSectionArea)); } if (v13_SheathDiameter) {set_attribute_value(12, (*v13_SheathDiameter)); }; populate_derived(); }

// Function implementations for IfcTessellatedFaceSet
::Ifc4::IfcCartesianPointList3D* Ifc4::IfcTessellatedFaceSet::Coordinates() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCartesianPointList3D>(true); }
void Ifc4::IfcTessellatedFaceSet::setCoordinates(::Ifc4::IfcCartesianPointList3D* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }

::Ifc4::IfcIndexedColourMap::list::ptr Ifc4::IfcTessellatedFaceSet::HasColours() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[479], 0)->as<IfcIndexedColourMap>(); }
::Ifc4::IfcIndexedTextureMap::list::ptr Ifc4::IfcTessellatedFaceSet::HasTextures() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[483], 1)->as<IfcIndexedTextureMap>(); }

const IfcParse::entity& Ifc4::IfcTessellatedFaceSet::declaration() const { return *((IfcParse::entity*)IFC4_types[1051]); }
const IfcParse::entity& Ifc4::IfcTessellatedFaceSet::Class() { return *((IfcParse::entity*)IFC4_types[1051]); }
Ifc4::IfcTessellatedFaceSet::IfcTessellatedFaceSet(IfcEntityInstanceData&& e) : IfcTessellatedItem(std::move(e)) { }
Ifc4::IfcTessellatedFaceSet::IfcTessellatedFaceSet(::Ifc4::IfcCartesianPointList3D* v1_Coordinates) : IfcTessellatedItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_Coordinates ? v1_Coordinates->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcTessellatedItem


const IfcParse::entity& Ifc4::IfcTessellatedItem::declaration() const { return *((IfcParse::entity*)IFC4_types[1052]); }
const IfcParse::entity& Ifc4::IfcTessellatedItem::Class() { return *((IfcParse::entity*)IFC4_types[1052]); }
Ifc4::IfcTessellatedItem::IfcTessellatedItem(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcTessellatedItem::IfcTessellatedItem() : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcTextLiteral
std::string Ifc4::IfcTextLiteral::Literal() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcTextLiteral::setLiteral(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcAxis2Placement* Ifc4::IfcTextLiteral::Placement() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcAxis2Placement>(true); }
void Ifc4::IfcTextLiteral::setPlacement(::Ifc4::IfcAxis2Placement* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcTextPath::Value Ifc4::IfcTextLiteral::Path() const {  return ::Ifc4::IfcTextPath::FromString(data_.get_attribute_value(2)); }
void Ifc4::IfcTextLiteral::setPath(::Ifc4::IfcTextPath::Value v) { set_attribute_value(2, EnumerationReference(&::Ifc4::IfcTextPath::Class(), (size_t) v));if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcTextLiteral::declaration() const { return *((IfcParse::entity*)IFC4_types[1058]); }
const IfcParse::entity& Ifc4::IfcTextLiteral::Class() { return *((IfcParse::entity*)IFC4_types[1058]); }
Ifc4::IfcTextLiteral::IfcTextLiteral(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcTextLiteral::IfcTextLiteral(std::string v1_Literal, ::Ifc4::IfcAxis2Placement* v2_Placement, ::Ifc4::IfcTextPath::Value v3_Path) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Literal));set_attribute_value(1, v2_Placement ? v2_Placement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcTextPath::Class(),(size_t)v3_Path)));; populate_derived(); }

// Function implementations for IfcTextLiteralWithExtent
::Ifc4::IfcPlanarExtent* Ifc4::IfcTextLiteralWithExtent::Extent() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcPlanarExtent>(true); }
void Ifc4::IfcTextLiteralWithExtent::setExtent(::Ifc4::IfcPlanarExtent* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
std::string Ifc4::IfcTextLiteralWithExtent::BoxAlignment() const {  std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTextLiteralWithExtent::setBoxAlignment(std::string v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcTextLiteralWithExtent::declaration() const { return *((IfcParse::entity*)IFC4_types[1059]); }
const IfcParse::entity& Ifc4::IfcTextLiteralWithExtent::Class() { return *((IfcParse::entity*)IFC4_types[1059]); }
Ifc4::IfcTextLiteralWithExtent::IfcTextLiteralWithExtent(IfcEntityInstanceData&& e) : IfcTextLiteral(std::move(e)) { }
Ifc4::IfcTextLiteralWithExtent::IfcTextLiteralWithExtent(std::string v1_Literal, ::Ifc4::IfcAxis2Placement* v2_Placement, ::Ifc4::IfcTextPath::Value v3_Path, ::Ifc4::IfcPlanarExtent* v4_Extent, std::string v5_BoxAlignment) : IfcTextLiteral(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, (v1_Literal));set_attribute_value(1, v2_Placement ? v2_Placement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, (EnumerationReference(&::Ifc4::IfcTextPath::Class(),(size_t)v3_Path)));set_attribute_value(3, v4_Extent ? v4_Extent->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, (v5_BoxAlignment));; populate_derived(); }

// Function implementations for IfcTextStyle
::Ifc4::IfcTextStyleForDefinedFont* Ifc4::IfcTextStyle::TextCharacterAppearance() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcTextStyleForDefinedFont>(true); }
void Ifc4::IfcTextStyle::setTextCharacterAppearance(::Ifc4::IfcTextStyleForDefinedFont* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcTextStyleTextModel* Ifc4::IfcTextStyle::TextStyle() const { if(data_.get_attribute_value(2).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcTextStyleTextModel>(true); }
void Ifc4::IfcTextStyle::setTextStyle(::Ifc4::IfcTextStyleTextModel* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }
::Ifc4::IfcTextFontSelect* Ifc4::IfcTextStyle::TextFontStyle() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcTextFontSelect>(true); }
void Ifc4::IfcTextStyle::setTextFontStyle(::Ifc4::IfcTextFontSelect* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< bool > Ifc4::IfcTextStyle::ModelOrDraughting() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } bool v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTextStyle::setModelOrDraughting(boost::optional< bool > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcTextStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[1061]); }
const IfcParse::entity& Ifc4::IfcTextStyle::Class() { return *((IfcParse::entity*)IFC4_types[1061]); }
Ifc4::IfcTextStyle::IfcTextStyle(IfcEntityInstanceData&& e) : IfcPresentationStyle(std::move(e)) { }
Ifc4::IfcTextStyle::IfcTextStyle(boost::optional< std::string > v1_Name, ::Ifc4::IfcTextStyleForDefinedFont* v2_TextCharacterAppearance, ::Ifc4::IfcTextStyleTextModel* v3_TextStyle, ::Ifc4::IfcTextFontSelect* v4_TextFontStyle, boost::optional< bool > v5_ModelOrDraughting) : IfcPresentationStyle(IfcEntityInstanceData(storage_t(5))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); }set_attribute_value(1, v2_TextCharacterAppearance ? v2_TextCharacterAppearance->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(2, v3_TextStyle ? v3_TextStyle->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, v4_TextFontStyle ? v4_TextFontStyle->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_ModelOrDraughting) {set_attribute_value(4, (*v5_ModelOrDraughting)); }; populate_derived(); }

// Function implementations for IfcTextStyleFontModel
std::vector< std::string > /*[1:?]*/ Ifc4::IfcTextStyleFontModel::FontFamily() const {  std::vector< std::string > /*[1:?]*/ v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcTextStyleFontModel::setFontFamily(std::vector< std::string > /*[1:?]*/ v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< std::string > Ifc4::IfcTextStyleFontModel::FontStyle() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcTextStyleFontModel::setFontStyle(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
boost::optional< std::string > Ifc4::IfcTextStyleFontModel::FontVariant() const { if(data_.get_attribute_value(3).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcTextStyleFontModel::setFontVariant(boost::optional< std::string > v) { if (v) {set_attribute_value(3, *v);} else {unset_attribute_value(3);} }
boost::optional< std::string > Ifc4::IfcTextStyleFontModel::FontWeight() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTextStyleFontModel::setFontWeight(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
::Ifc4::IfcSizeSelect* Ifc4::IfcTextStyleFontModel::FontSize() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(5)))->as<::Ifc4::IfcSizeSelect>(true); }
void Ifc4::IfcTextStyleFontModel::setFontSize(::Ifc4::IfcSizeSelect* v) { set_attribute_value(5, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(5); }


const IfcParse::entity& Ifc4::IfcTextStyleFontModel::declaration() const { return *((IfcParse::entity*)IFC4_types[1062]); }
const IfcParse::entity& Ifc4::IfcTextStyleFontModel::Class() { return *((IfcParse::entity*)IFC4_types[1062]); }
Ifc4::IfcTextStyleFontModel::IfcTextStyleFontModel(IfcEntityInstanceData&& e) : IfcPreDefinedTextFont(std::move(e)) { }
Ifc4::IfcTextStyleFontModel::IfcTextStyleFontModel(std::string v1_Name, std::vector< std::string > /*[1:?]*/ v2_FontFamily, boost::optional< std::string > v3_FontStyle, boost::optional< std::string > v4_FontVariant, boost::optional< std::string > v5_FontWeight, ::Ifc4::IfcSizeSelect* v6_FontSize) : IfcPreDefinedTextFont(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_Name));set_attribute_value(1, (v2_FontFamily)); if (v3_FontStyle) {set_attribute_value(2, (*v3_FontStyle)); } if (v4_FontVariant) {set_attribute_value(3, (*v4_FontVariant)); } if (v5_FontWeight) {set_attribute_value(4, (*v5_FontWeight)); }set_attribute_value(5, v6_FontSize ? v6_FontSize->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcTextStyleForDefinedFont
::Ifc4::IfcColour* Ifc4::IfcTextStyleForDefinedFont::Colour() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcColour>(true); }
void Ifc4::IfcTextStyleForDefinedFont::setColour(::Ifc4::IfcColour* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
::Ifc4::IfcColour* Ifc4::IfcTextStyleForDefinedFont::BackgroundColour() const { if(data_.get_attribute_value(1).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(1)))->as<::Ifc4::IfcColour>(true); }
void Ifc4::IfcTextStyleForDefinedFont::setBackgroundColour(::Ifc4::IfcColour* v) { set_attribute_value(1, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcTextStyleForDefinedFont::declaration() const { return *((IfcParse::entity*)IFC4_types[1063]); }
const IfcParse::entity& Ifc4::IfcTextStyleForDefinedFont::Class() { return *((IfcParse::entity*)IFC4_types[1063]); }
Ifc4::IfcTextStyleForDefinedFont::IfcTextStyleForDefinedFont(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcTextStyleForDefinedFont::IfcTextStyleForDefinedFont(::Ifc4::IfcColour* v1_Colour, ::Ifc4::IfcColour* v2_BackgroundColour) : IfcPresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Colour ? v1_Colour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, v2_BackgroundColour ? v2_BackgroundColour->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcTextStyleTextModel
::Ifc4::IfcSizeSelect* Ifc4::IfcTextStyleTextModel::TextIndent() const { if(data_.get_attribute_value(0).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcSizeSelect>(true); }
void Ifc4::IfcTextStyleTextModel::setTextIndent(::Ifc4::IfcSizeSelect* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcTextStyleTextModel::TextAlign() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcTextStyleTextModel::setTextAlign(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< std::string > Ifc4::IfcTextStyleTextModel::TextDecoration() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcTextStyleTextModel::setTextDecoration(boost::optional< std::string > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
::Ifc4::IfcSizeSelect* Ifc4::IfcTextStyleTextModel::LetterSpacing() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcSizeSelect>(true); }
void Ifc4::IfcTextStyleTextModel::setLetterSpacing(::Ifc4::IfcSizeSelect* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcSizeSelect* Ifc4::IfcTextStyleTextModel::WordSpacing() const { if(data_.get_attribute_value(4).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(4)))->as<::Ifc4::IfcSizeSelect>(true); }
void Ifc4::IfcTextStyleTextModel::setWordSpacing(::Ifc4::IfcSizeSelect* v) { set_attribute_value(4, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(4); }
boost::optional< std::string > Ifc4::IfcTextStyleTextModel::TextTransform() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcTextStyleTextModel::setTextTransform(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
::Ifc4::IfcSizeSelect* Ifc4::IfcTextStyleTextModel::LineHeight() const { if(data_.get_attribute_value(6).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(6)))->as<::Ifc4::IfcSizeSelect>(true); }
void Ifc4::IfcTextStyleTextModel::setLineHeight(::Ifc4::IfcSizeSelect* v) { set_attribute_value(6, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcTextStyleTextModel::declaration() const { return *((IfcParse::entity*)IFC4_types[1064]); }
const IfcParse::entity& Ifc4::IfcTextStyleTextModel::Class() { return *((IfcParse::entity*)IFC4_types[1064]); }
Ifc4::IfcTextStyleTextModel::IfcTextStyleTextModel(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcTextStyleTextModel::IfcTextStyleTextModel(::Ifc4::IfcSizeSelect* v1_TextIndent, boost::optional< std::string > v2_TextAlign, boost::optional< std::string > v3_TextDecoration, ::Ifc4::IfcSizeSelect* v4_LetterSpacing, ::Ifc4::IfcSizeSelect* v5_WordSpacing, boost::optional< std::string > v6_TextTransform, ::Ifc4::IfcSizeSelect* v7_LineHeight) : IfcPresentationItem(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, v1_TextIndent ? v1_TextIndent->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_TextAlign) {set_attribute_value(1, (*v2_TextAlign)); } if (v3_TextDecoration) {set_attribute_value(2, (*v3_TextDecoration)); }set_attribute_value(3, v4_LetterSpacing ? v4_LetterSpacing->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(4, v5_WordSpacing ? v5_WordSpacing->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v6_TextTransform) {set_attribute_value(5, (*v6_TextTransform)); }set_attribute_value(6, v7_LineHeight ? v7_LineHeight->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcTextureCoordinate
aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr Ifc4::IfcTextureCoordinate::Maps() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcSurfaceTexture >(); }
void Ifc4::IfcTextureCoordinate::setMaps(aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcTextureCoordinate::declaration() const { return *((IfcParse::entity*)IFC4_types[1066]); }
const IfcParse::entity& Ifc4::IfcTextureCoordinate::Class() { return *((IfcParse::entity*)IFC4_types[1066]); }
Ifc4::IfcTextureCoordinate::IfcTextureCoordinate(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcTextureCoordinate::IfcTextureCoordinate(aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr v1_Maps) : IfcPresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Maps)->generalize());; populate_derived(); }

// Function implementations for IfcTextureCoordinateGenerator
std::string Ifc4::IfcTextureCoordinateGenerator::Mode() const {  std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcTextureCoordinateGenerator::setMode(std::string v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
boost::optional< std::vector< double > /*[1:?]*/ > Ifc4::IfcTextureCoordinateGenerator::Parameter() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } std::vector< double > /*[1:?]*/ v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcTextureCoordinateGenerator::setParameter(boost::optional< std::vector< double > /*[1:?]*/ > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }


const IfcParse::entity& Ifc4::IfcTextureCoordinateGenerator::declaration() const { return *((IfcParse::entity*)IFC4_types[1067]); }
const IfcParse::entity& Ifc4::IfcTextureCoordinateGenerator::Class() { return *((IfcParse::entity*)IFC4_types[1067]); }
Ifc4::IfcTextureCoordinateGenerator::IfcTextureCoordinateGenerator(IfcEntityInstanceData&& e) : IfcTextureCoordinate(std::move(e)) { }
Ifc4::IfcTextureCoordinateGenerator::IfcTextureCoordinateGenerator(aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr v1_Maps, std::string v2_Mode, boost::optional< std::vector< double > /*[1:?]*/ > v3_Parameter) : IfcTextureCoordinate(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Maps)->generalize());set_attribute_value(1, (v2_Mode)); if (v3_Parameter) {set_attribute_value(2, (*v3_Parameter)); }; populate_derived(); }

// Function implementations for IfcTextureMap
aggregate_of< ::Ifc4::IfcTextureVertex >::ptr Ifc4::IfcTextureMap::Vertices() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcTextureVertex >(); }
void Ifc4::IfcTextureMap::setVertices(aggregate_of< ::Ifc4::IfcTextureVertex >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
::Ifc4::IfcFace* Ifc4::IfcTextureMap::MappedTo() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(2)))->as<::Ifc4::IfcFace>(true); }
void Ifc4::IfcTextureMap::setMappedTo(::Ifc4::IfcFace* v) { set_attribute_value(2, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcTextureMap::declaration() const { return *((IfcParse::entity*)IFC4_types[1068]); }
const IfcParse::entity& Ifc4::IfcTextureMap::Class() { return *((IfcParse::entity*)IFC4_types[1068]); }
Ifc4::IfcTextureMap::IfcTextureMap(IfcEntityInstanceData&& e) : IfcTextureCoordinate(std::move(e)) { }
Ifc4::IfcTextureMap::IfcTextureMap(aggregate_of< ::Ifc4::IfcSurfaceTexture >::ptr v1_Maps, aggregate_of< ::Ifc4::IfcTextureVertex >::ptr v2_Vertices, ::Ifc4::IfcFace* v3_MappedTo) : IfcTextureCoordinate(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, (v1_Maps)->generalize());set_attribute_value(1, (v2_Vertices)->generalize());set_attribute_value(2, v3_MappedTo ? v3_MappedTo->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcTextureVertex
std::vector< double > /*[2:2]*/ Ifc4::IfcTextureVertex::Coordinates() const {  std::vector< double > /*[2:2]*/ v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcTextureVertex::setCoordinates(std::vector< double > /*[2:2]*/ v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcTextureVertex::declaration() const { return *((IfcParse::entity*)IFC4_types[1069]); }
const IfcParse::entity& Ifc4::IfcTextureVertex::Class() { return *((IfcParse::entity*)IFC4_types[1069]); }
Ifc4::IfcTextureVertex::IfcTextureVertex(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcTextureVertex::IfcTextureVertex(std::vector< double > /*[2:2]*/ v1_Coordinates) : IfcPresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Coordinates));; populate_derived(); }

// Function implementations for IfcTextureVertexList
std::vector< std::vector< double > > Ifc4::IfcTextureVertexList::TexCoordsList() const {  std::vector< std::vector< double > > v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcTextureVertexList::setTexCoordsList(std::vector< std::vector< double > > v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcTextureVertexList::declaration() const { return *((IfcParse::entity*)IFC4_types[1070]); }
const IfcParse::entity& Ifc4::IfcTextureVertexList::Class() { return *((IfcParse::entity*)IFC4_types[1070]); }
Ifc4::IfcTextureVertexList::IfcTextureVertexList(IfcEntityInstanceData&& e) : IfcPresentationItem(std::move(e)) { }
Ifc4::IfcTextureVertexList::IfcTextureVertexList(std::vector< std::vector< double > > v1_TexCoordsList) : IfcPresentationItem(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_TexCoordsList));; populate_derived(); }

// Function implementations for IfcTimePeriod
std::string Ifc4::IfcTimePeriod::StartTime() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcTimePeriod::setStartTime(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
std::string Ifc4::IfcTimePeriod::EndTime() const {  std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcTimePeriod::setEndTime(std::string v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcTimePeriod::declaration() const { return *((IfcParse::entity*)IFC4_types[1080]); }
const IfcParse::entity& Ifc4::IfcTimePeriod::Class() { return *((IfcParse::entity*)IFC4_types[1080]); }
Ifc4::IfcTimePeriod::IfcTimePeriod(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcTimePeriod::IfcTimePeriod(std::string v1_StartTime, std::string v2_EndTime) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_StartTime));set_attribute_value(1, (v2_EndTime));; populate_derived(); }

// Function implementations for IfcTimeSeries
std::string Ifc4::IfcTimeSeries::Name() const {  std::string v = data_.get_attribute_value(0); return v; }
void Ifc4::IfcTimeSeries::setName(std::string v) { set_attribute_value(0, v);if constexpr (false)unset_attribute_value(0); }
boost::optional< std::string > Ifc4::IfcTimeSeries::Description() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcTimeSeries::setDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
std::string Ifc4::IfcTimeSeries::StartTime() const {  std::string v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcTimeSeries::setStartTime(std::string v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }
std::string Ifc4::IfcTimeSeries::EndTime() const {  std::string v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcTimeSeries::setEndTime(std::string v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcTimeSeriesDataTypeEnum::Value Ifc4::IfcTimeSeries::TimeSeriesDataType() const {  return ::Ifc4::IfcTimeSeriesDataTypeEnum::FromString(data_.get_attribute_value(4)); }
void Ifc4::IfcTimeSeries::setTimeSeriesDataType(::Ifc4::IfcTimeSeriesDataTypeEnum::Value v) { set_attribute_value(4, EnumerationReference(&::Ifc4::IfcTimeSeriesDataTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcDataOriginEnum::Value Ifc4::IfcTimeSeries::DataOrigin() const {  return ::Ifc4::IfcDataOriginEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcTimeSeries::setDataOrigin(::Ifc4::IfcDataOriginEnum::Value v) { set_attribute_value(5, EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(5); }
boost::optional< std::string > Ifc4::IfcTimeSeries::UserDefinedDataOrigin() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcTimeSeries::setUserDefinedDataOrigin(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
::Ifc4::IfcUnit* Ifc4::IfcTimeSeries::Unit() const { if(data_.get_attribute_value(7).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(7)))->as<::Ifc4::IfcUnit>(true); }
void Ifc4::IfcTimeSeries::setUnit(::Ifc4::IfcUnit* v) { set_attribute_value(7, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(7); }

::Ifc4::IfcExternalReferenceRelationship::list::ptr Ifc4::IfcTimeSeries::HasExternalReference() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[380], 3)->as<IfcExternalReferenceRelationship>(); }

const IfcParse::entity& Ifc4::IfcTimeSeries::declaration() const { return *((IfcParse::entity*)IFC4_types[1081]); }
const IfcParse::entity& Ifc4::IfcTimeSeries::Class() { return *((IfcParse::entity*)IFC4_types[1081]); }
Ifc4::IfcTimeSeries::IfcTimeSeries(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcTimeSeries::IfcTimeSeries(std::string v1_Name, boost::optional< std::string > v2_Description, std::string v3_StartTime, std::string v4_EndTime, ::Ifc4::IfcTimeSeriesDataTypeEnum::Value v5_TimeSeriesDataType, ::Ifc4::IfcDataOriginEnum::Value v6_DataOrigin, boost::optional< std::string > v7_UserDefinedDataOrigin, ::Ifc4::IfcUnit* v8_Unit) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_Name)); if (v2_Description) {set_attribute_value(1, (*v2_Description)); }set_attribute_value(2, (v3_StartTime));set_attribute_value(3, (v4_EndTime));set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcTimeSeriesDataTypeEnum::Class(),(size_t)v5_TimeSeriesDataType)));set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)v6_DataOrigin))); if (v7_UserDefinedDataOrigin) {set_attribute_value(6, (*v7_UserDefinedDataOrigin)); }set_attribute_value(7, v8_Unit ? v8_Unit->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcTimeSeriesValue
aggregate_of< ::Ifc4::IfcValue >::ptr Ifc4::IfcTimeSeriesValue::ListValues() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcValue >(); }
void Ifc4::IfcTimeSeriesValue::setListValues(aggregate_of< ::Ifc4::IfcValue >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcTimeSeriesValue::declaration() const { return *((IfcParse::entity*)IFC4_types[1083]); }
const IfcParse::entity& Ifc4::IfcTimeSeriesValue::Class() { return *((IfcParse::entity*)IFC4_types[1083]); }
Ifc4::IfcTimeSeriesValue::IfcTimeSeriesValue(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcTimeSeriesValue::IfcTimeSeriesValue(aggregate_of< ::Ifc4::IfcValue >::ptr v1_ListValues) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_ListValues)->generalize());; populate_derived(); }

// Function implementations for IfcTopologicalRepresentationItem


const IfcParse::entity& Ifc4::IfcTopologicalRepresentationItem::declaration() const { return *((IfcParse::entity*)IFC4_types[1085]); }
const IfcParse::entity& Ifc4::IfcTopologicalRepresentationItem::Class() { return *((IfcParse::entity*)IFC4_types[1085]); }
Ifc4::IfcTopologicalRepresentationItem::IfcTopologicalRepresentationItem(IfcEntityInstanceData&& e) : IfcRepresentationItem(std::move(e)) { }
Ifc4::IfcTopologicalRepresentationItem::IfcTopologicalRepresentationItem() : IfcRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcTopologyRepresentation


const IfcParse::entity& Ifc4::IfcTopologyRepresentation::declaration() const { return *((IfcParse::entity*)IFC4_types[1086]); }
const IfcParse::entity& Ifc4::IfcTopologyRepresentation::Class() { return *((IfcParse::entity*)IFC4_types[1086]); }
Ifc4::IfcTopologyRepresentation::IfcTopologyRepresentation(IfcEntityInstanceData&& e) : IfcShapeModel(std::move(e)) { }
Ifc4::IfcTopologyRepresentation::IfcTopologyRepresentation(::Ifc4::IfcRepresentationContext* v1_ContextOfItems, boost::optional< std::string > v2_RepresentationIdentifier, boost::optional< std::string > v3_RepresentationType, aggregate_of< ::Ifc4::IfcRepresentationItem >::ptr v4_Items) : IfcShapeModel(IfcEntityInstanceData(storage_t(4))) { set_attribute_value(0, v1_ContextOfItems ? v1_ContextOfItems->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_RepresentationIdentifier) {set_attribute_value(1, (*v2_RepresentationIdentifier)); } if (v3_RepresentationType) {set_attribute_value(2, (*v3_RepresentationType)); }set_attribute_value(3, (v4_Items)->generalize());; populate_derived(); }

// Function implementations for IfcToroidalSurface
double Ifc4::IfcToroidalSurface::MajorRadius() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcToroidalSurface::setMajorRadius(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }
double Ifc4::IfcToroidalSurface::MinorRadius() const {  double v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcToroidalSurface::setMinorRadius(double v) { set_attribute_value(2, v);if constexpr (false)unset_attribute_value(2); }


const IfcParse::entity& Ifc4::IfcToroidalSurface::declaration() const { return *((IfcParse::entity*)IFC4_types[1087]); }
const IfcParse::entity& Ifc4::IfcToroidalSurface::Class() { return *((IfcParse::entity*)IFC4_types[1087]); }
Ifc4::IfcToroidalSurface::IfcToroidalSurface(IfcEntityInstanceData&& e) : IfcElementarySurface(std::move(e)) { }
Ifc4::IfcToroidalSurface::IfcToroidalSurface(::Ifc4::IfcAxis2Placement3D* v1_Position, double v2_MajorRadius, double v3_MinorRadius) : IfcElementarySurface(IfcEntityInstanceData(storage_t(3))) { set_attribute_value(0, v1_Position ? v1_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_MajorRadius));set_attribute_value(2, (v3_MinorRadius));; populate_derived(); }

// Function implementations for IfcTransformer
boost::optional< ::Ifc4::IfcTransformerTypeEnum::Value > Ifc4::IfcTransformer::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcTransformerTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcTransformer::setPredefinedType(boost::optional< ::Ifc4::IfcTransformerTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcTransformerTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcTransformer::declaration() const { return *((IfcParse::entity*)IFC4_types[1089]); }
const IfcParse::entity& Ifc4::IfcTransformer::Class() { return *((IfcParse::entity*)IFC4_types[1089]); }
Ifc4::IfcTransformer::IfcTransformer(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcTransformer::IfcTransformer(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcTransformerTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcTransformerTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcTransformerType
::Ifc4::IfcTransformerTypeEnum::Value Ifc4::IfcTransformerType::PredefinedType() const {  return ::Ifc4::IfcTransformerTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTransformerType::setPredefinedType(::Ifc4::IfcTransformerTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTransformerTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcTransformerType::declaration() const { return *((IfcParse::entity*)IFC4_types[1090]); }
const IfcParse::entity& Ifc4::IfcTransformerType::Class() { return *((IfcParse::entity*)IFC4_types[1090]); }
Ifc4::IfcTransformerType::IfcTransformerType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcTransformerType::IfcTransformerType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcTransformerTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTransformerTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcTransportElement
boost::optional< ::Ifc4::IfcTransportElementTypeEnum::Value > Ifc4::IfcTransportElement::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcTransportElementTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcTransportElement::setPredefinedType(boost::optional< ::Ifc4::IfcTransportElementTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcTransportElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcTransportElement::declaration() const { return *((IfcParse::entity*)IFC4_types[1094]); }
const IfcParse::entity& Ifc4::IfcTransportElement::Class() { return *((IfcParse::entity*)IFC4_types[1094]); }
Ifc4::IfcTransportElement::IfcTransportElement(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcTransportElement::IfcTransportElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcTransportElementTypeEnum::Value > v9_PredefinedType) : IfcElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcTransportElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcTransportElementType
::Ifc4::IfcTransportElementTypeEnum::Value Ifc4::IfcTransportElementType::PredefinedType() const {  return ::Ifc4::IfcTransportElementTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTransportElementType::setPredefinedType(::Ifc4::IfcTransportElementTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTransportElementTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcTransportElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[1095]); }
const IfcParse::entity& Ifc4::IfcTransportElementType::Class() { return *((IfcParse::entity*)IFC4_types[1095]); }
Ifc4::IfcTransportElementType::IfcTransportElementType(IfcEntityInstanceData&& e) : IfcElementType(std::move(e)) { }
Ifc4::IfcTransportElementType::IfcTransportElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcTransportElementTypeEnum::Value v10_PredefinedType) : IfcElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTransportElementTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcTrapeziumProfileDef
double Ifc4::IfcTrapeziumProfileDef::BottomXDim() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcTrapeziumProfileDef::setBottomXDim(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcTrapeziumProfileDef::TopXDim() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTrapeziumProfileDef::setTopXDim(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
double Ifc4::IfcTrapeziumProfileDef::YDim() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcTrapeziumProfileDef::setYDim(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcTrapeziumProfileDef::TopXOffset() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcTrapeziumProfileDef::setTopXOffset(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }


const IfcParse::entity& Ifc4::IfcTrapeziumProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[1097]); }
const IfcParse::entity& Ifc4::IfcTrapeziumProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[1097]); }
Ifc4::IfcTrapeziumProfileDef::IfcTrapeziumProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcTrapeziumProfileDef::IfcTrapeziumProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_BottomXDim, double v5_TopXDim, double v6_YDim, double v7_TopXOffset) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(7))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_BottomXDim));set_attribute_value(4, (v5_TopXDim));set_attribute_value(5, (v6_YDim));set_attribute_value(6, (v7_TopXOffset));; populate_derived(); }

// Function implementations for IfcTriangulatedFaceSet
boost::optional< std::vector< std::vector< double > > > Ifc4::IfcTriangulatedFaceSet::Normals() const { if(data_.get_attribute_value(1).isNull()) { return boost::none; } std::vector< std::vector< double > > v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcTriangulatedFaceSet::setNormals(boost::optional< std::vector< std::vector< double > > > v) { if (v) {set_attribute_value(1, *v);} else {unset_attribute_value(1);} }
boost::optional< bool > Ifc4::IfcTriangulatedFaceSet::Closed() const { if(data_.get_attribute_value(2).isNull()) { return boost::none; } bool v = data_.get_attribute_value(2); return v; }
void Ifc4::IfcTriangulatedFaceSet::setClosed(boost::optional< bool > v) { if (v) {set_attribute_value(2, *v);} else {unset_attribute_value(2);} }
std::vector< std::vector< int > > Ifc4::IfcTriangulatedFaceSet::CoordIndex() const {  std::vector< std::vector< int > > v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcTriangulatedFaceSet::setCoordIndex(std::vector< std::vector< int > > v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
boost::optional< std::vector< int > /*[1:?]*/ > Ifc4::IfcTriangulatedFaceSet::PnIndex() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::vector< int > /*[1:?]*/ v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTriangulatedFaceSet::setPnIndex(boost::optional< std::vector< int > /*[1:?]*/ > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }


const IfcParse::entity& Ifc4::IfcTriangulatedFaceSet::declaration() const { return *((IfcParse::entity*)IFC4_types[1098]); }
const IfcParse::entity& Ifc4::IfcTriangulatedFaceSet::Class() { return *((IfcParse::entity*)IFC4_types[1098]); }
Ifc4::IfcTriangulatedFaceSet::IfcTriangulatedFaceSet(IfcEntityInstanceData&& e) : IfcTessellatedFaceSet(std::move(e)) { }
Ifc4::IfcTriangulatedFaceSet::IfcTriangulatedFaceSet(::Ifc4::IfcCartesianPointList3D* v1_Coordinates, boost::optional< std::vector< std::vector< double > > > v2_Normals, boost::optional< bool > v3_Closed, std::vector< std::vector< int > > v4_CoordIndex, boost::optional< std::vector< int > /*[1:?]*/ > v5_PnIndex) : IfcTessellatedFaceSet(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_Coordinates ? v1_Coordinates->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v2_Normals) {set_attribute_value(1, (*v2_Normals)); } if (v3_Closed) {set_attribute_value(2, (*v3_Closed)); }set_attribute_value(3, (v4_CoordIndex)); if (v5_PnIndex) {set_attribute_value(4, (*v5_PnIndex)); }; populate_derived(); }

// Function implementations for IfcTrimmedCurve
::Ifc4::IfcCurve* Ifc4::IfcTrimmedCurve::BasisCurve() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcCurve>(true); }
void Ifc4::IfcTrimmedCurve::setBasisCurve(::Ifc4::IfcCurve* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
aggregate_of< ::Ifc4::IfcTrimmingSelect >::ptr Ifc4::IfcTrimmedCurve::Trim1() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(1); return es->as< ::Ifc4::IfcTrimmingSelect >(); }
void Ifc4::IfcTrimmedCurve::setTrim1(aggregate_of< ::Ifc4::IfcTrimmingSelect >::ptr v) { set_attribute_value(1, (v)->generalize());if constexpr (false)unset_attribute_value(1); }
aggregate_of< ::Ifc4::IfcTrimmingSelect >::ptr Ifc4::IfcTrimmedCurve::Trim2() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(2); return es->as< ::Ifc4::IfcTrimmingSelect >(); }
void Ifc4::IfcTrimmedCurve::setTrim2(aggregate_of< ::Ifc4::IfcTrimmingSelect >::ptr v) { set_attribute_value(2, (v)->generalize());if constexpr (false)unset_attribute_value(2); }
bool Ifc4::IfcTrimmedCurve::SenseAgreement() const {  bool v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcTrimmedCurve::setSenseAgreement(bool v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
::Ifc4::IfcTrimmingPreference::Value Ifc4::IfcTrimmedCurve::MasterRepresentation() const {  return ::Ifc4::IfcTrimmingPreference::FromString(data_.get_attribute_value(4)); }
void Ifc4::IfcTrimmedCurve::setMasterRepresentation(::Ifc4::IfcTrimmingPreference::Value v) { set_attribute_value(4, EnumerationReference(&::Ifc4::IfcTrimmingPreference::Class(), (size_t) v));if constexpr (false)unset_attribute_value(4); }


const IfcParse::entity& Ifc4::IfcTrimmedCurve::declaration() const { return *((IfcParse::entity*)IFC4_types[1099]); }
const IfcParse::entity& Ifc4::IfcTrimmedCurve::Class() { return *((IfcParse::entity*)IFC4_types[1099]); }
Ifc4::IfcTrimmedCurve::IfcTrimmedCurve(IfcEntityInstanceData&& e) : IfcBoundedCurve(std::move(e)) { }
Ifc4::IfcTrimmedCurve::IfcTrimmedCurve(::Ifc4::IfcCurve* v1_BasisCurve, aggregate_of< ::Ifc4::IfcTrimmingSelect >::ptr v2_Trim1, aggregate_of< ::Ifc4::IfcTrimmingSelect >::ptr v3_Trim2, bool v4_SenseAgreement, ::Ifc4::IfcTrimmingPreference::Value v5_MasterRepresentation) : IfcBoundedCurve(IfcEntityInstanceData(storage_t(5))) { set_attribute_value(0, v1_BasisCurve ? v1_BasisCurve->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Trim1)->generalize());set_attribute_value(2, (v3_Trim2)->generalize());set_attribute_value(3, (v4_SenseAgreement));set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcTrimmingPreference::Class(),(size_t)v5_MasterRepresentation)));; populate_derived(); }

// Function implementations for IfcTubeBundle
boost::optional< ::Ifc4::IfcTubeBundleTypeEnum::Value > Ifc4::IfcTubeBundle::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcTubeBundleTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcTubeBundle::setPredefinedType(boost::optional< ::Ifc4::IfcTubeBundleTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcTubeBundleTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcTubeBundle::declaration() const { return *((IfcParse::entity*)IFC4_types[1103]); }
const IfcParse::entity& Ifc4::IfcTubeBundle::Class() { return *((IfcParse::entity*)IFC4_types[1103]); }
Ifc4::IfcTubeBundle::IfcTubeBundle(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcTubeBundle::IfcTubeBundle(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcTubeBundleTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcTubeBundleTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcTubeBundleType
::Ifc4::IfcTubeBundleTypeEnum::Value Ifc4::IfcTubeBundleType::PredefinedType() const {  return ::Ifc4::IfcTubeBundleTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcTubeBundleType::setPredefinedType(::Ifc4::IfcTubeBundleTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcTubeBundleTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcTubeBundleType::declaration() const { return *((IfcParse::entity*)IFC4_types[1104]); }
const IfcParse::entity& Ifc4::IfcTubeBundleType::Class() { return *((IfcParse::entity*)IFC4_types[1104]); }
Ifc4::IfcTubeBundleType::IfcTubeBundleType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcTubeBundleType::IfcTubeBundleType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcTubeBundleTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcTubeBundleTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcTypeObject
boost::optional< std::string > Ifc4::IfcTypeObject::ApplicableOccurrence() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcTypeObject::setApplicableOccurrence(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > Ifc4::IfcTypeObject::HasPropertySets() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(5); return es->as< ::Ifc4::IfcPropertySetDefinition >(); }
void Ifc4::IfcTypeObject::setHasPropertySets(boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v) { if (v) {set_attribute_value(5, (*v)->generalize());} else {unset_attribute_value(5);} }

::Ifc4::IfcRelDefinesByType::list::ptr Ifc4::IfcTypeObject::Types() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[832], 5)->as<IfcRelDefinesByType>(); }

const IfcParse::entity& Ifc4::IfcTypeObject::declaration() const { return *((IfcParse::entity*)IFC4_types[1106]); }
const IfcParse::entity& Ifc4::IfcTypeObject::Class() { return *((IfcParse::entity*)IFC4_types[1106]); }
Ifc4::IfcTypeObject::IfcTypeObject(IfcEntityInstanceData&& e) : IfcObjectDefinition(std::move(e)) { }
Ifc4::IfcTypeObject::IfcTypeObject(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets) : IfcObjectDefinition(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); }; populate_derived(); }

// Function implementations for IfcTypeProcess
boost::optional< std::string > Ifc4::IfcTypeProcess::Identification() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcTypeProcess::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcTypeProcess::LongDescription() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcTypeProcess::setLongDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcTypeProcess::ProcessType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcTypeProcess::setProcessType(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }

::Ifc4::IfcRelAssignsToProcess::list::ptr Ifc4::IfcTypeProcess::OperatesOn() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[803], 6)->as<IfcRelAssignsToProcess>(); }

const IfcParse::entity& Ifc4::IfcTypeProcess::declaration() const { return *((IfcParse::entity*)IFC4_types[1107]); }
const IfcParse::entity& Ifc4::IfcTypeProcess::Class() { return *((IfcParse::entity*)IFC4_types[1107]); }
Ifc4::IfcTypeProcess::IfcTypeProcess(IfcEntityInstanceData&& e) : IfcTypeObject(std::move(e)) { }
Ifc4::IfcTypeProcess::IfcTypeProcess(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ProcessType) : IfcTypeObject(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ProcessType) {set_attribute_value(8, (*v9_ProcessType)); }; populate_derived(); }

// Function implementations for IfcTypeProduct
boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > Ifc4::IfcTypeProduct::RepresentationMaps() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(6); return es->as< ::Ifc4::IfcRepresentationMap >(); }
void Ifc4::IfcTypeProduct::setRepresentationMaps(boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v) { if (v) {set_attribute_value(6, (*v)->generalize());} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcTypeProduct::Tag() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcTypeProduct::setTag(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }

::Ifc4::IfcRelAssignsToProduct::list::ptr Ifc4::IfcTypeProduct::ReferencedBy() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[804], 6)->as<IfcRelAssignsToProduct>(); }

const IfcParse::entity& Ifc4::IfcTypeProduct::declaration() const { return *((IfcParse::entity*)IFC4_types[1108]); }
const IfcParse::entity& Ifc4::IfcTypeProduct::Class() { return *((IfcParse::entity*)IFC4_types[1108]); }
Ifc4::IfcTypeProduct::IfcTypeProduct(IfcEntityInstanceData&& e) : IfcTypeObject(std::move(e)) { }
Ifc4::IfcTypeProduct::IfcTypeProduct(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag) : IfcTypeObject(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcTypeResource
boost::optional< std::string > Ifc4::IfcTypeResource::Identification() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcTypeResource::setIdentification(boost::optional< std::string > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< std::string > Ifc4::IfcTypeResource::LongDescription() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcTypeResource::setLongDescription(boost::optional< std::string > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcTypeResource::ResourceType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcTypeResource::setResourceType(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }

::Ifc4::IfcRelAssignsToResource::list::ptr Ifc4::IfcTypeResource::ResourceOf() const { if (!file_) { return nullptr; } return file_->getInverse(id_, IFC4_types[805], 6)->as<IfcRelAssignsToResource>(); }

const IfcParse::entity& Ifc4::IfcTypeResource::declaration() const { return *((IfcParse::entity*)IFC4_types[1109]); }
const IfcParse::entity& Ifc4::IfcTypeResource::Class() { return *((IfcParse::entity*)IFC4_types[1109]); }
Ifc4::IfcTypeResource::IfcTypeResource(IfcEntityInstanceData&& e) : IfcTypeObject(std::move(e)) { }
Ifc4::IfcTypeResource::IfcTypeResource(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< std::string > v7_Identification, boost::optional< std::string > v8_LongDescription, boost::optional< std::string > v9_ResourceType) : IfcTypeObject(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_Identification) {set_attribute_value(6, (*v7_Identification)); } if (v8_LongDescription) {set_attribute_value(7, (*v8_LongDescription)); } if (v9_ResourceType) {set_attribute_value(8, (*v9_ResourceType)); }; populate_derived(); }

// Function implementations for IfcUShapeProfileDef
double Ifc4::IfcUShapeProfileDef::Depth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcUShapeProfileDef::setDepth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcUShapeProfileDef::FlangeWidth() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcUShapeProfileDef::setFlangeWidth(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
double Ifc4::IfcUShapeProfileDef::WebThickness() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcUShapeProfileDef::setWebThickness(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcUShapeProfileDef::FlangeThickness() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcUShapeProfileDef::setFlangeThickness(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
boost::optional< double > Ifc4::IfcUShapeProfileDef::FilletRadius() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcUShapeProfileDef::setFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< double > Ifc4::IfcUShapeProfileDef::EdgeRadius() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcUShapeProfileDef::setEdgeRadius(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< double > Ifc4::IfcUShapeProfileDef::FlangeSlope() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcUShapeProfileDef::setFlangeSlope(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }


const IfcParse::entity& Ifc4::IfcUShapeProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[1120]); }
const IfcParse::entity& Ifc4::IfcUShapeProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[1120]); }
Ifc4::IfcUShapeProfileDef::IfcUShapeProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcUShapeProfileDef::IfcUShapeProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_Depth, double v5_FlangeWidth, double v6_WebThickness, double v7_FlangeThickness, boost::optional< double > v8_FilletRadius, boost::optional< double > v9_EdgeRadius, boost::optional< double > v10_FlangeSlope) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Depth));set_attribute_value(4, (v5_FlangeWidth));set_attribute_value(5, (v6_WebThickness));set_attribute_value(6, (v7_FlangeThickness)); if (v8_FilletRadius) {set_attribute_value(7, (*v8_FilletRadius)); } if (v9_EdgeRadius) {set_attribute_value(8, (*v9_EdgeRadius)); } if (v10_FlangeSlope) {set_attribute_value(9, (*v10_FlangeSlope)); }; populate_derived(); }

// Function implementations for IfcUnitAssignment
aggregate_of< ::Ifc4::IfcUnit >::ptr Ifc4::IfcUnitAssignment::Units() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcUnit >(); }
void Ifc4::IfcUnitAssignment::setUnits(aggregate_of< ::Ifc4::IfcUnit >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcUnitAssignment::declaration() const { return *((IfcParse::entity*)IFC4_types[1117]); }
const IfcParse::entity& Ifc4::IfcUnitAssignment::Class() { return *((IfcParse::entity*)IFC4_types[1117]); }
Ifc4::IfcUnitAssignment::IfcUnitAssignment(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcUnitAssignment::IfcUnitAssignment(aggregate_of< ::Ifc4::IfcUnit >::ptr v1_Units) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, (v1_Units)->generalize());; populate_derived(); }

// Function implementations for IfcUnitaryControlElement
boost::optional< ::Ifc4::IfcUnitaryControlElementTypeEnum::Value > Ifc4::IfcUnitaryControlElement::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcUnitaryControlElementTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcUnitaryControlElement::setPredefinedType(boost::optional< ::Ifc4::IfcUnitaryControlElementTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcUnitaryControlElementTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcUnitaryControlElement::declaration() const { return *((IfcParse::entity*)IFC4_types[1111]); }
const IfcParse::entity& Ifc4::IfcUnitaryControlElement::Class() { return *((IfcParse::entity*)IFC4_types[1111]); }
Ifc4::IfcUnitaryControlElement::IfcUnitaryControlElement(IfcEntityInstanceData&& e) : IfcDistributionControlElement(std::move(e)) { }
Ifc4::IfcUnitaryControlElement::IfcUnitaryControlElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcUnitaryControlElementTypeEnum::Value > v9_PredefinedType) : IfcDistributionControlElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcUnitaryControlElementTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcUnitaryControlElementType
::Ifc4::IfcUnitaryControlElementTypeEnum::Value Ifc4::IfcUnitaryControlElementType::PredefinedType() const {  return ::Ifc4::IfcUnitaryControlElementTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcUnitaryControlElementType::setPredefinedType(::Ifc4::IfcUnitaryControlElementTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcUnitaryControlElementTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcUnitaryControlElementType::declaration() const { return *((IfcParse::entity*)IFC4_types[1112]); }
const IfcParse::entity& Ifc4::IfcUnitaryControlElementType::Class() { return *((IfcParse::entity*)IFC4_types[1112]); }
Ifc4::IfcUnitaryControlElementType::IfcUnitaryControlElementType(IfcEntityInstanceData&& e) : IfcDistributionControlElementType(std::move(e)) { }
Ifc4::IfcUnitaryControlElementType::IfcUnitaryControlElementType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcUnitaryControlElementTypeEnum::Value v10_PredefinedType) : IfcDistributionControlElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcUnitaryControlElementTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcUnitaryEquipment
boost::optional< ::Ifc4::IfcUnitaryEquipmentTypeEnum::Value > Ifc4::IfcUnitaryEquipment::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcUnitaryEquipmentTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcUnitaryEquipment::setPredefinedType(boost::optional< ::Ifc4::IfcUnitaryEquipmentTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcUnitaryEquipmentTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcUnitaryEquipment::declaration() const { return *((IfcParse::entity*)IFC4_types[1114]); }
const IfcParse::entity& Ifc4::IfcUnitaryEquipment::Class() { return *((IfcParse::entity*)IFC4_types[1114]); }
Ifc4::IfcUnitaryEquipment::IfcUnitaryEquipment(IfcEntityInstanceData&& e) : IfcEnergyConversionDevice(std::move(e)) { }
Ifc4::IfcUnitaryEquipment::IfcUnitaryEquipment(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcUnitaryEquipmentTypeEnum::Value > v9_PredefinedType) : IfcEnergyConversionDevice(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcUnitaryEquipmentTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcUnitaryEquipmentType
::Ifc4::IfcUnitaryEquipmentTypeEnum::Value Ifc4::IfcUnitaryEquipmentType::PredefinedType() const {  return ::Ifc4::IfcUnitaryEquipmentTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcUnitaryEquipmentType::setPredefinedType(::Ifc4::IfcUnitaryEquipmentTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcUnitaryEquipmentTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcUnitaryEquipmentType::declaration() const { return *((IfcParse::entity*)IFC4_types[1115]); }
const IfcParse::entity& Ifc4::IfcUnitaryEquipmentType::Class() { return *((IfcParse::entity*)IFC4_types[1115]); }
Ifc4::IfcUnitaryEquipmentType::IfcUnitaryEquipmentType(IfcEntityInstanceData&& e) : IfcEnergyConversionDeviceType(std::move(e)) { }
Ifc4::IfcUnitaryEquipmentType::IfcUnitaryEquipmentType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcUnitaryEquipmentTypeEnum::Value v10_PredefinedType) : IfcEnergyConversionDeviceType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcUnitaryEquipmentTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcValve
boost::optional< ::Ifc4::IfcValveTypeEnum::Value > Ifc4::IfcValve::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcValveTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcValve::setPredefinedType(boost::optional< ::Ifc4::IfcValveTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcValveTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcValve::declaration() const { return *((IfcParse::entity*)IFC4_types[1122]); }
const IfcParse::entity& Ifc4::IfcValve::Class() { return *((IfcParse::entity*)IFC4_types[1122]); }
Ifc4::IfcValve::IfcValve(IfcEntityInstanceData&& e) : IfcFlowController(std::move(e)) { }
Ifc4::IfcValve::IfcValve(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcValveTypeEnum::Value > v9_PredefinedType) : IfcFlowController(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcValveTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcValveType
::Ifc4::IfcValveTypeEnum::Value Ifc4::IfcValveType::PredefinedType() const {  return ::Ifc4::IfcValveTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcValveType::setPredefinedType(::Ifc4::IfcValveTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcValveTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcValveType::declaration() const { return *((IfcParse::entity*)IFC4_types[1123]); }
const IfcParse::entity& Ifc4::IfcValveType::Class() { return *((IfcParse::entity*)IFC4_types[1123]); }
Ifc4::IfcValveType::IfcValveType(IfcEntityInstanceData&& e) : IfcFlowControllerType(std::move(e)) { }
Ifc4::IfcValveType::IfcValveType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcValveTypeEnum::Value v10_PredefinedType) : IfcFlowControllerType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcValveTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcVector
::Ifc4::IfcDirection* Ifc4::IfcVector::Orientation() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcDirection>(true); }
void Ifc4::IfcVector::setOrientation(::Ifc4::IfcDirection* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }
double Ifc4::IfcVector::Magnitude() const {  double v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcVector::setMagnitude(double v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcVector::declaration() const { return *((IfcParse::entity*)IFC4_types[1126]); }
const IfcParse::entity& Ifc4::IfcVector::Class() { return *((IfcParse::entity*)IFC4_types[1126]); }
Ifc4::IfcVector::IfcVector(IfcEntityInstanceData&& e) : IfcGeometricRepresentationItem(std::move(e)) { }
Ifc4::IfcVector::IfcVector(::Ifc4::IfcDirection* v1_Orientation, double v2_Magnitude) : IfcGeometricRepresentationItem(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, v1_Orientation ? v1_Orientation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(1, (v2_Magnitude));; populate_derived(); }

// Function implementations for IfcVertex


const IfcParse::entity& Ifc4::IfcVertex::declaration() const { return *((IfcParse::entity*)IFC4_types[1128]); }
const IfcParse::entity& Ifc4::IfcVertex::Class() { return *((IfcParse::entity*)IFC4_types[1128]); }
Ifc4::IfcVertex::IfcVertex(IfcEntityInstanceData&& e) : IfcTopologicalRepresentationItem(std::move(e)) { }
Ifc4::IfcVertex::IfcVertex() : IfcTopologicalRepresentationItem(IfcEntityInstanceData(storage_t(0))) { ; populate_derived(); }

// Function implementations for IfcVertexLoop
::Ifc4::IfcVertex* Ifc4::IfcVertexLoop::LoopVertex() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcVertex>(true); }
void Ifc4::IfcVertexLoop::setLoopVertex(::Ifc4::IfcVertex* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcVertexLoop::declaration() const { return *((IfcParse::entity*)IFC4_types[1129]); }
const IfcParse::entity& Ifc4::IfcVertexLoop::Class() { return *((IfcParse::entity*)IFC4_types[1129]); }
Ifc4::IfcVertexLoop::IfcVertexLoop(IfcEntityInstanceData&& e) : IfcLoop(std::move(e)) { }
Ifc4::IfcVertexLoop::IfcVertexLoop(::Ifc4::IfcVertex* v1_LoopVertex) : IfcLoop(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_LoopVertex ? v1_LoopVertex->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcVertexPoint
::Ifc4::IfcPoint* Ifc4::IfcVertexPoint::VertexGeometry() const {  return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(0)))->as<::Ifc4::IfcPoint>(true); }
void Ifc4::IfcVertexPoint::setVertexGeometry(::Ifc4::IfcPoint* v) { set_attribute_value(0, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(0); }


const IfcParse::entity& Ifc4::IfcVertexPoint::declaration() const { return *((IfcParse::entity*)IFC4_types[1130]); }
const IfcParse::entity& Ifc4::IfcVertexPoint::Class() { return *((IfcParse::entity*)IFC4_types[1130]); }
Ifc4::IfcVertexPoint::IfcVertexPoint(IfcEntityInstanceData&& e) : IfcVertex(std::move(e)) { }
Ifc4::IfcVertexPoint::IfcVertexPoint(::Ifc4::IfcPoint* v1_VertexGeometry) : IfcVertex(IfcEntityInstanceData(storage_t(1))) { set_attribute_value(0, v1_VertexGeometry ? v1_VertexGeometry->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcVibrationIsolator
boost::optional< ::Ifc4::IfcVibrationIsolatorTypeEnum::Value > Ifc4::IfcVibrationIsolator::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcVibrationIsolatorTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcVibrationIsolator::setPredefinedType(boost::optional< ::Ifc4::IfcVibrationIsolatorTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcVibrationIsolatorTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcVibrationIsolator::declaration() const { return *((IfcParse::entity*)IFC4_types[1131]); }
const IfcParse::entity& Ifc4::IfcVibrationIsolator::Class() { return *((IfcParse::entity*)IFC4_types[1131]); }
Ifc4::IfcVibrationIsolator::IfcVibrationIsolator(IfcEntityInstanceData&& e) : IfcElementComponent(std::move(e)) { }
Ifc4::IfcVibrationIsolator::IfcVibrationIsolator(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcVibrationIsolatorTypeEnum::Value > v9_PredefinedType) : IfcElementComponent(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcVibrationIsolatorTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcVibrationIsolatorType
::Ifc4::IfcVibrationIsolatorTypeEnum::Value Ifc4::IfcVibrationIsolatorType::PredefinedType() const {  return ::Ifc4::IfcVibrationIsolatorTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcVibrationIsolatorType::setPredefinedType(::Ifc4::IfcVibrationIsolatorTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcVibrationIsolatorTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcVibrationIsolatorType::declaration() const { return *((IfcParse::entity*)IFC4_types[1132]); }
const IfcParse::entity& Ifc4::IfcVibrationIsolatorType::Class() { return *((IfcParse::entity*)IFC4_types[1132]); }
Ifc4::IfcVibrationIsolatorType::IfcVibrationIsolatorType(IfcEntityInstanceData&& e) : IfcElementComponentType(std::move(e)) { }
Ifc4::IfcVibrationIsolatorType::IfcVibrationIsolatorType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcVibrationIsolatorTypeEnum::Value v10_PredefinedType) : IfcElementComponentType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcVibrationIsolatorTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcVirtualElement


const IfcParse::entity& Ifc4::IfcVirtualElement::declaration() const { return *((IfcParse::entity*)IFC4_types[1134]); }
const IfcParse::entity& Ifc4::IfcVirtualElement::Class() { return *((IfcParse::entity*)IFC4_types[1134]); }
Ifc4::IfcVirtualElement::IfcVirtualElement(IfcEntityInstanceData&& e) : IfcElement(std::move(e)) { }
Ifc4::IfcVirtualElement::IfcVirtualElement(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag) : IfcElement(IfcEntityInstanceData(storage_t(8))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }; populate_derived(); }

// Function implementations for IfcVirtualGridIntersection
aggregate_of< ::Ifc4::IfcGridAxis >::ptr Ifc4::IfcVirtualGridIntersection::IntersectingAxes() const {  aggregate_of_instance::ptr es = data_.get_attribute_value(0); return es->as< ::Ifc4::IfcGridAxis >(); }
void Ifc4::IfcVirtualGridIntersection::setIntersectingAxes(aggregate_of< ::Ifc4::IfcGridAxis >::ptr v) { set_attribute_value(0, (v)->generalize());if constexpr (false)unset_attribute_value(0); }
std::vector< double > /*[2:3]*/ Ifc4::IfcVirtualGridIntersection::OffsetDistances() const {  std::vector< double > /*[2:3]*/ v = data_.get_attribute_value(1); return v; }
void Ifc4::IfcVirtualGridIntersection::setOffsetDistances(std::vector< double > /*[2:3]*/ v) { set_attribute_value(1, v);if constexpr (false)unset_attribute_value(1); }


const IfcParse::entity& Ifc4::IfcVirtualGridIntersection::declaration() const { return *((IfcParse::entity*)IFC4_types[1135]); }
const IfcParse::entity& Ifc4::IfcVirtualGridIntersection::Class() { return *((IfcParse::entity*)IFC4_types[1135]); }
Ifc4::IfcVirtualGridIntersection::IfcVirtualGridIntersection(IfcEntityInstanceData&& e) : IfcUtil::IfcBaseEntity(std::move(e)) { }
Ifc4::IfcVirtualGridIntersection::IfcVirtualGridIntersection(aggregate_of< ::Ifc4::IfcGridAxis >::ptr v1_IntersectingAxes, std::vector< double > /*[2:3]*/ v2_OffsetDistances) : IfcUtil::IfcBaseEntity(IfcEntityInstanceData(storage_t(2))) { set_attribute_value(0, (v1_IntersectingAxes)->generalize());set_attribute_value(1, (v2_OffsetDistances));; populate_derived(); }

// Function implementations for IfcVoidingFeature
boost::optional< ::Ifc4::IfcVoidingFeatureTypeEnum::Value > Ifc4::IfcVoidingFeature::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcVoidingFeatureTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcVoidingFeature::setPredefinedType(boost::optional< ::Ifc4::IfcVoidingFeatureTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcVoidingFeatureTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcVoidingFeature::declaration() const { return *((IfcParse::entity*)IFC4_types[1136]); }
const IfcParse::entity& Ifc4::IfcVoidingFeature::Class() { return *((IfcParse::entity*)IFC4_types[1136]); }
Ifc4::IfcVoidingFeature::IfcVoidingFeature(IfcEntityInstanceData&& e) : IfcFeatureElementSubtraction(std::move(e)) { }
Ifc4::IfcVoidingFeature::IfcVoidingFeature(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcVoidingFeatureTypeEnum::Value > v9_PredefinedType) : IfcFeatureElementSubtraction(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcVoidingFeatureTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcWall
boost::optional< ::Ifc4::IfcWallTypeEnum::Value > Ifc4::IfcWall::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcWallTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcWall::setPredefinedType(boost::optional< ::Ifc4::IfcWallTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcWallTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcWall::declaration() const { return *((IfcParse::entity*)IFC4_types[1140]); }
const IfcParse::entity& Ifc4::IfcWall::Class() { return *((IfcParse::entity*)IFC4_types[1140]); }
Ifc4::IfcWall::IfcWall(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcWall::IfcWall(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcWallTypeEnum::Value > v9_PredefinedType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcWallTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcWallElementedCase


const IfcParse::entity& Ifc4::IfcWallElementedCase::declaration() const { return *((IfcParse::entity*)IFC4_types[1141]); }
const IfcParse::entity& Ifc4::IfcWallElementedCase::Class() { return *((IfcParse::entity*)IFC4_types[1141]); }
Ifc4::IfcWallElementedCase::IfcWallElementedCase(IfcEntityInstanceData&& e) : IfcWall(std::move(e)) { }
Ifc4::IfcWallElementedCase::IfcWallElementedCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcWallTypeEnum::Value > v9_PredefinedType) : IfcWall(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcWallTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcWallStandardCase


const IfcParse::entity& Ifc4::IfcWallStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[1142]); }
const IfcParse::entity& Ifc4::IfcWallStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[1142]); }
Ifc4::IfcWallStandardCase::IfcWallStandardCase(IfcEntityInstanceData&& e) : IfcWall(std::move(e)) { }
Ifc4::IfcWallStandardCase::IfcWallStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcWallTypeEnum::Value > v9_PredefinedType) : IfcWall(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcWallTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcWallType
::Ifc4::IfcWallTypeEnum::Value Ifc4::IfcWallType::PredefinedType() const {  return ::Ifc4::IfcWallTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcWallType::setPredefinedType(::Ifc4::IfcWallTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcWallTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcWallType::declaration() const { return *((IfcParse::entity*)IFC4_types[1143]); }
const IfcParse::entity& Ifc4::IfcWallType::Class() { return *((IfcParse::entity*)IFC4_types[1143]); }
Ifc4::IfcWallType::IfcWallType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcWallType::IfcWallType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcWallTypeEnum::Value v10_PredefinedType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcWallTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcWasteTerminal
boost::optional< ::Ifc4::IfcWasteTerminalTypeEnum::Value > Ifc4::IfcWasteTerminal::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcWasteTerminalTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcWasteTerminal::setPredefinedType(boost::optional< ::Ifc4::IfcWasteTerminalTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcWasteTerminalTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcWasteTerminal::declaration() const { return *((IfcParse::entity*)IFC4_types[1148]); }
const IfcParse::entity& Ifc4::IfcWasteTerminal::Class() { return *((IfcParse::entity*)IFC4_types[1148]); }
Ifc4::IfcWasteTerminal::IfcWasteTerminal(IfcEntityInstanceData&& e) : IfcFlowTerminal(std::move(e)) { }
Ifc4::IfcWasteTerminal::IfcWasteTerminal(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< ::Ifc4::IfcWasteTerminalTypeEnum::Value > v9_PredefinedType) : IfcFlowTerminal(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcWasteTerminalTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcWasteTerminalType
::Ifc4::IfcWasteTerminalTypeEnum::Value Ifc4::IfcWasteTerminalType::PredefinedType() const {  return ::Ifc4::IfcWasteTerminalTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcWasteTerminalType::setPredefinedType(::Ifc4::IfcWasteTerminalTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcWasteTerminalTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }


const IfcParse::entity& Ifc4::IfcWasteTerminalType::declaration() const { return *((IfcParse::entity*)IFC4_types[1149]); }
const IfcParse::entity& Ifc4::IfcWasteTerminalType::Class() { return *((IfcParse::entity*)IFC4_types[1149]); }
Ifc4::IfcWasteTerminalType::IfcWasteTerminalType(IfcEntityInstanceData&& e) : IfcFlowTerminalType(std::move(e)) { }
Ifc4::IfcWasteTerminalType::IfcWasteTerminalType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcWasteTerminalTypeEnum::Value v10_PredefinedType) : IfcFlowTerminalType(IfcEntityInstanceData(storage_t(10))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcWasteTerminalTypeEnum::Class(),(size_t)v10_PredefinedType)));; populate_derived(); }

// Function implementations for IfcWindow
boost::optional< double > Ifc4::IfcWindow::OverallHeight() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcWindow::setOverallHeight(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< double > Ifc4::IfcWindow::OverallWidth() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcWindow::setOverallWidth(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< ::Ifc4::IfcWindowTypeEnum::Value > Ifc4::IfcWindow::PredefinedType() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } return ::Ifc4::IfcWindowTypeEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcWindow::setPredefinedType(boost::optional< ::Ifc4::IfcWindowTypeEnum::Value > v) { if (v) {set_attribute_value(10, EnumerationReference(&::Ifc4::IfcWindowTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(10);} }
boost::optional< ::Ifc4::IfcWindowTypePartitioningEnum::Value > Ifc4::IfcWindow::PartitioningType() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } return ::Ifc4::IfcWindowTypePartitioningEnum::FromString(data_.get_attribute_value(11)); }
void Ifc4::IfcWindow::setPartitioningType(boost::optional< ::Ifc4::IfcWindowTypePartitioningEnum::Value > v) { if (v) {set_attribute_value(11, EnumerationReference(&::Ifc4::IfcWindowTypePartitioningEnum::Class(), (size_t) *v));} else {unset_attribute_value(11);} }
boost::optional< std::string > Ifc4::IfcWindow::UserDefinedPartitioningType() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcWindow::setUserDefinedPartitioningType(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }


const IfcParse::entity& Ifc4::IfcWindow::declaration() const { return *((IfcParse::entity*)IFC4_types[1151]); }
const IfcParse::entity& Ifc4::IfcWindow::Class() { return *((IfcParse::entity*)IFC4_types[1151]); }
Ifc4::IfcWindow::IfcWindow(IfcEntityInstanceData&& e) : IfcBuildingElement(std::move(e)) { }
Ifc4::IfcWindow::IfcWindow(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< double > v9_OverallHeight, boost::optional< double > v10_OverallWidth, boost::optional< ::Ifc4::IfcWindowTypeEnum::Value > v11_PredefinedType, boost::optional< ::Ifc4::IfcWindowTypePartitioningEnum::Value > v12_PartitioningType, boost::optional< std::string > v13_UserDefinedPartitioningType) : IfcBuildingElement(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_OverallHeight) {set_attribute_value(8, (*v9_OverallHeight)); } if (v10_OverallWidth) {set_attribute_value(9, (*v10_OverallWidth)); } if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcWindowTypeEnum::Class(),(size_t)*v11_PredefinedType))); } if (v12_PartitioningType) {set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcWindowTypePartitioningEnum::Class(),(size_t)*v12_PartitioningType))); } if (v13_UserDefinedPartitioningType) {set_attribute_value(12, (*v13_UserDefinedPartitioningType)); }; populate_derived(); }

// Function implementations for IfcWindowLiningProperties
boost::optional< double > Ifc4::IfcWindowLiningProperties::LiningDepth() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcWindowLiningProperties::setLiningDepth(boost::optional< double > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::LiningThickness() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcWindowLiningProperties::setLiningThickness(boost::optional< double > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::TransomThickness() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcWindowLiningProperties::setTransomThickness(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::MullionThickness() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcWindowLiningProperties::setMullionThickness(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::FirstTransomOffset() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcWindowLiningProperties::setFirstTransomOffset(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::SecondTransomOffset() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } double v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcWindowLiningProperties::setSecondTransomOffset(boost::optional< double > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::FirstMullionOffset() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } double v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcWindowLiningProperties::setFirstMullionOffset(boost::optional< double > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::SecondMullionOffset() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } double v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcWindowLiningProperties::setSecondMullionOffset(boost::optional< double > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
::Ifc4::IfcShapeAspect* Ifc4::IfcWindowLiningProperties::ShapeAspectStyle() const { if(data_.get_attribute_value(12).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(12)))->as<::Ifc4::IfcShapeAspect>(true); }
void Ifc4::IfcWindowLiningProperties::setShapeAspectStyle(::Ifc4::IfcShapeAspect* v) { set_attribute_value(12, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(12); }
boost::optional< double > Ifc4::IfcWindowLiningProperties::LiningOffset() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } double v = data_.get_attribute_value(13); return v; }
void Ifc4::IfcWindowLiningProperties::setLiningOffset(boost::optional< double > v) { if (v) {set_attribute_value(13, *v);} else {unset_attribute_value(13);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::LiningToPanelOffsetX() const { if(data_.get_attribute_value(14).isNull()) { return boost::none; } double v = data_.get_attribute_value(14); return v; }
void Ifc4::IfcWindowLiningProperties::setLiningToPanelOffsetX(boost::optional< double > v) { if (v) {set_attribute_value(14, *v);} else {unset_attribute_value(14);} }
boost::optional< double > Ifc4::IfcWindowLiningProperties::LiningToPanelOffsetY() const { if(data_.get_attribute_value(15).isNull()) { return boost::none; } double v = data_.get_attribute_value(15); return v; }
void Ifc4::IfcWindowLiningProperties::setLiningToPanelOffsetY(boost::optional< double > v) { if (v) {set_attribute_value(15, *v);} else {unset_attribute_value(15);} }


const IfcParse::entity& Ifc4::IfcWindowLiningProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[1152]); }
const IfcParse::entity& Ifc4::IfcWindowLiningProperties::Class() { return *((IfcParse::entity*)IFC4_types[1152]); }
Ifc4::IfcWindowLiningProperties::IfcWindowLiningProperties(IfcEntityInstanceData&& e) : IfcPreDefinedPropertySet(std::move(e)) { }
Ifc4::IfcWindowLiningProperties::IfcWindowLiningProperties(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< double > v5_LiningDepth, boost::optional< double > v6_LiningThickness, boost::optional< double > v7_TransomThickness, boost::optional< double > v8_MullionThickness, boost::optional< double > v9_FirstTransomOffset, boost::optional< double > v10_SecondTransomOffset, boost::optional< double > v11_FirstMullionOffset, boost::optional< double > v12_SecondMullionOffset, ::Ifc4::IfcShapeAspect* v13_ShapeAspectStyle, boost::optional< double > v14_LiningOffset, boost::optional< double > v15_LiningToPanelOffsetX, boost::optional< double > v16_LiningToPanelOffsetY) : IfcPreDefinedPropertySet(IfcEntityInstanceData(storage_t(16))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_LiningDepth) {set_attribute_value(4, (*v5_LiningDepth)); } if (v6_LiningThickness) {set_attribute_value(5, (*v6_LiningThickness)); } if (v7_TransomThickness) {set_attribute_value(6, (*v7_TransomThickness)); } if (v8_MullionThickness) {set_attribute_value(7, (*v8_MullionThickness)); } if (v9_FirstTransomOffset) {set_attribute_value(8, (*v9_FirstTransomOffset)); } if (v10_SecondTransomOffset) {set_attribute_value(9, (*v10_SecondTransomOffset)); } if (v11_FirstMullionOffset) {set_attribute_value(10, (*v11_FirstMullionOffset)); } if (v12_SecondMullionOffset) {set_attribute_value(11, (*v12_SecondMullionOffset)); }set_attribute_value(12, v13_ShapeAspectStyle ? v13_ShapeAspectStyle->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v14_LiningOffset) {set_attribute_value(13, (*v14_LiningOffset)); } if (v15_LiningToPanelOffsetX) {set_attribute_value(14, (*v15_LiningToPanelOffsetX)); } if (v16_LiningToPanelOffsetY) {set_attribute_value(15, (*v16_LiningToPanelOffsetY)); }; populate_derived(); }

// Function implementations for IfcWindowPanelProperties
::Ifc4::IfcWindowPanelOperationEnum::Value Ifc4::IfcWindowPanelProperties::OperationType() const {  return ::Ifc4::IfcWindowPanelOperationEnum::FromString(data_.get_attribute_value(4)); }
void Ifc4::IfcWindowPanelProperties::setOperationType(::Ifc4::IfcWindowPanelOperationEnum::Value v) { set_attribute_value(4, EnumerationReference(&::Ifc4::IfcWindowPanelOperationEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(4); }
::Ifc4::IfcWindowPanelPositionEnum::Value Ifc4::IfcWindowPanelProperties::PanelPosition() const {  return ::Ifc4::IfcWindowPanelPositionEnum::FromString(data_.get_attribute_value(5)); }
void Ifc4::IfcWindowPanelProperties::setPanelPosition(::Ifc4::IfcWindowPanelPositionEnum::Value v) { set_attribute_value(5, EnumerationReference(&::Ifc4::IfcWindowPanelPositionEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(5); }
boost::optional< double > Ifc4::IfcWindowPanelProperties::FrameDepth() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcWindowPanelProperties::setFrameDepth(boost::optional< double > v) { if (v) {set_attribute_value(6, *v);} else {unset_attribute_value(6);} }
boost::optional< double > Ifc4::IfcWindowPanelProperties::FrameThickness() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcWindowPanelProperties::setFrameThickness(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
::Ifc4::IfcShapeAspect* Ifc4::IfcWindowPanelProperties::ShapeAspectStyle() const { if(data_.get_attribute_value(8).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(8)))->as<::Ifc4::IfcShapeAspect>(true); }
void Ifc4::IfcWindowPanelProperties::setShapeAspectStyle(::Ifc4::IfcShapeAspect* v) { set_attribute_value(8, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(8); }


const IfcParse::entity& Ifc4::IfcWindowPanelProperties::declaration() const { return *((IfcParse::entity*)IFC4_types[1155]); }
const IfcParse::entity& Ifc4::IfcWindowPanelProperties::Class() { return *((IfcParse::entity*)IFC4_types[1155]); }
Ifc4::IfcWindowPanelProperties::IfcWindowPanelProperties(IfcEntityInstanceData&& e) : IfcPreDefinedPropertySet(std::move(e)) { }
Ifc4::IfcWindowPanelProperties::IfcWindowPanelProperties(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, ::Ifc4::IfcWindowPanelOperationEnum::Value v5_OperationType, ::Ifc4::IfcWindowPanelPositionEnum::Value v6_PanelPosition, boost::optional< double > v7_FrameDepth, boost::optional< double > v8_FrameThickness, ::Ifc4::IfcShapeAspect* v9_ShapeAspectStyle) : IfcPreDefinedPropertySet(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); }set_attribute_value(4, (EnumerationReference(&::Ifc4::IfcWindowPanelOperationEnum::Class(),(size_t)v5_OperationType)));set_attribute_value(5, (EnumerationReference(&::Ifc4::IfcWindowPanelPositionEnum::Class(),(size_t)v6_PanelPosition))); if (v7_FrameDepth) {set_attribute_value(6, (*v7_FrameDepth)); } if (v8_FrameThickness) {set_attribute_value(7, (*v8_FrameThickness)); }set_attribute_value(8, v9_ShapeAspectStyle ? v9_ShapeAspectStyle->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);; populate_derived(); }

// Function implementations for IfcWindowStandardCase


const IfcParse::entity& Ifc4::IfcWindowStandardCase::declaration() const { return *((IfcParse::entity*)IFC4_types[1156]); }
const IfcParse::entity& Ifc4::IfcWindowStandardCase::Class() { return *((IfcParse::entity*)IFC4_types[1156]); }
Ifc4::IfcWindowStandardCase::IfcWindowStandardCase(IfcEntityInstanceData&& e) : IfcWindow(std::move(e)) { }
Ifc4::IfcWindowStandardCase::IfcWindowStandardCase(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, ::Ifc4::IfcObjectPlacement* v6_ObjectPlacement, ::Ifc4::IfcProductRepresentation* v7_Representation, boost::optional< std::string > v8_Tag, boost::optional< double > v9_OverallHeight, boost::optional< double > v10_OverallWidth, boost::optional< ::Ifc4::IfcWindowTypeEnum::Value > v11_PredefinedType, boost::optional< ::Ifc4::IfcWindowTypePartitioningEnum::Value > v12_PartitioningType, boost::optional< std::string > v13_UserDefinedPartitioningType) : IfcWindow(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); }set_attribute_value(5, v6_ObjectPlacement ? v6_ObjectPlacement->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(6, v7_Representation ? v7_Representation->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_OverallHeight) {set_attribute_value(8, (*v9_OverallHeight)); } if (v10_OverallWidth) {set_attribute_value(9, (*v10_OverallWidth)); } if (v11_PredefinedType) {set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcWindowTypeEnum::Class(),(size_t)*v11_PredefinedType))); } if (v12_PartitioningType) {set_attribute_value(11, (EnumerationReference(&::Ifc4::IfcWindowTypePartitioningEnum::Class(),(size_t)*v12_PartitioningType))); } if (v13_UserDefinedPartitioningType) {set_attribute_value(12, (*v13_UserDefinedPartitioningType)); }; populate_derived(); }

// Function implementations for IfcWindowStyle
::Ifc4::IfcWindowStyleConstructionEnum::Value Ifc4::IfcWindowStyle::ConstructionType() const {  return ::Ifc4::IfcWindowStyleConstructionEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcWindowStyle::setConstructionType(::Ifc4::IfcWindowStyleConstructionEnum::Value v) { set_attribute_value(8, EnumerationReference(&::Ifc4::IfcWindowStyleConstructionEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(8); }
::Ifc4::IfcWindowStyleOperationEnum::Value Ifc4::IfcWindowStyle::OperationType() const {  return ::Ifc4::IfcWindowStyleOperationEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcWindowStyle::setOperationType(::Ifc4::IfcWindowStyleOperationEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcWindowStyleOperationEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
bool Ifc4::IfcWindowStyle::ParameterTakesPrecedence() const {  bool v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcWindowStyle::setParameterTakesPrecedence(bool v) { set_attribute_value(10, v);if constexpr (false)unset_attribute_value(10); }
bool Ifc4::IfcWindowStyle::Sizeable() const {  bool v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcWindowStyle::setSizeable(bool v) { set_attribute_value(11, v);if constexpr (false)unset_attribute_value(11); }


const IfcParse::entity& Ifc4::IfcWindowStyle::declaration() const { return *((IfcParse::entity*)IFC4_types[1157]); }
const IfcParse::entity& Ifc4::IfcWindowStyle::Class() { return *((IfcParse::entity*)IFC4_types[1157]); }
Ifc4::IfcWindowStyle::IfcWindowStyle(IfcEntityInstanceData&& e) : IfcTypeProduct(std::move(e)) { }
Ifc4::IfcWindowStyle::IfcWindowStyle(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, ::Ifc4::IfcWindowStyleConstructionEnum::Value v9_ConstructionType, ::Ifc4::IfcWindowStyleOperationEnum::Value v10_OperationType, bool v11_ParameterTakesPrecedence, bool v12_Sizeable) : IfcTypeProduct(IfcEntityInstanceData(storage_t(12))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); }set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcWindowStyleConstructionEnum::Class(),(size_t)v9_ConstructionType)));set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcWindowStyleOperationEnum::Class(),(size_t)v10_OperationType)));set_attribute_value(10, (v11_ParameterTakesPrecedence));set_attribute_value(11, (v12_Sizeable));; populate_derived(); }

// Function implementations for IfcWindowType
::Ifc4::IfcWindowTypeEnum::Value Ifc4::IfcWindowType::PredefinedType() const {  return ::Ifc4::IfcWindowTypeEnum::FromString(data_.get_attribute_value(9)); }
void Ifc4::IfcWindowType::setPredefinedType(::Ifc4::IfcWindowTypeEnum::Value v) { set_attribute_value(9, EnumerationReference(&::Ifc4::IfcWindowTypeEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(9); }
::Ifc4::IfcWindowTypePartitioningEnum::Value Ifc4::IfcWindowType::PartitioningType() const {  return ::Ifc4::IfcWindowTypePartitioningEnum::FromString(data_.get_attribute_value(10)); }
void Ifc4::IfcWindowType::setPartitioningType(::Ifc4::IfcWindowTypePartitioningEnum::Value v) { set_attribute_value(10, EnumerationReference(&::Ifc4::IfcWindowTypePartitioningEnum::Class(), (size_t) v));if constexpr (false)unset_attribute_value(10); }
boost::optional< bool > Ifc4::IfcWindowType::ParameterTakesPrecedence() const { if(data_.get_attribute_value(11).isNull()) { return boost::none; } bool v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcWindowType::setParameterTakesPrecedence(boost::optional< bool > v) { if (v) {set_attribute_value(11, *v);} else {unset_attribute_value(11);} }
boost::optional< std::string > Ifc4::IfcWindowType::UserDefinedPartitioningType() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcWindowType::setUserDefinedPartitioningType(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }


const IfcParse::entity& Ifc4::IfcWindowType::declaration() const { return *((IfcParse::entity*)IFC4_types[1160]); }
const IfcParse::entity& Ifc4::IfcWindowType::Class() { return *((IfcParse::entity*)IFC4_types[1160]); }
Ifc4::IfcWindowType::IfcWindowType(IfcEntityInstanceData&& e) : IfcBuildingElementType(std::move(e)) { }
Ifc4::IfcWindowType::IfcWindowType(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ApplicableOccurrence, boost::optional< aggregate_of< ::Ifc4::IfcPropertySetDefinition >::ptr > v6_HasPropertySets, boost::optional< aggregate_of< ::Ifc4::IfcRepresentationMap >::ptr > v7_RepresentationMaps, boost::optional< std::string > v8_Tag, boost::optional< std::string > v9_ElementType, ::Ifc4::IfcWindowTypeEnum::Value v10_PredefinedType, ::Ifc4::IfcWindowTypePartitioningEnum::Value v11_PartitioningType, boost::optional< bool > v12_ParameterTakesPrecedence, boost::optional< std::string > v13_UserDefinedPartitioningType) : IfcBuildingElementType(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ApplicableOccurrence) {set_attribute_value(4, (*v5_ApplicableOccurrence)); } if (v6_HasPropertySets) {set_attribute_value(5, (*v6_HasPropertySets)->generalize()); } if (v7_RepresentationMaps) {set_attribute_value(6, (*v7_RepresentationMaps)->generalize()); } if (v8_Tag) {set_attribute_value(7, (*v8_Tag)); } if (v9_ElementType) {set_attribute_value(8, (*v9_ElementType)); }set_attribute_value(9, (EnumerationReference(&::Ifc4::IfcWindowTypeEnum::Class(),(size_t)v10_PredefinedType)));set_attribute_value(10, (EnumerationReference(&::Ifc4::IfcWindowTypePartitioningEnum::Class(),(size_t)v11_PartitioningType))); if (v12_ParameterTakesPrecedence) {set_attribute_value(11, (*v12_ParameterTakesPrecedence)); } if (v13_UserDefinedPartitioningType) {set_attribute_value(12, (*v13_UserDefinedPartitioningType)); }; populate_derived(); }

// Function implementations for IfcWorkCalendar
boost::optional< aggregate_of< ::Ifc4::IfcWorkTime >::ptr > Ifc4::IfcWorkCalendar::WorkingTimes() const { if(data_.get_attribute_value(6).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(6); return es->as< ::Ifc4::IfcWorkTime >(); }
void Ifc4::IfcWorkCalendar::setWorkingTimes(boost::optional< aggregate_of< ::Ifc4::IfcWorkTime >::ptr > v) { if (v) {set_attribute_value(6, (*v)->generalize());} else {unset_attribute_value(6);} }
boost::optional< aggregate_of< ::Ifc4::IfcWorkTime >::ptr > Ifc4::IfcWorkCalendar::ExceptionTimes() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcWorkTime >(); }
void Ifc4::IfcWorkCalendar::setExceptionTimes(boost::optional< aggregate_of< ::Ifc4::IfcWorkTime >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }
boost::optional< ::Ifc4::IfcWorkCalendarTypeEnum::Value > Ifc4::IfcWorkCalendar::PredefinedType() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } return ::Ifc4::IfcWorkCalendarTypeEnum::FromString(data_.get_attribute_value(8)); }
void Ifc4::IfcWorkCalendar::setPredefinedType(boost::optional< ::Ifc4::IfcWorkCalendarTypeEnum::Value > v) { if (v) {set_attribute_value(8, EnumerationReference(&::Ifc4::IfcWorkCalendarTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcWorkCalendar::declaration() const { return *((IfcParse::entity*)IFC4_types[1163]); }
const IfcParse::entity& Ifc4::IfcWorkCalendar::Class() { return *((IfcParse::entity*)IFC4_types[1163]); }
Ifc4::IfcWorkCalendar::IfcWorkCalendar(IfcEntityInstanceData&& e) : IfcControl(std::move(e)) { }
Ifc4::IfcWorkCalendar::IfcWorkCalendar(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, boost::optional< aggregate_of< ::Ifc4::IfcWorkTime >::ptr > v7_WorkingTimes, boost::optional< aggregate_of< ::Ifc4::IfcWorkTime >::ptr > v8_ExceptionTimes, boost::optional< ::Ifc4::IfcWorkCalendarTypeEnum::Value > v9_PredefinedType) : IfcControl(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); } if (v7_WorkingTimes) {set_attribute_value(6, (*v7_WorkingTimes)->generalize()); } if (v8_ExceptionTimes) {set_attribute_value(7, (*v8_ExceptionTimes)->generalize()); } if (v9_PredefinedType) {set_attribute_value(8, (EnumerationReference(&::Ifc4::IfcWorkCalendarTypeEnum::Class(),(size_t)*v9_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcWorkControl
std::string Ifc4::IfcWorkControl::CreationDate() const {  std::string v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcWorkControl::setCreationDate(std::string v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
boost::optional< aggregate_of< ::Ifc4::IfcPerson >::ptr > Ifc4::IfcWorkControl::Creators() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } aggregate_of_instance::ptr es = data_.get_attribute_value(7); return es->as< ::Ifc4::IfcPerson >(); }
void Ifc4::IfcWorkControl::setCreators(boost::optional< aggregate_of< ::Ifc4::IfcPerson >::ptr > v) { if (v) {set_attribute_value(7, (*v)->generalize());} else {unset_attribute_value(7);} }
boost::optional< std::string > Ifc4::IfcWorkControl::Purpose() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcWorkControl::setPurpose(boost::optional< std::string > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }
boost::optional< std::string > Ifc4::IfcWorkControl::Duration() const { if(data_.get_attribute_value(9).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(9); return v; }
void Ifc4::IfcWorkControl::setDuration(boost::optional< std::string > v) { if (v) {set_attribute_value(9, *v);} else {unset_attribute_value(9);} }
boost::optional< std::string > Ifc4::IfcWorkControl::TotalFloat() const { if(data_.get_attribute_value(10).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(10); return v; }
void Ifc4::IfcWorkControl::setTotalFloat(boost::optional< std::string > v) { if (v) {set_attribute_value(10, *v);} else {unset_attribute_value(10);} }
std::string Ifc4::IfcWorkControl::StartTime() const {  std::string v = data_.get_attribute_value(11); return v; }
void Ifc4::IfcWorkControl::setStartTime(std::string v) { set_attribute_value(11, v);if constexpr (false)unset_attribute_value(11); }
boost::optional< std::string > Ifc4::IfcWorkControl::FinishTime() const { if(data_.get_attribute_value(12).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(12); return v; }
void Ifc4::IfcWorkControl::setFinishTime(boost::optional< std::string > v) { if (v) {set_attribute_value(12, *v);} else {unset_attribute_value(12);} }


const IfcParse::entity& Ifc4::IfcWorkControl::declaration() const { return *((IfcParse::entity*)IFC4_types[1165]); }
const IfcParse::entity& Ifc4::IfcWorkControl::Class() { return *((IfcParse::entity*)IFC4_types[1165]); }
Ifc4::IfcWorkControl::IfcWorkControl(IfcEntityInstanceData&& e) : IfcControl(std::move(e)) { }
Ifc4::IfcWorkControl::IfcWorkControl(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, std::string v7_CreationDate, boost::optional< aggregate_of< ::Ifc4::IfcPerson >::ptr > v8_Creators, boost::optional< std::string > v9_Purpose, boost::optional< std::string > v10_Duration, boost::optional< std::string > v11_TotalFloat, std::string v12_StartTime, boost::optional< std::string > v13_FinishTime) : IfcControl(IfcEntityInstanceData(storage_t(13))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); }set_attribute_value(6, (v7_CreationDate)); if (v8_Creators) {set_attribute_value(7, (*v8_Creators)->generalize()); } if (v9_Purpose) {set_attribute_value(8, (*v9_Purpose)); } if (v10_Duration) {set_attribute_value(9, (*v10_Duration)); } if (v11_TotalFloat) {set_attribute_value(10, (*v11_TotalFloat)); }set_attribute_value(11, (v12_StartTime)); if (v13_FinishTime) {set_attribute_value(12, (*v13_FinishTime)); }; populate_derived(); }

// Function implementations for IfcWorkPlan
boost::optional< ::Ifc4::IfcWorkPlanTypeEnum::Value > Ifc4::IfcWorkPlan::PredefinedType() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } return ::Ifc4::IfcWorkPlanTypeEnum::FromString(data_.get_attribute_value(13)); }
void Ifc4::IfcWorkPlan::setPredefinedType(boost::optional< ::Ifc4::IfcWorkPlanTypeEnum::Value > v) { if (v) {set_attribute_value(13, EnumerationReference(&::Ifc4::IfcWorkPlanTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(13);} }


const IfcParse::entity& Ifc4::IfcWorkPlan::declaration() const { return *((IfcParse::entity*)IFC4_types[1166]); }
const IfcParse::entity& Ifc4::IfcWorkPlan::Class() { return *((IfcParse::entity*)IFC4_types[1166]); }
Ifc4::IfcWorkPlan::IfcWorkPlan(IfcEntityInstanceData&& e) : IfcWorkControl(std::move(e)) { }
Ifc4::IfcWorkPlan::IfcWorkPlan(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, std::string v7_CreationDate, boost::optional< aggregate_of< ::Ifc4::IfcPerson >::ptr > v8_Creators, boost::optional< std::string > v9_Purpose, boost::optional< std::string > v10_Duration, boost::optional< std::string > v11_TotalFloat, std::string v12_StartTime, boost::optional< std::string > v13_FinishTime, boost::optional< ::Ifc4::IfcWorkPlanTypeEnum::Value > v14_PredefinedType) : IfcWorkControl(IfcEntityInstanceData(storage_t(14))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); }set_attribute_value(6, (v7_CreationDate)); if (v8_Creators) {set_attribute_value(7, (*v8_Creators)->generalize()); } if (v9_Purpose) {set_attribute_value(8, (*v9_Purpose)); } if (v10_Duration) {set_attribute_value(9, (*v10_Duration)); } if (v11_TotalFloat) {set_attribute_value(10, (*v11_TotalFloat)); }set_attribute_value(11, (v12_StartTime)); if (v13_FinishTime) {set_attribute_value(12, (*v13_FinishTime)); } if (v14_PredefinedType) {set_attribute_value(13, (EnumerationReference(&::Ifc4::IfcWorkPlanTypeEnum::Class(),(size_t)*v14_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcWorkSchedule
boost::optional< ::Ifc4::IfcWorkScheduleTypeEnum::Value > Ifc4::IfcWorkSchedule::PredefinedType() const { if(data_.get_attribute_value(13).isNull()) { return boost::none; } return ::Ifc4::IfcWorkScheduleTypeEnum::FromString(data_.get_attribute_value(13)); }
void Ifc4::IfcWorkSchedule::setPredefinedType(boost::optional< ::Ifc4::IfcWorkScheduleTypeEnum::Value > v) { if (v) {set_attribute_value(13, EnumerationReference(&::Ifc4::IfcWorkScheduleTypeEnum::Class(), (size_t) *v));} else {unset_attribute_value(13);} }


const IfcParse::entity& Ifc4::IfcWorkSchedule::declaration() const { return *((IfcParse::entity*)IFC4_types[1168]); }
const IfcParse::entity& Ifc4::IfcWorkSchedule::Class() { return *((IfcParse::entity*)IFC4_types[1168]); }
Ifc4::IfcWorkSchedule::IfcWorkSchedule(IfcEntityInstanceData&& e) : IfcWorkControl(std::move(e)) { }
Ifc4::IfcWorkSchedule::IfcWorkSchedule(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_Identification, std::string v7_CreationDate, boost::optional< aggregate_of< ::Ifc4::IfcPerson >::ptr > v8_Creators, boost::optional< std::string > v9_Purpose, boost::optional< std::string > v10_Duration, boost::optional< std::string > v11_TotalFloat, std::string v12_StartTime, boost::optional< std::string > v13_FinishTime, boost::optional< ::Ifc4::IfcWorkScheduleTypeEnum::Value > v14_PredefinedType) : IfcWorkControl(IfcEntityInstanceData(storage_t(14))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_Identification) {set_attribute_value(5, (*v6_Identification)); }set_attribute_value(6, (v7_CreationDate)); if (v8_Creators) {set_attribute_value(7, (*v8_Creators)->generalize()); } if (v9_Purpose) {set_attribute_value(8, (*v9_Purpose)); } if (v10_Duration) {set_attribute_value(9, (*v10_Duration)); } if (v11_TotalFloat) {set_attribute_value(10, (*v11_TotalFloat)); }set_attribute_value(11, (v12_StartTime)); if (v13_FinishTime) {set_attribute_value(12, (*v13_FinishTime)); } if (v14_PredefinedType) {set_attribute_value(13, (EnumerationReference(&::Ifc4::IfcWorkScheduleTypeEnum::Class(),(size_t)*v14_PredefinedType))); }; populate_derived(); }

// Function implementations for IfcWorkTime
::Ifc4::IfcRecurrencePattern* Ifc4::IfcWorkTime::RecurrencePattern() const { if(data_.get_attribute_value(3).isNull()) { return nullptr; } return ((IfcUtil::IfcBaseClass*)(data_.get_attribute_value(3)))->as<::Ifc4::IfcRecurrencePattern>(true); }
void Ifc4::IfcWorkTime::setRecurrencePattern(::Ifc4::IfcRecurrencePattern* v) { set_attribute_value(3, v->as<IfcUtil::IfcBaseClass>());if constexpr (false)unset_attribute_value(3); }
boost::optional< std::string > Ifc4::IfcWorkTime::Start() const { if(data_.get_attribute_value(4).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcWorkTime::setStart(boost::optional< std::string > v) { if (v) {set_attribute_value(4, *v);} else {unset_attribute_value(4);} }
boost::optional< std::string > Ifc4::IfcWorkTime::Finish() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcWorkTime::setFinish(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }


const IfcParse::entity& Ifc4::IfcWorkTime::declaration() const { return *((IfcParse::entity*)IFC4_types[1170]); }
const IfcParse::entity& Ifc4::IfcWorkTime::Class() { return *((IfcParse::entity*)IFC4_types[1170]); }
Ifc4::IfcWorkTime::IfcWorkTime(IfcEntityInstanceData&& e) : IfcSchedulingTime(std::move(e)) { }
Ifc4::IfcWorkTime::IfcWorkTime(boost::optional< std::string > v1_Name, boost::optional< ::Ifc4::IfcDataOriginEnum::Value > v2_DataOrigin, boost::optional< std::string > v3_UserDefinedDataOrigin, ::Ifc4::IfcRecurrencePattern* v4_RecurrencePattern, boost::optional< std::string > v5_Start, boost::optional< std::string > v6_Finish) : IfcSchedulingTime(IfcEntityInstanceData(storage_t(6))) {  if (v1_Name) {set_attribute_value(0, (*v1_Name)); } if (v2_DataOrigin) {set_attribute_value(1, (EnumerationReference(&::Ifc4::IfcDataOriginEnum::Class(),(size_t)*v2_DataOrigin))); } if (v3_UserDefinedDataOrigin) {set_attribute_value(2, (*v3_UserDefinedDataOrigin)); }set_attribute_value(3, v4_RecurrencePattern ? v4_RecurrencePattern->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v5_Start) {set_attribute_value(4, (*v5_Start)); } if (v6_Finish) {set_attribute_value(5, (*v6_Finish)); }; populate_derived(); }

// Function implementations for IfcZShapeProfileDef
double Ifc4::IfcZShapeProfileDef::Depth() const {  double v = data_.get_attribute_value(3); return v; }
void Ifc4::IfcZShapeProfileDef::setDepth(double v) { set_attribute_value(3, v);if constexpr (false)unset_attribute_value(3); }
double Ifc4::IfcZShapeProfileDef::FlangeWidth() const {  double v = data_.get_attribute_value(4); return v; }
void Ifc4::IfcZShapeProfileDef::setFlangeWidth(double v) { set_attribute_value(4, v);if constexpr (false)unset_attribute_value(4); }
double Ifc4::IfcZShapeProfileDef::WebThickness() const {  double v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcZShapeProfileDef::setWebThickness(double v) { set_attribute_value(5, v);if constexpr (false)unset_attribute_value(5); }
double Ifc4::IfcZShapeProfileDef::FlangeThickness() const {  double v = data_.get_attribute_value(6); return v; }
void Ifc4::IfcZShapeProfileDef::setFlangeThickness(double v) { set_attribute_value(6, v);if constexpr (false)unset_attribute_value(6); }
boost::optional< double > Ifc4::IfcZShapeProfileDef::FilletRadius() const { if(data_.get_attribute_value(7).isNull()) { return boost::none; } double v = data_.get_attribute_value(7); return v; }
void Ifc4::IfcZShapeProfileDef::setFilletRadius(boost::optional< double > v) { if (v) {set_attribute_value(7, *v);} else {unset_attribute_value(7);} }
boost::optional< double > Ifc4::IfcZShapeProfileDef::EdgeRadius() const { if(data_.get_attribute_value(8).isNull()) { return boost::none; } double v = data_.get_attribute_value(8); return v; }
void Ifc4::IfcZShapeProfileDef::setEdgeRadius(boost::optional< double > v) { if (v) {set_attribute_value(8, *v);} else {unset_attribute_value(8);} }


const IfcParse::entity& Ifc4::IfcZShapeProfileDef::declaration() const { return *((IfcParse::entity*)IFC4_types[1172]); }
const IfcParse::entity& Ifc4::IfcZShapeProfileDef::Class() { return *((IfcParse::entity*)IFC4_types[1172]); }
Ifc4::IfcZShapeProfileDef::IfcZShapeProfileDef(IfcEntityInstanceData&& e) : IfcParameterizedProfileDef(std::move(e)) { }
Ifc4::IfcZShapeProfileDef::IfcZShapeProfileDef(::Ifc4::IfcProfileTypeEnum::Value v1_ProfileType, boost::optional< std::string > v2_ProfileName, ::Ifc4::IfcAxis2Placement2D* v3_Position, double v4_Depth, double v5_FlangeWidth, double v6_WebThickness, double v7_FlangeThickness, boost::optional< double > v8_FilletRadius, boost::optional< double > v9_EdgeRadius) : IfcParameterizedProfileDef(IfcEntityInstanceData(storage_t(9))) { set_attribute_value(0, (EnumerationReference(&::Ifc4::IfcProfileTypeEnum::Class(),(size_t)v1_ProfileType))); if (v2_ProfileName) {set_attribute_value(1, (*v2_ProfileName)); }set_attribute_value(2, v3_Position ? v3_Position->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr);set_attribute_value(3, (v4_Depth));set_attribute_value(4, (v5_FlangeWidth));set_attribute_value(5, (v6_WebThickness));set_attribute_value(6, (v7_FlangeThickness)); if (v8_FilletRadius) {set_attribute_value(7, (*v8_FilletRadius)); } if (v9_EdgeRadius) {set_attribute_value(8, (*v9_EdgeRadius)); }; populate_derived(); }

// Function implementations for IfcZone
boost::optional< std::string > Ifc4::IfcZone::LongName() const { if(data_.get_attribute_value(5).isNull()) { return boost::none; } std::string v = data_.get_attribute_value(5); return v; }
void Ifc4::IfcZone::setLongName(boost::optional< std::string > v) { if (v) {set_attribute_value(5, *v);} else {unset_attribute_value(5);} }


const IfcParse::entity& Ifc4::IfcZone::declaration() const { return *((IfcParse::entity*)IFC4_types[1171]); }
const IfcParse::entity& Ifc4::IfcZone::Class() { return *((IfcParse::entity*)IFC4_types[1171]); }
Ifc4::IfcZone::IfcZone(IfcEntityInstanceData&& e) : IfcSystem(std::move(e)) { }
Ifc4::IfcZone::IfcZone(std::string v1_GlobalId, ::Ifc4::IfcOwnerHistory* v2_OwnerHistory, boost::optional< std::string > v3_Name, boost::optional< std::string > v4_Description, boost::optional< std::string > v5_ObjectType, boost::optional< std::string > v6_LongName) : IfcSystem(IfcEntityInstanceData(storage_t(6))) { set_attribute_value(0, (v1_GlobalId));set_attribute_value(1, v2_OwnerHistory ? v2_OwnerHistory->as<IfcUtil::IfcBaseClass>() : (IfcUtil::IfcBaseClass*) nullptr); if (v3_Name) {set_attribute_value(2, (*v3_Name)); } if (v4_Description) {set_attribute_value(3, (*v4_Description)); } if (v5_ObjectType) {set_attribute_value(4, (*v5_ObjectType)); } if (v6_LongName) {set_attribute_value(5, (*v6_LongName)); }; populate_derived(); }

